Introduction

Overview

Relativity Designer

Relativity DBA

Relativity DBMS

Undocumented Features

ODBC-Enabled Applications

Trademark Acknowledgments


Welcome to Relativity

Thank you for purchasing Relativity, Liant Software’s programming tool that allows core data from RM/COBOL and Micro Focus COBOL applications to be retooled as a full-featured relational database. Relativity makes integrating legacy data into distributed client/server applications a straightforward and efficient process.

About Relativity Documentation

This document, Relativity Designer Help (reldbdsn.chm), is one of several HTML Help files for Relativity. A companion document is the Relativity Database Administrator (DBA) Help (reldbdba.chm) file. Both these documentation resources provide detailed information on the features and options for the Relativity Designer and the DBA, along with step-by-step procedures on how to accomplish specific tasks. An extensive glossary is also included.

For more information, see Using Relativity Help.

In addition to these HTML Help systems, the Relativity documentation set also consists of separate installation guides for each software component. These manuals, available as PDF files, describe how to install the Relativity software and verify that the installation was successful.

Technical Support

Liant Software offers various support options. For a complete list and a description of each, visit the Product Support section at the Liant web site: http://www.liant.com or see Relativity Product Support.

Copyright 1994-2008. Liant Software Corporation. All rights reserved.


Overview

See Also

The Relativity product set enables the construction of a true relational database using existing COBOL application data. Relativity provides a full-featured, Windows Open Services Architecture (WOSA), Open Database Connectivity (ODBC)-compliant relational database engine. Thus, Relativity allows SQL-based client access to COBOL application data without moving, converting, replicating, or re-engineering COBOL data files.

With Relativity providing SQL-based access to COBOL data files, any ODBC-enabled client/server development application or tool can be chosen to build applications for ad hoc reporting, decision support, and specialized data processing functions. Relativity enables any working application to benefit from client/server technology without rewriting or migrating that application.

The Relativity product set consists of three main software components:

· Relativity Designer

· Relativity DBA

· Relativity DBMS


Relativity Designer

The Relativity Designer is an interactive, Windows-based tool that enables the COBOL application developer to define and maintain a relational database system of tables using COBOL data.

The Relativity Designer creates the Relativity catalog by performing the following functions:

· Automatically extracts the definitions of data files from the COBOL programs into the Relativity catalog.

· Collects information regarding the data from the application developer.

· Allows the developer to define relational tables from existing COBOL data items within records of existing COBOL files.

If an owner group has been assigned to the catalog, only users who are members of that owner group may open the data source associated with the catalog using the Relativity Designer. Assignment of an owner thus protects the sensitive data in the catalog exposed by the Relativity Designer from access by users who are not owners. A password-protected log on procedure validates user identities whenever a Relativity data source is opened, as explained in Providing Data Security.

Information for Users of Prior Versions of Relativity: If you have used earlier versions of Relativity, you will notice an important change to the Relativity Designer interface. The Catalog window ("control central") is, by default, displayed in the new Windows XP Look & Feel layout mode and procedures in this help file are written for that mode. If you would prefer to work in the tabbed mode more familiar in earlier versions of Relativity, click the Tabbed option from the Layout command on the View menu.


Relativity DBA

The Relativity DBA (Database Administrator) is an interactive, Windows-based tool that enables the system administrator at the end-user location to maintain and manage the Relativity database and the security of the Relativity database.

The Relativity DBA provides the following functions:

· Defining and authorizing users of the database.

· Restricting the view of the data for individual groups of users.

· Maintaining the linkages between tables and physical COBOL data files.

· Defining date constants.

· Merging security and connection information into a new catalog (an optional function controlled by the catalog developer).

· Producing reports on security and connections.

The Relativity DBA can be used only by users who have the Use Administrator privilege for the catalog. The catalog owner has all privileges on a database, including the Use Administrator privilege. The owner may grant the Use Administrator privilege to an administrative group different from the owner group. This allows users from the administrative group to perform the administrative functions. A password-protected log on procedure validates user identities whenever a Relativity data source is opened, as explained in Providing Data Security.


Relativity DBMS

The Relativity DBMS (Database Management System) connects Windows client-based tool products to COBOL data files. The Relativity DBMS processes SQL requests from the ODBC-enabled application (or tool) and performs the necessary actions to respond to the request with data obtained from the COBOL data files.


Undocumented Features

For last-minute information on undocumented features to this Relativity release, please refer to the "Relativity Documentation" section of the Relativity README text file included in the installation.


ODBC-Enabled Applications

Relativity is compliant with Microsoft's Open Database Connectivity (ODBC) standard. Thus, any Windows-based ODBC-enabled application can access and manipulate COBOL data files using Relativity.

Supported client tools include: current versions of Microsoft Office, Visual Basic, Access, Word, Excel, and Query; Powersoft PowerMaker, PowerViewer, PowerBuilder; Lotus 1-2-3, Approach; Trinzic Forest &Trees; Wang OpenQuery; Crystal Report Writer; Borland ReportSmith; Intersolve Q+E; Cognos Impromptu; Microsoft dbWeb; and Microsoft Internet Information Services.

Note Support for 64-bit SQL Server is only available using the Relativity 64-bit Data Client.


Trademark Acknowledgments

All terms mentioned in this online documentation that are known to be trademarks have been appropriately capitalized. Liant Software Corporation cannot attest to the accuracy of this information. Use of a term in this online documentation should not be regarded as affecting the validity of any trademark.

· Relativity, RM/COBOL, RM/COBOL-85, and RM/InfoExpress are registered trademarks of Liant Software Corporation.

· Btrieve is a registered trademark of Pervasive Software.

· IBM is a registered trademark of International Business Machines.

· Micro Focus is a registered trademark of Micro Focus International Limited.

· Microsoft, Windows, Windows 2000, Windows XP, Windows Server 2003, Windows Vista, Windows Server 2008, Microsoft Access, Microsoft Excel, Microsoft Query, and Visual Basic are registered trademarks of Microsoft Corporation in the United States and/or other countries.

· Simba is a registered trademark of Simba Technologies.

· UNIX is a registered trademark in the United States and other countries, licensed exclusively through X/Open Company Ltd.

· Other companies mentioned herein own various trademarks.


Getting Started

Starting the Relativity Designer

Customizing the Initialization File (RELDBDSN.INI)

Configuring a Relativity Data Source

Pattern Matching

Setting Options

Determining Micro Focus COBOL Indexed File Formats

Using Relativity Help

Relativity Product Support


Starting the Relativity Designer

See Also

When you run the Relativity Setup program, Setup automatically creates a new program group and new program items for Relativity in Windows. For more information about starting and closing the Relativity Designer, choose one of the following tasks:

· Start the Relativity Designer from Windows

· Exit the Relativity Designer


Start the Relativity Designer from Windows

You can start the Relativity Designer in several ways:

1. Start and run Windows.

2. Do one of the following:

· Click the Windows Start menu, point to Programs, point to Liant, point to Relativity v x (where x is the version number of the product), and then click Designer.

· Click the Windows Start menu, choose Run and then enter reldbdsn in the Run dialog box.

· Double-click reldbdsn.exe in the Relativity directory.

· Double-click the Relativity Designer icon (if you created a shortcut).

The Welcome to Relativity Designer window opens.


Exit the Relativity Designer

When you finish working in a Relativity session, exit the Relativity Designer before you quit Windows.

There are several ways to exit Relativity. Choose the one that you prefer:

· On the File menu, click Exit.

· Single-click the Control Menu icon at the far left of the title bar in the Relativity Designer window and then click Close from the menu.

Alternately, double-click the Control Menu icon.

· You can also quit Relativity by clicking the Close button at the far right of the title bar.


Customizing the Initialization File (RELDBDSN.INI)

An initialization file, with the name RELDBDSN.INI, is a text file that is used to contain configuration information for the Relativity Designer. The RELDBDSN.INI file must be located in the Windows directory. It is processed whenever the Relativity Designer is executed.

While it is possible to customize the RELDBDSN.INI to suit your needs, editing should be restricted to those features described specifically below:

· AirlineDate

· Date Formats Options

· Data Source Options

· File Menu Commands

· Importing Btrieve Keys (Micro Focus COBOL Only)

· Modifiers for Date and Time Transforms

· Special Date and Date/Time Transforms

· System Options

· Welcome to Relativity Window

Other entries in the RELDBDSN.INI file are reserved for use by Relativity.


Configuring a Relativity Data Source

See Also

Microsoft's Open Database Connectivity (ODBC) interface requires that a data source be configured in order to allow data access. Configuring a data source involves setting the data source name (DSN) by which the data source will be known, optionally entering a textual description of the data source, entering any additional information required by a specific ODBC driver for connecting to the actual data, and setting any options supported by the specific ODBC driver. Data source configuration applies both to setting up a new data source or modifying an existing data source.

· In single-tier (that is, non-client/server) versions of Relativity, the Data Client data source can be configured within the Relativity Designer. The Relativity Designer assumes the currently selected Relativity DBMS as the ODBC driver.

· In client/server versions of Relativity, the Data Server data source is configured using the Relativity Server Administrator, a separate utility provided with the Relativity DBMS. The Data Client data source is subsequently associated with the Data Server data source from within the Relativity Designer.

Note If you installed the Relativity Server Administrator utility, you can start this program from within the Relativity Designer by clicking Server Admin on the Tools menu. The Select Server dialog box is displayed. (For more information, see the Server Administrator Help file, which is available either by clicking Help in the Select Server dialog or by choosing Server Admin Help File on the Relativity Designer Help menu.)

Data source configuration also can be performed outside of Relativity, using the ODBC Administrator functions available from the Windows Control Panel (see the Data Sources (ODBC) applet; on Windows XP and Vista, the applet is found under Administrative Tools in the Control Panel). The ODBC Administrator, a standard ODBC program distributed with Relativity, requires selection of a particular ODBC driver.

Note The Relativity Designer allows easy and quick access to the ODBC Data Source Administrator. To start the program, click ODBC Control Panel on the Tools menu. The ODBC Data Source Administrator dialog box is displayed.

Since data source configuration is always specific to a selected ODBC driver, any method of starting the process requires that you complete the same tasks when configuring a Relativity data source. For more information about configuring a Relativity data source, choose one of the following tasks:

· Setting up a new data source

· Opening a data source

· Closing a data source

Note to users of Microsoft Query in Office 97: For more information on things you should know before using Relativity data sources with Microsoft Query in Office 97, click here.


Setting Up a New Data Source

See Also

An ODBC data source name is used to refer to the database, indirectly through the Relativity catalog.

To set up a new data source:

1. Start the Relativity Designer. The Relativity Designer window opens.

2. On the File menu, click New Data Source. (For further information, see "Setting Up a New Relativity Data Source" under the For All Users | Adding, Modifying, and Deleting a Relativity Data Source topic in the Relativity DBMS Help file.)

Alternatively, from the Welcome to Relativity window, click the New option and select the appropriate driver if you have multiple drivers installed.

3. When you have completed setting up a new Relativity data source, the Open Relativity Data Source dialog box is displayed.

4. In the Data Source Name list, select the name of the data source you want to open.

Note If you have multiple drivers installed, a list box also will be available, where you can select the appropriate driver.

5. Click Open.

If security has been defined for the catalog, see Step 6. If no security has been defined, proceed to Step 7.

6. If security has been defined for the catalog associated with this data source, the Logon dialog box is displayed. Do one of the following:

· If an owner has been defined for the catalog, type the name of a user in the Name box in the Logon dialog box.

Note If privileges have been defined for the catalog, the user name must belong to an owner group. See Catalog Ownership and procedures on how to define catalog ownership.

In the Password box, type the password of the user. An asterisk (*) character is displayed for each character entered.

Click OK. The Catalog window opens for the selected data source.

· If an owner has not been defined for the catalog, there are no restrictions on the characters typed in the Name box of the Logon dialog box. If the catalog has no owner, the Password box of the Logon dialog box is left blank.

Click OK. The Catalog window opens for the selected data source.

7. If security has not been defined for the catalog associated with this data source, the Catalog window opens.

Once you have set up a new data source, continue with one of the following actions:

· If you are working with an existing catalog, see the help topic, Augmenting the COBOL File Definition in the FD Form.

Note A message will appear if you attempt to open an existing catalog from a version of Relativity that is below the minimum-supported version. Newer versions of the Relativity Designer require additional information to be recorded in the catalog. Versions of the Relativity Data Managers prior to the current version may not accept catalogs with these new fields. When the Relativity Designer is used on an old catalog, you are prompted with the following message:

"Database catalog is below the minimum version level for this design tool. Do you wish to upgrade it to the latest level? (A current backup is strongly recommended.)"

When you respond Yes to this prompt, your catalog is reformatted to provide the new fields for the added information. Liant recommends that you perform the reformatting on a copy of the catalog if you plan to continue using the original catalog with an earlier Relativity Data Manager.

-  If you respond with Yes, you must ship a current Relativity Database Manager when shipping a new catalog to customers.

-  If you respond No to this prompt, install an appropriate version of the Relativity Designer and use it for maintenance on the catalog in question.

· If you are working with a new catalog, see the help topic, Importing COBOL File Definitions.


Opening a Data Source

See Also

To open and maintain an existing catalog that supports the Relativity database specified by the data source:

1. Start the Relativity Designer. The Relativity Designer window opens.

2. On the File menu, click Open Data Source to display the Open Relativity Data Source dialog box.

Alternatively, from the Welcome to Relativity window, click either the Recent or Existing option, select a data source from the list, and click OK. Proceed to Step 5.

3. In the Data Source Name list, select the name of the data source you want to open.

Note If you have multiple drivers installed, a list box also will be available, where you can select the appropriate driver.

4. Click Open.

If security has been defined for the catalog, see Step 5. If no security has been defined, proceed to Step 6.

5. If security has been defined for the catalog associated with this data source, the Logon dialog box is displayed. Do one of the following:

· If an owner has been defined for the catalog, type the name of a user in the Name box in the Logon dialog box.

Note If privileges have been defined for the catalog, the user name must belong to an owner group. See Catalog Ownership and procedures on how to define catalog ownership.

In the Password box, type the password of the user. An asterisk (*) character is displayed for each character entered.

Click OK. The Catalog window opens for the selected data source.

· If an owner has not been defined for the catalog, there are no restrictions on the characters typed in the Name box of the Logon dialog box. If the catalog has no owner, the Password box of the Logon dialog box is left blank.

Click OK. The Catalog window opens for the selected data source.

6. If security has not been defined for the catalog associated with this data source, the Catalog window opens.

Note You also may quickly open an existing data source by selecting a data source from the most recently used list area on the File menu.

Once you have opened a data source, continue with one of the following actions:

· If you are working with an existing catalog, see the help topic, Augmenting the COBOL File Definition in the FD Form.

Note A message will appear if you attempt to open an existing catalog from a version of Relativity that is below the minimum-supported version. Newer versions of the Relativity Designer require additional information to be recorded in the catalog. Versions of the Relativity Data Managers prior to the current version may not accept catalogs with these new fields. When the Relativity Designer is used on an old catalog, you are prompted with the following message:

"Database catalog is below the minimum version level for this design tool. Do you wish to upgrade it to the latest level? (A current backup is strongly recommended.)"

When you respond Yes to this prompt, your catalog is reformatted to provide the new fields for the added information. Liant recommends that you perform the reformatting on a copy of the catalog if you plan to continue using the original catalog with an earlier Relativity Data Manager.

-  If you respond with Yes, you must ship a current Relativity Database Manager when shipping a new catalog to customers.

-  If you respond No to this prompt, install an appropriate version of the Relativity Designer and use it for maintenance on the catalog in question.

· If you are working with a new catalog, see the help topic, Importing COBOL File Definitions.


Closing a Data Source

See Also

To close a data source, do one of the following:

· On the File menu, click Close Data Source. Shortcut: Ctrl+D

· In the Catalog window, single-click the Control Menu icon at the far left of the title bar and then click Close from the menu.

Alternately, double-click the Control Menu icon.

· In the Catalog window, click the Close button at the far right of the title bar.

When you close a data source the Relativity Designer window remains open, allowing you to reopen the data source, open another data source, set up a new data source, or exit the Relativity Designer.


Using Microsoft Query with Relativity Data Sources

See Also

If you use Microsoft Query in the Office 97 product suite with Relativity data sources, you should be aware of the following issue:

· Microsoft Query uses only File data source names (DSNs), while Relativity data sources can be defined only as User or System DSNs. Beginning with version 2.44, Relativity eliminates this problem by automatically creating a File DSN having the same name as the User or System data source just created. However, in versions of Relativity prior to 2.44, a File DSN must be created manually to point to the User or System DSN as follows:

1. Click the Start button, point to Settings, and then click Control Panel.

2. Double-click 32bit ODBC.

3. Click the File DSN tab.

4. Find the location of the File DSNs on this Windows workstation.

5. Create a file in that directory named datasource.dsn, where datasource is the name that you want to give the data source. The file's contents should be the following:

[ODBC]
DSN=datasource

where datasource is the name of the User or System DSN.

6. The Query wizard in Microsoft Query will not work with Relativity data sources. When you select a data source from the Choose Data Source dialog box in Microsoft Query, make sure that you deselect the Use the Query Wizard to create/edit queries check box.


Pattern Matching

See Also

The adding, editing, and deleting of various strings used in Relativity is controlled by the matching of patterns. Pattern matching provides a tool for string comparison between a pattern and a table name, a path name, a file label (if file labels are in effect), a column name, or a COBOL data item. These are collectively called "searched strings" in the examples provided.

In the Relativity Designer, pattern matching is used for the following purposes:

· To add, edit, or delete a table connection, as described in the topic, Establishing Table Connections.

· To replace selected characters in all column names defined by default in the FD form.

· To identify common patterns for COBOL data items. The data item pattern is then associated with a user data type and/or a transform.

· To replace or restore selected characters in table names during COBOL FD merge operations.

Relativity pattern matching uses the concept of "regular expressions." Regular expressions extend the conventional search criteria.

· To view a table that shows the list of character(s) in a pattern and what they match in the searched string, click here.

· For examples of pattern matching, click here.


Regular Expression Syntax Used in Pattern Matching

See Also

A regular expression is a pattern of text that consists of ordinary characters, for example, letters a through z, and special characters.

Character(s) | Matches in searched string
pattern | Matches pattern anywhere in the name.
\ | Marks the next character as either a special character, a literal, a back reference, or an octal escape. For example, 'd' matches the character "d". ' \d' matches a digit character. The sequence '\\' matches "\" and "\(" matches "(".
. | Matches any single character.
^ | Matches the position at the beginning of the searched string.
$ | Matches the position at the end of the searched string.
? | Matches the preceding subexpression zero or one time. For example, "mast(er)?" matches "mast" or "master". Also, see below for additional uses of '?'.
* | Matches the preceding subexpression zero or more times. For example, zo* matches "z" and "zoo".
+ | Matches the preceding subexpression one or more times. For example, 'zo+' matches "zo" and zoo", but not "z".
{n} | Matches exactly n times, where n is a nonnegative integer. For example, 'o{2}' matches the two o's in "zoo", but not the o in "zero".
{n,} | Matches at least n times, where n is a nonnegative integer. For example, 'o{2,}' matches all the o's in "zooooom" but not the o in "zero".
{n,m} | Matches at least n times and at most m times, where n and m are nonnegative integers (n <= m). For example, 'o{2,4}' matches the first four o's in "zooooom", but not the o in "zero".
? | When '?' immediately follows any of the qualifiers (*, +, ?, {n}, {n,}, {n,m}), the matching pattern is non-greedy. While the default pattern matching is to match as much of the searched string as possible, a non-greedy pattern matches as little of the searched string as possible. For example, 'o+?' matches a single o in "zooom", while 'o+' matches all the o's.
(pattern) | Matches pattern as a subexpression and remembers the match. The remembered match can be used in a following back reference (described below) or in the replacement string of a search and replace operation. To match the parentheses characters ( and ), use '\(' and '\)'.
X|y | Matches either x or y. For example, 'MAST(ER|FILE)' matches either "MASTER" or "MASTFILE".
[charlist] | Matches any single character in charlist. For example, '[aeiou]' matches the e in "Relativity".
[^charlist] | Matches any single character not in charlist. For example, '[^aeiou]' matches the R in "Relativity".
[a-z] | Matches any single character in the specified character range. For example, '[a-z]' matches any lowercase alphabetic character in the range "a" through "z", inclusive.
[^m-z] | Matches any single character not in the specified character range. For example, '[^m-z]' matches any character except those in the range "m" through "z", inclusive.
\b | Matches a word boundary (the position between a word and a space). For example, "le\b" matches the "le" of "file" in the searched string "lengthy file name", not the "le" in "lengthy".
\b | Matches a non-word boundary. For example, "le\B" matches the "le" of "lengthy" in the searched string "lengthy file name", not the "le" in "file".
\d | Matches a digit character (equivalent to [0-9]).
\D | Matches a non-digit character (equivalent to [^0-9]).
\s | Matches a white space character.
\S | Matches a nonwhite space character.
\w | Matches any word character including underscore (equivalent to [A-Za-z0-9_]).
\W | Matches any non-word character (equivalent to [^A-Za-z0-9_]).
\num | Matches a back reference to a remembered match, where num is a positive integer. For example, '(.)\1' matches two consecutive identical characters.


Pattern Matching Examples

For more information on pattern matching, choose one of the following examples:

· Pattern match anywhere

· Pattern match at beginning

· Pattern match at ending

· Pattern match entire searched string

· Match the beginning of a string

· Match the ending of a string

· Pattern match any single character

· Pattern match zero or more characters

· Pattern match any single digit

· Pattern match special character

· Pattern match any character in a range

· Pattern match any character outside a range

· Use back references in replacement strings


Pattern match anywhere

The pattern of character-string matches with a similar character-string found anywhere in searched string. The following examples illustrate the matching of a pattern located anywhere in the searched string.

Pattern | Searched String | Result
SALES | BSALES | Match
SALES | SALESFIL | Match
SALES | JSALESFL | Match
SALES | SALEFL | No match
SALES | salesfil | No match


Pattern match at beginning

The pattern of ^character-string matches with a similar character-string found at the beginning of the searched string. The following examples illustrate the matching of a pattern located at the beginning of the searched string.

Pattern | Searched String | Result
^SALES | BSALES | No match
^SALES | SALESFIL | Match
^SALES | JSALESFL | No match
^sales | SALESFL | No match


Pattern match at ending

The pattern of character-string$ matches with a similar character-string found at the end of the searched string. The following examples illustrate the matching of a pattern located at the end of the searched string.

Pattern | Searched String | Result
SALES$ | BSALES | Match
SALES$ | SALESFIL | No match
SALESR | JSALESFL | No match
Sales$ | PRSALES | No match


Pattern match entire searched string

The pattern of ^character-string$ matches with a similar character-string representing the entire searched string. The following examples illustrate the matching of a pattern equivalent to the entire searched string.

Pattern | Searched String | Result
^SALES$ | BSALES | No match
^SALES$ | SALESFIL | No match
^SALES$ | JSALESFL | No match
^SALES$ | SALES | Match
^sales$ | SALES | No match
^sales$ | sales | Match


Match the beginning of a string

The pattern of ^ represents a match at the beginning of the searched string. The following examples illustrate a match at the beginning of the searched string, allowing the insertion of the replacement string at the beginning of the searched string.

Pattern | Searched String | Replace with resort\
^ | salesfil | resort\salesfil
^ | orderfil | resort\orderfil
^ | cust2fil | resort\custfil
^ | CUST2FIL | resort\CUST2FIL


Match the ending of a string

The pattern of $ represents a match at the end of the searched string. The following examples illustrate a match at the end of the searched string, allowing the insertion of the replacement string at the end of the searched string.

Pattern | Searched String | Replace with .INX
$ | SALESFIL | SALESFIL.INX
$ | ORDERFIL | ORDERFIL.INX
$ | CUST2FIL | CUST2FIL.INX
$ | salesfil | salesfil.INX


Pattern match any single character

The pattern of . matches with any single character in the searched string. The following examples illustrate the matching a single character in the searched string.

Pattern | Searched String | Result
CUST.FIL | CUST1FIL | Match
CUST.FIL | CUST2FIL | Match
CUST.FIL | CUST45FIL | No match
PROD.FIL | PROD1FIL | Match
PROD.FIL | PROD2FIL | Match
PROD.FIL | PRODAAFIL | No match
Prod.fil | PROD3FIL | No match


Pattern match zero or more characters

Use the * character after the . character to represent a match with zero to more characters in the searched string. The following examples illustrate the matching of patterns containing the asterisk (*) character.

Pattern | Searched String | Result
\budget\.* | \budget\salesfil | Match
\budget\.* | \designer\orderfil | No match
\designer\.* | \designer\cust2fil | Match
\designer\.* | \budget\cust2fil.dat | No match
\.*\orderfil | \budget\orderfil | Match
\.*\orderfil | \designer\prod2fil | No match
\.*\prod2fil | \prod2fil | No match
\budget\.* | \designer\salesfil | No match


Pattern match any single digit

The pattern of \d represents a match with any digit, 0 through 9, within the searched string. The following examples illustrate the matching of patterns containing \d.

Pattern | Searched String | Result
CUST\dFIL | CUST1FIL | Match
CUST\dFIL | CUST2FIL | Match
CUST\dFIL | CUSTAFIL | No match
CUSTFIL\d | CUSTFIL3 | Match
CUSTFIL\d | CUST1FIL | No match
Custfil\d | CUSTFIL9 | No match


Pattern match special character

When a special character, such as ? * or [ , is preceded by a backslash (\), a match occurs if that special character is present in the indicated position of the searched string. The following examples illustrate the matching of patterns containing one of the special characters.

Pattern | Searched String | Result
CUST\*FIL | CUST*FIL | Match
CUST\*FIL | CUST2FIL | No match
Cust\*fil | CUST*FIL | No match


Pattern match any character in a range

The following examples illustrate the matching of patterns containing a range of characters. The pattern representation of a range consists of two characters separated by a hyphen and enclosed in brackets. For example, [1-5] indicates a range from '1' through '5'. The presence of any one of the characters in the range results in a match.

Pattern | Searched String | Result
CUST[1-5]FIL | CUST1FIL | Match
CUST[1-5]FIL | CUST4FIL | Match
CUST[1-5]FIL | CUST6FIL | No match
CUST1FL[A-Z] | CUST1FLB | Match
CUST1FL[A-Z] | CUST1FL2 | No match
CUST1FL[A-Z] | CUST1FLw | No match
CUST1FL[a-z] | CUST1FL4 | No match
CUST1FL[a-d0-9] | CUST1FL4 | Match
CUST1FL[A-D0-9] | CUST1FLL | No match
cust1fl[A-D0-9] | CUST1FLa | No match


Pattern match any character outside a range

The following examples illustrate the matching of patterns outside a range of characters. The presence of the caret ( ^ ) character after the left bracket and before the range pattern indicates that a match occurs when a character is not within the specified range. For example, [^4-9] indicates any character outside the range of '4' through '9'.

Pattern | Searched String | Result
CUST[^4-9]FIL | CUST1FIL | Match
CUST[^4-9]FIL | CUST2FIL | Match
CUST[^4-9]FIL | CUST6FIL | No match
CUS1FL[^A-Z] | CUST1FLA | No match
CUST1FL[^a-z] | cust1fla | No match
CUS1FL[^A-Z] | CUST1FL4 | Match
CUST1FL[^A-Z] | CUST1FLX | No match
CUST1FL[^a-z] | CUST1FLB | Match
CUST1FL[^a-z] | CUST1FLc | No match
CUST1FL[^a-z] | CUST1FL3 | Match
CUST1FL[^4-9A-D] | CUST1FL4 | No match
CUST1FL[^4-9A-D] | CUST1FLW | Match
CUST1FL[^4-9A-D] | CUST1FLg | Match
cust1fl[^4-8a-e] | CUST1FLA | No match


Use back references in replacement strings

The following examples illustrate the use of back references in a replacement string. Use the parentheses characters within the searched string to cause the subexpressions contained within the parentheses to be remembered. Subexpressions are numbered from left to right, starting with 1. Therefore, to refer to the leftmost remembered subexpression, use \1 in the replacement string, \2 for the second leftmost, and so forth.

Pattern | Searched String | Replacement | Result
(.+)(\d)(\.dat|\.DAT) | custfil5.dat | \1new\2\3 | Custfilenew5.dat
(First|1st)(.+)(Last|Final) | FirstThenLast | \3\2\1 | LastThenFirst
(First|1st)(.+)(Last|Final) | 1stThenFinal | \3\2\1 | FinalThen1st


Setting Options

Relativity allows you to specify default settings for various configuration preferences, including system, file, table, item patterns, user types, data sources, date formats, COBOL types, and privileges.

To display the Options dialog box:

1. Click Options from the Tools menu.

2. In the left pane, click the name of the option to display the corresponding page of preferences in the right pane.

· System Options

· File Options

· Table Options

· Item Patterns Options

· User Types Options

· Data Source Options

· Date Formats Options

· COBOL Types Options

· Privileges Options

Note Three buttons, OK, Cancel, and Apply, appear in the lower-right corner in the Options dialog box no matter which page is selected and displayed. They perform the same functions in all of the pages in the Options dialog box. The OK button closes the Options dialog box and saves any changes that you have made on the specified page. The Cancel button closes the Options dialog box without saving any changes you have made to the settings. The Apply button saves all the changes you have made without closing the Options dialog box.


System Options

See Also

The System page contains options that enable the user to specify settings for system preferences, such as startup status and background color on grids.

The following table describes the options available on the System page.

Option

Description

Open Last Data Source on Startup

When this check box is selected, the information about the last data source processed is stored when exiting from the Relativity Designer. The next time the Relativity Designer is started, the stored data source information determines the data source to be automatically opened. The data source name and user name are shown at the bottom of the System page.

Use White Background
on Grids

When this check box is selected, Relativity overrides the color choice (set on the Appearance tab of the Display Properties dialog box) with white on many of the grid areas (such as in the FD form, the Table form, the Edit Connections form, and the Show Table Contents form). If this option is not selected, the background will be the same color as the top portion in the form.

During Import, Initially Place Files in Available Column

When the During Import, Initially Place Files in Available Column check box is selected, the FDs from the COBOL source file are placed in the Available Files list of the File Selection pages of the Source Code Import wizard and the Source Code Merge wizard. This enables you then to select only those FDs you wish to include in the importing and merging processes.

The default behavior for the Relativity Designer is to assume that you want to import and merge all of the FDs from the COBOL source file. Consequently, all of the file definitions are initially placed in the Selected Files list unless you enable this option.

Note The procedures for importing and merging COBOL file definitions are written from the perspective of the default behavior; that is, all the files are shown in the Selected Files list.

Debug Log

This check box appears on the System page only when you have modified the [Designer] section of the RELDBDSN.INI file by changing the value of the DebugLog= entry to YES.

Note This option is used for debugging purposes and runs the Relativity Designer in trace mode. It should be enabled only when directed by a Liant technical support analyst.

Data Source Name

This option displays the name of the data source being processed by the Relativity Designer.

User Name

This option displays the name of the group or user logged on to use the data source.


File Options

See Also

The File page contains options that enable the user to specify the behavior and contents of the FD form.

The following table describes the options available on the File page.

Option | Description
Show FD Details | When this check box is selected, the FD form opens in the expanded (Show Details) mode with additional attributes of the data item. If this option is not selected, the FD form opens with only the level indicator/level number and COBOL Name attribute visible.
Show REDEFINES | If this check box is selected, the Redefines column is displayed in the FD form. This column shows the item that is redefined by the item in a particular row. If this option is not selected, the Redefines column is not displayed in the FD form.
Show Redefined By | If this check box is selected, the Redefined By column is displayed in the FD form. If this option is not selected, the Redefined By column is not displayed in the FD form.
Show VALUE Column | If this check box is selected, the Value column is displayed in the FD form. This column allows you to view the condition. If this option is not selected, the Value column is not displayed in the FD form.
Show Null Information | If this check box is selected, the Null Value and Not Null columns are displayed in the FD form. These columns allow the specification of conditions that provide null SQL column values. If this option is not selected, the Null Value and Not Null columns are not displayed in the FD form.
Save FD Changes | When this check box is selected, the changes to data definitions in the FD form are accepted into the catalog without a message requesting confirmation.
Show Comments | If this check box is selected, the Comment column is displayed in the FD form. Comments may be entered to provide additional documentation of the database. If this option is not selected, the Comment column is not displayed in the FD form.
Show Default Values | If this check box is selected, the Default Value column is displayed in the FD form. Default values are used when tables, which allow updates and inserts, are defined. If this option is not selected, the Default Value column is not displayed in the FD form.
Merge FD Change Table Rename Rules | This area allows you to specify the strings necessary to merge a changed FD with an existing FD in the Relativity catalog using the table Rename rules.


Merge FD Change Table Rename Rules

When a changed FD is merged with an existing FD in the Relativity catalog , that is, when an FD is re-imported into the catalog, the names of tables associated with the FDs must be changed because ODBC does not allow multiple tables with the same name in the same data source. Similarly, table names must be restored to their original names if a merge is abandoned and the previous FD is restored.

Two rules, the Replace rule and the Restore rule, collectively known as the Rename rules, govern the naming conventions applied in these situations. Each rule contains a matching text string and a replacement text string. These strings are specified on the File page in the Options dialog box.

· Replace rule. When FDs are merged, the tables associated with the FDs are automatically renamed using the standard string replacement specified by the Replace rule. The default Replace rule ("^^" with "_old") adds "_old" to the original table name. For example, a table named "mytable" would become "mytable_old".

· Restore rule. When an FD merge is abandoned, the tables associated with the FDs are automatically renamed using the string replacement specified by the Restore rule. Therefore, the Restore rule should 'undo' the Replace rule. The default Restore rule, ("_old^" with ""), removes the string "_old" when it occurs at the end of a name, thus undoing the default Replace rule. For example, "mytable_old" would be restored to "mytable".

For further explanation of the matching text patterns that can be used in the matching text string for these rules, see Pattern Matching.


Table Options

See Also

The Table page contains options that enable the user to specify the behavior and contents of the Table form.

The following table describes the options available on the Table page.

Option | Description
Save Table Changes | When this check box is selected, changes to data definitions in the Table form are accepted into the catalog without the message requesting confirmation.
Inherit FD Comments | When this check box is selected, movement of a data item from the FD form to the Table form also results in the movement of (in the Comments column) to the Table form. If the Inherit FD Comments check box is not selected, the comments associated with the FD form are not moved to the Table form.
Show Comments | When this check box is selected, the Comment column is displayed in the Table form. If the Show Comments check box is not selected, the Comment column is not displayed in the Table form.
Show Default Values | When this check box is selected, the Default Value column is displayed in the Table form if the Allow Inserts check box in the Table form toolbar has been selected for the table. If the Show Default Values check box is not selected, the Default Value column is not displayed in the Table form.
Show LogicalOrder Transform | When this check box is selected, the LogicalOrder column transform will be enabled in the data source. When this transform is enabled, Relativity will convert text from visual order (the order in which characters are presented for reading) into logical order (the order in which characters are typed on a keyboard) before returning the text to the application. Likewise, logical order text that is written into a column by the ODBC application will be converted back to visual order before storage into the COBOL data file, so that the COBOL application can use it. The LogicalOrder column transform can be placed either on an individual column or every column of a data source.


Item Patterns Options

See Also

The Item Patterns page contains options that allow the user to:

· Specify settings for an item pattern.

· Control the display of the Item Patterns form.

The following table describes the options available on the Item Patterns page.

Option | Description
Save Pattern Changes | When this check box is selected, changes to the Item Patterns form are accepted into the catalog without the message requesting confirmation.
Iconize at Open | When you select this option, the Item Patterns form is displayed as an icon when the data source is opened. This option is typically used when the Open when Opening Data Source preference is selected.
Open when Opening Data Source | If this check box is selected, the Item Patterns form opens when the data source is opened. If this option is not specified, the Item Patterns form is not displayed when the data source is opened.


User Types Options

See Also

The User Types page contains options that allow the user to:

· Specify settings for user data types.

· Control the display of the Data Types form.

The following table describes the options available on the Users Types page.

Option | Description
Save Data Type Changes | When this check box is selected, changes to the Data Types form are accepted into the catalog without the message requesting configuration.
Iconize at Open | When you select this option, the Data Types form is displayed as an icon. This option is typically used when the Open when Opening Data Source preference is selected.
Open when Opening Data Source | If this check box is selected, the Data Types form opens when the data source is opened. If this option is not specified, the Data Types form is not displayed when the data source is opened.


Data Source Options

See Also

The Data Source page contains options that enable the user to:

· Specify the way in which the data source file will be interpreted by Relativity.

· Access the Export Preferences dialog box in order to configure the export of an FD (see Export FD on the FD form toolbar).

The following table describes the options available on the Data Source page.

Option

Description

Assume Spaces=Zeros

This option indicates that the Relativity DBMS will translate space characters and binary zeros to zero characters in the data source.

Note The Assume Spaces=Zeros option has no effect on data items that are either all or part of a key.

There are three possible states that may be selected for this option:

· Select Never to cause the DBMS to return an error when this condition is encountered. This is the default.

· Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

· Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.

Assume Nonnegative=Positive

This option indicates that the Relativity DBMS will interpret numeric data not having explicitly correct negative sign values for the data type as positive (even though the data do not have explicitly correct positive sign values).

There are three possible states that may be selected for this option:

· Select Never to cause the DBMS to return an error when this condition is encountered. This is the default.

· Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

· Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.

Invalid Numerics Return NULL

This option indicates that the Relativity DBMS will return a NULL value for any column based on a data item containing invalid numeric data.

There are three possible states that may be selected for this option:

· Select Never to cause the DBMS to return an error when this condition is encountered. This is the default.

· Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

· Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.

These three states also can be set using the Nullable Column utility.

Invalid Dates Return NULL

This option indicates that the Relativity DBMS will return a NULL value for any date or date/time column based on a data item containing invalid date ranges either because the underlying numeric data is invalid, or the month or day is out of range.

There are three possible states that may be selected for this option:

· Select Never to cause the DBMS to return an error when this condition is encountered. This is the default.

· Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

· Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.

These three states also can be set using the Nullable Column utility.

Automated LogicalOrder Transform

This option indicates that a LogicalOrder column transform will be placed automatically on every text column of a data source.

There are three possible states that may be selected for this option:

· Select Never to cause the LogicalOrder transform not to be placed automatically on every text column of a data source. This is the default.

· Select Yes, Except for Record Key Data Items to apply the transform to all text columns except where it would result in the loss of an index on the table.

· Select Always to cause the LogicalOrder transform to be placed automatically on every text column of a data source.

Catalog Expires

By selecting this check box and entering an expiration date in the Date box, you can make access to a catalog unavailable after a specified date. By default, the date entered in the Date box is the current date. You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format.

Note The catalog expiration date feature does not affect the catalog owner's access to the catalog.

Level Numbers

In this box, type a comma-separated list of numbers indicating the desired level numbers to be used either when exporting an FD (see Export FD on the FD form toolbar) or when importing COBOL file definitions from RM/COBOL object programs.

The first number must be 1 followed by ascending values. The level numbers are implicitly extended using the difference of the last two numbers in the series. Thus, 1,3 indicates that the level numbers are to be 1,3,5,7,9,... and 1,5,10 indicates that the level numbers are to be 1,5,10,15,20,... (note that 1,5 would indicate 1,5,9,13,...).

When importing, level numbers are required only if you are importing COBOL file definitions from RM/COBOL object programs. RM/COBOL object programs do not contain the original level numbers for data items defined in a record description and must be specified in the Level numbers box. The generated level numbers are stored in the catalog during import and will not be changed if the level numbers option is changed after the import.

Note It is not necessary to specify level numbers if you import COBOL file definitions from a Relativity Symbol Table (RST) file, because existing source level information is preserved through the catalog.

Comments

This area is a free-format text field that will be stored inside the catalog. The Relativity Designer will display the comment on its Help About form, if there is a comment. One possible use for this text field would be catalog version information.

Data File Format

This list indicates the data file format that is to be used to open Micro Focus COBOL indexed files. The Micro Focus file manager must know the format of the indexed file so that the proper indexed file support can be used. The valid values are < none >, BTRIEVE, C-ISAM, LEVELII COBOL, IDX4, IDX8, and Default. For more information about how Relativity determines which indexed file format to request, click here.

Note This option applies only to Relativity for Micro Focus COBOL. It will not appear in the Data Source page unless the Micro Focus Types box is selected in the COBOL Types page.

Export

This button displays the Export Preferences dialog box in order to configure the export of an FD (see also Export FD on the FD form toolbar).


Date Formats Options

See Also

Because the COBOL language does not have a representation for date and time values, many storage formats have been used to represent date and/or time values. Each date and time format is represented in Relativity as a COBOL data item transform. Since many application data sources are internally consistent in the date and time formats used, date format options may be used to reduce the number of choices displayed within Relativity (typically in the FD form).

The Date Formats page contains options that enable the user to specify settings for date and time formatting. The options selected in the Date Formats page determine the choices available in the Transform list displayed in the FD form and the Table form.

Note Depending on the contents of your RELDBDSN.INI file, several additional check boxes may appear on the Date Formats page. Click one of the topics below for descriptions of optional check boxes that can appear on this page:

· Include 9s Complement Forms

· Include 10s Complement Forms

· Include '+ Subscript' Forms

· Include MMDDYY-30000 Forms

· Include 3000000 Complement Forms

The following table describes the options available on the Date Formats page.

Option | Description
Include YYMMDD Forms | When this check box is selected, the date transform YYMMDD choices are displayed.
Include MMDDYY Forms | When this check box is selected, the date transform MMDDYY choices are displayed.
Include DDMMYY Forms | When this check box is selected, the date transform DDMMYY choices are displayed.
Include YYDDD Forms | When this check box is selected, the date transform YYDDD choices are displayed.
Include YYYY Forms | When this check box is selected, the date transform YYYY is displayed for any YY form chosen. For example, if the Include YYMMDD Forms check box is selected, then selecting the Include YYYY Forms check box causes YYMMDD and YYYYMMDD date transforms to be displayed.
Include 'Days' Forms | When this check box is selected, the date transform Days is displayed. The transform represents the number of days since a specific day.
Include HHMM Forms | When this check box is selected, the time transform HHMM choices are displayed. In addition, if the Include Date/Time Forms check box is selected, HHMM forms of any date transforms are also displayed. For example, if the Include YYMMDD Forms check box is selected, then selecting the Include HHMM Forms check box causes both YYMMDD and YYMMDDHHMM date transforms to be displayed.
Include HHMMSS Forms | When this check box is selected, the time transform HHMMSS is displayed. In addition, if the Include Date/Time Forms check box is selected, HHMMSS forms of any date transforms are also displayed. For example, if the Include YYMMDD forms check box is selected, then selecting the Include HHMMSS Forms check box causes both YYMMDD and YYMMDDHHMMSS date transforms to be displayed.
Include HHMMSShh Forms | When this check box is selected, the time transform HHMMSShh is displayed. In addition, if the Include Date/Time Forms check box is selected, HHMMSShh forms of any date transforms are also displayed. For example, if the Include YYMMDD Forms check box is selected, then selecting the Include HHMMSShh Forms check box causes both YYMMDD and YYMMDDHHMMSShh date transforms to be displayed.
Include Date/Time Forms | When this check box is selected, combinations of the selected date and time transforms are displayed. For example, if the Include Date/Time Forms, Include YYMMDD Forms, and Include HHMMSShh Forms options are selected, both YYMMDD and YYMMDDHHMMSShh date transforms are displayed.
Enable Column Transforms | When this check box is selected, date and time transforms may be applied to column definitions in the Table form. When this option is not selected, date and time transforms are available only in the FD form. Selecting this option is discouraged.
Include Configurable Forms | When this check box is selected, the end-user configurable 6-digit (and 8-digit, if the Include YYYY Forms option is selected) date transforms are displayed. See Defining Date Constants.
Include Period Begin/End | When this check box is selected, the YYMM01, YYMM31, YY001 and YY365 (and YYYYMM01, YYYYMM31, YYYY001 and YYYY365 if the Include YYYY Forms option is selected) date transforms are displayed. These transforms assume the first or last day of a month or year.


COBOL Types Options

See Also

The COBOL Types page contains options that enable the user to specify settings for COBOL data types, such as COMP-6, COMPUTATIONAL, numeric edited, and alphanumeric edited. The options selected in the page determine the choices available in the Item Type list displayed in the Add COBOL Data Item Redefinition dialog box.

The following table describes the options available on the COBOL Types page.

Option

Description

Micro Focus Types

Select this check box to include Micro Focus COBOL data types in the list of data types displayed in the Item Type list in the Add COBOL Data Item Redefinition dialog box. Selecting this box also displays the Data File Format box on the Data Source page.

If the data files to be accessed through this catalog do not include any Micro Focus COBOL data types, do not select this check box.

RM/COBOL Types

Select this check box to include RM/COBOL data types in the list of data types displayed in the Item Type list in the Add COBOL Data Item Redefinition dialog box. If the data files to be accessed through this catalog do not include any RM/COBOL data types, do not select this check box.

DEC COBOL Types

Select this check box to include DEC COBOL data types in the list of data types displayed in the Item Type list in the Add COBOL Data Item Redefinition dialog box. If the data files to be accessed through this catalog do not include any DEC COBOL data types, do not select this check box.

Binary Byte Storage Mode

When this check box is selected, BINARY usage (and other binary usages, such as COMP-4, COMP-5, and possibly COMP) are assumed to use byte storage mode. If this check box is not selected, binary usage items are assumed to use word storage mode.

Note In word storage mode, the same number of bytes is assigned regardless of whether the data item is signed or unsigned. In byte storage mode, the number of bytes assigned is dependent on whether the data item is signed or unsigned.

Floating Point Types

When this check box is selected, the catalog includes the floating point COBOL data types described by the USAGE IS COMP-1 and COMP-2 clause.

Note Floating point data types will appear in the Item Type list in the Add COBOL Data Item Redefinition dialog box only if the Micro Focus Types or DEC COBOL Types check box is selected.

COMP-6 (Packed, No Sign)

When this check box is selected, the catalog includes the unsigned packed COBOL data type described by the USAGE IS COMP-6 clause.

Note COMP-6 (Packed, No Sign) data types will appear in the Item Type list in the Add COBOL Data Item Redefinition dialog box only if the Micro Focus Types check box is selected.

Numeric Edited

When this check box is selected, the catalog includes the numeric edited data type described by the PICTURE character-string; for example, PIC Z9.99.

RM/COBOL (74) Types

When this check box is selected, the catalog includes the COMP-3 and COMP data types with a special positive sign convention.

RM/COS Types

When this check box is selected, the catalog includes the special COMP-3 and COMP data types with regard to minus and positive sign conventions in the RM/COS operating system.

DIBOL Types

When this check box is selected, imports from VAX COBOL have the option to be treated as DEC DIBOL.

Alphanumeric Edited

When this check box is selected, the catalog includes the alphanumeric edited data type described by the PICTURE character-string; for example, PIC XBXBX.

JUSTIFIED

When this check box is selected, the catalog accepts data items described with the JUSTIFIED clause.

Unpacked BCD (RM COMP)

When this check box is selected, the catalog includes the signed decimal COBOL data type described by the USAGE IS COMPUTATIONAL clause.

EBCDIC Types

When this check box is selected, the catalog includes the EBCDIC data types.


Privileges Options

See Also

The Privileges page contains an option pertaining to security privileges granted to a group. In a Relativity data source, a given group may have access rights or privileges to a table and to a column within the table. The option selected in the Privileges page affects the behavior of the Edit Privileges form.

The following table describes the option available on the Privileges page.

Option

Description

Independent 'SELECT' Privilege

In a Relativity data source, a given group may have access rights or privileges to a table and to a column within a table. By default, when the Designer is requested to give INSERT, UPDATE, REFERENCES, or DELETE privileges to a table or column, the Designer also automatically (and without being requested to do so) gives a SELECT privilege (an independent privilege) to that same table or column. This occurs because the INSERT, UPDATE, REFERENCES, or DELETE privileges are of little use if the data in the table or column cannot be seen as well.

When this option is enabled, the Designer will stop automatically granting the SELECT privilege when INSERT, UPDATE, REFERENCES, or DELETE privileges are granted.

To see how the Table and Column privileges (accessed through the Privilege list on the Edit Privileges form) are affected when this check box:

· is selected, click here.

· is not selected, click here.


Determining Micro Focus COBOL Indexed File Formats

Relativity must know the physical access name information (that is, the table connection) for the COBOL file that contains the actual data. For Micro Focus COBOL, the format of the indexed file also must be ascertained. The methods used depend on whether you are opening an existing or creating a new Micro Focus COBOL indexed file.

Opening Existing Micro Focus COBOL Indexed Files

When opening existing Micro Focus COBOL indexed files, the process used by Relativity to determine which indexed file format to request is as follows:

· The file format can be enclosed in square brackets and appended to the path name. The file format can either be a name or a number representing the file format. Valid values are: BTRIEVE, C-ISAM, DEFAULT, IDX4, IDX8, and LEVELII COBOL. The numeric representation can be used to specify a file format that is not represented by these names. (See the Micro Focus COBOL documentation concerning the IDXFORMAT directive for more information.)

· If the file format is not present in the path name, Relativity uses the value specified in the Data File Format list on the Data Source page of the Options dialog box. The valid values are < none >, BTRIEVE, C-ISAM, LEVELII COBOL, IDX4, IDX8, and Default.

· If the value for the file format specified in the Data File Format list on the Data Source page of the Options dialog box is < none >, the same file format as the data source's catalog is used. For more information, see "Relativity Setup - Micro Focus Options Page" under the index entry, Relativity Setup dialog box, in the Relativity DBMS Help file.

Note The ability to specify the file format using the Data File Format list is useful if the file format of the catalog is different from that of the data files. While the file format could be appended to the path name as described in the first item above, using the method described in the second point applies the same file format to all the path names in the data source.

Creating a New Micro Focus COBOL Indexed File

When Relativity receives a request to create new tables, a new Micro Focus COBOL indexed file is created to store the table's data. The file format of this Micro Focus COBOL indexed file is determined as follows:

· First, the Relativity DBMS checks the file format selected in the New File Format list on the Micro Focus Options page of the Relativity Setup dialog box. For more information, see "Relativity Setup - Micro Focus Options Page" under the index entry, Relativity Setup dialog box, in the Relativity DBMS Help file.

· If the file format selected in the approach described above is < none >, Relativity determines the file format using the Data File Format list on the Data Source page of the Options dialog box in the Relativity DSN.

· If, by using the Data File Format list, the value of the file format is determined to be < none >, the format of the new file will be the same file format as the catalog of the data source.


Using Relativity Help

See Also

The Relativity Designer comes with extensive online assistance and step-by-step instructions.

You can access Help while using Relativity in a number of ways. The method you use often depends on the type of information for which you are searching.

· Help Contents. In the Relativity Designer main window, from the Help menu, click Contents to open the Relativity Designer online HTML Help system. The left side of the Help window (the navigational pane) contains the Contents, Index, Search, and Favorites tabs. The right side of the Help window (the topic pane) displays the currently selected Help topic. Across the top of the Help window is a group of buttons that help you navigate through the Help contents and perform other operations, such as printing a topic in the Help file. (For more information, see Help Button Bar.)

-  To browse through topics grouped by subject: Click the Contents tab. From here, you can go directly to more specific information and a list of all the Help topics by double-clicking any closed book icon. Then select the topic of interest from the expanded list and click the topic. The Help window for that topic appears in the topic pane.

-  To see a list of alphabetized index entries (or keywords): Click the Index tab to find specific topics listed alphabetically (the online index is arranged just like a book index). Type an entry or the first few letters of the word for which you want to search, or scroll through the list. Then select the topic and click the Display command button. The content of that Help topic opens in the Help window.

-  To search for words or phrases that may be contained in a Help topic: Click the Search tab. Follow the instructions on your screen to complete this task.

-  To create a list of preferred Help topics: Click the Favorites tab. Follow the instructions on your screen to complete this task. Note that, by default, the contents of this tab is empty until you select topics to populate it. The content of the Favorites tab is automatically saved between sessions.

· Context-sensitive Help. While you are working in Relativity, you also can press F1 to access the associated Help topic for currently selected menu commands, toolbar buttons, dialog box options, and other screen elements.

· Tool tips. When you pause with the pointer (without the mouse button pressed) over an item on a toolbar, a small pop-up window that includes a brief description is displayed.

· Help button in a dialog box. If available, click the Help button in the dialog box you are using. A Help topic explaining the dialog box appears.

You can exit Relativity online Help from the Designer Help window by clicking the Close button on the title bar or double-clicking the Control Menu icon at the left end of the title bar. To exit a context-sensitive Help window, if necessary, press the Esc key on the keyboard.

From the Relativity Designer Help menu, you can also access additional online Help files, if appropriate:

· Click DBMS Help File for information on using the Relativity Data Manager.

· Click Server Admin Help File for information on using the Relativity Server Administrator.

· Click Relativity Configuration Help for configuration information.


Help Button Bar

See Also

Several Help buttons enable you to move around the Relativity Help topics easily. These Help buttons, located on the button bar at the top of the Relativity Help window, provide the following actions.

Button

Action

Hide/Show

Click the Hide button to close the navigational pane (on the left) of the Help window. Only the button bar and the topic pane are visible. To restore the navigational pane, click the Show button.

Note Be default, all three panes of the Help window are displayed initially.

Previous

Click the Previous button to display the previous topic in a series of related topics. When the first topic in the series is reached, the Previous button appears dimmed and is unavailable.

Next

Click the Next button to display the next topic in a series of related topics. When the last topic in the series is reached, the Next button appears dimmed and is unavailable.

Back

Click the Back button to navigate to the last Help topic viewed. Each time the Back button is chosen, topics are displayed one at a time moving backwards through the order in which topics were previously viewed.

Forward

Click the Forward button to navigate forward to the most recent Help topic viewed. Each time the Forward button is chosen, topics are displayed one at a time moving forwards through the order in which topics were previously viewed.

Print

If you are in the topic pane, click the Print button to display the standard Windows Print dialog box, which allows you to print a copy of the current Help topic.

Shortcut: Right-click the mouse button over a Help window and click Print from the context-sensitive menu that appears.

Note If you are on the Contents tab, click this button to print pages, headings, and subtopics, or the entire table of contents. If you are on the Index or Search tab, this button opens the standard Windows Print dialog box to print the current topic.

Options

Click the down arrow on the Options button to display a menu list that includes the following:

· Hide Tabs. Closes the navigational pane.

· Back. Jumps to the previous topic.

· Forward. Jumps to the next topic in a previously-viewed sequence.

· Home. Jumps to the designated home page of the Help system.

· Stop. Stops downloading file information.

· Refresh. Updates the topic that is currently displayed in the topic pane.

· Print. If you are on the Contents tab, provides options to print pages, headings, and subtopics, or the entire table of contents. If you are on the Index or Search tab, it opens the standard Windows Print dialog box to print the current topic.

If you are in the topic pane, click this option to display the standard Windows Print dialog box, which allows you to print a copy of the current Help topic.

· Internet Options. Opens the Internet Explorer Internet Options dialog box, allowing quick access to accessibility and other features.

· Search Highlight On/Off. Turns on or off highlighting for search terms.

Glossary

If available, the Glossary button displays the list of glossary terms associated with Relativity Help. Click any underlined term in the list to display a pop-up definition of that glossary term.


Relativity Product Support

Liant Software Corporation offers a variety of services to help you with your questions. The Relativity online Help file and the installation manuals are designed to address the majority of users' questions. If, however, these sources do not answer your question or problem, please check the following:

· README files included with the Relativity Designer media.

· Frequently Asked Questions (FAQs) topic in the Relativity Designer Help file.

· Messages topic in the Relativity Designer.

· Liant web site at http://www.liant.com.

Contact Liant Software Corporation to obtain more information about Liant's technical support and training programs, as well as other products, upgrades, and services.


Frequently Asked Questions (FAQs)

The following are frequently asked questions about the Relativity Designer.

1. Are there any limits on the number of columns per table in Relativity?

Answer: There is a limit of 256 columns for tables created using the SQL CREATE statement. Tables built on COBOL files are limited only by memory.

2. Are there any limits on the number of tables per database in Relativity?

Answer: The only limit on the number of tables per database in Relativity is that of memory.

3. What path name may be entered for a table connection?

Answer: A valid path name for a COBOL data file has one of the following structures:

· A filename where the file is located in the same directory as the Relativity catalog, for example, orderfile.

· A relative filename where the file is located in a directory subordinate to the Relativity catalog.

· A relative filename where the file is located in a directory parallel to the Relativity catalog.

· A Universal Name Convention path name where the path name begins with the notation: \\<server-name>\

4. What kind of data files can Relativity handle?

Answer: Relativity handles native COBOL data (sequential, relative and indexed) files that can be described by COBOL FDs. This does not require that the data be originated by COBOL applications. COBOL is quite expressive when it comes to file structure and record layout. The general answer to this question is that Relativity is a very COBOL-centric set of tools. This focus allows it to do a much better job than it otherwise could. But it does not require COBOL in order to function, especially the Relativity Database Manager.

5. Does Relativity always read the entire file to service queries, or does it somehow do something "smarter?"

Answer: Since Relativity is focused on providing a SQL-based (specifically ODBC) data management capability built on top of existing COBOL data files, the assumption behind the Relativity DBMS engine is that it is dealing with an optimized, unnormalized operational database. Specifically, the data file(s) has indices (both primary and alternate) that are the result of years of performance-tuning to support the access patterns determined by the existing COBOL application programs. While non-procedural, SQL access to the data is not restricted to the same access patterns as the legacy programs, well-designed SQL use of the data is usually quite effectively supported by the underlying legacy file characteristics. In order to accomplish this, the Relativity DBMS makes extensive use of any and all indices (keys) that can improve the efficiency of file access. For example, most COBOL indexed files have several alternate keys in addition to the primary key. In most cases, each of these keys covers several data items, and can be used in both complete and generic form. When the data items are used to populate columns in a relational table, the result is that the physical file key implements (automatically) many SQL indices. That is, it is equivalent to a "native" relational database for which many CREATE INDEX statements have been performed over many of the columns. It is not unusual to see Relativity tables (dynamically populated from existing indexed files) with 20 or 30 SQL indices reported. In most cases, this allows the Relativity query optimizer several choices of index in order to avoid full table scans.

6. What SQL dialect does Relativity support?

Answer: It supports "ODBC SQL." ODBC SQL (in all versions prior to ODBC 3.0) is based on the SQL Access Group SQL CAE (1992) specification. This is basically a subset of the ANSI SQL92 standard. With ODBC 3.0, the SQL is brought more into line with the full SQL92 standard. ODBC allows a wide range of implementor choices within this framework. Relativity implements a set of SQL functions that is designed to support all of the popular ODBC-based client applications and tools (for example, MS-Access, PowerBuilder, Forest&Trees, Impromptu, Lotus 123, and so forth.). Usually, a human being never even sees the SQL being used. MS-Access is a good example of a tool that has its own SQL dialect, and it "compiles" SQL statements into the ODBC standard form dynamically.

7. Is there an open interface to the data dictionary used by Relativity?

Answer: First of all, Relativity calls its "data dictionary" the system catalog. This is similar to the system catalogs implemented as part of all relational database systems. Like all ODBC-compliant relational database management system (RDBMS) products, Relativity supports the extensive set of ODBC functions that provide access to the meta-data within a catalog.

8. Does Relativity optimize SQL queries in any way besides using indices?

Answer: The Relativity Database Manager collects information regarding the size of the data files. This information, within the constraints of the tables built on top of the files, is maintained in the system catalog. The SQL query optimizer uses it to choose an optimal execution plan. Because there is not a 1:1 mapping between tables and files, the Database Manager doesn't always have an accurate count of the number of rows in a given table until it has done a full scan. The size information is also not necessarily up-to-date. In any event, Relativity uses the best information available to generate the best possible access plan.

9. Is there any kind of data security provided by Relativity?

Answer: Relativity implements (within the catalog) a security scheme based on the capabilities specified for SQL92 GRANT/REVOKE. This means that the catalog owner (and any user granted Relativity DBA rights by the owner) may control access to tables and individual columns within the database. These access privileges are associated with the Relativity user IDs that are authenticated at ODBC logon time. If the user is allowed to access the Relativity database object (tables and columns), then the access rules within the database (for example, read, update, and insert) are enforced. If not, then use via Relativity is denied.

10. How does Relativity map SQL tables onto COBOL files?

Answer: This is a complicated question to answer. Relativity doesn't so much map tables to files as it allows a "normal" relational database to be defined along with the "bindings" to physical files and data items within the files that allow it to dynamically materialize rows within the tables at runtime. The bindings are established when the database designer (not the end-user of the database) "drags" a COBOL data item or group to an "in-progress" table definition. In addition to the bindings, there are many other things the database designer can (and in some cases, must) tell Relativity about the data. Examples are: what record-level data conditions distinguish one table's data from another, how the database designer would like Relativity to "unroll" repeating data items (row/item, column/item or another, more exotic, way), and how distinct repeating items relate to each other (independent, parallel, other). Furthermore, there is great flexibility in determining which SQL data type the data is presented as and how Relativity uses the record-level information to determine its value.

11. Why don't I get to specify any SQL index on the tables I build using the Relativity Designer?

Answer: The Relativity Database Manager automatically creates every possible index for the table using the COBOL keys defined for the underlying file. For properly designed tables, this means that there will be at least one index covering the primary key columns. There can be many more if columns are present that cover all or part of the COBOL alternate keys. Queries that are based on SQL index columns usually run much faster than queries that aren't.

12. What if the columns in my table only cover part of the COBOL file key? Will Relativity still be able to speed up SQL operations on the table?

Answer: Yes, provided that the data value(s) for the missing portions of the key can be determined as a result of the table filters and record type conditions defined for the table and its underlying file. For example, a table could be defined on a file with several record types, one of which is a customer record that has a "C" in the first item of each record. The customer number follows this item and consists of a PIC 9999 data item. The primary key for the file covers both record type and the customer number item. A "Customer" table built on this record type can have a column based on the customer number item. This column can serve as a unique index since the Relativity DBMS knows that the leading character on the file key must always be "C".

13. Why do queries on my table run slowly, as if an index that should be used did not exist?

Answer: There can be several reasons queries might seem to run more slowly than they should. One, in particular, to look out for is the existence of columns based on signed numeric items within a COBOL file key. Since it is possible for these items to contain negative numbers (and if they did, the key under the column would not sort the rows in the proper sequence), Relativity cannot use the key for searching and ordering. Many times the declaration of the data item as signed is the result of convention, and may not truly reflect a signed item. If this is the case, the Relativity Designer can often be used to redefine an unsigned item over the original signed item. This new item can then be used for column definitions. The resulting columns can then be used within a SQL index.

14. Why should I use record types or table filters to make several tables on one file? Wouldn't it be easier to define a table with all of the possible columns from all of the file items? SQL could then be used to select only the column values that matter for a particular record.

Answer: Remember that the foundation of relational technology (including SQL) is that the database structure should not reflect the "expected" use of the data. The beauty of a relational database management system (RDBMS) is that it supports patterns of data access that were unanticipated by the data designers. A common measure of how well a relational database lives up to this ideal is the "degree of normalization." By using record types and table filters to produce highly normalized tables, the Relativity Designer can produce a true relational database made up of business data objects. This database can be manipulated by the end-user with little or no knowledge of COBOL and COBOL data structures. By taking a little effort at database design time, the developer can save many times that effort for every user of the database.

15. When should I use a table filter versus a record type definition? They seem to do the same thing?

Answer: They do both accomplish a similar task. Sometimes the choice of which to use is subjective. Typically, the record type capability should be used to describe different record layouts (usually reflected by REDEFINEs). The record type filter then describes the conditions under which the layout correctly describes the record. The table filter is typically used to define subsets of a particular file record type, especially when the records of a single type link to multiple file types. An example of this would be a COMMENTS file that contains comment text for both orders and invoices. An appropriate use of table filters would be to split this into an order_comment table and an invoice_comment table.


Messages

The following is a partial list of messages displayed by the Relativity Designer:

· Catalog C:\SHIRT-1\SHIRT1.RCG was successfully created.

This informational message indicates that a Relativity catalog with the specified path name has been created as a result of entries in the Create Catalog for Data Source dialog box, which is described in "Creating a New Relativity Catalog" under the For All Users | Adding, Modifying, and Deleting a Relativity Data Source topic in the Relativity DBMS Help File.

· Commit xxxxxx record type to catalog?

This inquiry message appears after a record type is defined by the Add Record Type dialog box. A response of YES causes the record type to be included in the Relativity catalog.

· Commit FD Changes?

This inquiry message appears after the selection of the Save Changes button on the FD form toolbar. A response of OK causes all changes made to the FD form during this editing session to be included in the Relativity catalog.

· Does xxxxxx contain the complete value?

This inquiry message appears after selection of the Add Items to Set button on the Edit Item Sets form. A response of Yes causes the addition of a redundant data item to an item set.

· Include subordinate items in xxxxxx?

This inquiry message appears after the selection of the Add Record Type dialog box. A response of YES causes the subordinate data items of the data item XXXXXX to be included in the record type.

· Selections may contain only items that have OCCURS clause.

This information message appears after the selection of the Parallel Occurs button on the FD form toolbar. This message indicates that a selected data item does not contain an OCCURS clause.

· Selections may contain only one OCCURS item.

This information message appears after pressing the Parallel Occurs button.

· There is no condition (88-level) item in the FD upon which to base record selection.

This information message indicates that a data item in the FD form must be associated with a conditional variable having one or more 88-level condition-names. For further information, see Adding Condition Items.

· xxxxxx already has a DEPENDING ON item.

This information message appears after the selection of the Occurs Depending On button on the FD form toolbar. This message indicates that the data description of the specified data item already contains the DEPENDING ON phrase.

· xxxxxx is not in the record type.

This information message appears when the specified data item has been previously deleted from the record type.

· You will lose one or more FD changes. Please confirm: Do you wish to commit FD changes?

This inquiry message makes a second inquiry to verify that the changes made to the FD form during this editing session are to be ignored instead of accepted into the Relativity catalog.


Contact Liant Software Corporation

Use any of the following methods to contact Liant Software Corporation:

By | At
E-mail | sales@liant.com
Web site | http://www.liant.com
Telephone | US | (1) 512-343-1010 (1) 800-762-6265 (800-RM-COBOL)
Fax | US | (1) 512-343-9487
Mail | Liant Software Corporation 5914 West Courtyard Drive, Suite 100 Austin, Texas 78730 USA Registered in England No. 2355483 Registered Office: Pellipar House, 1st Floor, 9 Cloak Lane, London, EC4R 2RU VAT Registration No. GB 503 3514 90


Using the Catalog Window

Relativity Catalogs


Relativity Catalogs

See Also

The function of the Relativity catalog is similar to that of the "system catalog" in a relational database management system. It serves as a repository for information regarding the structure of relational tables as well as operational information required by runtime components of Relativity, such as the query optimizer. Additionally, the Relativity catalog contains complete information regarding the physical COBOL file structure (that is, the COBOL file definition, or FD information) and information produced by the database design process (Relativity Designer) that defines the association between COBOL files and data elements, and the relational tables and their constituent columns. Together, all of this information allows Relativity to present the COBOL data files through an ODBC interface of an ODBC-enabled application as a relational database of well-normalized tables substantially independent of the original COBOL file structure of the application.

The Catalog window, which is displayed in the Relativity Designer main window when a Relativity catalog (the mechanism that supports the Relativity database specified by the ODBC data source) is opened, is the point of origin for many of the activities related to structuring the COBOL data so that it can be viewed in a relational table. Within the Catalog window, lists of file definitions, tables, and reports can be viewed and opened. User information also can be viewed and changed.


Working with the Catalog Window

See Also

Information for Users of Prior Versions of Relativity If you have used earlier versions of Relativity, you will notice an important change to the Relativity Designer interface. The Catalog window is, by default, displayed in the new Windows XP Look & Feel layout view when you open a data source in the Relativity Designer.

Relativity displays the Catalog window when the data source associated with the Relativity catalog is opened.

Within the Catalog window, you can select from a list of catalog objects that include definitions of files, tables, and reports. You also can view user and group definitions. Common tasks associated with each type of catalog object can be initiated through the Catalog window.

Note An alternative method of choosing catalog tasks is provided by using commands from the View menu. It is also possible to change the appearance of the Catalog window using the Layout option on the View menu:

· Choosing XP Look & Feel causes Windows XP theme and visual styles to be used. This is the default view.

· Choosing Tabbed maintains the appearance of earlier versions of Relativity, which featured a series of tab layouts.

Note While descriptions of the Catalog window in Tabbed layout view are provided here, the information and procedures in the Relativity Help files are written for the Windows XP Look & Feel default view.


XP Look & Feel Layout View

If you choose the XP Look & Feel option from the Layout command on the View menu, the Catalog window provides a list of available catalog objects and interactively lists the common tasks and other pertinent information associated with the selected object. For example, if you choose Tables from the catalog objects, Relativity lists the activities that can be performed on the table and also lists the parent FD of the table. The Tooltips feature provides brief descriptions when the user hovers the cursor over an item without clicking it.


Tabbed Layout View

If you choose the Tabbed option from the Layout command on the View menu, the Catalog window is presented with a set of four tabs. To select a tab in the Catalog window, click on it. (The buttons available on each tab are described following this table.)

Tab | Displays a list of
Files | File definitions (COBOL file-names) that have been imported into the catalog. Single-clicking a file-name in the list selects it. Double-clicking a file-name in the list displays the FD form, which is equivalent to selecting the file and then clicking the Open button. (See the table below.) For more information, see Files Catalog Object.
Tables | Table definitions currently defined in the catalog. A table may be selected by clicking once on the table name. Double-clicking a table name in the list is equivalent to selecting it and then clicking the Open button. (See the table below.) For more information, see Tables Catalog Object.
Users | Groups and users currently defined in the catalog for the Relativity database. A group or user may be selected by clicking once on the group or user name. Double-clicking a group name is equivalent to selecting it and clicking the Privileges button. Double-clicking a user name simply selects the user name. (See the table below.) For more information, see Users & Groups Catalog Object.
Reports | Defined report categories and the descriptions of the currently defined reports for each category. A report category or a report description may be selected by clicking once on the desired item in the list. (See the table below.) For more information, see Reports Catalog Object.

Note In the tabbed view of the Catalog window, a set of buttons is active in all tabs. The names and purposes of these buttons change according to the selected tab. The following table lists the command buttons and the actions caused by selecting a tab. Note that double-clicking an object in the list area of each tab causes the action of the rightmost button (Open or Privileges) to occur.

Button

Tabs

Action

New

Files
Tables
Users

Creates a new object type for selected tab:

· For a Files catalog object, displays the Source Code Import wizard for the selection of the COBOL data files for the importing process.

· For a Tables catalog object, displays an empty (blank) Table form for the creation of a new table.

· For the Users & Groups catalog object, displays the Edit Users form for the definition of a new group or user for the catalog.

Open

Files
Tables
Reports

Edits the selected object:

· For a Files catalog object, displays the FD form for the selected file in the Catalog window. The Open button is disabled if a file has not been selected in the Files area list.

· For a Tables catalog object, displays the Table form for the selected table.

· For a Reports catalog object, provides the facility to either create a new report or modify a selected report.

-  If a report category has been selected, the Select Report dialog box is opened for selecting an existing report or creating a new report. (Note the exact name of this dialog box varies depending on the report category selected.) After completing the actions in this dialog, the selected report will open in the Report Editor.

-  If a specific report description has been selected, that report will be opened in the Report Editor for editing its description.

In either situation, the edited description may be saved as a new report, or saved as the new layout for the same report (using the Save As or Save command, respectively, in the Report Editor).

Merge

Files

Displays the Source Code Merge wizard for the selection of the COBOL data files for the merging process.

Files

Displays the Table wizard, which simplifies the creation of a table by automating the selection of elementary items from the FD form, the addition or removal of items to or from the table, and the editing of column names.

Connections

Tables

Displays the Edit Connections form for the selected table in order to edit the physical file connections for a table definition.

Delete

Users

Removes the selected group or user from the catalog. If a user name has been selected, the user name is immediately deleted. A message box, however, will be displayed requesting confirmation of a delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.

Privileges

Users

Displays the Edit Privileges form where you can edit access privileges for the selected group. If a group is not selected, the Privileges button is disabled.

Print

Reports

Displays the Print Options dialog box for the printing of the selected report.

Note If a report category is selected instead of a specific report description, a Select Report dialog box is displayed first to allow selection of the specific report definition file to be printed.

Export

Reports

Displays the Save Export File As dialog box for the output of a comma-separated value (.csv) text file. After you complete the Save Export File As dialog box, the Print Options dialog box is displayed. You must also print the report in order to write the .csv file.

Notes

· If a report category is selected instead of a specific report description, the Select Report dialog box is displayed after you complete the Save Export File As dialog box. After you select a specific report definition file, the Print Options dialog box is displayed.

· For procedures on how to export data, see Export data stored in a Relativity catalog.


Files Catalog Object

See Also

Selecting the Files catalog object in the Catalog window allows you to see a list of COBOL file-names that have been imported into the catalog and provides easy access to a variety of common tasks available for working on the file definitions. Double-clicking a file-name in the list displays the FD form.

When the Files catalog object is active in the Catalog window, the FD menu is displayed on the menu bar of the Relativity Designer window. (Note that the FD menu contains a different set of commands depending upon whether the focus is on the Catalog window or on a file definition opened in the FD form.)

Note Many of the commands on the FD menu also can be accessed quickly by opening a context-sensitive (or pop-up) menu. To open a context menu of the commands on the FD menu when Files is selected as the catalog object in the Catalog window, right-click a COBOL file definition. From the pop-up context menu, choose the command you need.

The Files catalog object contains the following options:

Option

Description

Catalog Objects

This area lists the Files, Tables, Users & Groups, and Reports objects that can be opened and viewed within the Catalog window. Click Files to display a list of COBOL file-names that have been imported into the catalog.

Common Tasks

When Files is selected as the catalog object, the name of this area is labeled as FD Common Tasks. This area displays the options (shortcuts) most often used with a Files catalog object:

· Open. Displays the FD form for the selected COBOL file definition in the Catalog window.

Note The Open shortcut provides the same functionality as the Open command on the FD menu (or the Open button on the Files tab when Tabbed layout view is selected).

· Import COBOL FDs. Moves information about the file description entries and the associated record descriptions of one or more COBOL files to the Relativity catalog. The Source Code Import wizard is displayed for the selection of the COBOL data files for the importing process. See Importing COBOL File Definitions and Creating a COBOL Schema File.

Note The Import COBOL FDs shortcut provides the same functionality as the Import COBOL FDs command on the FD Menu (or the New button on the Files tab when Tabbed layout view is selected).

· Merge COBOL FD Changes. Merges new (or changed) COBOL file definitions with corresponding definitions existing in the Relativity catalog. The Source Code Merge wizard is displayed for the selection of the COBOL data files for the merging process. See Merging COBOL File Definitions.

Note The Merge COBOL FD Changes shortcut provides the same functionality as the Merge COBOL FD Changes command on the FD menu (or the Merge button on the Files tab when Tabbed layout view is selected).

· Table Wizard. Displays the Table wizard, which simplifies the creation of a table by automating the selection of elementary items in the FD form, the addition or removal of items to or from the table, and the editing of column names. See Using the Table Wizard.

Note The Table Wizard shortcut provides the same functionality as the Table Wizard command on the FD menu (or the Table Wizard button on the Files tab when Tabbed layout view is selected).

· Delete FD. Removes the selected file-name of the file definition from the Relativity catalog. A message box will be displayed requesting confirmation of the delete request. If there are any table definitions based on the file definition, a second confirmation message box informs the user of the existing tables. If the user confirms the deletion, the file definition and any table definitions based on that file definition are deleted from the catalog.

Notes

-  The Delete FD shortcut provides the same functionality as the Delete FD command on the FD menu (or the Delete FD button on the FD form toolbar).

-  In addition to using the Delete FD shortcut or the Delete commands on the FD menu, it is possible to use the Del (Delete) key from the Catalog window to delete a selected file definition from the catalog.

Associated Tables

When Files is selected as the catalog object, this area displays any table that has the highlighted (selected) file as its parent FD.

List

This area displays a list of COBOL file-names that have been imported into the catalog.

· Single-clicking a file-name in the list selects it. You may then choose the appropriate shortcut from the FD Common Tasks area.

· Double-clicking a file-name in the list displays the FD form, which is equivalent to selecting the file and then choosing the Open shortcut.


Tables Catalog Object

See Also

Selecting the Tables catalog object in the Catalog window allows you to see a list of tables currently defined in the catalog and provides easy access to a variety of common tasks available for working on them. Double-clicking a table name in the list displays the Table form.

When the Tables catalog object is active in the Catalog window, the Table menu is displayed on the menu bar of the Relativity Designer window. (Note that the Table menu contains a different set of commands depending upon whether the focus is on the Catalog window or on a table definition opened in the Table form.)

Note Many of the commands on the Table menu also can be accessed quickly by opening a context-sensitive (or pop-up) menu. To open a context menu of the commands on the Table menu when Tables is selected as the catalog object in the Catalog window, right-click a table name. From the pop-up context menu, choose the command you need.

The Tables catalog object contains the following options:

Option

Description

Catalog Objects

This area lists the Files, Tables, Users & Groups, and Reports objects that can be opened and viewed within the Catalog window. Click Tables to display a list of the tables defined in the data source.

Common Tasks

When Tables is selected as the catalog object, the name of this area is labeled as Table Common Tasks. This area displays the options (shortcuts) most often used with a Tables catalog object:

· New. Displays an empty (blank) Table form for the creation of a new table.

Note The New shortcut provides the same functionality as the New command on the Table menu (or the New button on the Tables tab when Tabbed layout view is selected).

· Open. Displays the Table form for the selected table definition.

Note The Open shortcut provides the same functionality as the Open command on the Table menu (or the Open button on the Tables tab when Tabbed layout view is selected).

· Copy. Opens the Copy table name dialog box, where you can copy a selected table and give it a new table name.

Note The Copy shortcut provides the same functionality as the Copy command on the Table menu.

· Rename. Opens the Rename table dialog box for a table selected in the Catalog window. If a table is being renamed, the rename process will rename the table definition and, optionally, change the connection name. If a connection has the same name as the table being renamed, a message box will give you the option to rename the connection at the same time the definition is renamed. If there are any open file definitions or table definitions that will be affected by the rename, they will be automatically closed during the rename process. A table name must not be an SQL reserved word. See Establishing Table Connections.

Note The Rename shortcut provides the same functionality as the Rename command on the Table menu.

· Show Table Contents. Opens the Show Table Contents form for the selected table, where you can preview data about the contents of the table.

Note The Show Table Contents shortcut provides the same functionality as the Show Table Contents command on the Table menu or the Show button on the Table form toolbar.

· Connections. Displays the Edit Connections form for the defining and editing of a table connection. When the form is opened in this manner, it displays only the table definition currently selected on the Tables catalog object in the Catalog window or in the Table form.

Note The Connections shortcut provides the same functionality as the Connections command on the Security menu (or the Connections button on the Tables tab when Tabbed layout view is selected). If you choose the Connections command from the Security menu, however, the Edit Connections form lists all the tables currently defined in the catalog.

· Delete. Removes the selected table definition from the Relativity catalog or the entire table displayed in the Table form. A message box will be displayed requesting confirmation of the delete request. If there are any table definitions based on the file definition, a second confirmation message box informs the user of the existing tables. If the user confirms the deletion, the file definition and any table definitions based on that file definition are deleted from the catalog.

Notes

-  The Delete shortcut provides the same functionality as the Delete command on the Table menu or the Delete Table button on the Table form toolbar.

-  In addition to using the Delete shortcut or the Delete commands on the Table menu, it is also possible to use the Del (Delete) key from the Catalog window to delete a selected table from the catalog.

Parent FD

When Tables is selected as the catalog object, this area is displayed, allowing you to open the FD for that table.

List

This area displays a list of tables currently defined in the catalog.

· A table may be selected by clicking once on the table name and then choosing the appropriate shortcut from the Table Common Tasks area.

· Double-clicking a table name in the list displays the Table form, which is equivalent to selecting the table name and then choosing the Open shortcut.


Users & Groups Catalog Object

See Also

Selecting the Users & Groups catalog object in the Catalog window allows you to see a list of groups and users currently defined for the catalog and provides easy access to a variety of common tasks available for working on them.

When the Users & Groups catalog object is active in the Catalog window, the User menu is displayed on the menu bar of the Relativity Designer window.

Note Many of the commands on the User menu also can be accessed quickly by opening a context-sensitive (or pop-up) menu. To open a context menu of the commands on the User menu when Users & Groups is selected as the catalog object in the Catalog window, right-click a group or user name. From the pop-up context menu, choose the command you need.

The Users & Groups catalog object contains the following options:

Option

Description

Catalog Objects

This area lists the Files, Tables, Users & Groups, and Reports objects that can be opened and viewed within the Catalog window. Click Users & Groups to display a list of the groups and users currently defined in the catalog for the Relativity database.

Common Tasks

When Users & Groups is selected as the catalog object, the name of this area is labeled as User Common Tasks. This area displays the options (shortcuts) most often used with a Users & Groups catalog object:

· Add Group. Displays the Add Database Group dialog box for the entry of a new group name, an optional password, and an expiration date for the group name.

Note The Add Group shortcut provides the same functionality as the Add Group command on the User menu or the Add Group button on the Edit Users form.

· Add User. Displays the Add Database User dialog box for the entry of a new user name, an optional password, and an expiration date for the user name.

Note The Add User shortcut provides the same functionality as the Add User command on the User menu or the Add User button on the Edit Users form toolbar.

· Privileges. Displays the Edit Privileges form for the selected group in the Catalog window. (This shortcut does not appear if a user name is selected.)

Note The Privileges shortcut provides the same functionality as the Privileges command on the User menu (or the Privileges button on the Users tab when Tabbed layout view is selected). If a group is not selected, the Privileges shortcut (or button) is disabled.

· Delete. Removes the selected group or user from the catalog. If a user name has been selected, the user name is immediately deleted. A message box, however, will be displayed requesting confirmation of a delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.

Notes

-  The Delete shortcut provides the same functionality as the Delete command on the User menu (or the Delete button on the Users tab when Tabbed layout view is selected).

-  In addition to using the Delete shortcut or the Delete command on the User menu, it is also possible to use the Del (Delete) key from the Catalog window to delete a selected group or user from the catalog.

· Change Catalog Owner. Displays the Change Catalog Owner dialog box. The Change Catalog Owner dialog box displays options for a new owner name and an optional password. See Defining Catalog Ownership.

Note The Change Catalog Owner shortcut provides the same functionality as the Change Catalog Owner command on the Security menu.

List

This area displays a list of the groups and users currently defined in the catalog for the Relativity database.

A group or user may be selected by clicking once on the group or user name in the list and then choosing the appropriate shortcut from the User Common Tasks area.

· Double-clicking a group name in the list displays the Edit Privileges form, which is equivalent to selecting it and then clicking the Privileges shortcut.

· Double-clicking a user name simply selects the user name.


Reports Catalog Object

See Also

Selecting the Reports catalog object in the Catalog window allows you to see a list of the report categories and the descriptions of the currently defined reports for each category and provides easy access to a variety of common tasks available for working on them. A report category or a report description may be selected by clicking once on the desired item in the list.

The Reports menu is displayed on the menu bar of the Relativity Designer window.

Note Many of the commands on the Reports menu also can be accessed quickly by opening a context-sensitive (or pop-up) menu. To open a context menu of the commands on the Reports menu when Reports is selected as the catalog object in the Catalog window, right-click a report category or report description. From the pop-up context menu, choose the command you need.

The Reports catalog object contains the following options:

Option

Description

Catalog Objects

This area lists the Files, Tables, Users & Groups, and Reports objects that can be opened and viewed within the Catalog window. Click Reports to display a list of the report categories and the descriptions of the currently defined reports for each category.

Common Tasks

When Reports is selected as the catalog object, the name of this area is labeled as Report Common Tasks. This area displays the options (shortcuts) most often used with a Reports catalog object:

· Print. Displays the Print Options dialog box for the printing of the selected report. If a report category is selected instead of a specific report description, a Select Report dialog box is displayed first to allow selection of the specific report definition file to be printed. (Note that the exact name of this dialog box varies depending on the report category selected.) See Reporting and procedures on how to print a report.

Note The Print shortcut provides the same functionality as the Print command on the Reports menu (or the Print button on the Reports tab when Tabbed layout view is selected).

· Export. Displays the Save Export File As dialog box in order to export those fields and variables included in a report to a comma-separated value (.csv) text file. After you complete this dialog, the Print Options dialog box is displayed. You must also print the report in order to write the .cvs file.

Note If a report category is selected instead of a specific report description, the Select Report dialog box is displayed after you complete the Save Export File As dialog. After you select a specific report definition file, the Print Options dialog is displayed.

See Exporting Data to a Comma-Separated File and Reporting.

· Edit. Provides the facility to either create a new report or modify a selected report.

-  If a report category has been selected, the Select Report dialog box is opened for selecting an existing report or creating a new report. (Note that the exact name of this dialog box varies depending on the report category selected.) After completing the actions in this dialog, the selected report will open in the Report Editor.

-  If a specific report description has been selected, that report will be opened in the Report Editor for editing its description.

In either situation, the edited description may be saved as a new report, or saved as the new layout for the same report (using the Save As or Save commands, respectively, in the Report Editor).

Note The Edit shortcut provides the same functionality as the Edit command on the Reports menu (or the Open button on the Reports tab in the Catalog window when Tabbed layout view is selected).

List

This area displays a list of the report categories and the descriptions of the currently defined reports for each category.

A report category or a report description may be selected by clicking once on the desired item in the list and then choosing the appropriate shortcut from the Report Common Tasks area.

· Double-clicking a report category in the list displays the Select Report dialog box, which is equivalent to selecting the report category and then clicking the Print shortcut.

· Double-clicking a report description in the list displays the Print Options dialog box, which is equivalent to selecting the report description and then clicking the Print shortcut.


Preparing the COBOL Source

Preparing COBOL Files for Relativity

Importing COBOL File Definitions

Importing Definitions from Another Relativity Catalog

Importing Btrieve Keys (Micro Focus COBOL Only)

Maintaining Character Sets

Defining Nonstandard Character Sets


Preparing COBOL Files for Relativity

Before Relativity can retrieve application data, a normalized view of the COBOL schema file (or files) must be created. The schema information (all file description language syntax), which describes COBOL file structures, must be extracted from a COBOL application. The schema information is then mapped to a relational view (rows and columns). For information on creating a COBOL schema file, click here.

Once the schema information has been created, you are ready to import COBOL file definition information into the Relativity catalog. For more information, select from the following topics:

· Importing COBOL File Definitions

· Importing Definitions from Another Relativity Catalog

· Importing Btrieve Keys (Micro Focus COBOL Only)


Creating a COBOL Schema File

See Also

The Relativity Designer includes the Source Code Import wizard to automate the process of creating a COBOL schema file.

The schema extraction process extracts information from the file control entry (SELECT clause), file description entry (FD entry), and the associated data description entries for each file described in the COBOL source file and creates the COBOL schema file using this information. The COBOL schema file is also called the Relativity Symbol Table file (or RST file).

The schema extraction process also extracts information about Working-Storage Section and Linkage Section data description entries since these may include record description entries of interest to Relativity.

For procedures on how to use the Source Code Import wizard to import COBOL file definitions, click one of the following:

· Import a COBOL source file

Note In the schema extraction process for RM/COBOL when using the Import COBOL Source option, a number of restrictions exist.

· Import a previously compiled symbol table (RST) file

· Import a previously compiled RM/COBOL object program

Note In the schema extraction process for RM/COBOL when using the Import Previously Compiled RM/COBOL Program (.COB) option, a number of restrictions exist.

Relativity also includes support for Micro Focus COBOL compiler directives. For more information, click here. In the schema extraction process for Micro Focus COBOL on UNIX, a number of restrictions exist and several error messages may occur.


Import a COBOL source file

1. With a catalog open in the Relativity Designer, click the Import COBOL FDs shortcut from the FD Common Tasks area of the Files catalog object in the Catalog window or click Import COBOL FDs on the FD menu.

The Source Code Import wizard is displayed with the Import COBOL Source option selected as the default. This is the option required for this procedure.

Note In the schema extraction process for RM/COBOL when using the Import COBOL Source option, a number of restrictions exist.

2. In the Dialect list box, specify the desired type of COBOL files (RM/COBOL or MF COBOL).

The Source Code Import wizard provides different capabilities, depending upon which COBOL dialect, RM/COBOL or MF COBOL, is selected. To see the Source Code Import wizard with MF COBOL selected as the dialect, click here.

3. To specify the filename and path of the file you want to import into Relativity, do one of the following:

· If you know the name and path of the file, type it in the File to Import text box. Proceed to Step 5.

Note If the source file specified in the File to Import text box contains an error, the Detected Errors page of the Source Code Import wizard is displayed so that you can view the error file or view and edit the source file.

· If you do not know the name and path of the file, click Browse to open the Select COBOL Source dialog box. Proceed to Step 4.

4. In the Select COBOL Source dialog box, you can take the following actions:

a. In the Look in list, select the drive and folder containing the COBOL source file to be imported into the Relativity catalog.

b. In the File name box, type or select the filename of the COBOL source file to be imported into the Relativity catalog. This filename must have the suffix specified in the Files of type list.

c. In the Files of type list, select a file having the .CBL suffix.

d. Click Open to close the Select COBOL Source dialog box. The name of the selected file is displayed in the File to Import text box on the first page of the Source Code Import wizard.

5. In the wizard, if applicable, select the Process XML option to import any relational information in an accompanying XML file related to the selected COBOL FD.

6. If you are working with RM/COBOL files, enter an appropriate RM/COBOL Compile Command Option in the Compiler Options box.

7. Click Next to open the File Selection page of the Source Code Import wizard.

The File Selection page displays the COBOL data file definitions to be included in the importing procedure. By default, the Relativity Designer assumes that you want to import all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.

Note To import a selected character set, press the Advanced button on the File Selection page of the Source Code Import wizard to open the Select Character Set dialog box.

8. From the Selected Files list, select the COBOL data file definitions you do not want to import, if necessary, and click Remove or Remove All to move the file(s) to the Available Files list. Tip

Note If you do not want to select specific record definitions for one or more files, proceed to Step 10.

9. To select specific record descriptions from one or more files, take the following actions:

a. Select a filename (or filenames) from the Selected Files list and click Remove or Remove All to move the file(s) to the Available Files list.

b. Select a file in the Available Files list and click Select 01’s to display the Select 01's dialog box.

c. In the Section area, select the File, Working-Storage, and/or Linkage check boxes to determine the level 01 names to be displayed.

d. Select one or more record descriptions, Working-Storage Section data descriptions, and/or Linkage Section data descriptions. These descriptions will be imported as if subordinate to the selected file in the File Selection page of the Source Code Import wizard.

e. Click OK to close the dialog box and return to the File Selection page of the Source Code Import wizard. Then, click Add or Add All to move the file(s) from the Available Files list back to the Selected Files list.

10. Click either Remove or Remove All to move the selected COBOL data file definitions in the Selected Files list to the Available Files list.

11. Click Finish to complete the importing of the source code file.


RM/COBOL Source Program Schema Extraction Restrictions

The following restrictions and problems exist in the schema extraction process for RM/COBOL when using the Import COBOL Source option:

1. Empty groups generate a syntax error and the entire COBOL source is not imported into the catalog.

2. All relational-operators for the VALUE clause are not supported. Condition items with these relational operators generate a syntax error and the entire COBOL source is not imported into the catalog. For more information, see "Relation Condition" in Chapter 5 and "VALUE Clause, Format 2" in Chapter 4 of the RM/COBOL Language Reference Manual.

3. Data items with a USAGE Clause of Pointer are not supported. They will result in a syntax error and prevent the COBOL source from being imported into the catalog.

4. The source format extensions introduced in RM/COBOL 11, including longer source lines and changing of the right margin, are not supported, will result in syntax errors, and prevent the COBOL source from being imported into the catalog.

Note The Import COBOL Source option is being deprecated for the RM/COBOL source dialect. Liant recommends using the Import Previously Compiled RM/COBOL Program (.COB) option instead.


Import a previously compiled symbol table (RST) file

1. With a catalog open in the Relativity Designer, click the Import COBOL FDs shortcut from FD Common tasks are of the Files catalog object in the Catalog window or click Import COBOL FDs on the FD menu.

2. In the Source Code Import wizard, select the Import Previously Compiled Symbol Table (.RST) option.

3. To specify the previously compiled Relativity Symbol Table file that you want to import into Relativity, do one of the following:

· If you know the name and path of the file, type it in the File to Import text box. Proceed to Step 5.

· If you do not know the name and path of the file, click Browse to open the Select Symbol Table dialog box. Proceed to Step 4.

4. In the Select Symbol Table dialog box, you can take the following actions:

a. In the Look in list, select the drive and folder containing the RST file to be imported into the Relativity catalog.

b. In the File name box, type or select the filename of the RST file to be imported into the Relativity catalog. This filename must have the suffix specified in the Files of type list.

c. In the Files of type list, select a file having the .RST suffix.

d. Click Open to close the Select Symbol Table dialog box. The name of the selected file is displayed in the File to Import text box on the first page of the Source Code Import wizard.

5. In the wizard, if applicable, select the Process XML option to import any relational information in an accompanying XML file related to the selected COBOL FD.

6. Click Next to open the File Selection page of the Source Code Import wizard.

The File Selection page displays the COBOL data file definitions to be included in the importing procedure. By default, the Relativity Designer assumes that you want to import all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.

Note To import a selected character set, press the Advanced button on the File Selection page of the Source Code Import wizard to open the Select Character Set dialog box.

7. From the Selected Files list, select the COBOL data file definitions you do not want to import, if necessary, and click Remove or Remove All to move the file(s) to the Available Files list. Tip

Note If you do not want to select specific record definitions for one or more files, proceed to Step 9.

8. To select specific record descriptions from one or more files, take the following actions:

a. Select a filename from the Selected Files list.

b. Click Select 01’s to display the Select 01's dialog box.

c. In the Section area, select the File, Working-Storage, and/or Linkage check boxes to determine the level 01 names to be displayed.

d. Select one or more record descriptions, Working-Storage Section data descriptions, and/or Linkage Section data descriptions. These descriptions will be imported as if subordinate to the selected file in the File Selection page of the Source Code Import wizard.

e. Click OK to close the dialog box and return to the File Selection page of the Source Code Import wizard. Then, click Add or Add All to move the files from the Available Files list back to the Selected Files list.

9. Click either Add or Add All to move the selected COBOL data file definitions in the Selected Files list to the Available Files list.

10. Click Finish to complete the importing of the file.


Import a previously compiled RM/COBOL object program

1. With a catalog open in the Relativity Designer, click the Import COBOL FDs shortcut from the FD Common Tasks area of the Files catalog object in the Catalog window or click Import COBOL FDs on the FD menu.

2. In the Source Code Import wizard, select the Import Previously Compiled RM/COBOL Program (.COB) option.

Note In the schema extraction process for RM/COBOL when using the Import Previously Compiled RM/COBOL Program (.COB) option, a number of restrictions exist.

3. To specify the previously compiled RM/COBOL program that you want to import into Relativity, do one of the following:

· If you know the name and path of the file, type it in the File to Import text box. Proceed to Step 5.

· If you do not know the name and path of the file, click Browse. Proceed to Step 4.

4. In the Select RM/COBOL Program dialog box, take the following actions:

a. In the Look in list, select the drive and folder containing the RM/COBOL object file to be imported into the Relativity catalog.

b. In the File name box, type or select the filename of the RM/COBOL object file to be imported into the Relativity catalog. This filename must have the suffix specified in the Files of type list.

c. In the Files of type list, select a file having the .COB suffix.

d. Click Open to close the Select RM/COBOL Program dialog box. The name of the selected file is displayed in the File to Import text box on the first page of the Source Code Import wizard.

5. In the wizard, if applicable, select the Process XML option to import any relational information in an accompanying XML file related to the selected COBOL FD.

6. Click Next to open the File Selection page of the Source Code Import wizard.

The File Selection page displays the COBOL data file definitions to be included in the importing procedure. By default, the Relativity Designer assumes that you want to import all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.

Note To import a selected character set, press the Advanced button on the File Selection page of the Source Code Import wizard to open the Select Character Set dialog box.

7. From the Selected Files list, select the COBOL data file definitions you do not want to import, if necessary, and click Remove or Remove All to move the file(s) to the Available Files list. Tip

Note RM/COBOL object programs do not contain the original level numbers for data items defined in a record description. Therefore, level numbers are generated during import using the values specified in the Level Numbers option on the Data Source page in the Options dialog box. The generated level numbers are stored in the catalog during import and will not be changed if the level numbers setting is changed after the import.

8. Click either Remove or Remove All to move the selected COBOL data file definitions in the Selected Files list to the Available Files list.

9. Click Finish to complete the importing of the file.


RM/COBOL Object Program Schema Extraction Restrictions

The following restrictions and problems exist in the schema extraction process for RM/COBOL when using the Import Previously Compiled RM/COBOL Program (.COB) option:

1. Empty groups are ignored and are not imported into the catalog.

2. The following relational-operators for the VALUE clause are not supported: GREATER THAN, >, LESS THAN, <, GREATER THAN OR EQUAL TO, >=, LESS THAN OR EQUAL TO, <=, and LIKE, and their NOT variations. Condition items with these relational operators are ignored and not imported into the catalog. For more information, see "Relation Condition" in Chapter 5 and "VALUE Clause, Format 2" in Chapter 4 of the RM/COBOL Language Reference Manual.

3. Data items with USAGE Clause of Pointer generate an import error and the entire COBOL source is not imported into the catalog.


Micro Focus COBOL Compiler Directives Processing

See Also

Relativity includes support for Micro Focus COBOL compiler directives. Directives can be specified in either of the following ways:

· A cobol.dir file may contain directives. The cobol.dir file is processed automatically before compilation of the source file begins. The search for the cobol.dir file starts in the current directory and then in the directories indicated by the COBDIR environment variable. The cobol.dir file is one example of a directives file for the DIRECTIVES directive. It is no different than any other directives file except that it is processed automatically. The automatic processing of the cobol.dir file may be suppressed by specifying the NOCOBOLDIR directive on the command line for the UNIX Relativity MF Schema Extractor make_rst program or by deselecting the Process COBOL.DIR option in the Source Code Import wizard. Note that for the Source Code Import wizard, the current directory, which affects the search for the cobol.dir file, is always set to the directory containing the executables; that is, the Relativity installation directory.

· The source program may contain directives on $SET statement lines. $SET must be the first entry on the line, except if the line is a comment line and DIRECTIVES-IN-COMMENTS directive is set, then the $SET statement follows the comment indicator. The rest of the line must consist of directives. $SET statements cannot be continued and directives cannot be broken across lines, but multiple $SET statements may be specified in a sequence. Many of the directives are limited to appearing only on $SET statements that are placed before the first line of the source program.

The intent of the Relativity implementation of directives is to accurately mimic the Micro Focus COBOL implementation. Additional details on how directives are specified may be found in the Micro Focus COBOL documentation.


Micro Focus COBOL Compiler Directives

See Also

Micro Focus COBOL includes approximately 300 compiler directives, which are detailed in the Micro Focus COBOL System Reference Manual 2. Many of these directives have no bearing on Relativity and will never be implemented. Many do affect Relativity, but have not yet been implemented. However, all these directives are implemented in the sense that they are recognized by the directives scanner, their parameters are validated, and all documented and discovered dependencies are implemented. The final setting of most directives is ignored. For information on how Micro Focus COBOL compiler directives are handled by Relativity, click here.

The Micro Focus COBOL compiler directives implemented for Relativity and supported by the make_rst program are summarized in the following list. For a detailed explanation, click on each of the following directives.

APOST | DIRECTIVES"string" | QUOTE
ALIGN"integer" | [NO]DIRECTIVES-IN-COMMENTS | [NO]RM["ANSI"]
ALPHASTART"integer" | [NO]EARLY-RELEASE | [NO]SETTING["string"]
ASSIGN"string" | [NO]FOLD-COPY-NAME["string"] | [NO]SETTINGS["string"]
CHARSET"string" | [NO]IBMCOMP | [NO]SHOW-DIR
[NO]COBOLDIR | [NO]LIST"string" | [NO]TRUNCCOPY["integer"]
COMP-6"integer" | [NO]MFCOMMENT | SIGN"string"
COPYEXT"string" | NATIVE"string" | SOURCEFORMAT"string"
CURRENCY-SIGN"integer" | [NO]ODOSLIDE | SYMBSTART"integer"
DIR"string" | OSEXT"string" | USE"string"

Message File

The lexical pass of the schema extraction process produces a message file to configure the parser pass based on the specified directives. The message file contains a comment line for each directive that has been explicitly or implicitly modified. Because of directive dependencies, two directives that are not implemented for Relativity appear in the message file. These directives are BOUNDOPT (implicitly set to NOBOUNDOPT because the default of BOUNDOPT is forced to NOBOUNDOPT by the default of the BOUND directive) and FORM (implicitly set to NOFORM because the default of FORM"60" is forced to NOFORM by the default of the LIST directive).

This message file is handled differently on Windows and UNIX as explained below:

· On Windows, the schema extractor produces a tempname.msg file in the directory indicated by the TEMP environment variable. The file is automatically deleted upon completion of the schema extraction process unless the -d option is specified in the schema extractor (make_rst.exe) command line.

· On UNIX, the schema extractor produces a file named sourcename.msg in the same directory as the source file. The user may, if desired, delete the message file at any time after the schema extraction process completes.


Micro Focus COBOL Schema Extraction Restrictions

The following restrictions and problems exist in the schema extraction process for Micro Focus COBOL:

1. REPORT section must not be present beyond the section header.

2. PROCEDURE-POINTER is not supported in data description entries.

3. External floating point data items are not supported in data description entries. The E symbol is not allowed in the PICTURE character-strings for noting the exponent position.

4. The word CALL-CONVENTION is considered a reserved word by the schema extraction process, although the word is not reserved in Micro Focus COBOL.

5. EXTERNAL clause does not support the optional BY literal phrase.

6. The listing control directives TITLE, EJECT, SKIP1, SKIP2, and SKIP3 are not supported.

7. The SUPPRESS and INDEXED options in the COPY statement are not supported.

8. Internationalization features are not supported, including N"" literal, NCHAR and JAPANESE usage, DBCS usage, and the G symbol in PICTURE character-strings.

9. The BASIS/DELETE/INSERT source text manipulation statements are not supported.

10. The -INC and ++INCLUDE source text manipulation directives are not supported.

11. Conditional compilation directives $IF/$DISPLAY/$ELSE/$END are not supported.

12. Object-oriented syntax, such as TYPEDEF in the data description entry, is not supported.


Micro Focus COBOL Schema Extraction Error Messages

The following error messages are diagnosed only by number in the second pass of the schema extraction process:

COBOL to Relativity Translation Error (No. 1)

· Startup options passed from front-end parser were invalid or not found.

· Could not write header of RST file.

· Could not write trailer of RST file.

· Could not open the INT file.

COBOL to Relativity Translation Error (No. 2)

· Could not translate program received from front-end parser. Unrecognized token was passed. This error is often the result of including Procedure Division content without a proper Procedure Division header.

COBOL to Relativity Translation Error (No. 3)

· Could not translate a token received from the front-end parser for the Identification, Environment or Data Divisions. This error is unlikely since each of these Divisions has its own error trap (see errors numbers 4 through 6).

COBOL to Relativity Translation Error (No. 4)

· Could not translate a token received from the front-end parser for the Identification Division.

COBOL to Relativity Translation Error (No. 5)

· Could not translate a token received from the front-end parser for the Environment Division.

COBOL to Relativity Translation Error (No. 6)

· Could not translate a token received from the front-end parser for the Data Division.

COBOL to Relativity Translation Error (No. 7)

· Could not translate a token received from the front-end parser for the Procedure Division.

COBOL to Relativity Node Mapping Error (No. 8)

· An ordering error has occurred such that a symbol node number cannot be properly translated to an RST symbol node number.


Importing COBOL File Definitions

See Also

Once the schema information has been created, you are ready to import COBOL file definitions into the Relativity catalog.

The Relativity Designer imports COBOL file definitions by moving information about the file definition entries and the associated record descriptions from one or more files containing symbolic information about the COBOL file definitions to the Relativity catalog. The record descriptions of a COBOL file are displayed in an FD form.

For procedures on how to import COBOL file definitions, click one of the following:

· Import a COBOL source file

· Import a previously compiled symbol table (RST) file

· Import a previously compiled RM/COBOL object program


Importing Definitions from Another Relativity Catalog

See Also

The Relativity Designer can import file, table, and user data type definition objects from one Relativity catalog into another Relativity catalog. This capability permits several designers each to design and test a Relativity catalog. Then the results are merged into a single catalog for the end-user. Relativity does not permit multi-user access of the catalog by designer developers.

For procedures on how to import definitions from another Relativity catalog, click here.


Import definitions from another Relativity catalog

1. On the Tools menu, click Import from Another Relativity Data Source. The Open Relativity Data Source dialog box is displayed.

2. In the Data Source Name list, type or select the name of the data source from which to import file, table, or user data type definition objects.

3. Click Open to display the Logon dialog box.

4. If an owner has been defined for the catalog, type the name of a group or user in the Name box. If privileges have been defined for the catalog, the user name must belong to a group having the catalog owner privilege.

Note If an owner has not been defined for the catalog, there are no restrictions on the characters typed in the Name box.

5. In the Password box, type the password of the group or user. An asterisk (*) character is displayed for each character entered.

Note If the catalog has no owner, the Password box is left blank.

6. Click OK to accept the log on information. The Import from Another Relativity Data Source dialog box is displayed.

7. In the Object Type list, type or select the name of the object type to be imported (for example, object types such as files, tables, and user data types).

8. In the Objects In list, select one or more names of the objects to be imported.

Note If both files and tables are to be imported, you must import tables first to reduce the number of steps required.

9. Click Import to import the selected objects from the specified second catalog to the active Relativity catalog.

10. In response to the message, "File Definition does not exist. Import it?", click Yes. This message occurs as a result of importing tables that do not have an underlying file definition.

11. Return to Step 7 to import another object; otherwise, proceed to the next step.

12. When all objects have been imported to the active catalog, click Close to terminate the import process.


Importing Btrieve Keys (Micro Focus COBOL Only)

See Also

The Import Btrieve Keys command on the Tools menu allows the key structure of a Btrieve data file to be imported into a Relativity catalog . This is generally needed only if the Btrieve data file was not constructed with COBOL or the key structure has been modified with third-party Btrieve products.

For example, if the COBOL SELECT statement was generated to match an existing Btrieve structure without knowing the order of the keys in the Btrieve data file, this process can be used to ensure that the Relativity catalog matches the data.

Note To enable this option, you must set EnableBtrieveConversion=Yes in the [Designer] section of the RELDBDSN.INI file found in your Windows directory. This option is available only for Relativity for Micro Focus COBOL.

For procedures on how to import Btrieve keys from a Btrieve data file, click here.


Import Btrieve keys from a Btrieve data file

1. From the Files catalog object or the Tables catalog object in the Catalog window, select a file definition or table definition name, respectively.

2. On the Tools menu, click Import Btrieve Keys.

A message box is displayed that indicates the importing process has been initiated and prompts you to select a Btrieve data file.

3. Close the message box. The Select Btrieve Data File for filename dialog box is displayed.

4. In the File name list, type or select the appropriate Btrieve data file.

5. Click OK.


Maintaining Character Sets

See Also

Character sets provide a means of associating language characters with an 8-bit number to represent those characters in a data file. It is possible that the character set used to represent the data within a COBOL data file is different from the character set used by the ODBC application receiving the data.

The Character Set Maintenance dialog box provides Relativity with a mechanism for translating between the two character sets. However, Relativity must know the character set that is being used within the data file to represent the characters. This character set is initially determined when the FD is imported by using the Advanced button in the Source Code Import wizard File Selection page for either .CBL and .RST files or .COB files. The character set may then be modified after import.

For more information and procedures on how to maintain character sets, choose from one of the following topics:

· Add a standard character set. Relativity supports a large number of standard character sets. Before one of these standard character sets can be used, it must be added to the data source.

· Add a nonstandard character set. Occasionally, the data stored in a file does not match any of the supported character sets. In such cases, a nonstandard character set must be defined and imported into the Relativity data source before it can be used.

· Change existing character sets for a data source. If the actual character set that describes the characters in a data source’s files is different from the character set Relativity has recorded, the Character Set Maintenance dialog box can be used to change it.

· Change the location of the Euro character in a character set. Some COBOL applications supported the Euro character before the International Standard Organization decided its value in standard character sets. In these instances, Relativity needs to modify its understanding of the value of the character in the standard character set.


Add a standard character set

1. From the Tools menu, click Character Sets. The Character Set Maintenance dialog box opens.

2. From the Character Set list, select the name of the desired character set.

3. In the Add New Character Set area, click Add. The selected character set will appear in the list of standard character sets.

4. Click the Close toolbar button to dismiss the Character Set Maintenance dialog box.


Add a nonstandard character set

1. From the Tools menu, click Character Sets. The Character Set Maintenance dialog box opens.

2. In the Add New Character Set area, click Import. A standard Windows dialog box is displayed that allows you to enter the name of the file containing the definition of the nonstandard character set. To see a list of errors that can occur when a character set is imported into a Relativity data source, click here.

3. Click Open. The new character set will appear in the Character Set list.

4. Click the Close toolbar button to dismiss the Character Set Maintenance dialog box.


Change existing character sets for a data source

1. From the Tools menu, click Character Sets. The Character Set Maintenance dialog box opens.

2. Check the Character Set list to see whether the new character set is already in the data source. If the new character set is not present, follow the procedures either to add a standard character set or add a nonstandard character set. Then, continue with step 3.

3. In the Modify Existing FD Character Set area, in the Change From list, select the name of the character set that is currently associated with the file definitions.

4. From the To list, select the name of the character set that actually describes the data within the data source’s files.

5. Click the Change button. A Status Report dialog box shows a record of the action just taken.

6. Click the Close toolbar button to dismiss the Status Report dialog box.

7. Click the Close toolbar button to dismiss the Character Set Maintenance dialog box.


Change the location of the Euro character in a character set

1. From the Tools menu, click Character Sets. The Character Set Maintenance dialog box opens.

2. From the Character Set list, select the character set having the definition for the Euro character that will change.

3. Check the Enable Euro check box in the Set Euro Character For Selected Character Set area.

4. In the edit box, enter the value that is used to represent the Euro character in the COBOL data file. The value must be a number between decimal 0 and 255 (hexadecimal 0x00 and 0xff).

5. Click the Update button to change the location.

6. Click the Close toolbar button to dismiss the Character Set Maintenance dialog box.

Note This functionality is available from the Character Set Maintenance dialog box only if the data source is using a Relativity v5 or later driver.


Defining Nonstandard Character Sets

See Also

Relativity supports many standard character sets. If you need to define a character set that is nonstandard, however, Relativity has the ability to map data stored in one character set to a different character set for display purposes. This is usually necessary when data that was initially stored using one character set standard must be displayed using another character set standard; for example, data stored on a UNIX server using an ISO 8859 standard character set that must be displayed on Windows using a Code Page standard character set. ISO 8859 and Code Page character set standards are similar, but not identical, in the 8-bit values that are used to represent the different display characters. When the standards disagree on the 8-bit values (known as Code Points), the actual character displayed (known as a Glyph) will be incorrect.

To describe a character set, Relativity uses a derivation of the Unicode Consortium’s Format A character set definitions.

When the mapping tables are created between two character sets, unused Code Points and Code Points with unmatched Glyphs have a simple, one-to-one mapping between the two character sets. This mapping proceeds from the lowest Code Point to the highest and is symmetrical. That is, a character that is read and mapped through these mapping tables will have the correct value stored on a subsequent UPDATE operation.

If the data within a file does not match any of the character sets already defined in Relativity, then the character set of the data file must be installed in the Relativity data source. By so doing, Relativity can build the mapping tables later.

For more information, choose from the following procedures:

· Define a nonstandard character set

· Modify an existing Relativity character set

· Import a standard character set not supported by Relativity


Unicode Consortium's Format A

Unicode Consortium’s Format A

Standard character sets in the Unicode Consortium’s Format A are available from ftp://ftp.unicode.org/Public/MAPPINGS. To locate the character set you need, use one of the following methods:

· If the character set is a standard Microsoft Windows Code Page, change to the directory, VENDORS/MICSFT/WINDOWS.

· If the character set is an ISO 8859 character set, change to the directory, ISO8859.

· If the character set is none of the above, explore the other directories in ftp://ftp.unicode.org/Public/MAPPINGS in order to locate the desired character set.

· If you cannot find the character set you need, you must define a nonstandard character set or modify an existing Relativity character set.

Relativity augments this format with a Charset and EndCharset clause to allow more than one character set to appear in the character set source file.

A character set source file is a simple text file with the extension of .cs. Comments may appear anywhere in the file and are introduced with the hash character (#) and extend to the end of the line. Numeric values may begin with ‘0x’ to indicate a hexadecimal constant, a ‘0’ only to indicate an octal constant, or ‘1’ through ‘9’ to indicate a decimal constant. Strings are delimited by quotes (“”).

One or more character sets may be in this file. The format of each character set is:

Charset "Character Set Name" character-set-number
code-point-value unicode-value
code-point-value unicode-value
.
.
.
EndCharset

where:

Character Set Name is a string that is the name of the character set to display in the Relativity Designer.

character-set-number is the number to assign to the character set. For character sets installed via the Relativity Designer, this value is ignored and assumed to be zero.

code-point-value is the 8-bit numeric value of the Glyph in the character set. A code-point-value that is not present in the character set is assumed to be unused.

unicode-value is the 16-bit numeric value of the Glyph in the Unicode standard. This value also may be a Unicode constant, in which case, it will be delimited by a less than symbol (<) and a greater than symbol (>). The most commonly used of these is the constant <NOT USED>, which indicates that the Code Point does not have a Glyph assigned to it.


Supported Standard Character Sets

Relativity supports the following standard character sets:

Windows Latin 1 | MS-DOS Cyrillic CIS-1 | MS-DOS Hebrew
Windows Latin 2 | MS-DOS Turkish | EBCDIC US Canada
Windows Latin 5 | MS-DOS Portuguese | EBCDIC International
Windows Cyrillic | MS-DOS Icelandic | EBCDIC Greek
Windows Greek | MS-DOS French Canada | EBCDIC Latin 5 Turkish
Windows Baltic Rim | MS-DOS Greek | ISO 8859-1
Windows Hebrew | MS-DOS Greek 1 | ISO 8859-2
Windows Arabic | MS-DOS Greek 2 | ISO 8859-5
MS-DOS Latin US | MS-DOS Baltic Rim | ISO 8859-6
MS-DOS Latin 1 | MS-DOS Russian | ISO 8859-7
MS-DOS Latin 2 | MS-DOS Arabic | ISO 8859-8
MS-DOS Cyrillic | MS-DOS Arabic ASMO |


Define a nonstandard character set

1. Using a text editor, edit a new file in which to place the character set. Name the file with the extension, .cs.

2. Insert the following line at the beginning of the file:

Charset "Character Set Name" 0x0

For Character Set Name, substitute the name for the character set that is to be visible from within the Select Character Set dialog box.

3. Insert up to 256 lines into the file, one for each character in the character set being described. On each line there must be two entries, separated by a space or a tab, with an optional third entry, also separated by a space or tab. The first entry on the line must be the 8-bit Code Point value for the entry. This corresponds to the numeric value of the character being described. The second entry is the 16-bit Unicode character for the character being defined. The third entry is an optional comment for the line, preceded by a hash (#) character.

For example, if the character set had a Euro Sign at position 128, the line for it would be:

128 8364 #EURO SIGN

Or, using hexadecimal notation:

0x80 0x20AC #EURO SIGN

For Code Points where there is not a defined character, use the text <NOT USED> for the second entry.

Note A Unicode character may be used only once in a character set. If it appears twice, an error indicating a duplicate Unicode character will be generated during import. Unique Unicode characters are necessary for all defined Code Points in order to generate mapping tables that can be used to translate characters both to and from the new character set. Rather than arbitrarily assigning Unicode characters to unused Code Points, either leave them out of the character set definition or use <NOT USED> as the Unicode character entry. When Relativity encounters the <NOT USED> entry, it creates an association in the character set being defined with unused or unmatched entries in the target character set. In this manner, if an undefined character is present in the data, it will be translated consistently.

4. Following the lines describing the character set, insert the following line:

EndCharset

5. Save the file and import it into the Relativity data source.

To see a list of errors that can occur when a character set is imported into a Relativity data source, click here.


Modify an existing Relativity character set

1. Edit the file wincs.cs in the installation directory.

2. Locate the character set to modify.

3. Select and copy the lines Charset and EndCharset of the desired character set and all the text in between.

4. Create a text file in which to place the modified character set and paste in the text from Step 3.

5. Locate the Charset line and change the text between the quotes to the name for the character set that is to be visible from within the Select Character Set dialog box. Change the number at the end of the line to 0x0.

6. Locate the lines for the Code Points to be changed in the character set. This can be done by examining first entry on each the line. This value is the numeric value for the character in the character set. For example, in most Latin-based character sets, the capital letter A has the Code Point value of 65 (or 0x41 hexadecimal).

7. Change the second entry on the line to the Unicode value for the new character to be at this Code Point. For example, if you want the character at Code Point 65 to be interpreted as a capital letter A with an Acute, change the line to the following:

0x41 0x00C1 #LATIN CAPITAL LETTER A WITH ACUTE

8. If necessary, insert a new line with the Code Point and Unicode entries for new Code Points.

Note A Unicode character may be used only once in a character set. If it appears twice, an error indicating a duplicate Unicode character will be generated during import. Unique Unicode characters are necessary for all defined Code Points in order to generate mapping tables that can be used to translate characters both to and from the new character set. Rather than arbitrarily assigning Unicode characters to unused Code Points, either leave them out of the character set definition, or use <NOT USED> as the Unicode character entry. When Relativity encounters the <NOT USED> entry, it creates an association in the character set being defined with unused or unmatched entries in the target character set. In this manner, if an undefined character is present in the data, it will be translated consistently.

9. Save the file and import it into the Relativity data source.

To see a list of errors that can occur when a character set is imported into a Relativity data source, click here.


Import a standard character set not supported by Relativity

1. FTP to the site, ftp.unicode.org.

2. Change to the directory, Public/MAPPINGS.

3. Locate the character set you want, as follows:

· If the character set is a standard Microsoft Windows Code Page, change to the directory, VENDORS/MICSFT/WINDOWS.

· If the character set is a standard Microsoft DOS Code Page, change to the directory, VENDORS/MICSFT/PC.

· If the character set is an ISO 8859 character set, change to the directory, ISO8859.

· If the character set is none of the above, explore the other directories in ftp.unicode.org/Public/MAPPINGS in order to locate the desired character set.

· If you cannot find the character set you want, you must define a nonstandard character set or modify an existing Relativity character set.

4. Locate the file for the desired character set and download the file to your local machine. Name it with the extension, .cs.

5. Edit the file with a text editor, taking care to delete any control characters, usually marked with the characters ^D from the file.

6. Insert the following line at the beginning of the file:

Charset "Character Set Name" 0x0

For Character Set Name, substitute the name for the character set that is to be visible from within the Select Character Set dialog box.

7. At the end of the file, insert the following line:

EndCharset

8. Examine the remaining lines for any that are missing the second entry on the line. This second entry is the 16-bit Unicode character for the character being defined. In the definitions available on ftp.unicode.org, unused Code Points are left blank with the comment of UNDEFINED. Insert <NOT USED> as the second entry on the line.

Note A Unicode character may be used only once in a character set. If it appears twice, an error indicating a duplicate Unicode character will be generated during import. Unique Unicode characters are necessary for all defined Code Points in order to generate mapping tables that can be used to translate characters both to and from the new character set. Rather than arbitrarily assigning Unicode characters to unused Code Points, either leave them out of the character set definition, or use <NOT USED> as the Unicode character entry. When Relativity encounters the <NOT USED> entry, it creates an association in the character set being defined with unused or unmatched entries in the target character set. In this manner, if an undefined character is present in the data, it will be translated consistently.

9. Save the file and import it into the Relativity data source.

To see a list of errors that can occur when a character set is imported into a Relativity data source, click here.


Error Messages when Importing a Character Set

The following errors may be produced when importing a nonstandard character set into a Relativity data source:

· Redefinition of Character. Indicates that the value used in the code-point-value has appeared previously in the character set definition. A common cause of this problem is the omission of a unicode-value or code-point-value, causing the charset compiler to misinterpret the value. The code-point-value and unicode-value must appear in pairs.

· Syntax Error. Indicates that the character set does not conform to the format of a character set definition. This usually indicates that a numeric constant was not detected where it was expected.

· Unicode constant too large. Indicates that a unicode-value was larger than can be stored in 16-bits.

· Code Point constant too large. Indicates that a code-point-value was larger than can be stored in 8-bits. This message may indicate a missing value from a code-point-value and unicode-value pair.

· Illegal constant. Indicates that a decimal constant contained a nonnumeric character.

· Illegal hex constant. Indicates that a hexadecimal constant contained a non-hex character.

· Illegal octal constant. Indicates that an octal constant contained a non-octal character.

· Illegal string constant. Indicates that a string constant did not terminate before the end of a line.

· Unknown unicode constant. Indicates that a Unicode constant is unrecognized.

· Unknown keyword. Indicates that either the keyword Charset or EndCharset was not located where expected.

· Keyword too long. Indicates that a keyword was expected in the character set source file, but it was too large to be processed.

· String constant too long. Indicates that a string constant was too large to be processed.

· Illegal Unicode constant. Indicates that a Unicode constant did not have a closing delimiter (>) before the end of a line.

· Unicode constant too long. Indicates that a Unicode constant was too long to be processed.

· In Character Set Name, Unicode unicode-value duplicated at positions code-point-value and code-point-value. Indicates that the character set with the name Character Set Name has the same Unicode character in multiple Code Point locations. In order to create symmetrical mapping tables, a Unicode character may be used only once per character set.


Augmenting the COBOL File Definition in the FD Form

Editing File Definitions, An Overview

Defining Default Column Names

Redefining Data Items

Adding Condition Items

Defining User Data Types

Defining Item Patterns

Specifying Treatment of the OCCURS Clause

Defining Record Types

Defining Record Type Filters

Using Functions and Transforms

Defining Item Sets

Defining Default Values

Defining Null Information

Specifying Comments

Saving File Definitions


Editing File Definitions, An Overview

See Also

Certain information regarding the meaning and logical structure of the COBOL file definitions imported into a Relativity database can be supplied only by you, the application developer. The Relativity Designer automates this process to the greatest extent possible through a set of procedures to perform such functions as:

· Defining default column names.

· Redefining data items.

· Adding condition items in order to control record types, table filters, and OCCURS clause binding.

· Defining user data types.

· Defining item patterns in the naming or other characteristics of the data items that determine or give clues as to the proper relational database representation of the items.

· Specifying treatment of the OCCURS clause.

· Defining record types.

· Using and assigning internal functions and transforms.

· Defining item sets to associate redundant data items in the record descriptions so that they can be associated with one SQL column value.

· Defining default values.

· Defining null information.

· Specifying comments.

· Saving file definitions.

For an overview of the general procedures on how to edit file definitions in a Relativity catalog, click here.


Edit file definitions in a Relativity catalog

1. Click the Files catalog object in the Catalog window.

2. From the list of files associated with the catalog, select the name of the COBOL file to be edited and then click the Open shortcut in the FD Common Tasks area. (You can also double-click the name of the COBOL file to be edited.) The FD form for the selected file opens.

Alternatively, click Open on the FD menu.

3. Click All Levels on the FD form toolbar to display all data items in the record descriptions.

· To expand a single group, click the Expand icon in the untitled column in the FD form in the same row as the group's data-name.

· To collapse a single group, click the Collapse icon in the untitled column in the FD form in the same row as the group's data-name.

4. Click Magnify on the FD form toolbar to display the attributes of the data items. The horizontal scroll bar is used to scroll through the attributes of the data items in the FD form.

Note These attributes can be partially controlled by settings on the File page in the Options dialog box.

5. Click Split on the FD form toolbar to split the FD form into two horizontal panes. The two panes are initially half the vertical size of the FD form, but can be adjusted in size by dragging the split line. To return to a single pane, click Split again. Splitting into two panes makes it easier to work on two related, but widely separated, areas of the record descriptions.

6. Position the mouse pointer on the column title. Columns in the FD form can be moved (reordered left to right) or resized (in width) as desired.

· To move a column, place the mouse pointer on the column's title, click the primary mouse button, and drag the column so that it is positioned as desired.

· To resize a column, place the mouse pointer on the dividing line to the left of the column's title until it appears as a double-headed horizontal pointer. Click the primary mouse button and drag the dividing line to size the column as desired.

7. Adjust the default column name associated with each data item, using the following buttons on the FD form toolbar:

· Column Name Case

· Column Name Hyphen

· Column Name Global Edit

The steps for modifying the default column names in the FD form are detailed in Defining Default Column Names.

Individual default column names can also be directly edited in the FD form by clicking on the default column name and typing the desired value.

The default column names in the FD form are the names given to columns when a data item is dragged to the Table form, but are not necessarily the final column names since column names can be edited in the Table form.

8. Add any redefinitions of data items to access subdivisions of existing COBOL data items that are needed because COBOL procedural code used some means to access a subdivision that is not made explicit in the record descriptions.

· Click Add Data Item on the FD form toolbar to add a redefinition of the currently selected data item.

· Click Delete Item on the FD form toolbar to delete added items. The Delete Item button is disabled for items that were imported as part of the original FD.

Note Although Step 8 can be performed at any time during the design process, be aware that it may be necessary to adjust the default column name, user data type, and transform attributes for the added data item.

9. Add any necessary condition items needed for specifying null values, binding subscripts, specifying record types, or specifying table filters.

· Click Add Condition Item on the FD form toolbar to add an 88-level condition-name associated with the currently selected data item.

· Click Delete Item on the FD form toolbar to delete added condition items. The Delete Item button is disabled for condition items that were imported as part of the original FD.

Note Although Step 9 can be performed at any time during the design process, be aware that it may be necessary to adjust the default column name, user data type, and transform attributes for the added condition item.

10. Define user data types and item patterns.

11. Click Assign Default Data Types on the FD form toolbar to assign default data types and item transforms based on the previously defined item patterns.

12. Select the appropriate default data type and transform (if needed) for individual data items in the FD form when this has not been accomplished using item patterns (see Step 11).

13. Click Parallel Occurs on the FD form toolbar to define a table with x rows having a column for each of the selected data items having the same OCCURS x TIMES clause. See Identifying Parallel OCCURS Clauses.

14. Click Occurs Depending On on the FD form toolbar to define a table structure that simulates the relationship of an OCCURS clause with the DEPENDING ON phrase for the selected data items in the FD form. See Identifying Implicit OCCURS DEPENDING ON.

15. Define record types.

16. Assign internal functions, if needed, by clicking Add Function on the FD form toolbar.

· The Add Item Argument button, which becomes enabled when a function item and one other item are selected, causes that other selected item to be added to the argument list of the selected function.

· The Add Constant Argument button, which becomes enabled only when a function item is selected, displays the Add Function Constant dialog box to allow an alphanumeric or numeric constant to be added to the argument list of the selected function.

· The Delete Arguments button deletes all arguments for the selected function item.

17. Define item sets (to associate redundant data items in the record descriptions so that they can be associated with one SQL column value) by selecting a set of redundant data items and clicking Redundant Data Items on the FD form toolbar.

18. Define default values if write operations are going to be performed.

19. Define null information to specify the relationship between COBOL data item values and the SQL NULL value.

20. Specify comments, if any, pertaining to the data item.

21. Save all additions, changes, and deletions made to the file definition by clicking Save Changes on the FD form toolbar.


Defining Default Column Names

See Also

In Relativity, you can specify default column names for each data item defined in a file definition (FD). Most COBOL programs have a data-name for a data item that reflects COBOL coding standards meant to communicate information to the programmer. SQL column names, however, must communicate meaning to the end-user. An example of this is the hyphen (-) character. Since this is a legal character in COBOL, but not in SQL, Relativity removes the hyphens in the default column names.

Note When a default column name is typed directly in the FD form, the user is warned of conflicts with SQL reserved words. Such a warning does not occur, however, when the default column name is derived from the COBOL data-name or condition-name (a user-defined word that names a condition item) as described in the procedures to edit default column names. When these procedures result in a reserved default column name, a warning occurs when the item is made part of a table. For example, if (1) the COBOL data-name TEMP-ORARY exists in the record descriptions, and (2) default column names are derived by omitting hyphens, the default column name for the item would be the SQL reserved word Temporary and there would be no warning. Then, if the COBOL data item TEMP-ORARY is dragged to a Table form, the Invalid Column Name dialog box is displayed to allow you to change the column name.

In the FD form, the Default Column Name attribute is the SQL column name that will be assigned by the Relativity Designer when the data item is used as a column in a table. Initially, the Default Column Name attribute is derived from the COBOL data-name, subject to the setting of the Column Name Hyphen button and the Column Name Case button.

The following table illustrates how the Default Column Name attribute is derived for a data item named AN-EXAMPLE-ITEM.

Button states | Default Column Name
 | AnExampleItem
 | An_Example_Item
 | ANEXAMPLEITEM
 | AN_EXAMPLE_ITEM

Note Defining default column names in the FD form is unnecessary if you use the Table wizard to define a relational table. The Table wizard ignores the default column names specified in the FD form and uses its own rules to derive a column name in the new relational table that it builds. The column names are derived from the COBOL data-names per the selections made in the Table wizard.


Edit default column names

1. Click Column Name Global Edit on the FD form toolbar to display the Edit Default Column Names dialog box. (This dialog box presents options where you can replace selected characters in the column name with other characters. These characters may be located anywhere in the column name.)

2. In the Replace box, type the string of characters to be replaced on all or selected data items. If a match is found, then replacement takes place using the standard string substitution rules.

To specify the position of the characters to be replaced within the default column name, type the appropriate structure to determine the pattern matching process.

3. In the With box, type the string of characters to be substituted in those data items containing a matching string.

4. If desired, select the All Items check box to replace matching strings in all default column names.

5. Click Apply to perform the character replacement defined in the Edit Default Column Names dialog box.

Individual default column names may be edited to specific values desired by the user by clicking in the grid square containing the column and typing in a new name.


Redefining Data Items

See Also

Some file definitions do not contain all the implicit item definitions that exist in an application database. For example, an elementary data item in the file definition might be moved to a Working-Storage Section group item that is used to further subdivide the item for processing. Reference modification is another means of implicit redefinition or subdivision.

When it is necessary to expose these implicit subdivisions and redefinitions in the relational tables, the data items involved must be explicitly redefined for Relativity.

For procedures on how to redefine all or part of a data item in the file definition displayed in the FD form, click here.


Redefine a data item

1. Select the data item in the FD form needing all or some of its character positions redefined.

2. Click Add Data Item on the FD form toolbar to display the Add COBOL Data Item Redefinition dialog box.

Alternatively, you can choose the Add Redefines command from the FD menu when focus is in the FD form.

3. In the Name box, type the data-name of the new data item.

4. In the Item Type list, select the desired data type for the new data item.

5. In the Length box, select the desired length of the new data item. The length plus offset of the new data item must not exceed the length of the redefined data item plus one.

6. In the Offset box, select the offset from the beginning of the redefined data item. An offset value of 1 indicates the first character position of the redefined data item.

7. If a numeric data type was chosen in Step 4, do the following:

a. In the Precision box, select the desired precision for the new data item. The precision specifies the number of decimal digits and is constrained based on the data type and the length selected earlier in this procedure.

b. In the Scale box, select the scale factor for the new data item. The scale factor specifies the position of the decimal point from the right end of the new data item in terms of decimal digits. The absolute value of a negative scale factor specifies the number of digits to the right of the decimal point.

8. Verify the resulting COBOL-like data item definition at the bottom of the Add COBOL Data Item Redefinition dialog box.

9. If needed, change selections until the COBOL-like data item definition is correct for the new data item.

10. Click Add Item to insert the new data description entry into the record description in the FD form.


Adding Condition Items

See Also

Records within COBOL files often contain data items tested in the Procedure Division for a specific value. In order for Relativity to test the contents of a data item, the data item must be the conditional variable of a condition item. A condition item is referenced by an 88-level condition-name and specifies the value or values against which the conditional variable is to be tested.

For procedures on how to add a condition item, choose one of the following topics:

· Define a condition item with one value

· Define a condition item with a range of values

· Define a condition item with a series of values

· Define a condition item series


Define a condition item with one value

1. Select the data item in the FD form for which a condition item is needed.

2. Click Add Condition Item on the FD form toolbar.

Alternatively, you can choose the Add 88 command from the FD menu when focus is in the FD form.

3. In the Add Condition Item dialog box, type a condition-name in the New 88 Name box.

4. Select Single Value to indicate that one value is to be associated with the condition-name to form the condition item.

5. In the Value list box, click the arrow to display the list of value options and then select the value option for the condition item value.

6. If the Entered or Hexadecimal value option was selected in the Value list box, type the single value in the Value text box.

· For the Entered value option, type the characters of the value.

· For the Hexadecimal value option, type pairs of hexadecimal digits for each character of the value.

7. If a false value is to be assigned to the condition-name, select the Set to False check box and do the following:

a. In the False Value list box, click the arrow to display the list of value options.

b. From the list of value options, select the value option for the false value to be associated with the condition-name.

c. If the Entered or Hexadecimal value option was selected from the False Value list box, type the single false value in the False Value text box. For the Entered value option, type the characters of the false value. For the Hexadecimal value option, type pairs of hexadecimal digits for each character of the false value.

8. Click Add to generate a condition item for the selected data item in the FD form.

9. Click Save Changes on the FD form toolbar to save the change in the FD form.


Define a condition item with a range of values

1. Select the data item in the FD form for which a condition item is needed.

2. Click Add Condition Item on the FD form toolbar.

Alternatively, you can choose the Add 88 command from the FD menu when focus is in the FD form.

3. In the Add Condition Item dialog box, type a condition-name in the New 88 Name box.

4. Select Value Range to indicate that a range of values is to be associated with the condition-name to form the condition item.

5. In the Value list box, click the arrow to display the list of value options and then select the value option for the lower value of the condition item value range.

6. If the Entered or Hexadecimal value option was selected in the Value list box, type the lower value in the Value text box.

· For the Entered value option, type the characters of the lower value.

· For the Hexadecimal value option, type pairs of hexadecimal digits for each character of the lower value.

7. In the To Value list box, click the arrow to display the list of value options and then select the value option for the upper value of the condition item value range.

8. If the Entered or Hexadecimal value option was selected in the To Value list box, type the upper value in the To Value text box.

· For the Entered value option, type the characters of the upper value.

· For the Hexadecimal value option, type pairs of hexadecimal digits for each character of the upper value.

9. If a false value is to be assigned to the condition-name, select the Set to False check box and do the following:

a. In the False Value list box, click the arrow to display the list of value options.

b. From the list of value options, select the value option for the false value to be associated with the condition-name.

c. If the Entered or Hexadecimal value option was selected from the False Value list box, type the single false value in the False Value text box. For the Entered value option, type the characters of the false value. For the Hexadecimal value option, type pairs of hexadecimal digits for each character of the false value.

10. Click Add to generate a condition item for the selected data item in the FD form.

11. Click Save Changes on the FD form toolbar to save the change in the FD form.


Define a condition item with a series of values

1. Select the data item in the FD form for which a condition item is needed.

2. Click Add Condition Item on the FD form toolbar.

Alternatively, you can choose the Add 88 command from the FD menu when focus is in the FD form.

3. In the Add Condition Item dialog box, type a condition-name in the New 88 Name box.

4. Select Single Value or Value Range to indicate a single value or value range for the first element of the series of values associated with the condition-name to form the condition item.

5. In the Value list box, click the arrow to display the list of value options and then select the value option for the single value or lower value of the range of values for this element of the condition item value series.

6. If the Entered or Hexadecimal value option was selected in the Value list box, type the value in the Value text box.

· For the Entered value option, type the characters of the value.

· For the Hexadecimal value option, type pairs of hexadecimal digits for each character of the value.

7. If Value Range was selected, click the arrow in the To Value list box to display the list of value options and then select the value option for the upper value of this value range element of the condition item value series.

8. If Value Range was selected and the Entered or Hexadecimal value option was selected in the To Value list box, type the upper value in the To Value text box.

· For the Entered value option, type the characters of the upper value.

· For the Hexadecimal value option, type pairs of hexadecimal digits for each character of the upper value.

9. For each additional element of the series, click Next and then repeat Steps 2 through 6.

During this process you may click Previous and Next to view the values entered for each element of the series. The Previous button is disabled when the first element of the series is displayed. Be careful not to click the Next button when on the last element of the series in order to avoid generating an additional element of the series. When all elements of the series have been entered, proceed to Step 8.

10. If a false value is to be assigned to the condition-name, select the Set to False check box and do the following:

a. In the False Value list box, click the arrow to display the list of value options.

b. From the list of value options, select the value option for the false value to be associated with the condition-name.

c. If the Entered or Hexadecimal value option was selected from the False Value list box, type the single false value in the False Value text box. For the Entered value option, type the characters of the false value. For the Hexadecimal value option, type pairs of hexadecimal digits for each character of the false value.

11. Click Add to generate a condition item for the selected data item in the FD form.

12. Click Save Changes on the FD form toolbar to save the change in the FD form.


Define a condition item series

1. In the FD form, select the line containing the notation "SubscriptItem" subordinate to the data item that contains the OCCURS clause.

2. Click Add Condition Item on the FD form toolbar.

Alternatively, you can choose the Add 88 command from the FD menu when focus is in the FD form.

3. In the Add Condition Item dialog box, type a condition-name in the New 88 Name box.

4. Select the Series check box.

5. Click Add to generate a condition item series; that is, multiple condition-names associated with the subscript item selected in the FD form. These condition-names may be used to bind the subscript of the repeating data item(s) accessed by the selected subscript item.

Each condition-name for the series is generated from the name entered in the New 88 Name box in Step 3 by appending a hyphen and a number having a maximum of two digits. The value of the number varies from 1 to the maximum value of the subscript; thus, there is a condition-item for each occurrence.

6. Click Save Changes on the FD form toolbar to save the change in the FD form.

Note This procedure is available only when the selected data item is a subscript item.


Defining User Data Types

See Also

Relativity provides the facility to define user data types for SQL column descriptions. Relativity user data types are similar to what is called a domain in some relational database management systems. A user data type is a named set of properties for a column, including its ODBC data type, length, default value, whether the column allows null values, whether the column is constrained to certain values, and, for numeric type columns, the precision and scale. After a user data type is specified, it can be used in place of ODBC data types in column definitions, thus giving all columns with the same user data type similar characteristics.

In addition to consistency, user data types make it easy to adjust column properties since there is only one place to edit the user data type, instead of having to edit each individual column that shares a particular type. User data types, once defined, can be associated with a COBOL data item as the default type to use when a column is based on that data item. The assignment of a user data type to a COBOL data item can be automated by the use of an item pattern.

For procedures on how to define a user data type, click here.


Define a user data type

1. On the Tools menu, click Data Types. The Data Types form opens.

2. To edit an existing data type, click Design Mode and modify the properties shown on the form.

If the property to be modified is not shown on the form, the data type must be deleted by clicking Delete Data Type and then added again.

3. Click Add Data Type to display the Add Data Type dialog box and add a new data type.

4. In the Data Type Name box, type a descriptive name for this user data type.

5. In the Type list under Column Properties, select a column type.

6. In the Transform list under Column Properties, select a transform.

The value < None > indicates that no column transform is desired, but an item transform may be associated with the data item upon which columns of this user data type are based.

7. If the data type being defined requires a length, type a number in the Length box that specifies the number of characters for the length of the column value.

8. If the data type being defined requires a precision (because it is a numeric type), type a number in the Digits box that specifies the number of decimal digits in the column value.

9. If the data type being defined requires a scale (because it is a possible nonintegral numeric type), type a number in the Decimal Places box that specifies the number of decimal digits to the right of the decimal point in the column value.

10. If desired, specify the default column value in the Default Value box.

The default column value is the value used for SQL INSERT statements that do not provide this column value.

11. Select the Nullable check box if the user data type allows the column to be set to null.

12. Select the Constrain check box if the user data type constrains the column value to one of the true values of an 88-level condition-name associated with the data item upon which the column is based.

13. Click Add Data Type to add the new user data type. (The Add Data Type button is disabled if a data type name has not yet been specified.)

14. After editing or adding the desired user data types, click Save Changes toolbar button on the Data Types form to save the user data types in the Relativity catalog.


Defining Item Patterns

See Also

Relativity provides the facility to identify a set of properties, called item patterns, that are common to data items. Columns based on those data items belong to a particular domain. The properties include a string pattern match on the COBOL data-name, the COBOL data type, the length, and, for numeric items, the precision and scale. Associated with each item pattern is a user data type and item transform. After item patterns are defined, the patterns can be used to assign the associated user data type and item transform to all data items whose descriptions match one of the specified patterns. As a result, columns based on the data items that match a particular item pattern will also have matching characteristics; that is, will belong to the same domain. A common use of item patterns is to treat all COBOL data items that represent a date value in a consistent manner. Other examples of sets of COBOL data items to which item patterns apply are customer numbers, company identifiers, prices, and inventory numbers.

Assigning item patterns helps automate the process of using a common user data type or common transform for similar data items within an FD. Once item patterns have been defined, you may click Assign Default Data Types on the FD form toolbar to assign user data types and transforms to all the data items in the FD that match one of the item patterns. The process can be iteratively improved by inspecting the results, modifying the item patterns, and reusing the Assign Default Data Types button. Also, following the completion of assigning default user data types and transforms, individual data items can be adjusted directly in the FD form by making changes in the User Data Type and Transform attribute columns to handle exceptional cases to the item patterns.

For procedures on how to define an item pattern, click here.


Define an item pattern

1. Display the FD form containing data items of a COBOL file.

2. Select a data item in the FD form that has a data structure with a characteristic appearing in more than one data item in the FD form. For example, a data item containing a common format for a date item.

3. On the Tools menu, click Item Patterns. The Item Patterns form opens.

4. Drag and drop the data item from the FD form to the Item Patterns form.

The Add Data Item Pattern dialog box is displayed. The Relativity Designer updates the entries in the dialog box with the characteristics of the data item received from the FD form.

5. Change entries in the Add Data Item Pattern dialog box to correctly define the item pattern existing in the data item. For example, if precision is not an important property of the item pattern, clear the Precision check box. If members of the item pattern have a particular naming convention, the pattern matching string following the Pattern check box can be used as part of the item pattern.

Note The default name pattern requires an exactly matching data-name.

6. To associate a user data type with the item pattern, select a user data type from the User Data Type list. If the desired user data type has not yet been defined, choose the < New > item from the list.

The Add Data Type dialog box is displayed and you can define a user data type. When you click Add Data Type, the Add Data Item Pattern dialog box will display with the new user data type in the User Data Type list.

7. To associate a transform with the item pattern, select a transform from the Item Transform list in the Add Data Item Pattern dialog box.

8. Click Add Pattern to add this data type to the Item Patterns form.

Note If neither Step 6 nor Step 7 is completed, Step 8 will fail. The following information will be displayed in a message box: "An item transform or a user data type (or both) must be specified."

9. Click Save Changes on the Item Patterns form toolbar to save the item pattern definition.

10. After item patterns have been defined, click Assign Default Data Types on the FD form toolbar to assign the default user data type to all data items in the FD that match the pattern.

Note If the FD contains a COBOL data item that matches the criteria for more than one item pattern, the Select Data Type dialog box is displayed so that you can indicate which item pattern to apply.


Specifying Treatment of the OCCURS Clause

See Also

In COBOL, an OCCURS clause specifies a repeating data item or group of data items. The relational model does not include the concept of repeating items except as rows of a relational table, thus providing a simpler (or "normalized") data model. Relativity provides several techniques for handling the mapping of repeating data items in COBOL to normalized relational tables.

The following techniques may be used in any combination to properly specify the treatment of the OCCURS clause by Relativity:

· Multiple Rows vs. Flattening: The default behavior of Relativity is to map repeating items to multiple rows. There are instances, however, in which each occurrence defined by an OCCURS clause has unique significance such that the default behavior of Relativity is not desired. These cases should be identified and, at table construction time, separate columns can be added to the table for one, some, or all occurrences by binding the subscript item associated with the OCCURS clause to one or more specific occurrences. This technique is sometimes called flattening the OCCURS. For more details, see Flattening OCCURS.

· Parallel OCCURS: Sometimes the repeating group may be broken into multiple OCCURS clauses that may not be contiguous in the record. This is referred to as parallel OCCURS. The repeating groups run parallel to each other in different OCCURS structures. These structures must be identified so that they can be related when the database is defined. See Identifying Parallel OCCURS Clauses for more information.

· Unused Occurrences Elimination: Unused occurrences resulting from an OCCURS clause should not become rows in a relational table. Correctly eliminating unused occurrences can provide a significant boost in the performance of Relativity. For more information, see Eliminating Unused Occurrences.


Flattening OCCURS

See Also

Relativity's normal treatment of a COBOL OCCURS clause is to derive one row in a relational table for each occurrence of the repeating data item. However, there may be situations in which it is desirable to treat repeating data items as one or more columns rather than as multiple rows. An example situation would be one in which the months of a year need to display as twelve columns in a single row rather than as twelve separate rows. This is called "flattening" the OCCURS.

To facilitate this behavior in the table, it is necessary to prepare for handling repeating data items prior to dragging and dropping them to the Table form to create columns based on them. The necessary preparation is to create a condition item whose conditional variable is the Relativity-created subscript item.

If the desired single occurrence of a repeating data item is known at design time, a column may be bound to that occurrence by creating and using a condition item. This condition item must be associated with the Relativity-created subscript for the repeating data item. For more information, see Define a condition item with one value.

A special procedure exists to speed the definition and binding of all (or a large number) of occurrences of a repeating data item. For more information, see Define a condition item series.

In some cases, the desired occurrence is determined by the value of a numeric data item contained in the record. In this case, no preparation is needed. Binding of the subscript to a numeric data item is accomplished by using the Bind Subscripts form accessed from the Table form after the column based on the repeating data item is created.


Identifying Parallel OCCURS Clauses

See Also

In Relativity, identifying parallel OCCURS clauses means identifying parallel COBOL tables and associating them as if they were one table described with one OCCURS clause.

Records within COBOL files often contain two or more data items having the clause OCCURS x TIMES, with x typically being the same number for both data items.

A relational database must contain only single-valued columns. Thus, Relativity's normal treatment of a COBOL OCCURS clause is to derive one row in a relational table for each occurrence of the COBOL data item. For example, the data item QUANTITY-SOLD-PER-MONTH occurs 12 times in the FD for a COBOL file. This one data item is represented by 12 rows in a relational table for each COBOL record.

When columns for two (or more) such data items are included in a relational table, each COBOL record produces the number of rows that is determined by multiplying the integers in the OCCURS clauses. If three data items within a COBOL file are each associated with an OCCURS 12 TIMES clause, then the three data items produce 12 x 12 x 12 or 1,728 rows in a relational table.

The identification of data items having parallel OCCURS characteristics enables Relativity to generate 12 rows having columns for the three selected data items. Each row contains the nth occurrence of the three data items. Thus, the three data items produce 12 rows in a relational table.

For procedures on how to identify data items having parallel OCCURS characteristics, click here.


Identify parallel occurs

1. In the FD form, select two or more data items having an OCCURS x TIMES clause with the same number of occurrences. Tip

2. Click Parallel Occurs on the FD form toolbar.

A message box is displayed prompting you to confirm that the listed data items are parallel tables.

3. Click OK to place the parallel OCCURS definition in the Relativity catalog.


Eliminating Unused Occurrences

See Also

Unused occurrences associated with an OCCURS clause should not become rows in a relational table. If, for example, you have a COBOL data file with 10,000 records, each of which contains an OCCURS 20 TIMES clause and you do not eliminate the unused occurrences, the result of the normalization would be a table containing 200,000 rows. If all occurrences in every record are active, then this is the necessary size of the table. However, it is often the case that the OCCURS clause specifies an upper bound on the number of active occurrences, not the actual number of active occurrences. The performance of Relativity in such cases can be significantly improved by eliminating the unused occurrences.

There are three alternatives for dealing with unused occurrences of a repeating data item:

1. Use a variable number of occurrences within the COBOL program by specifying the OCCURS clause with the DEPENDING ON phrase. Relativity will then only use the active occurrences indicated by the value of the data item specified by the DEPENDING ON phrase.

2. Use an existing data item in the record that specifies the number of active occurrences; that is, an implicit Occurs Depending On variable, to limit the number of occurrences considered by Relativity. See Identifying Implicit OCCURS DEPENDING ON for more information.

3. Use table filters to discard occurrences with null values (for example, spaces or zeroes might indicate null values). See Defining Table Filters for more information.


Identifying Implicit OCCURS DEPENDING ON

See Also

Some application files describe data arrays with an OCCURS clause without the DEPENDING ON phrase. However, the files have uninitialized or otherwise invalid data in some of the occurrences. For example:

03 NUMBER-OF-STYLES PIC 99.
03 STYLE-STORAGE OCCURS 25.
05 FIELD-A ...
05 FIELD-B ...
03 FIELD-C ...

Because of the limitations on the use of the DEPENDING ON phrase, the COBOL Procedure Division statements test the data item NUMBER-OF-STYLES to limit the occurrences used.

· For procedures on how to identify implicit OCCURS clauses with the DEPENDING ON phrase and eliminate potential invalid data references, click here.

· For procedures on how to re-assign or remove OCCURS clauses with the DEPENDING ON phrase, click here.


Identify implicit OCCURS clauses with the DEPENDING ON phrase

1. In the FD form, select the data item having the OCCURS clause. Tip

2. Select the data item specifying the number of occurrences.

3. Click Occurs Depending On on the FD form toolbar.

A message box is displayed prompting whether you want to emulate the OCCURS clause with the DEPENDING ON phrase syntax for the referenced data items.

4. Click OK to emulate the OCCURS clause with the DEPENDING ON phrase syntax.

A message box is displayed that contains the following sentence:

"data-item-name now 'depends on' data-item-name."


Re-assign or remove OCCURS clauses with the DEPENDING ON phrase

To change (or re-assign) an OCCURS clause to a different DEPENDING ON data item:

1. In the FD form, select the data item having the OCCURS clause. Tip

2. Select the new data item specifying the number of occurrences.

3. Click Occurs Depending On on the FD form toolbar.

A message box is displayed indicating that the data item already has a DEPENDING ON item.

4. Click Yes to change the assignment.

A message box is displayed prompting whether you want to emulate the OCCURS clause with the DEPENDING ON phrase syntax for the referenced data items.

5. Click OK to emulate the OCCURS clause with the DEPENDING ON phrase syntax.

A message box is displayed that contains the following sentence:

"data-item-name now 'depends on' data-item-name."

To remove an OCCURS clause DEPENDING ON data item:

1. In the FD form, select the data item having the OCCURS clause. Tip

2. Select the current data item specifying the number of occurrences.

3. Click Occurs Depending On on the FD form toolbar.

A message box is displayed indicating that the data item already has a DEPENDING ON item.

4. Click No to remove the assignment.


Defining Record Types

See Also

Many COBOL data files contain different types of records. Often the record type difference is subtle, with the Procedure Division code using an IF test on one data item to determine how another data item is to be treated.

Relativity makes use of a record type filter to restrict records used to supply rows to a table to those conforming to a particular record type. In order for Relativity to test the contents of a data item, the data item must be the conditional variable of a condition item. A condition item is referenced by an 88-level condition-name and specifies the value or values against which the conditional variable is to be tested when the record is passed through the filter.

If the record description does not contain the condition item, then the condition item must be added before creating a table. The Designer supports the addition of condition items to the FD.

Multiple record structures in a COBOL file are defined by the following:

· The presence of multiple 01 entries.

· The presence of one or more REDEFINES clauses.

For procedures on how to define record types, see the following topics:

· Identify the data items within each record type structure

· Add a data item to a record type

· Delete a data item from a record type

· Delete a record type

· Define a record type filter

· Edit a record type filter


Identify the data items within each record type structure

1. In the FD form, select the data items that make up one record type. When selecting group data items, select the highest level group having all its subordinate data items within the record type. Do not select the conditional variable data item and 88-level condition items that differentiate the record types. Tip

Note The data items selected must belong to a particular definition or redefinition that is valid for a particular record structure stored in the data file, plus any data items that are valid for all record structures stored in the data file. The alternative redefinitions are later selected to define a different record type.

2. Define the record type name of the selected data items by using either one of the following methods:

· Click the arrow on the Record Type list on the Record Type toolbar to display the record type names associated with the FD form. Select the < new record type > option from the list.

· Place the mouse pointer anywhere in the grid area of the FD form. Hold down the left mouse button and move (or drag) the selected data items to the Record Type list on the Record Type toolbar. Release the mouse button when the mouse pointer changes to the word NEW.

The Add Record Type dialog box is displayed as a result of either procedure.

3. In the Record Type Name box, type the new record-name to be associated with the new record type and then click OK.

4. Next, do one of the following:

· Click Yes in response to the inquiry about including subordinate data items in the new record type if data items subordinate to a selected group should be part of the new record type.

· Click No in response to the inquiry to include the group item without any of its subordinate data items.

Repeat this step for each selected group.

5. Click OK in response to the inquiry to commit the new record type in the Relativity catalog. The new record type name now appears in the Record Type list on the Record Type toolbar.

All data items selected for the record type appear in bold font in the FD form. Subordinate data items appear in normal font if selected for inclusion with the record type. Data items not included in the record type appear in italic font.

6. Define a record type filter.

7. Click Save Changes on the FD form toolbar to save the FD changes before adding a second record type.


Add a data item to a record type

1. In the FD form, select a record type from the Record Type list on the Record Type toolbar.

2. Select a data item in the FD form to be added to the record type.

3. Click Add Item on the Record Type toolbar.


Delete a data item from a record type

1. In the FD form, select a record type from the Record Type list on the Record Type toolbar.

2. Select a data item in the FD form to be deleted from the record type. All data items associated with the record type appear in bold font in the FD form.

3. Click Delete Item on the Record Type toolbar.

The selected data item is no longer associated with the record type. Data items not associated with a record type appear in the italic font.


Delete a record type

1. In the FD form, select a record type from the Record Type list on the Record Type toolbar.

2. Click Delete Record Type on the Record Type toolbar.


Defining Record Type Filters

See Also

A record type filter defines the criteria that determine the records of the data file that contain data items conforming to a particular record type. A relational table based on the record type will have only rows corresponding to records that pass the record type filter.

A record type filter is specified as a logical expression composed of condition-names and the logical operators NOT, AND, and OR. Records in the file pass the record type filter if the logical expression is true for the record.

For procedures on how to define record type filters, see the following topics:

· Define a record type filter

· Edit a record type filter


Define a record type filter

1. In the FD form, select a record type from the Record Type list on the Record Type toolbar.

2. Click Record Type Filter Properties to open the Record Type Properties form for the selected record type.

3. Click Add Filter on the Record Type Properties form toolbar. The Describe Filter Subexpression dialog box is displayed.

4. In the Condition Item list, select the condition-name specifying the condition desired. (The condition-names in this list are associated with data items in the FD form. If an appropriate condition-name is not already defined, see the procedures on how to add a condition item.)

5. In the Operator list, select the joining logical operator.

Note The joining logical operator for the first filter subexpression of a filter expression being defined must be AND; if OR is selected for the first filter subexpression, it is changed to AND when the filter subexpression is added to the filter expression.

6. Click Add Subexpression. The filter subexpression associated with the record type is displayed in the Record Type Properties form.

Note Filter subexpressions are evaluated in the order they are inserted and displayed in the Record Type Properties form, with the logical NOT operator having the highest precedence, the logical OR operator having the next lower precedence, and the logical AND operator having the lowest precedence. The algebraic representation of the filter expression, displayed by clicking Show Filter on the Record Type Properties form toolbar, uses explicit parentheses to make the precedence order obvious.

7. Repeat Steps 3 through 6 for each additional filter subexpression to be included in the filter expression.

8. Click Show Filter on the Record Type Properties form toolbar to display an algebraic representation of the record type filter expression.

9. Make corrections to the existing filter subexpressions by clicking in the grid area of the Record Type Properties form and selecting the appropriate cells.

Selecting a logical operator in the And/Or and Not columns and then clicking it toggles the logical operator except for the first AND operator, which cannot be changed. Selecting a condition-name in the Condition column and then clicking on the arrow displays the list of condition-names from which a different condition-name may be selected.

Note To remove a filter expression, click Clear Filter on the Record Type Properties form toolbar.

10. Click Close on the title bar to close the Record Type Properties form.


Edit a record type filter

1. In the FD form, select a record type from the Record Type list on the Record Type toolbar.

2. Click Record Type Filter Properties to open the Record Type Properties form for the selected record type.

3. Change a condition-name by selecting it in the Condition column and then clicking the arrow to display the list of condition-names from which a different condition-name may be selected.

4. Change a logical operator AND or OR by selecting it in the And/Or column and then clicking it to toggle the logical operator.

Note The first logical operator must be AND; it cannot be changed by clicking on it.

5. Change a logical NOT operator (or its absence) by selecting it in the Not column and then clicking it to toggle the logical operator.

6. If the filter expression needs to be removed, click Clear Filter. Use the procedure on how to define a record type filter to add any filter subexpressions needed after clearing the filter.

Note If you want to shorten a filter expression by removing a filter subexpression, you must remove the entire filter expression.

7. Click Show Filter to review an algebraic representation of the edited record type filter expression.

8. Click Close in the title bar to close the Record Type Properties form.


Using Functions and Transforms

See Also

The Relativity Designer provides both internal functions and transforms to act on COBOL data items. In determining when to use an internal function and when to use a transform, consider the following points:

· Internal functions are used to synthesize a COBOL data item using the value or values of one or more other COBOL data items within the same FD. These synthesized COBOL data items may be used as any other COBOL data item. Transforms are used to "transform", or convert, existing COBOL data items.

· An internal function can operate on more than one COBOL data item. A transform can operate only on a single COBOL data item.

· An internal function must be applied to the COBOL data item in the FD. A transform can be applied to the COBOL data item in the FD or at the column level. If the transform is applied at the FD level, all the columns that use that COBOL data item will use the transformed item. If the transform is applied at the column level, only those columns with the transforms will be affected. In the case of a data item that will always be transformed, such as a date data item, it is better to apply the transform at the FD level. If the data item sometimes needs to be transformed, and other times not, it is better to apply the transform at the column level.

· An internal function may have another function as an argument.

For detailed information on using internal functions and transforms, see the following topics:

· Internal Functions

· Transforms


Transforms

See Also

Transforms specify a data transformation for a COBOL data item value to or from a relational database column value. A transform is changed by clicking in the grid cell (either in the FD form for data items or in the Table form for columns), then selecting a transform from the Transform list. A transform also may be assigned during the definition of item patterns.

The list of available transforms is controlled by various pages in the Options dialog box. It is also controlled by the size of the underlying COBOL data item. For example, on an item with a PIC 9(6) you will not see YYYYMMDD (8-digit) transforms.

It is common for COBOL products to have a limited set of formats used for storing dates. When specifying date formats options, it is prudent to select only those date formats used by your COBOL programs in order to avoid invalid transforms.

Relativity provides the following types of transforms:

· Hexadecimal transform

· Standard date and time transforms

· User-configurable date transforms

· Math transforms

· Special date and date/time transforms

· LogicalOrder column transform

For detailed information on defining transforms on data items, see Defining Transforms on Data Items.


Hexadecimal Transform

The Hexadecimal transform passes the hexadecimal value of the COBOL data. The column should be defined as char and be twice the size of the COBOL record field; that is, a field containing a PIC S9(5) COMP-3 data item, which is a three-byte field, will return six bytes of hexadecimal information.

The Hexadecimal transform is useful for tracking down problem data. For example, if you have a column that returns the SQL error "Invalid Numerics", you can use the Hexadecimal transform and see what data is in the field.


Standard Date and Time Transforms

The following list includes all of the standard date and time formats supported by Relativity. All of these transforms will return an SQL Date, SQL Time, or SQL Date/Time value. The following transforms may be modified using transform modifiers.

Note For information on the date and time transform modifiers, see Modifiers for Date and Time Transforms.

HHMM | YYYYDDDHHMM | MMDDYYYYHHMM
HHMMSS | YYYYDDDHHMMSS | MMDDYYYYHHMMSS
HHMMSShh | YYYYDDDHHMMSShh | MMDDYYYYHHMMSShh
YYDDD | YYYYMMDD | DDMMYY
YYDDDHHMM | YYYYMMDDHHMM | DDMMYYHHMM
YYDDDHHMMSS | YYYYMMDDHHMMSS | DDMMYYHHMMSS
YYDDDHHMMSShh | YYYYMMDDHHMMSShh | DDMMYYHHMMSShh
YYMMDD | MMDDYY | DDMMYYYY
YYMMDDHHMM | MMDDYYHHMM | DDMMYYYYHHMM
YYMMDDHHMMSS | MMDDYYHHMMSS | DDMMYYYYHHMMSS
YYMMDDHHMMSShh | MMDDYYHHMMSShh | YYYYDDD
MMDDYYYY | DDMMYYYYHHMMSShh |


Modifiers for Date and Time Transforms

There are four modifiers for the standard date and time transforms, each of which must be defined in the RELDBDSN.INI file in order to be available:

· 9s Complement. Subtracts the value of the COBOL data item from all 9's before computing the date or time value using the modified transform. The transforms incorporating this modifier are not listed unless the Include 9s Complement Forms option is selected on the Date Formats page in the Options dialog box. This option is available only if the following line is added to the [Designer] section of the RELDBDSN.INI file

DateFormat9sEnable=Yes

and the Relativity Designer is restarted. (Liant recommends that this change be made to the RELDBDSN.INI file when the Relativity Designer is not running.)

· 10s Complement. Computes the 9s Complement and adds 1 to that value before computing the date or time value using the modified transform.

Note The 10s Complement of a zero value is defined to be zero.

The transforms incorporating this modifier are not listed unless the Include 10s Complement Forms option is selected on the Date Formats page in the Options dialog box. This option is available only if the following line is added to the [Designer] section of the RELDBDSN.INI file

DateFormat10sEnable=Yes

and the Relativity Designer is restarted. (Liant recommends that this change to made to the RELDBDSN.INI file when the Relativity Designer is not running.)

· 3M Complement. Complements the value of the COBOL data item with respect to 3,000,000 based on a date format of CYYMMDD.

The transforms incorporating this modifier are not listed unless the Include 3000000 Complement Forms option is selected on the Date Formats page in the Options dialog box. This option is available only if the following line is added to the [Designer] section of the RELDBDSN.INI file

DateFormat3MEnable=Yes

and the Relativity Designer is restarted. (Liant recommends that this change be made to the RELDBDSN.INI file when the Relativity Designer is not running.)

· + Subscript. Adds the value of the associated subscript less one for a date data item that is associated with an OCCURS table (but not subordinate to the OCCURS clause). This transform modifier is useful when the COBOL data record contains a starting date item and an OCCURS table, where each entry in the OCCURS table is information about a date based on the starting date and the number of days equivalent to its occurrence number less one. By using this transform modifier with the appropriate date format transform on the date item and including both the date item and one or more items that are subordinate to the OCCURS clause in a table, the multiple rows generated for the OCCURS clause will each contain the correct date.

The transforms incorporating this modifier are not listed unless the Include '+ Subscript' Forms option is selected on the Date Formats page in the Options dialog box. This option is available only if the following line is added to the [Designer] section of the RELDBDSN.INI file

DateFormatAddSubscriptEnable=Yes

and the Relativity Designer is restarted. (Liant recommends that this change be made to the RELDBDSN.INI file when the Relativity Designer is not running.)


User-Configurable Date Transforms

The following date transforms handle the situation where the date is stored in the COBOL data item as either 6 digits or 8 digits, but the end-user configures the actual format of dates stored in the data item. Such situations occur, for example, when the COBOL program allows the end-user to configure the date format for local conventions such as:

6-digit forms | 8-digit forms | Locale Example
YYMMDD | YYYYMMDD | Japan
MMDDYY | MMDDYYYY | U.S.A.
DDMMYY | DDMMYYYY | Germany

The person responsible for designing the Relativity catalog chooses the appropriate 6- or 8-digit transform. Then the end-user of the catalog, by using the Date Constants dialog box in the Relativity DBA program, can select the format that configures Relativity to match the format configured for the COBOL program that built the local files.

The 'YY' Dates list in the Date Constants dialog box is used to configure 6-digit forms.

The 'YYYY' Dates list in the Date Constants dialog box is used to configure 8-digit forms.


Math Transforms

The Math transforms include the following:

· 9s Complement. Subtracts the value of the COBOL data from all 9's.

· 10s Complement. Subtracts the value of the COBOL data from all 9's and adds 1 to that value.

· <ColValue> - 1. Subtracts one from the value of the COBOL data.

· <ColValue> + 1. Adds one to the value of the COBOL data.

· Div 100 (Read only). Divides the value of the COBOL data by 100.

· Mod 100 (Read only). Returns the remainder of the COBOL data divided by 100.


Special Date and Date/Time Transforms

Several special date and date/time transforms are available.

The following transform provides 30KBias to support 5-digit NCR packed decimal dates:

· MMDDYY-30000

This transform is not listed unless the Include MMDDYY-30000 Form option is selected on the Date Formats page in the Options dialog box. This option is available only if the following line is added to the [Designer] section of the RELDBDSN.INI file

DateFormatNCREnable=Yes

and the Relativity Designer is restarted. (Liant recommends that this change be made to the RELDBDSN.INI file when the Relativity Designer is not running).

The following transforms convert a date or date/time where the date is specified as the number of days since the base date specified in the Date Constants 'Days' Base Date:

· Days

· DaysHHMM

· DaysHHMMSS

· DaysHHMMSShh

The following transforms return the first day of the month for a given year and month:

· YYYYMM01

· YYMM01

· MMYY01

· MMYYYY01

The following transforms return the last day of the month for a given year and month:

· YYMM31

· YYYYMM31

· MMYY31

· MMYYYY31

The following transforms return the first day of the year for a given year:

· YY001

· YYYY001

The following transforms return the last day of the year for a given year:

· YY365

· YYYY365


LogicalOrder Column Transform

Bi-directional text in languages, such as Hebrew and Arabic, may be represented within the computer in one of two ways: logical order and visual order.

ODBC applications expect that Relativity will supply them with text in logical order, and they automatically convert it to visual order when it comes time to display the text. Relativity also treats text from application files as being in logical order, and performs no transformations on it when returning it to the application program. It is possible, however, that the COBOL application received the text in visual order from the terminal, performed no translations on it, and stored the text in the application’s file still in visual order. When the ODBC application attempts to convert the text that is already in visual order to visual order again, the resulting text is not displayed properly. Although an ODBC translation DLL can be employed to translate the visual order to logical order, any sorting of the data via an index or an ORDER BY operation will have already been performed before the translation DLL is called; thus, the order of the data will not be correct.

Relativity offers the LogicalOrder column transform as an alternative to the ODBC translation DLL. The LogicalOrder column transform is used to convert visual order text to logical order text before returning it to the ODBC application. Likewise, logical order text that is written into a column by the ODBC application will be converted back to visual order before storage into the COBOL data file, so the COBOL application can use it.

Notes

· Data that is stored in visual order does not sort properly, and Relativity will not build an index on a column with a LogicalOrder transform, even though the underlying data file has a key on the data item. However, as the data that the column returns is now in logical order, performing an ORDER BY operation on the column will cause the information to sort properly.

· If the LogicalOrder column transform is in use, a translation DLL should not be used.

There are two approaches to take when using the LogicalOrder column transform. The first is to apply it to individual columns of a table. The second is to apply it to every text column in every table in the data source. Before applying the LogicalOrder transform to a column, however, you must first enable this transform in the data source.

For more information and procedures on using the LogicalOrder column transform, see the following topics:

· Enable the LogicalOrder column transform

· Apply the LogicalOrder column transform on an individual column

· Apply the LogicalOrder column transform on an entire data source


Enable the LogicalOrder column transform

1. From the Tools menu, select Options.

2. In the Options dialog box, select Table.

3. On the Table page, check the Show LogicalOrder Transform check box.

4. Click OK to save the options and close the dialog box.


Apply the LogicalOrder column transform on an individual column

After enabling the LogicalOrder column transform, follow these steps to apply the transform on individual columns of a table:

1. In the Catalog window, click the Tables catalog object.

2. From the Tables catalog object, select the name of the table that contains the desired column.

3. If necessary, expand the Table form horizontally to display more attributes by clicking the Design Mode toolbar button.

4. In the Table form, select the row containing the desired Column Name by clicking in the far left column.

5. From the Transform list box at the bottom of the Table form, select the LogicalOrder column transform option.

6. Save the table definition by clicking the Save Changes toolbar button.


Apply the LogicalOrder column transform on an entire data source

After enabling the LogicalOrder column transform, follow these steps to automatically apply the transform on every text column in every table of a data source:

1. In the Catalog window, click the Files catalog object.

2. From the Files catalog object, right-click the name of the file that contains visual order data and click Properties from the pop-up context menu.

Alternatively, you can choose the Properties command from the FD menu when focus is in the FD form.

3. In the FD Properties form, examine the Native Charset box. This text field must contain Hebrew 7-bit Old Code, or code page 862, 864, or 708. If it does not, do one of the following and then proceed to Step 4:

· To change the character set for a single file, use the Merge COBOL FD Changes command from the FD menu and import the FD again. Click Advanced in the Source Code Import wizard Files Selection page for either .CBL and .RST files or .COB files to select the proper character set.

· To change the character set of multiple files, click Character Sets on the Tools menu to open the Character Set Maintenance dialog box. Make the needed changes.

4. From the Tools menu, click Options.

5. In the Options dialog box, select the Data Source page.

6. From the Automated Logical Transform list, select Always to apply the transform to all text columns, or select Yes, Except For Record Key Data Items, to apply the transform to all text columns, except where it would result in the loss of an index on the table.

7. Click OK to save the options and close the dialog box.


Defining Transforms on Data Items

See Also

A transform is used to "transform", or convert, an existing COBOL data item value to and/or from a relational database column value. Transforms can be applied to the COBOL data item in the FD (as described here) or at the column level.

If the transform is applied at the FD level, all the columns that use that data item in the FD will use the transformed item. In the case of a data item that will always be transformed, such as a date field, it is better to apply the transform at the FD level.

Note A transform can operate only on a single COBOL data item.

To define a transform on a data item, choose one of the following methods.

Method 1

· From the expanded FD form, select a data item and then select a transform from the list in the Transform attribute.

Whenever a column that refers to the data item is accessed, it will be transformed from its COBOL format to the transform's format. For example, when a column accesses a COBOL PIC 9(8) that contains 19970320 with a date transform, the column will appear in SQL Date/Time format.

Method 2

· From the Item Patterns form, select a transform from list in the Item Transform attribute column.

This method associates the transform with the item pattern. When the item patterns are applied to the FD form by clicking Assign Default Data Types on the FD form toolbar, the associated transform will be assigned to any data items matching the pattern.


Internal Functions

See Also

Internal functions are part of the Relativity DBMS. An internal function is used to synthesize a COBOL data item using the value or values of one or more other COBOL data items within the same COBOL file definition (FD). A synthesized COBOL data item, known as a function item, may be used as any other COBOL data item. Unlike a transform, an internal function may operate on more than one COBOL data item.

For procedures on how to work with internal functions, choose from the following topics:

· Synthesize a data item using an internal function

· Specify a function argument

The following table describes all the available internal functions that can be added to an FD form.

Option

Description

AirlineDate

1. Travel date PIC X(5) in the form DDMMM.

2. Transaction date (must have a date transform).

3. Transaction type PIC X.

Note This internal function is available only if the RELDBDSN.INI file has the following entry in the [Designer] section: EnableAirlineDate=Yes.

CombineDateTime

1. A valid date data item.

2. A valid time data item.

Complement

1. Numeric data item to be conditionally complemented.

2. 88-level condition-name to determine if complement happens.

ComputeCenturyDate

1. A data item or constant containing the century, divided by 100. The value contained in this argument is multiplied by 100 and added to the value contained in the second argument to compute the actual year of the date.

2. A data item or constant containing the year of the century.

Note It is assumed that this value will be in the range of 0 through 99, but it is not enforced.

3. A data item or constant containing the month.

Note If the month argument is a constant zero (0), the days argument (argument 4) will be treated as the day of the year. Otherwise, the days argument will be treated as the day of the month.

4. A data item or constant containing the day of the month or year.

ComputeCenturyDateTime

1. A data item or constant containing the century, divided by 100. The value contained in this argument is multiplied by 100 and added to the value contained in the second argument to compute the actual year of the date.

2. A data item or constant containing the year of the century.

Note It is assumed that this value will be in the range of 0 through 99, but it is not enforced.

3. A data item or constant containing the month.

Note If the month argument is a constant zero (0), the days argument (argument 4) will be treated as the day of the year. Otherwise, the days argument will be treated as the day of the month.

4. A data item or constant containing the day of the month or year.

5. An optional data item or constant containing the hour of the day. Default is 00:00:00.00.

6. An optional data item or constant containing the minute of the hour. Default is hh:00:00.00.

7. An optional data item of constant containing the second of the minute. Default is hh:mm:00.00.

8. An optional data item or constant containing the hundredth of the second. Default is hh:mm:ss.00.

ComputeDate

1. A data item or constant containing the year. The precision of the data item (rather than its value) will be used to determine whether the year contains two or more than two digits. This in turn will determine whether to use the YY or YYYY date constants when evaluating the value of the data item. See the Date Constants dialog box and Defining Date Constants topics.

2. A data item or constant containing the month.

Note If this argument is a constant zero (0), then the days argument (see the next argument) will be treated as the day of the year. Otherwise, the days argument will be treated as the day of the month.

3. A data item or constant containing the day of the month or year (see the previous argument).

ComputeDateTime

1. A data item or constant containing the year. The precision of the data item (rather than its value) will be used to determine whether the year contains two or more than two digits. This in turn will determine whether to use the YY or YYYY date constants when evaluating the value of the data item. See the Date Constants dialog box and Defining Date Constants topics.

2. A data item or constant containing the month.

Note If this argument is a constant zero (0), then the days argument (see the next argument) will be treated as the day of the year. Otherwise, the days argument will be treated as the day of the month.

3. A data item or constant containing the day of the month or year (see the previous argument).

4. An optional data item or constant containing the hour of the day. Default is 00:00:00.00.

5. An optional data item or constant containing the minute of the hour. Default is hh:00:00.00.

6. An optional data item or constant containing the second of the minute. Default is hh:mm:00.00.

7. An optional data item or constant containing the hundredth of the second. Default is hh:mm:ss.00.

ComputeODO

1. A repeating data item.

ComputeTime

1. A data item or constant containing the hour of the day.

2. A data item or constant containing the minute of the hour.

3. An optional data item or constant containing the second of the minute. Default is hh:mm:00.00.

4. An optional data item or constant containing the hundredth of the second. Default is hh:mm:ss.00.

IsNumeric

1. Any data item.

IsValidDate

1. A valid date data item.

2. Must have a date transform set.

LogicalAnd

1. Two to twenty 88-level condition-names or logical internal functions.

LogicalOr

1. Two to twenty 88-level condition-names or logical internal functions.


Synthesize a data item using an internal function

To synthesize a data item using an internal function:

1. Click Add Function on the FD form toolbar to display the Select Function dialog box.

2. In the Select Function list, select an internal function.

3. Click Select to commit the internal function to the FD form. The function is displayed in the COBOL Name attribute column preceded by "f :" in the FD form.

Note Once the internal function has been added to the FD form, you must specify the function arguments for the internal function.


Specify function arguments

Once the internal function has been added to the FD form using the method described in synthesizing a data item using an internal function, you must specify the function arguments for the internal function. Take one of the following actions:

· Select a data item in the FD form and drag and drop it on the internal function.

· Alternatively, select both the internal function and the data item in the FD form (press Ctrl while selecting), and click Add Item Argument on the FD form toolbar.

For functions with multiple arguments, repeat one of the preceding alternatives until all the arguments have been specified.

The arguments specified for a function are displayed in the Value attribute of the FD form. The Value attribute column is not displayed unless the Show VALUE Column check box is selected on the File page in the Options dialog box.

Since an internal function represents a synthesized data item, an internal function may be used as an argument to another internal function. When an internal function is used as an argument to another internal function, the Function of Function dialog box is displayed for differentiating between the internal function and the function argument.


Defining Item Sets

See Also

An item set is composed of two or more data items in a COBOL record that contain identical information but that have been identified to Relativity as a set of redundant data items. Redundant data items include situations such as where one data item is identical to the first characters of another data item. One place where redundant data items are defined is in keys, where different keys provide different look-up capabilities in a file. Using Relativity, an item set becomes one data item in a relational database table.

Identifying redundant data items as an item set provides two advantages to Relativity:

· The Relativity DBMS is more likely able to choose an efficient index for accessing the data.

· When writing data with SQL UPDATE or INSERT statements, the redundant data will be maintained consistently by deriving its value from a single column value.

Item sets are defined in the Edit Item Sets form, which first opens when you click Redundant Data Items on the FD form toolbar.

For more information and procedures on how to define item sets, see the following topics:

· Define an item set

· Add a data item to an item set

· Delete a data item from an item set

· Delete an item set from the list of item sets

· Delete all item sets associated with an FD form


Define an item set

1. In the FD form, select two or more data items that contain redundant (or identical) data. Tip

2. Click Redundant Data Items on the FD form toolbar. The Edit Item Sets form opens.

3. Click Add New Item Set on the Edit Item Sets form toolbar.

4. For each item in the set, respond to the question "Does <item> contain the complete value?".

The names of the redundant data items forming the item set are displayed in the Edit Item Sets form. In the FD form, an asterisk character is placed to the right of the names of the data items forming the item set.

5. Close the Edit Item Sets form by clicking the Close toolbar button.


Add a data item to an item set

1. In the FD form, select one or more data items to be added to an item set. Tip

2. Click Redundant Data Items on the FD form toolbar. The Edit Item Sets form opens.

3. Scroll down the Edit Item Sets form in the FD form and select the item set from the list to receive the new data item.

4. Click Add Items to Set on the Edit Item Sets form toolbar. The names of the new data items are inserted into the item set list.

5. Close the Edit Item Sets form by clicking the Close toolbar button.


Delete a data item from an item set

1. Click Redundant Data Items on the FD form toolbar. The Edit Item Sets form opens.

2. Scroll down the Edit Item Sets form in the FD form.

3. Select one or more data items in one item set to be removed from that item set. Tip

4. Click Delete Item or Item Set on the Edit Item Sets form toolbar.

The name of the data item is no longer displayed as a member of the Edit Item set. Within the FD form, the asterisk is removed from the data item deleted the item set.

5. Close the Edit Item Sets form by clicking the Close toolbar button.


Delete an item set from the list of item sets

1. Click Redundant Data Items on the FD form toolbar. The Edit Item Sets form opens.

2. Scroll down the Edit Item Sets form in the FD form and select the item set to be deleted from the list of item sets.

3. Click Delete Item or Item Set on the Edit Item Sets form toolbar.

The item set is removed from the Edit Item Sets form. Within the FD form, the asterisk is removed from each data item associated with the deleted item set.

4. Close the Edit Item Sets form by clicking the Close toolbar button.


Delete all item sets associated with an FD form

1. Click Redundant Data Items on the FD form toolbar. The Edit Item Sets form opens.

2. Scroll down the Edit Item Sets form in the FD form.

3. Click Delete All on the Edit Item Sets form toolbar.

All item sets are removed from the Edit Item Sets form. Within the FD form, the asterisk is removed from each data item associated with the deleted item sets.

4. Close the Edit Item Sets form by clicking the Close toolbar button.


Defining Default Values

See Also

The Default Value attribute in the FD form is the value that is used in write operations if the item is not represented by a column in an SQL INSERT statement. This value is set by double-clicking in the Default Value column row of the selected item in the FD form, then typing or selecting the value in the Set Default Value dialog box. The value will be limited to the range of values that is valid for the underlying COBOL data type.

For example, if you are creating a date data type, the only valid default values are valid dates. The following forms are valid for entering dates:

2007-05-01 05-01-2007 01 May 2007

All of these forms refer to May 1, 2007.

The Default Value attribute column is displayed in the FD form only if the Show Default Values option is selected on the File page in the Options dialog box.


Defining Null Information

See Also

Null information is the means of specifying the relationship between COBOL data item values and the SQL NULL value. This information is specified in the FD form through the Null Value and Not Null attributes. The Null Value and Not Null attribute columns are displayed in the FD form only if the Show Null Information option is selected on the File page in the Options dialog box.

The Null Value attribute in the FD form describes the data value that will produce a null, or will be stored when a null is written, in an SQL column using this data item. The representation of a null for a data item in the FD form is selected from a list of condition-names. The conditional variable associated with a condition-name in the list does not have to be the data item in the FD form for which the Null Value attribute is being defined.

Note If the original source for the file description did not include the necessary 88-level condition-name definition, the condition-name may be added in the Designer. For more information on adding condition items in the Designer, click here.

The Not Null attribute in the FD form, when set, indicates that a column defined on this item is null when the null condition is false. The Not Null attribute is initially not set, indicating that a column defined on this item is null when the null condition is true.

A column in a relational table based on a data item with null information set will automatically be marked as nullable in the Table form. That is, the Nullable attribute in the Column Properties area of the Table form will indicate that this column allows nulls. If the condition specified by the condition-name in the FD form is true for a record, then the column will contain null for the row(s) derived from that record.

Note The Nullable Column Utility provides a way to determine the status of null information and change certain settings if desired. The utility also allows you to process all tables in a data source or only a selected group of tables.

Null information is also used on the Data Types form, on which the Nullable attribute indicates that the data type defines columns that allow nulls.


Specifying Comments

See Also

The Comment attribute contains comments pertaining to the data item defined by this row in the FD form. The comment is changed by clicking in the grid cell. The Comment attribute column is displayed in the FD form only if the Show Comments option is selected on the File page in the Options dialog box.

This attribute is totally owned by the developer for use in the Relativity Designer and through reports. It is a good place to maintain a user-friendly definition of the data item. Through the reporting tool, this comment could then be used to build a help file for the end-user of the Relativity catalog. Another use of this attribute might be to discuss the uses of a data item that may not be obvious.

Comments in the FD form may be inherited in the Table form if the Inherit FD Comments check box on the Table page in the Options dialog box is selected prior to building the table.


Saving File Definitions

There are two methods for saving file definitions.

Method 1

1. If needed, restore the FD form of the file by double-clicking on its icon in the Relativity Designer window.

2. Click Save Changes on the FD form toolbar.

The Save Changes button accepts into the Relativity catalog all changes made to the record description displayed in the FD form for a COBOL file.

Note This button will be enabled only if changes have been made.

Method 2

1. Click the Control Menu icon at the left side of the title bar of the FD form.

2. On the Control menu, click Close or press the Ctrl+F4 shortcut.

Alternatively, you can double-click the Control Menu icon to close the form.

3. In the Commit FD Changes message box, click Yes to save the file definitions in the Relativity catalog.

The image of the FD form is removed from the Relativity Designer window.


Defining Relational Tables in the Table Form

Building Tables, An Overview

Creating and Editing Table Definitions

Defining Columns on Repeating Data Items

Handling Multiple Record Types

Defining Table Filters

Defining Transforms on Columns

Previewing Table Data

Analyzing Table Definition Errors

Building Writable Tables

Establishing Table Connections

Supporting Multi-File Tables

Using the Table Wizard


Building Tables, An Overview

See Also

Working with the information from the COBOL file definition displayed in the FD form, it is easy to build and define the structure of a relational table using the Table form. The Relativity Designer is able to map the COBOL schema (basically, all the file description language semantics) from a set of one or more COBOL files to relational tables (rows and columns).

In the Relativity Designer, a relational table is built from the COBOL definitions displayed in the FD form. Using a "drag and drop" procedure, you create a table definition to define the structure of a relational table associated with a COBOL data file. Each entry in a table definition corresponds to an FD entry, which is a data item or a function item of FD data items. Using relational database terminology, each entry in a table definition is called a column.

Note The Table wizard provides an alternative to the drag and drop method of creating a table that further automates the process and allows a table to be built quickly.

For detailed information on defining and building relational tables, see the following topics:

· Creating and editing table definitions

· Defining columns on repeating data items

· Handling multiple record types

· Defining table filters

· Defining transforms on columns

· Previewing table data

· Analyzing table definition errors

· Building writable tables

· Establishing table connections

· Supporting multi-file tables

· Using the Table wizard

► Related Topic Relativity supports a set of stored procedures, identified with the prefix, DBA-, only if the user is the owner or a database administrator of the Relativity catalog. The DBA stored procedures deal with table definitions, table connections, and file names. All of the stored procedures are ODBC driver-specific. For more information, see "Stored Procedures" under the For Advanced Users | Relativity-Specific topic in the Relativity DBMS Help file.


Creating and Editing Table Definitions

See Also

Choose one of the following topics for procedures on how to create, save, and edit a relational table for the record descriptions in an existing FD form:

· Create a table definition

· Save a table definition

· Edit a table definition


Create a table definition

1. In the Catalog window, click the Files catalog object and double-click the name of the COBOL file for which a table is to be created. The FD form opens for that file.

2. In the Catalog window, click the Tables catalog object and then click the New shortcut from the Table Common Tasks. The Table form opens with the words "New Table" in the title bar.

Note The New shortcut provides the same functionality as the New command on the Table menu.

3. Position the FD form and the Table form so that both are visible in the Relativity Designer window.

Note If the FD has multiple record types, be sure to select the appropriate record type for this table.

4. Select one or more data items or function items in the FD form. Tip

5. Drag and drop the data items or function items from the FD form to the Table form. Tip

If a problem results when you drag a data item from an FD form to a Table form, Relativity will warn you.

a. If duplicate column names result from the process of dragging a data item from an FD form to a Table form, the Duplicate Column Name message box is displayed. You will be prompted either to enter a unique column name or skip the item.

b. If a data item from an FD form is dragged to a Table form that already contains a column based on that data item, the Binding Exists message box is displayed. You will be prompted to confirm whether you want to bind the column again.

c. If the editing of a default column name results in a reserved default column name, a warning occurs when the item is made part of a table. For example, if (1) the COBOL data-name TEMP-ORARY exists in the record descriptions, and (2) default column names are derived by omitting hyphens, the default column name for the item would be the SQL reserved word Temporary and there would be no warning. Then, if the data item TEMP-ORARY is dragged to a Table form, the Invalid Column Name dialog box will be displayed to allow you to change the column name.

6. Repeat the drag and drop operation, if necessary, until all the columns of the table have been created. Each row in the Table form represents, in relational database terminology, a column of the table being created. Each column is associated with an FD data item or function item.

7. Click Design Mode on the Table form toolbar to display the attributes of a table definition.

8. Click on any attribute of a table column entry and the Column Properties area for that entry will be displayed in the lower part of the Table form (except that, for columns whose Data Type attribute is a user data type rather than an ODBC data type, the column properties are not displayed in the Table form; for user data types, the column properties are set in the Add Data Type dialog box and displayed in the Data Types form).

The Column Name, Data Type, Default Value, and Comment attributes may be edited in the Table form. The Data Item attribute for a column entry may not be changed in the Table form (if a change in the data item is needed, delete the column entry, by selecting its row and clicking Delete Column on the Table form toolbar or the Del (Delete) key on the keyboard, and then drag the correct data item from the FD form to the Table form).

Note The Default Value and Comment attributes for a column entry are not shown in the Table form unless the appropriate check box has been selected on the Table page in the Options dialog box. In addition, the Default Value attribute is not shown in the Table form unless the Allow Inserts check box is selected on the Table form toolbar.

The column properties for column entries with an ODBC data type may be modified in the Table form. (The column properties for column entries with a user data type may be modified in the Data Types form.) The order the columns entries are shown in the Table form is the default order of columns for the table being created; that is, the order the columns would be returned for a "SELECT * FROM <table>" SQL statement. The order can be adjusted selecting one or more column entry rows and using the Move Up and Move Down buttons on the Table form toolbar to move the selected rows up or down, respectively.

For additional information on editing a table definition, see the procedures on how to edit a table definition.

9. Save the table. The Create New Table dialog box is displayed.

10. In the New Table Name box, type the table name.

11. Click OK.


Save table definitions

There are two methods for saving table definitions.

Method 1

1. If needed, restore the Table form of the desired table by double-clicking on its Catalog icon in the Relativity Designer window.

2. Click Save Changes on the Table form toolbar.

The Save Changes button accepts into the Relativity catalog all changes made to the table description displayed in the Table form.

Note This button will be enabled only if changes have been made.

Method 2

1. Click the Control Menu icon at the left side of the title bar of the Table form.

2. On the Control menu, click Close or press the Ctrl+F4 shortcut.

Alternatively, you can double-click the Control Menu icon to close the form.

3. In the Commit Table Changes message box, click Yes to save the table data definitions in the Relativity catalog.

The image of the Table form is removed from the Relativity Designer window.


Edit a table definition

1. In the Catalog window, click the Tables catalog object to display the list of tables associated with the table definitions in the Relativity catalog.

2. From the list of tables, double-click the name of the table to be edited. The Table form for the selected table opens.

3. Click Design Mode on the Table form toolbar to display all attributes in the Table form.

4. Pull down the bottom edge of the Table form to enlarge the area of table entries.

5. Adjust record types, if necessary, as described in Handling Multiple Record Types.

6. Verify the effect of your changes as described in Previewing Table Data.

7. Define table filters, if necessary, as described in Defining Table Filters.

8. Define columns on repeating data items as described in Defining Columns on Repeating Data Items.

9. Create a table connection as described in Establishing Table Connections.

10. Save the table definitions.

Note Many numeric data items do not order the data correctly. An index can include a column defined on a numeric data item under the following conditions:

· Whatever data item values, if any, that correspond to a null in the column must precede all other values.

· The key order must be the same as numeric order. For example, negative numbers must precede positive numbers; for many signed data types, negative numbers follow positive numbers. Note, however, that if the data item is signed but the column is marked unsigned, the Relativity DBMS will disallow negative values; the column can then be included in an index.

· There must be only one way to represent a given value in the numeric data item. For example, if the data item allows two or more representations of the sign, no index is possible. In some cases, the Relativity DBMS may limit the allowed representations of data items that are partially or totally within a file key so that an index can be built.


Defining Columns on Repeating Data Items

See Also

The OCCURS clause in COBOL data definitions presents a challenge when designing relational tables because the concept of the OCCURS clause is not available in the relational model.

Relativity provides several methods to accommodate the OCCURS clause, depending on the particular needs of the application database:

1. Generate one row for each occurrence of a data item within a COBOL record. This mechanism, along with the Relativity-created subscript subordinate to the data item containing the OCCURS clause, helps to automatically normalize the table definition. This is the default behavior for Relativity.

2. If the COBOL record type used to define a table contains a numeric data item that specifies an occurrence of another data item in that record type, the number may be used to bind a column to that occurrence at runtime.

3. If the desired single occurrence of a repeating data item is known at design time, a column may be bound to that occurrence by creating and using a condition item. This condition item must be associated with the Relativity-created subscript for the repeating data item. See Bind a subscript at design time.

4. A special procedure exists to speed the definition of all (or a large number) of occurrences of a repeating data item using a condition item series. Once defined, the condition items series can be bound at design time.

5. Sometimes the best presentation of a data item containing or subordinate to an OCCURS clause (a COBOL table) is to define and bind a column for each occurrence. Relativity has a straightforward process to speed this operation. See Bind a subscript at runtime.


Bind a subscript at runtime

Take the following steps to bind a numeric data item to a column subscript in the Table form at runtime:

1. In the Table form, select a column definition that is associated with a data item that contains, or is subordinate to, an OCCURS clause.

2. Select the Bound Subscripts check box that appears in the Column Properties area in the lower part of the Table form. The Bind Subscripts form opens.

3. Click Bind to Data Item. This action indicates that a numeric data item contains the occurrence number.

4. Click the arrow to the right of the Data-Name/Condition-Name box to view a list that contains the data-names of all nonsubscripted numeric data items within the FD form.

5. Select the data item from the list whose numeric value indicates the value of the subscript to obtain the desired data item. The box displays the data-name of the desired numeric data item.

6. Click Close to exit the Bind Subscripts form.


Bind a subscript at design time

1. In the FD form, select the line containing the notation SubscriptItem that is subordinate to the data item containing the OCCURS clause.

2. Using the techniques described in Adding Condition Items, define a condition item that meets your requirements, as follows:

· Having a single value

· Having a range of values

· Having a series of values

3. Click Save Changes on the FD form toolbar to commit the changes in the FD form.

4. In the Table form, select a column definition associated with a data item that contains, or is subordinate to, an OCCURS clause.

5. Select the Bound Subscripts check box that appears in the Column Properties area in the lower part of the Table form. The Bind Subscripts form opens.

6. Click Bind to Literal. This action indicates that a condition-name describes the desired occurrence number of the data item.

7. Click the arrow to the right of the Data-Name/Condition-Name box to view a list that contains all condition-names subordinate to the subscript item for the data item that contains the OCCURS clause.

8. Select the condition-name from the list whose numeric value indicates the occurrence of the desired data item. The box displays the selected condition-name.

9. Click Close to exit the Bind Subscripts form.


Bind all occurrences at design time

1. In the FD form, select the line containing the notation SubscriptItem subordinate to the data item that contains the OCCURS clause.

2. Click Add Condition Item on the FD form toolbar. The Add Condition Item dialog box is displayed.

3. In the New 88 Name box, type an 88-level condition-name.

4. Select the Series check box.

5. Click Add to generate a condition item series; that is, multiple condition-names associated with the subscript item selected in the FD form. Each condition-name for the series is generated from the name entered in Step 3 by appending a hyphen and a number having a maximum of two digits. The value of the number varies from 1 to the maximum value of the subscript; thus, there is a condition item for each occurrence.

6. Click Save Changes on the FD form toolbar to save the change in the FD form.

When you drag and drop the subscripted data item, adding it to a table, the Subscripted Data Item dialog box is displayed, allowing the choice of multiple rows or multiple columns.

7. Select the option for which columns are to be defined.

If you select the Create Multiple Columns option, the Choose Subscript Values dialog box is displayed showing all condition-names subordinate to the subscript item for the subscripted data item. The subscripted data item is the one described in Step 6.

8. To make selections in the Choose Subscript Values dialog box corresponding to the columns that you wish to define, select one or more of the occurrences.

9. Click OK. A column definition is added to the table definition for each selected 88-level condition-name. The column name for this definition is the default column name followed by the value of the 88-level condition-name.


Handling Multiple Record Types

See Also

When you create a new table, it is not associated with any FD or record type. As you drop the first item(s) onto a table, it is associated with the FD and record type (if a record type was selected) of the source. Subsequent items can add new record types (but not FDs) to a table. If an item from a record type not yet associated with a table (that already has one or more record types) is dropped on a table, a message is displayed prompting you to add this record type to the table. If you select No, neither the items nor the record type will be added. If you select Yes, the items and record type will be added to the table.

If the record types associated with a table need to be manually adjusted, double-click the File Indicator Bar in the expanded Table form that contains the FD name and the record types. The Assign or Remove Record Types dialog box is displayed.

The following four rules apply specifically to multiple record types:

1. Each item upon which a column is defined must belong to all record types associated with the table, or be nullable.

2. All columns in a table with multiple record types are allowed to be set as nullable, even if they do not have a null condition-name associated with the underlying COBOL data item. This feature is to handle the case where, due to the conditions of the filter not being met, a column is undefined for a given row.

Note The Nullable Column utility provides a way to determine the status of null information and change certain settings if desired. The utility also allows you to process all tables in a data source or only a selected group of tables.

3. Each record type associated with a table having multiple record types must contain a filter. In the Table form, this is checked when you try to save changes. If there are multiple record types, and one or more of those record types does not contain a filter, an error message will be displayed and your changes not saved. In the FD form, if a record type belongs to a table that has multiple record types, and you attempt to remove the filter, you will receive an error message, and the filter will not be cleared.

4. Items from a record type and items from a non-record type may not be added to a single table. Either the table is not associated with any record types, or a table is associated with one or more record types.


Defining Table Filters

See Also

A record type filter is applied in the FD form to distinguish between multiple record types. Sometimes, however, it is desirable to further limit the COBOL records that make up the rows in a table. For example, an employee payroll master file might have a single record type containing all employee information, but separate tables for active and inactive employees are desired. A table filter may be used for this purpose. While a separate record type could be defined in the FD form for each table, this seems unnecessary in most cases where the need is only for additional filter subexpressions.

A table filter defines the criteria that determine the records to be viewed in the Table form. Remember that a table filter is in addition to the record type filter. The record type filter is in effect for the record type being used to define the table. It is not necessary to specify the filter subexpressions already in the record type filter.

For more information on table filters, see the following topics:

· Define a table filter

· Edit a table filter


Define a table filter

1. Click Edit Table Filter on the Table form toolbar. The Table Filter Properties form opens.

2. Click Add Filter on the Table Filter Properties form toolbar. The Describe Filter Subexpression dialog box is displayed.

3. In the Condition Item list, select the condition-name specifying the condition desired. (The condition-names in this list are associated with data items in the FD form. If an appropriate condition-name is not already defined, see the procedures on how to add a condition item.)

4. In the Operator list, select the joining logical operator.

Note The joining logical operator for the first filter subexpression of a filter expression being defined must be AND; if OR is selected for the first filter subexpression, it is changed to AND when the filter subexpression is added to the filter expression.

5. Click Add Subexpression. The filter subexpression is inserted into the Table Filter Properties form.

Note Filter subexpressions are evaluated in the order they are inserted and displayed in the Table Filter Properties form, with the logical NOT operator having the highest precedence, the logical OR operator having the next lower precedence, and the logical AND operator having the lowest precedence. The algebraic representation of the filter expression, displayed by clicking Show Filter on the Table Filter Properties form toolbar, uses explicit parentheses to make the precedence order obvious.

6. Repeat Steps 2 through 6 for each additional filter subexpression to be included in the filter expression.

7. Click Show Filter on the Table Filter Properties form toolbar to display an algebraic representation of the filter expression.

8. Make corrections to the existing filter subexpressions by clicking in the grid area and selecting the appropriate cells in the Table Filter Properties form.

Selecting a logical operator in the And/Or and Not columns and then clicking it toggles the logical operator except for the first AND operator, which cannot be changed. Selecting a condition-name in the Condition column and then clicking on the arrow displays the list of condition-names from which a different condition-name may be selected.

Note To remove a filter expression, click Clear Filter on the Table Filter Properties form toolbar.

9. Click Close on the toolbar or Close on the title bar to close the Table Filter Properties form.


Edit a table filter

1. Click Edit Table Filter on the Table form toolbar. The Table Filter Properties form opens.

2. Change a condition-name by selecting it in the Condition column and then clicking the arrow to display the list of condition-names from which a different condition-name may be selected.

3. Change a logical operator AND or OR by selecting it in the And/Or column and then clicking it to toggle the logical operator.

Note The first logical operator must be AND; it cannot be changed by clicking on it.

4. Change a logical NOT operator (or its absence) by selecting it in the Not column and then clicking it to toggle the logical operator.

5. If the filter expression needs to be removed, click Clear Filter on the Table Filter Properties form toolbar. Use the procedure on how to define a table filter to add any filter subexpressions needed after clearing the filter.

Note If you want to shorten a filter expression by removing a filter subexpression, you must remove the entire filter expression.

6. Click Show Filter on the Table Filter Properties form toolbar to review an algebraic representation of the edited filter expression.

7. Click Close on the toolbar or Close on the title bar to close the Table Filter Properties form.


Defining Transforms on Columns

See Also

A transform is used to "transform", or convert, an existing data item value to and/or from a relational database column value. Transforms can be applied to the data item in the FD or at the column level (as described here).

If the transform is applied at the column level, only those columns with the transforms will be affected. A transform should be applied at the column level only when the data item sometimes needs to be transformed and other times not.

To define a transform on a column, follow these procedures:

1. Select a column name from the Column Name attribute in the expanded Table form.

2. In the Column Properties area of the Table form, select the transform you want to apply from the list in the Transform property.


Previewing Table Data

See Also

During the design and testing of a table definition, it is often necessary to verify the effect of a change or overall table design. The Show Table Contents form allows you to display table data in a grid so that you can see that the results are what you expected.

For procedures on how to preview data from the Table form, click here.

Note Previewing the table data is also very helpful in detecting and resolving any errors that may have occurred.


Preview table data from the Table form

1. Click Show on the Table form toolbar. The Show Table Contents form opens.

· If the Show button appears dimmed and is unavailable, then no table connection exists. See Establishing Table Connections for procedures on how to create a table connection before proceeding.

· If a table definition name opened in the Table form has more than one table connection pointing to it, none of which match the table definition name, the Select Table Connection to Show dialog box opens on top of the Show Table Contents form and displays options for selecting from the multiple table connections. Select the table definition from the list and click the Select button.

Note Alternatively, you can click Edit Connections on the Table form toolbar to display the Edit Connections form, select the desired table connection to be shown, and then click Show on the Edit Connections form toolbar.

2. Examine the displayed data in the form.

3. Click Close on the Show Table Contents form toolbar to dismiss the preview.

If none of the column definitions for the table are selected, the Show Table Contents form will retrieve and display all columns defined. If one or more of the column definitions are selected, the Show Table Contents form will display only those columns whose definitions are selected. Tip


Analyzing Table Definition Errors

See Also

The nature of table design and testing is likely to produce occasional table definition errors. If Relativity encounters these types of errors, a message box will display a detailed error message. This error process may also be triggered by file and/or table definition errors that interfere with Relativity’s ability to correctly create an adequate table structure.

If the file and table definitions do not describe the data actually in the COBOL file correctly, the Show Table Contents form may display rows that have no data values in the grid cells. The following is a partial list of some typical situations where this might occur:

· Nonnumeric data in an area described as numeric. The solution for this might involve defining or editing a record type filter to prevent incorrect physical records from generating rows. Otherwise, the fault might be in the actual data description.

· A transform (typically a date transform) that is attempting to transform invalid data. If several columns are being displayed, narrow the number of columns being displayed to aid you in determining the column causing the data error. Tip


Building Writable Tables

See Also

Contents of data files created by COBOL applications may be modified by using the INSERT, DELETE, and UPDATE statements of ODBC SQL. In order for Relativity to support these SQL statements and make Relativity tables writable, the Relativity Designer must follow several rules when defining tables and their association with COBOL application files. If these rules are not followed, tables built with the Relativity Designer can only be read.

Many of the rules will be enforced at design-time by the Relativity Designer. Others will be detected and enforced when an attempt is made to actually modify database tables. Restrictions beyond those imposed by the RDBMS may be intentionally imposed by the Relativity Designer using the Relativity security features. Note that defining the Relativity security and privilege capabilities becomes much more important when the end-user of the database can modify data files.

The rules fall into two general categories: those for determining whether or not rows can be inserted into and deleted from a particular table (see Rules for Insertable Tables), and those for determining whether or not a particular column in an existing row can be updated through SQL (see Update Rules).

For more information on building writable tables, choose from the following topics:

· Defining Insertable Tables

· Building a New Record

· Determining Occurrence Count

· Determining Record Type

· Modifying an Existing Record

· Using the Nullable Column Utility


Defining Insertable Tables

See Also

Relativity uses a set of rules for insertable tables to assert that a table is insertable. The rules for insertable tables are a list of rules that must be followed so that an SQL INSERT statement can be used to create the underlying COBOL data record based on the information provided in the INSERT statement. The SQL INSERT statement specifies column values for one or more columns, not necessarily all columns of the table. For columns not specified in the INSERT statement, NULL is implied, which means that columns not specified must be nullable.

The Relativity DBMS must create a COBOL data record that would generate the new row implied by that SQL INSERT statement. Since the relational table derived from the COBOL record may not have columns based on all the data items in the record, the Relativity DBMS must be able to synthesize values for all those data items not represented in a relational row of the table.

This synthesis is accomplished through various, sometimes subtle, means. The most obvious method is default values for columns or data items. More subtle methods are those based on making table filters and record type predicates true by setting appropriate values from condition-names into their conditional variables in the data record. The rules for insertable tables guarantee that the Relativity DBMS can derive a value for every data item in the inserted data record, given the partial information provided in the column values specified in the INSERT statement. Relativity allows SQL DELETE statements only if the table is marked as an insertable table.

A table in which one of the following techniques will work is, therefore, insertable. These techniques include:

· How the Relativity DBMS builds a record.

· List of Rules for Insertable Tables.

· Finally, for the vaguely defined SQL rules, some techniques are listed by which the Relativity DBMS may perform some of these actions (for example, Determining Record Type and Determining Occurrence Count).

Note A table definition with no associated record types is treated as having a single record type that includes all data items in the file definition.


Building a New Record

See Also

When performing an SQL INSERT statement, Relativity needs to construct a new COBOL record. It needs to determine the length of the new record and the value of every byte in the new record. The resulting record must be a valid record for the file to which it is to be written. It must also produce a row of the table on which the INSERT statement is operating.

To be a valid record, the record must “look like” one of the record types that a COBOL application might write to the file. It must have the correct length, and all data items which would be set by a COBOL application should be set by the INSERT statement. All variable-occurrence repeating data items must have occurrence counts that are between the minimum and maximum values.

To produce a row of the table means that the record must satisfy the table filter, if any, and also the record type filter for one of the record types on which the table is defined. The user would also expect that the column values returned from a SELECT statement of this row would match the column values supplied on the INSERT statement, except that columns omitted from the INSERT statement may have null or default values.

Note The Constrained property in the Data Types form limits the value that a column may have during an SQL INSERT or SQL UPDATE operation to one of the true values indicated by an 88-level condition-name defined on the data item associated with the column. The user may add condition items if the program does not have them.

The Relativity DBMS will select a record type (if the table is defined on multiple record types) and use the single 01-level item in that record type. This item will determine the record length and record layout. All areas of the record not covered by items in the record type will be set to spaces. Items belonging to the record will receive values as follows:

· If a column is associated with a data item, the data item will receive its value from the column, either a user-specified column value or the column’s default value.

· If no column is associated with an item, and if the table filter or record type filter determines a single value for an item, the item will be set to the value so determined. See the discussion of filters in Determining Record Type for more information about how a filter determines an item value.

· If no column is associated with a data item but the data item has a default value, the item will be set to its default value.

· If an item receives no value by any of the above means, the item will be set to zero if it is numeric. Nonnumeric items will not be set explicitly; the record area will be initialized to spaces before any items are set.

In addition, an item may receive a value indirectly, as follows:

· When a value is stored in a writable function item, the function stores in one or more of the arguments.

· If a column is associated with an item that has an associated null condition-name, when the column value is stored, the conditional variable data item associated with the null condition-name must also be set appropriately.

· If necessary, the Relativity DBMS may set values in unset items to force the table filter and record type filter expressions to be "true".


Rules for Insertable Tables

See Also

The following statements describe the conditions that a table definition and its associated file definition must obey for instances of the table definition to be considered “insertable.” To be insertable means that SQL INSERT and DELETE statements are allowed to operate on the table. Examples are also provided to illustrate each of the rules.

Rule

Description

Subscript

For writable tables, this rule means that no column may be defined on a subscript item. Example

Repeating Item

For writable tables, this rule means that no column may be defined on a repeating data item unless all of the item’s subscripts are bound to constants. Note that this does not prohibit columns defined on variable-length groups. It also does not say that a column must be bound to every occurrence of a repeating data item. Example

OCCURS

For writable tables, it must be possible for the Relativity DBMS to determine the value of every "OCCURS … DEPENDING ON" control item (ODO control item); that is, the occurrence count must be determined. Example

Same Item

For writable tables, no two columns may be defined on the same item or on overlapping items within the same record type. Example

Record Type

For writable tables, when a table is defined on multiple record types, it must be possible for the Relativity DBMS to determine the correct record type to use when inserting each record. Example

Only One 01

For writable tables, unless all of the columns in a table are bound to items that are located in the same 01-level item, each record type on which a table is defined must explicitly contain exactly one item at the 01 level. This 01-level item determines the length of inserted records which use that record type unless the file definition includes a record size working-storage item. Example

Overlap

For writable tables, in each record type on which a table is defined, none of the elementary data items may overlap except in the case of explicit redefinition within the same 01 record description. That is, an overlap may not occur for elementary data items described in different 01 record descriptions as a result of implicit or explicit redefinition, regardless of whether a column is bound to either or both of the overlapping items. Example

Null Condition

For writable tables, for every item in each record type on which the table is defined, each item’s null condition-name (if defined) must have a “SET TO FALSE” value, unless the null condition-name is defined on the data item. "SET TO FALSE" is an optional COBOL phrase for a condition-name. Relativity supports "SET TO FALSE" through the Add Condition Item dialog box. Example

Filter

For writable tables, it must be possible for the Relativity DBMS to ensure, for the table filter and for each record type filter, that the filter expression is true. This may require that some condition-names have “SET TO FALSE” values. Example

Key

For writable tables, during an insert, values for unique keys must be determined. This does not require that a column be defined for all of the items in every key. Nor does it preclude part of the key from using default values, or part of the key being defined in the filter. It is also allowable not to have any part of the key defined. This could happen if you have a key that used spaces as a valid value for some form of counter or header record. This would allow only one insert, but would be valid for updating. Some front-end tools may have different requirements. As an example, Microsoft Access wants to be able to determine a unique index before it will allow updates or inserts in datasheet view. Example

Nullable Columns

For writable tables, any column that is going to store a null value must have a null condition-name. If you have a table with multiple record types it is possible to mark columns as nullable without an underlying null condition-name. This supports the case where the item upon which the column is based is not part of the record type being written for a particular INSERT statement or for a numeric item that is set to return a null value if it contains non-numeric data. Setting a column as nullable does not by itself allow a null value to be stored. It is safer to assign a null condition-name to any item that might receive a null value. If you mark a column as nullable without having a null condition-name, and a null value is written, the write operation will fail with an error. Example

Note The Nullable Column utility provides a way to determine the status of null information and change certain settings if desired. The utility also allows you to process all tables in a data source or only a selected group of tables.


Subscript Rule

See Also

For writable tables, no column may be defined on a subscript item.

In this example, neither of the highlighted items (SubscriptItem) may be moved to a table and still have that table be writable. The subscript items do not really exist in the underlying COBOL data file. If you need to view subscript items, consider creating a table for retrieving data and a separate table for writing. The separate table for writing must not include any repeating data items with unbound subscripts.


Repeating Item Rule

See Also

For writable tables, no column may be defined on a repeating data item unless all of the item’s subscripts are bound to constants. Note that this does not prohibit columns defined on variable-length groups. It also does not say that a column must be bound to every occurrence of a repeating data item.

This example shows how all of an item's subscripts can be bound. The data item, SF-QUANTITY-SOLD-PER-MONTH, has condition-names set for each value that the subscript can contain. In this case the values are 1 through 12. See the Bind Subscripts form for more details on how subscripts are bound.


OCCURS Rule

See Also

For writable tables, it must be possible for the Relativity DBMS to determine the value of every "OCCURS … DEPENDING ON" control item (ODO control item); that is, the occurrence count must be determined.

The following example uses an OCCURS DEPENDING ON:

03 NUMBER-OF-STYLES PIC 99.
03 STYLE-STORAGE OCCURS 1 TO 9 TIMES
DEPENDING ON NUMBER-OF-STYLES
INDEXED by STYLE-I1
05 FIELD-A ...
05 FIELD-B ...
03 FIELD-C ...

Some application files describe data arrays with an OCCURS clause without the DEPENDING ON phrase. However, the files have uninitialized or otherwise invalid data in some of the occurrences.

Because of the limitations on the use of the DEPENDING ON phrase, the COBOL Procedure Division statements test the data item NUMBER-OF-STYLES to limit the occurrences used. If this is the case, the DEPENDING ON item must be identified.


Same Item Rule

See Also

For writable tables, no two columns may be defined on the same item or on overlapping items within the same record type.

Relativity prohibits this situation because the information written would not be the same information retrieved on a subsequent read. Consider if you had two columns defined on PF-PRICE-PER-UNIT. A value of 12.95 was placed in one column, and 13.95 in the other column. This row was then inserted into a table. If you were to immediately read that same row, there would be no way to return 12.95 and 13.95 to the columns, since only one COBOL record was written.


Record Type Rule

See Also

For writable tables, when a table is defined on multiple record types, it must be possible for the Relativity DBMS to determine the correct record type to use when inserting each record.

This is only an issue if multiple record types are assigned to the same table. In this example, the table is defined on the record types: CashSales, CreditSales, and Freight.

Relativity must be able to determine from the filters and data provided which record type was intended to be written to. The assumption is that only one of the record types will be valid.


Only One 01 Rule

See Also

For writable tables, unless all of the columns in a table are bound to items that are located in the same 01-level item, each record type on which a table is defined must explicitly contain exactly one item at the 01 level. This 01-level item determines the length of inserted records which use that record type unless the file definition includes a record size Working-Storage Section item.

This example shows multiple 01-level items included in the same record type (BACK-ORDER-RECORD and DISCONTINUED-RECORD). A table that contained this record type could not be written to unless all of the columns were derived from items that all belonged to BACK-ORDER-RECORD, or all were derived from items that belonged to DISCONTINUED-RECORD. This is the only way that the correct 01 level could not be selected for the COBOL WRITE or REWRITE. A simple rule to follow for writable tables is to define a record type for each level 01.

This rule does not imply that the 01 Level that is part of the record type must be part of the table. Adding a 01 Level to a table with any other items will probably violate the Same Item Rule.


Overlap Rule

See Also

For writable tables, in each record type on which a table is defined, none of the elementary data items may overlap except in the case of explicit redefinition within the same 01 record description. That is, an overlap may not occur for elementary data items described in different 01 record descriptions as a result of implicit or explicit redefinition, regardless of whether a column is bound to either or both of the overlapping items.


Null Condition Rule

See Also

For writable tables, for every item in each record type on which the table is defined, each item’s null condition-name (if defined) must have a “SET TO FALSE” value, unless the null condition-name is defined on the data item. "SET TO FALSE" is an optional COBOL phrase for a condition-name. Relativity supports "SET TO FALSE" through the Add Condition Item dialog box.

In this example, the data item, SF-STYLE, has a null condition-name. The null condition-name (STYLE-NULL-CONDITION) must have a "SET-TO-FALSE" value if it is to be included in a record type that will be written to. This is necessary so that the value for SF-PRODUCT-SIZE will be known if there is no column defined for it, and the value for the column defined on SF-STYLE is not null. If the value were null, the value for the null condition-name would be used; if the value is not null, the "SET-TO-FALSE" value is used.


Filter Rule

See Also

For writable tables, it must be possible for the Relativity DBMS to ensure, for the table filter and for each record type filter, that the filter expression is true. This may require that some condition-names have “SET TO FALSE” values.

In this example, the 88-level condition-name items BACK-ORDER and DISCONTINUED must both be false in order for a write to the record type PRODUCTS. The PF-PRODUCT-CATEGORY data item (on which the 88-level condition-name items are defined) must be represented in the table, or have a default value that would set these 88-level condition-name items to false.


Key Rule

See Also

For writable tables, during an insert, values for unique keys must be determined. This does not require that a column be defined for all of the data items in every key. Nor does it preclude part of the key from using default values, or part of the key being defined in the filter. It is also allowable not to have any part of the key defined. This could happen if you have a key that used spaces as a valid value for some form of counter or header record. This would allow only one insert, but would be valid for updating. Some front-end tools may have different requirements. As an example, Microsoft Access wants to be able to determine a unique index before it will allow updates or inserts in datasheet view.

In this example, the data items, SF-PRODUCT-CATEGORY, SF-PRODUCT-ID, SF-STYLE, SF-PRODUCT-SIZE, and SF-COLOR, make up the primary key. All of these data items should be accounted for in any tables that will allow write operations. They may be accounted for as a column, as part of the record type filter, or as part of the table filter.

Note If a table allows inserts, the Write Support wizard will always flag missing key items as an issue. This is to ensure that the file's record key fields that should be defined in a table are not overlooked. If a table only allows updates, the Write Support wizard will only flag unique keys.


Nullable Columns Rule

See Also

For writable tables, any column that is going to store an SQL NULL value must have a null condition-name. If you have a table with multiple record types, it is possible to mark columns as nullable without an underlying null condition-name. This supports the case where the item upon which the column is based is not part of the record type being written for a particular INSERT statement or for a numeric item that is set to return a null value if it contains non-numeric data. Setting a column as nullable does not by itself allow a null value to be stored. It is safer to assign a null condition-name to any data item that might receive a null value. If you mark a column as nullable without having a null condition-name, and a null value is written, the write operation will fail with an error.

Note The Nullable Column utility provides a way to determine the status of null information and change certain settings, if desired. The utility also allows you to process all tables in a data source or only a selected group of tables.

In this example, the SF-PRODUCT-CATEGORY data item has a null condition-name. This allows the column ProductCategory to be nullable. If a write operation is executed on this table, Relativity will know what value to store in the COBOL data file if the column contains a null value.


Determining Occurrence Count

See Also

The occurrence count of every repeating data item must be determined each time a record is inserted. The Relativity DBMS will try the following:

· If a column is defined on the ODO control item, the value will be set explicitly on each INSERT statement. The column must either not be marked as nullable or have a default value.

· If a column is defined on a variable-length group that contains the repeating data item, the occurrence count will be computed from the length of the column value.

· If neither of the above applies, but the ODO control item has a default value, the item’s default value will be used.

Note One of these conditions must be applicable or the table is not insertable.


Determining Record Type

See Also

When a table is defined on multiple record types, the Relativity DBMS must determine the appropriate record type on each SQL INSERT statement. The technique by which the Relativity DBMS accomplishes this can be quite involved. It can be thought of as a process whereby the Relativity DBMS builds a record according to each record type and then tests the table filters and record type filters, until both of these filter expressions are true or until all of record types have been tried. In the latter case, the SQL INSERT statement will fail.

The Relativity DBMS may test both the value of a filter expression and set items to make the predicate true. To understand what the Relativity DBMS must do, it is necessary to review exactly what a filter expression is.

A filter expression consists of one or more factors connected with logical AND operators. Each factor consists of one or more filter subexpressions connected with logical OR operators. Each subexpression is either a condition-name or a logically complemented condition-name.

Therefore, for a filter expression to be true, each factor must be true. For a factor to be true, at least one of the subexpressions of the factor must be true. For a subexpression to be true, the condition-name must be either false or true, depending on whether it is complemented or not, respectively. A factor that consists of a single subexpression is a very special case since it requires that the condition-name in this subexpression be true or (if complemented) false. Thus, requiring that the filter expression be true may force particular values be stored in the data items on which such condition-names are defined. The Relativity DBMS may use that fact to determine the values of some items in the record.

The complemented condition-names in a predicate are a problem. Some, but not all, condition-names define a “SET TO FALSE” value. To set these condition-names to false, the Relativity DBMS can set the data item to the "SET TO FALSE" value. For other condition-names, the Relativity DBMS cannot determine any particular value to set; the value must be determined some other way.

As a result, if a filter expression contains factors with multiple subexpressions, or if some of the subexpressions are complemented condition-names that do not specify "SET TO FALSE" values, the Relativity DBMS cannot force the filter expression to be true. If the table definition and/or file definition do not provide some other means to cause the filter’s value to be "true", the filter expression may never be true. Under such conditions, it may not be possible to insert any rows in the table.

Lastly, some record types may be excluded from consideration by examining which columns are given values (not null), either explicitly or a column default. If a column is defined on an item that is absent in one or more record types, the column is null for any record with one of these record types. Therefore, if an INSERT statement sets a column to a (not null) value, these record types may be ignored; their filters need not be tested.

Note The Nullable Column utility provides a way to determine the status of null information and change certain settings if desired. The utility also allows you to process all tables in a data source or only a selected group of tables.


Modifying an Existing Record

See Also

Unlike SQL INSERT statements, SQL UPDATE statements do not create records. Therefore, the problems that the Relativity DBMS faces for an INSERT operation do not apply. As a general rule, the Relativity DBMS allows any table to be updated if the user marks it updatable in the Relativity Designer. Some restrictions on the columns that can be updated, however, do apply.

In particular, the Relativity DBMS allows updates to tables that contain columns defined on repeating data items. Note that such tables contain two sorts of columns:

1. Columns defined on repeating data items, which may be different on each row.

2. Columns defined on nonrepeating data items, when items are shared by several rows.

Therefore, an update to the latter sort of column would change multiple rows. The Relativity DBMS does not permit updates to the latter sort of column in such a table.

Hence, if a record contains both repeating and nonrepeating data items, the Relativity DBMS allows the user to update the nonrepeating data items via a table that has no columns defined on repeating data items, or to update the repeating data items via a table that has repeating data.

For more information on the rules that apply to updating existing records, click here.


Update Rules

See Also

The following rules apply to SQL UPDATE operations when modifying an existing record in Relativity:

· A column is not updatable if it is defined on a subscript item.

· If any column is defined on a repeating data item with unbound subscripts, then the only columns that are updatable are those defined on repeating data items with the same unbound subscripts.

· A column is not updatable if it is associated with a data item that overlaps the file’s primary key.

· A column is not updatable if it is associated with a data item that overlaps the file key which the Relativity DBMS is using and if the file’s primary key permits duplicates.

· A column is not updatable (or insertable, for that matter) if it is a date type (not a date-time type) and it specifies a date-time transform function or it is defined on a data item that specifies a date-time transform function.


Using the Nullable Column Utility

See Also

The Nullable Column utility is helpful in choosing and applying the nullable settings for all numeric and date columns in your Relativity catalog. A nullable column is one that may be null. Null is not a value; it indicates the absence of a value. Since the rules of ODBC dictate that an error be returned if a numeric column contains non-numeric data, nullable settings can affect which columns can participate in an index and also the outcome of SQL UPDATE and INSERT operations.

Note Refer to the following topics in the Relativity DBMS Help file for more information about nullable settings:

· Relativity Indexes (under the For Advanced Users | Relativity-Specific topic)

· INSERT Statement Processing (under the For Advanced Users | Write Support topic)

· UPDATE Statement Searched (under the For Advanced Users | Write Support topic)

Two global data source settings in the Relativity Designer affect nullable columns: Invalid Numerics Return NULL and Invalid Dates Return NULL. These two attributes are configured on the Data Source page of the Options dialog box. These settings also can be set or changed using the Nullable Column utility.

For information on how to run this utility, click here.


Run the Nullable Column Utility

1. In the Relativity Designer window, click Nullable Column Utility on the Tools menu.

2. On the Welcome page, click Next.

3. On the Settings page, you can change global catalog settings that determine when NULLs are retuned for certain invalid data. The current settings for the data source, which were established on the Data Source page of the Options dialog box, are displayed in the upper portion of the page. Click the down arrow in either list box to change these settings:

· The Invalid Numerics Return NULL option indicates that the Relativity DBMS will return a NULL value for any column based on a data item containing invalid numeric data. There are three possible states that may be selected for this option:

-  Select Never to cause the DBMS to return an error when this condition is encountered. This is the default.

-  Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

-  Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.

· The Invalid Dates Return NULL option indicates that the Relativity DBMS will return a NULL value for any date or date/time column based on a data item containing invalid date ranges either because the underlying numeric data is invalid, or the month or day is out of range. There are three possible states that may be selected for this option:

-  Select Never to cause the DBMS to return an error when this condition is encountered. This is the default.

-  Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

-  Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.

4. Continuing on this page, determine whether you want to view a report containing only the results of changing these settings, apply the settings without a report, or view a report and then (optionally) apply the settings.

Finally, select either all the tables or a group of tables in the data source to process and then click Next.

5. On the Options page, choose whether to mark as nullable only those columns that do not participate in an index or all columns, including those columns that do participate in an index. For more information on indexes, refer to "Relativity Indexes" under the For Advanced Users | Relativity-Specific topic in the DBMS Help file.

Then, click Next.

CAUTION You may lose indexes depending on your settings for the Invalid Numerics Return NULL and the Invalid Dates Return NULL options.

6. If you chose the Select Tables to Process option on the Settings page, the Table Selection page is displayed, prompting you to select the appropriate tables. Make your selection(s) and click Next.

7. On the Summary page, a list of all the options you selected is displayed. Press Finish to start the process.

8. A Status Report window, which displays actions taken and explains why some actions were not taken, opens.

If, in step 4, you chose to apply the settings rather than simply review a report, you will be prompted with a message to confirm whether you want to update the data source with changes.


Establishing Table Connections

See Also

Relativity must know the physical access name information (that is, the table connection) for the COBOL file that contains the actual data. The table connection consists of two important items:

1. The path name (that is, the physical COBOL file-name) of a COBOL data file. For more information about how Relativity determines which indexed file format to request when opening a Micro Focus COBOL data file, click here.

2. The table name by which SQL statements can reference the data in the file.

Note Should file labels be in effect, the table connection also includes the name of the file label associated with the table connection.

Relativity distinguishes between the name of a table definition and the actual SQL table name. The table definition is manipulated in the Table form and is normally called a table within the Relativity Designer. Thus, several physical files that share the same COBOL file definition can be described by one Relativity table definition. The table connection is what an ODBC-enabled application actually "perceives" as a relational table.

In the Relativity Designer, table connections are established in the Edit Connections form. The Edit Connections form enables you to design and test a single table definition as well as change large numbers of table connections at one time.

Note When a new table definition is added, a default table connection having a table name that is the same as the table definition name is created using the path name associated with the file definition, if there is one. When a table definition is renamed using the Rename command on the Table menu, an option is also provided to modify the table name in such a table connection.

For more information and procedures on how to work with table connections, choose one of the following topics:

· Create a table connection from the Table form.

· Display table connections for one table definition.

· Add a table connection.

· Delete a table connection.

· Edit selected table connections.

· Add table connections with matching patterns.

· Delete table connections with matching patterns.

· Edit table connections with matching patterns.

· Exit the Edit Connections form.

· Print Connections report.

► Related Topic Relativity supports a set of stored procedures, identified with the prefix, DBA-, only if the user is the owner or a database administrator of the Relativity catalog. The DBA stored procedures deal with table definitions, table connections, and file names. All of the stored procedures are ODBC driver-specific. For more information, see "Stored Procedures" under the For Advanced Users | Relativity-Specific topic in the Relativity DBMS Help file.


Create a table connection from the Table form

1. Click Edit Connections on the Table form toolbar. The Edit Connections form opens.

When the Edit Connections form is opened from the Table form, it displays only the associated table connections for the selected Relativity table definition (that is, the table name, path name, and file label, if file labels are in effect). By default, the table name is selected in the hierarchical list. To view an example, click here.

Note Alternatively, you can right-click a selected column in the Table form and click Edit Connections from the pop-up context menu.

2. Select the table definition (that is, the leftmost item in the list) and then click Add Table Connection on the Edit Connections form toolbar. The Add Table Connection dialog box is displayed.

3. In the Table Name box, type a new table name of the SQL table to be associated with the table connection being added to the selected table definition.

4. In the Path Name box, type or select the path name from the list.

5. In the File Label box, type or select the file label from the list.

Note This box appears only if a file label item has been added to the FD on which this table is based. For more information, see Supporting Multi-File Tables.

6. Click Add Connection to accept the table name, the path name, and the file label, if one exists. The Edit Connections form is displayed with the new table connection entry. To view an example, click here.

7. On the Edit Connections form, click Save Changes.

8. To view the data in the table connection, select a table name from the hierarchical list and click Show. The Show Table Contents form is displayed.

9. Click Close to dismiss the data preview and exit this form, and return to the Edit Connections form.

10. Click Close to exit the Edit Connections form.


Display table connections for one table definition

1. On the Security menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all the currently existing table definitions for the catalog (to view an example, click here). Note that each item in this hierarchical list is preceded by a plus sign [+].

2. Select a table definition from the list and do the following:

· Click the plus sign [+] to display the table name(s).

· Click the plus sign [+] preceding the table name(s) to display the path name(s) and file label(s), if file labels are in effect.

The table names, path names, and file labels, which form the existing table connection(s) for the selected table definition, are displayed in the expanded list. To view an example, click here.

Note Alternatively, you can take any of the following actions to open the Edit Connections form:

· Select the table definition of interest from the Tables catalog object in the Catalog window and then click Connections.

· Select the table definition of interest from the Tables catalog object in the Catalog window and then click Open to display the Table form. Take one of the following steps:

-  On the Table form toolbar, click Edit Connections.

-  In the Table form, right-click a selected column definition and click Edit Connections from the pop-up context menu.

When any of these alternative methods are used, the Edit Connections form displays only the associated table connection(s) of the selected table definition. By default, the table name is selected in the expanded hierarchical list. To view an example, click here.


Add a table connection

1. On the Security menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all the currently existing table definitions for the catalog (to view an example, click here). Note that each item in this hierarchical list is preceded by a plus sign [+].

2. Select a table definition from the list.

3. Click Add Table Connection on the Edit Connections form. The Add Table Connection dialog box is displayed.

4. In the Table Name box, type the new table name. For example, type CustomerBudget to indicate the customer file having the budget shirts.

5. In the Path Name box, type or select the path name from the list.

6. In the File Label box, type or select the file label from the list.

Note This box appears only if a file label item has been added to the FD on which this table is based. For more information, see Supporting Multi-File Tables.

7. Next, do one of the following:

· To accept the table name, path name, and file label (if one exists) in the Add Table Connection dialog box, click Add Connection. A new table connection for the table definition is displayed in the Edit Connections form.

Note All the changes that have been made are displayed in bold text in the Edit Connections form until they are saved.

· If you do not want to accept the entries, click Cancel on the Add Table Connection dialog box to cancel all selections and close the dialog box.

8. On the Edit Connections form, click Save Changes.

9. Click Close to exit the Edit Connections form.

Note Alternatively, you can take any of the following actions to open the Edit Connections form:

· Select the table definition of interest from the Tables catalog object in the Catalog window and then click Connections.

· Select the table definition of interest from the Tables catalog object in the Catalog window and then click Open to display the Table form. Take one of the following steps:

-  On the Table form toolbar, click Edit Connections.

-  In the Table form, right-click a selected column definition and click Edit Connections from the pop-up context menu.

When any of these alternative methods are used, the Edit Connections form displays only the associated table connection(s) of the selected table definition. By default, the table name is selected in the expanded hierarchical list. To view an example, click here.


Delete a table connection

1. On the Security menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all the currently existing table definitions for the catalog (to view an example, click here). Note that each item in this hierarchical list is preceded by a plus sign [+].

2. Select a table definition and click the plus sign [+] preceding the table definition to expand the list and display the table names and path names of the existing table connections for the selected table definition.

3. Select a one or more table connection to be deleted. Tip

4. Click Delete Table Connection on the Edit Connections form to delete the table connection (that is, the table name and the path name.

Alternatively, you may right-click the table name and choose the Delete Table command from the pop-up context menu.

Note If the table connection being deleted is the only connection using a particular file path name, a message box will be displayed asking if the file connection should be deleted. Click Yes if you do not expect to use that file path name for a table connection to be added later. Click No if you would like the file path name to be available in the list for the Path Name box in the Add Table Connection dialog box for later use in adding a table connection.

5. Repeat this procedure for each table connection you wish to delete.

6. On the Edit Connections form, click Save Changes.

7. Click Close to exit the Edit Connections form.

Note Alternatively, you can take any of the following actions to open the Edit Connections form:

· Select the table definition of interest from the Tables catalog object in the Catalog window and then click Connections.

· Select the table definition of interest from the Tables catalog object in the Catalog window and then click Open to display the Table form. Take one of the following steps:

-  On the Table form toolbar, click Edit Connections.

-  In the Table form, right-click a selected column definition and click Edit Connections from the pop-up context menu.

When any of these alternative methods are used, the Edit Connections form displays only the associated table connection(s) of the selected table definition. By default, the table name is selected in the expanded hierarchical list. To view an example, click here.


Edit selected table connections

1. On the Security menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all the currently existing table definitions for the catalog (to view an example, click here). Note that each item in this hierarchical list is preceded by a plus sign [+].

2. Select a table definition for which a path name is to be edited.

If you would like to expand the list and view the table connection(s) associated with the selected table, click the plus sign [+] preceding the table definition to display the table name(s). Click the plus sign preceding the table name(s) to display the path name(s) and file label(s), if file labels are in effect.

3. Click Edit Table Connection on the Edit Connections form. The Edit Selected Table Connections dialog box is displayed.

4. In the Path Name Replace box, type the path name that is to be replaced, or enter a character pattern to match within the path names (for example, *.*).

5. In the Path Name With box, type the characters within the path name that are the replacement characters for the character pattern matched in the Path Name Replace box.

6. If file labels are in effect, do the following:

a. In the File Label Replace box, type the file label that is to be replaced, or enter a character pattern to match within the file labels.

b. In the File Label With box, type the characters within the file label that are the replacement characters for the characters matched in the File Label Replace box.

c. Select the AND option to make replacements if the contents of both the Path Name Replace and File Label Replace boxes match an individual table connection. Or, select the OR option to make replacements if the contents of either the Path Name Replace or File Label Replace boxes match an individual table connection.

Note A File Label area may appear in the Edit Selected Table Connections dialog box if a file label item has been added to the FD on which the table is based. For more information, see Supporting Multi-File Tables.

7. Next, do one of the following:

· To accept the entries made in the Edit Selected Table Connections dialog box, click Edit Connections.

Note All the changes that have been made are displayed in bold text in the Edit Connections form until they are saved.

· If you do not want to accept the entries, click Cancel on the Edit Selected Table Connections dialog box to cancel all selections and close the dialog box.

8. On the Edit Connections form, click Save Changes.

9. Click Close to exit the Edit Connections form.

Note Alternatively, you can take any of the following actions to open the Edit Connections form:

· Select the table definition of interest from the Tables catalog object in the Catalog window and then click Connections.

· Select the table definition of interest from the Tables catalog object in the Catalog window and then click Open to display the Table form. Take one of the following steps:

-  On the Table form toolbar, click Edit Connections.

-  In the Table form, right-click a selected column definition and click Edit Connections from the pop-up context menu.

When any of these alternative methods are used, the Edit Connections form displays only the associated table connection(s) of the selected table definition. By default, the table name is selected in the expanded hierarchical list. To view an example, click here.


Add table connections with matching patterns

1. On the Security menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all the currently existing table definitions for the catalog (to view an example, click here).

Note A printed report of existing table connections may be helpful in completing the steps of this procedure. See Reporting for information on how to print a report of table connections.

2. Select a table definition and then click the plus sign [+] to expand the list of tables to display the table name(s) of the table connection(s) associated with the selected table.

3. Click Global Add on the Edit Connections form. The Add Connections Matching Pattern dialog box is displayed.

4. In the Connection Selection Options area, select the Match Table Name check box to specify replacement of matching patterns in the table names of table connections.

In the text box, type a character or characters to specify the matching pattern for the table names of the table connections that are to be added in the Edit Connections form. Leave the Match Table Name text box empty to match all table names.

5. In the Connections Selection Options area, select the Match Path Name check box to specify replacement of matching patterns in the path names of table connections.

In the text box, type a character or characters to specify the matching pattern for the path names of the table connections that are to be added in the Edit Connections form. Leave the Match Path Name text box empty to match all path names.

6. If the Match Table Name check box is selected in Step 4, follow these steps:

a. In the Table Name Replace box, type the matching pattern for the table names that are to be replaced when a table name for the new table connection is generated. For example, typing the two characters ^^ will define a null match at the end of the table name.

b. In the Table Name With box, type the characters that are to replace the characters matching the pattern specified in the Table Name Replace box. For example, typing the characters Budget will define the pattern to be inserted at the end of the matched table names.

7. If the Match Path Name check box is selected in Step 5, follow these steps:

a. In the Path Name Replace box, type the matching pattern for the path name that is to be replaced when a path name for the new table connection is generated. For example, typing the one character ^ will define a null match at the beginning of the path name.

b. In the Path Name With box, type the characters that are to replace the characters matching the pattern specified in the Path Name Replace box. For example, typing the characters budget\ will define the pattern to be inserted at the beginning of the matched path names.

8. Next, do one of the following:

· To accept the selections and entries in the Add Connections Matching Pattern dialog box, click Add Connections.

A Status Report dialog box is displayed, which shows a record of the action just taken. For example, the report will contain a diagnostic if a duplicate (non-unique) or an invalid table name is generated for one of the new table connections. In such cases, the offending item will not be added. To accept the changes, click the Close button. (Each Status Report dialog box also allows you to save and print this information.)

· If you do not want to accept the entries, click Cancel on the Add Connections Matching Pattern dialog box to cancel all selections and close the dialog box.

9. On the Edit Connections form, click Save Changes.

10. Click Close to exit the Edit Connections form.


Delete table connections with matching patterns

1. On the Security menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all the currently existing table definitions for the catalog (to view an example, click here).

Note A printed report of existing table connections may be helpful in completing the steps of this procedure. See Reporting for information on how to print a report of table connections.

2. Select a table definition and then click the plus sign [+} to expand the list and display the table name(s) of the table connection(s) associated with the selected table.

3. Click Global Delete on the Edit Connections form. The Delete Connections Matching Pattern dialog box is displayed.

4. In the Connection Selection Options area, select the Match Table Name check box to specify matching on the table names of table connections.

In the text box, type a character or characters to specify the matching pattern for the table names of the table connections that are to be deleted.

5. In the Connection Selection Options area, select the Match Path Name check box to specify matching on the path names of table connections.

In the text box, type a character or characters to specify the matching pattern for the path names of the table connections that are to be deleted.

Note If Match Table Name and Match Path Name matching patterns are specified, table connections that match on either the table name or the path name are selected for deletion.

6. Next, do one of the following:

· To accept the entries in the Delete Connections Matching Pattern dialog box, click Delete Connections.

A Status Report dialog box is displayed, which shows a record of the action just taken. Click the Close button to dismiss the dialog. (Each Status Report dialog box also allows you to save and print this information.)

· If you do not want to accept the entries, click Cancel on the Delete Connections Matching Pattern dialog box to cancel all selections and close the dialog box.

7. On the Edit Connections form, click Save Changes.

8. Click Close to exit the Edit Connections form.


Edit table connections with matching patterns

1. On the Security menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all the currently existing table definitions for the catalog (to view an example, click here).

Note A printed report of existing table connections may be helpful in completing the steps of this procedure. See Reporting for information on how to print a report of table connections.

2. Select a table definition and then click the plus sign [+} to expand the list and display the table name(s) of the table connection(s) associated with the selected table.

3. Click Global Edit on the Edit Connections form. The Edit Connections Matching Pattern dialog box is displayed.

4. In the Connection Selection Options area, select the Match Table Name check box to specify matching on the table names of table connections.

In the text box, type a character or characters to specify the matching pattern for the table names of the table connections that are to be edited.

5. In the Connection Selection Options area, select the Match Path Name check box to specify matching on the path names of table connections.

In the text box, type a character or characters to specify the matching pattern for the path names of the table connections that are to be edited.

Note If Match Table Name and Match Path Name matching patterns are specified, table connections that match on either the table name or the path name are selected for potential editing. Only table connections having a path name matched by the Path Name Replace matching pattern operation will be edited.

6. In the Path Name Replace box, type the matching pattern to define the character string to be replaced in the path name.

7. In the Path Name With box, type the characters that are to replace the characters matching the pattern specified in the Path Name Replace box.

8. Next, do one of the following:

· To accept the entries in the Edit Connections Matching Pattern dialog box, click Edit Connections.

A Status Report dialog box is displayed, which shows a record of the action just taken. To accept the changes, click the Close button. (Each Status Report dialog box also allows you to save and print this information.)

· If you do not want to accept the entries, click Cancel on the Edit Connections Matching Pattern dialog box to cancel all selections and close the dialog box.

9. On the Edit Connections form, click Save Changes.

10. Click Close to exit the Edit Connections form.


Exit the Edit Connections form

· On the Edit Connections form toolbar, click Close to exit the Edit Connections form.


Print Connections report

1. On the Reports menu, choose Print and then click Connections to display the Select Connections Report dialog box.

2. Select a report definition file from the List area. The name and a thumbnail version of the report will be displayed in the Preview area.

The recommended selection is the contab1.rcl file, which has the description of the Connections by Table Name report.

3. Click Open to display the Print Options dialog box.

4. Adjust the print options, if necessary.

5. Click Start to obtain a printed copy of the selected Connections report.

Note See Reporting for more information on other reports that can be printed.


Supporting Multi-File Tables

See Also

Multi-file table support allows the records of more than one COBOL file to be combined to constitute the rows of a single table. This feature supports COBOL applications that have data from several different business units stored in different COBOL data files on the same machine. The same COBOL application manipulates the data files, but the application programmatically selects the set of files from which it accesses the COBOL data. (This may be done simply using environment variables, or by manipulating the access name in the file control entry before the file is opened.) Typically, the files are placed in different directories, with each directory representing the data for one business unit. It is also possible to place the files in the same directory and use a naming convention to distinguish the various business units.

Relativity allows individual table connections to the different files of the various business units. Although based on the same table definition, each table connection has a different table name that must be used in the SQL statement to indicate which data file is to be accessed. Sometimes, however, it is desirable to query the data in all business units. While it is possible to use separate table connections and to combine the resulting rows in the ODBC application, Relativity uses multi-file table support to perform this process automatically and at a record level, making use of the file keys.

The combining of records can occur in one of two ways. Either the records from each individual file are processed into rows separately, with each file being processed completely before proceeding to the next file, or the records from the individual files are read using the same key on each file and merged into one sorted record stream as if they were from a single file.

To control which method to use, and, in the ODBC application, to be able to distinguish the business unit from which the row originated, a special file definition item called a "file label" is added to the file’s FD using the Designer. A given FD may have only one file label item. A file label item can have a column defined on it, and this column will be part of the indexes defined on the table. Assuming that columns are completely defined on all the file key parts, at least two indexes will be created for each file key: one with the file label column as the most significant part of the index, and one with the file label column as the least significant part of the index. If a query uses the index that has the file label column as the most significant column, then rows from each file will be grouped together. If a query uses the index that has the file label column as the least significant column, then the rows from each file will be returned merged together. For an example that illustrates the difference between grouping records and merging records based on an index, click here.

When a COBOL file is added to a multi-file table, it is assigned a value for its file label. This is the value that is returned in the file label column. Note that while it is usually desirable to assign the same file label value to all the files from the different business units, Relativity does not require or enforce this.

To enable multi-file support on a table, the following steps must be performed:

1. Add a file label item to the FD.

2. Create a column on the file label item.

3. Associate one or more files with a table connection.

Once multi-file support has been enabled, file label items and columns can be copied to (and deleted from) other FDs and tables. For more details on these procedures, click one of the following:

· Copying file label items and columns

· Deleting file label items and columns


Add a file label FD item

1. In the Catalog window, click the Files catalog object and open the FD to which the file label item is to be added.

2. In the FD form, position the mouse over the FD and click the right mouse button.

3. From the pop-up FD context menu, choose Add File Label.

Alternatively, you can choose this same command from the FD menu when focus is in the FD form.

4. In the Add File Label dialog box, type a name for the file label item in the Name box.

5. Select the type of the file label item from the Item Type list.

6. In the Length box, enter the maximum length of the value for the file label.

7. Click Add File Label to generate a file label item in the FD form.

8. On the FD form toolbar, click Save Changes to save the change to the file definition.

Next, follow the steps to create a column on the file label item.


Create a column on the file label item

1. In the Catalog window, click the Tables catalog object and open the table on which the file label column is to be added.

2. On the Table form toolbar, click Open FD.

3. In the FD form, select the file label item. It will be the last FD item on the form and will not have a level number.

4. Drag and drop the file label item from the FD form to the Table form.

5. In the Table form, edit the resulting column, if desired. The column name may be changed, or a column transform may be applied.

6. On the Table form toolbar, click Save Changes to save the change to the table.

Next, follow the steps to associate one or more files with a table connection.


Associate one or more files with a table connection

1. In the Catalog window, click the Tables catalog object and open the table with which the files are to be associated.

2. On the Table form toolbar, click Edit Connections.

3. On the Edit Connections form, the table connection with which to associate a new file will be displayed. (If necessary, click the plus sign(s) to display the path names and file labels.) The leftmost item in the hierarchical list represents the table definition.

4. Click Add Table Connection. The Add Table Connection dialog box is displayed.

5. In the Path Name box, type or select the path name from the list.

6. In the File Label box, type or select the file label from the list.

7. Click Add Connection to accept the path name and file label. A new path name is displayed in the Edit Connections form.

8. Repeat Steps 3 through 7 until all desired files have been added to the table connection.

9. On the Edit Connections form toolbar, click Save Changes to save the change to the table connection.


Copy file label items and columns to other FDs and tables

1. Add a file label item on a single FD.

2. Add a file label column in a single table definition on the file label item created in Step 1.

3. Associate the files with a table connection for the table definition in Step 2 that has one or more file path names with file label item definitions.

4. Test that the file label column functions, as desired, in your application.

5. From the Tools menu, choose File Label Utilities to display a submenu.

6. From the submenu, choose FD and then click Copy File Label.

Note If you have any forms open, a message box will display prompting you to close them.

7. From the Copy File Label dialog box, copy the file label item definition to other FDs in the data source.

Relativity displays a status report showing the data source and the FD to which the file label was copied.

8. From the Tools menu, choose File Label Utilities to display a submenu.

9. From the submenu, choose Table and then click Copy File Label Column to open the Copy File Label Column dialog box and copy the file label column definition to other tables in the data source.

Relativity displays a status report showing the data source and the FD to which the file label was copied.


Delete file label columns and items from other FDs and tables

1. From the Tools menu, choose File Label Utilities to display a submenu.

2. On the submenu, choose Table and then click Delete File Label Columns to open the Delete File Label Column dialog box and remove the file label column.

Note File label items cannot be deleted if there is a File Label column still defined on the file label item within the selected FD(s).

3. From the Tools menu, choose File Label Utilities to display a submenu.

4. On the submenu, choose FD and then click Delete File Labels to open the Delete File Label dialog box and delete the file label item definition.


Using the Table Wizard

See Also

The Relativity Table wizard automates the process of creating a new relational table definition from a selected file definition. The Table wizard provides an alternative to the "drag and drop" procedure described in Creating and Editing Table Definitions.

Note The Table Wizard command on the FD menu is available only when the Files catalog object in the Catalog window is displayed.

For procedures on how to use the Table wizard, click here.


Use the Table wizard

1. Select a file definition on the Files catalog object in the Catalog window.

2. Build a new relational table by clicking Table Wizard either on the FD menu or in the FD Common Tasks area of the Files catalog object in the Catalog window.

The Table wizard is displayed with the title "Table Wizard for file-name" appearing in the title bar, where file-name is the currently selected file from the Files area in the Catalog window.

3. Use the Table wizard options for defining the column names you want.

The Table wizard ignores the default column names defined in the FD form and uses its own rules to derive a column name in the new relational table that it builds. Initially, all the elementary items are selected as candidates for relational columns.

With the exception of defining default column names, all of the other procedures described in the help topic, Augmenting the COBOL File Definition in the FD Form, provide information used by the Table wizard and should be performed as described.


Maintaining the Relativity Database

Maintaining the Relativity Database, An Overview


Maintaining the Relativity Database, An Overview

The Relativity database is the combination of the COBOL schema and the relational schema stored in the Relativity catalog. It is helpful to think of the Relativity database as having two parts: the file side and the relational side. The Relativity Designer supplies mechanisms that allow you to maintain the COBOL file schema and the relational schema in a relational database.

The file side, or COBOL schema, is created from the file and record descriptions imported from the COBOL schema file. The COBOL schema stored in the catalog may be further augmented in the Relativity Designer by adding data items, adding condition items, defining items sets, and so forth. See Augmenting the COBOL File Definition on the FD Form for more information.

The relational side is created in the Relativity Designer by defining tables made up of columns based on COBOL data items from the file side. The relational schema allows SQL generated by an ODBC-enabled application to access the COBOL data in a relational manner using the Relativity DBMS. For more information, see Defining Relational Tables on the Table Form.

For detailed information about maintaining the Relativity database, choose from the following topics:

· File schema maintenance

· Relational schema maintenance


File Schema Maintenance

See Also

After the COBOL schema information has been assimilated into the Relativity catalog, you may need to provide further maintenance of the file definitions from within the Relativity Designer. An example would be when file record layouts are changed. Relativity offers two options for dealing with such cases:

· Merging the modified file definition information into a database definition. See Merging COBOL File Definitions for more information.

· Exporting the file definitions in source form for subsequent use as part of the COBOL source program. For more details, see the Export FD button on the FD form toolbar.


Merging COBOL File Definitions

See Also

The Relativity Designer merges new (or changed) COBOL file definitions (FDs) with corresponding definitions that exist in the Relativity catalog . Merging COBOL file definitions allows the Relativity Designer to capture changes in the COBOL file definitions arising from normal application maintenance. At the same time, the additional information associated with those definitions that resides in the Relativity catalog is preserved.

Merging a COBOL file definition does not destroy or modify the definition existing in the Relativity catalog, other than to rename the SQL tables associated with that existing definition. This allows testing of the merged version. If the merged version is correct, the previous version may be removed. If the merged version is not correct, it may be removed and the previous version restored.

Merging a COBOL file definition includes three main steps:

1. Moving information about the file description entry and the associated record descriptions from the file containing symbolic information about the COBOL file description to the Relativity catalog. This step includes changing the existing Relativity definition to its previous status.

2. Resolving differences discovered in COBOL data items by interacting with the Automated Resolution dialog box.

3. Replicating table definitions and connecting them to the new file definition.

Note When FDs are merged, the names of tables associated with the FDs must be changed because ODBC does not allow multiple tables with the same name in the data source. Rules for renaming are specified on the File page in the Options dialog box.

For procedures on how to merge COBOL file definitions for specific products using the Source Code Merge wizard, choose one of the following topics:

· Merge a COBOL source file

· Merge a previously compiled symbol table (RST) file

· Merge a previously compiled RM/COBOL object program


Merge a COBOL source file

1. With a catalog open in the Relativity Designer, click the Merge COBOL FD Changes shortcut from the FD Common Tasks area of the Files catalog object in the Catalog window or click Merge COBOL FD Changes on the FD menu.

The Source Code Merge wizard is displayed with the Merge COBOL Source option selected as the default. This is the option required for this procedure.

2. In the Dialect list box, specify the desired type of COBOL files (RM/COBOL or MF COBOL).

The Source Code Merge wizard provides different capabilities, depending upon which COBOL dialect, RM/COBOL or MF COBOL, is selected. To see the Source Code Merge wizard with MF COBOL selected as the dialect, click here.

3. To specify the filename and path of the file you want to import for the merge procedure, do one of the following:

· If you know the name and path of the file, type it in the File to Import text box. Proceed to Step 5.

Note If the source file specified in the File to Import text box contains an error, the Detected Errors page of the Source Code Merge wizard is displayed so that you can view the error file or view and edit the source file.

· If you do not know the filename and path of the file, click Browse to open the Select COBOL Source dialog box. Proceed to Step 4.

4. In the Select COBOL Source dialog box, you can take the following actions:

a. In the Look in list, select the drive and folder containing the COBOL source file to be merged into the Relativity catalog.

b. In the File name box, type or select the filename of the COBOL source file to be merged into the Relativity catalog. This filename must have the suffix specified in the Files of type list.

c. In the Files of type list, select a file having the .CBL suffix.

d. Click Open to close the Select COBOL Source dialog box. The name of the selected file is displayed in the File to Import text box on the first page of the Source Code Merge wizard.

5. In the wizard, if applicable, select the Process XML option to import any relational information in an accompanying XML file related to the selected COBOL FD.

6. If you are working with RM/COBOL files, enter an appropriate RM/COBOL Compile Command Option in the Compiler Options box.

7. Click Next to open the File Selection page of the Source Code Merge wizard.

The File Selection page displays the COBOL data file definitions to be included in the merging procedure. By default, the Relativity Designer assumes that you want to import (and merge) all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page in the Options dialog box.

Note To merge a selected character set, press the Advanced button on the File Selection page of the Source Code Merge wizard to open the Select Character Set dialog box.

8. From the Selected Files list, select the COBOL data file definitions you do not want to merge, if necessary, and click Remove or Remove All to move the file(s) to the Available Files list. Tip

Note If you do not want to select specific record definitions for one or more files, proceed to Step 10.

9. To select specific record descriptions from one or more files, take the following actions:

a. Select a filename (or filenames) from the Selected Files list and click Remove or Remove All to move the file(s) to the Available Files list.

b. Select a file in the Available Files list and click Select 01’s to display the Select 01's dialog box.

c. In the Section area, select the File, Working-Storage, and/or Linkage check boxes to determine the level 01 names to be displayed.

d. Select one or more record descriptions, Working-Storage Section data descriptions, and/or Linkage Section data descriptions. These descriptions will be merged as if subordinate to the selected file in the File Selection page of the Source Code Merge wizard.

e. Click OK to close the dialog box and return to the File Selection page of the Source Code Merge wizard. Then, click Add or Add All to move the file(s) from the Available Files list back to the Selected Files list.

10. Click either Remove or Remove All to move the selected COBOL data file definitions in the Selected Files list to the Available Files list.

11. Click Finish to complete the merging of the source code file.


Merge a previously compiled symbol table (RST) file

1. With a catalog open in the Relativity Designer, click the Merge COBOL FD Changes shortcut from the FD Common Tasks area of the Files catalog object in the Catalog window or click Merge COBOL FD Changes on the FD menu.

2. In the Source Code Merge wizard, select the Merge Previously Compiled Symbol Table (.RST) option.

3. To specify the previously compiled Relativity Symbol Table file that you want to import for the merge procedure, do one of the following:

· If you know the name and path of the file, type it in the File to Import text box, and proceed to Step 5.

· If you do not know the name and path of the file, click Browse to open the Select Symbol Table dialog box. Proceed to Step 4.

4. In the Select Symbol Table dialog box, you can take the following actions:

a. In the Look in list, select the drive and folder containing the RST file to be merged into the Relativity catalog.

b. In the File name box, type or select the filename of the RST file to be merged into the Relativity catalog. This filename must have the suffix specified in the Files of type list.

c. In the Files of type list, select a file having the .RST suffix.

d. Click Open to close the Select Symbol Table dialog box. The name of the selected file is displayed in the File to Import text box on the first page of the Source Code Merge wizard.

5. In the wizard, if applicable, select the Process XML option to import any relational information in an accompanying XML file related to the selected COBOL FD.

6. Click Next to open the File Selection page of the Source Code Merge wizard.

The File Selection page displays the COBOL data file definitions to be included in the merging procedure. By default, the Relativity Designer assumes that you want to import (and merge) all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page in the Options dialog box.

Note To merge a selected character set, press the Advanced button on the File Selection page of the Source Code Merge wizard to open the Select Character Set dialog box.

7. From the Selected Files list, select the COBOL data file definitions you do not want to merge, if necessary, and click Remove or Remove All to move the file(s) to the Available Files list. Tip

Note If you do not want to select specific record definitions for one or more files, proceed to Step 9.

8. To select specific record descriptions from one or more files, take the following actions:

a. Select a filename (or filenames) from the Selected Files list and click Remove or Remove All button to move the files to the Available Files list.

b. Select a file in the Available Files list and click Select 01’s to display the Select 01's dialog box.

c. In the Section area, select the File, Working-Storage, and/or Linkage check boxes to determine the level 01 names to be displayed.

d. Select one or more record descriptions, Working-Storage Section data descriptions, and/or Linkage Section data descriptions. These descriptions will be merged as if subordinate to the selected file in the File Selection page of the Source Code Merge wizard.

e. Click OK to close the dialog box and return to the File Selection page of the Source Code Merge wizard. Then, click Add or Add All to move the files from the Available Files list back to the Selected Files list.

9. Click either Remove or Remove All to move the selected COBOL data file definitions in the Selected Files list to the Available Files list.

10. Click Finish to complete the merging of the file.

If necessary, the Resolve Merge Differences dialog box is displayed to allow resolution of differences between COBOL data definitions in the previous version and the merged version of the file. Click Done when you have finished resolving differences.

In the Tables to Keep dialog box, you can do the following:

· Place table definition names that are no longer valid for the new FD in the Tables to Discard list by selecting them and clicking Remove. (Click Remove All if no table definitions are to be kept.)

· Place table definition names that are still valid for the new FD in the Tables to Keep list by selecting them and clicking Add. (Click Add All to keep all the table definitions.)

· When the two lists are correct, click Done.


Merge a previously compiled RM/COBOL object program

1. With a catalog open in the Relativity Designer, click the Merge COBOL FD Changes shortcut from the FD Common Tasks area of the Files catalog object in the Catalog window or click Merge COBOL FD Changes on the FD menu.

2. In the Source Code Merge wizard, select the Merge Previously Compiled RM/COBOL Program (.COB) option.

3. To specify the previously compiled RM/COBOL program that you want to import for the merge procedure, do one of the following:

· If you know the name and path of the file, type it in the File to Import text box. Proceed to Step 5

· If you do not know the filename and path of the file, click Browse to open the Select RM/COBOL Program dialog box. Proceed to Step 4.

4. In the Select RM/COBOL Program dialog box, take the following actions:

a. In the Look in list, select the drive and folder containing the RM/COBOL object file to be merged into the Relativity catalog.

b. In the File name box, type or select the filename of the RM/COBOL object file to be merged into the Relativity catalog. This filename must have the suffix specified in the Files of type list.

c. In the Files of type list, select a file having the .COB suffix.

d. Click Open to close the Select RM/COBOL Program dialog box. The name of the selected file is displayed in the File to Import text box on the first page of the Source Code Merge wizard.

5. In the wizard, if applicable, select the Process XML option to import any relational information in an accompanying XML file related to the selected COBOL FD.

6. Click Next to open the File Selection page of the Source Code Merge wizard.

The File Selection page displays the COBOL data file definitions to be included in the merging procedure. By default, the Relativity Designer assumes that you want to import (and merge) all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page in the Options dialog box.

Note To merge a selected character set, press the Advanced button on the File Selection page of the Source Code Merge wizard to open the Select Character Set dialog box.

7. From the Selected Files list, select the COBOL data file definitions you do not want to merge, if necessary, and click Remove or Remove All to move the file(s) to the Available Files list. Tip

Note RM/COBOL object programs do not contain the original level numbers for data items defined in a record description. Therefore, level numbers are generated during the merge procedure using the values specified in the Level Numbers option on the Data Source page in the Options dialog box. The generated level numbers are stored in the catalog during the merge and will not be changed if the level numbers setting is changed after the merge.

8. Click either Remove or Remove All to move the selected COBOL data file definitions in the Selected Files list to the Available Files list.

9. Click Finish to complete the merging of the file(s).

If necessary, the Resolve Merge Differences dialog box is displayed to allow resolution of differences between COBOL data definitions in the previous version and the merged version of the file. Click Done when you have finished resolving differences.

In the Tables to Keep dialog box, you can do the following:

· Place table definition names that are no longer valid for the new FD in the Tables to Discard list by selecting them and clicking Remove. (Click Remove All if no table definitions are to be kept.)

· Place table definition names that are still valid for the new FD in the Tables to Keep list by selecting them and clicking Add. (Click Add All to keep all the table definitions.)

· When the two lists are correct, click Done.


Resolving Merge Differences

See Also

Changes and additions of COBOL data items are inherent in the process of merging a new COBOL file definition with a definition that already exists in the Relativity catalog . Changes to COBOL data items may occur for one or more of the following reasons:

· Name

· Length

· Position within the record description

· Number of occurrences

The goal of the merging process is to replicate all of the table definitions, record types, and so forth, which have been defined using the existing COBOL file definition. The process of resolving merge differences is vital to accurate preservation of information.

The process of resolving merge differences begins with the Resolve Merge Differences dialog box. A list of data items that Relativity’s automated resolution has been unable to match totally is presented in the Merged Version - Changed Items list. This list may be too large due to the propagation of a single change that affects many items (such as the insertion of a new field near the beginning of the record definition). In such a situation, the automated rules can be relaxed by clicking Automated Resolution on the toolbar.

For procedures on how to remove a data item from the merged version, click here.


Remove a data item from the merged version

Note In the Relativity merge process, two data items have the same name if both data items have identical COBOL data-names. If the data items are subordinate to other data items, then all levels above the data items must also have identical COBOL data-names.

1. In the Resolve Merge Differences dialog box, select a data item in the Merged Version - Changed Items list. If there is a corresponding data item of the same name in the Previous Version - All Items list, then that data item will be selected automatically.

2. Click New Item if the data item selected in the Merged Version - Changed Items list has no corresponding data item in the Previous Version - All Items list. This action informs Relativity that no column definitions or other uses of this new item exist. In this situation, return to Step 1 to resolve another data item. Otherwise, continue to Step 3.

3. Optionally, click Details to display the Merge Details dialog box.

This dialog box contains the differences that the Relativity automated resolution process discovered, including the inability to discover a proposed matching item in the Previous Version - All Items list. Click Close to dismiss the Merge Details dialog box.

4. If the selected data item in the Previous Version - All Items list is incorrect or has no matching data item, then position the Previous Version - All Items list to display the matching data item. Select the matching data item in the Previous Version - All Items list.

5. Click Resolve to inform Relativity of the equivalence of the two items.

An alternative method is to drag the item from the Merged Version - Changed Items list and drop it on the matching item in the Previous Version - All Items list. Return to Step 1 to resolve another data item. Otherwise, proceed to Step 6.

6. When all data items have been resolved and the Merged Version - Changed Items list is empty, click Done. The Tables to Keep dialog box is displayed as the merge process is continued.

Note After clicking Done, if you previously imported Btrieve keys with the Import Btrieve Keys command from the Tools menu, the Re-Importing Btrieve Keys dialog box is displayed. Choose the appropriate option for which keys to use.


Re-Importing Btrieve Keys (Micro Focus COBOL Only)

After a merge operation, the system will detect whether the keys in the catalog were previously imported from Btrieve files. If so, the user will be presented with the choices listed in the Re-Importing Btrieve Keys dialog box.


Relational Schema Maintenance

See Also

In the same way that further maintenance of the file definitions may be required from within the Relativity Designer, maintenance activities may also be required on the relational side. Activities falling into this category of maintenance include defining date constants, reporting, and distributing catalogs.

See the following topics for more information:

· Defining Date Constants

· Reporting

· Distributing Catalogs


Defining Date Constants

See Also

Relativity provides a set of six options that interpret the way in which COBOL dates are translated to SQL dates. These options, collectively known as date constants, are stored in the Relativity catalog. Date constants control the conversion in certain transforms and internal functions of COBOL data item values to SQL column date values.

The date constants can be adjusted using the Relativity Designer or the Relativity DBA to reflect common algorithms used in COBOL procedural code.

The Date Constants dialog box contains values for the date constants. The values and structures of the date constants can be changed by appropriate actions in the Date Constants dialog box:

· Define 'Days' Base Date

· Define 'YYYY' Base Year

· Define 'YY' Century Cutoff

· Define 'YY' Base Year

· Define Structure of 'YY' Dates

· Define Structure of 'YYYY' Dates


Define 'Days' Base Date

The 'Days' Base Date constant specifies the date used to interpret date values that represent an integer number of days from a base date in the Gregorian calendar. The default base year is 1899. The default base month is 12. The default base day is 30. Using the default, an integer value of zero in the COBOL data item thus represents the date 30 December 1899, and an integer value of two in the COBOL data item represents the date January 1, 1900. Negative values are allowed in a signed COBOL data item to represent dates prior to the specified base date.

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. In the Year box under 'Days' Base Date, click the arrows or type a four-digit year to specify the desired value for the year.

3. In the Month box under 'Days' Base Date, click the arrows or type a one- or two-digit day to specify the desired value for the month.

4. In the Day box under 'Days' Base Date, click the arrows or type a one- or two-digit day to specify the desired value for the day.

5. Click OK to accept the values specified for the 'Days' Base Date.


Define 'YYYY' Base Year

The 'YYYY' Base Year constant specifies the base year used to interpret date values containing a four-digit year. The default base year is 0. The base year is added to a four-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a four-digit year.

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. In the 'YYYY' Base Year box, click the arrows or type a four-digit base year to specify the desired value for the 'YYYY' Base Year.

3. Click OK to accept the value specified for the 'YYYY' Base Year.


Define 'YY' Century Cutoff

The 'YY' Century Cutoff constant specifies the century cutoff year used to interpret date values containing a two-digit year that are considered to be in the next century if lower than the specified cutoff. The default value is 1900. Using the default, all two-digit years are considered to be in the twentieth century (nineteen hundreds). If this date constant is changed to 1930, then all COBOL two-digit year dates less than 1930, after adding the two-digit base year, will be incremented by 100; that is, the two-digit years 00 through 29 would be interpreted as the four-digit years 2000 through 2029. If the value of 'YY' Century Cutoff is greater than 1900, then the value of 'YY' Base Year must be equal to 1900. The value of 'YY' Century Cutoff is only used when it is greater than 1900.

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. Select the 'YY' Century Cutoff option. A 'YY' Century Cutoff box is displayed on the second line of the dialog box.

3. In the 'YY' Century Cutoff box, click the arrows or type a four-digit century cutoff year to specify the desired century cutoff value.

4. Click OK to accept the value specified for the Century Cutoff year.


Define 'YY' Base Year

The 'YY' Base Year constant specifies the base year used to interpret date values containing a two-digit year. The default base year is 1900. The base year is added to a two-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a two-digit year.

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. Select the 'YY' Base Year option.

3. In the 'YY' Base Year box, click the arrows or type a four-digit base year to specify the desired 'YY' Base Year value.

4. Click OK to accept the value specified for the 'YY' Base Year.


Define Structure of 'YY' Dates

The 'YY' Dates constant specifies the structure to be used for COBOL data items that were associated with a six-digit date transform when the catalog was designed. The six-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with two-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in its files. The default structure is YYMMDD (a two-digit year, followed by a two-digit month of the year, followed by a two-digit day of the month).

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. From the 'YY' Dates list, select YYMMDD, MMDDYY, or DDMMYY.

3. Click OK to accept the selected 'YY' Dates structure.


Define Structure of YYYY Dates

The 'YYYY' Dates constant specifies the structure to be used for COBOL data items that were associated with an eight-digit date transform when the catalog was designed. The eight-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with four-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in its files. The default structure is YYYYMMDD (a four-digit year, followed by a two-digit month of the year, followed by a two-digit day of the month).

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. From the 'YYYY' Dates list, select YYYYMMDD, MMDDYYYY, or DDMMYYYY.

3. Click OK to accept the selected YYYY Dates structure.


Reporting

See Also

The Relativity Designer provides a set of reports that have been predefined to assist in reviewing four types of data in the Relativity catalog and maintaining that data, as required. The four report categories include the following:

1. Files/Tables. The reports in this category describe the file and table definitions (including cross-references) maintained in the catalog.

2. Connections. The reports in this category describe the physical access names associated with table definitions.

3. Privileges. The reports in this category describe the security, that is, privileges assigned to database groups defined for the catalog.

4. Users. The reports in this category describe the groups and users defined for the catalog.

The predefined Relativity reports may be useful to the database administrator at an end-user site. To make these reports available, the catalog designer must configure the Relativity DBA prior to delivering it to the end-user.

Each of the Relativity predefined reports can be used "as is." In the Relativity Designer, you can access the predefined reports in the Report Editor by using the shortcut tasks on the Reports catalog object in the Catalog window or by choosing the Print and Edit commands on the Reports menu in the Relativity Designer window.

For procedures on how to create and customize reports using the Report Editor, as well as how to print a report, choose from the following topics (or refer to the Report Editor online Help file):

· Create a new report

· Edit an existing report

· Print a report


Access the report definition files in the Report Editor

Note The WYSIWYG Report Editor included with the Relativity Designer also can be used either to create new reports based on the Relativity predefined reports or to customize and edit the Relativity predefined reports.

To access the predefined reports in the Report Editor, take any of the following actions:

· On the Reports catalog object, you can do the following:

-  Select a specific report description (for example, All Users by Group) and click the Edit shortcut in the Reports Common Tasks area or right-click and choose the Edit command from the pop-up context menu.

-  Select a report category (for example, Users) and click the Edit shortcut in the Reports Common Tasks area or right-click and choose the Edit command from the pop-up context menu. In this case, the Select Report dialog box opens where you may do either of the following:

· In the File name box, type a filename for a new report and click Open.

· In the List area, select an existing report and click Open.

-  To print a report, select a specific report description and click the Print shortcut in the Reports Common Tasks area or right-click and choose the Print command from the pop-up context menu. You may also choose a report category in the Reports area, in which case the Select Report dialog box opens where you may select a specific predefined report from the list or type a filename, and then click Open.

· On the Reports menu, you can perform the following actions:

-  Choose the Edit command and then click one of the submenus (Files/Tables, Connections, Privileges, or Users). In this case, the Select Report dialog box opens and you may follow the instructions described above. (Note that the exact name of this dialog box varies depending on the report category selected.)

-  Choose the Print command and then click one of the submenus (Files/Tables, Connections, Privileges, or Users) to print a predefined report.


Create a new report

1. Select a report category from the list displayed by either of the following actions:

· From the Reports area on the Reports catalog object in the Catalog window, select a report category from the list and click the Edit shortcut from the Report Common Tasks area.

Note If you select a specific report description on the Reports catalog object in the Catalog window and click Edit, that report will open immediately in the Report Editor. You may edit this report and then save it as a new report by using the Save As command on the Report Editor's File menu.

· On the Reports menu, point to Edit and then click one of the available report categories from the submenu.

2. In the Select Report dialog box (the exact name of this dialog box will vary depending on the report category selected), specify a file by either one of the following actions:

· In the File name box, type a filename of the report definition file for the report being created. For the filename extension, either type the default extension shown in the Files of type list or omit the extension. If the extension is omitted, the default extension is supplied.

· Select an existing filename of a report definition file as a starting point for a new report. (Be sure to use the Report Editor's Save As command immediately upon entry to avoid unintentionally overwriting an existing report.)

3. In the Report Editor, design the desired report. (For assistance, use the Report Editor Help File.)

4. On the Report Editor File menu, click Save As. The Save As dialog box is displayed.

5. In the Description box, enter a description of the report.

This report description is displayed in the Catalog window on the Reports catalog object.

6. If necessary, adjust the filename and folder/directory options for the report definition file. The directory should be one that is searched for report file definitions.

7. Click OK.


Edit an existing report

1. Select a report category from the list displayed by either of the following actions:

· From the Reports area on the Reports catalog object in the Catalog window, select a report category from the list and click the Edit shortcut from the Report Common Tasks area.

Note If you click Edit, when you have selected a specific report description on the Reports catalog object in the Catalog window, that report will open immediately in the Report Editor. You may edit this report and then save it by using the Save As (to avoid overwriting the report) or the Save command (to create a new layout for the same report) on the Report Editor's File menu.

· On the Reports menu, point to Edit and then click one of the available report categories from the submenu.

2. In the File name box of the Select Report dialog box (the exact name of this dialog box will vary depending on the report category selected), specify a file by selecting or typing a filename of the report definition file for the report being edited. For the filename extension, either type the default extension shown in the Files of type list or omit the extension. If the extension is omitted, the default extension is supplied.

3. In the Report Editor, edit the selected report. (For assistance, use the Report Editor Help File.)

4. On the Report Editor File menu, click Exit.

5. Click Yes in response to the message about saving changes.


Print a report

1. The manner in which you print a report depends on which of the following methods you choose.

· If you use the Reports catalog object in the Catalog window, follow these steps:

a. Select the description of the report to be printed.

b. Click Print. The Print Options dialog box is displayed.

Note If you click Print when a report category is selected in the Reports catalog object rather than a specific report description, the Select Report dialog box is displayed. In this case, follow the instructions beginning with Step 2c.

c. Proceed to Step 2.

· If you use the Reports menu, follow these steps:

a. Point to Print to display a submenu containing a list of report categories.

b. Click one of the available report categories to be printed.

c. In the Select Report dialog box (the exact name of this dialog box varies depending on the report category selected), type or select a filename of the report definition file for the report to be printed either from the File name list box or from the List area.

The name and a thumbnail version of the selected report will be displayed in the Preview area.

d. Click Open to display the Print Options dialog box.

e. Proceed to Step 2.

2. Adjust the print options, if necessary, in the Print Options dialog box.

3. Click Start. After retrieving information from the Relativity catalog, a message box is displayed. Printing status is updated as printing progresses.

Printing is complete when the message box disappears.

4. Click Cancel to halt printing before normal termination.


Report Definition Files

See Also

Report definition files are the files that describe particular reports. Some of the predefined report definition files provided by the Relativity Designer may be distributed along with the Relativity DBA so that the end-user can generate reports.

Note Reports with the extension .rxl (that is, the Files/Tables reports) cannot be distributed.

The report definition files also can be created using the Create a new report procedure.

Report definition files have the following default extensions:

· rcl Connections Reports

· rpl Privileges Reports

· rul Users Reports

· rxl Files/Tables Reports


Predefined files provided with the Relativity Designer

The following predefined files for the various report categories are provided with the Relativity Designer.

Files/Tables Reports

The Files/Tables report category includes the following predefined files:

Filename | Report Description
files1.rxl | COBOL Items by File Name
files2.rxl | COBOL Items Cross-referenced with Table/Column
files3.rxl | COBOL Items by Table Name
files4.rxl | COBOL Items by Column
files5.rxl | File-Table Cross Reference
files6.rxl | File-Table Cross Reference by Table Name

Connections Reports

The Connections report category includes the following predefined files:

Filename | Report Description
contab1.rcl | Connections by Table Name (This is the recommended default report to print from the Print toolbar button on the Edit Connections form in the Relativity DBA.)
contab2.rcl | Connections by Table Definition Name
contab3.rcl | Connections by Owner Name
contab4.rcl | Connections by File Access Name
contab5.rcl | Table List

Privileges Reports

The Privileges report category includes the following predefined files:

Filename | Report Description
grantee1.rpl | Privileges by Grantee (This is the recommended default report to print from the Print toolbar button on the Edit Privileges form in the Relativity DBA.)
grantor1.rpl | Privileges by Grantor
object1.rpl | Privileges by Object

Users Reports

The Users report category includes the following predefined files:

Filename | Report Description
user1.rul | All Users by Group
user2.rul | All Users by User Name (This is the recommended default report to print from the Print toolbar button on the Edit Users form in the Relativity DBA.)
user3.rul | All Users by Declared Order (Note that the name of this report implies that one can declare the order in which the report lists the users. In reality, users are listed in order of declaration, that is, by group ID and then by user ID order.)


Connections by Table Name Report

The following is an example of a Connections by Table Name report.


Privileges by Grantee Report

The following is an example of a Privileges by Grantee report. For a chart listing the Privilege codes, click here.


All Users by User Name Report

The following is an example of an All Users by User Name report.


Connections Report Features

See Also

The Connections report category provides detailed information about the association of SQL table names and the file physical access names maintained in a Relativity catalog.

The following data elements are available in Connections reports:

Data Element Name | Types Available | Explanation
DatabaseQualifier | V | ODBC database qualifier for this catalog
DataSourceName | V | ODBC data source name for this catalog
FileAccessName | FVPEI | Physical access name for the file associated with the SQL table
OwnerName | FVPE | Name of the group that owns the table
ProductName | V | Name of the Relativity product used to print the report
ProductVersion | V | Version of the Relativity product used to print the report
TableDefinitionName | FVPEI | Table definition name (typically known as the table name in the Relativity Designer)
TableName | FVPE | SQL table name


Privileges Report Features

See Also

The Privileges report category provides detailed information about database, table, and column privileges maintained in a Relativity catalog. For more information about the privilege codes that can appear on the Privileges reports, click here.

The following data elements are available in Privileges reports:

Data Element Name | Types Available | Explanation
DatabaseQualifier | V | ODBC database qualifier for this catalog
DataSourceName | V | ODBC data source name for this catalog
Grantee | FVPEI | Name of the group granted the privilege
Grantor | FVPEI | Name of the group granting the privilege
ObjectType | FVPEI | Indicator explaining the PrivilegeObject: “Database”, “Define”, “Table”, “TableColumn”, or “User”
Privilege | F | Encoded string tersely describing the privilege
PrivilegeObject | FVPE | Name of the object to which the privilege applies: SQL table name, SQL tablename:columnname, Table definition name, User name, or “Database”
PrivilegeVerbose | F | Verbose description of the privilege
ProductName | V | Name of the Relativity product used to print the report
ProductVersion | V | Version of the Relativity product used to print the report


Types of Report Data Elements

The following codes are used to describe the availability of the various data elements in reports:

F The data element is available as a Field in a report table object.

V The data element is available as a Variable in a report text object.

P A data element containing the value of the data element in the last report table line is available; the name of this element is “Previous” concatenated before the data element name (for example, Previous.File.Item.Name).

E The data element is available as an end-of-page variable in a report text object; the name of this element is “EOP” concatenated before the data element name (for example, EOP.File.Item.Name). In the Report Editor online Help file, see "Fundamentals", then "Linking Objects."

I The data element is available as an Input variable and field; the name of this element is “INPUT” concatenated before the data element name (for example, INPUT.COBOL.File.Name). If input data elements are used in a report (for example, in the report filter equation), then the operator will be prompted to enter a value for the input data element(s) before beginning the print run. The values entered will be maintained throughout the print run.


Privilege Codes Table

The following table defines the privilege codes that can appear on the Privileges reports. A plus sign before a privilege code means "with grant" and a minus character means "not granted."

Code | Meaning
A | Use Relativity DBA
G | Create New Groups
C | Modify Date Constants
P | Print Reports
T | Create New Table Connections
S | Select
I | Insert
U | Update
R | Reference
X | Delete
N | Create User


Users Report Features

See Also

The Users report category provides detailed information about users (a group is a user) maintained in a Relativity catalog.

The following data elements are available in Users reports:

Data Element Name | Types Available | Explanation
DatabaseQualifier | V | ODBC database qualifier for this catalog
DataSourceName | V | ODBC data source name for this catalog
GroupName | FVPEI | User group name
IsGroup | FVPEI | Boolean indicator that this UserName is the group name
IsOwner | FVPE | Boolean indicator that this group is the catalog owner
ProductName | V | Name of the Relativity product used to print the report
ProductVersion | V | Version of the Relativity product used to print the report
UserName | FVPE | Individual user name


Files/Tables Report Features

See Also

The Files/Tables report category provides detailed information about file and table definitions maintained in a Relativity catalog. Files/tables may be used to print cross reference reports as well as more simple reports about files or tables.

The following data elements are available in Files/Tables reports:

Data Element Name | Types Available | Explanation
DataSourceName | V | ODBC data source name for this catalog
DatabaseQualifier | V | ODBC database qualifier for this catalog
File.Comment | FVP | Comment from FD form [File] line
File.Name | FVPEI | COBOL file-name
File.Version | FVP | “Previous” indicator
File.Item.88Value | F | Value(s) from the VALUE clause for this condition-name
File.Item.Class | F | “G” for group items “E” for elementary items “S” for SubscriptItem “W” for working-storage items “F” for function items
File.Item.Comment | FP | Comment from the FD form for this item
File.Item.DefaultColumnName | F | Default column name as specified on FD form (does not include column name derived from File.Item.Name)
File.Item.Length | F | Number of character positions used by this item
File.Item.Name | FVPEI | COBOL data-name or condition item
File.Item.Offset | F | Number of character positions from the beginning of the COBOL physical record to the beginning of this item
File.Item.ParentItemName | FP | COBOL data-name of the group item containing this item
File.Item.Picture | F | COBOL picture for this item
File.Item.Precision | F | Number of decimal digits defined for this item
File.Item.Scale | F | Number of digits to the right of the decimal point
File.Item.Subscripts | F | Number of subscripts required by this item
File.Item.Transform | F | Transform specified for this COBOL item
File.Item.Type | F | Abbreviated three- or four-character code describing the COBOL item’s usage
ProductVersion | V | Version of the Relativity product used to print the report
ProductName | V | Name of the Relativity product used to print the report
Table.HasTableFilter | FV | True, if the table definition has a filter expression. For more information, click here.
Table.IsInsertable | FV | True, if the table definition has been marked insertable. For more information, click here.
Table.IsUpdatable | FV | True, if the table definition has been marked updatable. For more information, click here.
Table.Name | FVPEI | Table definition name
Table.Version | FVP | Indicates whether the table definition is the active or previous definition following a merge operation. For more information, click here.
Table.Column.Code | FP | Code used to distinguish the use of Table.Column.NameExtended: “C” for actual column name “S” for bound subscript “T” for record type (Table.Column.NameExtended contains the record type name) “U” for table filter (Table.Column.NameExtended contains “<Table filter>“)
Table.Column.Comment | F | Comment from the Table form for this column
Table.Column.HasBoundSubscripts | F | True, if the column has bound subscript(s). For more information, click here.
Table.Column.IsNullable | F | True, if the column is nullable. For more information, click here.
Table.Column.IsUnsigned | F | True, if the column is unsigned. For more information, click here.
Table.Column.IsUpdatable | F | True, if the column is updatable. For more information, click here.
Table.Column.Name | FVPEI | Column name associated with the COBOL data item
Table.Column.NameExtended | FVP | Column name associated with the COBOL data item extended to include noncolumn uses such as table filter(s) and record type filter(s), and bound subscripts
Table.Column.Transform | F | Transform specified for this column
Table.Column.Type | FP | ODBC data type of this column


Configuring Reports for Relativity DBA

See Also

There may be times when the person in charge of database administration at an end-user site could benefit from reports produced by the Relativity Designer. For example, the Users reports and Privileges reports would assist in managing Relativity security. The Connections reports would help manage table connections. However, since end-user sites normally do not have access to the Relativity Designer, the Relativity DBA can be configured to print reports created with the Report Editor in the Relativity Designer.

Note The reporting capability in the Relativity DBA is subject to the Reports privilege, which is in the Administrator set of privileges. The Reports privilege may expose certain database objects for which a user group would otherwise have no authority.

For information on how to configure reporting capabilities in the Relativity DBA, choose one of the following tasks:

· Configure a default report to be run with the Print toolbar button

· Configure a Reports menu

· Configure the Export command on the Reports menu

· Configure the Edit command on the Reports menu


Configure a default report to be run with the Print toolbar button

Add or modify the following section in the RELDBDBA.INI file:

[DefaultReports]
Connections=Connections by Table Name
Privileges=Privileges by Grantee
Users=All Users by User Name

Note Connections by Table Name, Privileges by Grantee, and All Users by User Name are the descriptions of the recommended default reports for the Edit Connections form, Edit Privileges form, and the Edit Users form, respectively. You can, however, assign any of the predefined reports within a report category as the default for that report category. The description of the report, not the filename of the report file, is used to specify the default report.

The Print toolbar button appears on the Edit Connections form, the Edit Privileges form, and the Edit Users form. If the corresponding default report description is not specified in the RELDBDBA.INI file, however, the Print button does not appear on the toolbar.

The Relativity DBA searches for report definition files at startup in three directories:

1. A directory specified in the RELDBDBA.INI file [Administrator] section as follows:

ReportDir=path

where path is the directory in which to search for reports.

2. The current directory specified at startup of the Relativity DBA.

3. The directory in which RELDBDBA.EXE is found.


Configure a Reports menu

Add one or more of the following lines to the [Administrator] section of the RELDBDBA.INI file:

EnableCustomUsers=Yes
EnableCustomConnections=Yes
EnableCustomPrivileges=Yes


Configure the Export command on the Reports menu

Add the following line to the [Administrator] section of the RELDBDBA.INI file:

EnableReportExport=Yes


Configure the Edit command on the Reports menu

Add one or more of the following lines to the [Administrator] section of the RELDBDBA.INI file:

EnableCustomEditUsers=Yes
EnableCustomEditConnections=Yes
EnableCustomEditPrivileges=Yes


Exporting Data to a Comma-Separated File

See Also

Relativity uses the Report Editor to export data stored in a Relativity catalog to a comma-separated file that may be imported by most database, spreadsheet, and word processing products.

For procedures on how to export data stored in a Relativity catalog, click here.


Export data stored in a Relativity catalog

1. Create a report containing a table print object (for more information, see Create a new report).

The table print object should print all of the desired data elements for the comma-separated file. Use the project filter condition expression (accessed from the Filter command on the Project menu of the Report Editor) to limit the data elements as necessary (for example, to print data for only one file definition).

2. Select a report for export by either of the following methods:

· From the Reports catalog object in the Catalog window, select the name of the report to be exported and click the Export shortcut in the Report Common Tasks area or right-click and choose the Export command from the pop-up context menu.

· On the Reports menu, click Export. A check mark appears to the left of the command name to indicate that the Export feature is active.

Then, click Print and select a report category from the list of submenu options (Files/Tables, Connections, Privileges, or Users).

3. In the Save Export File As dialog box, select the name of the file into which the export (comma-separated) information is to be stored.

4. Click Save. The Print Options dialog box is displayed.

5. Adjust the print options, if necessary.

6. Click Start. After retrieving information from the Relativity catalog, a message box is displayed. Printing status is updated as printing progresses.

7. To halt printing and exporting before normal termination, click Cancel.

Printing and exporting are complete when the message box disappears.


Distributing Catalogs

See Also

If you are going to distribute a Relativity catalog to end-users, you will need to comply with a number of conditions. (Instructions for performing each of these tasks can be found in the appropriate Relativity Client/Server Installation Guide.)

· For client/server implementations, the server must be installed at the end-user site.

· The catalog is generally placed on the same machine as the user data. The catalog must be delivered on appropriate media for the end-user.

· The Relativity DBMS must be installed on every Windows system that is to access the catalog.

· You may also choose to install the Relativity DBA on selected Windows machines, which will allow end-users to maintain security of the catalog.

· For each Windows system that is to access the catalog, an ODBC data source must be created.


Distributing Updated Catalogs

See Also

If you distribute catalogs to end-users, there will be occasions when you need to send out updates to that catalog. There are multiple ways to accomplish this:

· If you do not distribute the Relativity DBA, the end-user cannot modify your catalog; therefore, you just send an updated catalog and replace the end-user's existing catalog.

· If you do allow your end-user access to the Relativity DBA, then you may wish to preserve changes made by the end-user when you distribute an updated catalog.

The Catalog Merge capability, distributed with the Relativity DBA, generally takes any changes made by the DBA and merges them into a new catalog, preserving Users, Privileges, and Connections modified and added by the end-user. For procedures on using Catalog Merge, click here.

Note Both the existing and modified catalogs must have owners in order to run this merge process.


Merge a catalog

The updated catalog must be distributed on media appropriate for the end-user and the catalog must be in place prior to executing the catalog merge. The new catalog must also be published to ODBC prior to executing the catalog merge.

There are two ways of running the catalog merge process:

· Standalone. The standalone method of merging a catalog is appropriate when the merge is to be incorporated as part of an automated installation process. You can use any valid Windows method to run the merge.

You must specify the accompanying rules file on the command line. Here is an example command line:

C:\RELDBXX\RELDBUTL.EXE C:\WINDOWS\RELDBUTL.INI

(Note that " C:\RELDBXX" indicates the Relativity installation path.)

· Using the Relativity DBA. The Relativity DBA can be used to merge a catalog if the merge process needs to be run manually. To perform a merge from the DBA, click Merge Catalog from the File menu.

Note The Merge Catalog command is not visible on the File menu of the Relativity DBA unless a rules file with the name RELDBUTL.INI exists in the Windows directory. Additionally, this command will appear only if a data source has not been opened in the Relativity DBA.


Rules File for Merging a Catalog

When distributing updated catalogs, there must be an accompanying rules file for the merge process. The rules file is an INI format file having the name RELDBUTL.INI. It can contain sections for changed file and table definition names. The minimum entries in the rules file are the names of the two data sources to merge. The format for entries is the following:

PARAMETER=value

To view a sample rules file, click here.

[CATALOG] section specifies the data source names as well as the user IDs and passwords that are to be merged. The parameters are:

OLD: The customer's existing data source.

OLDUID: The customer’s existing user ID.

OLDPWD: The customer’s existing password.

NEW: The Relativity Designer's new data source.

NEWUID: The customer’s new user ID.

NEWPWD: The customer’s new password.

[FD] section provides a method of explaining file definition name changes. There should be an entry in this section for every FD name that has changed. The format is oldname=newname. There is no need to list unchanged file definitions; they are merged automatically.

[TABLE] section provides a method of explaining table name changes. There should be an entry in this section for every table name that has changed. The format is oldname=newname. There is no need to list unchanged table names as they are merged automatically.

[COLUMNS] section provides a method of explaining column name changes. There should be an entry in this section for every column name that has changed. The format of this section header is the keyword COLUMNS followed by a colon followed by the old name of the table. The format of the entries in the section is oldcolumn=newcolumn.

[CONNECT] section, which is optional, allows the new data source to be published to ODBC as part of the merge process. The parameters are:

DESC: Can be any text that describes the data source.

CATALOG: The full access path to where the catalog will be located.

DSN: Data Source Name. This is the ODBC reference name for the new catalog.

DRIVER: The Relativity DBMS used for the new catalog.

[MESSAGES] section, which is optional, is provided to allow the Relativity Designer to change the messages displayed on the screen as the merge is taking place. You may choose to provide any of these messages; you do not have to provide all. If a message is not found, the default will be used. The sample below uses the defaults. The valid messages and when they are displayed are:

LOGON1: The message displayed while the Logon dialog box for the user's existing catalog is displayed.

LOGON2: The message displayed while the Logon dialog box for the new catalog is displayed. (One use for this may be to provide a new user ID and password if the DBA has changed.)

STATUS: The message displayed while the actual merge is running.

COMPLETE: The message displayed following a successful merge. (One use for this message may be to remind the user to remove any media, or to run the next step in a process.)

INCOMPLETE: The message displayed following an aborted merge process. (One use for this message may be how to proceed if errors were encountered during the merge.)

LOG: Creates a log file at the end of the merge process. The only entry in the log file is a complete or incomplete message. If you have specified COMPLETE and INCOMPLETE messages, those will be used. If not, the default for these messages will be used.

Here are the default messages that will be used if none are provided:

LOGON1=Please log on to your existing catalog.

LOGON2=Please log on to new catalog.

STATUS=This process may take some time.

COMPLETE=Relativity Merge Complete.

INCOMPLETE=Relativity Merge NOT Complete.


Sample Rules File

The following is an example of sample rules file:

\WINDOWS\RELDBUTL.INI
[CONNECT]
DESC=New Data
Source
CATALOG=C:\MYDATA\MYCATALOG.RCG
DSN=MYDATA
DRIVER=Relativity for
RM
(*.rcg)
[CATALOG]
OLD=JMB
NEW=JMBTEST
[FD]
[TABLE]
[MESSAGES]
LOGON1=Please
log on to your existing data source.
LOGON2=Please log on to new data source,
user=Mike, password=Mike.
STATUS=Processing, please wait...
COMPLETE=Merge
Complete.  Remove media.
INCOMPLETE=Relativity Merge NOT Complete.
Please call for support.


Defining Security for Relativity Catalogs

Providing Data Security

Catalog Ownership

Database Administration

Defining Groups and Users

Defining Catalog Ownership

Defining Group Privileges


Providing Data Security

Relativity provides a security facility to protect data in the tables against unauthorized disclosure, alteration, or destruction.

For security purposes, a unit of data (or data object) ranges from an entire database to a specific column within a table of the database. A given user has different access privileges on different units of data. Access privileges (or privileges, for short) are the mechanism that provides data security for a Relativity database.

To provide data security:

1. Define groups and users. The first step in effective database administration is to design and establish the group structure; that is, the users and groups of users who are authorized access to the database. Groups and users are the basis for establishing security for your database. An individual user is identified by a user name. A group of users is identified by a group name. Each user name and group name within a Relativity catalog must be unique.

2. Define catalog ownership. In Relativity, a data source is the connection known to ODBC between a Windows workstation and a Relativity catalog. Before a data source associated with a catalog can be opened, a user name must be entered with a password via the Logon dialog box to identify the user requesting access to the database. If the user name and password are valid, the user may access the database, but only with the privileges assigned to the group to which that user belongs. This procedure prevents unauthorized persons from accessing the database or from accessing portions of the database for which they do not have access privileges. Passwords are assigned to groups and users when defining groups and users with Relativity. Assigned passwords are stored in an encrypted form in the catalog.

3. Define group privileges. Relativity allows you to establish specific permissions for groups and users. This is accomplished by granting privileges to groups, which is similar to the GRANT/REVOKE facilities in other relational database management systems.

In a Relativity catalog, privileges are assigned to a group of users. All users within a group inherit the privileges of the group. Not all groups associated with the Relativity database need access to all the data in the database. A group of users is given (that is, granted) privileges only to that data that is necessary for the group to carry out its work.

The Relativity software contains a group called <PUBLIC>. When a privilege is granted to the <PUBLIC> group, that privilege is granted to all users of the database. Thus, a privilege can be assigned to all users by granting that privilege to the <PUBLIC> group.

When granting privileges, it may be helpful to think of them in terms of a hierarchy, with the group that is the owner of the catalog having the highest level permissions, the group that administers the catalog having the next level of permissions, and a user group having the lowest level permission (the ability to access only one or more tables or columns).

► Related Topic Relativity supports a set of stored procedures, identified with the prefix, DBA-, only if the user is the owner or a database administrator of the Relativity catalog. The DBA stored procedures deal with table definitions, table connections, and file names. All of the stored procedures are ODBC driver-specific. For more information, see "Stored Procedures" in the under the For Advanced Users | Relativity-Specific topic in the Relativity DBMS Help file.


Catalog Ownership

See Also

A Relativity catalog has an ownership property that enables one group of users to be specified as the owner of the catalog. An owner of a catalog is automatically granted all privileges for the database and can perform every operation that supports a Relativity database. There is no security for a Relativity database until an owner is assigned to the catalog. Assigning an owner establishes security and, initially, the owner of a catalog is the only group that can do anything with the Relativity database.

Duties of the owner of the Relativity catalog include:

1. Creating groups of users for this database.

2. Granting the privilege of executing the Relativity Designer software to a group (or groups).

3. Granting other privileges to the group executing the Relativity Designer.

4. Granting another group the authority to grant specified privileges to other groups.

5. Revoking privileges from a group.

In addition to these duties, once an owner is assigned, only users who are members of the owner group may open the data source associated with the catalog using the Relativity Designer. Thus, the owner is equivalent to the catalog developer and has all development responsibilities supported only by the Relativity Designer.


Database Administration

See Also

When starting the Relativity Designer, a group name or user name is entered with a password to identify the user requesting access to the Relativity Designer. When the user is not an owner of the catalog, the user's group must have been assigned the Use Administrator privilege.

The administrative privileges, usually restricted to the catalog developer and to the database administrator, deal with controlling access by creating groups and users and granting database access privileges. (Database access privileges deal with the Table and Column privileges granted to various groups and users depending on their needs.)

Major duties for managing a database include:

1. Executing the Relativity DBA software.

2. Creating groups of users for this database (if granted, the Create Group privilege).

3. Creating user IDs and passwords for members of a group (if granted, the Create Users privilege).

4. Granting the privilege of executing the Relativity Designer software to a group (or groups).

5. Granting another group the authority to grant specified privileges to other groups.

6. Granting the privileges of accessing specified tables in the Relativity database to a group (or groups).

7. Granting the privileges of accessing specified columns within tables of the Relativity database to a group (or groups).

8. Revoking privileges from a group.

9. Setting an expiration date for groups and users, as needed.

10. Deleting groups and users, as needed.

For more information on the types of privileges that can be granted to a group of users, click one of the following topics:

· Administrator Privileges

· Create Users Privilege

· Create Tables Privilege

· Table Privileges

· Column Privileges


Administrator Privileges

The four Administrator privileges available for a group all pertain to database administration operations:

1. Use Administrator. Enabling the Use Administrator privilege allows the group granted the privilege to use the Relativity DBA software on the specified catalog.

2. Create Groups. Enabling the Create Groups privilege permits the group granted the privilege to add new database groups to the catalog.

3. Date Constants. Enabling the Date Constants privilege allows the group granted the privilege to change the existing (default) values for the date constants of the database in the catalog. These date constants include 'Days' Base Date, 'YYYY' Base Year, 'YY' Base Year, 'YY' Century Cutoff, and configurable date formats.

4. Reports. Enabling the Reports privilege permits the group granted the privilege to create and use reports for information in the catalog.

Note The Administrator privileges cannot be assigned to the <PUBLIC> group.

For information on enabling Administrator privileges for a group, click here.


Create Users Privilege

Enabling the Create Users privilege allows the group granted the privilege to add new users to a specific database group in the catalog and to delete existing users from a specific group.

Because the Create Users privilege is granted only for specific groups, it is possible to have specialized administrators of the database. For example, there could be a SalesAdmin group that is granted the privilege to create new users only for the Sales group. The director of sales would then be made a member of the SalesAdmin group so that the director could add users to or delete users from the Sales group without having to request such changes from the main administrator.

Note The Create Users privilege cannot be assigned to the <PUBLIC> group.

For information on enabling the Create Users privilege for a group, click here.


Create Tables Privilege

Enabling the Create Tables privilege allows the group granted the privilege to add, edit, and delete table connections between the Relativity table definitions and the physical COBOL data files.

Note The Create Tables privilege cannot be assigned to the <PUBLIC> group.

For information on enabling the Create Tables privilege for a group, click here.


Table Privileges

In a Relativity database, a given group may have access rights or privileges to a table. In order to perform an SQL operation, such as SELECT, INSERT, UPDATE, or DELETE on a table, the user must belong to a group granted the corresponding privilege for the columns affected by the operation. Table privileges apply to all columns of a table. If the administrator wishes to grant access only to specific columns of a table, then Column privileges must be granted instead of Table privileges.

The following Table privileges are available for a group:

1. Table All. The Table All privilege enables all the Table privileges (Table Select, Table Insert, Table Update, Table References, and Table Delete) on all columns of a specified table. To read about the special characteristics of the Table All privilege, click here.

2. Table Select. Enabling the Table Select privilege allows the group granted the privilege to access all of the columns of a specified table, including any columns added to that table later.

3. Table Insert. Enabling the Table Insert privilege permits the group granted the privilege to insert into all columns of a specified table, including any columns added to that table later.

4. Table Update. Enabling the Table Update privilege allows the group granted the privilege to update all columns of a specified table, including any columns added to that table later.

5. Table References. Enabling the Table References privilege allows the group granted the privilege to reference all columns of a specified table in integrity constraints, including all columns added to that table later. Integrity constraints may be specified in CREATE TABLE statements and could be used in a way that would obtain information about columns in another table for which a user would not otherwise have privileges.

6. Table Delete. Enabling the Table Delete privilege permits the group granted the privilege to delete a row from a specified table. Since deleting a row of a relational table is equivalent to deleting all columns of that row, this privilege exists only as a Table privilege; there is no corresponding Column Delete privilege.

Note Options selected on the Privileges page in the Options dialog box affect the behavior of the Edit Privileges form.

For information on enabling the Table privileges for a group, click here.


Column Privileges

In a Relativity database, a given group may have access rights or privileges to a column within a table. In order to perform an SQL operation, such as SELECT, INSERT, or UPDATE on a column within a table, the user must belong to a group granted the corresponding privilege for the columns affected by the operation.

The following Column privileges are available for a group:

1. Column All. The Column All privilege enables all the Column privileges (Column Select, Column Insert, Column Update, and Column References) on specified columns of a specified table. To read about the special characteristics of the Column All privilege, click here.

2. Column Select. Enabling the Column Select privilege permits the group granted the privilege to access specified columns of a specified table.

3. Column Insert. Enabling the Column Insert privilege allows the group granted the privilege to insert into specified columns of a specified table.

4. Column Update. Enabling the Column Update privilege permits the group granted the privilege to update specified columns of a specified table.

5. Column References. Enabling the Column References privilege allows the group granted the privilege to reference specified columns of a specified table in integrity constraints. Integrity constraints may be specified in CREATE TABLE statements and could be used in a way that would obtain information about columns in another table for which a user would not otherwise have privileges.

Notes

· There is no Column Delete privilege because the SQL DELETE statement deletes a row of a table, thus requiring delete privilege on all columns. You must use the Table Delete privilege described in Table Privileges to grant the privilege to delete rows of a table.

· Options selected on the Privileges page in the Options dialog box affect the behavior of the Edit Privileges form.

For information on enabling the Column privileges for a group, click here.


Defining Groups and Users

See Also

Groups and users are assigned to a Relativity database with the appropriate actions in the Edit Users form.

To open the Edit Users form in the Relativity Designer window:

· On the Security menu, click Users.

For detailed information on defining groups and users, choose from the following topics:

· Add a database group to the catalog

· Add a user to a group

· Delete a database group from the catalog

· Delete a user from a group

· Change a group password

· Change a user password

· Reset a group password

· Reset a user password

· Print Users report


Add a database group to the catalog

1. On the Security menu, click Users to open the Edit Users form.

Note The User menu appears on the menu bar of the Relativity Designer window when a group name is selected on the Users & Groups catalog object in the Catalog window. On the User menu, click Add Group. Alternatively, select a group name on the Users & Groups catalog object and click the Add Group shortcut from the User Common Tasks area. If you follow either of these methods, proceed to Step 3.

2. Click Add Group on the Edit Users form toolbar. The Add Database Group dialog box is displayed.

3. In the New Group Name box, type the name of the database group to be added to the catalog.

4. In the Password box, type the password for the new group. An asterisk (*) character is displayed for each character entered.

5. In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered.

Note Both passwords entered in the Add Database Group dialog box must contain the same characters before the password is accepted for the group.

6. If needed, select the Use Expiration check box. By default, the current date is already entered in the Date box. Type a different expiration date or click Calendar to select a date.

7. Click OK to accept the new group name in the Add Database Group dialog box.


Add a user to a group

1. On the Security menu, click Users to open the Edit Users form.

Note The User menu appears on the menu bar of the Relativity Designer window when a user name is selected on the Users & Groups catalog object in the Catalog window. On the User menu, click Add User. Alternatively, select a user name on the Users & Groups catalog object and click the Add User shortcut from the User Common Tasks area. If you follow either of these methods, proceed to Step 4.

2. Select a group in the Group Name column of the Edit Users form. The existing users for that group are displayed in the User Name column.

3. Click Add User on the Edit Users form toolbar. The Add Database User dialog box is displayed.

4. In the New User Name box, type the name of the user to be added to the selected group.

5. In the Password box, type the password for the new user. An asterisk (*) character is displayed for each character entered.

6. In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered.

Note Both passwords entered in the Add Database User dialog box must be the same in order for the password to be accepted for the user.

7. If needed, select the Use Expiration check box. By default, the current date is already entered in the Date box. Type a different expiration date or click Calendar to select a date.

8. Click OK to accept the new user name into the selected group.


Delete a database group from the catalog

1. On the Security menu, click Users to open the Edit Users form.

2. Select the database group in the Group Name column of the Edit Users form to be deleted from the current catalog.

3. Click Delete Group on the Edit Users form toolbar.

4. Click OK as the response to an inquiry message about deleting the entire group.

Note You may also delete a database group by selecting the group name on the Users & Groups catalog object in the Catalog window and then choosing the Delete command on the User menu or the Delete shortcut in the User Common Tasks area of the Users & Groups catalog object. A message box will be displayed requesting confirmation of the delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.


Delete a user from a group

1. On the Security menu, click Users to open the Edit Users form.

2. Select a group in the Group Name column of the Edit Users form. The existing users for that group are displayed in the User Name column.

3. Select the user in the User Name column of the Edit Users form to be deleted from the selected group.

4. Click Delete User on the Edit Users form toolbar.

Note You may also delete a user from a group by selecting the user name on the Users & Groups catalog object in the Catalog window and then choosing the Delete command on the User menu or the Delete shortcut in the User Common Tasks area of the Users & Groups catalog object. If a user name has been selected, the user name is immediately deleted from the catalog without any confirmation message.


Change a group password

1. On the Security menu, click Users to open the Edit Users form.

2. Select the group in the Group Name column of the Edit Users form whose password is to be changed.

3. Click Edit Group Password on the Edit Users form toolbar.

The Change Password dialog box is displayed with the name of the selected group in the User Name box.

4. In the New Password box, type the new password for the group. An asterisk (*) character is displayed for each character entered.

5. In the Verify Password box, type the new password for a second time to make sure that the password was typed correctly in the New Password box. An asterisk (*) character is displayed for each character entered.

6. Modify the expiration date settings, if necessary.

7. Click OK to accept the new password for the specified group.

Note You can also reset a group password by not entering a password in either the New Password or Verify Password boxes, and then clicking OK in the Change Password dialog box. Leaving these boxes empty is equivalent to using the Reset Group Password button in the Edit Users form.


Change a user password

1. On the Security menu, click Users to open the Edit Users form.

2. Select a group in the Group Name column of the Edit Users form. The existing users for that group are displayed in the User Name column of the Edit Users form.

3. Select one or more users in the User Name column of the Edit Users form whose password is to be changed.

4. Click Edit User Password on the Edit Users form toolbar.

The Change Password dialog box is displayed with the User Name box containing the name of the first selected user of the group.

5. In the New Password box, type the new password for the user specified in the User Name box. An asterisk (*) character is displayed for each character entered.

6. In the Verify Password box, type the new password for a second time to make sure that the password was typed correctly in the New Password box. An asterisk (*) character is displayed for each character entered.

7. Modify the expiration date settings, if necessary.

8. Click OK to accept the new password and the verify password for the user specified in the User Name box.

Notes

· If more than one user was selected in Step 3, the Change Password dialog box is displayed for the next selected user of the group. Repeat Steps 5 through 7 for each of the selected users.

· You can also reset a user password by not entering a password in either the New Password or Verify Password boxes, and then clicking OK in the Change Password dialog box. Leaving these boxes empty is equivalent to using the Reset User Password button in the Edit Users form.


Reset a group password

1. On the Security menu, click Users to open the Edit Users form.

2. Select the group in the Group Name column of the Edit Users form whose password is to be reset.

3. Click Reset Group Password on the Edit Users form toolbar.

Resetting a password for the selected group results in the group not having a password. The group can be assigned a new password by using the Change Password dialog box.

Note You can also reset a group password by using either of the following methods:

· In the Edit Users form, click the Edit Group Password button. In this procedure, click OK in the Change Password dialog box without entering a password in either the New Password or Verify Password boxes.

· Click Reset Password on the User menu for a selected group name on the Users & Groups catalog object in the Catalog window.


Reset a user password

1. On the Security menu, click Users to open the Edit Users form.

2. Select a group in the Group Name column of the Edit Users form. The existing users for that group are displayed.

3. Select one or more users in the User Name column of the Edit Users form whose password is to be reset.

4. Click Reset User Password on the Edit Users form toolbar.

Resetting a password for the selected users results in the users not having a password. The users can be assigned a new password by using the Change Password dialog box.

Note You can also reset a user password by using either of the following methods:

· In the Edit Users form, click the Edit User Password button. In this procedure, click OK in the Change Password dialog box without entering a password in either the New Password or Verify Password boxes.

· Click Reset Password on the User menu for a selected user name on the Users & Groups catalog object in the Catalog window.


Print Users report

1. On the Reports menu, choose Print and then click Users to display the Select Users Report dialog box.

2. Select a report definition file from the List area. The name and a thumbnail version of the report will be displayed in the Preview area.

The recommended selection is the usr2.rul file, which has the description of the All Users by User Name report.

3. Click Open to display the Print Options dialog box.

4. Adjust the print options, if necessary.

5. Click Start to obtain a copy of the selected Users report.

Note See Reporting for more information on other reports that can be printed.


Defining Catalog Ownership

See Also

If a catalog is unowned, then a group is specified as the catalog owner by making the appropriate entries in the Change Catalog Owner dialog box.

If a catalog has an owner and the owner group (or a user of the owner group) is specified in the Logon dialog box, then the group owning the catalog is changed by making the appropriate entries in the Change Catalog Owner dialog box.

For detailed information about defining catalog ownership, see the following topics:

· Define owner of catalog

· Transfer ownership of catalog


Define owner of catalog

1. On the Security menu, click Change Catalog Owner. The Change Catalog Owner dialog box is displayed.

Alternatively, you can open this dialog when you select Users & Groups catalog object in the Catalog window and click the Change Catalog Owner shortcut from the User Common Tasks area.

Note This command or shortcut is available only if there is no owner or if logged on as the owner (or as a user of the owner group).

2. In the New Owner Name box, which contains the names of database groups associated with the current catalog, select an owner name from the list.

Note If this list is empty, you must first define one or more groups.

3. In the Password box, type the password for the group specified in the New Owner Name box. An asterisk (*) character is displayed for each character entered.

4. Click OK to accept the selected group as the new owner name and the password for the current catalog.

Ownership and a password have been established for the catalog for the first time. The owner group has all privileges for the database and all other groups have no privileges until the owner enables privileges for those groups.

Note After defining an owner of the catalog, it is recommended that you close the data source and then reopen it, logging in as a member of the owner group.


Transfer ownership of catalog

1. On the Security menu, click Change Catalog Owner. The Change Catalog Owner dialog box is displayed.

Alternatively, you can open this dialog when you select Users & Groups catalog object in the Catalog window and click the Change Catalog Owner shortcut from the User Common Tasks area.

Note This command or shortcut is available only if there is no owner or if logged on as the owner (or as a user of the owner group).

2. In the New Owner Name box, which contains the names of the database groups associated with the current catalog, select the name of the new owner from the list.

Note If the owner is not defined, you must define an owner of the catalog.

3. In the Password box, type the password for the group specified in the New Owner Name box. An asterisk (*) character is displayed for each character entered.

The entry in the Password box is compared with the password of the new owner group. The two passwords must be equal in order for the new owner to be accepted.

4. Click OK to accept the selected group as the new owner of the catalog.

Note After transferring ownership of the catalog, it is recommended that you close the data source. If you wish to continue working with the data source, you can then reopen the data source, logging in as whatever user is appropriate for the actions you plan to perform.


Defining Group Privileges

See Also

Groups are assigned privileges to a Relativity database with the appropriate actions in the Edit Privileges form. The granting of a privilege to a group of users provides a mechanism to protect data in a database. Instead of having access to all the data in a database, a granted privilege restricts the user's access only to the data needed to carry out the user's work.

When assigning privileges, there are three choices for each pairing of a group and a privilege, table, or column:

· Not Granted. The group does not have the selected privilege.

· Granted. The group has the selected privilege, but cannot grant it to other groups.

· With Grant. The group has the selected privilege and can grant that privilege to other groups.

To open the Edit Privileges form in the Relativity Designer window, do one of the following:

· On the Security menu, click Privileges.

· In the Catalog window, click the Users & Groups catalog object, select a group name and then click the Privileges shortcut in the User Common Tasks area or the Privileges command from the User menu.

After all the privileges have been defined in the Edit Privileges form, click Save Changes on the Edit Privileges form toolbar to accept all privileges for the database groups of the current catalog.

For detailed information on enabling privileges, choose from the following topics:

· Define privilege structure within a database

· Enable Administrator privileges

· Enable the Create Users privilege

· Enable the Create Tables privilege

· Enable Table privileges

· Enable Column privileges

· Print Privileges report


Define privilege structure within a database

The following actions define the structure of privileges for groups within a Relativity database:

1. Define groups and users of the database.

2. Define a group as the owner of the catalog. All privileges to the database are automatically given to the group having ownership of the catalog. .

3. Close the data source.

4. Open the data source. In the Logon dialog box, type a user name that is a member of the group defined in Step 2 as the owner of the catalog.

5. Enable the following privileges to the appropriate group or groups:

· Administrator privileges

· Create Users privilege

· Create Tables privilege

· Table privileges

· Column privileges

6. Assign appropriate privileges to the <PUBLIC> group. Privileges assigned to the <PUBLIC> group become privileges assigned to all users of the database.

Note Privileges are assigned from a grantor group. The grantor group is determined based on the log on information used prior to granting privileges. It may, therefore, be necessary during Steps 5 and 6 to close and reopen the data source, logging in as a member of the desired grantor group.


Enable Administrator Privileges

1. On the Security menu, click Privileges to open the Edit Privileges form.

Note You can also open the Edit Privileges form when a group name is selected on the Users & Groups catalog object in the Catalog window. From the User menu that appears on the menu bar of the Relativity Designer window, click Privileges. Alternatively, select a group on the Users & Groups catalog object and click the Privileges shortcut in the User Common Tasks area.

2. Select a group from the Group list for which privileges are to be assigned (that is, the grantee group). Note that when the form is opened from the Users & Groups catalog object, the selected group is already displayed in the Group list.

3. Select the Administrator privilege from the Privilege list.

The Create Groups, Date Constants, Reports, and Use Administrator privileges are displayed in the Not Granted, Granted, or With Grant columns of the Edit Privileges form depending on their current privilege status. Initially, a group has no Administrator privileges, so the Administrator privileges will be displayed in the Not Granted column. To view an example, click here.

4. Select one or more privileges in the Not Granted column that you wish to grant to the grantee group.

5. Click the Move Right button at the right of the Not Granted column to move the privilege(s) to the Granted column.

6. To enable the grantee group to grant Administrator privileges to other groups, select one or more privileges in the Granted column.

7. Click the Move Right button at the right of the Granted column to move the privilege(s) to the With Grant column.

Note Use the Move Left buttons to reduce privileges assigned to a group.

· This button to the left of the With Grant column moves selected privilege(s) in the With Grant column to the Granted column.

· This button to the left of the Granted column moves selected privilege(s) in the Granted column to the Not Granted column.


Enable the Create Users Privilege

1. On the Security menu, click Privileges to open the Edit Privileges form.

Note You can also open the Edit Privileges form when a group name is selected on the Users & Groups catalog object in the Catalog window. From the User menu that appears on the menu bar of the Relativity Designer window, click Privileges. Alternatively, select a group on the Users & Groups catalog object and click the Privileges shortcut in the User Common Tasks area.

2. Select a group from the Group list for which privileges are to be assigned (that is, the grantee group). Note that when the form is opened from the Users & Groups catalog object, the selected group is already displayed in the Group list.

3. Select the Create Users privilege from the Privilege list.

The database groups defined for the current catalog, but not including the owner or currently logged in group, are displayed in the Not Granted, Granted, or With Grant columns of the Edit Privileges form depending on their current privilege status. Initially, a group does not have the Create Users privilege for any other group, so all group names will be displayed in the Not Granted column. To view an example, click here.

4. Select one or more groups in the Not Granted column for which the privilege to create users is to be granted to the grantee group.

5. Click the Move Right button at the right of the Not Granted column to move the selected groups to the Granted column.

6. To enable the grantee group to grant the Create Users privilege to other groups, select one or more groups in the Granted column.

7. Click the Move Right button at the right of the Granted column to move the selected groups to the With Grant column.

Note Use the Move Left buttons to reduce privileges assigned to the selected group.

· This button to the left of the With Grant column moves selected group(s) in the With Grant column to the Granted column.

· This button to the left of the Granted column moves selected group(s) in the Granted column to the Not Granted column.


Enable the Create Tables Privilege

1. On the Security menu, click Privileges to open the Edit Privileges form.

Note You can also open the Edit Privileges form when a group name is selected on the Users & Groups catalog object in the Catalog window. From the User menu that appears on the menu bar of the Relativity Designer window, click Privileges. Alternatively, select a group on the Users & Groups catalog object and click the Privileges shortcut in the User Common Tasks area.

2. Select a group from the Group list for which privileges are to be assigned (that is, the grantee group). Note that when the form is opened from the Users & Groups catalog object, the selected group is already displayed in the Group list.

3. Select the Create Tables privilege from the Privilege list.

The table definition for the current database are displayed in the Not Granted, Granted, or With Grant columns of the Edit Privileges form depending on their current privilege status. Initially, a group does not have the ability to create tables, so all table definition names will be displayed in the Not Granted column. To view an example, click here.

4. Select one or more table definition names in the Not Granted column for which the privilege to create tables is to be granted to the grantee group.

5. Click the Move Right button at the right of the Not Granted column to move the selected table definition names to the Granted column.

6. To enable the grantee group to grant the Create Tables privilege to other groups, select one or more table definition names in the Granted column.

7. Click the Move Right button at the right of the Granted column to move the selected table definition names to the With Grant column.

Note Use the Move Left buttons to reduce privileges assigned to the selected group.

· This button to the left of the With Grant column moves selected table definition name(s) in the With Grant column to the Granted column.

· This button to the left of the Granted column moves selected table definition name(s) in the Granted column to the Not Granted column.


Enable Table Privileges

1. On the Security menu, click Privileges to open the Edit Privileges form.

Note You can also open the Edit Privileges form when a group name is selected on the Users & Groups catalog object in the Catalog window. From the User menu that appears on the menu bar of the Relativity Designer window, click Privileges. Alternatively, select a group on the Users & Groups catalog object and click the Privileges shortcut in the User Common Tasks area.

2. Select a group from the Group list for which privileges are to be assigned (that is, the grantee group). Note that when the form is opened from the Users & Groups catalog object, the selected group is already displayed in the Group list.

3. Select a Table privilege (one that begins with the word "Table") from the Privilege list. (To read about the special characteristics of the Table All privilege, click here.)

The table names for the current database are displayed in the Not Granted, Granted, or With Grant columns of the Edit Privileges form depending on their current privilege status. Initially, a group has no Table privileges, so all table names will be displayed in the Not Granted column. To view an example, click here.

Note The setting of the Independent "SELECT" privilege check box on the Privileges page in the Options dialog box affects the behavior of assigning and removing Table privileges.

4. Select one or more table names in the Not Granted column for which the selected Table privilege is to be granted to the grantee group.

5. Click the Move Right button at the right of the Not Granted column to move the selected table names to the Granted column.

The group has been given the selected Table privilege on all columns of the tables associated with the table names appearing in the Granted column of the Edit Privileges form.

The group does not have access rights to the tables associated with the table names appearing in the Not Granted column of the Edit Privileges form.

6. To enable the grantee group to grant the selected Table privilege to other groups, select one or more table names in the Granted column.

7. Click the Move Right button at the right of the Granted column to move the selected table names to the With Grant column.

Note Use the Move Left buttons to reduce privileges assigned to the selected group.

· This button to the left of the With Grant column moves selected table name(s) in the With Grant column to the Granted column.

· This button to the left of the Granted column moves selected table name(s) in the Granted column to the Not Granted column.


Enable Column Privileges

1. On the Security menu, click Privileges to open the Edit Privileges form.

Note You can also open the Edit Privileges form when a group name is selected on the Users & Groups catalog object in the Catalog window. From the User menu that appears on the menu bar of the Relativity Designer window, click Privileges. Alternatively, select a group on the Users & Groups catalog object and click the Privileges shortcut in the User Common Tasks area.

2. Select a group from the Group list for which privileges are to be assigned (that is, the grantee group). Note that when the form is opened from the Users & Groups catalog object, the selected group is already displayed in the Group list.

3. Select a Column privilege (one that begins with the word "Column") from the Privilege list. The Table list is displayed on the form. (To read about the special characteristics of the Column All privilege, click here.)

Note The setting of the Independent "SELECT" privilege check box on the Privileges page in the Options dialog box affects the behavior of assigning and removing Column privileges.

4. Select a table name from the Table list.

The column names defined for the selected table are displayed in the Not Granted, Granted, or With Grant columns of the Edit Privileges form depending on their current privilege status. Initially, a group has no Column privileges, so all column names will be displayed in the Not Granted column. To view an example, click here.

5. Select one or more column names in the Not Granted column for which the selected Column privilege is to be granted to the grantee group for the selected table name.

6. Click the Move Right button at the right of the Not Granted column to move the selected column names to the Granted column.

The group has been given the selected Column privilege on all columns appearing in the Granted column of the Edit Privileges form.

The group does not have access rights to the columns appearing in the Not Granted column of the Edit Privileges form.

7. To enable the group to grant the selected Column privilege to other groups, select one or more column names in the Granted column.

8. Click the Move Right button at the right of the Granted column to move the selected column names to the With Grant column.

Note Use the Move Left buttons to reduce privileges assigned to the selected group.

· This button to the left of the With Grant column moves selected column name(s) in the With Grant column to the Granted column.

· This button to the left of the Granted column moves selected column name(s) in the Granted column to the Not Granted column.


Print Privileges report

1. On the Reports menu, choose Print and then click Privileges to display the Select Privileges Report dialog box.

2. Select a report definition file from the List area. The name and a thumbnail version of the report will be displayed in the Preview area.

The recommended selection is the grantee1.rpl file, which has the description of the Privileges by Grantee report.

3. Click Open to display the Print Options dialog box.

4. Adjust the print options, if necessary.

5. Click Start to obtain a printed copy of the selected Privileges report.

Note See Reporting for information on other reports that can be printed.


Reference Information

Welcome to Relativity Window

Relativity Designer Window

Options Dialog Box

Catalog Window

COBOL Definition Forms

Relational Definition Forms

Administration Forms

Dialog Boxes


Welcome to Relativity Window

See Also

The Welcome to Relativity window appears when you first install and start the Relativity Designer. From this window, you can set up and create a new data source, or open an existing or most recently used Relativity data source. After completing the first session with Relativity, the most recently used data source is always selected by default in this window when you start Relativity again.

Note The step-by-step procedures in the Relativity Designer Help file assume that you have disabled this window after the initial installation by clearing the Show Welcome at Startup check box. Subsequently, when you start Relativity, you will begin all operations in the main Relativity Designer window. You may, however, enable this capability again by choosing Welcome from the Tools menu.

The Welcome to Relativity window contains the following options.

Option

Description

Recent

Select the Recent option to open the data source that you have most recently used in the Relativity Designer. When you select this option, a numbered list--in the order of the most recently opened data sources--is displayed in the List area and the data source most recently used is highlighted.

To quickly reopen one of these data sources, click it. If one of these data sources is selected from this list, any open, existing data source is closed, and the selected data source is opened.

Note This option corresponds to the Most Recently Used Data Source command on the File menu.

New

Select the New option to set up and create a new data source. (An ODBC data source name is used to refer to the database, indirectly through the Relativity catalog that describes the database.) If you have multiple drivers installed, select the appropriate driver from the List area and then create a new data source. For more information, see Setting Up a New Data Source.)

Note This option provides the same functionality as the New Data Source command on the File menu.

Existing

Select the Existing option to open and maintain an existing catalog that supports the Relativity database specified by the data source. When you select this option, a list of all the existing data sources is displayed in the List area. If you have multiple drivers installed, a list will appear in a box to the right of this option, indicating that the existing catalogs displayed are associated with the data source for the selected driver.

To quickly open one of these data sources, click it. If one of these data sources is selected from this list, any open, existing data source is closed, and the selected data source is opened. For more information, see Opening a Data Source.)

Note This option provides the same functionality as the Open Data Source command on the File menu.

Driver

If multiple drivers are installed on your system, you can select the appropriate driver from the Driver list box in order to create and set up a new data source or open an existing data source.

List

The List area varies in its appearance depending on which of the options is selected:

· If the New option is selected, the List area allows you to select the appropriate driver (if multiple drivers are installed on your system) and then create a new data source. To see an example, click here.

· If either the Recent or Existing option is selected, the List area allows you to quickly open an existing or reopen a most recently used data source. Note that if a data source is selected from this list, any open, existing data source is closed, and the selected data source is opened.

The data sources displayed in this list depend on which option is selected:

-  If the Existing option is selected, the list displays the available catalogs associated with the data source (for the selected driver, if necessary).

-  If the Recent option is selected, a numbered list displays up to the last four data sources recently opened by the Relativity Designer. The default number of data sources displayed is four. This number can be adjusted by adding the following entry (or modifying an existing entry) in the [Designer] section of the RELDBDSN.INI file:

RecentFileCount=n

where n is a number from 0 to 9.

Show Welcome at Startup

By default, this option is selected when you first install and start the Relativity Designer. If this option remains enabled, the Welcome to Relativity window displays each time you start the Relativity Designer. If you disable this option, you can choose Welcome from the Tools menu to enable it again.

Cancel

The Cancel button cancels all selections and closes the Welcome to Relativity window.

OK

· If you click OK after selecting the New option, you set up a new data source.

· If you click OK after selecting either the Existing or Recent option, the Catalog window for the specified data source is opened. Note that if security has been defined for the catalog associated with the data source, you must complete the Logon dialog box.


Relativity Designer Window

See Also

If you have disabled the Show Welcome at Startup option on the Welcome to Relativity window, the Relativity Designer window is displayed when you start the Relativity Designer. This main window contains four regions: title bar, menu bar, desktop area, and status bar. Each region has specific uses and functions. For information about the key components of the Relativity Designer window, choose one of the following topics:

· Title Bar

· Menu Bar

· Status Bar

By default, the Catalog window is displayed in the desktop region of the Relativity Designer main window when a Relativity catalog (the mechanism that supports the Relativity database specified by the ODBC data source) is opened. This is the point of origin for many of the activities related to structuring the COBOL data so that it can be viewed in a relational table. Within the Catalog window, you can select from a list of catalog objects that include definitions of files, tables, and reports. You also can view user and group definitions.


Title Bar

The title bar, displayed at the top of the Relativity Designer window, contains the name "Relativity Designer." In addition, the title bar displays the name of the data source if any data source is open.

To move the Relativity Designer window to a different location:

1. Point the cursor at the text display section of the title bar.

2. Press and hold the primary mouse button.

3. Drag the window by moving the mouse.

4. Release the mouse button.

You can move, close, maximize, minimize, or restore the Relativity Designer window by using the four icons in the title bar.

Note The information presented here applies to any form in the Relativity Designer that contains a title bar and these icons/buttons.

Icon | Description
Control menu | The Control menu (also known as the System menu) icon is a pictorial equivalent of the Control menu used to manipulate the window. This icon is located at the far leftmost position on the title bar. The Control menu contains the menu commands: Restore, Move, Size, Minimize, Maximize, and Close.
 | The Minimize icon is a pictorial equivalent of the Minimize command to shrink a window to an icon. This icon is the third button from the right on the title bar.
 | The Maximize icon is a pictorial equivalent of the Maximize command to enlarge an icon to a window. This icon occupies the second button position from the right on the title bar.
 | The Restore icon is present when the window fills the inside of another window or if a window fills the screen. The Restore icon is a pictorial equivalent of the Restore command to restore an icon or maximized window to its previous window size.
 | You can also quit a program by clicking the Close icon at the far right of the title bar. Shortcut: Alt+F4


Menu Bar

The Relativity Designer menu bar, which is located below the title bar in the Relativity Designer window, contains the names of the menus. The menu names and commands that appear depend on whether a data source has been opened. Menus that are not currently available are temporarily removed from the menu bar.

· If a data source has not been opened, the File, Reports, Tools, Window, and Help menus are visible.

· If a data source has been opened, the menu bar contains the additional names View and Security.

· Depending on whether Files, Tables, or Users & Groups is selected as the catalog object in the Catalog window, either an FD, Table, or User menu will also appear on the menu bar. Furthermore, if the Edit Connections form is displayed, the Connection menu will appear on the menu bar.

Clicking a menu name displays a list of commands for accessing various Relativity Designer operations. Choose one of the following topics for more information about the commands located on each menu:

· File Menu Commands

· FD Menu Commands

· Table Menu Commands

· User Menu Commands

· View Menu Commands

· Security Menu Commands

· Connection Menu Commands

· Reports Menu Commands

· Tools Menu Commands

· Window Menu Commands

· Help Menu Commands


File Menu Commands

The commands displayed on the File menu of the Relativity Designer window depend on whether a data source has been opened and selected for processing.

Choose

To

New Data Source

Set up a new data source. (The Relativity Designer assumes the currently selected Relativity DBMS as the ODBC driver.) For more information, see Setting up a New Data Source.

In single-tier (non-client/server) versions of Relativity, the File Manager tab of the Relativity setup data source dialog box is displayed. In client/server versions of Relativity (in order to associate a Data Client data source with a Data Server data source), the ODBC Relativity C/S Setup dialog box is displayed.

Shortcut: Ctrl+N

Note The New Data Source command provides the same functionality as the New option in the Welcome to Relativity window.

Open Data Source

Display the Open Relativity Data Source dialog box in order to select the name of an existing data source to be processed. If security has been defined for the catalog associated with this data source, the Logon dialog box opens. If security has not been defined for the catalog associated with this data source, the Catalog window opens with the selected data source name in the title bar. See Opening a Data Source.

Shortcut: Ctrl+O

Note The Open Data Source command provides the same functionality as the Existing option in the Welcome to Relativity window.

Close Data Source

Terminate the processing of the data source identified by the name in the title bar of the Relativity Designer window. Any form that is open within the data source is also closed by clicking this command. See Closing a Data Source.

Shortcut: Ctrl+D

Driver

Select an installed ODBC driver.

Note This command appears as an option only if multiple ODBC drivers have been installed for Relativity.

Most Recently Used Data Source

Display up to the last nine data sources opened by the Relativity Designer. If one of these data sources is selected, any existing data source is closed, and the selected data source is opened. The default number of data sources displayed is four. This number can be adjusted by adding the following entry (or modifying an existing entry) in the [Designer] section of the RELDBDSN.INI file:

RecentFileCount=n

where n is a number from 0 to 9.

Notes

· To select a data source from the list, simply click the filename from the menu with the mouse or type the number that appears to the left of the name.

· The Most Recently Used Data Source command provides the same functionality as the Recent option in the Welcome to Relativity window.

Exit

Terminate the execution of the Relativity Designer. See Starting the Relativity Designer.


FD Menu Commands

The FD menu appears on the menu bar of the Relativity Designer window when a Files catalog object is selected in the Catalog window or when the FD form is open for the selected COBOL file definition. The FD menu contains a different set of commands depending upon the current context:

· When the focus is on the Catalog window, the FD menu includes (but is not limited to) general commands that can be performed on more than one file definition.

· When the focus is on a file definition opened in the FD form, the FD menu contains commands that can be performed on only that file.

Note In addition to the drop-down menus on the menu bar, Relativity offers context-sensitive menus that pop up at the click of the right mouse button. To open a context menu of the commands on the FD menu, right-click a COBOL file definition when Files is selected as the catalog object in the Catalog window or a data item is selected in the FD form. From the pop-up context menu, choose the command you need.


FD Menu Commands for a Files Catalog Object

When focus is on the Catalog window for a Files catalog object, the FD menu includes the following commands.

Choose

To

Open

Display the FD form for the selected COBOL file definition in the Catalog window.

Note The Open command provides the same functionality as the Open shortcut on the FD Common Tasks area of the Files catalog object (or the Open button on the Files tab when Tabbed layout mode is selected).

Rename

Open the Rename file dialog box, where you can rename the FD for a file selected in the Catalog window.

Import COBOL FDs

Move information about the file description entries and the associated record descriptions of one or more COBOL files to the Relativity catalog . The Source Code Import wizard is displayed for the selection of the COBOL data files for the importing process. See Importing COBOL File Definitions and Creating a COBOL Schema File.

Note The Import COBOL FDs command provides the same functionality as the Import COBOL FDs shortcut on the FD Common Tasks area of the Files catalog object (or the New button on the Files tab when Tabbed layout mode is selected).

Merge COBOL FD Changes

Merge new (or changed) COBOL file definitions with corresponding definitions existing in the Relativity catalog. The Source Code Merge wizard is displayed for the selection of the COBOL data files for the merging process. See Merging COBOL File Definitions.

Note The Merge COBOL FD Changes command provides the same functionality as the Merge COBOL FD Changes shortcut on the FD Common Tasks area of the Files catalog object (or the Merge button on the Files tab when Tabbed layout mode is selected).

Reset Previous Flag

Remove the previous flag. After COBOL FD changes have been merged, two files having the same name appear in the Catalog window when Files is selected as the catalog object. The word "Previous" will display in parentheses following the "old" filename.

Note This command appears only after COBOL FD changes have been merged and the “old” filename has been selected.

Table Wizard

Display the Table wizard, which simplifies the creation of a table by automating the selection of elementary items in the FD form, the addition or removal of items to or from the table, and the editing of column names. See Using the Table Wizard.

Note The Table Wizard command provides the same functionality as the Table Wizard shortcut on the FD Common Tasks area of the Files catalog object (or the Table Wizard button on the Files tab when Tabbed layout mode is selected).

Delete FD

Remove the selected the file-name of the file definition from the Relativity catalog. A message box will be displayed requesting confirmation of the delete request.

If there are any table definitions based on the file definition, a second confirmation message box informs the user of the existing tables.

If the user confirms the deletion, the file definition and any table definitions based on that file definition are deleted from the catalog.

A file definition also may be deleted from the catalog by selecting the file-name and pressing the Del (Delete) key.

Note The Delete FD command provides the same functionality as the Delete FD shortcut on the FD Common Tasks area of the Files catalog object (or the Delete FD button on the FD form toolbar).

Delete Multiple FDs

Display the Select Files to Delete dialog box where you can remove selected multiple file definitions from the Relativity catalog.

· To select multiple file definitions in the dialog box, press and hold down the Ctrl key, and then click each individual item you want to delete.

· To select a group of file definitions that are next to each other, press and hold down the Shift key, and then click the first and last item in the group.

After the items are selected, press the Delete key. A message box will be displayed requesting confirmation of each delete request.

If there are any table definitions based on the file definition, a second confirmation message box informs the user of the existing tables. If the user confirms the deletion, the file definition and any table definitions based on that file definition are deleted from the catalog. To dismiss the dialog box, click Cancel.

Properties

Display the FD Properties form for the selected file in the Catalog window or in the FD form. The properties shown include the COBOL file-name, the file organization, the minimum and maximum record size (or length), and comments, as well as the key structure, record types and filters, and all the tables built from the selected file definition.

Note The Properties command provides the same functionality as the FD Properties button on the FD form toolbar.


FD Menu Commands for the FD Form

When focus is in the FD form, the FD menu includes the following commands.

Choose

To

Save FD Changes

Write into the Relativity catalog all additions, changes, and deletions made to the record description displayed in the FD form for a COBOL file. If the FD form is closed with uncommitted changes, there will be a prompt asking if any pending changes should be saved or not. This behavior can be controlled by the Save FD Changes check box on the File page in the Options dialog box.

Note The Save FD Changes command provides the same functionality as the Save Changes button on the FD form toolbar.

Delete FD

Remove the selected the file-name of the file definition from the Relativity catalog. A message box will be displayed requesting confirmation of the delete request.

If there are any table definitions based on the file definition, a second confirmation message box informs the user of the existing tables.

If the user confirms the deletion, the file definition and any table definitions based on that file definition are deleted from the catalog.

A file definition also may be deleted from the catalog by selecting the file-name and pressing the Del (Delete) key.

Note The Delete FD command provides the same functionality as the Delete FD shortcut on the FD Common Tasks area of the Files catalog object (or the Delete FD button on the FD form toolbar).

Create Table

Open the Table Wizard to create a relational table from the FD's record description. The wizard simplifies the creation of a table by automating the selection of elementary items from the FD form, the addition or removal of items to or from the table, and the editing of column names.

Note The Create Table command provides the same functionality as the Table Wizard shortcut on the File Common Tasks area of the Files catalog object (or the Table Wizard button on the Files tab when Tabbed layout mode is selected).

Add Redefines

Display the Add COBOL Data Item Redefinition dialog box for the definition of a data item that redefines the selected data item in the FD form. See Redefining Data Items.

Note The Add Redefines command provides the same functionality as the Add Data Item button on the FD form toolbar.

Add 88

Display the Add Condition Item dialog box for the definition of a condition-name for the selected data item in the FD form or for the modification of an added condition item. See Adding Condition Items.

Note The Add 88 command provides the same functionality as the Add Condition Item button on the FD form toolbar.

Add Function

Display the Select Function dialog box to allow selection of a function to add to the FD as a synthesized data item. See Synthesize a data item using an internal function.

Note The Add Function command provides the same functionality as the Add Function button on the FD form toolbar.

Add File Label

Open the Add File Label dialog box where you can create a special file definition item, called a file label item, which is added to the file's FD. See Supporting Multi-File Tables.

Record Type

Display a submenu that allows you to maintain the different record type(s) associated with a file in the FD form:

· Choose Add Select Item(s) to Record Type to add selected data item(s) in the FD to the record type. (This command provides the same functionality as the Add Item button on the Record Type Toolbar.)

· Choose Remove Selected Item(s) to remove data items from a record type. (This command provides the same functionality as the Delete Item button on the Record Type Toolbar.)

· Choose Create New Record Type to open the Add Record Type dialog box, where you can define the record-name of the selected data items in the FD form that will be associated with the new record type. (This command provides the same functionality as the < new record type > option in the Record Type: list on the Report Type toolbar.)

· Choose the Record Type Filter command to open the Record Type Properties form, where you can define and edit a record type filter to specify the conditions that control the records that participate in providing data to a table based on the record type. (This command provides the same functionality as the Properties button on the Record Type toolbar.)

For more information, see Defining Record Types and Defining Record Type Filters.

Find

Open the Find COBOL Item dialog box, where you can search for a COBOL data item in the FD form.

Shortcut: Ctrl+F

Note This command provides the same functionality as the Find button on the FD form toolbar.

Find Next

Repeat the search specified in the Find COBOL Item dialog box.

Shortcut: F3

Note This command provides the same functionality as the Find Next button on the FD form toolbar.

Assign Default Data Types

Assign user data types based on the item patterns defined prior to editing of the FD form and the Table form.

If the FD contains a COBOL data item that matches the criteria for more than one item pattern, the Select Data Type dialog box is displayed so that you can indicate which item pattern to apply.

Note This command provides the same functionality as the Assign Default Data Types button on the FD form toolbar.

Properties

Display the FD Properties form for the selected file in the Catalog window or in the FD form. The properties shown include the COBOL file-name, the file organization, the minimum and maximum record size (or length), and comments, as well as the key structure, record types and filters, and all the tables built from the selected file definition.

Note The Properties command provides the same functionality as the FD Properties button on the FD form toolbar.


Table Menu Commands

The Table menu appears on the menu bar of the Relativity Designer window when a Tables catalog object is selected in the Catalog window or when a table is open in the Table form. The Table menu contains a different set of commands depending upon the current context:

· When the focus is on the Catalog window, the Table menu includes (but is not limited to) general commands that can be performed on more than one table.

· When the focus is on a table opened in the Table form, the Table menu contains commands that can be performed on only that table.

Note In addition to the drop-down menus on the menu bar, Relativity offers context-sensitive menus that pop up at the click of the right mouse button. To open a context menu of the commands on the Table menu, right-click a table definition when Tables is selected as the catalog object in the Catalog window or a table name is selected on the FD Properties form. To access a context menu from the Table form attribute grid, select the appropriate column definition(s) and right-click. From the pop-up context menu, choose the command you need.


Table Menu Commands for a Table Catalog Object

When focus is on the Catalog window for a Tables catalog object, the Table menu includes the following commands.

Choose

To

New

Display a blank Table form for the creation of a new table.

Note The New command provides the same functionality as the New shortcut on the Table Common Tasks area of the Tables catalog object (or the New button on the Tables tab when Tabbed layout mode is selected).

Open

Display the Table form for the selected table definition in the Catalog window.

Note The Open command provides the same functionality as the Open shortcut on the Table Common Tasks area of the Tables catalog object (or the Open button on the Tables tab when Tabbed layout mode is selected).

Copy

Open the Copy table name dialog box, where you can copy a selected table and give it a new table name .

Note The Copy command provides the same functionality as the Copy shortcut on the Table Common Tasks area of the Tables catalog object.

Rename

Open the Rename table dialog box for a table selected in the Catalog window. If a table is being renamed, the rename process will rename the table definition and, optionally, change the table connection name. If a table connection has the same name as the table being renamed, a message box will give you the option to rename the connection at the same time the definition is renamed. If there are any open file definitions or table definitions that will be affected by the rename, they will be closed automatically during the rename process. A table name must not be an SQL reserved word. See Establishing Table Connections.

Note The Rename command provides the same functionality as the Rename shortcut on the Table Common Tasks area of the Tables catalog object.

Export DDL

Display the Export DDL dialog box for the selected table definition in the Catalog window or in the Table form.

Show Table Contents

Open the Show Table Contents form for the selected table, where you can preview data about the contents of the table.

Note The Show Table Contents command provides the same functionality as the Show Table Contents shortcut on the Table Common Tasks area of the Tables catalog object.

Query Builder

Open the Query Builder form for the selected table, where you can create a query.

Show Indexes

Open the Show Indexes for Tablename form, where you can view the indexes for a selected table in the Catalog window.

Delete

Remove the selected table definition from the Relativity catalog or the entire table displayed in the Table form. A message box will be displayed requesting confirmation of the delete request.

Note The Delete command provides the same functionality as the Delete Table button in the Table form toolbar and the Delete shortcut on the Table Common Tasks area of the Tables catalog object.

Delete Multiple Tables

Display the Select Tables to Delete dialog box to remove selected multiple table definitions from the Relativity catalog.

· To select multiple table definitions in the dialog box, press and hold down the Ctrl key, and then click each individual item you want to delete.

· To select a group of table definitions that are next to each other, press and hold down the Shift key, and then click the first and last item in the group.

After the items are selected, press the Delete key. A message box will be displayed requesting confirmation of each delete request. To dismiss the dialog box, click Cancel.


Table Menu Commands for the Table Form

When focus is in the Table form, the Table menu includes the following commands.

Choose

To

Save Table Changes

Note that this command behaves differently depending on whether the table definition is new or already exists:

· If the table definition is new, the Save Table Changes command displays the Create New Table dialog box, which allows a name to be assigned to the table.

· If the table definition already exists, the Save Table Changes command writes into the Relativity catalog all additions, changes, and deletions made to the table description displayed in the Table form. If the Table form is closed with unsaved (or uncommitted) changes, there will be a prompt asking if any pending changes should be saved or not.

This behavior can be controlled by the Save Table Changes check box on the Table page in the Options dialog box.

Note This command provides the same functionality as the Save Changes button on the Table form toolbar.

Move Column Up

Move one or more selected column definition(s) up one position in the table. For information on selecting column definitions, click here.

Note The Move Column Up command provides the same functionality as the Move Up button on the Table form toolbar.

Move Column Down

Move one or more selected column definition(s) down one position in the table. For information on selecting column definitions, click here.

Note The Move Column Down command provides the same functionality as the Move Down button on the Table form toolbar.

Edit Table Filter

Display the Table Filter Properties form to define the conditions for determining records that participate in providing data to the table viewed in the Table form. See Defining Table Filters.

Note The Edit Table Filter command provides the same functionality as the Edit Table Filter button on the Table form toolbar.

Edit Connections

Display the Edit Connections form to define the connections between the table and its underlying files. See Establishing Table Connections.

Note The Edit Connections command provides the same functionality as the Edit Connections button on the Table form toolbar or the Connections command on the Security menu.

Show Table Contents

Display the Show Table Contents form containing data from the underlying COBOL file for selected columns in the Table form. See Previewing Table Data.

If no columns are selected, all columns will be displayed. The Show button is enabled only if there is exactly one table connection for the table definition displayed in the Table form. If there is no table connection or more than one table connection, see the Edit Connections form.

Note The Show Table Contents command provides the same functionality as the Show button on the Table form toolbar.

Find

Open the Find dialog box, where you can specify the criteria for your search in the Column Name column in the Table form. The search criteria are not highlighted when found, but rather the row selector is moved to the row where the criteria are located. This dialog box also optionally allows you to replace the search criteria by clicking the Replace button to open the Find and Replace dialog box. Replace behaves much the same as Find, except the Find What text is removed and replaced by the Replace With text.

Shortcut: Ctrl+F

Note The Find command provides the same functionality as the Find button on the Table form toolbar.

Find Next

Repeat the search specified in the Find dialog box or the Find and Replace dialog box.

Shortcut: F3

Note The Find Next command provides the same functionality as the Find Next button on the Table form toolbar.

Find Selected Item in FD

Display the table’s parent FD form highlighting the data item used to create the selected column name in the Table form.

Note The Find Selected Item in FD command provides the same functionality as the Open FD button on the Table form toolbar.


User Menu Commands

The User menu appears on the menu bar of the Relativity Designer window when a Users & Groups catalog object is selected in the Catalog window.

Note In addition to the drop-down menus on the menu bar, Relativity offers context-sensitive menus that pop up at the click of the right mouse button. To open a context-sensitive menu of the commands on the User menu, right-click a group or user name when Users & Groups is selected as the catalog object in the Catalog window. From the pop-up context menu, choose the command you need.

Choose

To

Add User

Display the Add Database User dialog box for the entry of a new user name, an optional password, and an expiration date for the user name.

Note The Add User command provides the same functionality as the Add User button on the Edit Users form toolbar and the Add User shortcut on the User Common Tasks area of the Users & Groups catalog object.

Add Group

Display the Add Database Group dialog box for the entry of a new group name, an optional password, and an expiration date for the group name.

Note The Add Group command provides the same functionality as the Add Group button on the Edit Users form toolbar and the Add Group shortcut on the User Common Tasks area of the Users & Groups catalog object.

Edit Group or
Edit User

Display either the Edit Group dialog box or Edit User dialog box for a group or user selected in the Catalog window. Use this dialog to rename a group or user, or change other characteristics of the group structure by adding or modifying an existing, optional password, verifying an existing password, and assigning or modifying an expiration date for the group or user name.

Reset Password

Immediately remove the current password for the user or group name selected in the Catalog window.

Note The Reset Password command provides the same functionality as the Reset Group Password or the Reset User Password buttons on the Edit Users form toolbar.

Privileges

Display the Edit Privileges form for the selected group in the Catalog window. (You also can access this form by choosing the Privileges command on the Security menu.)

Note The Privileges command provides the same functionality as the Privileges shortcut on the User Common Tasks area of the Users & Groups catalog object (or the Privileges button on the Users tab when Tabbed layout mode is selected). If a group is not selected, however, the Privileges shortcut (or button) is disabled.

Delete

Remove the selected group or user from the catalog. If a user name has been selected, the user name is immediately deleted. A message box, however, will be displayed requesting confirmation of a delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.

Note The Delete command provides the same functionality as the Delete shortcut on the User Common Tasks area of the Users & Groups catalog object (or the Delete button on the Users tab when Tabbed layout mode is selected).


View Menu Commands

The View menu of the Relativity Designer window is displayed in the menu bar when a data source has been selected for processing.

Choose

To

Files

Select Files as the catalog object in the Catalog window showing a list of file definitions in the data source.

Shortcut: Ctrl+L

Tables

Select Tables as the catalog object in the Catalog window showing a list of table definitions in the data source.

Shortcut: Ctrl+T

Users

Select Users as the catalog object in the Catalog window showing a list of groups and users defined for the data source.

Shortcut: Ctrl+U

Reports

Select Reports as the catalog object in the Catalog window showing a list of defined reports.

Shortcut: Ctrl+R

Layout

Display a submenu that allows you to choose the appearance of the Relativity Designer interface:

· Choose the Tabbed command to configure the display of the Designer in the exact same manner (series of tab layouts) as earlier versions with which you may be most familiar.

· Choose the XP Look & Feel command to display the Designer with the new Windows XP theme and visual styles. This is the default view when you open a Relativity data source.


Security Menu Commands

The Security menu of the Relativity Designer window is displayed in the menu bar when a data source has been selected for processing.

Choose

To

Connections

Display the Edit Connections form for the defining and editing of a table connection.

A table connection is composed of a table name and a path name (and a file label, if file labels are in effect). The table name is the name of an SQL table. The path name is the physical filename of a data file. A file label item makes it possible to differentiate among data artifacts in a file at the query level. All table connections associated with the same Relativity table definition have identical characteristics except for the path name of the underlying data files. See Establishing Table Connections.

Notes

· Whenever the Edit Connections form is displayed, a Connection menu appears on the menu bar in the Relativity Designer window.

· The Connections command provides the same functionality as the Connections shortcut on the Table Common Tasks area of the Tables catalog object or the Edit Connections button on the Table form toolbar.

Privileges

Display the Edit Privileges form . Groups are assigned privileges to a Relativity catalog with appropriate actions in the Edit Privileges form. See Defining Group Privileges.

Note The Privileges command provides the same functionality as the Privileges command on the User menu or the Privileges shortcut on the Users & Groups catalog object when a group is selected.

Users

Display the Edit Users form . Groups and users are assigned to a Relativity catalog with appropriate actions in the Edit Users form. See Defining Groups and Users.

Change Catalog Owner

Display the Change Catalog Owner dialog box . The Change Catalog Owner dialog box displays options for a new owner name and an optional password. See Defining Catalog Ownership.

Note The Change Catalog Owner command provides the same functionality as the Change Catalog Owner shortcut on the Users & Groups catalog object.


Connection Menu Commands

See Also

The Connection menu of the Relativity Designer window is displayed in the menu bar when the Edit Connections form is displayed. The commands available on the Connection menu vary depending on several factors:

· The manner in which the Edit Connections form was opened.

-  If the Edit Connections form is opened with the Connections command from the Security menu, the Edit Connections form lists all currently existing table definitions and the Add Table, Edit Table Connection, and the Global (Add, Delete, and Edit) commands are enabled on the Connection menu.

-  If the Edit Connections form is opened from the Tables catalog object in the Catalog window or from the Table form, the Edit Connections form displays only the table definition currently selected on the Tables catalog object in the Catalog window or in the Table form. In this case, only the Add Table and Edit Table Connection commands are enabled in the Connection menu.

· Which item is selected in the Edit Connections form.

-  If the table definition is selected, the Add Table and Edit Table Connection commands are enabled. (If you have opened the form with the Connections command on the Security menu, then the Global Add, Global Delete, and Global Edit commands also are available.)

-  If a table name is selected, the Add Connection, Delete Table, Rename, and Show Data commands are enabled. (If you have opened the form with the Connections command on the Security menu, then the Global Add, Global Delete, and Global Edit commands also are available.)

-  If the path name is selected, the Rename command is enabled. (If you have opened the form with the Connections command on the Security menu, then the Global Add, Global Delete, and Global Edit commands also are available.)

· Whether file labels are in effect.

-  If a file label item has been defined, and a table name is selected, the Add Connection, Delete Table, Rename, and Show Data commands are enabled. (If you have opened the form with the Connections menu on the Security menu, then the Global Add, Global Delete, and Global Edit options also are available.)

-  If the selected table name has more than one file label/path name connection, the Delete Connection, File Label, and Rename commands are enabled. (If you have opened the form with the Connections menu on the Security menu, then the Global Add, Global Delete, and Global Edit options also are available.)

Note In addition to the drop-down menus on the menu bar, Relativity offers context-sensitive menus that pop up at the click of the right mouse button. To open a context-sensitive menu of the commands on the Connection menu, right-click a table name, path name, or file label (if file labels are in effect) on the Edit Connections form. From the pop-up context menu, choose the command you need.

Choose

To

Add Table

Display the Add Table Connection dialog box. This dialog box contains options for the definition of a table connection for a selected table definition on the Edit Connections form.

Note The Add Table command provides the same functionality as the Add Table Connection button on the Edit Connections form toolbar.

Add Connection

Display the Add Table Connection dialog box if the selected table definition has a file label.

Notes

· This command does not appear unless the selected table definition has a file label.

· The Add Connection command provides the same functionality as the Add Table Connection button on the Edit Connections form toolbar.

Delete Table

Delete selected table connections for a selected table definition in the Edit Connections form.

Note The Delete Table command provides the same functionality as the Delete Table Connection button on the Edit Connections form toolbar.

Delete Connection

Delete the selected table connection if there are two path names associated with the same table name.

Notes

· This command does not appear unless the selected table name has more than one file label/path name connection.

· The Delete Connection command provides the same functionality as the Delete Table Connection button on the Edit Connections form toolbar.

Edit Table Connection

Display the Edit Selected Table Connections dialog box. This dialog box contains options for editing the path names and file label items, if defined, of selected table connections of a table definition.

Note The Edit Table Connection command provides the same functionality as the Edit Table Connection button on the Edit Connections form toolbar.

File Label

If file labels are in effect, display a dialog box where you can edit (enter) a file label for a specific table definition.

Note This command does not appear unless the selected table definition has a file label.

Rename

Depending on which item is selected, change the table name or path name (or file label, if file labels are in effect) by editing it. It is not necessary to specify a search and replace pattern.

Show Data

Display the Show Table Contents form containing data from underlying COBOL file(s) for the selected table connection.

Note The Show Data command provides the same functionality as the Show Data button on the Edit Connections form toolbar.

Global

Display a submenu having three options. (Note that these commands are not enabled unless all the table definitions are listed in the Edit Connections form.)

· Add. Display the Add Connections Matching Pattern dialog box. This dialog box contains options for the addition of table connections based on the matching of patterns within table names and/or path names on the Edit Connections form.

Note The Global | Add command provides the same functionality as the Global Add button on the Edit Connections form toolbar.

· Delete. Display the Delete Connections Matching Pattern dialog box. This dialog box contains options for the deletion of table connections based on the matching of patterns within table names and/or path names on the Edit Connections form.

Note The Global | Delete command provides the same functionality as the Global Delete button on the Edit Connections form toolbar.

· Edit. Display the Edit Connections Matching Pattern dialog box. This dialog box contains options for the editing of table connections based on the matching of patterns within the table names and/or path names on the Edit Connections form.

Note The Global | Edit command provides the same functionality as the Global Edit button on the Edit Connections form toolbar.


Reports Menu Commands

The Reports menu of the Relativity Designer window contains the following commands.

Note In addition to the drop-down menus on the menu bar, Relativity offers context-sensitive menus that pop up at the click of the right mouse button. To open a context menu of the commands on the Reports menu, right-click a report category or description when Reports is selected as the catalog object in the Catalog window. From the pop-up context menu, choose the command you need.

Choose

To

Print

Display a submenu that allows you to print an existing report. See Reporting and procedures on how to print a report.

Shortcut: Ctrl+P

Note A report also may be printed from the Catalog window, as the Print command provides the same functionality as the Print shortcut in the Report Common Tasks area of the Reports catalog object (or the Print button on the Reports tab when Tabbed layout mode is selected).

Export

Modify the action of the Print command. When the Export command is active, a check mark appears to the left of the Export command, and the Print command will export those fields and variables included in a report to a comma-separated value (.CSV) text file. See the Save Export File As dialog box. (When export is active, click the Export command to disable it.)

For more information, see Exporting Data to a Comma-Separated File and Reporting.

Note A report also may be exported from the Catalog window, as the Export command provides the same functionality as the Export shortcut in the Report Common Tasks area of the Reports catalog object (or the Export button on the Reports tab in the Catalog window when Tabbed layout mode is selected).

Preview

Modify the action of the Print command by allowing you to see how the report will look when it is printed. When the preview capability is active, a check mark appears to the left of the Preview command and the Preview button is selected in the Print Options dialog box. To disable the preview capability, click the Preview command again.

Edit

Display a submenu that allows you to select the category of the catalog object for which you want to create a new report or modify an existing report .

Note A report also may be edited from the Catalog window, as the Edit command provides the same functionality as the Edit shortcut in the Report Common Tasks area of the Reports catalog object (or the Open button on the Reports tab in the Catalog window when Tabbed layout mode is selected).


Tools Menu Commands

See Also

The Tools menu of the Relativity Designer window contains the following commands.

Note If no data source is open, only the Welcome, Server Admin (if a client/server configuration of Relativity is installed), ODBC Control Panel, and Options commands are available on the Tools menu.

Choose

To

SQL Window

Display the SQL window. The SQL window allows you to design queries using any valid SQL (Structured Query Language) SELECT statements. You can select columns and rows from one or more tables in the Relativity catalog; specify one or more conditions; order, summarize, and group the data. The resulting data will be displayed in a column-and-row format. You can view more than 100 rows of data.

In addition to allowing joins, the SQL window also enables the building of expressions as well as parameter queries. This functionality differs from that of the Query Builder form in that the Query Builder restricts the query to a single table and to only certain aspects of the SELECT statement.

Item Patterns

Display the Item Patterns form. The Item Patterns form allows the user to specify unique patterns frequently appearing within the COBOL data items. These patterns are then used by the Relativity Designer to automatically determine the type of data. See Defining Item Patterns.

Data Types

Display the Data Types form. The Data Types form allows the user to define SQL column characteristics as a user data type. The definition of user data types improves the consistency of data descriptions throughout the data source. See Defining User Data Types.

Welcome

Display the Welcome to Relativity window, where you can create (set up) a new data source and optionally select a driver if necessary, open an existing data source, or open a recently used data source. This window appears automatically when you first install and start the Relativity Designer.

Import Btrieve Keys

Note This feature is available only in Relativity for Micro Focus COBOL.

Specify a data file containing the Btrieve key structure in order to import that key structure into a Relativity catalog using the Select Btrieve Data File For filename dialog box. This procedure is generally needed only if the Btrieve data file was not constructed with COBOL or the key structure has been modified with third-party Btrieve products. If the COBOL SELECT statement was generated to match an existing Btrieve structure without knowing the order of the keys in the Btrieve data file, this process can be used to ensure that the Relativity catalog matches the data. This command is available only if a single file has been selected or a single table has been selected in the Catalog window.

To enable this option, you must set EnableBtrieveConversion=Yes in the [Designer] section of the RELDBDSN.INI file found in your Windows directory. See Importing Btrieve Keys (Micro Focus COBOL Only).

Import from Another Relativity Data Source

Display the Import from Another Relativity Data Source dialog box in order to import file, table, and user data type definition objects from a Relativity catalog into the open Relativity catalog.

Note that this dialog box is displayed only after you have opened a second data source in the Open Relativity Data Source dialog box and logged in, if necessary. See Importing Definitions from Another Relativity Catalog.

File Label Utilities

Note This command appears as an option only if a file label has been applied to an open FD. For more information, click here.

Display a submenu that allows you to copy and delete file labels for an FD or copy and delete copy file label columns for a table when using multi-file table support.

From the FD submenu, choose one of the following:

· Copy File Label to display the Copy File Label dialog box in order to propagate a file label item definition to other FDs in a catalog.

· Delete File Labels to display the Delete File Label dialog box in order to remove a file label item from a table.

From the Table submenu, choose one of the following:

· Copy File Label Column to display the Copy File Label Column dialog box in order to propagate a file label column definition to other tables in a catalog.

· Delete File Label Columns to display the Delete File Label Column dialog box in order to remove the file label column definition from tables in a catalog.

Nullable Column Utility

Launch the Nullable Column utility, which allows you to choose and apply the nullable settings for all the numeric and date columns in your Relativity catalog. The utility opens with the Welcome page and then is comprised of the following series of windows:

· Settings, which displays and allows you to change global catalog settings that determine when NULLs are returned for certain invalid data.

· Options, which allows you to select which columns are to be included in an index. For more information on indexes, refer to "Relativity Indexes" under the For Advanced Users | Relativity-Specific topic in the Relativity Data Manager (DBMS) Help file.

· Table Selection, which lists all tables in a catalog and allows you to select the ones you want. This dialog box is displayed only if you choose the Select Tables to Process option on the Settings page.

· Summary, which displays the settings you’ve selected and allows you either to regress through the utility to make changes or start the process of applying nullable settings to your selections.

· Status Report window, which displays actions taken and explains why some actions were not taken.

Server Admin

Display the Select Server dialog box, where you can define a Windows or UNIX server for the Relativity Data Client data source and configure a Relativity Data Server data source on a Windows or UNIX server for the Data Client. It is also used to verify communications between a Relativity Data Client data source and the Relativity Data Server data source. Note that this command is available only in client/server configurations of Relativity. See also the online Server Administrator Help file available from the Help menu.

ODBC Control Panel

Display the ODBC Data Source Administrator dialog box, where you can configure a Relativity Data Server data source on the Windows server and configure a Relativity Data Client data source on the Windows client.

Date Constants

Display the Date Constants dialog box. This dialog box enables you to change the values of the following:

· The four date constants, 'Days' Base Date, 'YYYY' Base Year, 'YY' Century Cutoff, and 'YY' Base Year.

· The structure of two date constants ('YY' Dates and 'YYYY' Dates).

For more details, see Defining Date Constants.

Character Sets

Display the Character Set Maintenance dialog box. This dialog box lists the character sets in use in a Relativity data source. This dialog box also allows you to add both standard and nonstandard character sets to a Relativity data source, modify the character set associated with file definitions, and alter the location of the Euro character within a character set. See Maintaining Character Sets and Defining Nonstandard Character Sets.

Options

Display the Options dialog box. The Options dialog box enables the user to select settings for various preferences for the Relativity Designer. These settings become the default settings for the appropriate options. See Setting Options.


Window Menu Commands

The Window menu of the Relativity Designer window contains the following commands.

Note At the bottom of the Window menu is a list of the Catalog window and other forms that may be open for the data source that has been selected for processing. A check mark appears next to the name of the window or form that is active in the Relativity Designer main window. To activate any of these windows or forms (that is, to bring any of them to the front), simply click the filename from the list or type the number that appears to the left of the name.

Choose | To
Cascade | Arrange windows in an overlapping cascade so that titles remain visible.
Tile Horizontal | Arrange windows so that a full horizontal view is shown of the top portion of each window.
Tile Vertical | Arrange windows side by side so that each window is visible.
Arrange Icons | Move all icons to a row at the bottom of the Relativity Designer window.


Help Menu Commands

See Also

The Help menu of the Relativity Designer window contains the following commands.

Choose | To
Contents | Display the Relativity Designer Help contents. The Contents command performs the same function as the Contents button on the Help toolbar.
Search for Help On | Enable the user to search the Help information for specific topics. The Search for Help On command performs the same function as the Index button on the Help toolbar.
DBMS Help File | Launch the Relativity Data Manager (DBMS) Help file for the currently selected ODBC driver. You select an ODBC driver on the File menu, in the Welcome to Relativity window when you open a data source, or in the Open Relativity Data Source dialog box.
Server Admin Help File | Launch the Relativity Server Administrator Help file. Note that this command is available only in client/server configurations of Relativity. See the Select Server dialog box.
About | Display the About dialog box, which includes the version number, copyright specifications, registration/serial number, catalog version number, and licensing information of the Relativity Designer product that is currently running.


Status Bar

The status bar, displayed at the bottom of the Relativity Designer window, displays information and messages to help the user of the Relativity Designer.

Note If the LED style indicator near the center turns yellow, Windows resources are too low to continue safely. Close some windows to reduce resource usage.


Options Dialog Box

See Also

Relativity allows you to establish default settings for various preferences related to the system, files, tables, item patterns, user data types, data source files, date formats, COBOL data types, and security privileges. You change most of these settings in the Options dialog box.

To access the Options dialog box in the Relativity Designer:

1. On the Tools menu, click Options.

2. In the left pane of the Options dialog box, click the topic or icon to display the corresponding page of preferences in the right pane.

Three buttons, OK, Cancel, and Apply, appear in the lower-right corner in the Options dialog box no matter which page is selected and displayed. They perform the same functions in all of the pages in the Options dialog box. The OK button closes the Options dialog box and saves any changes that you have made on the specified page. The Cancel button closes the Options dialog box without saving any changes you have made to the settings. The Apply button saves all the changes you have made without closing the Options dialog box.


Catalog Window

Information for Users of Prior Versions of Relativity: If you have used earlier versions of Relativity, you will notice an important change to the main interface. The Catalog window is, by default, displayed in the new Windows XP Look & Feel layout mode when you open a data source in the Relativity Designer. If you would prefer to work in the tabbed mode more familiar in earlier versions of Relativity, click the Tabbed option from the Layout command on the View menu. Note, however, that procedures in this help file are written for the Windows XP Look & Feel default view.

In Relativity, the Catalog window is "control central" for the creation and maintenance of a Relativity catalog. Within the Catalog window, definitions of files, tables, and reports can be viewed and opened. You can also view and change user and group definitions. By default, the Catalog window is displayed in the desktop area of the Relativity Designer main window when a data source is opened. For more information, see Working with the Catalog Window.

The Catalog window contains the following areas.

Option

Description

Catalog Objects

This area lists the Files, Tables, Users & Groups, and Reports catalog objects that can be opened and viewed within the Catalog window. Click an object to display the files, tables, and reports defined in the data source, as well as the group and user definitions.

Common Tasks

Depending on which catalog object is selected, the name of this area is labeled as FD, Table, User, or Report:

· The FD Common Tasks area displays the options most often used with a Files catalog object.

· The Table Common Tasks area displays the options most often used with a Tables catalog object.

· The User Common Tasks area displays the options most often used with a Users & Groups catalog object.

· The Report Common Tasks area displays the options most often used with a Reports catalog object.

Associated Tables

If Files is selected as the catalog object, this area displays any table that has the highlighted (selected) file as its parent FD.

Parent FD

If Tables is selected as the catalog object, this area is displayed, allowing you to open the FD for that table.

List

This area displays the detail information (including the number and names of the files, tables, users, and reports) for the selected catalog object.


FD Common Tasks on the Files Catalog Object

The FD Common Tasks area displays the options (shortcuts) most often used with a Files catalog object:

· Open. Displays the FD form for the selected COBOL file definition in the Catalog window.

Note The Open shortcut provides the same functionality as the Open command on the FD menu (or the Open button on the Files tab when Tabbed layout mode is selected).

· Import COBOL FDs. Moves information about the file description entries and the associated record descriptions of one or more COBOL files to the Relativity catalog. The Source Code Import wizard is displayed for the selection of the COBOL data files for the importing process. See Importing COBOL File Definitions and Creating a COBOL Schema File.

Note The Import COBOL FDs shortcut provides the same functionality as the Import COBOL FDs command on the FD Menu (or the New button on the Files tab when Tabbed layout mode is selected).

· Merge COBOL FD Changes. Merges new (or changed) COBOL file definitions with corresponding definitions existing in the Relativity catalog. The Source Code Merge wizard is displayed for the selection of the COBOL data files for the merging process. See Merging COBOL File Definitions.

Note The Merge COBOL FD Changes shortcut provides the same functionality as the Merge COBOL FD Changes command on the FD menu (or the Merge button on the Files tab when Tabbed layout mode is selected).

· Table Wizard. Displays the Table wizard, which simplifies the creation of a table by automating the selection of elementary items in the FD form, the addition or removal of items to or from the table, and the editing of column names. See Using the Table Wizard.

Note The Table Wizard shortcut provides the same functionality as the Table Wizard command on the FD menu (or the Table Wizard button on the Files tab when Tabbed layout mode is selected).

· Delete FD. Removes the selected the file-name of the file definition from the Relativity catalog. A message box will be displayed requesting confirmation of the delete request. If there are any table definitions based on the file definition, a second confirmation message box informs the user of the existing tables. If the user confirms the deletion, the file definition and any table definitions based on that file definition are deleted from the catalog.

Note The Delete FD shortcut provides the same functionality as the Delete FD command on the FD menu (or the Delete FD button on the FD form toolbar.


Table Common Tasks on the Tables Catalog Object

The Table Common Tasks area displays the options (shortcuts) most often used with a Tables catalog object:

· New. Displays a blank Table form for the creation of a new table.

Note The New shortcut provides the same functionality as the New command on the Table menu (or the New button on the Tables tab when Tabbed layout mode is selected).

· Open. Displays the Table form for the selected table definition.

Note The Open shortcut provides the same functionality as the Open command on the Table menu (or the Open button on the Tables tab when Tabbed layout mode is selected).

· Copy. Opens the Copy table name dialog box, where you can copy a selected table and give it a new table name.

Note The Copy shortcut provides the same functionality as the Copy command on the Table menu.

· Rename. Opens the Rename table dialog box for a table selected in the Catalog window. If a table is being renamed, the rename process will rename the table definition and, optionally, change the connection name. If a connection has the same name as the table being renamed, a message box will give you the option to rename the connection at the same time the definition is renamed. If there are any open file definitions or table definitions that will be affected by the rename, they will be automatically closed during the rename process. A table name must not be an SQL reserved word. See Establishing Table Connections.

Note The Rename shortcut provides the same functionality as the Rename command on the Table menu.

· Show Table Contents. Opens the Show Table Contents form for the selected table, where you can preview data about the contents of the table.

Note The Show Table Contents shortcut provides the same functionality as the Show Table Contents command on the Table menu or the Show button on the Table form toolbar.

· Connections. Display the Edit Connections form for the defining and editing of a table connection.

Note The Connections shortcut provides the same functionality as the Connections command on the Security menu.

· Delete. Removes the selected table definition from the Relativity catalog or the entire table displayed in the Table form. A message box will be displayed requesting confirmation of the delete request.

Note The Delete shortcut provides the same functionality as the Delete command on the Table menu or the Delete Table button on the Table form toolbar.


User Common Tasks on the Users & Groups Catalog Object

The User Common Tasks area displays the options (shortcuts) most often used with a Users & Groups catalog object:

· Add Group. Displays the Add Database Group dialog box for the entry of a new group name, an optional password, and an expiration date for the group name.

Note The Add Group shortcut provides the same functionality as the Add Group command on the User menu or the Add Group button on the Edit Users form.

· Add User. Displays the Add Database User dialog box for the entry of a new user name, an optional password, and an expiration date for the user name.

Note The Add User shortcut provides the same functionality as the Add User command on the User menu or the Add User button on the Edit Users form toolbar.

· Privileges. Displays the Edit Privileges form for the selected group in the Catalog window.

Note The Privileges shortcut provides the same functionality as the Privileges command on the User menu (or the Privileges button on the Users tab when Tabbed layout mode is selected). If a group is not selected, the Privileges shortcut (or button) is disabled.

· Delete. Removes the selected group or user from the Relativity catalog. If a user name has been selected, the user name is immediately deleted. A message box will be displayed requesting confirmation of a delete group request. If the user confirms the deletion, the group and all its users are deleted from the catalog.

Note The Delete shortcut provides the same functionality as the Delete command on the User menu (or the Delete button on the Users tab when Tabbed layout mode is selected).

· Change Catalog Owner. Displays the Change Catalog Owner dialog box. The Change Catalog Owner dialog box displays options for a new owner name and an optional password. See Defining Catalog Ownership.

Note The Change Catalog Owner shortcut provides the same functionality as the Change Catalog Owner command on the Security menu.


Report Common Tasks on the Reports Catalog Object

The Report Common Tasks area displays the options (shortcuts) most often used with a Reports catalog object:

· Print. Displays the Print Options dialog box for the printing of the selected report. If a report category is selected instead of a specific report description, a Select Report dialog box is displayed first to allow selection of the specific report definition file to be printed. See Reporting and procedures on how to print a report.

Note The Print shortcut provides the same functionality as the Print command on the Reports menu (or the Print button on the Reports tab when Tabbed layout mode is selected).

· Export. Displays the Save Export File As dialog box in order to export those fields and variables included in a report to a comma-separated value (.CSV) text file. After you complete this dialog, the Print Options dialog box is displayed. You must also print the report in order to write the .csv file. See Exporting Data to a Comma-Separated File and Reporting.

Note The Export shortcut provides the same functionality as the Export command on the Reports menu (or the Export button on the Reports tab when Tabbed layout mode is selected)

· Edit. Provides the facility to either create a new report or modify a selected report.

-  If a report category has been selected, the Select Report dialog box is opened for selecting an existing report or creating a new report. (Note that the exact name of this dialog box varies depending on the report category selected.)

-  If a specific report description has been selected, that report will be opened in the Report Editor for editing its description.

In either situation, the edited description may be saved as a new report or saved as the new layout for the same report (using the Save As or Save commands, respectively, in the Report Editor).

Note The Edit shortcut provides the same functionality as the Edit command on the Reports menu (or the Open button on the Reports tab in the Catalog window when Tabbed layout mode is selected).


COBOL Definition Forms

See Also

The Relativity Designer imports COBOL schema by moving information about the file description entries and the associated record description from one or more COBOL object files to the Relativity catalog. The record descriptions of an imported COBOL object file are displayed by the Relativity Designer in a format called an FD form.

From the FD form, editing operations are performed to prepare the data items for the creation of relational tables for the Relativity catalog. Other forms that are accessed via the FD form to assist in this editing process include the following:

· Data Types Form

· Edit Item Sets Form

· FD Properties Form

· Item Patterns Form

· Record Type Properties Form


FD Form

See Also

It is within the FD form that the editing operations are performed to prepare the data items for the creation of relational tables for the Relativity catalog.

When the FD form is open for a selected file definition, the FD menu appears on the menu bar of the Relativity Designer window.

Note Relativity also supports context-sensitive (pop-up) menus, where you can access menu commands and equivalent toolbar button shortcuts, specific to the object selected. To open a context menu on the FD form attribute grid, select the appropriate COBOL data item(s) and right-click.

For more information about a specific toolbar button or attribute in the FD form, choose from the following topics:

· FD Form Toolbar

· FD Form - Attributes Summary

· Record Type Toolbar

To

Do This

Display the FD form

Click the Files catalog object in the Catalog window and double-click a file definition from the list. When the FD form is opened for the first time, only the FD and 01 levels of the COBOL file are displayed under the COBOL Name attribute column.

To view an unexpanded FD form, click here.

Alternatively, you can click the Open task on the FD Common Tasks area in the Catalog window or choose the Open command from the FD menu to open the FD form for the selected file definition.

Expand the FD form horizontally to display more attributes of the data items

Click Magnify on the FD form toolbar. You can use the horizontal scroll bar to scroll through the attributes of the data items in the FD form.

To view an expanded FD form, click here.

Note In order to display some attribute columns on the FD form, the appropriate check box must be specified on the File page in the Options dialog box.

Display the FD Properties form for the selected file definition

Click FD Properties on the FD form toolbar.

Expand the FD form vertically to display all data items and subordinate data items in the record descriptions

Click All Levels on the FD form toolbar. You can use the vertical scroll bar to scroll through the data items in the record descriptions.

To view an example, click here.

Resize the width of a column in the FD form

Drag the vertical line located between the column headings to the left or right.

Change the position of a column in the FD form

Click the column heading and drag the column heading to the left or right.

Select a single row in the FD form attribute grid

Move the mouse pointer to the leftmost edge of the data item row you want to select and click the mouse button to select that row. Tip

Display or hide subordinate data items in the FD form attribute grid

Click over an Expand or Collapse icon.


FD Form Toolbar

See Also

The FD form includes a toolbar, illustrated above, which provides shortcuts to some of the more common commands from the FD menu. For more information about a specific item on this toolbar, refer to the following table. The buttons appear in the order of their appearance, starting from the left side of the toolbar.

Note Relativity also supports context-sensitive (pop-up) menus, where you can access menu commands and equivalent toolbar button shortcuts specific to the object selected. To open a context menu on the FD form attribute grid, select the appropriate COBOL data item(s) and right-click.

Button

Description

The Magnify button expands or contracts the FD form horizontally to display either the detail or abbreviated description of the data item.

The Split button causes the Relativity Designer window to split so that two different areas of a document can be seen in the same window.

The Save Changes button writes into the Relativity catalog all additions, changes, and deletions made to the record description displayed in the FD form for a COBOL file. If the FD form is closed with uncommitted changes, there will be a prompt asking if any pending changes should be saved or not. This behavior can be controlled by the Save FD Changes check box on the File page in the Options dialog box.

Note This option provides the same functionality as the Save FD Changes command on the FD menu.

The Export FD button sends the record description displayed in the FD form and the associated table definitions to a COBOL source file suitable for use by a COPY statement. Settings on the Data Source page in the Options dialog box control the location and format of the created file.

The Delete FD button deletes from the Relativity catalog the record description displayed in the FD form.

CAUTION The Delete FD button deletes all tables based on this FD and closes all open tables.

Note This option provides the same functionality as the Delete FD command on the FD menu (or the Delete FD task on the FD Common Tasks area of the Files catalog object).

The FD Properties button displays the FD Properties form for the selected file definition in the FD form.

Note This option provides the same functionality as the Properties command on the FD menu when a file definition is selected on the Files catalog object in the Catalog window.

The Assign Default Data Types button assigns user data types based on the item patterns defined prior to editing of the FD form and the Table form.

Notes

If the FD contains a COBOL data item that matches the criteria for more than one item pattern, the Select Data Type dialog box is displayed so that you can indicate which item pattern to apply.

This option provides the same functionality as the Assign Default Data Types command on the FD menu.

The All Levels button expands the FD form vertically to display all subordinate data items in the record description.

The Add Data Item button displays the Add COBOL Data Item Redefinition dialog box for the definition of a data item that redefines the selected data item in the FD form. See Redefining Data Items.

Note This option provides the same functionality as the Add Redefines command on the FD menu.

The Delete Item button removes from the FD form a data item or condition item that was not imported into the database. Imported items cannot be removed from the FD form.

The Occurs Depending On button defines a table structure that simulates the OCCURS clause with the DEPENDING ON phrase relationship for the selected data items in the FD form. The item on which the number of occurrences depends is displayed in the Occurs column on the FD form. See Identifying Implicit Occurs Depending On.

The Add Condition Item button displays the Add Condition Item dialog box for the definition of a condition-name for the selected data item in the FD form or for the modification of an added condition item. See Adding Condition Items.

Note This option provides the same functionality as the Add 88 command on the FD menu.

The Parallel Occurs button defines a set of data items described with the OCCURS clause that should be associated because they are parallel COBOL tables. That is, while they were described in the COBOL source with multiple OCCURS clauses, they are logically one COBOL table. The set of parallel OCCURS data items must be selected prior to selecting this button. See Identifying Parallel OCCURS Clauses for a fuller description of this concept.

The Redundant Data Items button displays the Edit Item Sets form for the definition of an item set containing the selected redundant data items that are to be reduced to one data item. See Defining Item Sets.

The Find button opens the Find COBOL Item dialog box, where you can search for a COBOL data item on the FD form.

Shortcut: Ctrl+F

Note This option provides the same functionality as the Find command on the FD menu.

The Find Next button repeats the search for the COBOL data item that you specified in the Find COBOL Item dialog box.

Shortcut: F3

Note This option provides the same functionality as the Find Next command on the FD menu.

The Column Name Case button toggles the case used when converting data-names and condition-names in the FD to default column names.

If this button is selected, the default column names are all uppercase. If this button is not selected, the default column names are mixed case or lowercase depending on whether the Column Name Hyphen button is selected.

This button does not affect any default column name that has been manually edited in the FD form or globally edited using the Edit Default Column Names dialog box.

Note This button is present only in the detailed FD view (see the Magnify button on the FD form toolbar).

The Column Name Hyphen button toggles the treatment of hyphens that is necessary when converting data-names and condition-names in the FD to default column names because SQL column names cannot contain hyphens:

· If this button is selected, the default column names are derived by replacing hyphens with underscores. When hyphens are replaced by underscores and the Column Name Case button is not selected, default column names are all lowercase.

· If this button is not selected, the default column names are derived by deleting hyphens. When hyphens are deleted and the Column Name Case button is not selected, the default column names are mixed case, with capitalization of the first letter and each letter that followed a hyphen.

This button does not affect any default column name that has been manually edited in the FD form or globally edited using the Edit Default Column Names dialog box.

Note This button is present only in the detailed FD view (see the Magnify button on the FD form toolbar).

The Column Name Global Edit button displays the Edit Default Column Names dialog box for editing default column names using pattern matching and replacement. The editing can be applied to the default column names for selected items in the FD form or for all items in the FD form.

Note This button is present only in the detailed FD view (see the Magnify button on the FD form toolbar).

The Add Function button displays the Select Function dialog box to allow selection of a function to add to the FD as a synthesized data item.

Note This option provides the same functionality as the Add Function command on the FD menu.

The Add Item Argument button, which becomes enabled when a function item and one other data item, condition item, or function item are both selected, causes that other selected item to be added to the argument list of the selected function item. Note that an item may be added as a function argument by selecting that item, then dragging and dropping on the function item. If you select another function item as an argument, you will be presented with the Function of Function dialog box to select which function is the argument.

The Add Constant Argument button, which becomes enabled when only a function item is selected, displays the Add Function Constant dialog box to allow an alphanumeric or numeric constant to be added to the argument list of the selected function.

The Delete Arguments button deletes all arguments for the selected function item.


FD Form - Attributes Summary

See Also

The expanded FD form provides a detailed definition for the data item specified under the COBOL Name attribute column. The following is a summary list with information about the attributes in the FD form. The appearance of certain attribute columns on the FD form is dependent upon the settings on the File page in the Options dialog box.

Note Relativity also supports context-sensitive (pop-up) menus, where you can access menu commands and equivalent toolbar button shortcuts, specific to the object selected. To open a context menu on the FD form attribute grid, select the appropriate COBOL data item(s) and right-click.

Attribute

Description

COBOL Name

The COBOL Name attribute is the name of the FD entry and the data description entries for each record in the COBOL file. The following items are displayed as the COBOL Name attributes for data items in the FD form:

· FD level indicator followed by a COBOL file-name.

· Level-number 01 followed by a COBOL record-name.

· Level-number 02 and above followed by the COBOL data-name of a group data item or elementary data item.

· Function items defined by f : followed by the name of the internal function.

· A subscript item defined by si followed by the text SubscriptItem.

Indentation of the abbreviated data descriptions gives a visual representation of the hierarchical structure of the data items contained in the record.

Expand / Collapse

The Expand and Collapse icons control the display of group data items:

· Clicking Expand displays all subordinate data items in the group.

· Clicking Collapse hides all of the subordinate date items within the group.

Picture

The Picture attribute contains one of the following:

· The type of file organization (Sequential, Relative, or Indexed) appears for the COBOL file-name.

· Group data items are represented by the word Group followed by a PICTURE character-string of X(n) enclosed in brackets. The value of n indicates the number of alphanumeric character in the group item.

· Elementary items are represented by a PICTURE character-string and, for numeric items that are not DISPLAY usage, the usage, for example, BINARY or PACKED-DECIMAL. The PICTURE character-string is omitted for numeric items that do not use a PICTURE character-string, for example, COMP-1 or COMP-2 floating point items. For signed numeric display items, one of the words LEADING or TRAILING follows the PICTURE to indicate the sign position.

Start

The Start attribute is the first character position for the data item within the record. For the file-name, the Start attribute is the minimum record size.

End

The End attribute is the last character position for the data item within the record. For the file-name, the End attribute is the maximum record size.

Occurs

The Occurs attribute is the same number as appears in the OCCURS clause for data items whose descriptions contain the OCCURS clause. See Specifying Treatment of the OCCURS Clause.

Subscripts

The Subscripts attribute is the number of subscripts that are necessary to reference the data item.

Default Column Name

The Default Column Name attribute is the SQL column name that will be assigned by the Relativity Designer when the data item is used as a column in a table. When the Default Column Name attribute is first generated, it is derived from the COBOL data-name according to a set of rules for defining default column names.

The column name may be changed after a column is created by using the Column Name attribute in the Table form.

Column names may not be an SQL reserved word.

User Data Type

The User Data Type attribute is the user data type that will be assigned by the Relativity Designer when the data item is used as a column in a table. Assign default data types to data items in the FD form by clicking Assign Default Data Types on the FD form toolbar. Change the default data type in the User Data Type attribute column by clicking in the grid cell and then selecting a user data type from the list. After a column is created, the default data type can be changed by selecting a type from the Data Type attribute column in the Table form, which causes the display of a list containing types appropriate for the data item. See Defining User Data Types and Defining Item Patterns.

Redefines

The Redefines attribute is the COBOL data-name that appears in the REDEFINES clause of the data description for a data item that contains the REDEFINES clause. See Redefining Data Items and Defining Record Types.)

The Redefines attribute column is displayed in the FD form only if the Show REDEFINES check box is selected on the File page in the Options dialog box.

Redefined By

The Redefined By attribute is the COBOL data-name of any data item having a data description with the REDEFINES clause that specifies this data item. See Redefining Data Items and Defining Record Types.

The Redefined By attribute column is displayed in the FD form only if the Show Redefined By check box is selected on the File page in the Options dialog box.

Default Value

The Default Value attribute is the value that is used in write operations if the data item is not represented by a column in an SQL INSERT statement. This value is set by clicking the ellipsis button in the column row of the selected item in the FD form, then typing or selecting the value in the Set Default Value dialog box. The value will be limited to the range of values that is valid for the underlying COBOL data type. See Defining Default Values.

The Default Value attribute column is displayed in the FD form only if the Show Default Values check box is selected on the File page in the Options dialog box.

Value

The Value attribute displays the value in the VALUE clause of a condition-name or the argument list of a function item. Double-click on the grid cell to display a message dialog box showing the complete VALUE entry or argument list. See Adding Condition Items and Internal Functions.

The Value attribute column is displayed in the FD form only if the Show VALUE Column check box is selected on the File page in the Options dialog box.

Null

The Null Value attribute describes the data value that will produce a null, or will be stored when a null is written, in an SQL column using this data item. The representation of a null for a data item in the FD form is selected from a list of condition-names. The conditional variable associated with a condition-name in the list does not have to be the data item on the FD form for which the Null Value attribute is being defined. See Defining Null Information.

The Null Value attribute column is displayed in the FD form only if the Show Null Information check box is selected on the File page in the Options dialog box.

Not Null

The Not Null attribute, when set, indicates that an SQL column defined on this item is null when the null condition is false. The Not Null attribute is initially not set, indicating that an SQL column defined on this item is null when the null condition is true. See Defining Null Information.

The Not Null attribute column is displayed in the FD form only if the Show Null Information check box is selected on the File page in the Options dialog box.

Transform

The Transform attribute specifies a data transformation for a COBOL data item value to and/or from a relational database column value. Change the transform in the Transform attribute by clicking in the grid cell and then selecting a transform from the list. A transform may also be assigned during the definition of an item pattern. See Defining Transforms on Data Items, Transforms, and Defining Item Patterns.

The choices available in the Transform attribute column are determined by the settings selected on the Date Formats page in the Options dialog box.

Comment

The Comment attribute contains comments pertaining to the data item defined by this row in the FD form. The comment is changed by clicking in the grid cell. The Comment attribute column is displayed in the FD form only if the Show Comments check box is selected on the File page in the Options dialog box. See Specifying Comments.

This attribute is totally owned by the catalog developer for use in the Relativity Designer and through reports. It is a good place to maintain a user-friendly definition of the data item. Through the reporting tool, this comment could then be used to build a help file for the end-user of the catalog. Another use of this attribute might be to discuss the uses of a data item that may not be obvious.


FD Properties Form

The FD Properties form retrieves many of the property values of the selected COBOL file definition and allows you to view this useful information in one location. The properties retrieved for the FD include the COBOL file-name, the COBOL dialect, the character set of the source code and the data file, the file organization, the minimum and maximum record size (or length), and comments. Additionally, you can view the properties related to the key structure of the file, the record types and filters, and all the tables built from the selected file definition from this form.

To display the FD Properties form, take any of the following actions:

· Select a file definition on the Files catalog object in the Catalog window and click Properties from the FD menu or right-click to access this command from the context menu.

· If an FD form is open for a selected file definition, take one of the following steps:

-  Click Properties from the FD menu. Alternatively, right-click to access the command from the context menu.

-  Click the FD Properties button on the FD form toolbar.

The name of the selected file definition appears in the title bar of the FD Properties form.

Note You can leave the FD Properties form open as you work with different objects in the Relativity Designer window. The contents of the FD Properties form always match the currently selected file definition. Rather than closing and reopening the window as you edit a form, for example, move it off to the side, where you can see its contents without hiding other elements in the main window. You also can minimize the window, where it is out of your way, but still can be retrieved quickly.

The following describes the use of the left pane and the properties displayed in the right pane of the FD Properties form for the selected file definition.

Option

Description

Left pane

Use this area to view additional properties for the selected file definition: Keys, Record Types, and Tables.

Click the plus sign [+] to expand the item and select one of the items within the list. (To collapse an item, click the minus sign [-].) The properties related to that item are displayed in the Properties pane on the right.

Properties pane

Note Most of the FD properties presented are grayed out, which means they cannot be modified. In some cases, however, you are able to perform other operations (such as opening a table) or make changes (such as renaming a record type) by accessing a context-sensitive menu on a selected property.

· The Name property identifies the COBOL file-name (COBOL Name attribute) of the FD entry in the FD form.

· The Dialect box indicates the type of COBOL dialect (RM/COBOL or Micro Focus COBOL) that is being used.

· The Source Charset box indicates the character set of the source code. This box is informational only.

· The Native Charset box indicates the character set of the data in the actual data file. The Relativity DBMS makes use of this information to translate to and/or from the character set in use at the time the data is accessed. This box is informational only.

· The Organization list identifies the file type and structure (indexed, sequential, or relative) of the underlying COBOL file.

· The Record Length box displays the length of the record. If the record is a variable length record, this area displays the minimum and maximum length (that is, a To box also is displayed).

· The Comment box displays the comments, if any, associated with the selected FD.

· The Update Comment button allows you to add additional comments associated with the selected FD.


FD Properties Form: Keys

With Keys expanded in the left pane of the FD Properties form, the number of keys for this file is indicated, allowing you to view all the keys defined for the selected file definition.

The following describes the use of the left pane and the properties displayed in the right pane of the FD Properties form for the key structure of the selected file definition.

Option

Description

Left pane

Use this area to view additional properties for the selected file definition: FD Properties, Record Types, and Tables.

If there is more than one key defined, click on the plus sign [+] to expand the list. (To collapse an item in the list, click the minus sign [-].) The properties related to that key are displayed in the Properties pane on the right.

Keys properties

· The Key # x of n area denotes which key is being addressed, and also indicates the total number of keys associated with the selected FD. (Note that before a key is selected in the left pane and the properties are displayed, this area is labeled "This file contains n key.")

· The Unique list indicates whether the key is unique or not; that is, whether duplicates are disallowed or allowed.

· The Key Part # x of n section is primarily used for segmented (or split) keys. If the key is not segmented, this area will always reflect Key Part # 1 of 1. If a key is segmented, it will denote which segment is selected and the total number of segments in the key. (Note that before a key is selected in the left pane and the properties are displayed, this area is labeled "Select key component for information.")

· The Name box specifies the name of the COBOL data item associated with the key or key segment.

· The Offset box indicates the offset in the COBOL record buffer for the selected key or key segment.

· The Length box indicates the number of bytes in the COBOL record buffer for the selected key or key segment.


FD Properties Form: Record Types

See Also

With Record Types expanded in the left pane of the FD Properties form, you are able to view all the record types for the selected file definition. (Click on the plus sign [+] to expand the list. To collapse an item, click the minus sign [-].) You may also use this area to view additional properties for the selected file definition: FD Properties, Keys, and Tables.

Note If you right-click a selected record type in the left pane, you can click Rename in the pop-up context menu to open the Rename file dialog box, where you can rename the record type for the selected file definition. When you rename a record type, the new name appears in the Record Type list on the Record Type toolbar on the FD form.

In the right pane of the FD Properties form for the selected record type, the record type filters are displayed:

· The Filter box displays the record type filter associated with the record types. Record type filters are specified in the Record Type Properties form accessed from the Record Type toolbar on the FD form.


FD Properties Form: Tables

With Tables expanded in the left pane of the FD Properties form, you are able to view all the tables that were built from the selected file definition.

Note If you right-click a table name in the Tables list, you can choose a command from the pop-up context menu to open, copy, rename, export a DDL, show the contents of, build a query, show the indexes for the table built, or delete a table (or multiple tables) from the selected file definition on the Files catalog object.

The following describes the use of the left pane and the properties displayed in the right pane of the FD Properties form for the tables that were built from the selected file definition.

Option

Description

Left pane

Use this area to view additional properties for the selected file definition: FD Properties, Keys, and Record Types.

If there is more than one table defined, click on the plus sign [+] to expand the list. (To collapse an item in the list, click the minus sign [-].) The properties related to that key are displayed in the Properties pane on the right.

Tables properties

· The Name box indicates the name of the table for the table definition.

· The Allow Updates and Allow Inserts check boxes indicate whether these functions are permitted for the selected table definition. These options are specified on the Table form toolbar.


Record Type Toolbar

See Also

The Record Type toolbar, located between the FD form toolbar and the FD attribute grid on the FD form, enables you to maintain the different record types associated with a file in the FD form. Using the different options available in the Record Type toolbar, you can perform the following tasks:

· Identify the data items within each record type structure.

· Add or remove data items from a record type.

· Delete record types.

· Define and edit a record type filter to specify the conditions that control the records that participate in providing data to a table based on the record type.

Note The records that participate in providing data to a table based on the record type may be further filtered by a table filter associated with that table. For more information, see Defining Record Type Filters.

All the record types and record type filters associated with a selected file definition can be viewed in one location in the Record Types Properties pane of the FD Properties form.

The following table describes the options in the order of their appearance starting from the left side of the Record Type toolbar.

Option

Description

Record Type:

Click the down arrow on the Record Type: list box to display the possible selections:

· The < new record type > option.

Select the < new record type > option to display the Add Record Type dialog box, where you define the record-name of the selected data items in the FD form that will make up a new record type. See Identify the data items within each record type structure.

Note This option provides the same functionality as the Record Types | Create New Record Type command on the FD menu when an FD form is open.

· The < no record type > option.

Use the < no record type > option to reset or indicate that no record type is selected. Note that all COBOL names in the FD form are displayed in “normal” type style when the < no record type > option is selected.

· The available record-name option.

Select an available record-name for the record type associated with the file displayed in the FD form to display the Record Type Properties form for the selected record type. The definition of a record type can be changed or deleted by the appropriate actions in this form.

Note When a record-name is selected from the Record Type: list, the type style of the data items listed in the COBOL names column in the FD form has special meaning. For more information, click here.

The Add Item toolbar button accepts the selected data item in the FD form as a new item in the record type having the record-name displayed in the Record Type: list. See Add a data item to a record type.

The Delete Item toolbar button removes the selected data item in the FD form from the record type having the record-name displayed in the Record Type: list. See Delete a data item from a record type.

The Delete Record Type toolbar button removes the record type having the record-name displayed in the Record Type: list. See Delete a record type.

The Record Type Filter Properties toolbar button displays the Record Type Properties form, where you can define a record type filter to specify the conditions that control the records that participate in providing data to a table based on the record type.


Data Types Form

See Also

The Data Types form provides the facility for the user to define characteristics of a data type that is used frequently in the SQL tables forming the database. The definition of user data type controls the consistency of SQL column descriptions throughout the database.

Note The Column Properties area appears in the lower left portion of the Data Types form when you drag the bottom border to enlarge the form vertically. The appearance of each property is dependent on the ODBC data type of the selected item in the Type attribute column.

To display the Data Types form, click Data Types from the Tools menu of the Relativity Designer window. To select a row in the column attributes grid, move the mouse pointer to the left of the data type that you want to select under the Name attribute heading and click the mouse button to select that row. You can close this form by double-clicking the Control Menu icon on the left side of the title bar.

The following table describes the options available in the Data Types form.

Option

Description

The Design Mode toolbar button expands or contracts the Data Types form horizontally to display all of the options, including the description of the user-defined data type, which can then be edited.

The Save Changes toolbar button writes into the catalog all additions, changes, and deletions made to the data types displayed in the Data Types form. If the Data Types form is closed with unsaved changes, there will be a prompt asking if any pending changes should be saved or not. This behavior can be controlled by the Save Data Type Changes check box on the User Types page in the Options dialog box.

The Add Data Type toolbar button displays the Add Data Type dialog box for the definition of a new user-defined data type.

The Delete Data Type toolbar button removes the selected user-defined data type from the Data Types form.

Name

The Name attribute is the name assigned to the user data type being defined. This data type name will appear in the list of the Data Type attribute on the Table form. This data type name must be unique.

Type

The Type attribute is the ODBC data type (char, date, integer, and so forth) associated with this user data type. To choose a different type, press the down arrow for a list of types. The following lists the data type names pre-assigned to ODBC data types in Relativity:

· Exact numeric data types are bit, smallint, integer, and decimal.

· Approximate numeric data types are single and double.

· Character (or text) data types are char, varchar, and longvarchar.

· Unstructured binary data type is longvarbinary.

· Date/time data types are date, time, and timestamp.

Default Value

The Default Value attribute is the value that is used in write operations if the column is not present in an INSERT statement. The value will be limited to the range of values that is valid for the data type of the column.

For example, if you are creating a date data type, the only valid default values are valid dates. The following forms are valid for entering dates:

2007-05-01 05-01-2007 01 May 2007

All of these forms refer to May 1, 2007.

This value is set in the Set Default Value dialog box.

Comment

The Comment attribute contains comments pertaining to the user data type being defined.

Column Properties

The following describes the column properties (located in the lower left portion of the form) available for a selected Type attribute in the Data Types form:

· The Transform property specifies transformation of a COBOL data item value to/from a relational database column value. The transform is changed by selecting from the list. This transform property is in addition to any transform attribute assigned to the COBOL data-item in the FD form. This transform can only be specified if Enable Column Transforms check box is selected on the Date Formats page in the Options dialog box.

· The Length property specifies the number of characters in an alphanumeric data item.

· The Digits property specifies the number of digits in a numeric data item.

· The Decimal Places property specifies the number of digits to the right of the decimal point in a numeric data item.

· The Nullable property indicates that this data type defines columns that allow nulls.

· The Unsigned property indicates that the data type does not have a sign.

· The Constrained property limits the value that a column may have during an INSERT or UPDATE operation to one of the true values indicated by an 88-level condition-name defined on the data item associated with the column. The user may add 88-level condition-names if the program does not have them. For more information, see Building a New Record.


Item Patterns Form

See Also

The Item Patterns form provides the facility for the user to identify common patterns for COBOL data items. The item pattern is then associated with a user data type and/or a transform.

To display the Item Patterns form, click Item Patterns from the Tools menu. To display additional attributes on the right side of the Item Patterns form, click on the rightmost scroll arrow at the bottom of the Item Patterns form. (Note that this scroll bar and arrow appear only when the Item Patterns form is not displayed at full size.) You can close this form by double-clicking the Control Menu icon on the left side of the title bar.

The following table describes the options available in the Item Patterns form.

Option | Description
 | The Save Changes toolbar button writes into the catalog all additions, changes, and deletions made to the item patterns displayed in the Item Patterns form. If the Item Patterns form is closed with unsaved changes, there will be a prompt asking if any pending changes should be saved or not. This behavior can be controlled by the Save Patterns Changes check box on the Item Patterns page in the Options dialog box.
 | The Add Item Pattern toolbar button displays the Add Data Item Pattern dialog box for the definition of an item pattern.
 | The Delete Item Pattern toolbar button removes the selected item pattern from the Item Patterns form.
 | The Edit Item Pattern button displays the Edit Data Item Pattern dialog box for the editing of the selected item pattern.
User Data (Name) | The User Data (Name) attribute is the name assigned to the user data type. This data type name will appear in the Data Type list on the Table form and in the User Data Type list on the FD form. This data type name must be unique.
Item Transform | The Item Transform attribute specifies a data transformation for a COBOL data item value to and/or from a relational database column value. The transform is changed by selecting a transform from the list.
Pattern | The Pattern attribute is the pattern specified in the Add Data Item Pattern dialog box to qualify data items for this data type. A value of N/A implies that the Pattern attribute is not used when qualifying data items for this data type.
Data Type | The Data Type attribute is the data type of the COBOL data item. A value of N/A implies that the Data Type attribute is not used when qualifying data items for this user data type.
Length | The Length attribute specifies the number of characters in an alphanumeric data item. A value of N/A implies that the Length attribute is not used when qualifying data items for this user data type.
Precision | The Precision attribute specifies the number of digits in a numeric data item. A value of N/A implies that the Precision attribute is not used when qualifying data items for this user data type.
Scale | The Scale attribute specifies the number of digits to the right of the decimal point in a numeric data item. A value of N/A implies that the Scale attribute is not used when qualifying data items for this user data type.


Record Type Properties Form

See Also

The Record Type Properties form enables you to define a record type filter to specify the conditions that control the records that participate in providing data to a table based on the record type.

Note The records that participate in providing data to a table based on the record type may be further filtered by a table filter associated with that table.

To display the Record Type Properties form, click Properties on the Record Type toolbar. The Record Type Properties form consists of a toolbar and a list of condition-names of the conditions for the filter subexpressions of the filter expression being defined. When the row selector symbol changes to an edit symbol (pencil), it indicates that the contents of the row have been or are being modified.

The following table describes the options available in the Record Type Properties form.

Option

Description

The Close toolbar button closes this window and retains any changes that you may have made.

The Show Filter toolbar button displays an algebraic representation of the filter expression specified in the Record Type Properties form.

The Clear Filter toolbar button removes every filter expression listed in the Record Type Properties form.

The Add Filter toolbar button displays the Describe Filter Subexpression dialog box for the definition of a filter subexpression to be added to the filter expression being defined in the Record Type Properties form. See Define a record type filter.

And/Or

The And/Or attribute specifies whether the AND logical operator or OR logical operator connects this filter subexpression to the filter expression being defined. To view an example, click here.

Not

The Not attribute specifies whether the NOT logical operator is applied to this filter subexpression of the filter expression being defined:

· If the Not attribute is selected as blank, the condition specified by the condition-name in the Condition attribute column must be true for records to pass the filter.

· If the Not attribute indicates the NOT logical operator, the condition specified by the condition-name in the Condition attribute column must be false.

Condition

The Condition attribute specifies the condition-name of the condition for the filter subexpression of the filter expression being defined. To view an example, click here.


Edit Item Sets Form

See Also

An item set is composed of two or more redundant data items. The Edit Item Sets form allows the user to create item sets, add or delete data items from a set, delete an entire item set, and delete all item sets.

To access the Edit Item Sets form:

1. On the FD form, select two or more data items that contain redundant (or identical) data.

2. Click Redundant Data Items on the FD form toolbar. The Edit Item Sets form is displayed on top of the FD form that is opened for the selected file definition.

The following table describes the options available in the Edit Item Sets form.

Option | Description
 | The Close toolbar button closes this form and retains any changes that you may have made. (The form can only be reopened by again clicking the Redundant Data Items button on the FD form toolbar.)
 | The Add New Item Set toolbar button accepts data items selected in the FD form as a new set of items. See Define an item set.
 | The Add Items to Set toolbar button accepts data items selected in the FD form into an existing item set. See Add a data item to an item set.
 | The Delete Item or Item Set toolbar button removes either: (1) a selected data item from an existing item set (see Delete a data item from an item set), or (2) a selected item set from the FD form (see Delete an item set from the list of item sets).
 | The Delete All button removes all item sets associated with FD form. See Delete all item sets associated with an FD form.
Item Set | The Item Set area lists the data items forming an item set.


Relational Definition Forms

See Also

In the Relativity Designer, you are able to map the COBOL schema from a set of one or more COBOL files to relational tables. The definitions of the relational tables are stored in the Relativity catalog and become a relational database.

A relational table is built from the COBOL file definitions displayed in the FD form. A relational table contains records that are represented by rows. The data items within the record are represented by columns. Example

Using the drag and drop technique, COBOL items are moved from the FD form to the Table form. From the Table form, editing operations are performed on the column definitions. Other forms, which are accessed via the Table form to assist in this editing process, include the following:

· Bind Subscripts Form

· Edit Connections Form

· Query Builder Form

· Show Table Contents Form

· Table Filter Properties Form

· Show Indexes for Tablename Form

The Nullable Column utility, which allows you to choose and apply nullable settings for all numeric and date columns in your Relativity catalog, is accessible from the Tools menu.


Table Form

See Also

The Table form provides detailed information concerning the properties of data items that have been dragged from the FD form and dropped into the Table form, where they are represented as column definitions. (The lower left portion of the Table form contains the Column Properties area for the selected column definition in the Table form. The appearance of each property is dependent on the data type of the data item being represented as a column definition.) Editing operations are then performed on the column definitions in the Table form.

When the Table form is open for a selected table definition, the Table menu appears on the menu bar of the Relativity Designer window.

Note Relativity also supports context-sensitive (pop-up) menus, where you can access menu commands and equivalent toolbar button shortcuts, specific to the object selected. To open a context menu in the Table form attribute grid, select the appropriate column definition(s) and right-click.

For more information about a specific toolbar button, attribute, or column property in the Table form, choose from the following topics:

· Table Form Toolbar

· Table Form - Attributes Summary

· Table Form - Column Property Summary

· Table Form - File Indicator Bar

To

Do This

Display the Table form

Click the Tables catalog object in the Catalog window and double-click a table definition from the list. When the Table form is opened for the first time, only the Column Name and Index attributes are displayed, listing the column definition(s) and indicating whether the column is a member of at least one index.

To view an unexpanded Table form, click here.

Alternatively, you can click the Open shortcut on the Table Common Tasks area or choose the Open command from the Table menu to open the Table form for the selected table definition.

Expand the Table form horizontally to display more attributes

Click Design Mode on the Table form toolbar.

To view an expanded Table form, click here.

Resize the width of a column in the Table form

Drag the vertical line located between the boundary of the column heading to the left or right.

Change the position of a column in the Table form

Click the column heading and drag the column heading to the left or right.

Select a single column definition cell in the Table form attribute grid

Click to the left edge of the cell.

Select a single column definition row in the Table form attribute grid

Move the mouse pointer to the leftmost edge of the column definition row you want to select and click the mouse button to select that column definition. Tip

Note When a column definition cell or row is selected, a selector symbol appears in the gray area to the left of the grid.

Select all column definitions

Click Select All Columns on the Table form toolbar.

Move one or more selected column definition row(s) up or down one position in the table

Click Move Up or Move Down on the Table form toolbar, respectively.

Reposition a single column definition anywhere within the list

Select an entire column and drag the selected column definition and drop it at its destination.


Example

For example, eight records within Product-1-File are represented by eight rows in a relational table. The six data items within one record are represented by six columns in a relational table.

ProductNo | Size | Color | Price | 4Price | Quantity
PF5431978D | L | 26 | 24.00 | 20.40 | 000340
PF5431978D | M | 26 | 24.00 | 20.40 | 001200
PF5431978D | S | 26 | 24.00 | 20.40 | 000333
PF5431978D | XL | 26 | 24.00 | 20.40 | 000100
PF5432232B | L | 34 | 18.00 | 15.30 | 001754
PF5432232B | M | 34 | 18.00 | 15.30 | 001055
PF5432232B | S | 34 | 18.00 | 15.30 | 000602
PF5432232B | XL | 34 | 18.00 | 15.30 | 000293


Table Form Toolbar

See Also

The Table form includes a toolbar, illustrated above, which provides shortcuts to some of the more common commands from the Table menu. For more information about a specific item on the toolbar, refer to the following table. The buttons and check boxes appear in the order of the item's appearance, starting from the left side of the toolbar.

Note Relativity also supports context-sensitive (pop-up) menus, where you can access menu commands and equivalent toolbar button shortcuts specific to the object selected. To open a context menu in the Table form attribute grid, select the appropriate column definition(s) and right-click.

Item

Description

The Design Mode button expands or contracts the Table form horizontally to display either the detailed or abbreviated description of the column definitions, which can then be edited.

The Save Changes button behaves differently depending on whether the table definition is new or already exists.

· If the table definition is new, the Save Changes button displays the Create New Table dialog box, which allows a name to be assigned to the table.

· If the table definition already exists, the Save Changes button writes into the Relativity catalog all additions, changes, and deletions made to the table description displayed in the Table form. If the Table form is closed with unsaved (or uncommitted) changes, there will be a prompt asking if any pending changes should be saved or not. This behavior can be controlled by the Save Table Changes check box on the Table page in the Options dialog box.

Note This option provides the same functionality as the Save Table Changes command on the Table menu.

The Delete Table button removes the entire table displayed in the Table form from the Relativity catalog.

Note This option provides the same functionality as the Delete command on the Table menu (or the Delete shortcut on the Table Common Tasks area of the Tables catalog object).

The Delete Column button removes one or more selected column definitions from the table displayed in the form.

The Move Down button moves one or more selected column definition(s) down one position in the table. For information on selecting column definitions, click here.

Note This option provides the same functionality as the Move Down command on the Table menu.

The Move Up button moves one or more selected column definition(s) up one position in the table. For information on selecting column definitions, click here.

Note This option provides the same functionality as the Move Up command on the Table menu.

The Select All Columns button is a toggle button that either selects all columns or removes the selection of all columns in the table.

The Find Column Name button opens the Find dialog box, where you can specify the criteria for your search in the Column Name column in the Table form. The search criteria are not highlighted when found, but rather the row selector is moved to the row where the criteria are located. This dialog box also optionally allows you to replace the search criteria by clicking the Replace button to open the Find and Replace dialog box. Replace behaves much the same as Find, except the Find What text is removed and replaced by the Replace With text.

Shortcut: Ctrl+F

Note This option provides the same functionality as the Find command on the Table menu.

The Find Next button repeats the search specified in the Find dialog box or the Find and Replace dialog box.

Shortcut: F3

Note This option provides the same functionality as the Find Next command on the Table menu.

The Edit Table Filter button displays the Table Filter Properties form to define the conditions for determining records that participate in providing data to the table viewed in the Table form. See Defining Table Filters.

Note This option provides the same functionality as the Edit Table Filter command on the Table menu.

The Edit Connections button displays the Edit Connections form to define the connections between the table and its underlying files. See Establishing Table Connections.

Note This option provides the same functionality as the Edit Connections command on the Table menu (or the Connections shortcut on the Table Common Tasks area of the Tables catalog object).

The Open FD button displays the FD form associated with the Table form.

The Show button displays the Show Table Contents form containing data from the underlying COBOL file for selected columns in the Table form. See Previewing Table Data.

If no columns are selected in the Table form, all columns will be displayed in the Show Table Contents form. The Show button is enabled only if there is exactly one table connection for the table definition displayed in the Table form. If there is no table connection or more than one table connection, see the Edit Connections form, which is displayed by clicking the Edit Connections toolbar button.

Note This option provides the same functionality as the Show Table Contents command on the Table menu (or the Show Table Contents shortcut on the Table Common Tasks area of the Tables catalog object).

The Show Indexes button displays the Show Indexes for Tablename form, which allows you to specify the columns in a table definition that participate in one or more indices.

The Write Support Wizard button launches the Write Support wizard, which will examine your table for issues that may occur if you attempt a write operation.

Allow Updates

The Allow Updates check box is used to control whether or not a given table definition will allow updates (that is, SQL UPDATE statements) on this table. This is an extra level of security that the Relativity Designer allows.

· If Allow Updates is not selected, then no matter what security a user is given, there is no way to perform update operations on the underlying table.

· If Allow Updates is selected, the user must still have the appropriate security levels to update entries in the table.

Allow Inserts

The Allow Inserts check box is used to control whether or not a given table definition will allow inserts (that is, SQL INSERT and DELETE statements) on this table. This is an extra level of security that the Relativity Designer allows.

· If Allow Inserts is not selected, then no matter what security a user is given, there is no way to perform insert or delete operations on the underlying table.

· If Allow Inserts is selected, the user must still have the appropriate security levels to insert or delete entries in the table.

If the Allow Inserts check box is selected, and if the Show Default Values check box is selected on the Table page in the Options dialog box, the Default Value column is displayed in the Table form.


Table Form - Attributes Summary

See Also

The following is a summary list with information about the attributes in the Table form attribute grid.

Attribute

Description

Column Name

The Column Name attribute is the name assigned to a column in the relational table. The column name is initially generated from the Default Column Name attribute in the FD form and may be edited. A column name may not be an SQL reserved word.

Data Type

The Data Type attribute is either the user data type or the ODBC data type associated with the column defined by this row in the Table form.

Selecting the Data Type attribute in the Table form causes the display of a down arrow indicating a list. The content of the Data Type list is limited to the database data types appropriate for the COBOL data item. Within this list, the user data types appear in normal font. The pre-assigned data type names for the ODBC data type appear in a bold font.

The following lists the data type names pre-assigned to ODBC data types in Relativity:

· Exact numeric data types are bit, smallint, integer, and decimal.

· Approximate numeric data types are single and double.

· Character (or text) data types are char, varchar, and longvarchar.

· Unstructured binary data type is longvarbinary.

· Date/time data types are date, time, and timestamp.

User data types are defined in the Data Types form. The Data Types form allows the user to define characteristics of a data type that is used frequently in the COBOL files forming the database. The definition of user data types controls the consistency of data descriptions throughout the database.

Data Item

The Data Item attribute is the COBOL data-name in the record description associated with the column. This is the same COBOL data-name that appears as the COBOL Name attribute in the FD form.

Default Value

Note The Default Value attribute is displayed in the Table form only if the Show Default Values check box is selected on the Table page in the Options dialog box and the Allow Inserts check box is selected on the Table form toolbar.

The Default Value attribute is the value that is used in write operations if the column is not present in an SQL INSERT statement. This value is set by clicking in the column, then typing in the value. The value will be limited to the range of values that is valid for the data type of the column.

For example, if a column has the date data type, the only valid default values are valid dates. The following forms are valid for entering dates:

2007-05-01 05-01-2007 01 May 2007

All of these forms refer to May 1, 2007.

If the value is inherited from a user data type (defined in the Data Types form), it may not be changed here.

Comment

Note The Comment attribute is displayed in the Table form only if the Show Comments check box is selected on the Table page in the Options dialog box.

The Comment attribute contains comments pertaining to the data item defined by this row in the Table form. If the Inherit FD Comments check box is selected on theTable page in the Options dialog box, then the comments in the FD form are moved with the data item to the Table form. See Specifying Comments.

This attribute is totally owned by the catalog developer for use in the Relativity Designer and through reports. It is a good place to maintain a user-friendly definition of the column. Through the reporting tool, this comment could then be used to build a help file for the end-user of the catalog. Another use of this attribute might be to discuss the uses of the column that may not be obvious.

Index

The Index attribute indicates that the column is a member of at least one index that Relativity has created in the table definition. (Use the Show Indexes button, which displays the Show Indexes for Tablename form, to see the indexes that have the column as a member.)

Indexes are important because they allow Relativity to optimize the performance of queries using the file keys in the underlying COBOL data file. When a table contains a column defined on a data item that is part of one of the file keys, and there is no checkmark in the Index attribute, it indicates a condition that is preventing Relativity from using that file's key. This is a condition that should be corrected before proceeding. If none of the columns in the table have the Index attribute checked, this indicates a serious problem because Relativity will be forced to read all the table's rows completely in order to select rows from it.

Note The Index attribute is not valid until the table has been saved. Also note that, even though a column is a member of an index on the table, it does not necessarily mean that Relativity will be able to use the index in a SELECT or UPDATE statement. The index chosen is a function of the columns in the WHERE clause. In order for an index to be used, the WHERE clause should not simply specify the column of interest, but all of the columns necessary to specify the leading portion of the index's file key. Use the Query Plan Viewer to see the actual index chosen for a query. The Query Plan Viewer is a standalone utility that can be started from the Relativity group on the Windows Start menu or from a command prompt. It is described in the DBMS Help file (which is accessible from the Help menu).


Table Form - Column Property Summary

See Also

The Column Properties area appears in the lower left portion of the Table form. The appearance of each property is dependent on the data type of the selected item.

The following is a summary list with information about the column properties.

Column Property

Description

Transform

The Transform property specifies a data transformation for a COBOL data item value to and/or from a relational database column value. The transform is selected from the list. This transform property is in addition to any transform assigned to the COBOL data item in the FD form. See Transforms.

The options selected on the Date Formats and/or Table pages in the Options dialog box determine the choices available in this Transform property.

Length

The Length property specifies the number of characters in an alphanumeric data item.

Digits

The Digits property specifies the number of digits in a numeric data item. The maximum number of digits is 18.

Decimal Places

The Decimal Places property specifies the number of digits to the right of the decimal point in a numeric data item.

Nullable

The Nullable property indicates that this column allows nulls. The representation of a null value for a data item is selected from a list of condition-names in the FD form. If the condition specified by the condition-name is true for a record, then the column will contain null for the row(s) derived from that record. See Defining Null Information.

The conditional variable associated with a condition-name in the list does not have to be the data item in the FD form for which the null value is defined.

Updatable

The Updatable property is visible only if the table is already marked as updatable. It can be used to prevent an individual column from being updated. This value is automatically set on or off when the Allow Updates check box is selected or cleared on the Table form toolbar.

Bound Subscripts

The Bound Subscripts property consists of a check box and a button:

· The Bound Subscripts check box appears if the selected column is associated with a repeating data item. If the Bound Subscripts check box is not selected, then none of the subscripts for the repeating data item are bound. In this case, a row will be generated in the table for every occurrence of the repeating data item. To associate the column with a particular occurrence of the repeating data item, select the check box to display the Bind Subscripts form.

· The Bound Subscripts button appears to the right of the Bound Subscripts check box. Choose the Bound Subscripts button to view or modify the options in the Bind Subscripts form for a column that already has bound subscripts.

Unsigned

The Unsigned property indicates that only nonnegative numeric values will appear in the column.

Many numeric data items do not order the data correctly. An index can include a column defined on a numeric data item under the following circumstances:

· Whatever data item values, if any, that correspond to a null in the column must precede all other values.

· The key order must be the same as numeric order. For example, negative numbers must precede positive numbers; for many signed data types, negative numbers follow positive numbers.

Note If the data item is signed but the column is marked unsigned, the Relativity DBMS will disallow negative values; the column can then be included in an index.

· There must be only one way to represent a given value in the numeric data item. For example, if the data item allows two or more representations of the sign, no index is possible. In some cases, the Relativity DBMS may limit the allowed representations of data items that are partially or totally within a file key so that an index can be built.


Table Form - File Indicator Bar

See Also

The File Indicator Bar, illustrated above, appears in the upper portion of the Table form just below the toolbar. It displays the name of the FD associated with this table. If there are record types associated with the table, they will be displayed here also.

If there are multiple record types, double-click on the File Indicator Bar to access the Assign or Remove Record Types dialog box.


Table Filter Properties Form

See Also

The Table Filter Properties form allows you to define and maintain a table filter. A table filter determines the conditions applied to records that contribute rows to the table viewed in the Table form.

Note A table filter is applied in addition to a record type filter, which is applied in the Record Type toolbar in the FD form to distinguish between multiple record types.

To display the Table Filter Properties form, click Edit Table Filter on the Table form toolbar.

The Table Filter Properties form is composed of a toolbar and a list of condition-names of the conditions for the filter subexpressions of the filter expression being defined. The following table describes the options available from the Table Filter Properties form.

Option

Description

The Close toolbar button closes the Table Filter Properties form and retains any changes that you may have made.

The Delete Filter toolbar button deletes the selected table filter expression listed in the Table Filter Properties form.

The Clear Filter toolbar button removes all filter expressions listed in the Table Filter Properties form.

The Add Filter toolbar button displays the Describe Filter Subexpression dialog box for the definition of a filter subexpression to be added to the filter expression being defined in the Table Filter Properties form. See Define a table filter.

The Show Filter toolbar button displays an algebraic representation of the filter expression specified in the Table Filter Properties form.

And/Or

The And/Or attribute specifies whether the AND logical operator or the OR logical operator connects this filter subexpression to the filter expression being defined.

Not

The Not attribute specifies whether the NOT logical operator is applied to this filter subexpression of the filter expression being defined:

· If the Not attribute is selected as blank, the condition specified by the condition-name in the Condition attribute must be true in order for records to pass the filter.

· If the Not attribute indicates the NOT logical operator, the condition specified by the condition-name in the Condition attribute must be false.

Condition

The Condition attribute specifies the condition-name of the condition for the filter subexpression of the filter expression being defined


Bind Subscripts Form

See Also

The Bind Subscripts form defines the data item or condition-name that specifies the occurrence of a desired repeating data item for a column within a table defined in the Table form that is based on that repeating data item.

The Bind Subscripts form is displayed when a column is selected in the Table form that is associated with a repeating data item in the FD form and either of the following actions is taken:

· The Bound Subscripts check box is selected in the Column Properties area of the Table form when it was not already selected.

· The Bound Subscripts button is clicked in the Column Properties area of the Table form when the Bound Subscripts check box is already selected.

The following table describes the options available from the Bind Subscripts form.

Option | Description
 | The Close toolbar button exits the Bind Subscripts form and removes the image from the Relativity Designer window.
 | The Previous toolbar button moves back to the previous subscript when two or more subscripts are associated with the data item.
 | The Next toolbar button advances to the next subscript when two or more subscripts are associated with the data item.
 | The Unbind toolbar button removes a previously established binding for a subscripted data item, regardless of whether the binding was to a data item or literal. If the subscript is unbound, then multiple rows will be generated for a column based on the subscripted data item.
 | The Bind to Data Item toolbar button allows selection of a data-name for binding the subscript to a data item. After selecting the button, the list box in the Bind Subscripts form displays a list of numeric data item data-names from which the desired binding can be selected.
 | The Bind to Literal toolbar button allows selection of a condition-name for binding the subscript to the literal value associated with the selected condition-name. After selecting the button, the list box in the Bind Subscripts form displays a list of condition-names from which the desired binding can be selected.
Data-Name/Condition-Name | The Data-Name/Condition-Name attribute is selected from the list containing either data-names or condition-names. The selected data-name or condition-name specifies the occurrence of the desired data item within a table defined in the FD form.


Show Table Contents Form

See Also

The Show Table Contents form allows you to perform the following tasks:

· Preview table data within a grid.

· Access the Query Builder form and design a query.

· Save the results of a query to a comma separated file.

· Preview and then print the results of a query.

· Search for specific text in the results of a query.

For procedures on how to display the Show Table Contents form, click here.

Note Relativity also supports context-sensitive (pop-up) menus, where you can access menu commands and equivalent toolbar button shortcuts specific to the object selected. To open a context menu on the Show Table Contents form, select the appropriate column definition(s) and right-click. The commands on this menu are shortcuts to some of the functions provided by the Show Table Contents form toolbar buttons.

The following table describes the options available from the Show Table Contents form.

Note The name of the selected table appears on the title line of the form. You can leave the Show Table Contents form open as you work in the Relativity Designer. To minimize the form, click Minimize on the title bar.

Option

Description

Data grid

The data shown on the form indicate the number of rows processed as well as the number of errors detected. When an ODBC error is encountered, “ERROR!” is also displayed in the cell causing the error. Clicking on the cell with the error displays information about the Column Type, the underlying FD item in the Picture attribute, and the text of the error from ODBC. Viewing this type of information is very helpful in detecting and resolving invalid numeric errors.

If none of the column definitions for the table are selected, the Show Table Contents form will retrieve and display all columns defined. If one or more of the column definitions are selected, the Show Table Contents form will display only those columns whose definitions are selected. Clicking within a column grid cell displays a Column Information message box containing detailed data about that column.

The Close toolbar button dismisses the Show Table Contents form.

Note The Close button provides the same functionality as the Close command on the pop-up context menu.

The Query Builder toolbar button opens the Query Builder form, where you can design a new query, or, if you have been working with a query, you can make changes to modify it. Then, you can retrieve the query results for a selected table in the catalog. The results of the query will appear automatically in the Show Table Contents form when you execute the query in the Query Builder form.

Note The Query Builder button provides the same functionality as the Design Query command on the pop-up context menu.

The Save Results toolbar button saves the results of the executed query to a comma separated file (*.csv). When you click this button, a standard Windows Save As dialog box is displayed.

Note The Save Results button provides the same functionality as the Export Results command on the pop-up context menu.

The Print toolbar button prints the results of the executed query displayed on Show Table Contents form.

Note The Print button provides the same functionality as the Print command on the pop-up context menu.

The Print Preview toolbar button opens a Print Preview window where you can see how the results of the executed query will look when printed. To disable the preview capability, click Exit from the File menu in the window or click the Close button on the title bar.

When the Print Preview window is active, a menu bar and toolbar display commands and buttons you can use to print all or part of the results, and change the display of the window.

Note The Print Preview button provides the same functionality as the Print Preview command on the pop-up context menu.

The Find toolbar button opens a Find dialog box, where you can specify the text you want to locate in a particular column of the query results displayed in the Show Table Contents form. The name of the column displayed in the Find dialog box is determined by the column definition that is selected in the form.

You can then use the Find Next toolbar button to find and select the next occurrence of the specified text.

The Find Next toolbar button finds and selects the next occurrence of the text specified with the Find toolbar button.


Display the Show Table Contents form

Choose from one of the following methods:

· If you are working with the Tables catalog object of the Catalog window, select a table definition and click Show Table Contents on the Table menu or right-click to access this same command from the pop-up context menu. Alternatively, click the Show Table Contents shortcut from the Table Common Tasks area of the Catalog window.

· If you are working with a table defined in the Table form, click Show Table Contents on the Table menu or right-click to access this same command from the pop-up context menu. Alternatively, click the Show button on the Table form toolbar.

· If you are viewing the properties of a selected file definition in the FD Properties form, expand the list of tables built from the selected file definition and right-click a table name. Click Show Table Contents from the pop-up context menu.

· If you are designing a query in the Query Builder form, click the Execute Query button.

· If you are editing table connections on the Edit Connections form, click the Show button. Note that in the Edit Connections form, the table connection must be selected prior to clicking the Show button.

Note If, as described by the first two methods listed above, a table definition name selected on the Tables catalog object in the Catalog window or opened in the Table form has more than one table connection pointing to it, the Select Table Connection to Show dialog box displays options for selecting from the multiple table connections. If the Show button on the Table form toolbar appears dim and is unavailable, then no table connection exists. Click Edit Connections on the Table form toolbar to display the Edit Connections form, where you can add the desired table connection. For procedures on how to create a table connection in the Table form, click here.


SQL Window

See Also

The SQL window allows you to define queries using any valid SQL (Structured Query Language) SELECT statements. You can select columns and rows from one or more tables in the Relativity catalog; specify one or more conditions; and order, summarize, and group the data. The resulting data will be displayed in the lower pane of the SQL window in a column-and-row format. You can view more than 100 rows of data. In addition to allowing joins, the SQL window also enables the building of expressions as well as parameter queries. The functionality of the SQL window differs from that of the Query Builder form in that the Query Builder restricts the query to a single table and to only certain aspects of the SELECT statement are permitted.

· To display the SQL window, click SQL Window on the Tools menu.

· To view the query results after you are satisfied with all your entries, click the Execute Query button to run the query. The resulting data will be displayed in the lower pane of the SQL window (this pane is resizable).

Note Only the Close and Execute Query toolbar buttons are active when you first open the SQL window. To view an example of the window in this state, click here.

► Related Topics For more information related to SQL, see the following content topics or index entries in the Relativity DBMS Help file:

· Additional Supported ODBC SQL Grammar (under the For Advanced Users | SQL Grammar topic)

· Driver-Specific ODBC SQL Grammar (under the For Advanced Users | SQL Grammar topic)

· Outer Joins (see the index entry)

· SELECT Statement (see the index entry)

· SQL Expression (see the index entry)

The following table describes the options available from the SQL window.

Option

Description

List

This is the area is where you enter your SQL SELECT statements, conditions, and parameters or expressions.

Expanded

This is the area of the window that expands to display the results of your query in a column-and-row format.

The Close button dismisses the SQL window. You also can click Close in the upper-right corner of the title bar.

After you are satisfied with all your entries, click the Execute Query button to run the query and display the results in the expanded SQL window.

The Save Results button saves the results of the executed query to a comma separated file (*.csv). When you click this button, a standard Windows Save As dialog box is displayed.

The Print button prints the results of the executed query displayed in the SQL window.

The Print Preview button opens a Print Preview window where you can see how the results of the executed query will look when printed. To disable the preview capability, click Exit from the File menu in the window or click the Close button on the title bar.

When the Print Preview window is active, a menu bar and toolbar display commands and buttons you can use to print all or part of the results, and change the display of the window.

The Find button opens a Find dialog box, where you can specify the text you want to locate in a particular column of the query results displayed in the SQL window. The name of the column displayed in the Find dialog box is determined by the column definition that is selected in the window.

You can then use the Find Next button to find and select the next occurrence of the specified text.

The Find Next button allows you to find and select the next occurrence of the text specified with the Find button.


Query Builder Form

See Also

The Query Builder form allows you to design a simple query and then to retrieve the data you want from specific columns for a single table selected in the Relativity catalog. The ability to define a query on a selected table is highly useful. For example, you can easily find erroneous data in your table by using the sort and specific criteria options to exclude data that you do not want to see.

To view the query results after you are satisfied with all your settings, click the Execute Query button to run the query. The resulting data will be displayed in a row-and-column format in the Show Table Contents form. You can view more than 100 rows of data.

To display the Query Builder form, do one of the following:

· Select a table definition on the Tables catalog object in the Catalog window and click Query Builder on the Table menu or right-click to access the command from the pop-up context menu.

· If you are viewing the properties of a selected file definition in the FD Properties form, expand the list of tables built from the selected file definition and right-click a table name. Click Query Builder from the pop-up context menu.

· If you are currently viewing table data in the Show Table Contents form, you can modify a query that was just defined or build a new query by clicking the Query Builder button on the Show Table Contents form toolbar.

Whichever method you choose, the column definitions displayed in the Column Name attribute for that table become available in the top pane (under Column List) of the Query Builder form. The lower pane contains a grid to design the query.

The following table describes the options available from the Query Builder form.

Note The name of the selected table appears on the title line of the form. You can leave the Query Builder form open as you work in the Relativity Designer. To minimize the form, click Minimize on the title bar.

Option

Description

The Close button dismisses the Query Builder form. You also can click Close in the upper-right corner of the title bar.

After you are satisfied with all your settings, click the Execute Query button to run the query and display the results in the Show Table Contents form.

Column List

In the Query Builder area, the Column List displays all the column definitions (displayed in the Column Name attribute in the selected table). This is the area where you specify the information you want in your query. To add these column names to the active query, simply drag the column name directly from the list to a cell in the Column row in the query design grid.

Alternatively, you can double-click a column name in the list to move it to the Column row. If you use this latter method, the column name is automatically added in the next available column. By default, adding a column name from this list to the Column row also displays the condition True in the Show row.

Max Rows and
Max Errors

· The Max Rows box allows you to enter the maximum number of rows in the table to be processed for the query.

· The Max Errors box allows you to enter the maximum number of errors to report. When errors are reported in the Show Table Contents form, you can correct them in the appropriate column in the Table form.

Query Design Grid

The query design grid is the area where you define your query options. It contains several columns and rows, displayed in a grid. In each column of the grid, you specify the column name from the Column List you want to include in your query and in the order in which you want it to appear. Each row in the grid lets you define a query option based on the information in one of the column names of the selected table. The information you select or add to the cells in the Sort and Criteria rows determines what you will see in the query results displayed in the Show Table Contents form.

· The Column row adds a column name to the results of the query. To add a column name, double-click the column's name in the Column List or drag the column name to this row. By default, the Show row is also displayed.

· The Show row displays or hides a column in the results of the query. If you hide a column, you can still use it to specify criteria. By default, the condition is set to True (show) when a column name is added to the Column row in the query design grid. To change the condition to False (hide), double-click in the cell to toggle the value.

· The Sort row specifies whether a particular column will be used for sorting, and if so, whether the sort is in Ascending (0 to 9, A to Z) or Descending (9 to 0, Z to A) order. If you specify a sort order in multiple columns, Relativity sorts by each column, going in order from left to right. Sorting is optional; the default is a blank cell; that is, not sorted.

To specify a sort order on a column name, double-click in the cell to toggle between Ascending and Descending, or leave the cell blank to specify no sorting.

· The Criteria row contains one or more criterion expressions for determining which records will be included in the query results. Any expressions you enter in this row instruct Relativity to show only those records that satisfy the criteria.

To enter criteria in the query, click the first Criteria cell for the column name you want to set criteria for and type the criteria expression. Note that all text and dates must be entered between single quotes.


Show Indexes for Tablename Form

See Also

The Show Indexes for Tablename form allows you to view the indexes that Relativity automatically defines on a table.

Indexes are based on the file keys of the file definition for the table. Because indexes allow Relativity to improve substantially the performance of queries, it is important that Relativity’s query optimizer have the indexes required in order to reduce the number of rows (and hence the number of file records) that must be searched in order to satisfy a query. The Show Indexes for Tablename form allows the database Designer to examine the indexes that Relativity is currently creating for the table in order to determine whether the desired indexes are available. There are several factors that will cause Relativity to exclude columns from participating in indexes, and this form is useful in detecting whether that has happened. It should be noted, however, that the Show Indexes for Tablename form will not diagnose the cause of the exclusion. To read a brief discussion that describes the requirements for a column to be part of an index, click here. A more detailed description can be found in the Relativity DBMS Help file in "Relativity Indexes" under the For Advanced Users | Relativity-Specific topic.

To display the Show Indexes for Tablename form, do one of the following:

· Select a table definition on the Tables catalog object of the Catalog window and click Show Indexes on the Table menu or right-click to access this command from the pop-up context menu.

· If you are working with a table defined in the Table form, click Show Indexes on the Table form toolbar.

· If you are viewing the properties of a selected file definition in the FD Properties form, expand the list of tables built from the selected file definition and right-click a table name. Click Show Indexes from the pop-up context menu.

The approximate number of rows for that particular table also appears in the title bar of the form.

The following table describes the options available from the Show Indexes for Tablename form.

Option | Description
Index Name | The Index Name column contains a unique name generated by Relativity for the index. It typically begins with an x_ and is followed by the numbers of the columns that make up the index, delimited by underscores. It is a requirement of SQL for the Index to have a name; however, it has no other useful purpose, as Relativity will automatically determine the best index to use for a query.
Unique | The Unique column contains True if the index uniquely identifies a row in the table and False otherwise. The False value may indicate that the underlying key allows duplicates, or that there are insufficient columns in the table definition to cover the entire file key.
Type | The Type column contains the type of the index. The following values are valid: · Clustered. Indicates a sorted index. Relativity supports only Clustered indexes. · Hashed. Indicates an index that can be used to directly index to a row in the table, but is not otherwise sorted.
Ordinal Position | The Ordinal Position column contains the position of the column within the index, with 1 indicating the most significant column.
Column Name | The Column Name column indicates the column in the relational table that participates in the index. In each index, there will be one row for each column in the index.
Order | The Order column contains a value of "Asc" if the column in the index is sorted in ascending order and a value of "Dsc" if the column is sorted in descending order.


Nullable Column Utility

See Also

The Nullable Column utility allows you to choose and apply the nullable settings for all numeric and date columns in your Relativity catalog. To start this utility in the Relativity Designer window, click Nullable Column Utility on the Tools menu.

For information on using and running this utility, click here.

The following table describes the options available on the pages of the Nullable Column utility.

Option

Description

Welcome

The utility opens with the Welcome page, which explains the purpose of the utility.

Click Next button to proceed to the next page of options or click Cancel to close the utility.

Settings

The Settings page allows you to change global catalog settings that determine when NULLs are returned for certain valid data.

· Note The following two global data source attributes may also be configured on the Data Source page of the Options dialog box.

-  The Invalid Numerics Return NULL option indicates that the Relativity DBMS will return a NULL value for any column based on a data item containing invalid numeric data.

-  The Invalid Dates Return NULL option indicates that the Relativity DBMS will return a NULL value for any date or date/time column based on a data item containing invalid date ranges either because the underlying numeric data is invalid, or the month or day is out of range.

Click the down arrow in either list box to change the three possible states for these options:

-  Select Never to cause the DBMS to return an error when this condition is encountered. (This is the default.)

-  Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

-  Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.

· To specify whether settings are to be previewed or applied, choose from the following:

-  Report Only, to view a report containing only the results of changing these settings.

-  Apply Settings, to apply the settings without viewing a report.

-  Report First, then optionally apply, to view a report and then (optionally) apply the settings.

· Select all the tables or a group of tables in the data source to process with either the Process All Tables or Select Tables to Process options.

Note If you choose the Select Tables to Process option, the Table Selection page is displayed, prompting you to select the appropriate tables. Make your selection(s) and click Next.

· Click Cancel to close the utility, click Back to return to the previous page, or click Next to open the Options page.

Options

The Options page allows you to select which columns are to be included in an index:

· Only columns that do not participate in an index. Indicates a sorted index. Relativity supports only Clustered indexes.

· All columns. Indicates an index that can be used to directly index to a row in the table, but is not otherwise sorted.

CAUTION You may lose indexes depending on your settings for the Invalid Numerics Return NULL and the Invalid Dates Return NULL options on the Settings page.

· Click Cancel to close the utility, click Back to return to the previous page, or click Next to open the Summary page.

For more information on indexes, refer to "Relativity Indexes" under the For Advanced Users | Relativity-Specific topic in the DBMS Help file.

Summary

A list of all the options you selected is displayed on the Summary page.

Click Finish to start the process. A Status Report window opens and displays actions taken, and also explains why some actions were not taken.

Note If on the Settings page you chose to apply the settings rather than simply review a report, you will be prompted with a message to confirm whether you want to update the data source with these changes.


Administration Forms

See Also

Several forms support the administration of a Relativity database:

· The Edit Connections form displays a list of table connections for the table displayed in the Table form or the table definition selected on the Tables catalog object in the Catalog window. This form supports adding, deleting, and modifying the connections between Relativity database tables and the COBOL data files that provide data for a particular table.

· The Edit Users form supports adding, deleting, and modifying authorized users of the Relativity database.

· The Edit Privileges form supports modifying the database security privileges assigned to any particular authorized user of the Relativity catalog.

These forms are available in the Relativity Designer for convenience, but also are available in the Relativity DBA for end-user administration of Relativity databases.


Edit Connections Form

See Also

The Edit Connections form provides the facility to define and edit one or more table connections associated with a Relativity table definition.

Note Whenever the Edit Connections form is displayed, a Connections menu appears on the menu bar in the Relativity Designer window.

To open the Edit Connections form in the Relativity Designer window:

· On the Security menu, click Connections.

When this method is used, the Edit Connections form lists all currently existing table definitions. The list of table definitions is hierarchical in nature, in that when expanded, it displays the table connection (that is, the table name, path name, and file label, if file labels are in effect) for a specific table definition. A plus [+] sign precedes each item in the list. To expand the list, select an item and click the plus sign (to view an example, click here). To collapse the list, click the minus sign [-].

Because all existing table definitions are accessible from this view, the Global Add, Global Delete, and Global Edit toolbar buttons are enabled.

Note If file labels are in effect, the table connection also includes the name of the file label associated with the table definition. (To view an example, click here.) For further information, see Supporting Multi-File Tables.

· Alternatively, you can open the Edit Connections form by using either of these methods:

-  From the Tables catalog object in the Catalog window, select a table definition and click the Connections shortcut in the Table Common Tasks area.

-  On the Table form toolbar, click the Edit Connections button. Or, on the Table form, right-click on a selected column definition and click Edit Connections on the pop-up context menu.

When any of these alternative methods are used, the Edit Connections form displays only the table definition currently selected on the Tables catalog object in the Catalog window or opened in the Table form.

In addition to drop-down menus, Relativity also supports context-sensitive menus that pop up at the click of the right mouse button. If you select and right-click any of the items in the list or expanded list of table definitions, the menu commands relevant to that item are displayed. From the pop-up context menu, choose the command you need. (Commands that do not apply are dimmed.)

The Edit Connections form contains the following options.

Option

Description

The Close toolbar button closes the Edit Connections form and saves any changes you may have made.

Shortcut: Ctrl+F4

The Save Changes toolbar button saves any changes you may have made to the Edit Connections form without closing the form.

Shortcut: Alt+S

The Global Add toolbar button displays the Add Connections Matching Pattern dialog box, which contains options for the addition of table connections based on the matching of patterns within table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Security menu), the Global Add button is enabled for global manipulation.

Shortcut: Alt+G

The Global Delete toolbar button displays the Delete Connections Matching Pattern dialog box, which contains options for the deletion of table connections based on the matching of patterns within table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Security menu), the Global Delete button is enabled for global manipulation.

Shortcut: Alt+T

The Global Edit toolbar button displays the Edit Connections Matching Pattern dialog box, which contains options for the editing of table connections based on the matching of patterns within the table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Security menu), the Global Edit button is enabled for global manipulation.

Shortcut: Alt+F

The Add Table Connection toolbar button displays the Add Table Connection dialog box, which contains options for the definition of a table connection for a selected table definition on the Edit Connections form.

Shortcut: Alt+A

The Delete Table Connection toolbar button deletes selected table connections for a selected table definition in the Edit Connections form.

Shortcut: Alt+D

The Edit Table Connection toolbar button displays the Edit Selected Table Connections dialog box, which contains options for the editing of selected path names and file labels (if file labels are in effect) in selected table connections of a table definition in the Edit Connections form.

Shortcut: Alt+E

The Show toolbar button displays the Show Table Contents form containing data from underlying COBOL file(s) for the selected table connection.

Table

The Table area contains the names of the Relativity table definitions associated with one or more table connections. How the information is displayed depends on how you open the form:

· When the Edit Connections form is opened by choosing the Connections command from the Security menu in the Designer window, this area displays a hierarchical list of all the currently existing table definitions. To view an example, click here.

· When the Edit Connections form is opened from the Tables catalog object in the Catalog window or on the Table form, this area displays only the associated table connection (that is, the table name, path name, which is the physical file-name of the data file, and file label, if file labels are in effect) for the selected table definition. To view examples, click here.

In either case, a plus sign [+] or minus [-] sign precedes each item in the list shown in the Table area. To expand an item and display the table connection for a specific table definition, click the plus sign. Conversely, click the minus sign to collapse an item in the expanded list.

Note If you right-click any of the items in the list or expanded list, a pop-up context-sensitive menu is displayed for that item.


Edit Users Form

See Also

The Edit Users form provides the facility to define and maintain groups and users for a Relativity database. A database group name is the name of a group of users associated with a catalog. A user name is the name of a user associated with a group with a database. Each group name and user name within a catalog must be unique.

Note Many of the functions provided on the Edit Users form can be accessed by using the commands on the User menu or the shortcuts in the User Common Tasks area when a user or group name is selected on the Users & Groups catalog object in the Catalog window.

To open the Edit Users form in the Relativity Designer window:

· On the Security menu, click Users.

The Edit Users form contains the following options.

Option

Description

The Close button closes the Edit Users form and saves any changes that you may have made.

Shortcut: Ctrl+F4

The Add Group button displays the Add Database Group dialog box, which contains options for the addition of a new database group and an expiration date for catalog access.

Shortcut: Alt+G

Note The Add Group button provides the same functionality as the Add Group command on the User menu.

The Delete Group button deletes the selected group and all its users from the Edit Users form.

Shortcut: Alt+T

The Edit Group Password button displays the Change Password dialog box, which contains options for the definition of a new password, verification of an existing password, and an expiration date for catalog access for the selected group in the Edit Users form.

Shortcut: Alt+E

The Reset Group Password button removes the current password for the selected group in the Edit Users form.

Shortcut: Alt+X

Note The Reset Group Password button provides the same functionality as the Reset Password command on the User menu.

The Add User button displays the Add Database User dialog box, which contains options for the addition of a new user to the selected group and an expiration date for catalog access in the Edit Users form. Each user name must be unique within the catalog.

Shortcut: Alt+U

Note The Add User button provides the same functionality as the Add User command on the User menu.

The Delete User button deletes a selected user from a group in the Edit Users form.

Shortcut: Alt+D

The Edit User Password button displays the Change Password dialog box. This dialog box contains options for the definition of a new password, verification of the password, and an expiration date for catalog access for one or more selected users within a selected group in the Edit Users form.

Shortcut: Alt+J

The Reset User Password button removes the current password for one or more selected users within a selected group in the Edit Users form.

Shortcut: Alt+Y

Note The Reset User Password button provides the same functionality as the Reset Password command on the User menu.

Group Name

The Group Name attribute is the name of a user group associated with the catalog. Each group name and user name within a catalog must be unique.

User Name

The User Name attribute is the name of a user associated with the selected user group. Each user name and group name within a catalog must be unique.


Edit Privileges Form

See Also

The Edit Privileges form provides the facility to define and maintain privileges of groups associated with a Relativity table definition.

To open the Edit Privileges form in the Relativity Designer window:

· On the Security menu, click Privileges.

· Alternatively, select a group name on the Users & Groups catalog object in the Catalog window and do one of the following:

-  Click Privileges on the User menu or right-click to access this same command from the pop-up context menu.

-  Click the Privileges shortcut from the User Common Tasks area.

The Edit Privileges form contains the following options.

Option

Description

The Close toolbar button closes the Edit Privileges form. However, if you have made any changes to the form, a message box appears prompting you to commit the privilege changes:

· Selecting Yes accepts the changes and then closes the form.

· Selecting No closes the form without applying any of the changes.

· Selecting Cancel ignores any changes and leaves the form open.

Shortcut: Ctrl+F4

The Save Changes toolbar button accepts all privileges defined in the Edit Privileges form for the groups of a database.

Shortcut: Alt+S

Group

The Group list on the Edit Privileges form contains the names of database groups associated with the catalog. This list contains the groups defined in the Edit Users form and a group called <PUBLIC>. Privileges assigned to the <PUBLIC> group become privileges assigned to all users in the database.

Note When the form is opened from the Users & Catalog object, the selected group is already displayed in the Group list. When the form is opened from the Privileges command on the Security menu, you must select the group from this list.

Privilege

The Privilege list on the Edit Privileges form contains the privileges that can either be granted or not granted to a database group associated with the catalog. There are five types of privileges for a Relativity database:

· Administrator privileges

· Create Users privilege

· Create Tables privilege

· Table privileges

· Column privileges

Note When a Column privilege is selected, a Table list is displayed to the right of the Privilege list in the Edit Privileges form. This list contains the names of all tables within the database. Upon selection of a table, the Not Granted column contains the names of all columns within the specified table.

The privilege you select in the Privilege list determines what appears in the Not Granted, Granted, and With Grant columns. For more information, click here.

Table

The Table list on the Edit Privileges form contains the names of all tables within the database. When a table is selected, the Not Granted column contains the names of all columns within the specified table. The Table list is displayed only when a Column privilege is selected.

Not Granted

The Not Granted column on the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group does not have access rights.

Granted

The Granted column on the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group has access rights.

With Grant

The With Grant column on the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group has access rights. The group also has the ability to grant those access rights to another group.

The Move Right toolbar button between the Not Granted and Granted columns on the Edit Privileges form moves the selected item(s) from the Not Granted column to the Granted column.

Note Using the Move Right button to move an item from the Not Granted column to the Granted column is the equivalent of the action performed by the SQL GRANT statement without the WITH GRANT OPTION phrase. That is, the privilege is now in the state of having been granted.

The Move Left toolbar button between the Not Granted and Granted columns on the Edit Privileges form moves the selected item(s) from the Granted column to the Not Granted column.

Note Using the Move Left button to move an item from the Granted column to the Not Granted column is the equivalent of the action performed by the SQL REVOKE statement. That is, the privilege is now revoked and is in the state of being not granted.

The Move Right toolbar button between the Granted and With Grant columns on the Edit Privileges form moves the selected item(s) from the Granted column to the With Grant column.

Note Using the Move Right button to move an item from the Granted column to the With Grant column is equivalent to having specified the WITH GRANT OPTION phrase in the SQL GRANT statement. That is, the privilege is now in the state of having been granted with the grant option.

The Move Left toolbar button between the Granted and With Grant columns on the Edit Privileges form moves the selected item(s) from the With Grant column to the Granted column.

Note Using the Move Left button to move an item from the With Grant column to the Granted column is the equivalent of the action performed by the SQL REVOKE statement specifying the GRANT OPTION FOR phrase (REVOKE GRANT OPTION FOR privilege-list ON object FROM user-list). That is, the privilege is again in the state of having been granted without the grant option.


Dialog Boxes

For information about specific options in the dialog boxes provided in the Relativity Designer, select one of the following topics.

Add COBOL Data Item Redefinition | Merge Details
Add Condition Item | ODBC Data Source Administrator
Add Connections Matching Pattern | Open Relativity Data Source
Add Data Item Pattern | Print Options
Add Data Type | Printer Choice
Add Database Group | Re-Importing Btrieve Keys (Micro Focus COBOL Only)
Add Database User | Rename file
Add File Label | Rename table
Add Function Constant | Resolve Merge Differences
Add Record Type | Save Export File As
Add Table Connection | Select 01's
Assign or Remove Record Types | Select Btrieve Data File for filename (Micro Focus COBOL Only)
Automated Resolution | Select Character Set
Btrieve Key Import for filename Dialog Box (Micro Focus COBOL Only) | Select COBOL Source
Change Catalog Owner | Select Data Type
Change Password | Select DDL Export File
Character Set Maintenance | Select FDs to Delete
Choose Subscript Values | Select Function
Copy File Label | Select Report
Copy File Label Column | Select RM/COBOL Program
Copy table name | Select Server
Create New Table | Select Symbol Table
Date Constants | Select Table Connection to Show
Delete Connections Matching Pattern | Select Tables to Delete
Delete File Label | Set Default Value
Delete File Label Column | Source Code Import Wizard
Describe Filter Subexpression | Source Code Import Wizard (with Micro Focus COBOL as the Dialect)
Edit Connections Matching Pattern | Source Code Import Wizard Detected Errors Page
Edit Data Item Pattern | Source Code Import Wizard File Selection Page (for .CBL or .RST files)
Edit Default Column Names | Source Code Import Wizard File Selection Page (for .COB Files)
Edit Group | Source Code Merge Wizard
Edit User | Source Code Merge Wizard (with Micro Focus COBOL as the Dialect)
Edit Selected Table Connections | Source Code Merge Wizard Detected Errors Page
Export DDL | Source Code Merge Wizard File Selection Page (for .CBL and .RST Files)
Export Preferences | Source Code Merge Wizard File Selection Page (for .COB Files)
Find and Find and Replace | Status Report
Find COBOL Item | Subscripted Data Item Dialog Box
Function of Function | Table Wizard
Import from Another Relativity Data Source | Table Wizard Edit Page
Invalid Column Name | Tables to Keep
Logon | Write Support Wizard


Add COBOL Data Item Redefinition Dialog Box

See Also

The Add COBOL Data Item Redefinition dialog box displays options for the creation of a data item to be associated with a portion of a previously selected data item in the FD form.

To display this dialog box, click Add Data Item on the FD form toolbar. Alternatively, you can choose Add Redefines from the FD menu when focus is in the FD form.

The Add COBOL Data Item Redefinition dialog box contains the following options.

Note The contents of this dialog box can vary depending on the data item selected in the Item Type list.

Option | Description
Name | In the Name box, type the data-name to be assigned to the data item being defined. This data-name must conform to the rules for a COBOL data-name.
Item Type | The Item Type list displays a list of COBOL data types from which to select the data type of the data item being defined. The options selected on the COBOL Types page in the Options dialog box determine the choices available in the Item Type list.
Length | In the Length box, enter a value for the length of the data item being defined. The maximum length that can be specified is determined by the number of characters in the data item whose portion is being redefined by the Add COBOL Data Item Redefinition dialog box.
Offset | In the Offset box, enter a value for the offset of the data item being defined. An offset value of 1 indicates that the data item being defined begins in the first character in the containing data item. An offset value of 3 indicates that the data item being defined begins in the third character of the containing data item.
Precision | If a numeric item type was selected the Precision box is displayed, enabling you to enter a value for the precision of the data item being defined. The precision specifies the number of decimal digits and is constrained based on the data type and the length selected.
Scale | If a numeric item type was selected the Scale box is displayed, enabling you to enter a value for the scale of the data item being defined. The scale factor specifies the position of the decimal point from the right end of the new data item in terms of decimal digits. The absolute value of a negative scale factor specifies the number of digits to the right of the decimal point.
Generated description | Located immediately above the Add Item button is a COBOL-like data description entry that is generated by the entries in the Add COBOL Data Item Redefinition dialog box. For example, EXCHANGE-CODE PIC 999 REDEFINES CF-PHONE (4:3) is the data description entry for the field EXCHANGE located in the 4th, 5th, and 6th character positions of the containing field CF-PHONE.
Add Item | The Add Item button completes the Add COBOL Data Item Redefinition dialog box by accepting all the selections made within the dialog box.
Cancel | The Cancel button backs out of the Add COBOL Data Item Redefinition dialog box by canceling all selections made within the dialog box.


Add Condition Item Dialog Box

See Also

The Add Condition Item dialog box displays options for the creation of an 88-level condition-name entry to be associated with a previously selected data item in the FD form. The selected data item is displayed at the top of the dialog box.

To display this dialog box, click Add Condition Item on the FD form toolbar. Alternatively, you can choose Add 88 from the FD menu when focus is in the FD form.

The Add Condition Item dialog box contains the following options.

Option

Description

New 88 Name

In the New 88 Name box, type the 88-level condition-name to be assigned to a data description entry. The condition-name must conform to the rules for a COBOL condition-name.

Single Value and
Value Range

The Single Value and Value Range option buttons provide you with a choice of defining a condition-name associated with either a single value or a range of values.

Value and To Value

1. The Value and To Value list boxes display the following items for the selection of a value or a type of value:

· Entered. Specifies that a value is to be entered in the text box to the right. Note that Entered is the only selection allowed when the conditional variable is numeric.

· SPACES. Specifies the figurative constant SPACES as the value for the condition-name.

· ZEROS. Specifies the figurative constant ZEROS as the value for the condition-name.

· LOW-VALUES. Specifies the figurative constant LOW-VALUES as the value for the condition-name.

· HIGH-VALUES. Specifies the figurative constant HIGH-VALUES as the value for the condition-name.

· Hexadecimal. Specifies that a hexadecimal value is to be entered in the text box to the right.

If the Single Value option button is selected, then the Value list box applies to the single value.

If the Value Range option button is selected, then the Value list box applies to the lowest value in the range of values. The To Value list box applies to the highest value in the range of values.

2. The Value and To Value text boxes allow you to type in a value when the value type selected in the Value or To Value drop-down list is Entered or Hexadecimal.

-  If the Single Value option button is selected, then a single value is typed in the Value text box.

-  If the Value Range option button is selected, then the lowest value in the range is typed in the Value text box. The highest value in the range is typed in the To Value text box.

Series

Selecting the Series check box causes the generation of a condition item series; that is, multiple condition-names associated with the selected subscript item. These condition-names may be used to bind the subscript of the repeating data items accessed by the selected subscript item.

Each condition item in the generated series of condition items is assigned a condition-name consisting of the name provided in the New 88 Name box appended with a hyphen and a number. The number ranges from 1 to the maximum value of the subscript. The number appended to each condition-name in the series is also set as the single true value for the corresponding condition-item in the series.

For example, assume SubscriptItem is selected in the FD form, the Add Condition Item button is clicked, the characters CNAME are entered in the New 88 Name box, the Series check box is selected, and Add button is clicked. Then the following condition items will be associated with SubscriptItem:

03 repeating-data-item     PIC X  OCCURS 5 TIMES.
   si SubscriptItem  [subscript of repeating-data-item].
      88 CNAME-1     value 1.
      88 CNAME-2     value 2.
      88 CNAME-3     value 3.
      88 CNAME-4     value 4.
      88 CNAME-5     value 5.

Note The Series check box is not available when the item selected in the FD form is not a subscript item.

Set to False

Selecting the Set to False check box allows you to define a condition-name associated with the entry of a value in the False Value list box.

Note Because the false value is always a single value, this check box is not available on subsequent Add Condition Item dialog boxes that are displayed when the Next button is clicked. If you want to set the false value after having clicked the Next button, use the Previous button to return to the first value of the condition item being added.

False Value

1. The False Value list box displays a list of items for the selection of a value or a type of value. The false value is used by Relativity only for write support operations (that is, building writable tables). The false value is always a single value, never a value range or series. The following items are valid:

· Entered. Specifies that a value is to be entered in the text box to the right. Note that Entered is the only selection allowed when the conditional variable is numeric.

· SPACES. Specifies the figurative constant SPACES as the value for the condition-name.

· ZEROS. Specifies the figurative constant ZEROS as the value for the condition-name.

· LOW-VALUES. Specifies the figurative constant LOW-VALUES as the value for the condition-name.

· HIGH-VALUES. Specifies the figurative constant HIGH-VALUES as the value for the condition-name.

· Hexadecimal. Specifies that a hexadecimal value is to be entered in the text box to the right.

2. The False Value text box allows you to type in a value when the value type selected in the False Value list box is Entered or Hexadecimal.

Add

The Add button completes the Add Condition Item dialog box by accepting all the entries made within the dialog box.

Previous

The Previous button enables you to define the previous value for multiple values within the VALUE clause associated with the condition-name being defined.

Next

The Next button enables you to define the next value for multiple values within the VALUE clause associated with the condition-name being defined.

Cancel

The Cancel button backs out of the Add Condition Item dialog box by canceling all entries made within the dialog box.


Add Connections Matching Pattern Dialog Box

See Also

The Add Connections Matching Pattern dialog box displays options for the addition of table connections based on the matching of patterns within table names in the Edit Connections form.

To display this dialog box, select a table definition or table name on the Edit Connections form and click the Global Add toolbar button.

The Add Connections Matching Pattern dialog box contains the following options.

Option

Description

Match Table Name

If the check box preceding the Match Table Name box is selected, you can enter the matching pattern for the table name in the Edit Connections form. Each occurrence of the matching pattern within table names in the Edit Connections form results in the addition of a table connection with the specified table name and path name.

Match Path Name

If the check box preceding the Match Path Name is selected, you can enter the matching pattern for the path name in the Edit Connections form. Each occurrence of the matching pattern within table names in the Edit Connections form results in the addition of a table connection with the specified table name and path name.

Match File Label

If the check box preceding the Match File Label box is selected, you can enter the matching pattern for the file label item in the Edit Connections form.

Note This box appears only if a file label item has been added to the FD on which the table is based. For more information, see Supporting Multi-File Tables.

Table Name

· The Table Name Replace box contains the pattern to be matched within the table name for replacement in the generation of a table name for the new table connection.

· The Table Name with box contains the pattern that is to replace the matching characters specified in the Table Name Replace box. The resulting table name becomes the table name for the new table connection.

Path Name

· The Path Name Replace box contains the pattern to be matched within the path name for replacement in the generation of a path name for the new table connection.

· The Path Name with box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the path name for the new table connection.

File Label

· The File Label Replace box contains the pattern to be matched within the file label for replacement in the generation of a file label for the new table connection.

· The File Label with box contains the pattern that is to replace the matching characters specified in the File Label Replace box. The resulting file label becomes the file label for the new table connection.

Note This option appears only if a file label item has been added to the FD on which the table is based. For more information, see Supporting Multi-File Tables.

Add Connections

The Add Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you click Save Changes on the Edit Connections form.

Cancel

The Cancel button closes the Add Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Add Data Item Pattern Dialog Box

See Also

The Add Data Item Pattern dialog box displays attributes for the definition of common patterns appearing in COBOL data items. In this dialog box, a selected check box following the attribute name indicates that the attribute is part of the definition of the item pattern.

To display this dialog box, do one of the following:

· On the Item Patterns form, click the Add Item Pattern toolbar button.

· Drag a data item in the FD form to the Item Patterns form.

The Add Data Item Pattern dialog box contains the following options.

Option | Description
Item Type | When the Item Type check box is selected in the Item Pattern area, a list of data types is enabled to allow the selection of the data type of the data item being defined.
Length | When the Length check box is selected in the Item Pattern area, a text box is enabled that allows you to specify the number of storage characters in the data item pattern.
Precision | When the Precision check box is selected in the Item Pattern area, a text box is enabled that allows you to specify the number of digits in a numeric data item pattern.
Scale | When the Scale check box is selected in the Item Pattern area, a text box is enabled that allows you to specify the number of digits to the right of the decimal point in a numeric data item pattern.
Pattern | When the Pattern check box is selected in the Item Pattern area, a text box is enabled that allows you to specify a character pattern that appears within the COBOL name associated with the data item.
User Data Type | The User Data Type list specifies the name of the user data type having the data item pattern defined in the Add Data Item Pattern dialog box. The data type name is chosen from the list of data types in the associated list. If the < New > item is selected from the list of data types, then a new data type name is defined by entries in the Add Data Type dialog box.
Item Transform | The Item Transform list allows you to select a transform that specifies the transformation of a COBOL data item value to and/or from a relational database column value.
Add Pattern | The Add Pattern button completes the Add Data Item Pattern dialog box by accepting all the selections made within the dialog box.
Cancel | The Cancel button backs out of the Add Data Item Pattern dialog box by canceling all selections made within the dialog box.


Add Data Type Dialog Box

See Also

The Add Data Type dialog box displays options to define a user data type.

To display this dialog box, do one of the following:

· On the Add Data Item Pattern dialog box, click the < New > item in the User Data Type list.

· On the Data Types form, click the Add Data Type toolbar button.

The Add Data Type dialog box contains the following options.

Option

Description

Data Type Name

In the Data Type Name box, type the name to be assigned to the user data type. This data type name will appear in the lists of data types in the Table form and the FD form. This data type name must be unique.

Type

Under Column Properties, the Type list selects the ODBC data type (char, date, integer, and so forth) associated with this user data type. The following lists the data type names pre-assigned to ODBC data types in Relativity:

· Exact numeric data types are bit, smallint, integer, and decimal.

· Approximate numeric data types are single and double.

· Character (or text) data types are char, varchar, and longvarchar.

· Unstructured binary data type is longvarbinary.

· Date/time data types are date, time, and timestamp.

Transform

A transform converts a COBOL data item value to or from a relational database column value. The transform to be used is selected from the Transform list under Column Properties. Note that this transform property is usually left blank if the transform is already assigned to the COBOL data item.

Length

Under Column Properties, the Length box specifies the length of the item as represented in an SQL column.

Digits

Under Column Properties, the Digits box specifies the number of decimal digits in a numeric item.

Decimal Places

Under Column Properties, the Decimal Places box specifies the number of decimal digits to the right of the decimal place in a numeric item.

Default Value

Under Column Properties, the Default Value box specifies the value that is used in write operations if the column is not present in an INSERT statement. The value will be limited to the range of values that is valid for the data type of the column.

For example, if creating a date data type, the only valid default values are valid dates. The following forms are valid for entering dates:

2007-05-01 05-01-2007 01 May 2007

All of these forms refer to May 1, 2007.

Nullable

The Nullable attribute indicates that this data type can create null column values. The COBOL representation of a null for a data type is selected from a list of condition-names in the FD form COBOL data item for which a nullable column is defined.

If the condition specified by the condition-name is true, then the data item in the FD form is considered to have a null value, the value of a data item to one of the true values indicated by an 88-level condition-name. You may add 88-level condition-names if the program does not have them.

The conditional variable associated with a condition-name in the list does not have to be the data item in the FD form for which the null value is defined.

Constrain

The Constrain attribute limits the value that a column may have during an insert or update to one of the true values indicated by an 88-level condition-name defined on the data item associated with the column. You may add 88-level condition-names if the program does not have them.

Add Data Type

The Add Data Type button completes the Add Data Type dialog box by accepting all the selections made within the dialog box.

Cancel

The Cancel button backs out of the Add Data Type dialog box by canceling all selections made within the dialog box.


Add Database Group Dialog Box

See Also

The Add Database Group dialog box displays options for the entry of a new group name, an optional password, and an expiration date for access to a catalog for the group name. The expiration feature allows a group's access privileges to be terminated without actually deleting the group from the catalog. Consequently, the group could be authorized access later at the same security level.

Note If the access date for a group has expired, all of the privileges of the users in that group have also expired.

To display this dialog box, do any of the following:

· On the Edit Users form, click the Add Group toolbar button.

· When a group name is selected on the Users & Groups catalog object in the Catalog window, you can do either of the following:

-  Click the Add Group shortcut from the User Common Tasks area.

-  Choose Add Group from the User menu.

The Add Database Group dialog box contains the following options.

Option

Description

New Group Name

In the New Group Name box, type the name of the new group to be added to the list of database groups associated with the catalog. Each group name and user name must be unique within a catalog.

Password

In the Password box, type the password for the new group. An asterisk (*) character is displayed for each character entered. This entry is optional.

Verify Password

In the Verify Password box, type the password a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Add Database Group dialog box must contain the same characters before the password is accepted for the group.

Use Expiration

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the group name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.

OK

The OK button completes the Add Database Group dialog box by accepting the new group name in the dialog box.

Cancel

The Cancel button backs out of the Add Database Group dialog box by canceling all entries made within the dialog box.


Add Database User Dialog Box

See Also

The Add Database User dialog box displays options for the entry of a new user name, an optional password, and an expiration date for access to a catalog for the user name. The expiration feature allows a user's access privileges to be terminated without actually deleting the user ID from the group. Consequently, the user could be authorized access later at the same security level in the group.

Note An expiration date set on a user applies only to that user within the group. An expiration date set on a group, however, applies to all members of the group. If the access date for a group has expired, all of the privileges of the users in that group have also expired.

To display this dialog box, do any of the following:

· On the Edit Users form, click the Add User toolbar button.

· When a user name is selected on the Users & Groups catalog object in the Catalog window, you can do either of the following:

-  Click the Add User shortcut from the User Common Tasks area.

-  Click Add User from the User menu.

The Add Database User dialog box contains the following options.

Option

Description

New User Name

In the New User Name box, type the name of the new user to be added to the selected database group within the catalog. Each group name and user name must be unique within a catalog.

Password

In the Password box, type the password for the new user. An asterisk (*) character is displayed for each character entered. This entry is optional.

Verify Password

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Add Database User dialog box must contain the same characters before the password is accepted for the user.

Use Expiration

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the user name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.

OK

The OK button completes the Add Database User dialog box by accepting the new user name into the selected group.

Cancel

The Cancel button backs out of the Add Database User dialog box by canceling all entries made within the dialog box.


Add File Label Dialog Box

See Also

The Add File Label dialog box displays options for the creation of a special file definition item, called a file label item, which is added to the file's FD.

To display this dialog box, open the FD form for the selected COBOL file definition and choose Add File Label from the FD menu.

The Add File Label dialog box contains the following options.

Option | Description
Name | In the Name box, type the name to be given to the file label item.
Item Type | In the Item Type box, select the type to be given to the file label item. Note Currently, the only item type supported for file labels is Alphanumeric edited.
Length | In the Length box, enter the maximum length of the value for the file label item.
Add File Label | The Add File Label button generates a file label item in the FD form.
Cancel | The Cancel button backs out of the Add File Label dialog box by canceling all entries made within the dialog box.


Add Function Constant Dialog Box

See Also

The Add Function Constant dialog box displays options for the addition of an alphanumeric or numeric constant to the argument list of the selected function item. The text, "Argument n for function-item-name", is displayed below the title bar.

To display this dialog box, select a function item in the FD form and click Add Constant Argument on the FD form toolbar.

The Add Function Constant dialog box contains the following options.

Option

Description

Alphanumeric

If selected, the Alphanumeric option button specifies that the argument will be alphanumeric.

Numeric

If selected, the Numeric option button specifies that the argument will be numeric.

Value

1. The Value list box displays the following items for the selection of a value or a type of value:

· Entered. Specifies that a value is to be entered in the text box to the right. Note that Entered is the only selection allowed when the conditional variable is numeric.

· SPACES. Specifies the figurative constant SPACES as the value for the condition-name.

· ZEROS. Specifies the figurative constant ZEROS as the value for the condition-name.

· LOW-VALUES. Specifies the figurative constant LOW-VALUES as the value for the condition-name.

· HIGH-VALUES. Specifies the figurative constant HIGH-VALUES as the value for the condition-name.

· Hexadecimal. Specifies that a hexadecimal value is to be entered in the text box to the right.

2. The Value text box allows you to type in a value when the value type selected in the Value drop-down list is Entered or Hexadecimal.

Add

The Add button completes the Add Function Constant dialog box by accepting all selections made within the dialog box.

Cancel

The Cancel button backs out of the Add Function Constant dialog box by canceling the selections made within the dialog box.


Add Record Type Dialog Box

See Also

The Add Record Type dialog box displays a box for the entry of the record-name to be associated with the new record type.

To display this dialog box, select the < new record type > item from the Record Type list on the Record Type toolbar in the FD form.

The Add Record Type dialog box contains the following options.

Option | Description
Record Type Name | In the Record Type Name box, type the record-name to be assigned to the record defined by the selected data items in the FD form. This record-name must conform to the rules for a COBOL data-name.
OK | The OK button completes the Add Record Type dialog box by accepting the record-name typed in the box.
Cancel | The Cancel button backs out of the Add Record Type dialog box by canceling the record-name entry made within the box.


Add Table Connection Dialog Box

See Also

The Add Table Connection dialog box displays options for the definition of a table connection to be established for the table definition selected in the Edit Connections form.

To display this dialog box, do one of the following:

· Click the Add Table Connection toolbar button on the Edit Connections form.

· Select a table definition in the Edit Connections form and click Add Table from the Connection menu, or right-click and choose this same command from the pop-up Connection context menu.

· If a selected table definition has a file label, select the table name in the Edit Connections form and click Add Connection from the Connection menu, or right-click and choose this same command from the pop-up Connection context menu. (Note that this command appears only when file labels are in effect.)

The Add Table Connection dialog box is displayed for each new table connection whenever the path name (or the file label, if file labels are in effect) is not modified (that is, when the path name and/or file label replace pattern match fails to find a matching string in the existing table connection path name and/or file label). This represents the case where a new table name would be equivalent to an existing table name. You can do one of the following:

· Click Cancel to skip this table connection.

· Click Add Connection to accept the table connection.

· Select a different path name and click Add Connection to accept the modified table connection.

The Add Table Connection dialog box contains the following options.

Option

Description

Table Name

In the Table Name box, type the table name of the SQL table to be associated with the table connection being added to the selected table definition in the Edit Connections form.

Path Name

In the Path Name box, type, or select from the list, the path name to the data file. This path name is associated with the table connection being added to the selected table definition in the Edit Connections form. The path name is the physical filename of the data file.

Each unique file path name used in a table connection is added to the file connection list in the catalog. This list is used to provide the list for the Path Name box in the Add Table Connection dialog box. When a table connection is deleted and no other table connection refers to its file connection entry, a message box prompts whether the file connection should be deleted. If the file connection is deleted, it will no longer be available in the list for the Path Name box of the Add Table Connection dialog box, thus requiring that it be retyped into the box if another table connection is later added that uses the same file path name.

File Label

In the File Label box, type, or select from the list, the file label to be associated with the table connection being added to the selected table definition in the Edit Connections form.

Note This box appears only if a file label item has been added to the FD on which the table is based. For more information, see Supporting Multi-File Tables.

Add Connection

The Add Connection button completes the Add Table Connection dialog box by accepting all entries made within the dialog box.

Cancel

The Cancel button backs out of the Add Table Connection dialog box by canceling all entries made within the dialog box.


Assign or Remove Record Types Dialog Box

See Also

The Assign or Remove Record Types dialog box allows control of which record types are associated with a table. This dialog box is available only when a table has multiple record types.

To display this dialog box, double-click the Record Types option on the File Indicator Bar in the expanded Table form.

The Assign or Remove Record Types dialog box contains the following options.

Option | Description
Available Record Types | The Available Record Types list contains all of the record types associated with the file definition that are not already in use for this table. This list is updated by specifying actions with the Add, Remove, Add All, and Remove All buttons.
Record Types Used | The Record Types Used list contains all of the record types that are already in use for this table. This list is updated by specifying actions with the Add, Remove, Add All, and Remove All buttons.
Add | The Add button moves the selected record type(s) in the Available Record Types list to the Record Types Used list.
Remove | The Remove button moves the selected COBOL object program in the Record Types Used list to the Available Record Types list.
Add All | The Add All button moves all the record types in the Available Record Types list to the Record Types Used list.
Remove All | The Remove All button moves all COBOL object programs in the Record Types Used list to the Available Record Types list.
Save | The Save button completes the Assign or Remove Record Types dialog box by accepting all the selections made within the dialog box.
Cancel | The Cancel button backs out of the Assign or Remove Record Types dialog box by canceling all selections made within the dialog box.


Automated Resolution Dialog Box

See Also

The Automated Resolution dialog box allows the modification of the rules under which Relativity attempts to match COBOL data item definitions during the merging process.

To display this dialog box, click the Automated Resolution toolbar button in the Resolve Merge Differences dialog box.

The Automated Resolution dialog box contains the following options.

Option | Description
Type Changes | Under Resolve, selecting the Type Changes check box instructs Relativity automatically to resolve changes in the COBOL data type of COBOL data items during the merging process.
Position Changes | Under Resolve, selecting the Position Changes check box instructs Relativity automatically to resolve changes in the character position of COBOL data items during the merging process.
Length Changes | Under Resolve, selecting the Length Changes check box instructs Relativity automatically to resolve changes in the length of COBOL data items during the merging process.
Process | The Process button causes Relativity to reprocess the merged (new) COBOL file definitions using the constraints imposed by the Type Changes, Position Changes, and Length Changes options.
Cancel | The Cancel button returns to the Resolve Merge Differences dialog box without reprocessing the merged (new) COBOL file definitions.


Btrieve Key Import for filename Dialog Box (Micro Focus COBOL Only)

See Also

Note This feature is available only in Relativity for Micro Focus COBOL.

The Btrieve Key Import for filename dialog box allows the selection of a Btrieve data file so that the file's key structure can be imported into a Relativity catalog .

To display this dialog box, click Import Btrieve Keys on the Tools menu and close the message box that indicates the importing process has been initiated.

The Btrieve Key Import for filename dialog box contains the following options.

Option | Description
Keys to Import | The Keys to Import text box allows you to specify the filename and path of the Btrieve data file having the key structure you want to import into a Relativity catalog. Note that this filename must have the suffix .dat.
Browse | The Browse button displays the Select Btrieve Data File for filename dialog box, for the selection of the desired file.
Update Keys | The Update Keys button performs the importing of keys on the specified file.
Cancel | The Cancel button backs out of the dialog box by canceling the selections made within the dialog box and closing the dialog.


Change Catalog Owner Dialog Box

See Also

The Change Catalog Owner dialog box displays options for a new owner name and an optional password for a Relativity catalog. Note the following:

· If a catalog is unowned, then a database group can be specified as the catalog owner by making the appropriate entries in this dialog box.

· If a catalog has an owner and either the owner group or a user of the owner group is specified in the Logon dialog box, then the group owning the catalog can be changed by making the appropriate entries in this dialog box.

To display this dialog box, do one of the following:

· Choose Change Catalog Owner on the Security menu.

· Click the Change Catalog Owner shortcut in the User Common Tasks area of the Users & Groups catalog object in the Catalog window.

The Change Catalog Owner dialog box contains the following options.

Option | Description
Current Owner | The Current Owner box contains the name of the current owner of the catalog. If there is no current owner, the Current Owner box contains the text, < No Owner >.
New Owner Name | In the New Owner Name list, select the name of the new owner of the catalog. This list contains the name of database groups associated with the current catalog.
Password | In the Password box, type the password for the new owner. An asterisk (*) character is displayed for each character entered. This entry is optional.
OK | The OK button completes the Change Catalog Owner dialog box by accepting all entries made in the dialog box.
Cancel | The Cancel button backs out of the Change Catalog Owner dialog box by canceling all entries made in the dialog box.


Change Password Dialog Box

See Also

The Change Password dialog box contains options for the definition of a new password, verification of an existing password, and an expiration date for access to a catalog for the selected group name or user name. The expiration feature allows access privileges for a user or group to be terminated without actually deleting the user or group from the catalog. Consequently, the user or group could be authorized access later at the same security level.

Note An expiration date set on a user applies only to that user within the group. An expiration date set on a group, however, applies to all members of the group. If the access date for a group has expired, all of the privileges of the users in that group have also expired.

To display this dialog box, click either the Edit Group Password toolbar button or Edit User Password toolbar button on the Edit Users form.

The Change Password dialog box contains the following options.

Option

Description

User Name

The User Name box displays the name of the group or user whose password is to be changed.

New Password

In the New Password box, type a new password for the selected group or user. An asterisk (*) character is displayed for each character entered. This entry is optional.

Verify Password

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Change Password dialog box must contain the same characters before the password is accepted for the group or user.

Use Expiration

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the selected user name or group name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.

OK

The OK button completes the Change Password dialog box by accepting all entries made within the dialog box.

Cancel

The Cancel button backs out of the Change Password dialog box by canceling all entries made within the dialog box.


Character Set Maintenance Dialog Box

See Also

The Character Set Maintenance dialog box lists the character sets in use in a Relativity data source. This dialog box also allows you to perform the following tasks:

· Add both standard and nonstandard character sets to a Relativity data source.

· Modify the character set associated with file definitions.

· Alter the location of the Euro character within a character set.

To display this dialog box, choose Character Sets from the Tools menu.

The Character Set Maintenance dialog box contains the following options.

Option

Description

Add New Character Set

Use the Add New Character Set area to add either a nonstandard character set or a standard character set, or both, to a data source.

· The From CS File option allows you to add a nonstandard character set by clicking the Import button. A standard Windows dialog box is displayed that allows you to enter the name of the desired character set file. When you click Open on that dialog box, the new character set will appear in the Character Set column. To see a list of errors that can occur when a nonstandard character set is imported into a Relativity data source, click here.

Note The Import button provides the same functionality as the New button on the Select Character Set dialog box.

· The From List of Standard Character Sets list box displays a list of standard character sets supported by Relativity. Select the desired character set file. When you click the Add button, the new character set will appear in the Character Set column.

Modify Existing FD Character Set

Use the Modify Existing FD Character Set area to change an existing character set for all file definitions in a data source when the wrong character set is associated with those FDs. First, select the name of the character set that is currently associated with the file definitions from the Change From list box. Next, select the name of the character set that actually describes the data within the data source's files from the To list box. Then click the Change button. A Status Report dialog box shows a record of the action just taken.

Note This capability is different from that described in the procedure on how to modify an existing Relativity character set in the topic, Defining Nonstandard Character Sets, which has to do with modifying a character set in some way to suit a particular need.

Set Euro Character For Selected Character Set

Use the Set Euro Character for Selected Character Set area to change the location of the Euro character in a character set. Some COBOL applications supported the Euro character before the International Standards Organization decided its value in standard character sets. In such cases, Relativity must modify its understanding of the value of the Euro character within the standard character set.

To do this, select the character set whose definition for the Euro character will change from the Character Set column. Check the Enable Euro check box. In the edit box, enter the value that is used to represent the Euro character in the COBOL data file. The value must be a number between decimal 0 and 255 (hexadecimal 0x00 and 0xff). Click the Update button to change the value. The new value will appear in the Euro list to the right of the character set name in the Character Set column.

Character Set and Euro

In this area, the Character Set column lists all the character sets used in the data source.

The Euro column shows the value that is used to represent the Euro character for the selected character set in the COBOL data file. The value must be a number between decimal 0 and 255 (hexadecimal 0x00 and 0xff).


Choose Subscript Values Dialog Box

See Also

The Choose Subscript Values dialog box allows you to select one or more (or all) of the occurrences in a repeating data item to add to a table. You must complete the following sequence of events in order to display this dialog box:

1. Open an FD containing a repeating data item by selecting that file from the Files catalog object in the Catalog window.

2. With the FD displayed in the FD form, modify column names as required using the Edit Default Column Names dialog box.

3. Create the appropriate condition items by clicking Add Condition Item in the FD form toolbar and using the Add Condition Item dialog box.

4. Create a new table by clicking New on the Tables catalog object in the Catalog window. The Table form is displayed.

5. Add the repeating data item to the table by highlighting the appropriate item in the FD form and dragging it to the new table. The Subscripted Data Item dialog box is displayed.

6. In that dialog, select the Create Multiple Columns option. The Choose Subscript Values dialog box is displayed, with the name of the subscripted data item displayed below the title bar.

The Choose Subscript Values dialog box contains the following options.

Option | Description
Column Name | The Column Name column contains the name of the 88-level condition-name (which is established in the Add Condition Item dialog box).
Value | The Value column, which is labeled with the name of the repeating data item, contains the value of the 88-level condition-name. If a nested repeating data item occurs, then a column for each level of nesting is displayed, with each column labeled with the name of the repeating data item.
OK | Click the OK button to complete the Choose Subscript Values dialog box and accept all selections made within the dialog box.
Select All | Click the Select All button to select all of the occurrences in a repeating data item to add to a table.
Cancel | Click the Cancel button to back out of the Choose Subscript Values dialog box and cancel the selections made within the dialog box.


Copy File Label Dialog Box

See Also

The Copy File Label dialog box allows you to propagate a file label item definition to other FDs in a catalog. After the file label item has been defined and tested in a single FD, the definition can be copied to the remaining FDs using the Copy File Label Column dialog box.

To display this dialog box, choose Copy File Label from the File Label Utilities | FD submenu on the Tools menu. Note that the Copy File Label command is visible only if at least one FD has a file label item defined in it.

The Copy File Label dialog box contains the following options.

Option | Description
Source | The Source list box contains all the FDs in the catalog on which a file label item has been defined. Choose a single FD from this list box.
Destination | The Destination list box contains all the FDs in the catalog on which a file label item has not been defined. Choose one or more FDs from this list box.
Apply | The Apply button begins the copying process. A file label item with the same name, type, and size as the file label item selected from the Source list box will be placed in all the eligible FDs.
Cancel | The Cancel button does not copy the file label item and closes the Copy File Label dialog box.


Copy File Label Column Dialog Box

See Also

The Copy File Label Column dialog box allows you to propagate a file label column definition to other tables in a catalog. After the file label column has been defined and tested in a single table, copy the definition to the remaining tables in the catalog. Before this step can be completed, the file label items must be copied using the Copy File Label dialog box.

To display this dialog box, choose Copy File Label Column from the File Label Utilities | Table submenu on the Tools menu. Note that the Copy File Label Column command is visible only if at least one FD has a file label item defined in it.

The Copy File Label Column dialog box contains the following options.

Option | Description
Source Table | The Source Table list box contains all the tables on which a file label column has already been defined. Choose a single table from this list.
Destination Tables | The Destination Tables list box contains all the tables on which a file label column has not been defined. Choose one or more tables from this list.
Apply | The Apply button begins the copying process. A file label column with the same name, type, and size as the file label column selected from the Source Table list box will be placed in all the eligible tables.
Cancel | The Cancel button does not copy the file label column and closes the Copy File Label Column dialog box.


Copy table name Dialog Box

The Copy table name dialog box allows you to copy an existing table name and add it to the catalog.

Note If a table connection exists in the original table with the same name as the table, a connection for the new table will be built with the new table name. All other connections will have a number appended to them in order to make them unique.

To display this dialog box, select a table definition on the Tables catalog object in the Catalog window, and click Copy on the Table menu. The newly named and copied table appears in the Tables area of the Catalog window.

Note In addition to the drop-down menus on the menu bar, Relativity offers context-sensitive menus that pop up at the click of the right mouse button. To open a context menu of the commands on the Table menu, right-click a table definition on the Tables catalog object or a table name on the FD Properties form. From the pop-up Table context menu, choose the command you need.

The Copy table name dialog box contains the following options.

Option | Description
New Table Name | In the New Table Name box, type a unique new table name for the table connection.
Copy | The Copy button completes the Copy dialog box by accepting the new table name and closing the dialog box.
Cancel | The Cancel button backs out of the Copy dialog box by canceling all entries made within the dialog box.


Create New Table Dialog Box

The Create New Table dialog box displays a box for the entry of the table name for the table to be created.

To display this dialog box, click Save Changes on the Table form toolbar after creating a new table definition.

The Create New Table dialog box contains the following options.

Option | Description
New Table Name | In the New Table Name box, type the table name to be assigned to the table to be created. A table name must begin with an alphabetic character. The remaining characters can be any combination of alphabetic, numeric, or underscore characters. A table name must not, however, be an SQL reserved word.
OK | The OK button completes the Create New Table dialog box by accepting the table name typed in the New Table Name box.
Cancel | The Cancel button backs out of the Create New Table dialog box by canceling the table name entered in the New Table Name box.


Date Constants Dialog Box

See Also

The Date Constants dialog box enables you to change the values or structures of the date constants:

· 'Days' Base Date

· 'YY' Base Year

· 'YYYY' Base Year

· 'YY' Century Cutoff

· 'YY' Dates

· 'YYYY' Dates

To display this dialog box, click Date Constants on the Tools menu.

The Date Constants dialog box contains the following options.

Option

Description

'Days' Base Date

The 'Days' Base Date is changed either by typing or clicking on the arrows to indicate the year, month, and day for the date constant 'Days' Base Date. This date constant specifies the date used to interpret date values that represent an integer number of days from a base date in the Gregorian calendar. The default base Year is 1899. The default base Month is 12. The default base Day is 30. Using the default, an integer value of zero in the COBOL data item thus represents the date 30 December 1899, and an integer value of two in the COBOL data item represents the date January 1, 1900. Negative values are allowed in a signed COBOL data item to represent dates prior to the specified base date.

'YY' Base Year

The 'YY' Base Year box is displayed on the second line of the Date Constants dialog box when the 'YY' Base Year option button is selected. The 'YY' Base Year is changed either by typing a two-digit year or clicking on the arrows to indicate the two-digit year. This date constant specifies the base year used to interpret date values containing a two-digit year. The default base year is 1900. The base year is added to a two-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a two-digit year.

The selection of the 'YY' Base Year option button displays the 'YY' Base Year box on the second line of the Date Constants dialog box.

'YYYY' Base Year

The 'YYYY' Base Year is changed either by typing or clicking on the arrows to indicate the four-digit base year. This date constant specifies the base year used to interpret date values containing a four-digit year. The default base year is 0. The base year is added to a four-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a four-digit year.

'YY' Century Cutoff

The 'YY' Century Cutoff box is displayed on the second line of the Date Constants dialog box in place of the 'YY' Base Year box when the 'YY' Century Cutoff option button is selected. The 'YY' Century Cutoff is changed either by typing a two-digit value or clicking on the arrows to indicate the two-digit century cutoff. This date constant specifies the century cutoff year used to interpret date values containing a two-digit year that are considered to be in the next century if lower than the specified cutoff. The default value is 1900. Using the default, all two-digit years are considered to be in the twentieth century (nineteen hundreds). If this date constant is changed to 1930, then all COBOL two-digit year dates less than 1930, after adding the two-digit base year, will be incremented by 100; that is, the two-digit years 00 through 29 would be interpreted as the four-digit years 2000 through 2029. If the value of 'YY' Century Cutoff is greater than 1900, then the value of 'YY' Base Year must be equal to 1900. The value of 'YY' Century Cutoff is only used when it is greater than 1900.

The selection of the 'YY' Century Cutoff option button displays the 'YY' Century Cutoff box on the second line in the Date Constants dialog box in place of the 'YY' Base Year box.

'YY' Dates

The structure of 'YY' Dates is selected from the 'YY' Dates list. This date constant specifies the structure to be used for COBOL data items that were associated with a six-digit date transform when the catalog was designed. The six-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with two-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in its files. The default structure is YYMMDD (a two-digit year, followed by a two-digit month of the year, followed by a two-digit-day of the month).

'YYYY' Dates

The structure of 'YYYY' Dates is selected from the 'YYYY' Dates list. This date constant specifies the structure to be used for COBOL data items that were associated with an eight-digit date transform when the catalog was designed. The eight-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with four-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in its files. The default structure is YYYYMMDD (a four-digit year, followed by a two-digit month of the year, followed by a two-digit day of the month).

Defaults

The Defaults button resets the values in the Date Constants dialog box to the default values.

OK

The OK button completes the Date Constants dialog box by accepting the values and structures specified in the dialog box.

Cancel

The Cancel button backs out of the Date Constants dialog box by canceling all selections made within the dialog box.


Delete Connections Matching Pattern Dialog Box

See Also

The Delete Connections Matching Pattern dialog box displays options for the deletion of table connections based on the matching of patterns within table names and/or path names in the Edit Connections form.

To display this dialog box, select a table definition or table name and then click the Global Delete toolbar button on the Edit Connections form.

The Delete Connections Matching Pattern dialog box contains the following options.

Option | Description
Match Table Name | If the check box preceding the Match Table Name box is selected, the matching pattern must be present in the table name for deletion of the table connection. The Match Table Name box specifies the matching pattern that must be present in the table name for deletion of the table connection.
Match Path Name | If the check box preceding Match Path Name box is selected, the matching pattern must be present in the path name for deletion of the table connection. The Match Path Name box specifies the matching pattern that must be present in the path name for deletion of the table connection.
Delete Connections | The Delete Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes button on the Edit Connections form.
Cancel | The Cancel button closes the Delete Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Delete File Label Dialog Box

See Also

The Delete File Label dialog box allows you to remove a file label item from a table.

To display this dialog box, choose Delete File Labels from the File Label Utilities | FD submenu on the Tools menu. Note that the Delete File Labels command is visible only if at least one FD has a file label item defined in it.

Note File label items cannot be deleted if there is a file label column still defined on the file label item within the selected FDs. Use the Delete File Label Column dialog box to remove any columns first.

If it is necessary to make a global change to all file label items, remove all but one of the existing file label items using this dialog box, make the desired change to the remaining file label item, test it, and then use the Copy File Label dialog box to copy the change to the remaining FDs.

The Delete File Label dialog box contains the following options.

Option | Description
Source | The Source area contains all the FDs in a catalog on which a file label item has been defined. Choose one or more FDs from this list.
Delete | The Delete button begins the deletion process. File label items will be deleted from all of the FDs selected in the Source area.
Cancel | The Cancel button does not delete the file label items and closes the Delete File Label dialog box.


Delete File Label Column Dialog Box

See Also

The Delete File Label Column dialog box allows you to remove the file label column definition from tables in a catalog.

To display this dialog box, select Delete File Label Columns from the File Label Utilities | Table submenu on the Tools menu. Note that the Delete File Label Columns command is visible only if at least one FD has a file label item defined in it.

If it is necessary to make a global change to all file label columns, remove all but one of the existing file label columns using this dialog box, make the desired change to the remaining file label column, test it, and then use the Copy File Label Column dialog box to copy the change to the remaining tables.

Note File label columns must be deleted before the file label item on which they are based is deleted with the Delete File Label dialog box.

The Delete File Label Column dialog box contains the following options.

Option | Description
Source | The Source list box contains all the tables on which a file label column has already been defined. Choose one or more tables from this list.
Delete | The Delete button begins the deletion process. The file label columns will be removed for the selected tables.
Cancel | The Cancel button does not delete the file label columns and closes the Delete File Label Column dialog box.


Describe Filter Subexpression Dialog Box

See Also

The Describe Filter Subexpression dialog box is used to compose a filter expression that specifies the condition under which a record passes through a filter. This dialog box displays options for the definition of a filter subexpression to be added to a filter expression. The filter is then applied to either a table in the Table form or a record type in the FD form.

To display this dialog box, click Add Filter on either the Table Filter Properties form or the Record Type Properties form.

The Describe Filter Subexpression dialog box contains the following options.

Option

Description

Operator

From the Operator list, select the logical operator that is to connect this filter subexpression to the filter expression being defined. Available selections are And, Or, And Not, and Or Not.

· If either And or Or is selected, the condition specified in the Condition Item list must be true for records to pass the filter.

· If either And Not or Or Not is selected, the condition specified in the Condition Item list must be false.

Condition Item

From the Condition Item list, select the condition item for the filter subexpression of the filter expression being defined.

Add Subexpression

The Add Subexpression button completes the Describe Filter Subexpression dialog box by accepting the filter subexpressions described within the dialog box.

Cancel

The Cancel button backs out of the Describe Filter Subexpression dialog box by canceling all selections made within the dialog box.


Edit Connections Matching Pattern Dialog Box

See Also

The Edit Connections Matching Pattern dialog box displays options for the editing of table connections based on the matching of patterns within the table names and/or path names in the Edit Connections form.

To display this dialog box:

1. Open the Edit Connections form by clicking the Connections command on the Security menu.

2. Select a table definition or table name and then click the Global Edit toolbar button on the form.

The Edit Connections Matching Pattern dialog box contains the following options.

Option

Description

Match Table Name

If the check box preceding the Match Table Name box is selected, the matching pattern must be present in the table name for editing the table connection. The Match Table Name box specifies the matching pattern that must be present in the table name for editing the table connection.

Match Path Name

If the check box preceding the Match Path Name box is selected, the matching pattern must be present in the path name for editing the table connection. The Match Path Name box specifies the matching pattern that must be present in the path name for editing the table connection.

Path Name

· The Path Name Replace box contains the pattern to be matched within the path name for replacement in the generation of a path name for the new table connection.

· The Path Name with box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the path name for the new table connection.

Edit Connections

The Edit Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes toolbar button on the Edit Connections form.

Cancel

The Cancel button closes the Edit Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Edit Data Item Pattern Dialog Box

See Also

The Edit Data Item Pattern dialog box displays attributes for the editing of the data item pattern. In this dialog box, a selected check box following the attribute name indicates that the attribute is part of the definition of the item pattern.

To display this dialog box, select the row containing the item pattern to be edited and click the Edit Item Pattern toolbar button on the Item Patterns form.

The Edit Data Item Pattern dialog box contains the following options.

Option | Description
Item Type | When the Item Type check box is selected, a list of data types is enabled to allow the selection of the data type of the data item being defined.
Length | When the Length check box is selected, a text box is enabled that allows you to specify the number of storage characters in the data item pattern.
Precision | When the Precision check box is selected, a text box is enabled that allows you to specify the number of digits in a numeric data item pattern.
Scale | When the Scale check box is selected, a text box is enabled that allows you to specify the number of digits to the right of the decimal point in a numeric data item pattern.
Pattern | When the Pattern check box is selected, a text box is enabled that allows you to specify a character pattern that appears within the COBOL name associated with the data item.
User Data Type | The User Data Type attribute specifies the name of the data type having the data item pattern defined in the Add Data Item Pattern dialog box. The data type name is chosen from the list of data types in the associated User Data Type list in that dialog. If the < New > item is selected from the list of data types, then a new data type name is defined by entries in the Add Data Type dialog box.
Item Transform | The Item Transform attribute transforms (converts) a COBOL data item value to and/or from a relational database column value. The transform is selected from the Item Transform list.
OK | The OK button completes the Edit Data Item Pattern dialog box by accepting all the selections made within the dialog box.
Cancel | The Cancel button backs out of the Edit Data Item Pattern dialog box by canceling all selections made within the dialog box.


Edit Default Column Names Dialog Box

See Also

The Edit Default Column Names dialog box displays options for the replacement of selected characters in all column names assigned by default in the FD form. (Note that in the sample Edit Default Column Names dialog box shown in this topic, the two characters Cf at the beginning of all column names in the FD form are deleted because no replacement characters are specified in the With box.)

To display this dialog box, click Column Name Global Edit on the FD form toolbar.

The Edit Default Column Names dialog box contains the following options.

Option | Description
Replace | The Replace box contains the characters to be matched within the column names in the FD form for replacement to take place. To specify the position of the characters to be replaced within the default column name, type the appropriate structure to determine the pattern matching process.
With | The With box contains the pattern that is to replace the matching characters specified in the Replace box. The resulting column names are moved to the Table form during the creation of a table from the data items in the FD form. If the With box is blank, then the characters in the Replace box are deleted from the column names.
All Items | The All Items check box indicates that the replacement takes place in all column names within the table.
Apply | The Apply button completes the Edit Default Column Names dialog box by accepting all the entries made within the dialog box.
Cancel | The Cancel button backs out of the Edit Default Column Names dialog box by canceling all entries made within the dialog box.


Edit Group Dialog Box

See Also

The Edit Group dialog box displays options that allow you to enter a new name for the group being renamed, add or modify an optional password, and assign an expiration date for the group name selected on the Users & Groups catalog object in the Catalog window.

Note An expiration date set on a user applies only to that user within the group. An expiration date set on a group, however, applies to all members of the group. Therefore, if the access date for a group has expired, all of the privileges of the users in that group have also expired.

To display this dialog box, click Edit Group from the User menu.

Note In addition to the drop-down menus on the menu bar, Relativity offers context-sensitive menus that pop up at the click of the right mouse button. To open a context-sensitive menu of the commands on the User menu, right-click a group or user name on the Users & Groups catalog object. From the pop-up User context menu, choose the command you need.

The Edit Group dialog box contains the following options.

Option

Description

New Group Name

In the New Group Name box, type the new name for the group being renamed. This name will be added to the list of database groups associated with the catalog. Each group name and user name must be unique within a catalog.

Password

In the Password box, type the password for the group being renamed. An asterisk (*) character is displayed for each character entered. This entry is optional.

Verify Password

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Edit Group dialog box must contain the same characters before the password is accepted for the group.

Use Expiration

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the selected group name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.

OK

The OK button completes the Edit Group dialog box by accepting the new group name.

Cancel

The Cancel button backs out of the Edit Group dialog box by canceling all entries made within the dialog box.


Edit User Dialog Box

See Also

The Edit User dialog box displays options that allow you to enter a new name for the user being renamed, add or modify an optional password, and assign an expiration date for the user name selected on the Users & Groups catalog object in the Catalog window.

Note An expiration date set on a user applies only to that user within the group. An expiration date set on a group, however, applies to all members of the group. If the access date for a group has expired, all of the privileges of the users in that group have also expired.

To display this dialog box, click Edit User from the User menu.

Note In addition to the drop-down menus on the menu bar, Relativity offers context-sensitive menus that pop up at the click of the right mouse button. To open a context-sensitive menu of the commands on the User menu, right-click a group or user name on the Users & Groups catalog object. From the pop-up User context menu, choose the command you need.

The Edit User dialog box contains the following options.

Option

Description

New User Name

In the New User Name box, type the new name for the user being renamed. This name will be added to the selected database group within the catalog. Each group name and user name must be unique within a catalog.

Password

In the Password box, type the password for the user being renamed. An asterisk (*) character is displayed for each character entered. This entry is optional.

Verify Password

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Edit User dialog box must contain the same characters before the password is accepted for the user.

Use Expiration

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the selected user name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.

OK

The OK button completes the Edit User dialog box by accepting the new user name into the selected group.

Cancel

The Cancel button backs out of the Edit User dialog box by canceling all entries made within the dialog box.


Edit Selected Table Connections Dialog Box

See Also

The Edit Selected Table Connections dialog box edits the path names and/or file label items, if defined, of selected table connections of a table definition in the Edit Connections form.

To display this dialog box, click the Edit Table Connection toolbar button on the Edit Connections form .

The Edit Selected Table Connections dialog box contains the following options.

Option

Description

Path Name

· The Path Name Replace box contains the pattern to be matched within the path name for replacement in the selected table connection.

· The Path Name With box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the new path name for the selected table connection.

And / Or

· Select the AND option to make replacements if the contents of both the Path Name Replace and File Label Replace boxes match an individual table connection.

· Select the OR option to make replacements if the contents of either the Path Name Replace or File Label Replace boxes match an individual table connection.

File Label

Note This area is enabled only if a file label item has been added to the FD on which the table is based.

· The File Label Replace box contains the pattern to be matched within the file label for replacement in the selected table connection.

· The File Label With box contains the pattern that is to replace the matching characters specified in the File Label Replace box. The resulting file label becomes the new file label for the selected table connection.

Edit Connections

The Edit Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes toolbar button on the Edit Connections form.

Cancel

The Cancel button closes the Edit Selected Table Connections dialog box and cancels all entries made within the dialog box.


Export DDL Dialog Box

The Export DDL dialog box displays options that enable you to export selected table(s) to a database definition language file. This text file, with the extension .ddl, displays the SQL syntax description of the table.

To display the Export DDL dialog box, do one of the following:

· Select a table definition name on the Tables catalog object in the Catalog window and choose Export DDL on the Table menu, or right-click to access this command from the pop-up Table context menu.

· If you are viewing the properties of a selected file definition in the FD Properties form, expand the list of tables built from the selected file definition and right-click a table name. Choose Export DDL from the pop-up Table context menu.

The Export DDL dialog box contains the following options.

Option

Description

Export File

The Export File box displays the name and location of the resulting output file for the selected table(s). The file format for the exported file has the extension .ddl, which represents database definition language file. You can type in this information or click the Browse button to find a location and enter a filename.

Browse

Click the Browse button to open the Select DDL Export File dialog box, where you can select the file format (by default, .ddl), and the name and location of the resulting output file.

Single Table
All Tables
Selected Table(s)

In this area, select the table definitions you want to export to a .ddl file:

· Selecting the Single Table option exports only the table definition selected on the Tables catalog object or opened in the Table form. (The name of the table definition name appears to the right of this option.) This option is selected by default when the dialog box is first opened.

· Selecting the All Tables option exports all the table definitions in the catalog.

· If you check the Selected Table(s) option, you can click the name of the table definition that you want to export in the Table Definition Names list box. To select multiple table definition names, press the Ctrl key as you select with the mouse.

Table Definition Names

The Table Definition Names list box displays all the table definitions in the catalog that are available for exporting to a .ddl text file. From this list, you can select specific table definition names you want to export if you have checked the Selected Table(s) option.

Cancel

The Cancel button cancels all selections and closes the Export DDL dialog box.

OK

Click OK to export the selected table definition name(s).


Export Preferences Dialog Box

See Also

The Export Preferences dialog box allows you to configure the export of an FD. See Export FD on the FD form toolbar.

To display this dialog box, click Export on the Data Source page in the Options dialog box.

The Export Preferences dialog box contains the following options.

Option

Description

Components to Export

Under the Components to Export area:

· Selecting All causes all subsequent exports of an FD to include the following:

-  File description entry.

-  Level 01 data description entries subordinate to the file description entry.

-  Data description entries subordinate to the included level 01 data description entries.

· Selecting No FD causes all subsequent exports of an FD to include the following:

-  Level 01 data description entries subordinate to the file description entry.

-  Data description entries subordinate to the included level 01 data description entries.

· Selecting No 01, FD causes all subsequent exports of an FD to include all the data description entries subordinate to the file description entry, but not including the level 01 data description entries.

Note This option generally is not appropriate if your file definitions contain multiple level 01 data description entries.

Filler

When exporting an FD, selecting the FILLER check box causes the file to be exported with the word FILLER present. If this check box is not selected, the file is exported with the word FILLER deleted.

COMP-3

When exporting an FD, selecting the COMP-3 check box causes the file to be exported with the USAGE IS COMP-3 clause specified for data items having the packed decimal data type. If this option is not selected, the file is exported with the USAGE IS PACKED-DECIMAL clause specified for data items having the packed decimal data type.

Path Name

In the Path Name box, type drive:\directory\^.ext, where the ^ is automatically replaced by the COBOL file-name of the source file to receive the FD being exported.

Tab Stops

In the Tab Stops box, type a comma-separated list of numbers indicating the columns in which to align the various elements and clauses of the exported COBOL data item definitions. The first number in the list must be the number 8.

PIC Tabs

In the PIC Tabs box, type a number indicating the beginning tab position for the placement of PICTURE clauses when exporting an FD. The value of this number must be within the range of 12 through 72.

Preferred Tabs

In the Preferred Tabs box, type numbers indicating tab positions within the range of 12 through 72 to be used when exporting an FD.

OK

The OK button accepts the selections and returns to the Data Source page in the Options dialog box.

Note The selections are not saved in the RELDBDSN.INI file until you click OK on the Data Source page in the Options dialog box.

Cancel

The Cancel button terminates the selections and returns to the Data Source page in the Options dialog box.


Find and Find and Replace Dialog Boxes

The Find dialog box allows you to search for text in the Column Name column in the Table form. In the search operation, the text is not highlighted, but rather the pointer is moved to the row where that text is located.

To open the Find dialog box, click the Find button on the Table form toolbar. Specify the criteria for your search and then click the Find button in the dialog. To search for the next occurrence, click the Find Next button in the dialog box.

The Find dialog box also allows you to optionally replace the search criteria specified in the Find What box by clicking the Replace button to open the Find and Replace dialog box. Replace behaves much the same as Find, except that the Replace With and Replace All options become available.

The Find and Find and Replace dialog boxes contain the following options.

Option

Description

Find What

In the Find What box, enter the Column Name that you want to search for. You can type or paste text into this box.

Replace With

In the Find and Replace dialog box, type the text that you want to use as replacement text in the Replace With box. You can type or paste text into this box. To delete from your table the text in the Find What box, leave the Replace With box empty.

Match Whole Word

When Match Whole Word is selected, Relativity searches only for occurrences that are whole words and not part of a larger word.

Case Sensitive

The Case Sensitive option distinguishes between uppercase and lowercase characters. When this option is selected, Relativity finds only those instances in which the capitalization matches the text you typed in the Find What box.

Find

The Find button searches for the first instance of the search criteria specified in the Find What box.

Find Next

The Find Next button finds and selects the next occurrence of the search criteria specified in the Find What box.

Note If you close the Find dialog box, you may click the Find Next button on the Table form toolbar to search for the next occurrence of the last specified search criteria.

Replace

· In the Find dialog box, the Replace button opens the Find and Replace dialog box, where you replace the selected instance of the search criteria, find the next occurrence, and then stop. If you want to replace all occurrences of the search criteria automatically, click Replace All.

· In the Find and Replace dialog box, the Replace button replaces the selected instance of the search criteria, finds the next occurrence, and then stops. If you want to replace all occurrences of the search criteria automatically, click Replace All.

Replace All

In the Find and Replace dialog box, if you want to automatically replace all occurrences of the search criteria, click the Replace All button. To search and replace the selected instance of the search criteria, find the next occurrence, and then stop, click the Replace button.

Close

The Close button closes the dialog box and retains any changes that you may have made.


Find COBOL Item Dialog Box

The Find COBOL Item dialog box allows you to search for a COBOL data item in the FD form. When found, the text is not highlighted, but rather the pointer is moved to the row where that text is located. If the found row is not currently visible (due to scrolling), then that row is set to be the top row. Otherwise, the found item just becomes the current row.

To open the Find COBOL Item dialog box, click the Find button on the FD form toolbar. In the dialog box, you can then specify the criteria for your search and click OK. To search for the next occurrence, click the Find Next button on the FD form toolbar. If you wish to change your search criteria, click the Find button again.

Note Your search covers only expanded data items in the FD form attribute grid and ignores collapsed items.

The Find COBOL Item dialog box contains the following options.

Option | Description
Find | In the Find box, enter the name of a COBOL data item for which you want to search. Note that to search the entire FD form, be sure to expand the subordinate data items in the FD form attribute grid by clicking the Magnify toolbar button.
OK | Click the OK button to begin your search. Click the Find Next button to search for the next occurrence of the specified search criteria.
Cancel | Click the Cancel button to close this dialog box.


Function of Function Dialog Box

See Also

The Function of Function dialog box allows you to specify which of the two internal functions is intended as an argument for the other internal function.

To display this dialog box, follow these steps:

1. Select two function items in the FD form (a function item is preceded with f: in the COBOL Name attribute list)

2. Click Add Item Argument on the FD form toolbar.

The Function of Function dialog box contains the following options.

Option | Description
Select Combination | The options under Select Combination represent the two possible function argument combinations with the functions that are selected. The functions are listed in the same order as they appear in the FD form. This allows you to distinguish between two combinations if the functions selected are the same.
OK | The OK button accepts the options and returns to the FD form.
Cancel | The Cancel button terminates the function argument selection and closes the Function of Function dialog box.


Import from Another Relativity Data Source Dialog Box

See Also

The Import from Another Relativity Data Source dialog box displays the available file, table, and user data type definitions in a second Relativity catalog. Objects are selected from this second Relativity catalog for import into the active Relativity catalog.

To display this dialog box, click Import from Another Relativity Data Source on the Tools menu, after you have opened a second data source in the Open Relativity Data Source dialog box and logged in, if necessary.

The Import from Another Relativity Data Source dialog box contains the following options.

Option | Description
Object Type | The Object Type list contains a list of the Relativity catalog object types available. The object types available are files, tables, and user data type definitions. Selecting an object type causes the contents of the objects in the Objects in list to be updated with the objects of the appropriate type.
Objects in | The Objects in list displays all the objects of the type specified in the Object Type list. Select the objects for which importing is desired prior to clicking Import.
Import | The Import button initiates the importing of those objects selected in the Objects in list.
Close | The Close button terminates the Import from Another Relativity Data Source dialog box without further action.


Invalid Column Name Dialog Box

See Also

The Invalid Column Name dialog box allows a column name to be changed.

For example, if (1) the COBOL data-name, TEMP-ORARY, exists in the record descriptions, and (2) the default column names are derived by omitting hyphens, the default column name for the item would be the SQL reserved word, Temporary, and there would be no warning. Then, if the COBOL data item, TEMP-ORARY, is dragged to a Table form, the Invalid Column Name dialog box will be displayed to allow you to change the column name.

This dialog box is displayed when the editing of a default column name results in a reserved default column name, and that data item is dragged from the FD form to the Table form.

The Invalid Column Name dialog box contains the following options.

Option | Description
Column Name | The Column Name box allows you to enter a unique column name.
OK | The OK button completes the Invalid Column Name dialog box by accepting all entries made within the dialog box.
Cancel | The Cancel button backs out of the Invalid Column Name dialog box by canceling all entries made in the dialog box.


Logon Dialog Box

See Also

When security has been defined for a catalog associated with a data source, the Logon dialog box provides for the entry of a user name and an optional password in order to gain access to the catalog.

Note The password is optional only if there is no password associated with the user name.

To display this dialog box, click Open in the Open Relativity Data Source dialog box. (Note that security must have been defined for the catalog.)

The Logon dialog box contains the following options.

Option | Description
Name | In the Name box, type the name of the user of the catalog. If privileges have been defined for the catalog, the user name must belong to a group having the Use Administrator privilege.
Password | In the Password box, type the password for the group or user. An asterisk (*) character is played for each character entered. This entry is optional.
OK | The OK button completes the Logon dialog box by accepting all entries made within the dialog box.
Cancel | The Cancel button backs out of the Logon dialog box by canceling all entries made in the dialog box.


Merge Details Dialog Box

See Also

The Merge Details dialog box shows the differences that the Relativity automated resolution process discovered, including the inability to discover a proposed matching item in the previous version of the COBOL file definition being replaced by the merging process.

To display this dialog box, click either Resolve or Details on the Resolve Merge Differences dialog box. The appearance of the Merge Details dialog box varies slightly depending upon which button you click:

· If you click Resolve, a Transform list appears in the lower-right corner of the dialog box. If a transform existed on the original (previous) FD, you can apply it or change it on the new one. Other options also can appear on this dialog box, as described in the following table.

· If you click Details, the detected changes are shown for viewing purposes only, as shown here.

The Merge Details dialog box contains the following options.

Option

Description

Merge Item

The Merge Item area displays the name of an item in the updated data file.

Previous Item

The Previous Item area displays the name of the same item in the existing data file.

Changes Detected

The Changes Detected box lists changes between the updated data file and the existing data file.

Close

The Close button dismisses the Merge Details dialog box. (The Close option appears on the dialog box if you click the Details button on the Resolve Merge Differences dialog box.)

Other Options

These options appear on this dialog box if you click the Resolve button on the Resolve Merge Differences dialog box:

· OK. The OK button completes the Merge Details dialog box by accepting the changes made in the Transform list.

· Cancel. The Cancel button backs out of the Merge Details dialog box without making any changes.

· Transform. The Transform list shows the transform associated with the original (previous) FD. By clicking the down arrow to the right of the box, all transforms are listed, and you can select a different transform to apply to the new FD, if desired.


ODBC Data Source Administrator Dialog Box

See Also

The ODBC Data Source Administrator dialog box is displayed when you launch the ODBC Data Source Administrator program by clicking ODBC Control Panel on the Tools menu from within the Relativity Designer.

This standard ODBC program, which is distributed with Relativity, is used to configure and maintain ODBC data sources.

Note The Data Sources (ODBC) applet is also accessible from the Windows Control Panel. In Windows XP and Vista, the applet can be found under Administrative Tools in the Control Panel.


Open Relativity Data Source Dialog Box

See Also

The Open Relativity Data Source dialog box allows selection of the data source that is to be processed by Relativity.

To display this dialog box, do one of the following:

· Successfully complete setting up a new Relativity data source.

· Choose Open Data Source on the File menu or select one the most recently opened data sources from the numbered list to open a data source.

· Select the Existing option in the Welcome to Relativity window, choose one of the listed data sources, and then click OK.

· Choose Import from Another Relativity Data Source from the Tools menu.

The Open Relativity Data Source dialog box contains the following options.

Option

Description

Driver

If multiple ODBC drivers are installed on your system, you can select the appropriate driver from this Driver list in order to create and set up a new data source or open an existing data source.

Data Source Name

In the Data Source Name list, select the name of the data source for processing by Relativity.

Open

· If security has been defined for the catalog associated with the data source, the Open button displays the Logon dialog box, which provides for the entry of a user name and an optional password for the specified catalog.

· If security has not been defined for the catalog, the Open button opens the Catalog window in the Relativity Designer window.

Cancel

The Cancel button backs out of the Open Relativity Data Source dialog box by canceling the selections made within the dialog box.


Print Options Dialog Box

See Also

The Print Options dialog box allows you to specify a printer (or other export module) and printing options for the printing of a selected report. The name of the report that was selected for printing or exporting to another type of media is shown at the top portion of this dialog box.

To display this dialog box, perform any of the following actions:

· Click Print on the Reports catalog object in the Catalog window when a specific report description is selected.

Note If you click Print when a report category is selected (rather than a specific report description), a Select Report dialog box is displayed initially (the exact name of this dialog varies depending on the report category selected). You can then type or select a filename of the report definition file for the report be printed and click Open to display the Print Options dialog box.

· Click Open from a Select Report dialog box after a report description has been selected for printing.

· Click Save from the Save Export File As dialog box after a report description has been selected for exporting to a comma-separated file.

The Print Options dialog box contains the following options.

Option

Description

Export Media

Use the Export Media area to select where to send (direct) output: to a printer, print preview, or to a file. The name of the selected (or default) printer is displayed in the top portion of this area.

Click the Change button to display the Printer Choice dialog box, which allows you to specify a different printer.

In addition to sending output to a printer or print preview, you may also direct output to numerous other file formats, including a PostScript printer file (.prn), Rich Text (.rtf), HTML, Adobe PDF, Multi-MIME HTML, XML, bitmap, JPEG-picture, or metafile (EMF) files. When you select a file format from the Direct to drop-down list, you can click the Export Options button to specify additional options for that particular file format (export module). After setting your file format options, you will be prompted to specify a name for the file in a Save As dialog box, or, in the case of a PostScript (.prn) file, the File for Printing dialog box.

The Save options permanently check box allows you to save the settings you have selected for the printer or other export media. Note that this check box is unavailable unless the printer (and any printer settings) or export module options have been changed in the Printer Choice dialog box.

Options

The Options area allows the selection of what portion of the report to print or direct to an export module:

· a group of pages beginning with a specific page number

· all pages

· a range of pages

Start

The Start button sends the print job to the selected printer or export module.

Cancel

The Cancel button cancels the operation so the job is not sent to the printer or export module.


Printer Choice Dialog Box

The Printer Choice dialog box allows you to specify a different printer than the one shown on the Print Options dialog box, to change printer settings, and to designate whether you want portions of the report to go to different printers. Changing the printer, printer settings, and/or type of export media enables the Save options permanently check box on the Print Options dialog box.

To display this dialog box, click the Change button in the Export Media area in the Print Options dialog box.

The Printer Choice dialog box contains the following options.

Option | Description
Printer Page-Independent | The Printer Page-Independent option in the Printer Choice area relates to the printing of all pages of a report. Selecting this option enables a Select button.
Printer Page-Dependent | The Printer Page-Dependent option in the Printer Choice area relates to the printing of the first and following pages of a report on different printers. Selecting this option enables two Select buttons.
Select | The Select button displays a standard Windows dialog box that allows you to specify a printer and define its properties and paper settings (paper size, paper source, and paper orientation).
OK | The OK button completes the Printer Choice dialog box by accepting the selections made within the dialog box.
Cancel | The Cancel button backs out of the Printer Choice dialog box by canceling the selections made within the dialog box.


Re-Importing Btrieve Keys Dialog Box (Micro Focus COBOL Only)

See Also

After a merge operation, the system will detect whether the keys in the Relativity catalog were previously imported from Btrieve files. If so, you will be presented with the choices listed in the Re-Importing Btrieve Keys dialog box.

The Re-Importing Btrieve Keys dialog box contains the following options.

Option | Description
Existing Keys | The Existing Keys button directs Relativity to copy the previously imported Btrieve keys to the newly merged FD. This is the default action.
New Keys | The New Keys button directs Relativity to use the keys from the file being merged. This means that the keys will come from the merged-in file.
Re-import Keys | The Re-import Keys button directs Relativity to invoke the Import Btrieve Keys command on the Tools menu, which allows you to choose the Btrieve data files from which to import the keys.


Rename file Dialog Box

The Rename file dialog box allows you to specify a new name for the selected file definition. Any open file definitions that would be affected by the renaming process will be closed automatically. (To view the Rename dialog box for a table definition, click here.)

To display this dialog box, select a file definition listed on the Files catalog object in the Catalog window, and click Rename from the FD menu, or right-click and choose this same command from the pop-up FD context menu.

There are several other ways you can access a Rename dialog box in the Relativity Designer. Choose Rename from the pop-up context menu when you take any of the following actions:

· Right-click a selected table name on the FD Properties form.

· Right-click a selected record type name on the FD Properties form.

· Right-click the table name, the path name, or the file label (if file labels are in effect) for a selected table connection on the Edit Connections form. Note that in each of these cases, the text box in which to enter the new name in the Rename dialog will be labeled as Enter Table Name, Enter Path Name, or Enter File Label, depending on the item selected in the Edit Connections form.

The Rename file dialog box contains the following options.

Option | Description
Enter New Name | In the Enter New Name box, type the new name for the file definition being renamed. A file-name must begin with an alphabetic character. The remaining characters can be any combination of alphabetic, numeric, or underscore characters. Note A table name must not be an SQL reserved word.
OK | The OK button completes the Rename file dialog box by accepting the new name.
Cancel | The Cancel button backs out of the Rename file dialog box by canceling the entry of a new name.


Rename table Dialog Box

See Also

The Rename table dialog box allows you to specify a new name for the selected table. Any open table definitions that would be affected by the renaming process will be closed automatically. (To view the Rename dialog box for a file definition, click here.)

To display this dialog box, select a table listed on the Tables catalog object in the Catalog window and do one of the following:

· Choose Rename from the Table menu, or right-click and choose this same command from the pop-up Table context menu.

· Click the Rename shortcut on the Table Common Tasks area of the Tables catalog object.

Note If a table definition is being renamed, the rename process will optionally change the table connection as well. If a table connection has the same name as the table being renamed, a message box will ask whether you want to rename the connection at the same time the table is renamed.

There are several other ways you can access a Rename dialog box in the Relativity Designer. Choose Rename from the pop-up context menu when you take any of the following actions:

· Right-click a selected table name on the FD Properties form.

· Right-click a selected record type name on the FD Properties form.

· Right-click the table name, path name, or file label (if file labels are in effect) for a selected table connection on the Edit Connections form. Note that in each of these cases, the text box in which to enter the new name in the Rename dialog will be labeled as Enter Table Name, Enter Path Name, or Enter File Label, depending on the item selected in the Edit Connections form.

The Rename table dialog box contains the following options.

Option | Description
Enter New Name | In the Enter New Name box, type the new name for the table being renamed. A table definition name must begin with an alphabetic character. The remaining characters can be any combination of alphabetic, numeric, or underscore characters. Note A table name must not be an SQL reserved word.
OK | The OK button completes the Rename table dialog box by accepting the new name.
Cancel | The Cancel button backs out of the Rename table dialog box by canceling the entry of a new name.


Resolve Merge Differences Dialog Box

See Also

The Resolve Merge Differences dialog box displays the COBOL data definitions that changed and provides tools for resolving the differences.

To display this dialog box, click Finish in the File Selection page of the Source Code Merge wizard.

The Resolve Merge Differences dialog box contains the following options.

Option

Description

The Magnify toolbar button displays the Merged FD grid. The Merged FD grid contains a detailed list of all data items from the merged (new) version of the COBOL file definitions as they will be saved in the catalog at the end of the merging process. The attributes shown in the Merged FD grid are the same as the attributes that are displayed in the FD form.

Note The Merged FD grid is displayed only when the Magnify button is clicked. The Merged FD grid does not permit edit operations. To view an example of the Merged FD grid in the Resolve Merge Differences dialog box, click here.

The Save Changes toolbar button displays the Tables to Keep dialog box. Clicking the Save Changes toolbar button is identical to clicking the Done command button.

The Automated Resolution toolbar button displays the Automated Resolution dialog box. Use the Automated Resolution button to relax the set of rules under which changes in COBOL file definitions are detected.

The Abort Merge toolbar button causes the merging process to be abandoned. Choosing the Abort Merge button is identical to clicking the Cancel command button.

Merged Version - Changed Items

The Merged Version - Changed Items list contains a list of all data items from the merged (new) version of the COBOL file definition. The data items in this list do not match any data items in the previous version of the COBOL file definition. Also listed are the data items that have not been resolved through user interaction. The Merged Version - Changed Items list must be empty before the merging process may continue.

Previous Version -
All Items

The Previous Version - All Items list contains a list of all data items from the previous version of the COBOL file definition being replaced by the merging process. The Previous Version - All Items list is used to interactively resolve entries in the Merged Version - Changed Items list.

New Item

The New Item button removes the selected data item from the Merged Version - Changed Items list. The data item is added to the merged COBOL file definition as a new COBOL data item.

Resolve

The Resolve button displays the Merge Details dialog box for the selected data item from the Merged Version - Changed Items list and its selected data item from the Previous Version - All Items list. If a transform was associated with the previous (original) FD, it will be displayed and you can apply it to the new FD or select a different transform to apply.

Details

The Details button displays the Merge Details dialog box for the selected data item from the Merged Version - Changed Items list and its matching data item from the Previous Version - All Items list. The information is provided for viewing purposes only.

Done

The Done button displays the Tables to Keep dialog box. Choosing the Done button is identical to clicking Save Changes on the toolbar.

Cancel

The Cancel button causes the merging process to be abandoned. Choosing the Cancel button is identical to clicking Abort Merge on the toolbar.


Save Export File As Dialog Box

See Also

The Save Export File As dialog box is a standard Windows Save As dialog box, which allows you to specify the filename for an exported comma-separated file for a selected report. The comma-separated file is produced when the selected report is printed with the Export option in effect. The Export option is in effect when either of the following is true:

· The Export button on the Reports catalog object in the Catalog window is clicked.

· The Print command on the Reports menu is clicked when the Export command on this menu has also been toggled on. (A check mark appears to the left of the command name to indicate that the Export option is active.)

After the Save Export File As dialog box is completed, the Print Options dialog box is displayed.

The Save Export File As dialog box contains the following options.

Option

Description

Save in

In the Save in list, select the drive and folder in which you want to save the file.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.

Toolbar

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.

List

The List area displays all the folders and files in the selected location. To open any folder or file, click its name in the list. You can toggle the manner in which information is displayed in this area with the options available from the View Menu toolbar button.

File name

In the File name list box, type or select the name of the file into which the export (comma-separated) information is to be saved. This filename must have the extension .csv.

Save as type

In the Save as type list, select the filename extension from the list or type an extension. The extension for a comma-separated file is .csv.

Save

The Save button completes the Save Export File As dialog box by accepting all selections made within the dialog box and displays the Print Options dialog box.

Cancel

The Cancel button closes the Save Export File As dialog box without saving any changes you have made.


Select 01's Dialog Box

See Also

The Select 01's dialog box permits the selection of record description entries from a COBOL file for the importing or merging processes.

To display this dialog box:

· In the File Selection page of either the Source Code Import wizard or the Source Code Merge wizard, select a COBOL file in the Available Files list and click the Select 01's button.

Note By default, the Relativity Designer assumes that you want to import all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. Use the Add, Remove, Add All, and Remove All buttons to move the file to the Available Files list, use the options in the Select 01's dialog box, and then move the file back to the Selected Files list to complete the importing process.

The Select 01's dialog box contains the following options.

Option

Description

File Path Name

The File Path Name box displays the path name for the COBOL file containing the level 01 entries.

COBOL File

The COBOL File box displays the filename of the COBOL file containing the level 01 entries.

COBOL Program

The COBOL Program box displays the name of the COBOL program containing the level 01 entries.

SECTION

In the SECTION area:

· Selecting the File check box causes the display of level 01 entries from the File Section of the COBOL program.

· Selecting the Working-Storage check box causes the display of data items from the Working-Storage Section of the COBOL program.

· Selecting the Linkage check box causes the display of data items from the Linkage Section of the COBOL program.

01 Record Name

The 01 Record Name column contains a list of names for the level 01 entries in the COBOL file definition. Data-names from the Working-Storage Section and the Linkage Section are included in this list depending on the selection of the associated check box in the SECTION area.

Record Size

The Record Size column displays the size of the record associated with the data-name on the same line.

Source

The Source column displays the COBOL file-name or section-name in which the data item is located.

· The characters, FD, indicate that the data-name is subordinate to the COBOL file shown in the COBOL File box. FD:filename indicates that the record is found in the File Section and is subordinate to the COBOL file named filename.

· The characters, WSS, indicate that the data item is found in the Working-Storage Section.

· The characters, LS, indicate that the data item is found in the Linkage Section.

OK

The OK button completes the Select 01's dialog box by associating the selected 01 entries with the file shown in the COBOL File box.

Cancel

The Cancel button backs out of the Select 01's dialog box by canceling the selections made within the dialog box.


Select Btrieve Data File for filename Dialog Box (Micro Focus COBOL Only)

See Also

Note This feature is available only in Relativity for Micro Focus COBOL.

The Select Btrieve Data File for filename dialog box allows the selection of a Btrieve data file so that the file's key structure can be imported into a Relativity catalog .

To display this dialog box, click Browse on the Btrieve Key Import for filename dialog box.

The Select Btrieve Data File for filename dialog box contains the following options.

Option

Description

Look in

In the Look in list, select the drive and folder containing the Btrieve data file having the key structure you want to import into the Relativity catalog.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.

Toolbar

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.

List

The List area displays all the folders and files in the selected location. To open any folder or file, click its name in the list. You can toggle the manner in which information is displayed in this area with the View Menu toolbar button.

File name

In the File name list box, type or select (from the List area) the filename to be assigned to the Relativity catalog into which the Btrieve data file key structure is to be imported. This filename must have the .dat suffix.

Files of type

In the Files of type list, select Btrieve Data Files (*.dat).

Open as read-only

The Open as read-only check box is not functional in this context and has no effect on the importing process.

Open

The Open button closes the Select Btrieve Data File for filename dialog box. The name of the selected file is displayed in the Keys to Import text box on the Btrieve Key Import for filename dialog box.

Cancel

The Cancel button backs out of the Select Btrieve Data File for filename dialog box by canceling the selections made within the dialog box.


Select Character Set Dialog Box

See Also

The Select Character Set dialog box permits the selection of the appropriate character set.

The Select Character Set dialog box is displayed when:

· Upgrading a catalog from a version of Relativity that did not include character set support to a version that does include character set support. The catalog conversion process will associate the selected character set with all of the file definitions in the catalog. If it is necessary to select individual character sets for files, you must create a new catalog and follow the instructions for importing definitions from another Relativity catalog to import the file definitions with differing Code Pages.

· More than one catalog is involved in an operation, and one or more of the catalogs has not been upgraded to the current version. For example, this would occur during a catalog merge.

· You import COBOL file definitions and click Advanced in the Source Code Import wizard Files Selection page for either .CBL and .RST files or .COB files.

· You merge COBOL file definitions and click Advanced in the Source Code Merge wizard Files Selection page for either .CBL and .RST files or .COB files.

The Select Character Set dialog box contains the following options.

Option

Description

Character Set

In the Character Set box, type, or select from the list, the code pages that are known by Relativity. The defined code page number for each character set will be displayed to the right in parentheses. To view the standard character sets supported by Relativity, click here.

OK

The OK button completes the Select Character Set dialog box by associating the selected code page entries with all of the file definitions in the catalog.

New

The New button displays a standard Windows dialog box that allows you to specify the file that contains the character set you want to use. Character set files have the extension, .cs.

Note This button provides the same functionality as the Import button on the Character Set Maintenance dialog box.

Help

The Help button displays the related Help screen and provides information about the Select Character Set dialog box.

Cancel

The Cancel button backs out of the Select Character Set dialog box by canceling the selections made within the dialog box.


Select COBOL Source Dialog Box

See Also

The Select COBOL Source dialog box displays options for the selection of the COBOL source file to be imported or merged into the Relativity catalog.

To display this dialog box, click Browse in either the Source Code Import wizard or the Source Code Merge wizard depending on whether the Import COBOL Source or Merge COBOL Source option was selected.

The Select COBOL Source dialog box contains the following options.

Option

Description

Look in

In the Look in list, select the drive and folder containing the COBOL source file to be imported or merged into the Relativity catalog.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.

Toolbar

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.

List

The List area displays all the folders and files in the selected location. To open any folder or file, click its name in the list. You can toggle the manner in which information is displayed in this area with the View Menu toolbar button.

File name

In the File name list box, type or select the filename of the COBOL source file to be imported or merged into the Relativity catalog. This filename must have the suffix specified in the Files of type list.

Files of type

In the Files of type list, select a file having the .cbl suffix.

Open

The Open button closes the Select COBOL Source dialog box. The name of the selected file is displayed in the File to Import text box on either the Source Code Import wizard or Source Code Merge wizard.

Cancel

The Cancel button backs out of the Select COBOL Source dialog box by canceling the selections made within the dialog box.


Select Data Type Dialog Box

See Also

The Select Data Type dialog box allows you to choose which item pattern you want for the data item.

This dialog box is displayed when you click Assign Default Data Types on the FD form toolbar to assign the default user data type to all COBOL data items in the FD that match an item pattern and there are data items in the FD that match the criteria for more than one item pattern.

The Select Data Type dialog box contains the following options.

Option | Description
Data Item | The Data Item area (in the top portion of the dialog) displays a COBOL data item in the FD that matches the criteria for more than one item pattern.
User Data Type | The User Data Type column lists the user data type associated with the item pattern.
Item Transform | The Item Transform column lists the transform associated with the item pattern.
Select | The Select button completes the Select Data Type dialog box by accepting the selection made within the dialog box.
Cancel | The Cancel button backs out of the Select Data Type dialog box by canceling the selections made within the dialog box.


Select DDL Export File Dialog Box

The Select DDL Export File dialog box opens when you click Browse in the Export DDL dialog box.

The Select DDL Export File dialog box contains the following options.

Option

Description

Look in

In the Look in list, select the drive or folder to which you want to export.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow.

· To open the folder one level higher, click the Up One Level toolbar button.

Toolbar

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.

List

The List area displays all the folders and files in the selected location. To open any folder or file, click its name in the list. You can toggle the manner in which information is displayed in this area with the View Menu toolbar button.

File name

In the File name list box, type or select the filename of the data definition language file. This filename must have the suffix specified in the Files of type list.

Files of type

In the Files of type list, select a file having the .ddl suffix.

Open

After making the selection in the File name list box, click the Open button to close the Select DDL Export File dialog box, and display the name and location of the resulting output file in the Export File option of the Export DDL dialog box.

Cancel

The Cancel button backs out of the Select DDL Export File dialog box by canceling the selections made within the dialog box.


Select FDs to Delete Dialog Box

The Select FDs to Delete dialog box enables you to remove selected multiple file definitions from the Relativity catalog.

To display this dialog box, click Delete Multiple FDs on the FD menu when a Files catalog object is opened in the Catalog window, or right-click to choose this same command from the pop-up FD context menu.

The Select FDs to Delete dialog box contains the following options.

Option

Description

Select FDs

The Select FDs list displays the file-names of the file definitions that can be selected and deleted from a Relativity catalog.

To select multiple file definitions in this list, press and hold down the Ctrl key, and then click each individual item you want to delete. To select a group of file definitions that are next to each other, press and hold down the Shift key, and then click the first and last item in the group.

Delete

After the items are selected, press the Delete button. A message box will be displayed requesting confirmation of each delete request.

Note If there are any table definitions based on the file definition, a second confirmation message box informs you of the existing tables. If you confirm the deletion, the file definition and any table definitions based on that file definition are deleted from the catalog.

Cancel

The Cancel button dismisses the Select FDs to Delete dialog box by canceling the selections made within the dialog box.


Select Function Dialog Box

See Also

The Select Function dialog box displays a list of all available internal functions that can be added to an FD form as a synthesized data item.

To display this dialog box, do one of the following:

· Click Add Function on the FD form toolbar.

· Choose Add Function from the FD menu when focus is on a file definition opened in the FD form, or right-click to choose this same command from the pop-up FD context menu.

The Select Function dialog box contains the following options.

Option | Description
Select Functions | The Select Functions list displays the internal functions that can be selected and added to an FD. You may only select one function at a time from this list.
Select | The Select button completes the Select Function dialog box by accepting the selection made within the dialog box. (In the FD form, the function is displayed in the COBOL Name attribute column preceded by "f:".)
Cancel | The Cancel button backs out of the Select Function dialog box by canceling the selections made within the dialog box.


Select Report Dialog Box

See Also

The Select Report dialog box displays options for the selection of a Relativity report to print or edit. Note that the exact name of this dialog box varies depending on the report category selected (for example, Files/Tables, Connections, Privileges, or Users).

To display this dialog box, do one of the following:

· From the Reports catalog object in the Catalog window, click the Print or Edit shortcut from the Report Common Tasks area after selecting a report category rather than a specific report description.

· From the Reports menu, point to Print or Edit to display a submenu containing a list of report categories and then click the category of report to be printed or edited. (Alternatively, you may choose these same commands from the pop-up Reports context menu.)

The Select Report dialog box contains the following options.

Option

Description

Look in

The Look in list box indicates the current location of the report definition file for the specified report category.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.

Toolbar

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.

List

The List area displays a list of all the report definition files for the specified file type in the currently selected location. You can toggle the manner in which information is displayed in this area with the View Menu toolbar button.

File name

In the File name list box, type or select the filename of a report definition file. This filename must have the extension specified in the Files of type list.

Files of type

The Files of type list displays the default filename extension of the report definition file for the selected report category.

Open

When a report is specified in the File name list box, click the Open button to do one of the following:

· Display the Print Options dialog box, if you are printing the report.

· Access the Report Editor, if you are editing the report.

Cancel

The Cancel button backs out of the Select Report dialog box by canceling the selections made within the dialog box.

Preview

In the right half of the dialog box, the Preview area displays a thumbnail version and the name of the of the selected report definition file as you move from file to file in the List area.


Select RM/COBOL Program Dialog Box

See Also

The Select RM/COBOL Program dialog box displays options for the selection of the previously compiled RM/COBOL object file to be imported or merged into the Relativity catalog.

To display this dialog box, click Browse in either the Source Code Import wizard or the Source Code Merge wizard depending on whether the Import Previously Compiled RM/COBOL Program (.COB) or Merge Previously Compiled RM/COBOL (.COB) option was selected.

The Select RM/COBOL Program dialog box contains the following options.

Option

Description

Look in

In the Look in list, select the drive and folder containing the RM/COBOL object file to be imported or merged into the Relativity catalog.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.

Toolbar

This area contains several toolbar buttons that allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.

List

The List area displays a list of all the previously compiled RM/COBOL object file programs to be imported or merged into the Relativity catalog in the currently selected location. You can toggle the manner in which information is displayed in this area with the View Menu toolbar button.

File name

In the File name list box, type or select the filename of the RM/COBOL object file to be imported or merged into the Relativity catalog. This filename must have the suffix specified in the Files of type list.

Files of type

In the Files of type list, select a file having the .cob suffix.

Open

The Open button closes the Select RM/COBOL Program dialog box. The name of the selected file is displayed in the File to Import text box on the Source Code Import wizard or Source Code Merge wizard.

Cancel

The Cancel button backs out of the Select RM/COBOL Program dialog box by canceling the selections made within the dialog box.


Select Server Dialog Box

See Also

The Select Server dialog box is displayed when you launch the Relativity Server Administrator utility by clicking Server Admin on the Tools menu from within the Relativity Designer. (The Relativity Server Administrator utility applet, Relativity Server, is also accessible from the Windows Control Panel.)

Note This command and utility are available only in client/server configurations of Relativity.

This utility allows you to define a Windows or UNIX server for the Relativity Data Client data source and to configure a Relativity Data Server data source on a Windows or UNIX server for the Data Client. It is also used to verify communications between a Relativity Data Client data source and the Relativity Data Server data source.

For detailed information about the Relativity Server Administrator utility, see the Relativity Server Administrator online Help file. (To access this Help file, click either Help in this dialog box or Server Admin Help File from the Help menu in the Relativity Designer window.)


Select Symbol Table Dialog Box

See Also

The Select Symbol Table dialog box displays options for the selection of the previously compiled Relativity symbol table file to be imported or merged into the Relativity catalog.

To display this dialog box, click Browse in either the Source Code Import wizard or the Source Code Merge wizard depending on whether the Import Previously Compiled Symbol Table (.RST) or Merge Previously Compiled Symbol Table (.RST) option was selected.

The Select Symbol Table dialog box contains the following options.

Option

Description

Look in

In the Look in list, select the drive and folder containing the Relativity symbol table file to be imported or merged into the Relativity catalog.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.

Toolbar

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.

List

The List area displays a list of all the previously compiled RM/COBOL symbol table files to be imported or merged into the Relativity catalog in the currently selected location. You can toggle the manner in which information is displayed in this area with the View Menu toolbar button.

File name

In the File name list box, type or select the filename of the Relativity symbol table file to be imported or merged into the Relativity catalog. This filename must have the suffix specified in the Files of type list.

Files of type

In the Files of type list, select a file having the .rst suffix.

Open

The Open button closes the Select Symbol Table dialog box. The name of the selected file is displayed in the File to Import text box on the Source Code Import wizard or Source Code Merge wizard.

Cancel

The Cancel button backs out of the Select Symbol Table dialog box by canceling the selections made within the dialog box.


Select Table Connection to Show Dialog Box

See Also

Multiple table connections may be associated with a Relativity table definition. A table connection is composed of a table name and a path name. Each table connection associated with the same Relativity table definition has identical characteristics except for the path name of the underlying COBOL data file.

Note Should file labels be in effect, the table connection also includes the name of the file label associated with the table connection.

If a table definition name selected in the Tables catalog object in the Catalog window or opened in the Table form has multiple table connections pointing to it, none of which match the table definition name, the Select Table Connection to Show dialog box displays options for selecting from the multiple table connections.

To display this dialog box, click one of the following commands from the Table menu:

· Show Table Contents to preview table data. In this case, the Selected Table Connection to Show dialog is displayed on top of the Show Table Contents form.

· Show Indexes to show indexes in the Show Indexes for Tablename form.

This dialog box is also displayed when you select a table from the Tables catalog object in the Catalog window, right-click, and choose either Show Table Contents or Show Indexes from the pop-up Table context menu.

The Select Table Connection to Show dialog box contains the following options.

Option | Description
Connections | The Connections list box displays all table connections for the selected table definition. Select the correct table connection and then press the Select button.
Select | After selecting the correct table connection, click Select to close this dialog and then open either the Show Table Contents form or the Show Indexes for Tablename form, depending on the operation you have selected from the Table menu.
Cancel | The Cancel button backs out of the Select Table Connection to Show dialog box by canceling all entries made within the dialog box.


Select Tables to Delete Dialog Box

The Select Tables to Delete dialog box enables you to remove selected multiple table definitions from the Relativity catalog.

To open this dialog box, click Delete Multiple Tables on the Table menu when the Tables catalog object is selected in the Catalog window, or right-click to access this command from the pop-up Table context menu.

The Select Tables to Delete dialog box contains the following options.

Option

Description

Table Definitions

The Table Definitions list box displays all table definitions in the catalog.

· To select multiple table definitions in the dialog box, press and hold down the Ctrl key, and then click each individual item you want to delete.

· To select a group of table definitions that are next to each other, press and hold down the Shift key, and then click the first and last item in the group.

Delete

After selecting the table definitions, click Delete. A message box will be displayed requesting confirmation of each delete request.

Cancel

The Cancel button dismisses the Select Tables to Delete dialog box and cancels all entries made within the dialog box.


Set Default Value Dialog Box

See Also

The Set Default Value dialog box allows the setting of the default value for a data item. This value is used in write operations if the data item is not represented by a column in the INSERT statement.

To display this dialog box, click the Default Value column of the selected data item in the FD form and then click on the ellipsis button that appears in the column. Note that before the Default Value column will appear in the FD form, you must first select the Show Default Values option on the File page in the Options dialog box.

The Set Default Value dialog box contains the following options.

Option

Description

Value

In the Value list box, select from one of the following values or types of values:

· Entered. Specifies that a value is to be entered in the box to the right.

· SPACES. Specifies the figurative constant SPACES as the value for the condition-name.

· ZEROS. Specifies the figurative constant ZEROS as the value for the condition-name.

· LOW-VALUES. Specifies the figurative constant LOW-VALUES as the value for the condition-name.

· HIGH-VALUES. Specifies the figurative constant HIGH-VALUES as the value for the condition-name.

· Hexadecimal. Specifies that a hexadecimal value is to be entered in the box to the right.

In the Value text box, type the value.

OK

The OK button completes the Set Default Value dialog box by accepting all the entries made within the dialog box.

Cancel

The Cancel button backs out of the Set Default Value dialog box by canceling all entries made within the dialog box.


Source Code Import Wizard

See Also

The Source Code Import wizard allows for specifying the COBOL source file to be used in creating a COBOL schema file. To display this wizard, do one of the following:

· Click the Import COBOL FDs shortcut on the FD Common Tasks area from the Files catalog object in the Catalog window.

· Click Import COBOL FDs on the FD menu.

Note The Source Code Import wizard displays with the Import COBOL Source option selected as the default. The wizard provides different capabilities, depending upon which COBOL dialect, RM/COBOL or MF COBOL, is selected. The discussion here pertains to the RM/COBOL dialect. To see the Source Code Import wizard with MF COBOL selected as the dialect, click here.

The Source Code Import wizard contains the following options.

Option

Description

Import COBOL Source

The Import COBOL Source option initiates the procedure to import a COBOL source file into Relativity. Selecting this option enables the Dialect list box and the Compiler Options option if RM/COBOL is selected as the dialect.

Note A number of restrictions exist when using this option in the schema extraction process for RM/COBOL.

Dialect

The Dialect list box allows you to specify the type of COBOL files (RM/COBOL or MF COBOL) to be used when the Import COBOL Source option is selected.

Note The Dialect list box is disabled unless Import COBOL Source is selected.

Import Previously Compiled Symbol Table (.RST)

The Import Previously Compiled Symbol Table (.RST) option imports the previously compiled Relativity symbol table file specified in the File to Import text box.

Import Previously Compiled RM/COBOL Program (.COB)

The Import Previously Compiled RM/COBOL Program (.COB) option imports the previously compiled RM/COBOL file specified in the File to Import text box.

Note A number of restrictions exist when using this option in the schema extraction process for RM/COBOL.

File to Import

The File to Import text box allows you to specify the filename and path of the file you want to import into Relativity. If the Import COBOL Source option is selected and the source file specified in the File to Import text box contains an error, the Detected Errors page of the Source Code Import wizard is displayed.

Note When using a client/server version of Relativity, a Remote check box will be visible in this area of the wizard. By default it is selected, indicating that the file containing the source code being imported is located on the remote server. If you clear this check box, you can select source code from the local machine to import.

Process XML

The Process XML option enables the Source Code Import wizard to import not only the COBOL FD information, but also the relational information related to that FD in an accompanying XML (Extensible Markup Language) file. Any tables defined in the XML file are also created as part of the import process. The XML file must reside in the same directory as the COBOL source file, and it must have the same name as the source but with the file extension, .xml.

This ability to permit relational definitions to be imported at the same time as the COBOL FD is imported makes possible the faster development and deployment of Relativity catalogs. Furthermore, this capability optionally provides a mechanism that would allow for the synchronized maintenance of the COBOL and non-COBOL information required to create a catalog.

Contact Liant Software Corporation to obtain further information from technical support services.

Note Currently, this feature provides only a subset of Relativity's functionality necessary to import relational information from other products.

Browse

The Browse button initiates a search for a file of the type indicated by the selected option, as follows:

· If the Import COBOL Source option is selected, the Browse button displays the Select COBOL Source dialog box for the selection of a .cbl file.

· If the Import Previously Compiled Symbol Table (.RST) option is selected, the Browse button displays the Select Symbol Table dialog box for the selection of an .rst file.

· If the Import Previously Compiled RM/COBOL Program (.COB) option is selected, the Browse button displays the Select RM/COBOL Program dialog box for the selection of a .cob file.

Compiler Options

The Compiler Options option allows you to enter RM/COBOL Compile Commands to control the compilation process. Note that the Compiler Options option is disabled unless Import COBOL Source is selected and RM/COBOL is selected in the Dialect list box.

The RM/COBOL Compile Command options must be preceded by a hyphen. The following RM/COBOL Compile Commands are pertinent to Relativity (see the RM/COBOL User's Guide for more information):

G Designates a file to be used as the compiler configuration.

H Designates a file as a supplement to the compiler configuration.

S Assumes a separate sign when the SIGN clause is not specified for a DISPLAY usage, signed numeric data item.

U Assumes an alternative usage for data items described as COMP or COMPUTATIONAL.

B Defines as binary sequential those sequential files not explicitly declared to be line sequential in their file control entries.

V Defines as line sequential any sequential file not declared to be binary sequential.

Cancel

The Cancel button unloads the Source Code Import wizard without importing a source code file or previously compiled symbol table/object file.

Back

The Back button is not enabled on the first page of the Source Code Import wizard.

Next

The Next button opens the File Selection page of the Source Code Import wizard. The File Selection page provides different capabilities, depending upon the type of file being imported.

· If you are importing a COBOL source file (.cbl) or a previously compiled symbol table file (.rst), click here.

· If you are importing a previously compiled RM/COBOL object program (.cob), click here.

Finish

The Finish button is not enabled on the first page of the Source Code Import wizard.


Source Code Import Wizard (with Micro Focus COBOL as the Dialect)

See Also

Note The Source Code Import wizard provides different capabilities, depending upon which COBOL dialect, RM/COBOL or MF COBOL, is selected. The discussion here pertains to the Micro Focus COBOL dialect. To see the Source Code Import wizard with RM/COBOL selected as the dialect, click here.

The Source Code Import wizard (with Micro Focus COBOL as the Dialect) contains the following options.

Option

Description

Import COBOL Source

The Import COBOL Source option initiates the procedure to import a COBOL source file into Relativity. Selecting this option enables the Dialect list box, and the Process COBOL.DIR, Display Errors, Debug, and Free Format options, if MF COBOL is selected as the dialect.

Dialect

The Dialect list box allows you to specify the type of COBOL files (RM/COBOL or MF COBOL) to be used when the Import COBOL Source option is selected.

Note The Dialect list box is disabled unless Import COBOL Source is selected.

Import Previously Compiled Symbol Table File (.RST)

The Import Previously Compiled Symbol Table (.RST) option imports the previously compiled Relativity symbol table file specified in the File to Import text box.

Import Previously Compiled RM/COBOL Program (.COB)

The Import Previously Compiled RM/COBOL Program (.COB) option imports the previously compiled RM/COBOL file specified in the File to Import text box.

File to Import

The File to Import text box allows you to specify the filename and path of the file you want to import into Relativity. If the Import COBOL Source option is selected and the source file specified in the File to Import text box contains an error, the Detected Errors page of the Source Code Import wizard is displayed.

Note When using a client/server version of Relativity, a Remote check box will be visible in this area of the wizard. By default it is selected, indicating that the file containing the source code being imported is located on the remote server. If you clear this check box, you can select source code from the local machine to import.

Process XML

The Process XML option enables the Source Code Import wizard to import not only the COBOL FD information, but also the relational information related to that FD in an accompanying XML (Extensible Markup Language) file. Any tables defined in the XML file are also created as part of the import process. The XML file must reside in the same directory as the COBOL source file, and it must have the same name as the source but with the file extension, .xml.

This ability to permit relational definitions to be imported at the same time as the COBOL FD is imported makes possible the faster development and deployment of Relativity catalogs. Furthermore, this capability optionally provides a mechanism that would allow for the synchronized maintenance of the COBOL and non-COBOL information required to create a catalog.

Contact Liant Software Corporation to obtain further information from technical support services.

Note Currently, this feature provides only a subset of Relativity's functionality necessary to import relational information from other products.

Browse

The Browse button initiates a search for a file of the type indicated by the selected option, as follows:

· If the Import COBOL Source option is selected, the Browse button displays the Select COBOL Source dialog box for the selection of a .cbl file.

· If the Import Previously Compiled Symbol Table (.RST) option is selected, the Browse button displays the Select Symbol Table dialog box for the selection of an .rst file.

· If the Import Previously Compiled RM/COBOL Program (.COB) option is selected, the Browse button displays the Select RM/COBOL Program dialog box for the selection of a .cob file.

Process COBOL.DIR

The Process COBOL.DIR option causes the source file import procedure to process the cobol.dir file, which specifies Micro Focus COBOL compiler directives. If a directive is not specified in a cobol.dir file, then the directive has the same default setting as the Micro Focus COBOL compiler for Windows. (Refer to your Micro Focus COBOL documentation for details on the meanings of each directive.) Note that the Process COBOL.DIR option is disabled unless Import COBOL Source is selected.

Display Errors

The Display Errors option causes the import procedure to display an error file containing any errors or warnings that occurred during compilation of the selected source file.

Note The Display Errors option is disabled unless Import COBOL Source is selected.

Debug

The Debug option causes the selected source code file to be processed as if the WITH DEBUGGING MODE clause was specified in the SOURCE-COMPUTER paragraph; that is, debug lines will be processed as source lines rather than comment lines.

Note The Debug option is disabled unless Import COBOL Source is selected.

Free Format

The Free Format option enables you to specify the Free Format compiler option in Micro Focus COBOL, which relaxes the restrictions placed on the COBOL source and allows source lines longer than 80 characters.

Note The Free Format option is disabled unless Import COBOL Source is selected.

Cancel

The Cancel button unloads the Source Code Import wizard without importing a source code file or previously compiled symbol table/object file.

Back

The Back button is not enabled on the first page of the Source Code Import wizard.

Next

The Next button opens the File Selection page of the Source Code Import wizard. The File Selection page provides different capabilities, depending upon the type of file being imported.

· If you are importing a COBOL source file (.cbl) or a previously compiled symbol table file (.rst), click here.

· If you are importing a previously compiled RM/COBOL object program (.cob), click here.

Finish

The Finish button is not enabled on the first page of the Source Code Import wizard.


Source Code Import Wizard Detected Errors Page

The Detected Errors page of the Source Code Import wizard lists the errors found during compilation of the source file.

This page is displayed when the Import COBOL Source option is selected on the first page of the Source Code Import wizard and the source file specified in the File to Import text box contains an error.

The Source Code Import wizard Detected Errors page contains the following options.

Option | Description
Open Error File | The Open Error File option causes the error file to display in the text editor specified in the With text box when the Open button is clicked.
Open Source File | The Open Source File option causes the source file to display in the text editor specified in the With text box when the Open button is clicked. The detected error(s) can then be corrected and the source recompiled.
With | The With text box allows for the entry of a text editor.
Open | The Open button opens the text editor specified in the With text box.
Cancel | The Cancel button unloads the Source Code Import wizard without importing a source code file or previously compiled symbol table/object file.
Back | The Back button returns to the first page of the Source Code Import wizard.
Next | The Next button is not enabled on the Detected Errors page of the Source Code Import wizard.
Finish | The Finish button is not enabled on the Detected Errors page of the Source Code Import wizard.


Source Code Import Wizard File Selection Page (for .CBL or .RST Files)

The File Selection page (for .CBL or .RST files) of the Source Code Import wizard displays the all the COBOL data file definitions to be included in the importing procedure.

To display this page for RM/COBOL or Micro Focus COBOL files, select either the Import COBOL Source option or the Import Previously Compiled Symbol Table (.RST) option on the first page of the Source Code Import wizard and click the Next button.

The Source Code Import wizard File Selection page (for .CBL and .RST files) contains the following options.

Option

Description

Date/Time Compiled

The Date/Time Compiled area indicates the date and time on which the selected source file was last compiled.

Available Files

The Available Files list contains a list of COBOL data file definitions available (but not selected) for importing by the Relativity Designer. This list is created by specifying actions with the Add, Remove, Add All, and Remove All buttons.

Note When the During Import, Initially Place Files in Available Column check box is selected on the System page, the FDs from the COBOL source file are placed in the Available Files list instead of the Selected Files list (the default). This enables you then to select only those FDs you wish to include in the importing process.

Selected Files

The Selected Files list contains a list of COBOL data file definitions to be imported into the Relativity catalog.

Note By default, the Relativity Designer assumes that you want to import all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.

Add

Use the Add button to move the selected COBOL data file definitions between the Selected Files and Available Files lists, as necessary.

Add All

Use the Add All button to move all COBOL data file definitions between the Selected Files and Available Files lists, as necessary.

Remove

Use the Remove button to move the selected COBOL data file definitions between the Available Files and Selected Files lists, as necessary.

Remove All

Use the Remove All button to move all COBOL data file definitions between the Available Files and Selected Files lists, as necessary.

Advanced

The Advanced button displays the Select Character Set dialog box to allow the selection of character set(s) for the files being imported.

Select 01's

The Select 01's button displays the Select 01's dialog box allowing the association of other level 01 record descriptions not subordinate to the selected COBOL file-name with the selected COBOL file-name. Note that a file definition must be selected in the Available Files list before this button is enabled.

Cancel

The Cancel button unloads the Source Code Import wizard without importing a source code file or previously compiled symbol table/object file.

Back

The Back button returns to the first page of the Source Code Import wizard.

Next

The Next button is not enabled on the File Selection page of the Source Code Import wizard.

Finish

The Finish button completes the importing of a source code file or previously compiled symbol table/object file.


Source Code Import Wizard File Selection Page (for .COB Files)

The File Selection page (for .COB files) of the Source Code Import wizard displays all the COBOL data file definitions to be included in the importing procedure.

To display this page, select the Previously Compiled RM/COBOL Program (.COB) option on the first page of the Source Code Import wizard and click the Next button.

The Source Code Import wizard File Selection page (for .COB files) contains the following options.

Option

Description

Date/Time Compiled

The Date/Time Compiled area indicates the date and time on which the selected source file was last compiled.

Available Files

The Available Files list contains a list of COBOL data file definitions available (but not selected) for importing by the Relativity Designer. This list is created by specifying actions with the Add, Remove, Add All, and Remove All buttons.

Note When the During Import, Initially Place Files in Available Column check box is selected on the System page, the FDs from the COBOL source file are placed in the Available Files list instead of the Selected Files list (the default). This enables you then to select only those FDs you wish to include in the importing process.

Selected Files

The Selected Files list contains a list of COBOL data file definitions to be imported into the Relativity catalog.

Note By default, the Relativity Designer assumes that you want to import all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.

Add

Use the Add button to move the selected COBOL data file definitions between the Selected Files and Available Files lists, as necessary.

Add All

Use the Add All button to move all COBOL data file definitions between the Selected Files and Available Files lists, as necessary.

Remove

Use the Remove button to move the selected COBOL data file definitions between the Available Files and Selected Files lists, as necessary.

Removed All

Use the Remove All button to move all COBOL data file definitions between the Available Files and Selected Files lists, as necessary.

Advanced

The Advanced button displays the Select Character Set dialog box to allow the selection of character set(s) for the files being imported.

Cancel

The Cancel button unloads the Source Code Import wizard without importing a source code file or previously compiled symbol table/object file.

Back

The Back button returns to the first page of the Source Code Import wizard.

Next

The Next button is not enabled on the File Selection page of the Source Code Import wizard.

Finish

The Finish button completes the importing of a source code file or previously compiled symbol table/object file.


Source Code Merge Wizard

See Also

The Source Code Merge wizard allows for specifying the COBOL source file to be used in creating a COBOL schema file. To display this wizard, do one of the following:

· Click the Merge COBOL FDs shortcut on the FD Common Tasks area from the Files catalog object in the Catalog window.

· Click Merge COBOL FD Changes on the FD menu.

Note The Source Code Merge wizard displays with the Merge COBOL Source option selected as the default. The wizard provides different capabilities, depending upon which COBOL dialect, RM/COBOL or MF COBOL, is selected. The discussion here pertains to the RM/COBOL dialect. To see the Source Code Merge wizard with MF COBOL selected as the dialect, click here.

The Source Code Merge wizard contains the following options.

Option

Description

Merge COBOL Source

The Merge COBOL Source option initiates the procedure to merge a COBOL source file into Relativity. Selecting this option enables the Dialect list box and the Compiler Options option if RM/COBOL is selected as the dialect.

Dialect

The Dialect list box allows you to specify the type of COBOL files (RM/COBOL or MF COBOL) to be used when the Merge COBOL Source option is selected.

Note The Dialect list box is disabled unless Merge COBOL Source is selected.

Merge Previously Compiled Symbol Table (.RST)

The Merge Previously Compiled Symbol Table (.RST) option merges the previously compiled Relativity Symbol Table file specified in the File to Import text box.

Merge Previously Compiled RM/COBOL Program (.COB)

The Merge Previously Compiled RM/COBOL Program (.COB) option merges the previously compiled RM/COBOL file specified in the File to Import text box.

File to Import

The File to Import text box allows you to specify the filename and path of the file you want to import into Relativity for the merge procedure. If the Merge COBOL Source option is selected and the source file specified in the File to Import text box contains an error, the Detected Errors page of the Source Code Merge wizard is displayed.

Note When using a client/server version of Relativity, a Remote check box will be visible in this area of the wizard. By default it is selected, indicating that the file containing the source code being imported is located on the remote server. If you clear this check box, you can select source code from the local machine to import.

Process XML

The Process XML option enables the Source Code Import wizard to import not only the COBOL FD information, but also the relational information related to that FD in an accompanying XML (Extensible Markup Language) file. Any tables defined in the XML file are also created as part of the import process. The XML file must reside in the same directory as the COBOL source file, and it must have the same name as the source but with the file extension, .xml.

This ability to permit relational definitions to be imported at the same time as the COBOL FD is imported makes possible the faster development and deployment of Relativity catalogs. Furthermore, this capability optionally provides a mechanism that would allow for the synchronized maintenance of the COBOL and non-COBOL information required to create a catalog.

To obtain further information from technical support services, contact Liant Software Corporation.

Note Currently, this feature provides only a subset of Relativity's functionality necessary to import relational information from other products.

Browse

The Browse button initiates a search for a file of the type indicated by the selected option, as follows:

· If the Merge COBOL Source option is selected, the Browse button displays the Select COBOL Source dialog box for the selection of a .cbl file.

· If the Merge Previously Compiled Symbol Table (.RST) option is selected, the Browse button displays the Select Symbol Table dialog box for the selection of an .rst file.

· If the Merge Previously Compiled RM/COBOL Program (.COB) option is selected, the Browse button displays the Select RM/COBOL Program dialog box for the selection of a .cob file.

Compiler Options

The Compiler Options option allows you to enter RM/COBOL Compile Commands to control the compilation process. Note that the Compiler Directives option is disabled unless Merge COBOL Source is selected.

The RM/COBOL Compile Command options must be preceded by a hyphen. The following RM/COBOL Compile Commands are pertinent to Relativity (see the RM/COBOL User's Guide for more information):

G Designates a file to be used as the compiler configuration.

H Designates a file as a supplement to the compiler configuration.

S Assumes a separate sign when the SIGN clause is not specified for a DISPLAY usage, signed numeric data item.

U Assumes an alternative usage for data items described as COMP or COMPUTATIONAL.

B Defines as binary sequential those sequential files not explicitly declared to be line sequential in their file control entries.

V Defines as line sequential any sequential file not declared to be binary sequential.

Cancel

The Cancel button unloads the Source Code Merge wizard without importing a source code file or previously compiled symbol table/object file for the merge procedure.

Back

The Back button is not enabled on the first page of the Source Code Merge wizard.

Next

The Next button opens the File Selection page of the Source Code Merge wizard. The File Selection page provides different capabilities, depending upon the type of file being imported for the merge procedure:

· If you are importing a COBOL source file (.cbl) or a previously compiled symbol table file (.rst), click here.

· If you are importing a previously compiled RM/COBOL object program (.cob), click here.

Finish

The Finish button is not enabled on the first page of the Source Code Merge wizard.


Source Code Merge Wizard (with Micro Focus COBOL as the Dialect)

Note The Source Code Merge wizard provides different capabilities, depending upon which COBOL dialect, RM/COBOL or MF COBOL, is selected. The discussion here pertains to the Micro Focus COBOL dialect. To see the Source Code Merge wizard with RM/COBOL selected as the dialect, click here.

The Source Code Merge wizard (with Micro Focus COBOL as the Dialect) contains the following options.

Option

Description

Merge COBOL Source

The Merge COBOL Source option initiates the procedure to merge a COBOL source file into Relativity. Selecting this option enables the Dialect list box, and the Process COBOL.DIR, Display Errors, Debug, and Free Format options, if MF COBOL is selected as the dialect.

Dialect

The Dialect list box allows you to specify the type of COBOL files (RM/COBOL or MF COBOL) to be used when the Merge COBOL Source option is selected.

Note The Dialect list box is disabled unless Merge COBOL Source is selected.

Merge Previously Compiled Symbol Table (.RST)

The Merge Previously Compiled Symbol Table (.RST) option merges the previously compiled Relativity Symbol Table file specified in the File to Import text box.

Merge Previously Compiled RM/COBOL Program (.COB)

The Merge Previously Compiled RM/COBOL Program (.COB) option merges the previously compiled RM/COBOL file specified in the File to Import text box.

File to Import

The File to Import text box allows you to specify the filename and path of the file you want to import into Relativity for the merge procedure. If the Merge COBOL Source option is selected and the source file specified in the File to Import text box contains an error, the Detected Errors page of the Source Code Merge wizard is displayed.

Note When using a client/server version of Relativity, a Remote check box will be visible in this area of the wizard. By default it is selected, indicating that the file containing the source code being imported is located on the remote server. If you clear this check box, you can select source code from the local machine to import.

Process XML

The Process XML option enables the Source Code Import wizard to import not only the COBOL FD information, but also the relational information related to that FD in an accompanying XML (Extensible Markup Language) file. Any tables defined in the XML file are also created as part of the import process. The XML file must reside in the same directory as the COBOL source file, and it must have the same name as the source but with the file extension, .xml.

This ability to permit relational definitions to be imported at the same time as the COBOL FD is imported makes possible the faster development and deployment of Relativity catalogs. Furthermore, this capability optionally provides a mechanism that would allow for the synchronized maintenance of the COBOL and non-COBOL information required to create a catalog.

To obtain further information from technical support services, contact Liant Software Corporation.

Note Currently, this feature provides only a subset of Relativity's functionality necessary to import relational information from other products.

Browse

The Browse button initiates a search for a file of the type indicated by the selected option, as follows:

· If the Merge COBOL Source option is selected, the Browse button displays the Select COBOL Source dialog box for the selection of a .cbl file.

· If the Merge Previously Compiled Symbol Table (.RST) option is selected, the Browse button displays the Select Symbol Table dialog box for the selection of an .rst file.

· If the Merge Previously Compiled RM/COBOL Program (.COB) option is selected, the Browse button displays the Select RM/COBOL Program dialog box for the selection of a .cob file.

Process COBOL.DIR

The Process COBOL.DIR option causes the source file merge procedure to process the cobol.dir file, which specifies Micro Focus COBOL compiler directives. If a directive is not specified in a cobol.dir file, then the directive has the same default setting as the Micro Focus COBOL compiler for Windows. Refer to your Micro Focus COBOL documentation for details on the meanings of each directive.

Note The Process COBOL.DIR option is disabled unless Merge COBOL Source is selected.

Display Errors

The Display Errors option causes the merge procedure to display an error file containing any errors or warnings that occurred during compilation of the selected source file.

Note The Display Errors option is disabled unless Merge COBOL Source is selected.

Debug

The Debug option causes the selected source code file to be processed as if the WITH DEBUGGING MODE clause was specified in the SOURCE-COMPUTER paragraph; that is, debug lines will be processed as source lines rather than comment lines.

Note The Debug option is disabled unless Merge COBOL Source is selected.

Free Format

The Free Format option enables you to specify the Free Format compiler option in Micro Focus COBOL, which relaxes the restrictions placed on the COBOL source and allows source lines longer than 80 characters.

Note The Free Format option is disabled unless Merge COBOL Source is selected.

Cancel

The Cancel button unloads the Source Code Merge wizard without importing a source code file or previously compiled symbol table/object file for the merge procedure.

Back

The Back button is not enabled on the first page of the Source Code Merge wizard.

Next

The Next button opens the File Selection page of the Source Code Merge wizard. The File Selection page provides different capabilities, depending upon the type of file being imported for the merge procedure:

· If you are importing a COBOL source file (.cbl) or a previously compiled symbol table file (.rst), click here.

· If you are importing a previously compiled RM/COBOL object program (.cob), click here

Finish

The Finish button is not enabled on the first page of the Source Code Merge wizard.


Source Code Merge Wizard Detected Errors Page

The Detected Errors page of the Source Code Merge wizard lists the errors found during compilation of the source file.

This page is displayed when the Merge COBOL Source option is selected on the first page of the Source Code Merge wizard and the source file specified in the File to Import text box contains an error.

The Source Code Merge wizard Detected Errors page contains the following options.

Option | Description
Open Error File | The Open Error File option causes the error file to display in the text editor specified in the With text box when the Open button is clicked.
Open Source File | The Open Source File option causes the source file to display in the text editor specified in the With text box when the Open button is clicked. The detected error(s) can then be corrected and the source recompiled.
With | The With text box allows for the entry of a text editor.
Open | The Open button opens the text editor specified in the With text box.
Cancel | The Cancel button unloads the Source Code Merge wizard without importing a file for the merge procedure.
Back | The Back button returns to the first page of the Source Code Merge wizard.
Next | The Next button is not enabled on the Detected Errors page of the Source Code Merge wizard.
Finish | The Finish button is not enabled on the Detected Errors page of the Source Code Merge wizard.


Source Code Merge Wizard File Selection Page (for .CBL and .RST Files)

See Also

The File Selection page (for .CBL and .RST files) of the Source Code Merge wizard displays the available COBOL data file definitions to be included in the merging procedure.

To display this page for RM/COBOL or Micro Focus COBOL files, select either the Merge COBOL Source option or the Import Previously Compiled Symbol Table (.RST) option on the first page of the Source Code Merge wizard and click the Next button.

The Source Code Merge wizard File Selection page (for .CBL and .RST files) contains the following options.

Option

Descriptions

Date/Time Compiled

The Date/Time Compiled area indicates the date and time on which the selected source file was last compiled.

Available Files

The Available Files list contains a list of COBOL data file definitions available (but not selected) for importing (and merging) by the Relativity Designer. This list is created by specifying actions with the Add, Remove, Add All, and Remove All buttons.

Note When the During Import, Initially Place Files in Available Column check box is selected on the System page, the FDs from the COBOL source file are placed in the Available Files list instead of the Selected Files list (the default). This enables you then to select only those FDs you wish to include in the importing and merging processes.

Selected Files

The Selected Files list contains a list of COBOL data file definitions to be imported into the Relativity catalog for the merge procedures.

Note By default, the Relativity Designer assumes that you want to import (and merge) all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.

Add

Use the Add button to move the selected COBOL data file definitions between the Selected Files and Available Files lists, as necessary.

Add All

Use the Add All button to move all COBOL data file definitions between the Selected Files and Available Files lists, as necessary.

Remove

Use the Remove button to move the selected COBOL data file definitions between the Available Files and Selected Files lists, as necessary.

Remove All

Use the Remove All button to move all COBOL data file definitions between the Available Files and Selected Files lists, as necessary.

Advanced

The Advanced button displays the Select Character Set dialog box to allow the selection of character set(s) for the files being merged.

Select 01's

The Select 01's button displays the Select 01's dialog box allowing the association of other level 01 record descriptions not subordinate to the selected COBOL file-name with the selected COBOL file-name. Note that a file definition must be selected in the Available Files list before this button is enabled.

Cancel

The Cancel button unloads the Source Code Merge wizard without importing a source code file or previously compiled symbol table/object file for the merge procedure.

Back

The Back button returns to the first page of the Source Code Merge wizard.

Next

The Next button is not enabled on the File Selection page of the Source Code Merge wizard.

Finish

The Finish button completes the importing a source code file or previously compiled symbol table/object file for the merge procedure.

Note If necessary, when merging a previously compiled symbol table (RST) file, the Resolve Merge Differences dialog box is displayed to allow resolution of differences between COBOL data definitions in the previous version and the merged version of the file.


Source Code Merge Wizard File Selection Page (for .COB Files)

See Also

The File Selection page (for .COB files) of the Source Code Merge wizard displays the available COBOL data file definitions to be included in the merging procedure.

To display this page, select the Previously Compiled RM/COBOL Program (.COB) option on the first page of the Source Code Merge wizard and click the Next button.

The Source Code Merge wizard File Selection page (for .COB files) contains the following options.

Option

Description

Date/Time Compiled

The Date/Time Compiled area indicates the date and time on which the selected source file was last compiled.

Available Files

The Available Files list contains a list of COBOL data file definitions available (but not selected) for importing (and merging) by the Relativity Designer. This list is created by specifying actions with the Add, Remove, Add All, and Remove All buttons.

Note When the During Import, Initially Place Files in Available Column check box is selected on the System page, the FDs from the COBOL source file are placed in the Available Files list instead of the Selected Files list (the default). This enables you then to select only those FDs you wish to include in the importing and merging processes.

Selected Files

The Selected Files list contains a list of COBOL data file definitions to be imported into the Relativity catalog for the merge procedure.

Note By default, the Relativity Designer assumes that you want to import (and merge) all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.

Add

Use the Add button to move the selected COBOL data file definitions between the Selected Files and Available Files lists, as necessary.

Add All

Use the Add All button to move all COBOL data file definitions between the Selected Files and Available Files lists, as necessary.

Remove

Use the Remove button to move the selected COBOL data file definitions between the Available Files and Selected Files lists, as necessary.

Remove All

Use the Remove All button to move all COBOL data file definitions between the Available Files and Selected Files lists, as necessary.

Advanced

The Advanced button displays the Select Character Set dialog box to allow the selection of character set(s) for the files being merged.

Cancel

The Cancel button unloads the Source Code Merge wizard without importing a source code file or previously compiled symbol table/object file for the merge procedure.

Back

The Back button returns to the first page of the Source Code Merge wizard.

Next

The Next button is not enabled on the File Selection page of the Source Code Merge wizard.

Finish

The Finish button completes the importing of a source code file or previously compiled symbol table/object file for the merge procedure.

Note If necessary, when merging a previously compiled RM/COBOL object file, the Resolve Merge Differences dialog box is displayed to allow resolution of differences between COBOL data definitions in the previous version and the merged version of the file.


Status Report Dialog Box

See Also

Several batch file processes in the Relativity Designer report the successful completion of the operation when it is finished. Some of the activities that report their results in a Status Report dialog box include the following:

· Establishing table connections

· Exporting a table to a DDL file

· Importing an RST file

· Importing from another catalog

· Merging COBOL FDs

· Changing existing character sets for a data source

A Status Report dialog box contains the following information and options.

Option

Description

List

Each Status Report dialog box displays similar information in the List area: the type of operation, the location of the output file, if appropriate, the results of the operation, and any messages or possible errors that may be relevant.

Color values are used to display the results: blue text indicates the operation that was performed, black text indicates the results of the operation, and red text indicates any error or diagnostic messages that occurred.

The ending date and time are also included.

The Close toolbar button dismisses the Status Report dialog box.

The Save toolbar button allows you to save the information displayed in this dialog box.

The Print toolbar button enables you to print the information in the dialog box.


Subscripted Data Item Dialog Box

See Also

The Subscripted Data Item dialog box allows you to select the desired behavior of the subscripted data item (also called a repeating data item).

This dialog box is displayed when you add a repeating data item to a table by dragging the item from the FD form and dropping it in the Table form.

The Subscripted Data Item dialog box contains the following options.

Option

Description

Create Multiple Rows

If the Create Multiple Rows option is selected, each occurrence of the subscripted data item will appear as a separate row in the table.

Note If the necessary condition items (as described in Flattening OCCURS) have not been defined, you can select the Create Multiple Rows option. This selection can later be modified by use of the Bound Subscripts control in the Column Properties area in the Table form for the column associated with the repeating data items. Selecting the Create Multiple Rows option and later using the Bound Subscripts controls is also necessary if the subscript binding is to a numeric data item value rather than to a constant.

Create Multiple Columns

If the Create Multiple Columns option is selected, selected occurrences of the subscripted data item will appear as separate columns in the table. The Choose Subscript Values dialog box will be displayed after clicking OK if this option is selected. The Choose Subscript Values dialog box allows selection of the occurrences for which columns are desired.

OK

The OK button accepts the user option and closes the dialog box.


Table Wizard

See Also

The Table wizard, designed to simplify the creation of tables, starts by selecting all of the elementary items from the FD form. From there, items may be added or removed from the table, and the column names may be edited.

To display the Table wizard, select a file definition from the Files catalog object in the Catalog window and do one of the following:

· Click the Table Wizard shortcut from the FD Common Tasks area.

· Click Table Wizard from the FD menu.

The Table wizard contains the following options.

Option | Description
Available Items | The Available Items list contains a list of all of the data items from the FD form that are not to be included in the new table.
Selected Items | The Selected Items list contains a list of all of the data items that are to be included in the new table. This list defaults to all of the elementary items from the FD form.
 | The Add button moves the selected data items in the Available Items list to the Selected Items list.
 | The Add All button moves all data items in the Available Items list to the Selected Items list.
 | The Remove button moves the selected data items in the Selected Items list to the Available Items list.
 | The Remove All button moves all data items in the Selected Items list to the Available Items list.
Record Type | The Record Type list displays the following choice: · Any currently defined record types for the selected data items. · The <no record type option>, which allows you to reset or indicate that no record type is selected.
Display Group Items | Under List Options, the Display Group Items check box controls the displaying of group level items in the Available Items list.
Show 88 Items | Under List Options, the Show 88 Items check box controls whether the 88-level condition-name is displayed in the Available Items list.
Cancel | The Cancel button unloads the Table wizard without creating a table.
Back | The Back button is not enabled.
Next | The Next button opens the Edit page of the Table wizard, where you can edit column names.
Finish | The Finish button completes the Table wizard by creating the table definition based upon the selections made.


Table Wizard Edit Page

See Also

The Edit page of the Table wizard allows you to edit column names.

To display this page, click Next in the Table wizard.

The Edit page of the Table wizard contains the following options.

Option

Description

Column Names

The Column Names list contains a list of all of the columns and is displayed to show the results of any editing that is done.

Make Uppercase

Under Edit Column Names, the Make Uppercase check box toggles between whether the column names will be in mixed case or uppercase letters.

Add Underbars

Under Edit Column Names, the Add Underbars check box toggles the converting of dashes in the FD form to the underbar character in the column name.

Replace - With

The Replace - With boxes allow global search and replace on the column names.

Reset Names

The Reset Names button restores all of the column names to their unedited state.

Apply

The Apply button applies the values entered in the Replace - With boxes.

Allow Updates

Under the Write Support area, the Allow Updates check box is used to control whether or not SQL UPDATE statements are allowed on this table. This is an extra level of security that the Relativity Designer allows.

· If Allow Updates is not set, then no matter what security a user is given, there is no way to perform update operations on the underlying table.

· If Allow Updates is set, you must still have the appropriate security levels to update entries in the table.

You also can set this option on the Table form toolbar.

Allow Inserts

Under the Write Support area, the Allow Inserts check box is used to control whether or not SQL INSERT and DELETE statements are allowed on this table. This is an extra level of security that the Relativity Designer allows.

· If Allow Inserts is not set, then no matter what security a user is given, there is no way to perform insert or delete operations on the underlying table.

· If Allow Inserts is set, you must still have the appropriate security levels to insert or delete entries in the table.

If the Allow Inserts check box is selected, and if the Show Default Values check box is selected on the Table page in the Options dialog box, the Default Value column is displayed in the Table form.

You also can set this option on the Table form toolbar.

Cancel

The Cancel button unloads the Edit page of the Table wizard without creating a table.

Back

The Back button returns to the first page of the Table wizard.

Next

The Next button is disabled.

Finish

The Finish button completes the Edit page of the Table wizard by creating the table definition based upon the selections made.


Tables to Keep Dialog Box

See Also

The Tables to Keep dialog box displays the available table definitions from which you select those to be included in the merging procedure.

To display this dialog box, click either the Done command button or the Save Changes button in the Resolve Merge Differences dialog box.

The Tables to Keep dialog box contains the following options.

Options | Description
Tables to Discard | The Tables to Discard list contains a list of table definitions associated with the previous file definition that will not be replicated during the last phase of the merging process.
Tables to Keep | The Tables to Keep list contains a list of table definitions associated with the previous file definition that will be replicated during the last phase of the merging process.
Add | The Add button moves the selected table definitions from the Tables to Discard list to the Tables to Keep list.
Add All | The Add All button moves all table definitions in the Tables to Discard list to the Tables to Keep list.
Remove | The Remove button moves the selected table definition in the Tables to Keep list to the Tables to Discard list.
Remove All | The Remove All button moves all table definitions in the Tables to Keep list to the Tables to Discard list.
Done | The Done button completes the Tables to Keep dialog box by replicating table definitions for all table definitions appearing in the Tables to Keep list.


Write Support Wizard

See Also

The Write Support wizard analyzes the underlying table and file definitions. It then displays the list of issues, if any, that would arise if a write operation were attempted on the underlying table. (For a complete list of rules that is checked by the Write Support wizard, see Rules for Insertable Tables.)

To display the Write Support wizard, click Write Support Wizard on the Table form toolbar.

The Write Support wizard contains the following options.

Option | Description
Issue Label | The Issue Label area describes the issue found by the Write Support wizard. The complete list of rules that is checked by the Write Support wizard is located in the topic Rules for Insertable Tables.
Details List | The Details List area gives details about exactly what caused the issue. It is intended to aid in resolving issues, by pointing to the exact cause.
Help | The Help button displays the related Help screen. Clicking this button while on one of the issues in the list, will present you with a more detailed explanation of the rule in question, and also give an example.
Back | The Back button is used to view the previous issue in the list. When the button is not enabled, the current issue is the first issue in the list.
Next | The Next button is used to proceed to the next issue found by the Write Support wizard. When the button is not enabled, there are no more issues in the list.
Close | The Close button is used to return to the Write Support dialog box. No changes are made while the Write Support wizard is loaded, so there is nothing that needs to be saved.


SQL Reserved Words

See Also

The SQL reserved words are words that Relativity prevents from use as a column name or table name when creating a new table name. This is necessary because some ODBC-enabled applications can not handle these words as column or table names when you create a new table.

SQL Reserved Words (A - B)

SQL Reserved Words (C)

SQL Reserved Words (D - E)

SQL Reserved Words (F - H)

SQL Reserved Words (I - L)

SQL Reserved Words (M - O)

SQL Reserved Words (P - R)

SQL Reserved Words (S)

SQL Reserved Words (T - U)

SQL Reserved Words (V - Z)


SQL Reserved Words (A - B)

To view other SQL reserved words, click here.

ABSOLUTE | BEGIN
ACTION | BETWEEN
ADA | BIT
ADD | BIT_LENGTH
ALL | BOTH
ALLOCATE | BY
ALTER |
AND |
ANY |
ARE |
AS |
ASC |
ASSERTION |
AT |
AUTHORIZATION |
AVG |


SQL Reserved Words (C)

To view other SQL reserved words, click here.

CASCADE | COALESCE | CONVERT
CASCADED | COBOL | CORRESPONDING
CASE | COLLATE | COUNT
CAST | COLLATION | CREATE
CATALOG | COLUMN | CROSS
CHAR | COMMIT | CURRENT
CHAR_LENGTH | CONNECT | CURRENT_DATE
CHARACTER | CONNECTION | CURRENT_TIME
CHARACTER_LENGTH | CONSTRAINT | CURRENT_TIMESTAMP
CHECK | CONSTRAINTS | CURRENT_USER
CLOSE | CONTINUE | CURSOR


SQL Reserved Words (D - E)

To view other SQL reserved words, click here.

DATABASE | ELSE
DATE | END
DAY | END-EXEC
DEALLOCATE | ESCAPE
DEC | EXCEPT
DECIMAL | EXCEPTION
DECLARE | EXEC
DEFAULT | EXECUTE
DEFERRABLE | EXISTS
DEFERRED | EXTERNAL
DELETE | EXTRACT
DESC |
DESCRIBE |
DESCRIPTOR |
DIAGNOSTICS |
DISCONNECT |
DISTINCT |
DOMAIN |
DOUBLE |
DROP |


SQL Reserved Words (F - H)

To view other SQL reserved words, click here.

FALSE | GET | HAVING
FETCH | GLOBAL | HOUR
FIRST | GO |
FLOAT | GOTO |
FOR | GRANT |
FOREIGN | GROUP |
FORTRAN |  |
FOUND |  |
FROM |  |
FULL |  |


SQL Reserved Words (I - L)

To view other SQL reserved words, click here.

IDENTITY | JOIN | KEY | LANGUAGE
IF |  |  | LAST
IMMEDIATE |  |  | LEADING
IN |  |  | LEFT
INCLUDE |  |  | LEVEL
INDEX |  |  | LIKE
INDICATOR |  |  | LOCAL
INITIALLY |  |  | LOWER
INNER |  |  |
INPUT |  |  |
INSENSITIVE |  |  |
INSERT |  |  |
INT |  |  |
INTEGER |  |  |
INTERSECT |  |  |
INTERVAL |  |  |
INTO |  |  |
IS |  |  |
ISOLATION |  |  |


SQL Reserved Words (M - O)

To view other SQL reserved words, click here.

MATCH | NAMES | OCTET_LENGTH
MAX | NATIONAL | OF
MIN | NATURAL | ON
MINUTE | NCHAR | ONLY
MODULE | NEXT | OPEN
MONTH | NO | OPTION
MUMPS | NONE | OR
 | NOT | ORDER
 | NULL | OUTER
 | NULLIF | OUTPUT
 | NUMERIC | OVERLAPS


SQL Reserved Words (P - R)

To view other SQL reserved words, click here.

PAD | READ
PARTIAL | REAL
PASCAL | REFERENCES
PLI | RELATIVE
POSITION | RESTRICT
PRECISION | REVOKE
PREPARE | RIGHT
PRESERVE | ROLLBACK
PRIMARY | ROWS
PRIOR |
PRIVILEGES |
PROCEDURE |
PUBLIC |


SQL Reserved Words (S)

To view other SQL reserved words, click here.

SCHEMA | SET | SQLERROR
SCROLL | SIZE | SQLSTATE
SECOND | SMALLINT | SQLWARNING
SECTION | SOME | SUBSTRING
SELECT | SPACE | SUM
SEQUENCE | SQL | SVBEGIN
SESSION | SQLCA | SVEND
SESSION_USER | SQLCODE | SYSTEM_USER


SQL Reserved Words (T - U)

To view other SQL reserved words, click here.

TABLE | UNION
TEMPORARY | UNIQUE
THEN | UNKNOWN
TIME | UPDATE
TIMESTAMP | UPPER
TIMEZONE_HOUR | USAGE
TIMEZONE_MINUTE | USER
TO | USING
TRAILING |
TRANSACTION |
TRANSLATE |
TRANSLATION |
TRIM |
TRUE |


SQL Reserved Words (V - Z)

To view other SQL reserved words, click here.

VALUE | WHEN | YEAR | ZONE
VALUES | WHENEVER |  |
VARCHAR | WHERE |  |
VARYING | WITH |  |
VIEW | WORK |  |
 | WRITE |  |


Glossary of Terms

The glossary terms used in Relativity are listed below alphabetically.

88-level

AirlineDate

attribute

catalog

COBOL schema

COBOL schema file

COBOL table

CombineDateTime

Complement

ComputeCenturyDate

ComputeCenturyDateTime

ComputeDate

ComputeDateTime

ComputeODO

ComputeTime

Constrain property

condition item

condition-name

conditional variable

data item

data source

data-name

database

date constants

domain

file connection

file label item

filter

filter subexpression

function

function item

indexed file

internal function

ISAM file

IsNumeric

IsValidDate

item pattern

item set

LogicalAnd

LogicalOr

null

nullable

ODBC

ODBC data type

ODBC-enabled application

ODO control item

Open Database Connectivity

parallel OCCURS

RDBMS

record type

record type filter

redundant data items

relational database

relational database management system

relational table

Relativity Data Client

Relativity Data Manager

Relativity Data Server

Relativity DBMS

Relativity Symbol Table file

repeating data item

SQL

Structured Query Language

subscript item

subscripted data item

table

table connection

table definition

table filter

table name

transform

user data type


01 Record Name

The 01 Record Name column contains a list of names for the level 01 entries in the COBOL file definition. Data-names from the Working-Storage Section and the Linkage Section are included in this list depending on the selection of the associated check box in the SECTION area.


Abort Merge

The Abort Merge button causes the merging process to be abandoned. Choosing the Abort Merge button is identical to clicking the Cancel command button.


Add (Add Condition Item)

The Add button completes the Add Condition Item dialog box by accepting all the entries made within the dialog box.


Add (Add Function Constant)

The Add button completes the Add Function Constant dialog box by accepting all selections made within the dialog box.


Add All (Assign or Remove Record Types)

The Add All button moves all the record types in the Available Record Types list to the Record Types Used list.


Add All (Impprt File Selection Page COB RST)

The Add All button moves all COBOL data file definitions between the Selected Files list and the Available Files list, as necessary.


Add All (Import File Selection Page COB)

The Add All button moves all COBOL data file definitions between the Selected Files list and the Available Files list, as necessary.


Add All ( Merge File Selection Page CBL RST)

The Add All button moves all COBOL data file definitions between the Selected Files list and the Available Files list, as necessary.


Add All ( Merge File Selection Page COB)

Use the Add All button to move all COBOL data file definitions between the Selected Files list and the Available Files list, as necessary.


Add All (Tables to Keep)

The Add All button moves all table definitions in the Tables to Discard list to the Tables to Keep list.


Add All (Table Wizard)

The Add All button moves all data items in the Available Items list to the Selected Items list.


Add (Assign or Remove Record Types)

The Add button moves the selected record type(s) in the Available Record Types list to the Record Types Used list.


Add COBOL Data Item Redefinition Dialog Box See Also

Redefining Data Items


Add Condition Item Dialog Box See Also

Adding Condition Items

Building Writable Tables

Flattening OCCURS


Add Condition Item (FD Form Toolbar)

The Add Condition Item button displays the Add Condition Item dialog box for the definition of a condition-name for the selected data item in the FD form or for the modification of an added condition item. See Adding Condition Items.

Note This option provides the same functionality as the Add 88 command on the FD menu.


Add Connection (Add Table Connection Regular)

The Add Connection button completes the Add Table Connection dialog box by accepting all entries made within the dialog box.


Add Connections (Add Connections Matching)

The Add Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you click Save Changes on the Edit Connections form.


Add Connections Matching Pattern Dialog Box See Also

Add table connections with matching patterns

Establishing Table Connections

Pattern Matching


Add Constant Argument (FD Form Toolbar)

The Add Constant Argument button, which becomes enabled when only a function item is selected, displays the Add Function Constant dialog box to allow an alphanumeric or numeric constant to be added to the argument list of the selected function.


Add Database Group Dialog Box See Also

Add a database group to the catalog

Defining Groups and Users


Add Database User Dialog Box See Also

Add a user to a group

Defining Groups and Users


Add Data Item (FD Form Toolbar)

The Add Data Item button displays the Add COBOL Data Item Redefinition dialog box for the definition of a data item that redefines the selected data item in the FD form. See Redefining Data Items.

Note This option provides the same functionality as the Add Redefines command on the FD menu.


Add Data Item Pattern Dialog Box See Also

Defining Item Patterns

Pattern Matching

Using Functions and Transforms


Add Data Type (Add Data Type)

The Add Data Type button completes the Add Data Type dialog box by accepting all the selections made within the dialog box.


Add Data Type (Data Types Form)

In the Data Types form, the Add Data Type button displays the Add Data Type dialog box for the definition of a new user-defined data type.


Add Data Type Dialog Box See Also

Defining User Data Types

Using Functions and Transforms


Add File Label (Add File Label)

The Add File Label button generates a file label item in the FD form.


Add File Label Dialog Box See Also

Add a file label FD item

Supporting Multi-File Tables


Add Filter (Record Type Toolbar)

The Add Filter button displays the Describe Filter Subexpression dialog box for the definition of a filter subexpression to be added to the filter expression being defined in the Record Type Properties form. See Define a record type filter.


Add Filter (Table Filter Properties)

The Add Filter button displays the Describe Filter Subexpression dialog box for the definition of a filter subexpression to be added to the filter expression being defined in the Table Filter Properties form. See Define a table filter.


Add Function Constant Dialog Box See Also

Internal Functions

Using Functions and Transforms


Add Function (FD Form Toolbar)

The Add Function button displays the Select Function dialog box to allow selection of a function to add to the FD as a synthesized data item.

Note This option provides the same functionality as the Add Function command on the FD menu.


Add Group (Edit Users Form)

The Add Group button on the Edit Users form displays the Add Database Group dialog box, which contains options for the addition of a new database group and an expiration date for catalog access.

Shortcut: Alt+G

Note The Add Group button provides the same functionality as the Add Group command on the User menu.


Add (Import File Selection Page COB RST)

The Add button moves the selected COBOL data file definitions between the Selected Files list and the Available Files list, as necessary.


Add (Import File Selection Page COB)

The Add button moves the selected COBOL data file definitions between the Selected Files list and the Available Files list, as necessary.


Adding Condition Items See Also

Add Condition Item Dialog Box

Bind all occurrences at design time

Bind a subscript at design time

FD Form

Table Form


Add Item

The Add Item button completes the Add COBOL Data Item Redefinition dialog box by accepting all the selections made within the dialog box.


Add Item Argument (FD Form Toolbar)

The Add Item Argument button, which becomes enabled when a function item and one other data item, condition item, or function item are both selected, causes that other selected item to be added to the argument list of the selected function item. Note that an item may be added as a function argument by selecting that item, then dragging and dropping on the function item. If you select another function item as an argument, you will be presented with the Function of Function dialog box to select which function is the argument.


Add Item Pattern (Item Patterns Form)

The Add Item Pattern button displays the Add Data Item Pattern dialog box for the definition of an item pattern.


Add Item (Edit Record Type Form)

The Add Item button accepts the selected data item in the FD form as a new item in the record type having the record-name displayed in the Record Type: list. See Add a data item to a record type.


Add Items to Set (Edit Item Sets Form)

The Add Items to Set button accepts data items selected in the FD form into an existing item set. See Add a data item to an item set.


Add ( Merge File Selection Page CBL RST)

The Add button moves the selected COBOL data file definitions between the Selected Files list and the Available Files list, as necessary.


Add ( Merge File Selection Page COB)

Use the Add button to move the selected COBOL data file definitions between the Selected Files list and the Available Files list, as necessary.


Add New Character Set

Use the Add New Character Set area to add either a nonstandard character set or a standard character set, or both, to a data source.

· The From CS File option allows you to add a nonstandard character set by clicking the Import button. A standard Windows dialog box is displayed that allows you to enter the name of the desired character set file. When you click Open on that dialog box, the new character set will appear in the Character Set column. To see a list of errors that can occur when a nonstandard character set is imported into a Relativity data source, click here.

Note The Import button provides the same functionality as the New button on the Select Character Set dialog box.

· The From List of Standard Character Sets list box displays a list of standard character sets supported by Relativity. Select the desired character set file. When you click the Add button, the new character set will appear in the Character Set column.


Add New Item Set (Edit Item Sets Form)

The Add New Item Set button accepts data items selected in the FD form as a new set of items. See Define an item set.


Add Pattern (Add Data Item Pattern)

The Add Pattern button completes the Add Data Item Pattern dialog box by accepting all the selections made within the dialog box.


Add Record Type Dialog Box See Also

Defining Record Types


Add Subexpression (Describe Filter Subexpression)

The Add Subexpression button completes the Describe Filter Subexpression dialog box by accepting the filter subexpressions described within the dialog box.


Add Table Connection Dialog Box See Also

Add a table connection

Associate files with the table connection

Establishing Table Connections


Add Table Connection (Edit Connections Form)

The Add Table Connection button displays the Add Table Connection dialog box. This dialog box contains options for the definition of a table connection for a selected table definition on the Edit Connections form.

Shortcut: Alt+A


Add (Tables to Keep)

The Add button moves the selected table definitions from the Tables to Discard list to the Tables to Keep list.


Add (Table Wizard)

The Add button moves the selected data items in the Available Items list to the Selected Items list.


Add Underbars (Table Wizard Edit)

Under Edit Column Names, the Add Underbars check box toggles the converting of dashes in the FD form to the underbar character in the column name.


Add User (Edit Users Form)

The Add User button displays the Add Database User dialog box. This dialog box contains options for the addition of a new user to the selected group and an expiration date for catalog access in the Edit Users form. Each user name must be unique within the catalog.

Shortcut: Alt+U

Note The Add User button provides the same functionality as the Add User command on the User menu.


Administration Forms See Also

Catalog Window

COBOL Definition Forms

Options Dialog Box

Relational Definition Forms

Table Form Toolbar


Advanced (Import File Selection Page COB RST)

The Advanced button displays the Select Character Set dialog box to allow the selection of character set(s) for the files being imported.


Advanced (Import File Selection Page COB)

The Advanced button displays the Select Character Set dialog box to allow the selection of character set(s) for the files being imported.


Advanced (Merge File Selection Page CBL RST)

The Advanced button displays the Select Character Set dialog box to allow the selection of character set(s) for the files being merged.


Advanced (Merge File Selection Page COB)

The Advanced button displays the Select Character Set dialog box to allow the selection of character set(s) for the files being merged.


AirlineDate Internal Function

AirlineDate is a specialized internal function that computes a date from an "airline travel date" (PIC X(5) in the form DDMMM), transaction date (transformed into a date), and a one-character transaction type (PIC X), respectively. The resulting date is formed by using the day and month of the travel date. If the travel month is less than the transaction month and the transaction type = "1", then add 1 to the transaction year to produce the resulting year.

The YYYYMMDD transform may be applied to resulting data item.

Note This internal function is available only if the RELDBDSN.INI file has the following entry in the [Designer] section: EnableAirlineDate=Yes.


ALIGN"integer"

The ALIGN"integer" directive specifies inter-record alignment to a multiple of integer. Alignment is implicitly set by the IBMCOMP directive to ALIGN"8". The alignment does not actually affect Relativity, since all file records appear as if they start at offset zero. However, this could affect use of the SYNCHRONIZED clause if ALIGN"integer" is set to a value of less than four after setting the IBMCOMP directive (something that is not recommended).


All Items

The All Items check box indicates that the replacement takes place in all column names within the table.


All Levels (FD Form Toolbar)

The All Levels button expands the FD form vertically to display all subordinate data items in the record description.


Allow Inserts (Table Form Toolbar)

The Allow Inserts check box is used to control whether or not a given table definition will allow inserts (that is, SQL INSERT and DELETE statements) on this table. This is an extra level of security that the Relativity Designer allows.

· If Allow Inserts is not selected, then no matter what security a user is given, there is no way to perform insert or delete operations on the underlying table.

· If Allow Inserts is selected, the user must still have the appropriate security levels to insert or delete entries in the table.

If the Allow Inserts check box is selected, and if the Show Default Values check box is selected on the Table page in the Options dialog box, the Default Value column is displayed in the Table form.


Allow Inserts (Table Wizard Edit)

Under the Write Support area, the Allow Inserts check box is used to control whether or not SQL INSERT and DELETE statements are allowed on this table. This is an extra level of security that the Relativity Designer allows.

· If Allow Inserts is not set, then no matter what security a user is given, there is no way to perform insert or delete operations on the underlying table.

· If Allow Inserts is set, you must still have the appropriate security levels to insert or delete entries in the table.

If the Allow Inserts check box is selected, and if the Show Default Values check box is selected on the Table page in the Options dialog box, the Default Value column is displayed in the Table form.

You also can set this option on the Table form toolbar.


Allow Updates (Table Form Toolbar)

The Allow Updates check box is used to control whether or not a given table definition will allow updates (that is, SQL UPDATE statements) on this table. This is an extra level of security that the Relativity Designer allows.

· If Allow Updates is not selected, then no matter what security a user is given, there is no way to perform update operations on the underlying table.

· If Allow Updates is selected, the user must still have the appropriate security levels to update entries in the table.


Allow Updates (Table Wizard Edit)

Under the Write Support area, the Allow Updates check box is used to control whether or not SQL UPDATE statements are allowed on this table. This is an extra level of security that the Relativity Designer allows.

· If Allow Updates is not set, then no matter what security a user is given, there is no way to perform update operations on the underlying table.

· If Allow Updates is set, you must still have the appropriate security levels to update entries in the table.

You also can set this option on the Table form toolbar.


Alphanumeric (Add Function Constant)

If selected, the Alphanumeric option button specifies that the argument will be alphanumeric.


Alphanumeric Edited

When the Alphanumeric Edited check box is selected, the catalog includes the alphanumeric edited data type described by the PICTURE character-string; for example, PIC XBXBX.


ALPHASTART"integer"

The ALPHASTART"integer" directive specifies the starting value for integers used in the ALPHABET and CLASS clauses of the SPECIAL-NAMES paragraph. The default value of integer is 1 to match Standard COBOL. A value of 0 may be specified to match early Micro Focus COBOL implementations of the ALPHABET and CLASS clauses.


Analyzing Table Definition Errors See Also

Previewing Table Data


And/Or (Record Type Toolbar)

The And/Or attribute specifies whether the AND logical operator or OR logical operator connects this filter subexpression to the filter expression being defined. To view an example, click here.


And/Or (Table Filter Properties)

The And/Or attribute specifies whether the AND logical operator or the OR logical operator connects this filter subexpression to the filter expression being defined.


APOST

The APOST directive specifies that the figurative constants, QUOTE and QUOTES, will have the value ALL "'"; that is, one or more single quote characters (apostrophes). The opposite directive to APOST is QUOTE. The default is QUOTE, which specifies double quote characters for figurative constants.


Apply

The Apply button completes the Edit Default Column Names dialog box by accepting all the entries made within the dialog box.


Apply Command Button (COBOL Types Options)

The Apply button saves the settings specified for options in the Options dialog box without closing the dialog box.


Apply Command Button (Data Source Options)

The Apply button saves the settings specified for options in the Options dialog box without closing the dialog box.


Apply Command Button (Date Formats Options)

The Apply button saves the settings specified for options in the Options dialog box without closing the dialog box.


Apply Command Button (File Options)

The Apply button saves the settings specified for options in the Options dialog box without closing the dialog box.


Apply Command Button (Item Patterns Options)

The Apply button saves the settings specified for options in the Options dialog box without closing the dialog box.


Apply Command Button (Privilege Options)

The Apply button saves the settings specified for options in the Options dialog box without closing the dialog box.


Apply Command Button (System Options)

The Apply button saves the settings specified for options in the Options dialog box without closing the dialog box.


Apply Command Button (Table Options)

The Apply button saves the settings specified for options in the Options dialog box without closing the dialog box.


Apply Command Button (User Types Options)

The Apply button saves the settings specified for options in the Options dialog box without closing the dialog box.


Apply (Copy File Label)

The Apply button begins the copying process. A file label item with the same name, type, and size as the file label item selected from the Source list box will be placed in all the eligible FDs.


Apply (Copy File Label Column)

The Apply button begins the copying process. A file label column with the same name, type, and size as the file label column selected from the Source Table list box will be placed in all the eligible tables.


Apply (Table Wizard Edit)

The Apply button applies the values entered in the Replace - With boxes.


Assign Default Data Types (FD Form Toolbar)

The Assign Default Data Types button assigns user data types based on the item patterns defined prior to editing of the FD form and the Table form.

Notes

If the FD contains a COBOL data item that matches the criteria for more than one item pattern, the Select Data Type dialog box is displayed so that you can indicate which item pattern to apply.

This option provides the same functionality as the Assign Default Data Types command on the FD menu.


Assign or Remove Record Types Dialog Box See Also

Defining Record Types

Creating and Editing Table Definitions

Handling Multiple Record Types


ASSIGN"string"

The ASSIGN"string" directive specifies how to assign a file access name when neither EXTERNAL nor DYNAMIC is specified in the ASSIGN clause of the file control entry (SELECT) that defines a file-name. The parameter string must be one of the words EXTERNAL or DYNAMIC. Note that the ASSIGN directive may be specified in any $SET statement, but only the initial $SET ASSIGN setting is currently supported by Relativity. ASSIGN directives in $SET statements that are not initial $SET statements are currently ignored.


Assume Nonnegative=Positive

The Assume Nonnegative=Positive option indicates that the Relativity DBMS will interpret numeric data not having explicitly correct negative sign values for the data type as positive (even though the data do not have explicitly correct positive sign values). There are three possible states that may be selected for this option:

· Select Never to cause the DBMS to return an error when this condition is encountered. This is the default.

· Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

· Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.


Assume Spaces=Zeros

The Assume Spaces=Zeros option indicates that the Relativity DBMS will translate space characters and binary zeros to zero characters in the data source.

Note The Assume Spaces=Zeros option has no effect on data items that are either all or part of a key.

There are three possible states that may be selected for this option:

· Select Never to cause the DBMS to return an error when this condition is encountered. This is the default.

· Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

· Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.


Automated LogicalOrder Transform

The Automated LogicalOrder Transform option indicates that a LogicalOrder column transform will be placed automatically on every text column of a data source. There are three possible states that may be selected for this option:

· Select Never to cause the LogicalOrder transform not to be placed automatically on every text column of a data source. This is the default.

· Select Yes, Except for Record Key Data Items to apply the transform to all text columns except where it would result in the loss of an index on the table.

· Select Always to cause the LogicalOrder transform to be placed automatically on every text column of a data source.


Automated Resolution

The Automated Resolution button displays the Automated Resolution dialog box. Use the Automated Resolution button to relax the set of rules under which changes in COBOL file definitions are detected.


Automated Resolution Dialog Box See Also

Merging COBOL File Definitions

Resolving Merge Differences


Available Files (Import File Selection Page COB RST)

The Available Files list contains a list of COBOL data file definitions available (but not selected) for importing by the Relativity Designer. This list is created by specifying actions with the Add, Remove, Add All, and Remove All buttons.

Note When the During Import, Initially Place Files in Available Column check box is selected on the System page, the FDs from the COBOL source file are placed in the Available Files list instead of the Selected Files list (the default). This enables you then to select only those FDs you wish to include in the importing process.


Available Files (Import File Selection Page COB)

The Available Files list contains a list of COBOL data file definitions available (but not selected) for importing by the Relativity Designer. This list is created by specifying actions with the Add, Remove, Add All, and Remove All buttons.

Note When the During Import, Initially Place Files in Available Column check box is selected on the System page, the FDs from the COBOL source file are placed in the Available Files list instead of the Selected Files list (the default). This enables you then to select only those FDs you wish to include in the importing and merging process.


Available Files (Merge File Selection Page CBL RST)

The Available Files list contains a list of COBOL data file definitions available (but not selected) for importing (and merging) by the Relativity Designer. This list is created by specifying actions with the Add, Remove, Add All, and Remove All buttons.

Note When the During Import, Initially Place Files in Available Column check box is selected on the System page, the FDs from the COBOL source file are placed in the Available Files list instead of the Selected Files list (the default). This enables you then to select only those FDs you wish to include in the importing and merging processes.


Available Files (Merge File Selection Page COB)

The Available Files list contains a list of COBOL data file definitions available for importing (and merging) by the Relativity Designer. This list is created by specifying actions with the Add, Remove, Add All, and Remove All buttons.

Note When the During Import, Initially Place Files in Available Column check box is selected on the System page, the FDs from the COBOL source file are placed in the Available Files list instead of the Selected Files list (the default). This enables you then to select only those FDs you wish to include in the importing and merging processes.


Available Items (Table Wizard)

The Available Items list contains a list of all of the data items from the FD form that are not to be included in the new table.


Available Record Types

The Available Record Types list contains all of the record types associated with the file definition that are not already in use for this table. This list is updated by specifying actions with the Add, Remove, Add All, and Remove All buttons.


Back (Import Detected Errors Page)

The Back button returns to the first page of the Source Code Import wizard.


Back (Import File Selection Page COB RST)

The Back button returns to the first page of the Source Code Import wizard.


Back (Import File Selection Page COB)

The Back button returns to the first page of the Source Code Import wizard.


Back (Import Wizard MF COBOL)

The Back button is not enabled on the first page of the Source Code Import wizard.


Back (Import Wizard RM COBOL)

The Back button is not enabled on the first page of the Source Code Import wizard.


Back (Merge Detected Errors Page)

The Back button returns to the first page of the Source Code Merge wizard.


Back (Merge File Selection Page CBL RST)

The Back button returns to the first page of the Source Code Merge wizard.


Back (Merge File Selection Page COB)

The Back button returns to the first page of the Source Code Merge wizard.


Back (Merge Wizard MF COBOL)

The Back button is not enabled on the first page of the Source Code Merge wizard.


Back (Merge Wizard RM COBOL)

The Back button is not enabled on the first page of the Source Code Merge wizard.


Back (Table Wizard)

The Back button is not enabled.


Back (Table Wizard Edit)

The Back button returns to the first page of the Table wizard.


Back (Write Support Wizard)

The Back button is used to view the previous issue in the list. When the button is not enabled, the current issue is the first issue in the list.


Basics DSN See Also

ODBC-Enabled Applications

Trademark Acknowledgments


Binary Byte Storage Mode

When the Binary Byte Storage Mode check box is selected, BINARY usage (and other binary usages, such as COMP-4, COMP-5, and possibly COMP) are assumed to use byte storage mode. If this check box is not selected, binary usage items are assumed to use word storage mode.

Note In word storage mode, the same number of bytes is assigned regardless of whether the data item is signed or unsigned. In byte storage mode, the number of bytes assigned is dependent on whether the data item is signed or unsigned.


Bind Subscripts Form See Also

Adding Condition Items

Defining Columns on Repeating Data Items

Relational Definition Forms


Bind to Data Item (Bind Subscripts)

The Bind to Data Item button allows selection of a data-name for binding the subscript to a data item. After selecting the button, the list box in the Bind Subscripts form displays a list of numeric data item data-names from which the desired binding can be selected.


Bind to Literal (Bind Subscripts)

The Bind to Literal button allows selection of a condition-name for binding the subscript to the literal value associated with the selected condition-name. After selecting the button, the list box in the Bind Subscripts form displays a list of condition-names from which the desired binding can be selected.


Bound Subscripts (Table Form Column Property)

The Bound Subscripts property consists of a check box and a button:

· The Bound Subscripts check box appears if the selected column is associated with a repeating data item. If the Bound Subscripts check box is not selected, then none of the subscripts for the repeating data item are bound. In this case, a row will be generated in the table for every occurrence of the repeating data item. To associate the column with a particular occurrence of the repeating data item, select the check box to display the Bind Subscripts form.

· The Bound Subscripts button appears to the right of the Bound Subscripts check box. Choose the Bound Subscripts button to view or modify the options in the Bind Subscripts form for a column that already has bound subscripts.


Browse (Export DDL)

Click the Browse button to open the Select DDL Export File dialog box, where you can select the file format (by default, .ddl), and the name and location of the resulting output file.


Browse (Import Wizard MF COBOL)

The Browse button initiates a search for a file of the type indicated by the selected option, as follows:

· If the Import COBOL Source option is selected, the Browse button displays the Select COBOL Source dialog box for the selection of a .cbl file.

· If the Import Previously Compiled Symbol Table (.RST) option is selected, the Browse button displays the Select Symbol Table dialog box for the selection of an .rst file.

· If the Import Previously Compiled RM/COBOL Program (.COB) option is selected, the Browse button displays the Select RM/COBOL Program dialog box for the selection of a .cob file.


Browse (Import Wizard RM COBOL)

The Browse button initiates a search for a file of the type indicated by the selected option, as follows:

· If the Import COBOL Source option is selected, the Browse button displays the Select COBOL Source dialog box for the selection of a .cbl file.

· If the Import Previously Compiled Symbol Table (.RST) option is selected, the Browse button displays the Select Symbol Table dialog box for the selection of an .rst file.

· If the Import Previously Compiled RM/COBOL Program (.COB) option is selected, the Browse button displays the Select RM/COBOL Program dialog box for the selection of a .cob file.


Browse (Merge Wizard MF COBOL)

The Browse button initiates a search for a file of the type indicated by the selected option, as follows:

· If the Merge COBOL Source option is selected, the Browse button displays the Select COBOL Source dialog box for the selection of a .cbl file.

· If the Merge Previously Compiled Symbol Table (.RST) option is selected, the Browse button displays the Select Symbol Table dialog box for the selection of an .rst file.

· If the Merge Previously Compiled RM/COBOL Program (.COB) option is selected, the Browse button displays the Select RM/COBOL Program dialog box for the selection of a .cob file.


Browse (Merge Wizard RM COBOL)

The Browse button initiates a search for a file of the type indicated by the selected option, as follows:

· If the Merge COBOL Source option is selected, the Browse button displays the Select COBOL Source dialog box for the selection of a .cbl file.

· If the Merge Previously Compiled Symbol Table (.RST) option is selected, the Browse button displays the Select Symbol Table dialog box for the selection of an .rst file.

· If the Merge Previously Compiled RM/COBOL Program (.COB) option is selected, the Browse button displays the Select RM/COBOL Program dialog box for the selection of a .cob file.


Btrieve Key Import for filename Dialog Box See Also

Importing Btrieve Keys (Micro Focus COBOL Only)


Building a New Record See Also

Adding Condition Items

Building Writable Tables

Defining Null Information

Defining Record Types

Internal Functions


Building Tables, An Overview See Also

Files/Tables Report Features

Internal Functions


Building Writable Tables See Also

Defining Security for Relativity Catalogs

Establishing Table Connections

Table Form Toolbar

Write Support Wizard


Bypass Version Checking

Reserved for future use.


Byte Storage Mode

Byte storage mode is a memory assignment mode in which binary numeric data items are assigned the minimum number of bytes necessary to represent the number of decimal digits described by the PICTURE character-string for the data item. In this mode, the SYNCHRONIZED clause has no meaning and hence has no effect. The minimum number of bytes can be determined from the following chart:

Number of Digits (9s) in PICTURE character-string |  | Bytes of storage assigned
Signed | Unsigned | Byte Storage Mode
1-2 | 1-2 | 1
3-4 | 3-4 | 2
5-6 | 5-7 | 3
7-9 | 8-9 | 4
10-11 | 10-12 | 5
12-14 | 13-14 | 6
15-16 | 15-16 | 7
17-18 | 17-18 | 8


Cancel (Add COBOL Data Item Redefinition)

The Cancel button backs out of the Add COBOL Data Item Redefinition dialog box by canceling all selections made within the dialog box.


Cancel (Add Condition Item)

The Cancel button backs out of the Add Condition Item dialog box by canceling all entries made within the dialog box.


Cancel (Add Connections Matching)

The Cancel button closes the Add Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Cancel (Add Database Group)

The Cancel button backs out of the Add Database Group dialog box by canceling all entries made within the dialog box.


Cancel (Add Database User)

The Cancel button backs out of the Add Database User dialog box by canceling all entries made within the dialog box.


Cancel (Add Data Item Pattern)

The Cancel button backs out of the Add Data Item Pattern dialog box by canceling all selections made within the dialog box.


Cancel (Add Data Type)

The Cancel button backs out of the Add Data Type dialog box by canceling all selections made within the dialog box.


Cancel (Add File Label)

The Cancel button backs out of the Add File Label dialog box by canceling all entries made within the dialog box.


Cancel (Add Function Constant)

The Cancel button backs out of the Add Function Constant dialog box by canceling the selections made within the dialog box.


Cancel (Add Record Type)

The Cancel button backs out of the Add Record Type dialog box by canceling the record-name entry made within the box.


Cancel (Add Table Connection Regular)

The Cancel button backs out of the Add Table Connection dialog box by canceling all entries made within the dialog box.


Cancel (Assign or Remove Record Types)

The Cancel button backs out of the Assign or Remove Record Types dialog box by canceling all selections made within the dialog box.


Cancel (Change Catalog Owner)

The Cancel button backs out of the Change Catalog Owner dialog box by canceling all entries made in the dialog box.


Cancel (Change Password)

The Cancel button backs out of the Change Password dialog box by canceling all entries made within the dialog box.


Cancel (Choose Subscript Values)

Click the Cancel button to back out of the Choose Subscript Values dialog box and cancel the selections made within the dialog box.


Cancel Command Button (COBOL Types Options)

The Cancel button closes the Options dialog box without saving any changes.


Cancel Command Button (Data Source Options)

The Cancel button closes the Options dialog box without saving any changes.


Cancel Command Button (Date Formats Options)

The Cancel button closes the Options dialog box without saving any changes.


Cancel Command Button (File Options)

The Cancel button closes the Options dialog box without saving any changes.


Cancel Command Button (Item Patterns Options)

The Cancel button closes the Options dialog box without saving any changes.


Cancel Command Button (Privilege Options)

The Cancel button closes the Options dialog box without saving any changes.


Cancel Command Button (System Options)

The Cancel button closes the Options dialog box without saving any changes.


Cancel Command Button (Table Options)

The Cancel button closes the Options dialog box without saving any changes.


Cancel Command Button (User Types Options)

The Cancel button closes the Options dialog box without saving any changes.


Cancel (Copy File Label)

The Cancel button does not copy the file label item and closes the Copy File Label dialog box.


Cancel (Copy File Label Column)

The Cancel button does not copy the file label column and closes the Copy File Label Column dialog box.


Cancel (Copy Table)

The Cancel button backs out of the Copy dialog box by canceling all entries made within the dialog box.


Cancel (Create New Table)

The Cancel button backs out of the Create New Table dialog box by canceling the table name entered in the New Table Name box.


Cancel (Date Constants)

The Cancel button backs out of the Date Constants dialog box by canceling all selections made within the dialog box.


Cancel (Delete Connections Matching Pattern)

The Cancel button closes the Delete Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Cancel (Delete File Label)

The Cancel button does not delete the file label items and closes the Delete File Label dialog box.


Cancel (Delete File Label Column)

The Cancel button does not delete the file label columns and closes the Delete File Label Column dialog box.


Cancel (Describe Filter Subexpression)

The Cancel button backs out of the Describe Filter Subexpression dialog box by canceling all selections made within the dialog box.


Cancel (Edit Connections Matching Pattern)

The Cancel button closes the Edit Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Cancel (Edit Data Item Pattern)

The Cancel button backs out of the Edit Data Item Pattern dialog box by canceling all selections made within the dialog box.


Cancel (Edit Default Column Names)

The Cancel button backs out of the Edit Default Column Names dialog box by canceling all entries made within the dialog box.


Cancel (Edit Group Dialog)

The Cancel button backs out of the Edit Group dialog box by canceling all entries made within the dialog box.


Cancel (Edit Selected Table Connections)

The Cancel button closes the Edit Selected Table Connections dialog box and cancels all entries made within the dialog box.


Cancel (Edit User Dialog)

The Cancel button backs out of the Edit User dialog box by canceling all entries made within the dialog box.


Cancel (Export DDL)

The Cancel button cancels all selections and closes the Export DDL dialog box.


Cancel (Export Preferences)

The Cancel button terminates the selections and returns to the Data Source page in the Options dialog box.


Cancel (Find FD)

Click the Cancel button to close this dialog box.


Cancel (Function of Function)

The Cancel button terminates the function argument selection and closes the Function of Function dialog box.


Cancel (Import Detected Errors Page)

The Cancel button unloads the Source Code Import wizard without importing a source code file or previously compiled symbol table/object file.


Cancel (Import File Selection Page COB RST)

The Cancel button unloads the Source Code Import wizard without importing a source code file or previously compiled symbol table/object file.


Cancel (Import File Selection Page COB)

The Cancel button unloads the Source Code Import wizard without importing a source code file or previously compiled symbol table/object file.


Cancel (Import Wizard MF COBOL)

The Cancel button unloads the Source Code Import wizard without importing a source code file or previously compiled symbol table/object file.


Cancel (Import Wizard RM COBOL)

The Cancel button unloads the Source Code Import wizard without importing a source code file or previously compiled symbol table/object file.


Cancel (Invalid Column Name)

The Cancel button backs out of the Invalid Column Name dialog box by canceling all entries made in the dialog box.


Cancel (Logon)

The Cancel button backs out of the Logon dialog box by canceling all entries made in the dialog box.


Cancel (Merge Detected Errors page)

The Cancel button unloads the Source Code Merge wizard without importing a file for the merge procedure.


Cancel (Merge File Selection Page CBL RST)

The Cancel button unloads the Source Code Merge wizard without importing a source code file or previously compiled symbol table/object file for the merge procedure.


Cancel (Merge File Selection Page COB)

The Cancel button unloads the Source Code Merge wizard without importing a source code file or previously compiled symbol table/object file for the merge procedure.


Cancel (Merge Wizard MF COBOL)

The Cancel button unloads the Source Code Merge wizard without importing a source code file or previously compiled symbol table/object file for the merge procedure.


Cancel (Merge Wizard RM COBOL)

The Cancel button unloads the Source Code Merge wizard without importing a source code file or previously compiled symbol table/object file for the merge procedure.


Cancel (Open Relativity Data Source)

The Cancel button backs out of the Open Relativity Data Source dialog box by canceling the selections made within the dialog box.


Cancel (Printer Choice)

The Cancel button backs out of the Printer Choice dialog box by canceling the selections made within the dialog box.


Cancel (Print Options)

The Cancel button cancels the operation so the job is not sent to the printer or export module.


Cancel (Rename)

The Cancel button backs out of the Rename file dialog box by canceling the entry of a new name.


Cancel (Resolve Merge Differences)

The Cancel button returns to the Resolve Merge Differences dialog box without reprocessing the merged (new) COBOL file definitions.


Cancel (Resolve Merge Differences)

The Cancel button causes the merging process to be abandoned. Choosing the Cancel button is identical to clicking Abort Merge on the toolbar.


Cancel (Save Export File As)

The Cancel button closes the Save Export File As dialog box without saving any changes you have made.


Cancel (Select 01's)

The Cancel button backs out of the Select 01's dialog box by canceling the selections made within the dialog box.


Cancel (Select Character Set)

The Cancel button backs out of the Select Character Set dialog box by canceling the selections made within the dialog box.


Cancel (Select COBOL Source)

The Cancel button backs out of the Select COBOL Source dialog box by canceling the selections made within the dialog box.


Cancel (Select Data Type)

The Cancel button backs out of the Select Data Type dialog box by canceling the selections made within the dialog box.


Cancel (Select Function)

The Cancel button backs out of the Select Function dialog box by canceling the selections made within the dialog box.


Cancel (Select Report)

The Cancel button backs out of the Select Report dialog box by canceling the selections made within the dialog box.


Cancel (Select RM/COBOL Program)

The Cancel button backs out of the Select RM/COBOL Program dialog box by canceling the selections made within the dialog box.


Cancel (Select Symbol Table)

The Cancel button backs out of the Select Symbol Table dialog box by canceling the selections made within the dialog box.


Cancel (Select Table Connection to Show)

The Cancel button backs out of the Select Table Connection to Show dialog box by canceling all entries made within the dialog box.


Cancel (Set Default Value)

The Cancel button backs out of the Set Default Value dialog box by canceling all entries made within the dialog box.


Cancel (Table Wizard)

The Cancel button unloads the Table wizard without creating a table.


Cancel (Table Wizard Edit)

The Cancel button unloads the Edit page of the Table wizard without creating a table.


Cancel (Welcome to Relativity Window)

The Cancel button cancels all selections and closes the Welcome to Relativity window.


Case Sensitive (Find Table)

The Case Sensitive option distinguishes between uppercase and lowercase characters. When this option is selected, Relativity finds only those instances in which the capitalization matches the text you typed in the Find What box.


Catalog Expires Area (Data Source Options)

By selecting the Catalog Expires check box and entering an expiration date in the Date box, you can make access to a catalog unavailable after a specified date. By default, the date entered in the Date box is the current date. You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format.

Note The catalog expiration date feature does not affect the catalog owner's access to the catalog.


Catalog Ownership See Also

Database Administration

Defining Catalog Ownership

Defining Group Privileges

Defining Groups and Users


Categories of DSNs

ODBC introduced the differentiation of data source names (DSNs) beginning in version 2.5. DSNs are divided into three categories: User, System, and File.

· User DSNs are local to a computer and may be used only by the current user.

· System DSNs are local to a computer rather than dedicated to a user. The system, or any user having privileges, can use a data source set up with a system DSN.

· File DSNs are file-based data sources that may be shared among all users who have the same Relativity DBMS installed, which means they have access to the database. File DSNs need not be dedicated to a user or local to a computer.


Change Catalog Owner Dialog Box See Also

Catalog Ownership

Defining Catalog Ownership


Change Password Dialog Box See Also

Defining Groups and Users

Change a group password

Change a user password


Change (Print Options)

The Change button displays the Printer Choice dialog box, which allows you to specify a different printer.


Changes Detected

The Changes Detected box lists changes between the updated data file and the existing data file.


Character Set

In the Character Set box, type, or select from the list, the code pages that are known by Relativity. The defined code page number for each character set will be displayed to the right in parentheses. Relativity supports the following standard character sets:

Windows Latin 1 | MS-DOS Cyrillic CIS-1 | MS-DOS Hebrew
Windows Latin 2 | MS-DOS Turkish | EBCDIC US Canada
Windows Latin 5 | MS-DOS Portuguese | EBCDIC International
Windows Cyrillic | MS-DOS Icelandic | EBCDIC Greek
Windows Greek | MS-DOS French Canada | EBCDIC Latin 5 Turkish
Windows Baltic Rim | MS-DOS Greek | ISO 8859-1
Windows Hebrew | MS-DOS Greek 1 | ISO 8859-2
Windows Arabic | MS-DOS Greek 2 | ISO 8859-5
MS-DOS Latin US | MS-DOS Baltic Rim | ISO 8859-6
MS-DOS Latin 1 | MS-DOS Russian | ISO 8859-7
MS-DOS Latin 2 | MS-DOS Arabic | ISO 8859-8
MS-DOS Cyrillic | MS-DOS Arabic ASMO |


Character Set and Euro Columns (Character Set Maintenance)

In this area, the Character Set column lists all the character sets used in the data source.

The Euro column shows the value that is used to represent the Euro character for the selected character set in the COBOL data file. The value must be a number between decimal 0 and 255 (hexadecimal 0x00 and 0xff).


Character Set Maintenance Dialog Box See Also

Maintaining Character Sets


CHARSET"string"

The CHARSET"string" directive specifies the native character set of the environment, where string is either ASCII or EBCDIC.


Choose Subscript Values Dialog Box See Also

Adding Condition Items

Defining Columns on Repeating Data Items

Specifying Treatment of the OCCURS Clause


Clear Filter (Record Type Toolbar)

The Clear Filter button removes every filter expression listed in the Record Type Properties form.


Clear Filter (Table Filter Properties)

The Clear Filter button removes all filter expressions listed in the Table Filter Properties form.


Close (Bind Subscripts)

The Close button exits the Bind Subscripts form and removes the image from the Relativity Designer window.


Close Button (Record Type Toolbar)

The Close button closes this window and retains any changes that you may have made.


Close Button (SQL Window)

The Close button is used to dismiss the SQL window. You also can click Close in the upper-right corner of the title bar.


Close (Edit Connections Form)

The Close button closes the Edit Connections form and saves any changes you may have made.

Shortcut: Ctrl+F4


Close (Edit Item Sets Form)

The Close button closes this form and retains any changes that you may have made.


Close (Edit Privileges Form)

The Close toolbar button closes the Edit Privileges form. However, if you have made any changes to the form, a message box appears prompting you to commit the privilege changes:

· Selecting Yes accepts the changes and then closes the form.

· Selecting No closes the form without applying any of the changes.

· Selecting Cancel ignores any changes and leaves the form open.

Shortcut: Ctrl+F4


Close (Edit Users Form)

The Close button closes the Edit Users form and saves any changes that you may have made.

Shortcut: Ctrl+F4


Close (Find Table)

The Close button closes these dialog boxes and retains any changes that you may have made.


Close (Import From Another Relativity Data Source)

The Close button terminates the Import from Another Relativity Data Source dialog box without further action.


Close (Merge Details)

The Close button dismisses the Merge Details dialog box. (The Close option appears on the dialog box if you click the Details button on the Resolve Merge Differences dialog box.)


Close (Table Filter Properties)

The Close button closes the Table Filter Properties form and retains any changes that you may have made.


Close Window Button (Show Table Contents)

The Close button is used to dismiss the Show Table Contents form.

Alternatively, you can open a pop-up context menu of the commands available for the Show Table Contents form by right-clicking in the form. From the context menu, choose the command you need. Note that the Close button provides the same functionality as the Close command on the context menu.


Close Window (Query)

Use the Close button to dismiss the Query Builder form. You also can click Close in the upper-right corner of the title bar.


Close (Write Support Wizard)

The Close button is used to return to the Write Support dialog box. No changes are made while the Write Support wizard is loaded, so there is nothing that needs to be saved.


Closing a Data Source See Also

Configuring a Relativity Data Source


COBOL Definition Forms See Also

Administration Forms

Catalog Window

Files Catalog Object

Options Dialog Box

Relational Definition Forms


COBOL File

The COBOL File box displays the filename of the COBOL file containing the level 01 entries.


COBOL Name (FD Form Attributes)

The COBOL Name attribute is the name of the FD entry and the data description entries for each record in the COBOL file. The following items are displayed as the COBOL Name attributes for data items in the FD form.

· FD level indicator followed by a COBOL filename.

· Level-number 01 followed by a COBOL record-name.

· Level-number 02 and above followed by the COBOL data-name of a group data item or elementary data item.

· Function items defined by f : followed by the name of the internal function.

· A subscript item defined by si followed by the text SubscriptItem.

Indentation of the abbreviated data descriptions gives a visual representation of the hierarchical structure of the data items contained in the record.


COBOL Program

The COBOL Program box displays the name of the COBOL program containing the level 01 entries.


COBOL Types Options See Also

Redefining Data Items

Setting Options

Tools Menu Commands


Column All

The Column ALL privilege is a shortcut method of assigning all the Column privileges (SELECT, INSERT, UPDATE, and REFERENCES) at one time. When the Column:ALL privilege is selected, the column names associated with the selected table are displayed in the leftmost applicable column; that is, if any Column privilege is not granted, the column names are displayed in the Not Granted column (but some individual privileges may be granted). If any Column privilege is not granted with grant, then column names are displayed in the Granted column (but some individual privileges may be granted with grant). Finally, if all Column privileges are granted with grant, column names are displayed in the With Grant column.

When Column:ALL is selected, a column name can be moved from the Not Granted column to the Granted column in order to grant all the individual Column privileges for the selected table to the selected group. Then the user may select an individual Column privilege, for example, Column:select, and move the same column name from the Granted column to the With Grant column. If the user then selects the Column:ALL privilege again, that column name will still be displayed in the Granted column (not the With Grant column), even though the group has with grant privilege for the Column:select privilege.

Then, the user may select an individual Column privilege, for example, Column:insert, and move the same column name from the Granted column to the Not Granted column. In this case, if the user then selects the Column:ALL privilege again, that column name will be displayed in the Not Granted column, even though the group still has the privileges other than Column:insert for the table. This is because the group no longer has all Column privileges for the table.

Moving a column name from the Granted column to the Not Granted column when Column:ALL is selected resets all the Column privileges to Not Granted (including any individual Column privileges that were assigned With Grant).


Column List (Query)

In the Query Builder area, the Column List displays all the column definitions (displayed in the Column Name attribute in the selected table). This is the area where you specify the information you want in your query. To add these column names to the active query, simply drag the column name directly from the list to a cell in the Column row in the query design grid. Alternatively, you can double-click a column name in the list to move it to the Column row. If you use this latter method, the column name is automatically added in the next available column. By default, adding a column name from this list to the Column row also displays the condition True in the Show row.


Column Name Case (FD Form Toolbar)

The Column Name Case button toggles the case used when converting data-names and condition-names in the FD to default column names.

If this button is selected, the default column names are all uppercase. If this button is not selected, the default column names are mixed case or lowercase depending on whether the Column Name Hyphen button is selected.

This button does not affect any default column name that has been manually edited in the FD form or globally edited using the Edit Default Column Names dialog box.

Note This button is present only in the detailed FD view (see the Magnify button on the FD form toolbar).


Column Name Global Edit (FD Form Toolbar)

The Column Name Global Edit button displays the Edit Default Column Names dialog box for editing default column names using pattern matching and replacement. The editing can be applied to the default column names for selected items in the FD form or for all items in the FD form.

Note This button is present only in the detailed FD view (see the Magnify button on the FD form toolbar).


Column Name Hyphen (FD Form Toolbar)

The Column Name Hyphen button toggles the treatment of hyphens that is necessary when converting data-names and condition-names in the FD to default column names because SQL column names cannot contain hyphens:

· If this button is selected, the default column names are derived by replacing hyphens with underscores. When hyphens are replaced by underscores and the Column Name Case button is not selected, default column names are all lowercase.

· If this button is not selected, the default column names are derived by deleting hyphens. When hyphens are deleted and the Column Name Case button is not selected, the default column names are mixed case, with capitalization of the first letter and each letter that followed a hyphen.

This button does not affect any default column name that has been manually edited in the FD form or globally edited using the Edit Default Column Names dialog box.

Note This button is present only in the detailed FD view (see the Magnify button on the FD form toolbar).


Column Name (Invalid Column Name)

The Column Name box allows you to enter a unique column name.


Column Name (Show Indexes)

The Column Name column indicates the column in the relational table that participates in the index. In each index, there will be one row for each column in the index.


Column Names (Table Wizard Edit)

The Column Names list contains a list of all of the columns and is displayed to show the results of any editing that is done.


Column Name (Table Form Attributes)

In the Table form, the Column Name attribute is the name assigned to a column in the relational table. The column name is initially generated from the Default Column Name attribute in the FD form and may be edited. Column names may not be an SQL reserved word.


Column Properties Area (Data Types Form)

The following list is a summary of the Column Properties (located in the lower left portion of the form) available for a selected Type attribute in the Data Types form.

Transform

The Transform property specifies transformation of a COBOL data item value to/from a relational database column value. The transform is changed by selecting from the list. This transform attribute is in addition to any transform attribute assigned to the COBOL data-item in the FD form. This transform can only be specified if Enable Column Transforms check box is selected on the Date Formats page in the Options dialog box.

Length

The Length property specifies the number of characters in an alphanumeric data item.

Digits

The Digits property specifies the number of digits in a numeric data item.

Decimal Places

The Decimal Places property specifies the number of digits to the right of the decimal point in a numeric data item.

Nullable

The Nullable property indicates that this data type defines columns that allow nulls.

Unsigned

The Unsigned property indicates that the data type does not have a sign.

Constrained

The Constrained property limits the value that a column may have during an INSERT or UPDATE operation to one of the true values indicated by an 88-level condition-name defined on the data item associated with the column. The user may add 88-level condition-names if the program does not have them. For more information, see Building a New Record.


Column Row (Query)

In the query design grid, the Column row adds a column name to the results of the query. To add a column name, double-click the column's name in the Column List or drag the column name to this row. By default, the Show row is also displayed.


CombineDateTime Internal Function

The CombineDateTime internal function allows two data items to be combined into a single date/time stamp value. The first argument should be a date data item. The second argument should be a time data item.

The YYYYMMDDHHMMS transform may be applied to resulting data item.


Comment (Data Types Form)

In the Data Types form, the Comment attribute contains comments pertaining to the user data type being defined.


Comment (FD Form Attributes)

In the expanded FD form, the Comment attribute contains comments pertaining to the data item defined by this row in the FD form. The comment is changed by clicking in the grid cell. The Comment attribute column is displayed in the FD form only if the Show Comments check box is selected on the File page in the Options dialog box. See Specifying Comments.

This attribute is totally owned by the catalog developer for use in the Relativity Designer and through reports. It is a good place to maintain a user-friendly definition of the data item. Through the reporting tool, this comment could then be used to build a help file for the end-user of the catalog. Another use of this attribute might be to discuss the uses of a data item that may not be obvious.


Comment (FD Properties)

In the Properties area of the FD Properties form, the Comment box displays the comments, if any, associated with the selected FD.


Comments

The Comments area is a free-format text field that will be stored inside the catalog. The Relativity Designer will display the comment on its Help About form, if there is a comment. One possible use for this text field would be catalog version information.


Comment (Table Form Attributes)

Note The Comment attribute is displayed in the Table form only if the Show Comments check box is selected on the Table page in the Options dialog box.

The Comment attribute contains comments pertaining to the data item defined by this row in the Table form. If the Inherit FD Comments check box is selected on the Table page in the Options dialog box, then the comments in the FD form are moved with the data item to the Table form. See Specifying Comments.

This attribute is totally owned by the catalog developer for use in the Relativity Designer and through reports. It is a good place to maintain a user-friendly definition of the column. Through the reporting tool, this comment could then be used to build a help file for the end-user of the catalog. Another use of this attribute might be to discuss the uses of the column that may not be obvious.


COMP-3

When exporting an FD, selecting the COMP-3 check box causes the file to be exported with the USAGE IS COMP-3 clause specified for data items having the packed decimal data type. If this option is not selected, the file is exported with the USAGE IS PACKED-DECIMAL clause specified for data items having the packed decimal data type.


COMP-6"integer"

The COMP-6"integer" directive specifies binary (integer=1) or packed-decimal (integer=2) representation for COMP-6 data items. The binary representation allocation size is not affected by the IBMCOMP directive. The default is 2 (packed-decimal) for DOS and Windows, but is 1 (binary) for UNIX. Note that there is an undocumented dependency that the RM and RM"ANSI" directives set COMP-6"1" immediately on DOS and Windows, but not on UNIX.


COMP-6 (Packed, No Sign)

When the COMP-6 (Packed, No Sign) check box is selected, the catalog includes the unsigned packed COBOL data type described by the USAGE IS COMP-6 clause.

Note COMP-6 (Packed, No Sign) data types will appear in the Item Type list in the Add COBOL Data Item Redefinition dialog box only if the Micro Focus Types check box is selected.


Compiler Options (Import Wizard RM COBOL)

The Compiler Options option allows you to enter RM/COBOL Compile Commands to control the compilation process. Note that the Compiler Options option is disabled unless Import COBOL Source is selected and RM/COBOL is selected in the Dialect list box.

The RM/COBOL Compile Command options must be preceded by a hyphen. The following RM/COBOL Compile Commands are pertinent to Relativity (see the RM/COBOL User's Guide for more information):

G Designates a file to be used as the compiler configuration.

H Designates a file as a supplement to the compiler configuration.

S Assumes a separate sign when the SIGN clause is not specified for a DISPLAY usage, signed numeric data item.

U Assumes an alternative usage for data items described as COMP or COMPUTATIONAL.

B Defines as binary sequential those sequential files not explicitly declared to be line sequential in their file control entries.

V Defines as line sequential any sequential file not declared to be binary sequential.


Compiler Options (Merge Wizard RM COBOL)

The Compiler Options option allows you to enter RM/COBOL Compile Commands to control the compilation process. Note that the Compiler Directives option is disabled unless Merge COBOL Source is selected.

The RM/COBOL Compile Command options must be preceded by a hyphen. The following RM/COBOL Compile Commands are pertinent to Relativity (see the RM/COBOL User's Guide for more information):

G Designates a file to be used as the compiler configuration.

H Designates a file as a supplement to the compiler configuration.

S Assumes a separate sign when the SIGN clause is not specified for a DISPLAY usage, signed numeric data item.

U Assumes an alternative usage for data items described as COMP or COMPUTATIONAL.

B Defines as binary sequential those sequential files not explicitly declared to be line sequential in their file control entries.

V Defines as line sequential any sequential file not declared to be binary sequential.


Complement Internal Function

The Complement internal function performs a conditional arithmetic complement on a data item. The first argument is the data item to be conditionally complemented. The second argument is an 88-level condition-name. If the condition-name is true, the function returns the complement of the value of the first argument. If the condition-name is false, the function returns the value of the first argument.


Components to Export

Under Components to Export:

· Selecting All causes all subsequent exports of an FD to include the following:

-  File description entry.

-  Level 01 data description entries subordinate to the file description entry.

-  Data description entries subordinate to the included level 01 data description entries.

· Selecting No FD causes all subsequent exports of an FD to include the following:

-  Level 01 data description entries subordinate to the file description entry.

-  Data description entries subordinate to the included level 01 data description entries.

· Selecting No 01, FD causes all subsequent exports of an FD to include all the data description entries subordinate to the file description entry, but not including the level 01 data description entries.

Note This option generally is not appropriate if your file definitions contain multiple level 01 data description entries.


ComputeCenturyDate Internal Function

The ComputeCenturyDate internal function computes a date from data items and/or constants containing the century, the year of the century, the month, and the day of the month or year. When a constant zero is supplied for the month, ComputeCenturyDate computes a date from data items and/or constants containing the year and the days of the year.

The YYYYMMDD transform may be applied to resulting data item.


ComputeCenturyDateTime Internal Function

The ComputeCenturyDateTime internal function computes a date and time data item from data items and/or constants containing the century, the year, the month, the day of the month or year and optional data items or constants containing the hour or the day, the minute of the hour, the second of the minute, and the hundredth of the second.

The YYYYMMDDHHMMSShh transform may be applied to the resulting data item.


ComputeDate Internal Function

The ComputeDate internal function computes a date from data items and/or constants containing the year, the month, and the day of the month. When a constant zero is supplied for the month, ComputeDate computes a date from data items and/or constants containing the year and the days of the year.

The YYYYMMDD transform may be applied to resulting data item.


ComputeDateTime Internal Function

The ComputeDateTime internal function computes a date and time data item from data items and/or constants containing the year, the month, the day of the month or year and optional data items or constants containing the hour or the day, the minute of the hour, the second of the minute, and the hundredth of the second.

The YYYYMMDDHHMMSShh transform may be applied to the resulting data item.


ComputeODO Internal Function

The ComputeODO internal function computes an occurrence count from the record length, the record offset of the (single) argument, and the length and span of the argument. The argument must be a repeating data item at the end of the record.

The function accepts one argument. The argument is a repeating data item. This function exists for the situation in which the repeating item is declared to have a fixed number of occurrences, but it really has a variable number of occurrences. The function computes the occurrence count from the record length. The only place it should be used is in conjunction with the ODO button in the Relativity Designer.

For example:

FD VARIABLE-FILE RECORD IS VARYING IN SIZE FROM 22 TO 40
CHARACTERS DEPENDING ON VARIABLE-LENGTH.

01 VARIABLE-RECORD.
03 SOME-MISC-STUFF PIC X(20).
03 A-REPEATING-ITEM OCCURS 10 TIMES.
05 ANOTHER-ONE PIC X.
05 AND-ONE-MORE PIC 9.

In this example, the record contains one to ten occurrences of A-REPEATING-ITEM, but the item is declared as a fixed number of occurrences. The ComputeODO function would take A-REPEATING-ITEM as its argument and compute the occurrences from the record length. For example, if a particular record were 28 bytes long, the value of the function would be four (4).


ComputeTime Internal Function

The ComputeTime internal function computes a time data item from data items and/or constants containing the hour of the day, the second of the minute, and the hundredth of the second.

The HHMMSShh transform may be applied to the resulting data item.


Condition Item (Describe Filter Subexpression)

From the Condition Item list, select the condition item for the filter subexpression of the filter expression being defined.


Condition (Record Type Toolbar)

The Condition attribute specifies the condition-name of the condition for the filter subexpression of the filter expression being defined. To view an example, click here.


Condition (Table Filter Properties)

The Condition attribute specifies the condition-name of the condition for the filter subexpression of the filter expression being defined.


Configuring a Relativity Data Source See Also

Data Source Options

Defining Groups and Users


Configuring Reports for Relativity DBA See Also

Exporting Data to a Comma-Separated File

Report Definition Files

Reporting


Connection Menu Commands See Also

Establishing Table Connections

Pattern Matching


Connections Area (Select Table Connection to Show)

The Connections list area displays all table connections for the selected table definition. Select the correct table connection and then press Select.


Connections Command Button (Tables Tab)

The Connections button displays the Edit Connections form for the selected table. If a table is not selected in the Tables area list, the Connections button is disabled.

Note The Connections command on the Security menu provides the same functionality as the Connections button. If you choose the Connections command from the Security menu without first selecting a table on the Tables tab, however, the Edit Connections form lists all the tables currently defined in the catalog.


Connections Report Features See Also

Connections by Table Name Report

Establishing Table Connections

Reporting


Constrain

The Constrain attribute limits the value that a column may have during an insert or update to one of the true values indicated by an 88-level condition-name defined on the data item associated with the column. You may add 88-level condition-names if the program does not have them.


Copy (Copy Table)

The Copy button completes the Copy dialog box by accepting the new table name and closing the dialog box.


COPYEXT"string"

The COPYEXT"string" directive specifies the list of extensions, comma separated, to be used when searching for a copy file where the text-name specified in the COPY statement does not contain an extension. The OSEXT directive value overrides the first entry in the list. If a name without an extension is to be searched for "as is", an empty entry must occur somewhere in the list. This directive is documented by Micro Focus COBOL as being allowed in $SET statements only if they are initial $SET statements. Micro Focus actually allows the directive anywhere in the source, and it affects all COPY statements that follow until another COPYEXT directive is specified.

As part of implementing the COPYEXT directive, the copy file open algorithm was modified to use the directory search sequence specified by Micro Focus COBOL, including use of the COBCPY environment variable to specify directory search path(s).

For DOS, Windows, and OS/2, the default is "cbl,cpy," (the Micro Focus COBOL documentation incorrectly omits the last comma); that is, search for the file with the extension ".cbl", then the extension ".cpy", and then the file without an extension. On DOS and Windows, only the value set by the OSEXT directive is used to search for the main source file.

For UNIX, the default is ",cbl,cpy"; that is, search for the file without an extension, then for the file with the extension ".cbl", and then the extension ".cpy". On UNIX, the first entry in COPYEXT overrides OSEXT immediately, OSEXT overrides the first entry in COPYEXT immediately, and the full value of COPYEXT is used to search for the main source file as well as copy files.


Copy File Label Column Dialog Box See Also

Copy file label items and columns to other FDs and tables

Supporting Multi-File Tables


Copy File Label Dialog Box See Also

Copy file label items and columns to other FDs and tables

Supporting Multi-File Tables


Create Multiple Columns

If the Create Multiple Columns option is selected, selected occurrences of the subscripted data item will appear as separate columns in the table. The Choose Subscript Values dialog box will be displayed after clicking OK if this option is selected. The Choose Subscript Values dialog box allows selection of the occurrences for which columns are desired.


Create Multiple Rows

If the Create Multiple Rows option is selected, each occurrence of the subscripted data item will appear as a separate row in the table.

Note If the necessary condition items (as described in Flattening OCCURS) have not been defined, you can select the Create Multiple Rows option. This selection can later be modified by use of the Bound Subscripts control in the Column Properties area in the Table form for the column associated with the repeating data items. Selecting the Create Multiple Rows option and later using the Bound Subscripts controls is also necessary if the subscript binding is to a numeric data item value rather than to a constant.


Creating a COBOL Schema File See Also

Importing COBOL Definitions

Preparing COBOL Files for Relativity


Creating and Editing Table Definitions See Also

Defining Columns on Repeating Data Items

Defining Table Filters

Defining Transforms on Columns

Establishing Table Connections

Handling Multiple Record Types

Previewing Table Data

SQL Reserved Words

Using the Table Wizard


Criteria Row (Query)

In the query design grid, the Criteria row contains one or more criterion expressions for determining which records will be included in the query results. Any expressions you enter in this row instruct Relativity to show only those records that satisfy the criteria.

To enter criteria in the query, click the first Criteria cell for the column name you want to set criteria for and type the criteria expression. Note that all text and dates must be entered between single quotes.


Criterion Expressions (Query)

When building an entry in the Criteria row of the Query Builder form, you can use any expression that evaluates to a single value, True or False. An expression is any combination of operators, literal values, and names of columns.

The most commonly used conditions for numeric and date columns are the comparison operators, as defined below:

Operators | Definition
> | Greater than
> | Less than
= | Equal to
>= | Greater than or equal to
<= | Less than or equal to
<> | Not equal to
Between | Numeric range

You can also use the logical operators And, Or, and Not. If two expressions are connected by And, the operation is true only if both expressions are true. By contrast, the Or operation is true if either one or both of the expressions are true. The Not operation yields the opposite of the expression it modifies--true if the expression is false, or false if the expression is true. You can use the logical operators to combine the values of two comparison expressions.

For example, to search for dates from March 31, 1999 through January 1, 2000 for the KEY1_DATE column name:

> '1999-03-31' AND KEY1_DATE < '2000-01-01'

The following examples illustrate how to search for dates:

= '1999-03-31'

> '1999-03-31'

< '1999-03-31'

The following examples illustrate how to search for integer or decimal numeric values:

> 250

> 250.00


CURRENCY-SIGN"integer"

The CURRENCY-SIGN"integer" directive specifies the default currency symbol in the absence of a CURRENCY SIGN clause in the source program. A CURRENCY SIGN clause in the source program overrides the currency symbol set by the CURRENCY-SIGN directive. The parameter integer is the decimal character code for the desired character, such as 36 for the ASCII $ character.


Current Owner

The Current Owner box contains the name of the current owner of the catalog. If there is no current owner, the Current Owner box contains the text, < No Owner >.


Database Administration See Also

Catalog Ownership

Defining Group Privileges

Defining Groups and Users


Data File Format

The Data File Format list indicates the data file format that is to be used to open Micro Focus COBOL indexed files. The Micro Focus file manager must know the format of the indexed file so that the proper indexed file support can be used. The valid values are < none >, BTRIEVE, C-ISAM, LEVELII COBOL, IDX4, IDX8, and Default. For more information about how Relativity determines which indexed file format to request, click here.

Note This option applies only to Relativity for Micro Focus COBOL. It will not appear in the Data Source page unless the Micro Focus Types box is selected in the COBOL Types page.


Data Item (Select Data Type)

The Data Item area displays a COBOL data item in the FD that matches the criteria for more than one item pattern.


Data Item (Table Form Attributes)

The Data Item attribute is the COBOL data-name in the record description associated with the column. This is the same COBOL data-name that appears as the COBOL Name attribute in the FD form.


Data-Name Condition-Name (Bind Subscripts)

The Data-Name/Condition-Name attribute is selected from the list containing either data-names or condition-names. The selected data-name or condition-name specifies the occurrence of the desired data item within a table defined in the FD form.


Data Source Name (Open Relativity Data Source)

In the Data Source Name list, select the name of the data source for processing by Relativity.


Data Source Name (System Options)

The Data Source Name option displays the name of the data source being processed by the Relativity Designer.


Data Source Options See Also

Configuring a Relativity Data Source

Determining Micro Focus COBOL Indexed File Formats

Importing COBOL File Definitions

Setting Options

Tools Menu Commands

Transforms


Data Type (Item Patterns Form)

The Data Type attribute is the data type of the COBOL data item. A value of N/A implies that the Data Type attribute is not used when qualifying data items for this user data type.


Data Type Name (Add Data Type)

In the Data Type Name box, type the name to be assigned to the user data type. This data type name will appear in the lists of data types in the Table form and the FD form. This data type name must be unique.


Data Types Form See Also

Defining Item Patterns

Defining User Data Types

Transforms


Data Type (Table Form Attributes)

The Data Type attribute is either the user data type or the ODBC data type associated with the column defined by this row in the Table form.

Selecting the Data Type attribute in the Table form causes the display of a down arrow indicating a list. The content of the Data Type list is limited to the database data types appropriate for the COBOL data item. Within this list, the user data types appear in normal font. The pre-assigned data type names for the ODBC data type appear in a bold font.

The following lists the data type names pre-assigned to ODBC data types in Relativity:

· Exact numeric data types are bit, smallint, integer, and decimal.

· Approximate numeric data types are single and double.

· Character (or text) data types are char, varchar, and longvarchar.

· Unstructured binary data type is longvarbinary.

· Date/time data types are date, time, and timestamp.

User data types are defined in the Data Types form. The Data Types form allows the user to define characteristics of a data type that is used frequently in the COBOL files forming the database. The definition of user data types controls the consistency of data descriptions throughout the database.


Date Constants Dialog Box See Also

Date Formats Options

Defining Date Constants

Transforms

User-Configurable Date Transforms

Using Functions and Transforms


Date Formats Options See Also

Defining Date Constants

Setting Options

Tools Menu Commands

Transforms

Using Functions and Transforms


Date/Time Compiled (Import File Selection Page COB RST)

The Date/Time Compiled area indicates the date and time on which the selected source file was last compiled.


Date/Time Compiled (Import File Selection Page COB)

The Date/Time Compiled area indicates the date and time on which the selected source file was last compiled.


Date/Time Compiled (Merge File Selection Page CBL RST)

The Date/Time Compiled area indicates the date and time on which the selected source file was last compiled.


Date/Time Compiled (Merge File Selection Page COB)

The Date/Time Compiled area indicates the date and time on which the selected source file was last compiled.


'Days' Base Date

The 'Days' Base Date is changed either by typing or clicking on the arrows to indicate the year, month, and day for the date constant 'Days' Base Date. This date constant specifies the date used to interpret date values that represent an integer number of days from a base date in the Gregorian calendar. The default base Year is 1899. The default base Month is 12. The default base Day is 30. Using the default, an integer value of zero in the COBOL data item thus represents the date 30 December 1899, and an integer value of two in the COBOL data item represents the date January 1, 1900. Negative values are allowed in a signed COBOL data item to represent dates prior to the specified base date.


Debug (Import Wizard MF COBOL)

The Debug option causes the selected source code file to be processed as if the WITH DEBUGGING MODE clause was specified in the SOURCE-COMPUTER paragraph; that is, debug lines will be processed as source lines rather than comment lines.

Note The Debug option is disabled unless Import COBOL Source is selected.


Debug Log (System Options)

This check box appears on the System page only when you have modified the [Designer] section of the RELDBDSN.INI file by changing the value of the DebugLog= entry to YES.

Note This option is used for debugging purposes and runs the Relativity Designer in trace mode. It should be enabled only when directed by a Liant technical support analyst.


Debug (Merge Wizard MF COBOL)

The Debug option causes the selected source code file to be processed as if the WITH DEBUGGING MODE clause was specified in the SOURCE-COMPUTER paragraph; that is, debug lines will be processed as source lines rather than comment lines.

Note The Debug option is disabled unless Merge COBOL Source is selected.


DEC COBOL Types

Select the DEC COBOL Types check box to include DEC COBOL data types in the list of data types displayed in the Item Type list in the Add COBOL Data Item Redefinition dialog box. If the data files to be accessed through this catalog do not include any DEC COBOL data types, do not select this check box.


Decimal Places (Add Data Type)

Under Column Properties, the Decimal Places box specifies the number of decimal digits to the right of the decimal place in a numeric item.


Decimal Places (Table Form Column Property)

The Decimal Places property specifies the number of digits to the right of the decimal point in a numeric data item.


Default Column Name (FD Form Attributes)

In the expanded FD form, in the FD form, the Default Column Name attribute is the SQL column name that will be assigned by the Relativity Designer when the data item is used as a column in a table. When the Default Column Name attribute is first generated, it is derived from the COBOL data-name according to a set of rules for defining default column names.

The column name may be changed after a column is created by using the Column Name attribute in the Table form.

Column names may not be an SQL reserved word.


Defaults (Date Constants)

The Defaults button resets the values in the Date Constants dialog box to the default values.


Default Value (Add Data Type)

Under Column Properties, the Default Value box specifies the value that is used in write operations if the column is not present in an INSERT statement. The value will be limited to the range of values that is valid for the data type of the column.

For example, if creating a date data type, the only valid default values are valid dates. The following forms are valid for entering dates:

2007-05-01 05-01-2007 01 May 2007

All of these forms refer to May 1, 2007.


Default Value (Data Types Form)

In the Data Types form, the Default Value attribute is the value that is used in write operations if the column is not present in an INSERT statement. The value will be limited to the range of values that is valid for the data type of the column.

For example, if you are creating a date data type, the only valid default values are valid dates. The following forms are valid for entering dates:

2007-05-01 05-01-2007 01 May 2007

All of these forms refer to May 1, 2007.

This value is set in the Set Default Value dialog box.


Default Value (FD Form Attributes)

In the expanded FD form, the Default Value attribute is the value that is used in write operations if the item is not represented by a column in an SQL INSERT statement. This value is set by double-clicking in the column row of the selected item in the FD form, then typing or selecting the value in the Set Default Value dialog box. The value will be limited to the range of values that is valid for the underlying COBOL data type. See Defining Default Values.

The Default Value attribute column is displayed in the FD form only if the Show Default Values check box is selected on the File page in the Options dialog box.


Default Value (Table Form Attributes)

Note The Default Value attribute is displayed in the Table form only if the Show Default Values check box is selected on the Table page in the Options dialog box and the Allow Inserts check box is selected on the Table form toolbar.

The Default Value attribute is the value that is used in write operations if the column is not present in an SQL INSERT statement. This value is set by clicking in the column, then typing in the value. The value will be limited to the range of values that is valid for the data type of the column.

For example, if a column has the date data type, the only valid default values are valid dates. The following forms are valid for entering dates:

2007-05-01 05-01-2007 01 May 2007

All of these forms refer to May 1, 2007.

If the value is inherited from a user data type (defined in the Data Types form), it may not be changed here.


Defining Catalog Ownership See Also

Catalog Ownership

Defining Groups and Users


Defining Columns on Repeating Data Items See Also

Adding Condition Items

Bind Subscripts Form

Specifying Treatment of the OCCURS Clause

Table Form


Defining Date Constants See Also

Date Formats Options

Internal Functions

Relational Schema Maintenance

Transforms

User-Configurable Date Transforms

Using Functions and Transforms


Defining Default Column Names See Also

Defining Columns on Repeating Data Items

Edit Default Column Names Dialog Box

Pattern Matching

Table Form


Defining Default Values See Also

Building Writable Tables

Data Types Form


Defining Group Privileges See Also

Database Administration

Privileges Options


Defining Groups and Users See Also

Catalog Ownership

Configuring a Relativity Data Source

Database Administration

Defining Catalog Ownership

Users & Groups Catalog Object


Defining Insertable Tables See Also

Building Writable Tables


Defining Item Patterns See Also

Add Data Item Pattern Dialog Box

Add Data Type Dialog Box

Data Types Form

Defining User Data Types

Item Patterns Form

Item Patterns Options

FD Form

Pattern Matching

Tools Menu Commands

Transforms


Defining Item Sets See Also

FD Form


Defining Nonstandard Character Sets See Also

Importing Btrieve Keys (Micro Focus COBOL Only)

Importing COBOL File Definitions

Importing Definitions from Another Relativity Catalog

Maintaining Character Sets


Defining Null Information See Also

Building a New Record

Handling Multiple Record Types

Rules for Insertable Tables


Defining Record Type Filters See Also

Defining Record Types

Defining Table Filters


Defining Record Types See Also

Add Record Type Dialog Box

Describe Filter Subexpression Dialog Box

FD Form

Handling Multiple Record Types

Record Type Properties Form

Record Type Toolbar

Record Types Properties


Defining Table Filters See Also

Define a record type filter

Defining Record Type Filters

Defining Record Types


Defining Transforms on Columns See Also

Transforms

Using Functions and Transforms


Defining Transforms on Data Items See Also

Transforms

Using Functions and Transforms


Defining User Data Types See Also

Add Data Type Dialog Box

Data Types Form

Defining Item Patterns

Tools Menu Commands

Transforms

User Types Options


Definition Character Set (Select Character Set)

Typically, a character set is a collection of graphical symbols, called Glyphs, which are used to communicate in a language. In order to represent the Glyphs in a computer, they must be associated with a numerical value, called a Code Point, for storage. In modern computers, the Code Points are stored in individual, 8-bit bytes of memory allowing 256 Glyphs to be represented. Relativity uses the term “character set” to refer to Glyphs and their associated Code Points.

On IBM PCs, the term “Code Page” is commonly used to describe this mapping of Glyphs to Code Points. However, on UNIX-based machines, it is more common to use the ISO 8859 standard to describe this mapping. Relativity provides character sets for both of these standards.

Relativity uses the character set of each file in order to interpret the Code Points stored within it. For example, if your data is in English and resides on Windows or DOS, selecting the character set for Code Page 437 would be appropriate. If your data is in English and resides on UNIX, the character set for ISO 8859-1 (otherwise known as Latin 1) would be appropriate.


Delete All Sets Button (Edit Item Sets Form)

The Delete All button removes all item sets associated with FD form. See Delete all item sets associated with an FD form.


Delete Arguments (FD Form Toolbar)

The Delete Arguments button deletes all arguments for the selected function item.


Delete Column (Table Form Toolbar)

The Delete Column button removes one or more selected column definitions from the table displayed in the Table form.


Delete Command Button (Users Tab)

The Delete button removes the selected group or user from the catalog. If a user name has been selected, the user name is immediately deleted. A message box, however, will be displayed requesting confirmation of a delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.

Note The Delete command on the User menu provides the same functionality as the Delete button.


Delete Connections (Delete Connections Matching Pattern)

The Delete Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes tool bar button on the Edit Connections form.


Delete Connections Matching Pattern Dialog Box See Also

Delete table connections with matching patterns

Establishing Table Connections

Pattern Matching


Delete Data Type (Data Types Form)

The Delete Data Type button removes the selected user-defined data type from the Data Types form.


Delete (Delete File Label)

The Delete button begins the deletion process. File label items will be deleted from all of the FDs selected in the Source area.


Delete (Delete File Label Column)

The Delete button begins the deletion process. The file label columns will be removed for the selected tables.


Delete (FD Form Toolbar)

The Delete FD button deletes from the Relativity catalog the record description displayed in the FD form.

CAUTION The Delete FD button deletes all tables based on this FD and closes all open tables.

Note This option provides the same functionality as the Delete FD command on the FD menu (or the Delete FD task on the FD Common Tasks area of the Files catalog object).


Delete File Label Column Dialog Box See Also

Delete file label columns and items from other FDs and tables

Supporting Multi-File Tables


Delete File Label Dialog Box See Also

Delete file label columns and items from other FDs and tables

Supporting Multi-File Tables


Delete Filter Subexpression Dialog Box See Also

Define a record type filter

Define a table filter

Defining Record Type Filters

Defining Table Filters

Edit a record type filter

Edit a table filter


Delete Filter (Table Filter Properties)

The Delete Filter button deletes the selected table filter expression listed in the Table Filter Properties form.


Delete Group (Edit Users Form)

The Delete Group button deletes the selected group and all its users from the Edit Users form.

Shortcut: Alt+T


Delete Item (FD Form Toolbar)

The Delete Item button removes from the FD form a data item or condition item that was not imported into the database. Imported items cannot be removed from the FD form.


Delete Item or Item Set (Edit Item Sets Form)

The Delete Item or Item Set button removes either: (1) a selected data item from an existing item set (see Delete a data item from an item set), or (2) a selected item set from the FD form (see Delete an item set from the list of item sets).


Delete Item Pattern IPF (Item Patterns Form)

The Delete Item Pattern button removes the selected item pattern from the Item Patterns form.


Delete Item (Edit Record Type Form)

The Delete Item button removes the selected data item in the FD form from the record type having the record-name displayed in the Record Type: list. See Delete a data item from a record type.


Delete Record Type (Edit Record Type Form)

The Delete Record Type button removes the record type having the record-name displayed in the Record Type: list. See Delete a record type.


Delete Table Connection (Edit Connections Form)

The Delete Table Connection button deletes selected table connections for a selected table definition in the Edit Connections form.

Shortcut: Alt+D


Delete Table (Table Form Toolbar)

The Delete Table button removes the entire table displayed in the Table form from the Relativity catalog.

Note This option provides the same functionality as the Delete command on the Table menu (or the Delete shortcut on the Table Common Tasks area of the Tables catalog object),


Delete User (Edit Users Form)

The Delete User button deletes a selected user from a group in the Edit Users form.

Shortcut: Alt+D


Design Grid (Query)

The query design grid is the area where you define your query options. It contains several columns and rows, displayed in a grid. In each column of the grid, you specify the column name from the Column List you want to include in your query and in the order in which you want it to appear. Each row in the grid lets you define a query option based on the information in one of the column names of the selected table. The information you select or add to the cells in the Sort and Criteria rows determines what you will see in the query results displayed in the Show Table Contents form.


Design Mode (Data Types Form)

The Design Mode button expands or contracts the Data Types form horizontally to display all of the options, including the description of the user-defined data type, which can then be edited.


Design Mode (Table Form Toolbar)

The Design Mode button expands or contracts the Table form horizontally to display either the detailed or abbreviated description of the column definitions, which can then be edited.


Destination (Copy File Label)

The Destination list box contains all the FDs in the catalog on which a file label item has not been defined. Choose one or more FDs from this list box.


Destination (Copy File Label Column)

The Destination Tables list box contains all the tables on which a file label column has not been defined. Choose one or more tables from this list.


Details

The Details button displays the Merge Details dialog box for the selected data item from the Merged Version - Changed Items list and its matching data item from the Previous Version - All Items list. The information is provided for viewing purposes only.


Details List (Write Support Wizard)

The Details List area gives details about exactly what caused the issue. It is intended to aid in resolving issues, by pointing to the exact cause.


Determining Occurrence Count See Also

Building Writable Tables

Identifying Implicit OCCURS DEPENDING ON.

OCCURS Rule


Determining Record Type See Also

Building Writable Tables

Handling Multiple Record Types


Dialect (FD Properties)

In the Properties area of the FD Properties form, the Dialect box indicates the type of COBOL dialect (RM/COBOL or Micro Focus COBOL) that is being used.


Dialect (Import Wizard MF COBOL)

The Dialect list box allows you to specify the type of COBOL files (RM/COBOL or MF COBOL) to be used when the Import COBOL Source option is selected.

Note The Dialect list box is disabled unless Import COBOL Source is selected.


Dialect (Import Wizard RM COBOL)

The Dialect list box allows you to specify the type of COBOL files (RM/COBOL or MF COBOL) to be used when the Import COBOL Source option is selected.

Note The Dialect list box is disabled unless Import COBOL Source is selected.


Dialect (Merge Wizard MF COBOL)

The Dialect list box allows you to specify the type of COBOL files (RM/COBOL or MF COBOL) to be used when the Merge COBOL Source option is selected.

Note The Dialect list box is disabled unless Merge COBOL Source is selected.


Dialect (Merge Wizard RM COBOL)

The Dialect list box allows you to specify the type of COBOL files (RM/COBOL or MF COBOL) to be used when the Merge COBOL Source option is selected.

Note The Dialect list box is disabled unless Merge COBOL Source is selected.


DIBOL Types

When the DIBOL Types check box is selected, imports from VAX COBOL have the option to be treated as DEC DIBOL.


Digits (Add Data Type)

Under Column Properties, the Digits box specifies the number of decimal digits in a numeric item.


Digits (Table Form Column Property)

The Digits property specifies the number of digits in a numeric data item. The maximum number of digits is 18.


DIRECTIVES"string"

The DIRECTIVES"string" directive specifies a directives file named string to be processed. The directives file is searched for first in the current directory and then in the directories specified by the COBDIR environment variable. For each directory searched, if the specified directives filename does not contain an extension, then the extension ".dir" is first added to the name; if that file is not found in the directory being searched, then the filename as specified is searched for in the directory; if the filename is specified with an extension, then only that filename is searched for in each directory. There is no directory search if string contains a path specification.

The Micro Focus COBOL System Reference 1 manual describes directives files in detail. Directive files are simple text files that contain zero or more directives per line with up to 128 characters per line (including the line separator character). A comment line is indicated with an & character. Experimentation has shown that, despite Micro Focus COBOL documentation saying the & must be in column 1, the & can be in any column and is more like an end-of-line comment initiator than a comment line indicator. Note that directives files do not contain $SET statements; they only contain directives. Also note that, for purposes of the directory search sequence, Relativity always sets the current directory to the directory containing the executables; that is, the Relativity installation directory.


DIR"string"

The DIR"string" directive is a synonym for the DIRECTIVES directive, q.v.


Disabled Query Builder Buttons (Query)

These toolbar buttons are disabled in the Query Builder form.


Display Errors (Import Wizard MF COBOL)

The Display Errors option causes the import procedure to display an error file containing any errors or warnings that occurred during compilation of the selected source file.

Note The Display Errors option is disabled unless Import COBOL Source is selected.


Display Errors (Merge Wizard MF COBOL)

The Display Errors option causes the merge procedure to display an error file containing any errors or warnings that occurred during compilation of the selected source file.

Note The Display Errors option is disabled unless Merge COBOL Source is selected.


Display Group Items (Table Wizard)

Under List Options, the Display Group Items check box controls the displaying of group level items in the Available Items list.


Distributing Catalogs See Also

Distributing Updated Catalogs

Relational Schema Maintenance


Distributing Updated Catalogs See Also

Defining Nonstandard Character Sets

Distributing Catalogs


Done (Resolve Merge Differences)

The Done button displays the Tables to Keep dialog box. Choosing the Done button is identical to clicking Save Changes on the toolbar.


Done (Tables to Keep)

The Done button completes the Tables to Keep dialog box by replicating table definitions for all table definitions appearing in the Tables to Keep list.


Driver List Box (Welcome to Relativity Window)

If multiple drivers are installed on your system, you can select the appropriate driver from this list in order to create and set up a new data source or open an existing data source.


Driver (Open Relativity Data Source)

If multiple ODBC drivers are installed on your system, you can select the appropriate driver from this Driver list in order to create and set up a new data source or open an existing data source.


Drives (Save Export File As)

In the Drives list, select the drive on which you want to save the file.


Drives (Select Report)

In the Drives list, select the drive containing the desired report definition files.


During Import, Initially Place Files in Available Column

When the During Import, Initially Place Files in Available Column check box is selected, the FDs from the COBOL source file are placed in the Available Files list of the File Selection pages of the Source Code Import wizard and the Source Code Merge wizard. This enables you then to select only those FDs you wish to include in the importing and merging processes.

The default behavior for the Relativity Designer is to assume that you want to import and merge all of the FDs from the COBOL source file. Consequently, all of the file definitions are initially placed in the Selected Files list unless you enable this option.

Note The procedures for importing and merging COBOL file definitions are written from the perspective of the default behavior; that is, all the files are shown in the Selected Files list.


EBCDIC Types

When the EBCDIC Types check box is selected, the catalog includes the EBCDIC data types.


Edit Connections (Edit Connections Matching Pattern)

The Edit Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes toolbar button on the Edit Connections form.


Edit Connections (Edit Selected Table Connections)

The Edit Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes toolbar button on the Edit Connections form.


Edit Connections Form See Also

Connections Report Features

Establishing Table Connections

Pattern Matching

Previewing Table Data


Edit Connections Matching Pattern Dialog Box See Also

Edit table connections with matching patterns

Establishing Table Connections

Pattern Matching


Edit Data Item Pattern Dialog Box See Also

Define an item pattern

Defining Item Patterns

Transforms


Edit Default Column Names Dialog Box See Also

Defining Default Column Names

Edit default column names

Pattern Matching


Edit Group Dialog Box See Also

Defining Groups and Users


Edit Group Password (Edit Users Form)

The Edit Group Password button displays the Change Password dialog box. This dialog box contains options for the definition of a new password, verification of an existing password, and an expiration date for catalog access for the selected group in the Edit Users form.

Shortcut: Alt+E


Editing File Definitions, An Overview See Also

FD Form


Edit Item Pattern (Item Patterns Form)

The Edit Item Pattern button displays the Edit Data Item Pattern dialog box for the editing of the selected item pattern.


Edit Item Sets Form See Also

Defining Item Sets


Edit Privileges Form See Also

Defining Group Privileges

Privileges Options


Edit Selected Table Connections Dialog Box See Also

Edit selected table connections

Establishing Table Connections


Edit Table Connection (Edit Connections Form)

The Edit Table Connection button displays the Edit Selected Table Connections dialog box. This dialog box contains options for the editing of selected path names and file labels (if file labels are in effect) in selected table connections of a table definition in the Edit Connections form.

Shortcut: Alt+E


Edit Table Filter (Table Form Toolbar)

The Edit Table Filter button displays the Table Filter Properties form to define the conditions for determining records that participate in providing data to the table viewed in the Table form. See Defining Table Filters.

Note This option provides the same functionality as the Edit Table Filter command on the Table menu.


Edit User Dialog Box See Also

Defining Groups and Users


Edit User Password (Edit Users Form)

The Edit User Password button displays the Change Password dialog box. This dialog box contains options for the definition of a new password, verification of the password, and an expiration date for catalog access for one or more selected users within a selected group in the Edit Users form.

Shortcut: Alt+J


Edit Users Form See Also

Defining Groups and Users


Eliminating Unused Occurrences See Also

Specifying Treatment of the OCCURS Clause


Enable Column Transforms

When the Enable Column Transforms check box is selected, date and time transforms may be applied to column definitions in the Table form. When this option is not selected, date and time transforms are available only in the FD form. Selecting this option is discouraged.


End (FD Form Attributes)

In the expanded FD form, the End attribute is the last character position for the data item within the record. For the filename, the End attribute is the maximum record size.


Entered Value

An Entered numeric value is specified in the text box as the COBOL numeric literal for the associated value. For example, 489, +12.75, -3.28, or -3.22E+12. The leading sign character is allowed only if the associated data item is signed. The decimal point is allowed only if the associated data item has digits to the right of the decimal point. The exponential notation is allowed only for associated data items with floating point numbers.

An Entered nonnumeric value is specified in the text box as the string of characters against which the conditional variable is to be compared. It is similar to a COBOL nonnumeric literal, except that the delimiting quotes are omitted and embedded quote characters are not doubled (that is, each occurrence of a quote character in the string represents one quote character in the resultant value as opposed to a COBOL nonnumeric literal where each pair of quote characters represents one quote character in the resultant value).


Enter New Name (Rename)

In the Enter New Name box, type the new name for the file definition being renamed. A file-name must begin with an alphabetic character. The remaining characters can be any combination of alphabetic, numeric, or underscore characters.

Note A table name must not be an SQL reserved word.


Establishing Table Connections See Also

Connections Report Features

Pattern Matching

Supporting Multi-File Tables


Example Edit Connections Form for a Table Definition and a File Label

The following illustrates the associated table connection for a selected table definition.

The following illustrates a table connection when file labels are in effect.


Example Popup

To understand the difference between grouping records and merging records based on an index, consider two decks of playing cards, with each deck having different backs so that it is possible to tell which deck a card came from. If one deck of cards is placed on top of the other, the cards are grouped together by deck. But, if the cards are shuffled together, then they are merged. If the cards were then sorted into suits by their value without looking at which deck each card came from, then the cards are merged based on an index (their suit and value).

In Relativity, consider a table based on two files. Using the index that returns rows grouped together, the ODBC application would first see all the rows from the first file, and then the rows from the second. Using the index that merges the two files together, the ODBC application would see rows coming back from the two files mixed together.


Execute Query Button (Query)

After you are satisfied with all your settings, click the Execute Query button to run the query and display the results in the Show Table Contents form.


Execute Query Button (SQL Window)

After you are satisfied with all your entries, click the Execute Query button to run the query and display the results in the expanded SQL window.


Existing Keys

The Existing Keys button directs Relativity to copy the previously imported Btrieve keys to the newly merged FD. This is the default action.


Existing (Welcome to Relativity Window)

Select the Existing option to open and maintain an existing catalog that supports the Relativity database specified by the data source. When you select this option, a list of all the existing data sources is displayed in the List area. If you have multiple drivers installed, a list will appear in a box to the right of this option, indicating that the existing catalogs displayed are associated with the data source for the selected driver.

To quickly open one of these data sources, click it. If one of these data sources is selected from this list, any open, existing data source is closed, and the selected data source is opened. For more information, see Opening a Data Source.)

Note This option provides the same functionality as the Open Data Source command on the File menu.


Expand / Collapse (FD Form Attributes)

In the expanded FD form, the Expand and Collapse icons control the display of group data items:

· Clicking Expand displays all subordinate data items in the group.

· Clicking Collapse hides all of the subordinate date items within the group.


Expanded Area (SQL Window)

This is the area of the window that expands to display the results of your query in a column-and-row format.


Export Command Button (Data Source Options)

The Export button in the Data Source page displays the Export Preferences dialog box in order to configure the export of an FD (see also Export FD on the FD form toolbar).


Export Command Button (Reports Tab)

The Export button displays the Save Export File As dialog box for the output of a comma-separated value (.csv) text file. After you complete the Save Export File As dialog box, the Print Options dialog box is displayed. You must also print the report in order to write the .csv file.

Notes

· If a report category is selected instead of a specific report description, the Select Report dialog box is displayed after you complete the Save Export File As dialog box. After you select a specific report definition file, the Print Options dialog box is displayed.

· See Export data stored in a Relativity catalog for procedures on how to export data.


Export (FD Form Toolbar)

The Export FD button sends the record description displayed in the FD form and the associated table definitions to a COBOL source file suitable for use by a COPY statement. Settings on the Data Source page in the Options dialog box control the location and format of the created file.


Export File (Export DDL)

The Export File box displays the name and location of the resulting output file for the selected table(s). The file format for the exported file has the extension .ddl, which represents database definition language file. You can type in this information or click the Browse button to find a location and enter a filename.


Exporting Data to a Comma-Separated File See Also

Configuring Reports for Relativity DBA

File Schema Maintenance

Reporting


Export Media DSN Area (Print Options)

Use the Export Media area to select where to send (direct) output: to a printer, print preview, or to a file. The name of the selected (or default) printer is displayed in the top portion of this area.

Click the Change button to display the Printer Choice dialog box, which allows you to specify a different printer.

In addition to sending output to a printer or print preview, you may also direct output to numerous other file formats, including a PostScript printer file (.prn), Rich Text (.rtf), HTML, Adobe PDF, Multi-MIME HTML, XML, bitmap, JPEG-picture, or metafile (EMF) files. When you select a file format from the Drop to drop-down list, you can click the Export Option button to specify additional options for that particular file format (export module). After setting your file format options, you will be prompted to specify a name for the file in a Save As dialog box, or, in the case of a PostScript (.prn) file, the File for Printing dialog box.


Export Preferences Dialog Box See Also

File Schema Maintenance


False Value (Add Condition Item)

The False Value list box displays a list of items for the selection of a value or a type of value. The false value is used by Relativity only for write support operations (that is, building writable tables). The false value is always a single value, never a value range or series. The following items are valid:

· Entered. Specifies that a value is to be entered in the text box to the right. Note that Entered is the only selection allowed when the conditional variable is numeric.

· SPACES. Specifies the figurative constant SPACES as the value for the condition-name.

· ZEROS. Specifies the figurative constant ZEROS as the value for the condition-name.

· LOW-VALUES. Specifies the figurative constant LOW-VALUES as the value for the condition-name.

· HIGH-VALUES. Specifies the figurative constant HIGH-VALUES as the value for the condition-name.

· Hexadecimal. Specifies that a hexadecimal value is to be entered in the text box to the right.


False Value Text Box (Add Condition Item)

The False Value text box allows you to type in a value when the value type selected in the False Value list box is Entered or Hexadecimal.


FD Form Attributes Summary See Also

FD Form Toolbar

Record Type Toolbar


FD Form See Also

Augmenting the COBOL File Definition on the FD Form

Data Types Form

Edit Item Sets Form

Item Patterns Form

Record Type Properties Form

Table Form


FD Form Toolbar See Also

FD Form

FD Form - Attributes Summary

Record Type Toolbar


FD Name (FD Properties)

In the Properties area of the FD Properties form, the Name property identifies the COBOL file-name (COBOL Name attribute) of the FD entry in the FD form.


FD Properties (FD Form Toolbar)

The FD Properties button displays the FD Properties form for the selected file definition in the FD form.

Note This option provides the same functionality as the Properties command on the FD menu when a file definition is selected on the Files catalog object in the Catalog window.


File Label (Add Table Connection Regular)

In the File Label box, type, or select from the list, the file label to be associated with the table connection being added to the selected table definition in the Edit Connections form.

Note This box appears only if a file label item has been added to the FD on which the table is based.


File Label AND OR (Edit Selected Table Connections)

· Select the AND option to make replacements if the contents of both the Path Name Replace and File Label Replace boxes match an individual table connection.

· Select the OR option to make replacements if the contents of either the Path Name Replace or File Label Replace boxes match an individual table connection.


File Label Replace (Edit Selected Table Connections)

Note This area is enabled only if a file label item has been added to the FD on which the table is based.

· The File Label Replace box contains the pattern to be matched within the file label for replacement in the selected table connection.

· The File Label With box contains the pattern that is to replace the matching characters specified in the File Label Replace box. The resulting file label becomes the new file label for the selected table connection.


File Label Replace With (Add Connections Matching)

· The File Label Replace box contains the pattern to be matched within the file label for replacement in the generation of a file label for the new table connection.

· The File Label with box contains the pattern that is to replace the matching characters specified in the File Label Replace box. The resulting file label becomes the file label for the new table connection.

Note This option appears only if a file label item has been added to the FD on which the table is based. For more information, see Supporting Multi-File Tables.


File Label With

The File Label with box contains the pattern that is to replace the matching characters specified in the File Label Replace box. The resulting file label becomes the file label for the new table connection.


File Name (Save Export File As)

In the File name list box, type the name of the file into which the export (comma-separated) information is to be saved. This filename must have the extension .csv.


File Name (Select COBOL Source)

In the File name list box, type or select the filename of the COBOL source file to be imported or merged into the Relativity catalog. This filename must have the suffix specified in the Files of type list.


File name (Select Report)

In the File name list box, type or select the filename of a report definition file. This filename must have the extension specified in the Files of type list.


File Name (Select RM/COBOL Program)

In the File name list box, type or select the filename of the RM/COBOL object file to be imported or merged into the Relativity catalog. This filename must have the suffix specified in the Files of type list.


File Name (Select Symbol Table)

In the File name list box, type or select the filename of the Relativity symbol table file to be imported or merged into the Relativity catalog. This filename must have the suffix specified in the Files of type list.


File Options See Also

Augmenting the COBOL File Definition in the FD Form

Merging COBOL File Definitions

Pattern Matching

Setting Options

Tools Menu Commands


File Path Name

The File Path Name box displays the path name for the COBOL file containing the level 01 entries.


Files Catalog Object See Also

Editing File Definitions, An Overview

Edit file definitions in a Relativity catalog

Tabbed Layout View

Working with the Catalog Window


File Schema Maintenance See Also

Maintaining the Relativity Database

Re-Importing Btrieve Keys (Micro Focus COBOL Only)

Relational Schema Maintenance

Resolving Merge Differences


File Section

Selecting the File check box causes the display of level 01 entries from the File Section of the COBOL program.


Files List (Files Tab)

The Files area displays a list of COBOL file-names that have been imported into the catalog. Single-clicking a file-name in the list selects it. Double-clicking a file-name in the list displays the FD form, which is equivalent to selecting the file and then clicking the Open button.

Note A file definition may be deleted from the catalog by selecting the file-name and pressing the Del (Delete) key. A message box will be displayed requesting confirmation of the delete request. If there are any table definitions based on the file definition, a second confirmation message box informs the user of the existing tables. If the user confirms the deletion, the file definition and any table definitions based on that file definition are deleted from the catalog.


Files of Type (Select COBOL Source)

In the Files of type list, select a file having the .cbl suffix.


Files of type (Select Report)

The Files of type list displays the default filename extension of the report definition file for the selected report category.


Files of Type (Select RM/COBOL Program)

In the Files of type list, select a file having the .cob suffix.


Files of Type (Select Symbol Table)

In the Files of type list, select a file having the .rst suffix.


Files/Tables Report Features See Also

Reporting


Files to Import (Import Wizard RM COBOL)

The File to Import text box allows you to specify the filename and path of the file you want to import into Relativity. If the Import COBOL Source option is selected and the source file specified in the File to Import text box contains an error, the Detected Errors page of the Source Code Import wizard is displayed.

Note When using a client/server version of Relativity, a Remote check box will be visible in this area of the wizard. By default it is selected, indicating that the file containing the source code being imported is located on the remote server. If you clear this check box, you can select source code from the local machine to import.


File to Import (Import Wizard MF COBOL)

The File to Import text box allows you to specify the filename and path of the file you want to import into Relativity. If the Import COBOL Source option is selected and the source file specified in the File to Import text box contains an error, the Detected Errors page of the Source Code Import wizard is displayed.

Note When using a client/server version of Relativity, a Remote check box will be visible in this area of the wizard. By default it is selected, indicating that the file containing the source code being imported is located on the remote server. If you clear this check box, you can select source code from the local machine to import.


File to Import (Merge Wizard MF COBOL)

The File to Import text box allows you to specify the filename and path of the file you want to import into Relativity for the merge procedure. If the Merge COBOL Source option is selected and the source file specified in the File to Import text box contains an error, the Detected Errors page of the Source Code Merge wizard is displayed.

Note When using a client/server version of Relativity, a Remote check box will be visible in this area of the wizard. By default it is selected indicating, that the file containing the source code being imported is located on the remote server. If you clear this check box, you can select source code from the local machine to import.


File to Import (Merge Wizard RM COBOL)

The File to Import text box allows you to specify the filename and path of the file you want to import into Relativity for the merge procedure. If the Merge COBOL Source option is selected and the source file specified in the File to Import text box contains an error, the Detected Errors page of the Source Code Merge wizard is displayed.

Note When using a client/server version of Relativity, a Remote check box will be visible in this area of the wizard. By default it is selected, indicating that the file containing the source code being imported is located on the remote server. If you clear this check box, you can select source code from the local machine to import.


FILLER

When exporting an FD, selecting the FILLER check box causes the file to be exported with the word FILLER present. If this check box is not selected, the file is exported with the word FILLER deleted.


Filter Rule See Also

Building Writable Tables

Rules for Insertable Tables


Find Area (Find FD)

Enter the name of a COBOL data item for which you want to search. Note that to search the entire FD form, be sure to expand the subordinate data items in the FD form attribute grid by clicking the Magnify toolbar button.


Find Button (SQL Window)

Use the Find button to open a Find dialog box, where you can specify the text you want to locate in a particular column of the query results displayed in the SQL window. The name of the column displayed in the Find dialog box is determined by the column definition that is selected in the window.

You can then use the Find Next button to find and select the next occurrence of the specified text.


Find (FD Form Toolbar)

The Find button opens the Find COBOL Item dialog box, where you can search for a COBOL data item on the FD form.

Shortcut: Ctrl+F

Note This option provides the same functionality as the Find command on the FD menu.


Find (Find Table)

The Find button searches for the first instance of the search criteria specified in the Find What box.


Find Next Button (SQL Window)

The Find Next button allows you to find and select the next occurrence of the text specified with the Find button.


Find Next (FD Form Toolbar)

The Find Next button repeats the search for the COBOL data item that you specified in the Find COBOL Item dialog box.

Shortcut: F3

Note This option provides the same functionality as the Find Next command on the FD menu.


Find Next (Find Table)

The Find Next button finds and selects the next occurrence of the search criteria specified in the Find What box.

Note If you close the Find dialog box, you may click the Find Next button on the Table form toolbar to search for the next occurrence of the last specified search criteria.


Find Next (Show Table Contents)

The Find Next button allows you to find and select the next occurrence of the text specified with the Find button.


Find Next (Table Form Toolbar)

The Find Next button repeats the search specified in the Find dialog box or the Find and Replace dialog box.

Shortcut: F3

Note This option provides the same functionality as the Find Next command on the Table menu.


Find (Show Table Contents)

Use the Find button to open a Find dialog box, where you can specify the text you want to locate in a particular column of the query results displayed in the Show Table Contents form. The name of the column displayed in the Find dialog box is determined by the column definition that is selected in the form.

You can then use the Find Next button to find and select the next occurrence of the specified text.


Find (Table Form Toolbar)

The Find Column Name button opens the Find dialog box, where you can specify the criteria for your search in the Column Name column in the Table form. The search criteria are not highlighted when found, but rather the row selector is moved to the row where the criteria are located. This dialog box also optionally allows you to replace the search criteria by clicking the Replace button to open the Find and Replace dialog box. Replace behaves much the same as Find, except the Find What text is removed and replaced by the Replace With text.

Shortcut: Ctrl+F

Note This option provides the same functionality as the Find command on the Table menu.


Find What (Find Table)

In the Find What box, enter the Column Name that you want to search for. You can type or paste text into this box.


Finish (Import Detected Errors page)

The Finish button is not enabled on the Detected Errors page of the Source Code Import wizard.


Finish (Import File Selection Page COB RST)

The Finish button completes the importing of a source code file or previously compiled symbol table/object file.


Finish (Import File Selection Page COB)

The Finish button completes the importing of a source code file or previously compiled symbol table/object file.


Finish (Import Wizard MF COBOL)

The Finish button is not enabled on the first page of the Source Code Import wizard.


Finish (Import Wizard RM COBOL)

The Finish button is not enabled on the first page of the Source Code Import wizard.


Finish (Merge Detected Errors page)

The Finish button is not enabled on the Detected Errors page of the Source Code Merge wizard.


Finish (Merge File Selection CBL RST page)

The Finish button completes the importing a source code file or previously compiled symbol table/object file for the merge procedure.

Note If necessary, when merging a previously compiled symbol table (RST) file, the Resolve Merge Differences dialog box is displayed to allow resolution of differences between COBOL data definitions in the previous version and the merged version of the file.


Finish (Merge File Selection Page COB)

The Finish button completes the importing of a source code file or previously compiled symbol table/object file for the merge procedure.

Note If necessary, when merging a previously compiled RM/COBOL object file, the Resolve Merge Differences dialog box is displayed to allow resolution of differences between COBOL data definitions in the previous version and the merged version of the file.


Finish (Merge Wizard MF COBOL)

The Finish button is not enabled on the first page of the Source Code Merge wizard.


Finish (Merge Wizard RM COBOL)

The Finish button is not enabled on the first page of the Source Code Merge wizard.


Finish (Table Wizard)

The Finish button completes the Table wizard by creating the table definition based upon the selections made.


Finish (Table Wizard Edit)

The Finish button completes the Edit page of the Table wizard by creating the table definition based upon the selections made.


Flattening OCCURS See Also

Adding Condition Items

Specifying Treatment of the OCCURS Clause


Floating Point Types

When the Floating Point Types check box is selected, the catalog includes the floating point COBOL data types described by the USAGE IS COMP-1 and COMP-2 clause.

Note Floating point data types will appear in the Item Type list in the Add COBOL Data Item Redefinition dialog box only if the Micro Focus Types or DEC COBOL Types check box is selected.


Free Format Import Wizard MF COBOL

The Free Format option enables you to specify the Free Format compiler option in Micro Focus COBOL, which relaxes the restrictions placed on the COBOL source and allows source lines longer than 80 characters.

Note The Free Format option is disabled unless Import COBOL Source is selected.


Free Format Merge Wizard MF COBOL

The Free Format option enables you to specify the Free Format compiler option in Micro Focus COBOL, which relaxes the restrictions placed on the COBOL source and allows source lines longer than 80 characters.

Note The Free Format option is disabled unless Merge COBOL Source is selected.


Function of Function Dialog Box See Also

Internal Functions

Specify function arguments

Synthesize a data item using an internal function

Using Functions and Transforms


Functions

The Select Functions list displays the internal functions that can be selected and added to an FD. You may only select one function at a time from this list.


Generated Description

Located immediately above the Add Item button is a COBOL-like data description entry that is generated by the entries in the Add COBOL Data Item Redefinition dialog box. For example, EXCHANGE-CODE PIC 999 REDEFINES CF-PHONE (4:3) is the data description entry for the field EXCHANGE located in the 4th, 5th, and 6th character positions of the containing field CF-PHONE.


Global Add (Edit Connections Form)

The Global Add button displays the Add Connections Matching Pattern dialog box. This dialog box contains options for the addition of table connections based on the matching of patterns within table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Security menu), the Global Add button is enabled for global manipulation.

Shortcut: Alt+G


Global Delete (Edit Connections Form)

The Global Delete button displays the Delete Connections Matching Pattern dialog box. This dialog box contains options for the deletion of table connections based on the matching of patterns within table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Security menu), the Global Delete button is enabled for global manipulation.

Shortcut: Alt+T


Global Edit (Edit Connections Form)

The Global Edit button displays the Edit Connections Matching Pattern dialog box. This dialog box contains options for the editing of table connections based on the matching of patterns within the table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Security menu), the Global Edit button is enabled for global manipulation.

Shortcut: Alt+F


88-level

A means of defining a condition-name in COBOL data description entries.


AirlineDate

An internal function that computes a date from an "airline travel date" (PIC X(5) in the form DDMMM), transaction date (transformed into a date), and a one-character transaction type (PIC X), respectively. The resulting date is formed by using the day and month of the travel date. If the travel month is less than the transaction month and the transaction type = "1", then add 1 to the transaction year to produce the resulting year.

The YYYYMMDD transform may be applied to resulting data item.

Note that this function is available only if the RELDBDSN.INI file has the following entry in the [Designer] section:

EnableAirlineDate=Yes


attribute

The term attribute refers to information about a Relativity form, such as the: FD form, Table form, Edit Connections form, Edit Users form, or Edit Privileges form.


catalog

The function of the Relativity catalog is similar to that of the "system catalog" in a relational database management system. It serves as a repository for information regarding the structure of relational tables as well as operational information required by runtime components of Relativity, such as the query optimizer.

Additionally, the Relativity catalog contains complete information regarding the physical COBOL file structure (that is, the COBOL file definition, or FD information) and information produced by the database design process (Relativity Designer) that defines the association between COBOL files and data elements, and the relational tables and their constituent columns. Together, all of this information allows Relativity to present the COBOL data files through the ODBC interface of an ODBC-enabled application as a Relativity database of well-normalized tables substantially independent of the original COBOL file structure of the application. See also Relativity DBMS and relational table.


COBOL schema

The file control entry, the file definition (FD) entry, and the associated data description entries for a COBOL data file extracted from a COBOL source file. See also COBOL schema file.


COBOL schema file

This file contains one or more COBOL schemas as extracted from a COBOL source file. The COBOL schema file is also called the Relativity Symbol Table file (or RST file). See also COBOL schema.


COBOL table

A COBOL group or elementary data item described with the OCCURS clause. Contrast with relational table. See also table and repeating data item.


CombineDateTime

An internal function that allows two data items to be combined into a single date/time stamp value. The first argument should be a date data item. The second argument should be a time data item.

The YYYYMMDDHHMMS transform may be applied to resulting data item.


Complement

An internal function that performs an arithmetic complement on a numeric data item. The first argument is the data item to be complemented; the second argument is an 88-level condition-name. If the 88-level condition-name value is false, the arithmetic complement is not performed.


ComputeCenturyDate

The ComputeCenturyDate internal function computes a date from data items and/or constants containing the century, the year of the century, the month, and the day of the month or year. When a constant zero is supplied for the month, ComputeCenturyDate computes a date from data items and/or constants containing the year and the days of the year.

The YYYYMMDD transform may be applied to resulting data item.


ComputeCenturyDateTime

The ComputeCenturyDateTime internal function computes a date and time data item from data items and/or constants containing the century, the year, the month, the day of the month or year and optional data items or constants containing the hour or the day, the minute of the hour, the second of the minute, and the hundredth of the second.

The YYYYMMDDHHMMSShh transform may be applied to the resulting data item.


ComputeDate

An internal function that computes a date from data items and/or constants containing the year, the month, and the day of the month. When a constant zero is supplied for the month, ComputeDate computes a date from data items and/or constants containing the year and the days of the year.

The YYYYMMDD transform may be applied to resulting data item.


ComputeDateTime

An internal function that computes a date and time data item from data items and/or constants containing the year, the month, the day of the month or year and optional data items or constants containing the hour or the day, the minute of the hour, the second of the minute, and the hundredth of the second.

The YYYYMMDDHHMMSShh transform may be applied to the resulting data item.


ComputeODO

An internal function that computes an occurrence count from the record length, the record offset of the (single) argument, and the length and span of the argument. The argument must be a repeating data item at the end of the record.


ComputeTime

An internal function that computes a time data item from data items and/or constants containing the hour of the day, the second of the minute, and the hundredth of the second.

The HHMMSShh transform may be applied to the resulting data item.


conditional variable

A data item that has one or more condition-names associated with it. The value of the conditional variable is used to determine whether the condition item named by the condition-name is true or false by comparing it to the values assigned to the condition-name.


condition item

A named subset of values that a conditional variable may assume. The condition item is true when the conditional variable assumes any of the true values. The condition item is false when the conditional variable assumes any other value. A condition item may optionally specify a single preferred value for which the condition item is false when the conditional variable assumes that value. The declaration of a condition item includes a condition-name that is used to refer to the condition item.

In Relativity, a column may be defined on a condition item, in which case the column has a value of 0 for false, and 1 for true. Relativity also uses condition items for specifying null values, specifying filters, and binding subscripts. To help support these uses of condition items, the Relativity Designer allows definition of additional condition items that were not in the COBOL source program.


condition-name

A user-defined word that names a condition item. In COBOL, a condition-name is declared in an 88-level description entry following the data description entry of its associated conditional variable.

Note Relativity does not make use of the alternative COBOL meaning of condition-name where the condition-name is assigned to the status of a switch or device.


Constrain property

A property that limits the value that a column may have during an INSERT or UPDATE operation to one of the true values indicated by an 88-level condition-name defined on the data item associated with the column. If the program did not define the appropriate 88-level condition-name(s), the Relativity Designer may be used to add the necessary condition-name(s).


database

In this document, particularly when qualified by "Relativity", a database refers to a relational database of tables and columns accessible as an ODBC data source, where the value for a column is derived from a data item in a COBOL file. An ODBC data source name is used to refer to the database, indirectly through the Relativity catalog that describes the database. The Relativity Designer is used to create and maintain the catalog. The Relativity DBA may be used to maintain a subset of the catalog relating to end-user administration features such as table connections, security, and date constants.


data item

A named unit of data (excluding literals) defined by the COBOL program in a data description entry. The declaration of a data item includes a data-name that is used to refer to the data item. The Relativity Designer allows additional data items to be defined that redefine data items defined by the COBOL source program. See also repeating data item.


data-name

A user-defined word that names a data item.


data source

In Relativity, a data source is the connection known to ODBC between a Windows workstation and a Relativity catalog. A data source name (DSN) is used to identify the data source on the workstation. See also database and ODBC-enabled application.

Note In client/server configurations of Relativity, a data source is defined on both the client workstation and on the server. The client data source is known to ODBC by its DSN and specifies the connection to the server data source. The server data source provides the connection to the Relativity catalog.


date constants

Values stored in the Relativity catalog that control the conversion in a date transform or an internal function of COBOL data item values to SQL column date values. The date constants can be adjusted using the Relativity Designer or Relativity DBA to reflect common algorithms used in COBOL procedural code.


domain

A named set of characteristics of a column including the data type, default value, constraints on the values in the column, and whether null values are allowed for the column. See also item pattern, ODBC data type, and user data type.


file connection

A file connection is used to store each unique path name specified in one or more table connections. When a table connection is added that specifies a file path name that is not in the file connection list of the catalog, a new file connection entry is created. The file connection entries are used to display the list for the Path Name box in the Add Table Connection dialog box.


file label item

A file label item is a special file definition item used in multi-file table support. Multi-file table support allows the records of more than one COBOL file to be combined to constitute the rows of a single table. A file label item controls the way in which the records are combined, and provides a way to distinguish the business unit from which the row originated in the ODBC application.

A given FD may have only one file label item. A file label item can have a column defined on it and this column will be part of the indexes defined on the table.


filter

A set of criteria applied to records in order to obtain a subset of records that will be used to supply rows to a table. Relativity uses two types of filters: record type filter and table filter. Relativity filters use an expression composed of a filter subexpression or several filter subexpressions to specify the condition under which a record passes through the filter.


filter subexpression

A connecting logical operator (AND or OR), an optional negation logical operator (NOT), and a condition-name used to compose a filter expression that specifies the condition under which a record passes through the filter. If a filter has no subexpressions, then all records pass through the filter.


function

See internal function.


function item

A data item that has been synthesized using an internal function.


indexed file

A file having a permanent logical file structure in which each record is identified by a value of one or more keys within that record.


internal function

A conversion process, built into Relativity DBMS, that is used to synthesize a COBOL data item using the value or values of one or more other COBOL data items within the same COBOL file definition (FD). The other COBOL data items, which may include a previously defined internal function, are specified as arguments to internal functions. The result of the internal function is used as the value for the synthesized COBOL data item, also known as a function item. Unlike a transform, an internal function may operate on more than one COBOL data item. Compare to transform.


ISAM file

A term used to refer to an indexed file.


IsNumeric

An internal function that evaluates the data item supplied as an argument to determine whether its value is a valid numeric value. If the data item is numeric, the function returns the value one, which is the logical value of true. If the data item is not numeric, the function returns the value zero, which is the logical value of false.


IsValidDate

An internal function that evaluates the data item supplied as an argument to determine whether its value conforms to that item’s date transform. If the date item value represents a valid date, the function returns the numeric value one, which is the logical value of true. If the data item value does not represent a valid date, the function returns the numeric value zero, which is the logical value of false.


item pattern

A set of properties common to data items for which columns based on those data items belong to a particular domain. The properties include a string pattern match on the COBOL data-name, the COBOL data type, the length, and, for numeric items, the precision and scale. Associated with each item pattern is a user data type and item transform. After item patterns are defined, the patterns can be used to assign the associated user data type and item transform to all data items whose descriptions match one of the specified patterns. As a result, columns based on the data items that match a particular item pattern will also have matching characteristics, that is, will belong to the same domain. A common use of item patterns is to treat all COBOL data items that represent a date value in a consistent manner. Other examples of sets of COBOL data items to which item patterns apply are customer numbers, company identifiers, prices, and inventory numbers.


item set

Two or more data items in a COBOL record that contain identical information but that have been identified to Relativity as sets of redundant data items. Redundant data items include situations such as where one data item is identical to the first characters of another data item. One place where redundant data items are defined is in keys, where different keys provide different look-up capabilities in a file. Using Relativity, an item set becomes one data item in a relational table.


LogicalAnd

An internal function that does a logical "and" operation on two to twenty 88-level condition-name data items or logical internal functions (IsNumeric, LogicalAnd, LogicalOr). If all of the arguments are true, a numeric value of one is returned as the column value. If any of the arguments are false, a numeric value of zero is returned.


LogicalOr

An internal function that does a logical "or" operation on two to twenty 88-level condition-name data items or logical internal functions (IsNumeric, LogicalAnd, LogicalOr). If any of the arguments are true, a numeric value of one is returned as the column value. If all of the arguments are false, a numeric value of zero is returned.


null

A value used in SQL to indicate that the column data value is incorrect, inapplicable, or unavailable. See also condition item and null.


nullable

An indicator that the column data value may be set to null.


ODBC

Abbreviation for Open Database Connectivity, a Microsoft Windows interface allowing applications to access data in database management systems (DBMS) using Structured Query Language (SQL). See also ODBC-enabled application.


ODBC data type

An SQL definition that governs the type of data that is valid for a column in a relational table. The following lists the data type names preassigned to ODBC data types in Relativity:

· Exact numeric data types are bit, smallint, integer, and decimal.

· Approximate numeric data types are single and double.

· Character (or text) data types are char, varchar, and longvarchar.

· Unstructured binary data type is longvarbinary.

· Date/time data types are date, time, and timestamp.

The preassigned data type names for the ODBC data type appear in a bold font on the Table form. See also user data type.


ODBC-enabled application

A Windows-based client application program (or tool) that has been designed to use the ODBC interface to access data external to the application. The ODBC interface requires that a data source be configured in order to allow data access. Examples of such programs include MS-Access, MS-Excel, Lotus 1,2,3, Crystal Reports, PowerBuilder, and so forth.


ODO control item

The data item referenced by the data-name specified in the DEPENDING ON phrase of the OCCURS clause.


Open Database Connectivity

A Microsoft interface allowing applications to access data in database management systems (DBMS) using Structured Query Language (SQL). Abbreviated ODBC.


parallel OCCURS

Two or more separate OCCURS clauses in a record description entry that each specify the same number of occurrences and where the COBOL tables created by the OCCURS clauses can be thought of as really being a single COBOL table accessed by a single subscript item.


RDBMS

Abbreviation for relational database management system, a program or set of programs for managing a relational database. Such a system normally includes a query capability that implements a query language. A common choice for the query language is Structured Query Language (SQL). See also Relativity DBMS.


record type

A particular layout of a record area when multiple layouts exist because of redefinition or varying interpretation of data items in the record area. Normally, record types are distinguished by a record type indicator data item that is either outside any redefinition or exists in every redefinition. Relativity uses an 88-level condition-name defined on the record type indicator to distinguish record types. If the program did not define the appropriate 88-level condition-name(s), the Relativity Designer may be used to add the necessary condition-name(s). See also record type filter.


record type filter

A filter associated with a record type that determines the conditions controlling the subset of records from the file that conform to that record type. When a table is based on the record type, only records that satisfy the specified conditions contribute rows to that table. Those records may be further filtered by a table filter if a table filter is associated with the table. Record type filters are specified on the Record Type Properties form accessed from the FD form in the Relativity Designer.


redundant data items

See item set.


relational database

A type of database that defines multiple and complex relations among different data using tables (rows and columns of data). In a relational database, the rows of a table represent records (collections of information about separate items) and columns represent data items (particular attributes of a record). Relationships among data items are not physically stored. Instead, data is stored in tables, and relationships between two or more records are established by matching the values of columns common to those tables. See also relational database management system.


relational database management system

A program or set of programs for managing a relational database. Such a system normally includes a query capability that implements a query language. A common choice for the query language is Structured Query Language (SQL). Abbreviated RDBMS. See also Relativity DBMS.


relational table

A set of rows where each row contains the same number of columns. In any one column of a table, all the rows have the same value type in that column. Contrast with COBOL table. See also database and table.


Relativity Data Client

The Relativity Data Client is the component of the Relativity DBMS that resides on the Windows client machine and provides the ODBC interface for the two-tier or client/server configuration of Relativity. ODBC-enabled applications running on the client machine access Relativity data on the server machine using the interface implemented in the Data Client. The Data Client is, essentially, the ODBC Driver for Relativity in this configuration. See also Relativity Data Server.


Relativity Data Manager

The Relativity Data Manager is used in the single-tier (or non-client/server) configuration of Relativity where the complete Relativity DBMS resides on a single Windows machine. This component implements the ODBC interface, the file to relational database transformations, and the application data file access routines. All the data files to be accessed must be accessible from the Windows machine, either because the files exist on disk drives attached to that machine or are accessible using the Windows network file system.


Relativity Data Server

The Relativity Data Server is the component of a two-tier or client/server Relativity DBMS that resides on the remote server machine and implements the file to relational database transformations and the application data file access routines. This component runs on the remote machine that has access to the COBOL data files, either directly or through the network file system of the remote machine. See also Relativity Data Client.


Relativity DBMS

The Relativity DBMS (Database Management System) is software that implements an ODBC-compliant and relational database view of actual, operational COBOL data files. The Relativity DBMS also can take instructions from the ODBC-enabled application to access and change data in the COBOL data files. The ODBC-enabled application issues a high-level command, called an SQL statement, describing the data that the application wants to access. The Relativity DBMS performs the same actions a COBOL program would perform in order to extract that data and then returns the data to the ODBC-enabled application in the form of "rows".

The Relativity DBMS comes in two different configurations. In the single-tier or non-client/server configuration, the complete Relativity DBMS resides on a single Windows machine. The single-tier configuration component of the Relativity DBMS is referred to as the Relativity Data Manager. In the two-tier or client/server configuration, the Relativity DBMS is split into two components so that the DBMS can reside on two machines. The two-tier components of the Relativity DBMS are referred to as the Relativity Data Client and the Relativity Data Server. See also data source and catalog.


Relativity Symbol Table file

A file containing one or more COBOL schemas extracted from a COBOL source file. The Relativity Symbol Table file (or RST file) is also called the COBOL schema file. See also COBOL schema.


repeating data item

A data item having a data description entry that either contains the OCCURS clause or is subordinate to a data description entry that contains the OCCURS clause. See COBOL table. A repeating data item is also referred to as a subscripted data item, since such data items generally require a subscript when specified in COBOL source statements.


SQL

Abbreviation for Structured Query Language, a language to access data in a database management system (DBMS). See also ODBC.


Structured Query Language

A language to access data in a database management system (DBMS). Abbreviated SQL. See also ODBC.


subscripted data item

A repeating data item (q.v.).


subscript item

A data item created by the Relativity Designer for each COBOL table. A subscript item, while not an actual part of the record, represents the subscript used to access repeating data items in the record. A column may be based on the subscript item by dragging the subscript item to a relational table in the Table form. Subscript items are given the data-name "SubscriptItem", and they are shown in the FD form immediately following any data item described with the OCCURS clause.


table

In Relativity, a table is usually a relational table composed of rows and columns. In certain cases, made clear by explicit qualification or context, a table is a COBOL table of repeating data items defined by use of the OCCURS clause. See also table filter.


table connection

A table connection is composed of a table name and a path name. (The table name is the name of an SQL table. The path name is the physical filename of a data file.) One or more table connections are associated with a Relativity table definition. Each table connection associated with the same Relativity table definition has identical characteristics except for the path name of the underlying COBOL data file.


table definition

A table definition is created by the Relativity Designer to define the structure of a relational table associated with a COBOL data file.


table filter

A filter associated with a table that determines the conditions controlling the subset of records from the file that contribute rows in that table. If the table is based on one or more record types, the table filter is applied after the record type filters, if any, associated with those record types. A table filter is appropriate when either record types are not used or the table is a subset of the records belonging to the record type upon which the table is based. Table filters are specified on the Table Filter Properties form accessed from the Table form or Table menu in the Relativity Designer.


table name

A table name is the name of an SQL table.


transform

A process of converting a single COBOL data item value to or from a relational database column value. An example would be taking a COBOL PIC 9(8) data item that contains 19970129 and converting it to an ODBC date column that contains January 29, 1997. Compare to internal function.


user data type

A Relativity representation of a domain. A user data type, which is defined by the user, is a named set of properties for a column, including its ODBC data type, length, default value, whether the column allows null values, whether the column is constrained to certain values, and, for numeric type columns, the precision and scale. After a user data type is defined, it can be used in place of ODBC data types in column definitions, thus giving all columns with the same user data type similar characteristics.


Granted (Edit Privileges Form)

The Granted column on the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group has access rights.


Graphic Data Types Form FD

The Data Types form is shown here in design mode.


Graphic Edit Connections Form DSN Connections Button

Note If file labels are in effect, the following example illustrates the Edit Connections form when a selected table definition is opened either from the Tables catalog object in the Catalog window or from the Table form.


Graphic Privilege Dropdown List Table

When you select the following privilege | These items appear in the Not Granted, Granted, and With Grant columns
Administrator | Privileges: Create Groups, Date Constants, Reports, Use Administrator
Create Users | Group names
Create Tables | Table definition names
Table | Table names
Column | Column names (from the table definition associated with the table connection selected in the Table list that is displayed when a Column privilege is selected)


Group List (Edit Privileges Form)

The Group list on the Edit Privileges form contains the names of database groups associated with the catalog. This list contains the groups defined in the Edit Users form and a group called <PUBLIC>. Privileges assigned to the <PUBLIC> group become privileges assigned to all users in the database.

Note When the form is opened from the Users & Catalog object, the selected group is already displayed in the Group list. When the form is opened from the Privileges command on the Security menu, you must select the group from this list.


Group Name (Edit Users Form)

The Group Name attribute on the Edit Users form is the name of a user group associated with the catalog. Each group name and user name within a catalog must be unique.


Handling Multiple Record Types See Also

Defining Null Information

Defining Record Type Filters

Defining Record Types

Defining Table Filters


Help Button Bar See Also

Using Relativity Help


Help Menu Commands See Also

Help Button Bar

Using Relativity Help


Help (Select Character Set)

The Help button displays the related Help screen and provides information about the Select Character Set dialog box.


Help (Write Support Wizard)

The Help button displays the related Help screen. Clicking this button while on one of the issues in the list, will present you with a more detailed explanation of the rule in question, and also give an example.


Hexadecimal Value

A Hexadecimal value is specified as a string of pairs of hexadecimal digits (0-9, A-Z), where each consecutive pair of hexadecimal digits specifies one character of the resultant value. For example, the string 0A0D would represent a value containing the ASCII character NL (newline) followed by CR (carriage return), the string 48494A4B would represent a conditional value containing the ASCII string HIJK, and the string F7F3F9 would represent a value containing the EBCDIC string 739. The Hexadecimal option is only allowed for nonnumeric data items.


Iconize at Open Item Patterns Options

When you select the Iconize at Open option, the Item Patterns form is displayed as an icon when the data source is opened. This option is typically used when the Open when Opening Data Source preference is selected.


Iconize at Open User Types Options

When you select the Iconize at Open option, the Data Types form is displayed as an icon. This option is typically used when the Open when Opening Data Source preference is selected.


Identifying Implicit OCCURS DEPENDING ON See Also

Eliminating Unused Occurrences

Specifying Treatment of the OCCURS Clause


Identifying Parallel OCCURS Clauses See Also

Specifying Treatment of the OCCURS Clause


Import COBOL Source (Import Wizard MF COBOL)

The Import COBOL Source option initiates the procedure to import a COBOL source file into Relativity. Selecting this option enables the Dialect list box, and the Process COBOL.DIR, Display Errors, Debug, and Free Format options if MF COBOL is selected as the dialect.


Import COBOL Source (Import Wizard RM COBOL)

The Import COBOL Source option initiates the procedure to import a COBOL source file into Relativity. Selecting this option enables the Dialect list box and the Compiler Options option if RM/COBOL is selected as the dialect.

Note A number of restrictions exist when using this option in the schema extraction process for RM/COBOL.


Import from Another Relativity Data Source Dialog Box See Also

Importing Definitions from Another Relativity Catalog


Import (Import from Another Relativity Data Source)

The Import button initiates the importing of those objects selected in the Objects in list.


Importing Btrieve Keys (Micro Focus COBOL Only) See Also

Defining Nonstandard Character Sets

Importing COBOL File Definitions

Importing Definitions from Another Relativity Catalog

Re-Importing Btrieve Keys (Micro Focus COBOL Only)


Importing COBOL File Definitions See Also

Defining Nonstandard Character Sets

Importing Btrieve Keys (Micro Focus COBOL Only)

Importing Definitions from Another Relativity Catalog


Importing Definitions from Another Relativity Catalog See Also

Defining Nonstandard Character Sets

Importing Btrieve Keys (Micro Focus COBOL Only)

Importing COBOL File Definitions

Merging COBOL File Definitions


Import Previously Compiled RM/COBOL Program (.COB) (Import Wizard MF COBOL)

The Import Previously Compiled RM/COBOL Program (.COB) option imports the previously compiled RM/COBOL file specified in the File to Import text box.


Import Previously Compiled RM/COBOL Program (Import Wizard RM COBOL)

The Import Previously Compiled RM/COBOL Program (.COB) option imports the previously compiled RM/COBOL file specified in the File to Import text box.

Note A number of restrictions exist when using this option in the schema extraction process for RM/COBOL.


Import Previously Compiled Symbol Table (.RST) (Import Wizard MF COBOL)

The Import Previously Compiled Symbol Table (.RST) option imports the previously compiled Relativity symbol table file specified in the File to Import text box.


Import Previously Compiled Symbol Table (.RST) (Import Wizard RM COBOL)

The Import Previously Compiled Symbol Table (.RST) option imports the previously compiled Relativity symbol table file specified in the File to Import text box.


Include 9s Complement Forms Optional

When the Include 9s Complement Forms check box is selected, transforms incorporating the 9s Complement modifier, which subtracts the value of the COBOL data item from all 9's before computing the date or time value using the modified transform, are displayed.

Note This option is available only if the following line is added to the [Designer] section of the RELDBDSN.INI file:

DateFormat9sEnable=Yes

and the Relativity Designer is restarted. (Liant recommends that this change be made to the RELDBDSN.INI file when the Relativity Designer is not running.)


Include 10s Complement Forms Optional

When the Include 10s Complement Forms check box is selected, transforms incorporating the 10s Complement modifier, which computes the 9s Complement and adds 1 to that value before computing the date or time value using the modified transform, are displayed.

Note This option is available only if the following line is added to the [Designer] section of the RELDBDSN.INI file:

DateFormat10sEnable=Yes

and the Designer is restarted. (Liant recommends that this change be made to the RELDBDSN.INI file when the Relativity Designer is not running.)


Include 3000000 Complement Forms Optional

When the Include 3000000 Complement Forms check box is selected, the transforms incorporating the 3M Complement, which complements the value of the COBOL data item with respect to 3,000,000 based on a date format of CYYMMDD, are displayed.

This option is available only if the following line is added to the [Designer] section of the RELDBDSN.INI file:

DateFormat3MEnable=Yes

and the Relativity Designer restarted. (It is preferable to make the change to the RELDBDSN.INI file when the Relativity Designer is not running.)


Include Configurable Forms

When the Include Configurable Forms check box is selected, the end-user configurable 6-digit (and 8-digit, if the Include YYYY Forms option is selected) date transform(s) are displayed. See Defining Date Constants.


Include Date/Time Forms

When the Include Date/Time Forms check box is selected, combinations of the selected date and time transforms are displayed. For example, if the Include Date/Time Forms, Include YYMMDD Forms, and Include HHMMSShh Forms options are selected, both YYMMDD and YYMMDDHHMMSShh date transforms are displayed.


Include 'Days' Forms

When the Include 'Days' Forms check box is selected, the date transform Days is displayed. The transform represents the number of days since a specific day.


Include DDMMYY Forms

When the Include DDMMYY Forms check box is selected, the date transform DDMMYY choices are displayed.


Include HHMM Forms

When the Include HHMM Forms check box is selected, the time transform HHMM choices are displayed. In addition, if the Include Date/Time Forms check box is selected, HHMM forms of any date transforms are also displayed. For example, if the Include YYMMDD Forms check box is selected, then selecting the Include HHMM Forms check box causes both YYMMDD and YYMMDDHHMM date transforms to be displayed.


Include HHMMSS Forms

When the Include HHMMSS Forms check box is selected, the time transform HHMMSS is displayed. In addition, if the Include Date/Time Forms check box is selected, HHMMSS forms of any date transforms are also displayed. For example, if the Include YYMMDD forms check box is selected, then selecting the Include HHMMSS Forms check box causes both YYMMDD and YYMMDDHHMMSS date transforms to be displayed.


Include HHMMSShh Forms

When the Include HHMMSShh Forms check box is selected, the time transform HHMMSShh is displayed. In addition, if the Include Date/Time Forms check box is selected, HHMMSShh forms of any date transforms are also displayed. For example, if the Include YYMMDD Forms check box is selected, then selecting the Include HHMMSShh Forms check box causes both YYMMDD and YYMMDDHHMMSShh date transforms to be displayed.


Include MMDDYY 30000 Forms Optional

When the Include MMDDYY-30000 Forms check box is selected, the 5-digit NCR packed decimal date transforms are displayed.

Note This option is available only if the following line is added to the [Designer] section of the RELDBDSN.INI file:

DateFormatNCREnable=Yes

and the Relativity Designer restarted. (It is preferable to make the change to the RELDBDSN.INI file when the Relativity Designer is not running.)


Include MMDDYY Forms

When the Include MMDDYY Forms check box is selected, the date transform MMDDYY choices are displayed.


Include Period Begin/End

When the Include Period Begin/End check box is selected, the YYMM01, YYMM31, YY001 and YY365 (and YYYYMM01, YYYYMM31, YYYY001 and YYYY365 if the Include YYYY Forms option is selected) date transforms are displayed. These transforms assume the first or last day of a month or year.


Include '+ Subscript' Forms Optional

When the Include '+ Subscript' Forms check box is selected, the YYDDD, YYDDDHHMM, YYDDDHHMMSS, YYDDDHHMMSShh, YYMMDD, YYMMDDHHMM, YYMMDDHHMMSS, YYMMDDHHMMSShh date transforms are displayed. Also, when the '+ subscript' option is selected, the YYMMDDHHMMSShh date transform is displayed. Finally, if the Include YYYY Forms option is selected, all of the YYYY formats of the date transforms are displayed. All of these transforms allow access to combined date and OCCURS items.

Note This transform is available only if the following line is added to the [Designer] section of the RELDBDSN.INI file:

DateFormatAddSubscriptEnable=Yes

and the Relativity Designer is restarted. (Liant recommends that this change be made to the RELDBDSN.INI file when the Relativity Designer is not running.)

For example:

01 DATA-RECORD.
03 TRAN-DATE PIC 9(6).
03 TRAN-HOUR-THIS-DAY OCCURS 30 PIC 999V9.


Include YYDDD Forms

When the Include YYDDD Forms check box is selected, the date transform YYDDD choices are displayed.


Include YYMMDD Forms

When the Include YYMMDD Forms check box is selected, the date transform YYMMDD choices are displayed.


Include YYYY Forms

When the Include YYYY Forms check box is selected, the date transform YYYY is displayed for any YY form chosen. For example, if the Include YYMMDD Forms check box is selected, then selecting the Include YYYY Forms check box causes YYMMDD and YYYYMMDD date transforms to be displayed.


Independent 'SELECT' Privilege

In a Relativity data source, a given group may have access rights or privileges to a table and to a column within a table. By default, when the Designer is requested to give INSERT, UPDATE, REFERENCES, or DELETE privileges to a table or column, the Designer also automatically (and without being requested to do so) gives a SELECT privilege (an independent privilege) to that same table or column. This occurs because the INSERT, UPDATE, REFERENCES, or DELETE privileges are of little use if the data in the table or column cannot be seen as well.

When the Independent 'SELECT' Privilege option is enabled, the Designer will stop automatically granting the SELECT privilege when INSERT, UPDATE, REFERENCES, or DELETE privileges are granted.

To see how the Table and Column privileges (accessed through the Privilege list on the Edit Privileges form) are affected when this check box

· is selected, click here.

· is not selected, click here.


Index Name (Show Indexes)

The Index Name column contains a unique name generated by Relativity for the index. It typically begins with an x_ and is followed by the numbers of the columns that make up the index, delimited by underscores. It is a requirement of SQL for the Index to have a name; however, it has no other useful purpose, as Relativity will automatically determine the best index to use for a query.


Index Requirements for a Column (Show Indexes)

Requirements for a column to be part of an index

Relativity automatically creates indexes using the columns in the table definition that are associated with record key fields within the file definition. In order for a column to be included in an index that Relativity builds, the underlying key field of the column must have a type that sorts in a numerically ascending manner, with negative numbers coming before zero (and their absolute value decreasing to zero), and positive numbers coming after zero (and their absolute value increasing from zero). The COBOL File Manager sorts all keys as bytes and does not try to interpret their contents. There are many numeric USAGE types that, when used in a file key, cause the record to be returned in a manner that is not numerically sequential. For example, Signed Numeric DISPLAY with trailing separate sign will sort the values -2, -1, 0, 1, 2 as 0, -1, 1, 2, and -2. While this may be a useful sorting for the COBOL application, it violates the SQL definition of an index; thus, a column built on such a key field cannot participate in an index.

Another impediment to a column being included in an index is the way in which item values that are to be interpreted as NULL are sorted by the key field. The SQL definition of an index states that NULL columns must either all appear at the beginning of sorted rows, or all at the end. They may not appear in the middle of the sorted sequence. The biggest issue here is the Configuration option, which causes invalid numeric data to be interpreted as NULL. Setting this Configuration option will cause columns not to be considered as part of an index.

Another common issue is the case in which there are insufficient columns in the table to cover all of the data items of a file's key. In order for a column to participate in an index, there must be columns on all of the preceding data items of the file key. The only exception to this rule is if the values of the data items in those gaps are filled by condition items specified in a filter expression.


Index (Table Form Attributes)

The Index attribute indicates that the column is a member of at least one index that Relativity has created in the table definition. (Use the Show Indexes button, which displays the Show Indexes for Tablename form, to see the indexes that have the column as a member.)

Indexes are important because they allow Relativity to optimize the performance of queries using the file keys in the underlying COBOL data file. When a table contains a column defined on a data item that is part of one of the file keys, and there is no checkmark in the Index attribute, it indicates a condition that is preventing Relativity from using that file's key. This is a condition that should be corrected before proceeding. If none of the columns in the table have the Index attribute checked, this indicates a serious problem because Relativity will be forced to read all the table's rows completely in order to select rows from it.

Note The Index attribute is not valid until the table has been saved. Also note that, even though a column is a member of an index on the table, it does not necessarily mean that Relativity will be able to use the index in a SELECT or UPDATE statement. The index chosen is a function of the columns in the WHERE clause. In order for an index to be used, the WHERE clause should not simply specify the column of interest, but all of the columns necessary to specify the leading portion of the index’s file key. Use the Query Plan Viewer to see the actual index chosen for a query. The Query Plan Viewer is a standalone utility that can be started from the Relativity group on the Windows Start menu or from a command prompt. It is described in the DBMS Help file (which is accessible from the Help menu.)


Inherit FD Comments

When the Inherit FD Comments check box is selected, movement of a data item from the FD form to the Table form also results in the movement of comments (in the Comments column) to the Table form. If the Inherit FD Comments check box is not selected, the comments associated with the FD form are not moved to the Table form.


Internal Functions See Also

Add Function Constant Dialog Box

FD Form

Select Function Dialog Box

Using Functions and Transforms


Invalid Column Name Dialog Box See Also

Create a table definition

Defining Default Column Names


Invalid Dates Return NULL

The Invalid Dates Return NULL option indicates that the Relativity DBMS will return a NULL value for any date or date/time column based on a data item containing invalid date ranges either because the underlying numeric data is invalid, or the month or day is out of range. There are three possible states that may be selected for this option:

· Select Never to cause the DBMS to return an error when this condition is encountered. This is the default.

· Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

· Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.


Invalid Numerics Return Null

The Invalid Numerics Return NULL option indicates that the Relativity DBMS will return a NULL value for any column based on a data item containing invalid numeric data. There are three possible states that may be selected for this option:

· Select Never to cause the DBMS to return an error when this condition is encountered. This is the default.

· Select Yes, Except for Record Key Data Items to cause the DBMS to correct the condition for all data items except for record keys, which will still return an error.

· Select Always to cause the DBMS to correct the condition in all instances.

Note Selecting the Always state will result in some numeric data items not being available to participate in SQL indexes.


IsNumeric Internal Function

The IsNumeric internal function evaluates the data item supplied as an argument to determine whether its value is a valid numeric value. If the data item is numeric, the function returns the value 1, which is the logical value of true. If the data item is not numeric, the function returns the value 0, which is the logical value of false.


Issue Label (Write Support Wizard)

The Issue Label area describes the issue found by the Write Support wizard. (For a complete list of rules that is checked by the Write Support wizard, see Rules for Insertable Tables.)


IsValidDate Internal Function

The IsValidDate internal function evaluates the data item supplied as an argument to determine whether its value conforms to that item’s date transform. If the date item value represents a valid date, the function returns the numeric value 1, which is the logical value of true. If the data item value does not represent a valid date, the function returns the numeric value 0, which is the logical value of false.


Item Patterns Form See Also

Defining Item Patterns

Defining User Data Types

Pattern Matching

Transforms


Item Patterns Options See Also

Configuring a Relativity Data Source

Defining Item Patterns

Setting Options

Tools Menu Commands


Item Transform

The Item Transform attribute specifies the transforms to be used to convert a COBOL data item value to and/or from a relational database column value. The transform is selected from the Item Transform list.


Item Transform (Edit Data Item Pattern)

The Item Transform attribute transforms (converts) a COBOL data item value to and/or from a relational database column value. The transform is selected from the Item Transform list.


Item Transform (Item Patterns Form)

The Item Transform attribute specifies a data transformation for a COBOL data item value to/from a relational database column value. The transform is changed by selecting a transform from the list.


Item Transform (Select Data Type)

The Item Transform column lists the transform associated with the item pattern.


Item Type

The Item Type list displays a list of COBOL data types from which to select the data type of the data item being defined. The options selected on the COBOL Types page in the Options dialog box determine the choices available in the Item Type list.


Item Type (Add Data Item Pattern)

When the Item Type check box is selected in the Item Pattern area, a list of data types is enabled to allow the selection of the data type of the data item being defined.


Item Type (Add File Label)

In the Item Type box, select the type to be given to the file label item.

Note Currently, the only item type supported for file labels is Alphanumeric edited.


Item Type (Edit Data Item Pattern)

When the Item Type check box is selected, a list of data types is enabled to allow the selection of the data type of the data item being defined.


JUSTIFIED

When the JUSTIFIED check box is selected, the catalog accepts data items described with the JUSTIFIED clause.


Key Rule See Also

Building Writable Tables

Rules for Insertable Tables


Left Pane (FD Properties)

Use this area of the FD Properties form to view the properties for the selected file definition. In the left pane, click the plus sign [+] to expand the item and select one of the items within the list. The properties related to that item are displayed in the right pane.


Length

In the Length box, enter a value for the length of the data item being defined. The maximum length that can be specified is determined by the number of characters in the data item whose portion is being redefined by the Add COBOL Data Item Redefinition dialog box.


Length (Add Data Item Pattern)

When the Length check box is selected in the Item Pattern area, a text box is enabled that allows you to specify the number of storage characters in the data item pattern.


Length (Add Data Type)

Under Column Properties, the Length box specifies the length of the item as represented in an SQL column.


Length (Add File Label)

In the Length box, enter the maximum length of the value for the file label item.


Length Changes

Under Resolve, selecting the Length Changes check box instructs Relativity automatically to resolve changes in the length of COBOL data items during the merging process.


Length (Edit Data Item Pattern)

When the Length check box is selected, a text box is enabled that allows you to specify the number of storage characters in the data item pattern.


Length (Item Patterns Form)

The Length attribute specifies the number of characters in an alphanumeric data item. A value of N/A implies that the Length attribute is not used when qualifying data items for this user data type.


Length (Table Form Column Property)

The Length property specifies the number of characters in an alphanumeric data item.


Level Numbers

In the Level Numbers box, type a comma-separated list of numbers indicating the desired level numbers to be used either when exporting an FD (see Export FD on the FD form toolbar) or when importing COBOL file definitions from RM/COBOL object programs.

The first number must be 1 followed by ascending values. The level numbers are implicitly extended using the difference of the last two numbers in the series. Thus, 1,3 indicates that the level numbers are to be 1,3,5,7,9,... and 1,5,10 indicates that the level numbers are to be 1,5,10,15,20,... (note that 1,5 would indicate 1,5,9,13,...).

When importing, level numbers are required only if you are importing COBOL file definitions from RM/COBOL object programs. RM/COBOL object programs do not contain the original level numbers for data items defined in a record description and must be specified in the Level numbers box. The generated level numbers are stored in the catalog during import and will not be changed if the level numbers option is changed after the import.

Note It is not necessary to specify level numbers if you import COBOL file definitions from a Relativity Symbol Table (RST) file, because existing source level information is preserved through the catalog.


Linkage Section

Selecting the Linkage check box causes the display of data items from the Linkage Section of the COBOL program.


List Area (Save Export As)

The List area displays all the folders and files in the selected location. To open any folder or file, click its name in the list. You can toggle the manner in which information is displayed in this area with the options available from the View Menu toolbar button.


List Area (Select Report)

The List area displays a list of all the report definition files for the specified file type in the currently selected location. You can toggle the manner in which information is displayed in this area with the View Menu toolbar button.


List Area (Select RM/COBOL Program)

The List area displays a list of all the previously compiled RM/COBOL object file programs to be imported or merged into the Relativity catalog. You can toggle the manner in which information is displayed in this area with the View Menu toolbar button.


List Area (Select Symbol Table)

The List area displays a list of all the previously compiled RM/COBOL symbol table files to be imported or merged into the Relativity catalog in the currently selected location. You can toggle the manner in which information is displayed in this area with the View Menu toolbar button.


List Area (SQL Window)

This is the area where you enter your SQL SELECT statements, conditions, and parameters or expressions.


List area (Welcome to Relativity Window)

· If the New option is selected, the List area allows you to select the appropriate driver (if multiple drivers are installed on your system) and then create a new data source. To see an example, click here.

· If either the Existing or Recent option is selected, the List area allows you to quickly open an existing or reopen a most recently used data source. Note that if a data source is selected from this list, any open, existing data source is closed, and the selected data source is opened.

The data sources displayed in this list depend on which option is selected:

-  If the Existing option is selected, the list displays the available catalogs associated with the data source (for the selected driver, if necessary).

-  If the Recent option is selected, a numbered list displays up to the last four data sources recently opened by the Relativity Designer. The default number of data sources displayed is four. This number can be adjusted by adding the following entry (or modifying an existing entry) in the [Designer] section of the RELDBDSN.INI file:

RecentFileCount=n

where n is a number from 0 to 9.


LogicalAnd Internal Function

The LogicalAnd internal function does a logical "and" operation on two to twenty 88-level condition-names or logical internal functions (IsNumeric, LogicalAnd, LogicalOr). If all of the arguments are true, the function returns the numeric value 1, which is the logical value of true. If any of the arguments are false, the function returns the numeric value 0, which is the logical value of false.


Logical Order Definition Popup

Logical order is the way that the text is typed on a keyboard. Rather than left-to-right or right-to-left, the characters are represented first-to-last. The text may contain embedded control characters that indicate the direction of the subsequent text.


LogicalOr Internal Function

The LogicalOr internal function does a logical "or" operation on two to twenty 88-level condition-names or logical internal functions (IsNumeric, LogicalAnd, LogicalOr). If any of the arguments are true, the function returns the numeric value 1, which is the logical value of true. If all of the arguments are false, the function returns the numeric value 0, which is the logical value of false.


Logon Dialog Box See Also

Change Catalog Owner Dialog Box

Configuring a Relativity Data Source

Defining Catalog Ownership

Defining Groups and Users


Look in (Select COBOL Source)

In the Look in list, select the drive and folder containing the COBOL source file to be imported or merged into the Relativity catalog.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.


Look In (Select Report)

The Look in list box indicates the current location of the report definition file for the specified report category.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.


Look in (Select RM/COBOL Program)

In the Look in list, select the drive and folder containing the RM/COBOL object file to be imported or merged into the Relativity catalog.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.


Look in (Select Symbol Table)

In the Look in list, select the drive and folder containing the Relativity symbol table file to be imported or merged into the Relativity catalog.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.


Magnify (FD Form Toolbar)

The Magnify button expands or contracts the FD form horizontally to display either the detail or abbreviated description of the data item.


Magnify (Resolve Merge Differences)

The Magnify button displays the Merged FD grid. The Merged FD grid contains a detailed list of all data items from the merged (new) version of the COBOL file definitions as they will be saved in the catalog at the end of the merging process. The attributes shown in the Merged FD grid are the same as the attributes that are displayed in the FD form.

The Merged FD grid is displayed only when the Magnify button is clicked. The Merged FD grid does not permit edit operations. To view an example of the Merged FD grid in the Resolve Merge Differences dialog box, click here.


Maintaining Character Sets See Also

Defining Nonstandard Character Sets

Importing Btrieve Keys (Micro Focus COBOL Only)

Importing COBOL File Definitions

Importing Definitions from Another Relativity Catalog


make_rst Program

The installation directory of the Relativity Data Servers for UNIX includes a program, make_rst, which can be used on the UNIX machine to create a Relativity Symbol Table file (or RST file) for later import by the Relativity Designer. This command for this program has the following command line syntax.

./make_rst filename directive...

where:

filename is the name of COBOL source file.

directive can be 0, 1, or more compiler directives (quotes in directives must be quoted as \").

This program makes use of a temporary file. If the environment variable, TMP, is defined with a value of a directory name, the temporary file is written there. Otherwise, the file is written to the current directory. If this program completes normally, the temporary file is removed.

Note The task of creating a Relativity Symbol Table file (or RST file) can also be accomplished by using the Source Code Import wizard.


Make Uppercase (Table Wizard Edit)

Under Edit Column Names, the Make Uppercase check box toggles between whether the column names will be in mixed case or uppercase letters.


Match File Label (Add Connections Matching)

If the check box preceding the Match File Label box is selected, you can enter the matching pattern for the file label item in the Edit Connections form.

Note This box appears only if a file label item has been added to the FD on which the table is based. For more information, see Supporting Multi-File Tables.


Match Path Name (Add Connections Matching Pattern)

If the check box preceding the Match Path Name is selected, you can enter the matching pattern for the path name in the Edit Connections form. Each occurrence of the matching pattern within table names in the Edit Connections form results in the addition of a table connection with the specified table name and path name.


Match Path Name (Delete Connections Matching Pattern)

If the check box preceding Match Path Name box is selected, the matching pattern must be present in the path name for deletion of the table connection. The Match Path Name box specifies the matching pattern that must be present in the path name for deletion of the table connection.


Match Path Name (Edit Connections Matching Pattern)

If the check box preceding the Match Path Name box is selected, the matching pattern must be present in the path name for editing the table connection. The Match Path Name box specifies the matching pattern that must be present in the path name for editing the table connection.


Match Table Name (Add Connections Matching Pattern)

If the check box preceding the Match Table Name box is selected, you can enter the matching pattern for the table name in the Edit Connections form. Each occurrence of the matching pattern within table names in the Edit Connections form results in the addition of a table connection with the specified table name and path name.


Match Table Name (Delete Connections Matching Pattern)

If the check box preceding the Match Table Name box is selected, the matching pattern must be present in the table name for deletion of the table connection. The Match Table Name box specifies the matching pattern that must be present in the table name for deletion of the table connection.


Match Table Name (Edit Connections Matching Pattern)

If the check box preceding the Match Table Name box is selected, the matching pattern must be present in the table name for editing the table connection. The Match Table Name box specifies the matching pattern that must be present in the table name for editing the table connection.


Match Whole Word (Find Table)

When Match Whole Word is selected, Relativity searches only for occurrences that are whole words and not part of a larger word.


Max Row and Max Errors (Query)

Use the Max Rows box to enter the maximum number of rows in the table to be processed for the query.

Use the Max Errors box to enter the maximum number of errors to report. When errors are reported in the Show Table Contents form, you can correct them in the appropriate column in the Table form.


Merge COBOL Source (Merge Wizard MF COBOL)

The Merge COBOL Source option initiates the procedure to merge a COBOL source file into Relativity. Selecting this option enables the Dialect list box, and the Process COBOL.DIR, Display Errors, Debug, and Free Format options if MF COBOL is selected as the dialect.


Merge COBOL Source (Merge Wizard RM)

The Merge COBOL Source option initiates the procedure to merge a COBOL source file into Relativity. Selecting this option enables the Dialect list box and the Compiler Options option if RM/COBOL is selected as the dialect.


Merge Command Button (Files Tab)

The Merge button displays the Source Code Merge wizard for the selection of the COBOL data files for the merging process.

Note The Merge COBOL FD Changes command on the FD menu provides the same functionality as the Merge button.


Merge Details Dialog Box See Also

Automated Resolution Dialog Box

Merging COBOL File Definitions

Resolving Merge Differences


Merge Item

The Merge Item area displays the name of an` item in the updated data file.


Merge Previously Compiled RM/COBOL Program (.COB) (Merge Wizard MF COBOL)

The Merge Previously Compiled RM/COBOL Program (.COB) option merges the previously compiled RM/COBOL file specified in the File to Import text box.


Merge Previously Compiled RM/COBOL Program (.COB) (Merge Wizard RM COBOL)

The Merge Previously Compiled RM/COBOL Program (.COB) option merges the previously compiled RM/COBOL file specified in the File to Import text box.


Merge Previously Compiled Symbol Table (.RST) (Merge Wizard MF COBOL)

The Merge Previously Compiled Symbol Table (.RST) option merges the previously compiled Relativity Symbol Table file specified in the File to Import text box.


Merge Previously Compiled Symbol Table (.RST) (Merge Wizard RM COBOL)

The Merge Previously Compiled Symbol Table (.RST) option merges the previously compiled Relativity Symbol Table file specified in the File to Import text box.


Merge Version - Changed Items

The Merged Version - Changed Items list contains a list of all data items from the merged (new) version of the COBOL file definition. The data items in this list do not match any data items in the previous version of the COBOL file definition. Also listed are the data items that have not been resolved through user interaction. The Merged Version - Changed Items list must be empty before the merging process may continue.


Merging COBOL File Definitions See Also

Defining Nonstandard Character Sets

File Schema Maintenance

Resolving Merge Differences


Micro Focus COBOL Compiler Directives Processing See Also

Creating a COBOL Schema File


Micro Focus COBOL Compiler Directives See Also

Creating a COBOL Schema File

Source Code Import Wizard (with Micro Focus COBOL as the Dialect)


Micro Focus Types

Select the Micro Focus Types check box to include Micro Focus COBOL data types in the list of data types displayed in the Item Type list in the Add COBOL Data Item Redefinition dialog box. Selecting this box also displays the Data File Format box on the Data Source page.

If the data files to be accessed through this catalog do not include any Micro Focus COBOL data types, do not select this check box.


Modify Existing FD Character Set

Use the Modify Existing FD Character Set area to change an existing character set for all file definitions in a data source when the wrong character set is associated with those FDs. First, select the name of the character set that is currently associated with the file definitions from the Change From list box. Next, select the name of the character set that actually describes the data within the data source's files from the To list box. Then click the Change button. A Status Report dialog box shows a record of the action just taken.

Note This capability is different from that described in the procedure on how to modify an existing Relativity character set, in the topic Defining Nonstandard Character Sets, which has to do with modifying a character set in some way to suit a particular need.


Modifying an Existing Record See Also

Building Writable Tables


Move Down (Table Form Toolbar)

The Move Down button moves one or more selected column definition(s) down one position in the table. For information on selecting column definitions, click here.

Note This option provides the same functionality as the Move Down command on the Table menu.


Move Left Granted and With Grant (Edit Privileges Form)

The Move Left toolbar button between the Granted and With Grant columns on the Edit Privileges form moves the selected item(s) from the With Grant column to the Granted column.

Note Using the Move Left button to move an item from the With Grant column to the Granted column is the equivalent of the action performed by the SQL REVOKE statement specifying the GRANT OPTION FOR phrase (REVOKE GRANT OPTION FOR privilege-list ON object FROM user-list). That is, the privilege is again in the state of having been granted without the grant option.


Move Left Not Granted and Granted (Edit Privileges Form)

The Move Left toolbar button between the Not Granted and Granted columns on the Edit Privileges form moves the selected item(s) from the Granted column to the Not Granted column.

Note Using the Move Left button to move an item from the Granted column to the Not Granted column is the equivalent of the action performed by the SQL REVOKE statement. That is, the privilege is now revoked and is in the state of being not granted.


Move Right Granted and With Grant (Edit Privileges Form)

The Move Right toolbar button between the Granted and With Grant columns on the Edit Privileges form moves the selected item(s) from the Granted column to the With Grant column.

Note Using the Move Right button to move an item from the Granted column to the With Grant column is equivalent to having specified the WITH GRANT OPTION phrase in the SQL GRANT statement. That is, the privilege is now in the state of having been granted with the grant option.


Move Right Not Granted and Granted (Edit Privileges Form)

The Move Right toolbar button between the Not Granted and Granted columns on the Edit Privileges form moves the selected item(s) from the Not Granted column to the Granted column.

Note Using the Move Right button to move an item from the Not Granted column to the Granted column is the equivalent of the action performed by the SQL GRANT statement without the WITH GRANT OPTION phrase. That is, the privilege is now in the state of having been granted.


Move Up (Table Form Toolbar)

The Move Up button moves one or more selected column definition(s) up one position in the table. For information on selecting column definitions, click here.

Note This option provides the same functionality as the Move Up command on the Table menu.


Name

In the Name box, type the data-name to be assigned to the data item being defined. This data-name must conform to the rules for a COBOL data-name.


Name (Add File Label)

In the Name box, type the name to be given to the file label item.


Name (Choose Subscript Values)

The Column Name column contains the name of the 88-level condition-name (which is established in the Add Condition Item dialog box).


Name (Data Types Form)

In the Data Types form, the Name attribute is the name assigned to the user data type being defined. This data type name will appear in the list of the Data Type attribute on the Table form. This data type name must be unique.


Name (Logon)

In the Name box, type the name of the user of the catalog. If privileges have been defined for the catalog, the user name must belong to a group having the Use Administrator privilege.


Native Charset (FD Properties)

In the Properties area of the FD Properties form, the Native Charset box indicates the character set of the data in the actual data file. The Relativity DBMS makes use of this information to translate to and/or from the character set in use at the time the data is accessed. This box is informational only.


NATIVE"string"

The NATIVE"string" directive specifies the default program collating sequence for comparisons, where string is either ASCII or EBCDIC. An explicit PROGRAM COLLATING SEQUENCE clause in the source program overrides the NATIVE directive setting.


Network (Save Export File As)

The Network button displays the standard Windows Connect Network Drive dialog box.


New 88 Name

In the New 88 Name box, type the 88-level condition-name to be assigned to a data description entry. The condition-name must conform to the rules for a COBOL condition-name.


New Command Button (Files Tab)

The New button displays the Source Code Import wizard for the selection of the COBOL data files for the importing process.

Note The Import COBOL FDs command on the FD menu provides the same functionality as the New button.


New Command Button (Tables Tab)

The New button displays an empty Table form for the creation of a new table.


New Command Button (Users Tab)

The New button displays the Edit Users form for the definition of a new group or user for the catalog.

Note The Users command on the Security menu provides the same functionality as the New button.


New Group Name (Add Database Group)

In the New Group Name box, type the name of the new group to be added to the list of database groups associated with the catalog. Each group name and user name must be unique within a catalog.


New Group Name (Edit Group Dialog)

In the New Group Name box, type the new name for the group being renamed. This name will be added to the list of database groups associated with the catalog. Each group name and user name must be unique within a catalog.


New Item

The New Item button removes the selected data item from the Merged Version - Changed Items list. The data item is added to the merged COBOL file definition as a new COBOL data item.


New Keys

The New Keys button directs Relativity to use the keys from the file being merged. This means that the keys will come from the merged-in file.


New Owner Name

In the New Owner Name list, select the name of the new owner of the catalog. This list contains the name of database groups associated with the current catalog.


New Password

In the New Password box, type a new password for the selected group or user. An asterisk (*) character is displayed for each character entered. This entry is optional.


New (Select Character Set)

The New button displays a standard Windows dialog box that allows you to specify the file that contains the character set you want to use. Character set files have the extension, .cs.

Note This button provides the same functionality as the Import button on the Character Set Maintenance dialog box.


New Table Name (Copy Table)

In the New Table Name box, type a unique new table name for the table connection.


New Table Name (Create New Table)

In the New Table Name box, type the table name to be assigned to the table to be created. A table name must begin with an alphabetic character. The remaining characters can be any combination of alphabetic, numeric, or underscore characters. A table name must not, however, be an SQL reserved word.


New User Name (Add Database User)

In the New User Name box, type the name of the new user to be added to the selected database group within the catalog. Each group name and user name must be unique within a catalog.


New User Name (Edit User Dialog)

In the New User Name box, type the new name for the user being renamed. This name will be added to the selected database group within the catalog. Each group name and user name must be unique within a catalog.


New (Welcome to Relativity Window)

Select the New option to set up and create a new data source. (An ODBC data source name is used to refer to the database, indirectly through the Relativity catalog that describes the database.) If you have multiple drivers installed, select the appropriate driver from the List area and then create a new data source. For more information, see Setting Up a New Data Source.)

Note This option provides the same functionality as the New Data Source command on the File menu.


Next (Add Condition Item)

The Next button enables you to define the next value for multiple values within the VALUE clause associated with the condition-name being defined.


Next (Bind Subscripts)

The Next button advances to the next subscript when two or more subscripts are associated with the data item.


Next (Import Detected Errors Page)

The Next button is not enabled on the Detected Errors page of the Source Code Import wizard.


Next (Import File Selection Page COB RST)

The Next button is not enabled on the File Selection page of the Source Code Import wizard.


Next (Import File Selection Page COB)

The Next button is not enabled on the File Selection page of the Source Code Import wizard.


Next (Import Wizard MF COBOL)

The Next button opens the File Selection page of the Source Code Import wizard. The File Selection page provides different capabilities, depending upon the type of file being imported.

· If you are importing a COBOL source file (.cbl) or a previously compiled symbol table file (.rst), click here.

· If you are importing a previously compiled RM/COBOL object program (.cob), click here.


Next (Import Wizard RM)

The Next button opens the File Selection page of the Source Code Import wizard. The File Selection page provides different capabilities, depending upon the type of file being imported.

· If you are importing a COBOL source file (.cbl) or a previously compiled symbol table file (.rst), click here.

· If you are importing a previously compiled RM/COBOL object program (.cob), click here.


Next (Merge Detected Errors Page)

The Next button is not enabled on the Detected Errors page of the Source Code Merge wizard.


Next (Merge File Selection Page CBL RST)

The Next button is not enabled on the File Selection page of the Source Code Merge wizard.


Next (Merge File Selection Page COB)

The Next button is not enabled on the File Selection page of the Source Code Merge wizard.


Next (Merge Wizard MF COBOL)

The Next button opens the File Selection page of the Source Code Merge wizard. The File Selection page provides different capabilities, depending upon the type of file being imported for the merge procedure.

· If you are importing a COBOL source file (.cbl) or a previously compiled symbol table file (.rst), click here.

· If you are importing a previously compiled RM/COBOL object program (.cob), click here.


Next (Merge Wizard RM COBOL)

The Next button opens the File Selection page of the Source Code Merge wizard. The File Selection page provides different capabilities, depending upon the type of file being imported for the merge procedure:

· If you are importing a COBOL source file (.cbl) or a previously compiled symbol table file (.rst), click here.

· If you are importing a previously compiled RM/COBOL object program (.cob), click here.


Next (Table Wizard)

The Next button opens the Edit page of the Table wizard.


Next (Table Wizard Edit)

The Next button is disabled.


Next (Write Support Wizard)

The Next button is used to proceed to the next issue found by the Write Support wizard. When the button is not enabled, there are no more issues in the list.


[NO]COBOLDIR

The [NO]COBOLDIR directive disables or enables automatic processing of the cobol.dir directives file. You can specify NOCOBOLDIR on the command line to suppress the automatic processing of cobol.dir. Since the command line is actually processed after the cobol.dir file, the directive NOCOBOLDIR causes the directive settings made by the cobol.dir file to be reset to their default values. This is consistent with the Micro Focus COBOL compiler implementation.


[NO]DIRECTIVES-IN-COMMENTS

The [NO]DIRECTIVES-IN-COMMENTS directive disables or enables the scanning of $SET statements in comment lines of the source file. Note that there is an undocumented dependency on DOS and Windows, but not on UNIX: any $SET statement in a non-comment line that does not specify NODIRECTIVES-IN-COMMENTS sets DIRECTIVES-IN-COMMENTS immediately.


[NO]EARLY-RELEASE

The [NO]EARLY-RELEASE directive disables or enables some early release features. In the current implementation for Relativity, this simply means that some early release directives are absent from or present in the listing produced by the SETTING directive, depending on whether EARLY-RELEASE has been specified.


[NO]FOLD-COPY-NAME["string"]

The [NO]FOLD-COPY-NAME["string"] directive determines whether COPY file-names are converted to uppercase or lowercase. The string parameter may specify UPPER or LOWER for the case conversion. NOFOLD-COPY-NAME indicates no case conversion for copy file-names.


[NO]IBMCOMP

The [NO]IBMCOMP directive disables or enables word-storage mode for binary data items; that is, BINARY, COMP-4, and COMP-5 data items. When word-storage mode is enabled by the IBMCOMP directive setting, the alignment of binary data items that use the SYNCHRONIZED clause follows IBM alignment rules. Word-storage mode for COMP-5 items occurs when IBMCOMP is specified, even if the COMP-5 item is described with an alphanumeric PICTURE character-string. This directive does not affect the allocation of COMP-6 data items, even when they use binary storage because of a COMP-6"1" directive setting. This directive does not affect the allocation of COMP-X data items. The state of having word-storage mode disabled is referred to as byte-storage mode, which is the default Micro Focus COBOL storage mode.


[NO]LIST"string"

The [NO]LIST"string" directive disables or enables the listing of source records to a listing file, where the file is specified by the string parameter. The main functionality of this directive is not supported for Relativity, since all source records are listed to the sourcename.int file, regardless of LIST and NOLIST directive settings. However, because of dependencies that are supported, such as NOLIST (the default) setting NOSETTING at end, the LIST directive must be specified in order to avoid suppressing the SETTING directive.


[NO]MFCOMMENT

The [NO]MFCOMMENT directive disables or enables support for Micro Focus COBOL comment lines; that is, source lines with an asterisk in column 1.


[NO]ODOSLIDE

The [NO]ODOSLIDE directive disables or enables sliding data for data description entries that follow, but are not subordinate to, an OCCURS DEPENDING ON clause in a record description entry. NOODOSLIDE, the default, results in fixed locations for such data. ODOSLIDE causes the data to have variable addresses depending on the current value of the data item specified in the DEPENDING ON phrase.


[NO]RM["ANSI"]

The [NO]RM["ANSI"] directive disables or enables RM COBOL dialect support. RM and RM"ANSI" are only partially supported in that they do not yet affect the reserved word list. They do modify COMP usage to be equivalent to DISPLAY usage, COMP-1 usage to be equivalent to RM COMP-1 usage (instead of single precision floating point as is the default for Micro Focus COMP-1), and the SYNCHRONIZED clause to cause two-byte alignment of data items. Also, RM without the "ANSI" parameter sets the default for signed numeric DISPLAY data to use a separate sign in the absence of a SIGN clause. Note that there is an undocumented dependency that RM and RM"ANSI" set COMP-6"1" immediately on DOS and Windows. However, this dependency does not occur on UNIX.


[NO]SETTINGS["string"]

The [NO]SETTINGS["string"] directive is a synonym for the SETTING directive, q.v.


[NO]SETTING["string"]

The [NO]SETTING["string"] directive disables or enables the listing of the directives to the sourcename.int file and specifies the format of the listing when enabling directive listing. Note that this directive is not acted upon immediately per the Micro Focus COBOL implementation. If this directive is specified other than on a $SET statement (that is, in cobol.dir), the command line, or in a directives file specified directly or indirectly from cobol.dir or the command line, then the settings are shown immediately before the source program is processed. If the directive is specified in a $SET statement, or a directives file referenced directly or indirectly from a $SET statement, then the settings are shown after all the directives on that $SET statement line have been processed. After the settings are listed, the directive is automatically reset to NOSETTING. The string parameter specifies a listing format of LINE, COL, or COL3. The Relativity COL and COL3 format listings exactly match the corresponding Micro Focus COBOL listings. The Relativity LINE format listing has slightly different line breaks since Relativity does not split a directive and its parameter across lines, even though the Micro Focus COBOL LINE format listing does split directives and parameters in some cases.


[NO]SHOW-DIR

The [NO]SHOW-DIR directive disables or enables the listing of directives files that are processed because of DIR, DIRECTIVES, or USE directives that occur in $SET statements. The directives file is listed in the sourcename.int file if SHOW-DIR has been specified. The ability to list the cobol.dir file or directives files specified from the command line is not currently implemented in Relativity. The format of the listing also differs from that used by Micro Focus COBOL in that Micro Focus lists each directive on a line by itself preceded by "Accepted: ", whereas Relativity lists each line from the directive file as it is read.


Not Granted (Edit Privileges Form)

The Not Granted column on the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group does not have access rights.


Not Null (FD Form Attributes)

In the expanded FD form, the Not Null attribute, when set, indicates that an SQL column defined on this item is null when the null condition is false. The Not Null attribute is initially not set, indicating that an SQL column defined on this item is Null when the Null condition is true. See Defining Null Information.

The Not Null attribute column is displayed in the FD form only if the Show Null Information check box is selected on the File page in the Options dialog box.


Not (Record Type Toolbar)

The Not attribute specifies whether the NOT logical operator is applied to this filter subexpression of the filter expression being defined:

· If the Not attribute is selected as blank, the condition specified by the condition-name in the Condition attribute column must be true for records to pass the filter.

· If the Not attribute indicates the NOT logical operator, the condition specified by the condition-name in the Condition attribute column must be false.


[NO]TRUNCCOPY["integer"]

The [NO]TRUNCCOPY["integer"] directive disables or enables the truncation of copy file names to integer characters in length, where integer is from 8 to 255. This truncation will probably only have an effect on systems that support long filenames, such as UNIX, since DOS truncates filenames to 8 characters in all cases. Micro Focus COBOL documents this as an initial $SET statement, but since Micro Focus does not validate this, it is implemented as allowed in any $SET statement and affects all COPY statements which follow until another TRUNCCOPY directive occurs.


Not Selected Select Privilege

Privilege | Action
Table: ALL Column: ALL | Adds or removes all related privileges.
Table: select Column: select | Adds 'SELECT' privilege or removes all privileges.
Table/Column: insert, update, references, delete | Adds named privilege and 'SELECT' privilege or removes only named privilege.


Not (Table Filter Properties)

The Not attribute specifies whether the NOT logical operator is applied to this filter subexpression of the filter expression being defined:

· If the Not attribute is selected as blank, the condition specified by the condition-name in the Condition attribute must be true in order for records to pass the filter.

· If the Not attribute indicates the NOT logical operator, the condition specified by the condition-name in the Condition attribute must be false.


Nullable (Add Data Type)

The Nullable attribute indicates that this data type can create null column values. The COBOL representation of a null for a data type is selected from a list of condition-names in the FD form COBOL data item for which a nullable column is defined.

If the condition specified by the condition-name is true, then the data item in the FD form is considered to have a null value, the value of a data item to one of the true values indicated by an 88-level condition-name. You may add 88-level condition-names if the program does not have them.

The conditional variable associated with a condition-name in the list does not have to be the data item in the FD form for which the null value is defined.


Nullable Columns Rule See Also

Building Writable Tables

Defining Null Information

FD Form

Rules for Insertable Tables

Table Form


Nullable Column Utility Pages See Also

Defining Null Information

Determining Record Type

Handling Multiple Record Types

Nullable Columns Rule


Nullable (Table Form Column Property)

The Nullable property indicates that this column allows nulls. The representation of a null value for a data item is selected from a list of condition-names in the FD form. If the condition specified by the condition-name is true for a record, then the column will contain null for the row(s) derived from that record.

The conditional variable associated with a condition-name in the list does not have to be the data item in the FD form for which the null value is defined.


Null Condition Rule See Also

Building Writable Tables

Defining Null Information

Rules for Insertable Tables


Null Value (FD Form Attributes)

In the expanded FD form, the Null Value attribute describes the data value that will produce a null, or will be stored when a null is written, in an SQL column using this data item. The representation of a null for a data item in the FD form is selected from a list of condition-names. The conditional variable associated with a condition-name in the list does not have to be the data item on the FD form for which the Null Value attribute is being defined. See Defining Null Information.

The Null Value attribute column is displayed in the FD form only if the Show Null Information check box is selected on the File page in the Options dialog box.


Numeric (Add Function Constant)

If selected, the Numeric option button specifies that the argument will be numeric.


Numeric Edited

When the Numeric Edited check box is selected, the catalog includes the numeric edited data type described by the PICTURE character-string; for example, PIC Z9.99.


Objects In

The Objects in list displays all the objects of the type specified in the Object Type list. Select the objects for which importing is desired prior to clicking Import.


Object Types

The Object Type list contains a list of the Relativity catalog object types available. The object types available are files, tables, and user data type definitions. Selecting an object type causes the contents of the objects in the Objects in list to be updated with the objects of the appropriate type.


Occurs (FD Form Attributes)

In the expanded FD form, the OCCURS attribute is the same number as appears in the OCCURS clause for data items whose descriptions contain the OCCURS clause.


OCCURS Rule See Also

Building Writable Tables

Determining Occurrence Count

Identifying Implicit OCCURS DEPENDING ON

Rules for Insertable Tables


ODBC Data Source Administrator Dialog Box See Also

Configuring a Relativity Data Source


ODO (FD Form Toolbar)

The Occurs Depending On button defines a table structure that simulates the relationship of the OCCURS clause with the DEPENDING ON phrase for the selected data items in the FD form. The item on which the number of occurrences depends is displayed in the Occurs column on the FD form. See Identifying Implicit Occurs Depending On.


Offset

In the Offset box, enter a value for the offset of the data item being defined. An offset value of 1 indicates that the data item being defined begins in the first character in the containing data item. An offset value of 3 indicates that the data item being defined begins in the third character of the containing data item.


OK (Add Database Group)

The OK button completes the Add Database Group dialog box by accepting the new group name in the dialog box.


OK (Add Database User)

The OK button completes the Add Database User dialog box by accepting the new user name into the selected group.


OK (Add Record Type)

The OK button completes the Add Record Type dialog box by accepting the record-name typed in the box.


OK (Change Catalog Owner)

The OK button completes the Change Catalog Owner dialog box by accepting all entries made in the dialog box.


OK (Change Password)

The OK button completes the Change Password dialog box by accepting all entries made within the dialog box.


OK (Choose Subscript Values)

Click the OK button to complete the Choose Subscript Values dialog box and accept all selections made within the dialog box.


OK Command Button (COBOL Types Options)

The OK button accepts all the selected options in the Options dialog box and closes the dialog box.


OK Command Button (Data Source Options)

The OK button accepts all the selected options in the Options dialog box and closes the dialog box.


OK Command Button (Date Formats Options)

The OK button accepts all the selected options in the Options dialog box and closes the dialog box.


OK Command Button (File Options)

The OK button accepts all the selected options in the Options dialog box and closes the dialog box.


OK Command Button (Item Patterns Options)

The OK button accepts all the selected options in the Options dialog box and closes the dialog box.


OK Command Button (Privilege Options)

The OK button accepts all the selected options in the Options dialog box and closes the dialog box.


OK Command Button (System Options)

The OK button accepts all the selected options in the Options dialog box and closes the dialog box.


OK Command Button (Table Options)

The OK button accepts all the selected options in the Options dialog box and closes the dialog box.


OK Command Button (User Types Options)

The OK button accepts all the selected options in the Options dialog box and closes the dialog box.


OK (Create New Table)

The OK button completes the Create New Table dialog box by accepting the table name typed in the New Table Name box.


OK (Date Constants)

The OK button completes the Date Constants dialog box by accepting the values and structures specified in the dialog box.


OK (Edit Data Item Pattern)

The OK button completes the Edit Data Item Pattern dialog box by accepting all the selections made within the dialog box.


OK (Edit Group Dialog)

The OK button completes the Edit Group dialog box by accepting the new group name.


OK (Edit User Dialog)

The OK button completes the Edit User dialog box by accepting the new user name into the selected group.


OK (Export DDL)

Click OK to export the selected table definition name(s).


OK (Export Preferences)

The OK button accepts the selections and returns to the Data Source page in the Options dialog box.

Note The selections are not saved in the RELDBDSN.INI file until you click OK on the Data Source page in the Options dialog box.


OK (Find FD)

Click the OK button to begin your search. Click the Find Next button to search for the next occurrence of the specified search criteria.


OK (Function of Function)

The OK button accepts the options and returns to the FD form.


OK (Invalid Column Name)

The OK button completes the Invalid Column Name dialog box by accepting all entries made within the dialog box.


OK (Logon)

The OK button completes the Logon dialog box by accepting all entries made within the dialog box.


OK (Printer Choice)

The OK button completes the Printer Choice dialog box by accepting the selections made within the dialog box.


OK (Rename)

The OK button completes the Rename file dialog box by accepting the new name.


OK (Select 01's)

The OK button completes the Select 01's dialog box by associating the selected 01 entries with the file shown in the COBOL File box.


OK (Select Character Set)

The OK button completes the Select Character Set dialog box by associating the selected code page entries with all of the file definitions in the catalog.


OK (Set Default Value)

The OK button completes the Set Default Value dialog box by accepting all the entries made within the dialog box.


OK (Subscript)

The OK button accepts the user option and closes the dialog box.


OK (Welcome to Relativity Window)

· If you click OK after selecting the New option, you set up a new data source.

· If you click OK after selecting either the Existing or Recent option, the Catalog window for the specified data source is opened. Note that if security has been defined for the catalog associated with the data source, you must complete the Logon dialog box.


Only One 01 Rule See Also

Building Writable Tables

Rules for Insertable Tables


Open Command Button (Files Tab)

The Open button displays the FD form for the selected file in the Catalog window. The Open button is disabled if a file has not been selected in the Files area list.

Note The Open command on the FD menu provides the same functionality as the Open button.


Open Command Button (Reports Tab)

The Open button provides the facility to do either of the following:

· Create a new report

· Modify a selected report

If a report category has been selected prior to clicking the Open button, the Select Report dialog box is displayed for selecting an existing report or creating a new report. If a specific report description has been selected prior to clicking the Open button, that report will be opened in the Report Editor for editing its description. The edited description may be saved as a new report, using Save As, or saved as the new layout for the same report, using Save.

Note The Edit command on the Reports menu provides the same functionality as the Open button.


Open Command Button (Tables Tab)

The Open button displays the Table form for the selected table. If a table is not selected in the Tables area list, the Open button is disabled.

Note The Open command on the Table menu provides the same functionality as the Open button.


Open Error File (Import Detected Errors Page)

The Open Error File option causes the error file to display in the text editor specified in the With text box when the Open button is clicked.


Open Error File (Merge Detected Errors Page)

The Open Error File option causes the error file to display in the text editor specified in the With text box when the Open button is clicked.


Open FD (Table Form Toolbar)

The Open FD button displays the FD form associated with the Table form.


Open (Import Detected Errors Page)

The Open button opens the text editor specified in the With text box.


Opening a Data Source See Also

Configuring a Relativity Data Source


Open Last Data Source on Startup

When the Open Last Data Source on Startup check box is selected, the information about the last data source processed is stored when exiting from the Relativity Designer. The next time the Relativity Designer is started, the stored data source information determines the data source to be automatically opened. The data source name and user name are shown at the bottom of the System page.


Open (Merge Detected Errors Page)

The Open button opens the text editor specified in the With text box.


Open (Open Relativity Data Source)

· If security has been defined for the catalog associated with the data source, the Open button displays the Logon dialog box, which provides for the entry of a user name and an optional password for the specified catalog.

· If security has not been defined for the catalog, the Open button opens the Catalog window in the Relativity Designer window.


Open Relativity Data Source Dialog Box See Also

Configuring a Relativity Data Source

Defining Catalog Ownership


Open (Select COBOL Source)

The Open button closes the Select COBOL Source dialog box. The name of the selected file is displayed in the File to Import text box on either the Source Code Import wizard or Source Code Merge wizard.


Open (Select Report)

When a report is specified in the File name list box, click the Open button to do one of the following:

· Display the Print Options dialog box, if you are printing the report.

· Access the Report Editor, if you are editing the report.


Open (Select RM/COBOL Program)

The Open button closes the Select RM/COBOL Program dialog box. The name of the selected file is displayed in the File to Import text box on the Source Code Import wizard or Source Code Merge wizard.


Open (Select Symbol Table)

The Open button closes the Select Symbol Table dialog box. The name of the selected file is displayed in the File to Import text box on the Source Code Import wizard or Source Code Merge wizard.


Open Source File (Import Detected Errors Page)

The Open Source File option causes the source file to display in the text editor specified in the With text box when the Open button is clicked. The detected error(s) can then be corrected and the source recompiled.


Open Source File (Merge Detected Errors Page)

The Open Source File option causes the source file to display in the text editor specified in the With text box when the Open button is clicked. The detected error(s) can then be corrected and the source recompiled.


Open when Opening Data Source Item Patterns

If the Open when Opening Data Source check box is selected, the Item Patterns form opens when the data source is opened. If this option is not specified, the Item Patterns form is not displayed when the data source is opened.


Open when Opening Data Source User Types

If the Open when Opening Data Source check box is selected, the Data Types form opens when the data source is opened. If this option is not specified, the Data Types form is not displayed when the data source is opened.


Operator

From the Operator list, select the logical operator that is to connect this filter subexpression to the filter expression being defined. Available selections are And, Or, And Not, and Or Not.

· If either And or Or is selected, the condition specified in the Condition Item list must be true for records to pass the filter.

· If either And Not or Or Not is selected, the condition specified in the Condition Item list must be false.


Options Area (Print Options)

The Options area allows the selection of what portion of the report to print or direct to an export module:

· a group of pages beginning with a specific page number

· all pages

· or a range of pages


Options Dialog Box See Also

Setting Options


Order (Show Indexes)

The Order column contains a value of “Asc” if the column in the index is sorted in ascending order and a value of “Dsc” if the column is sorted in descending order.


Ordinal Position (Show Indexes)

The Ordinal Position column contains the position of the column within the index, with 1 indicating the most significant column.


Organization (FD Properties)

In the Properties area of the FD Properties form, the Organization list identifies the file type and structure (indexed, sequential, or relative) of the underlying COBOL file.


OSEXT"string"

The OSEXT"string" directive specifies the default extension to be used for source files (testing of Micro Focus COBOL shows this directive is only used for DOS and Windows). The specified extension is used as the default extension for the main source file on DOS and Windows and also overrides the first extension specified by the COPYEXT directive immediately. The default for DOS, Windows, and OS/2 is "cbl"; the default for UNIX is "".

On UNIX, OSEXT overrides the first entry in COPYEXT immediately, the first entry in COPYEXT overrides OSEXT immediately, and the full value of COPYEXT is used to search for the main source file as well as copy files. That is, on UNIX, OSEXT is not used to search for the main source file except in its effect on overriding the first entry in COPYEXT; if COPYEXT is specified after OSEXT, then OSEXT is not used on UNIX, although its value is reset to the first entry in the COPYEXT directive's value.


Other Options (Merge Details)

These options appear on this dialog box if you click the Resolve button on the Resolve Merge Differences dialog box:

· Transform. The Transform list shows the transform associated with the original (previous) FD. By clicking the down arrow to the right of the box, all transforms are listed, and you can select a different transform to apply to the new FD, if desired.

· OK. The OK button completes the Merge Details dialog box by accepting the changes made in the Transform list.

· Cancel. The Cancel button backs out of the Merge Details dialog box without making any changes.


Overlap Rule See Also

Building Writable Tables

Rules for Insertable Tables


Parallel Occurs (FD Form Toolbar)

The Parallel Occurs button defines a set of data items described with the OCCURS clause that should be associated because they are parallel COBOL tables. That is, while they were described in the COBOL source with multiple OCCURS clauses, they are logically one COBOL table. The set of parallel OCCURS data items must be selected prior to selecting this button. See Identifying Parallel OCCURS Clauses for a fuller description of this concept.


Password (Add Database Group)

In the Password box, type the password for the new group. An asterisk (*) character is displayed for each character entered. This entry is optional.


Password (Add Database User)

In the Password box, type the password for the new user. An asterisk (*) character is displayed for each character entered. This entry is optional.


Password (Change Catalog Owner)

In the Password box, type the password for the new owner. An asterisk (*) character is displayed for each character entered. This entry is optional.


Password (Edit Group Dialog)

In the Password box, type the password for the group being renamed. An asterisk (*) character is displayed for each character entered. This entry is optional.


Password (Edit User Dialog)

In the Password box, type the password for the user being renamed. An asterisk (*) character is displayed for each character entered. This entry is optional.


Password (Logon)

In the Password box, type the password for the group or user. An asterisk (*) character is played for each character entered. This entry is optional.


Path Name

The Path Name attribute on the Edit Connections form is the physical filename of the data file.


Path Name (Add Table Connection Regular)

In the Path Name box, type, or select from the list, the path name to the data file. This path name is associated with the table connection being added to the selected table definition in the Edit Connections form. The path name is the physical filename of the data file.

Each unique file path name used in a table connection is added to the file connection list in the catalog. This list is used to provide the list for the Path Name box in the Add Table Connection dialog box. When a table connection is deleted and no other table connection refers to its file connection entry, a message box prompts whether the file connection should be deleted. If the file connection is deleted, it will no longer be available in the list for the Path Name box of the Add Table Connection dialog box, thus requiring that it be retyped into the box if another table connection is later added that uses the same file path name.


Path Name (Export Preferences)

In the Path Name box, type drive:\directory\^.ext, where the ^ is automatically replaced by the COBOL file-name of the source file to receive the FD being exported.


Path Name Replace (Edit Selected Table Connections)

The Path Name Replace box contains the pattern to be matched within the path name for replacement in the selected table connection.


Path Name Replace With (Add Connections Matching)

· The Path Name Replace box contains the pattern to be matched within the path name for replacement in the generation of a path name for the new table connection.

· The Path Name with box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the path name for the new table connection.


Path Name Replace With (Edit Connections Matching Pattern)

· The Path Name Replace box contains the pattern to be matched within the path name for replacement in the generation of a path name for the new table connection.

· The Path Name With box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the path name for the new table connection.


Path Name With

The Path Name with box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the path name for the new table connection.


Path Name With (Edit Selected Table Connections)

The Path Name With box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the new path name for the selected table connection.


Pattern

When the Pattern check box is selected in the Item Pattern area, a text box is enabled that allows you to specify a character pattern that appears within the COBOL name associated with the data item.


Pattern (Edit Data Item Pattern)

When the Pattern check box is selected, a text box is enabled that allows you to specify a character pattern that appears within the COBOL name associated with the data item.


Pattern (Item Patterns Form)

The Pattern attribute is the pattern specified in the Add Data Item Pattern dialog box to qualify data items for this data type. A value of N/A implies that the Pattern attribute is not used when qualifying data items for this data type.


Pattern Matching See Also

Add Connections Matching Pattern Dialog Box

Add Data Item Pattern Dialog Box

Delete Connections Matching Pattern Dialog Box

Edit Connections Matching Pattern Dialog Box

Edit Default Column Names Dialog Box

Item Patterns Form


PIC Tabs

In the PIC Tabs box, type a number indicating the beginning tab position for the placement of PICTURE clauses when exporting an FD. The value of this number must be within the range of 12 through 72.


Picture (FD Form Attributes)

In the expanded FD form, the Picture attribute contains one of the following:

· The type of file organization (Sequential, Relative, or Indexed) appears for the file-name.

· Group data items are represented by the word Group followed by a PICTURE character-string of X(n) enclosed in brackets. The value of n indicates the number of alphanumeric character in the group item.

· Elementary items are represented by a PICTURE character-string.


Position Changes

Under Resolve, selecting the Position Changes check box instructs Relativity automatically to resolve changes in the character position of COBOL data items during the merging process.


Precision

When the Precision check box is selected in the Item Pattern area, a text box is enabled that allows you to specify the number of digits in a numeric data item pattern.


Precision (Add COBOL Data Item Redefinition)

If a numeric item type was selected the Precision box is displayed, enabling you to enter a value for the precision of the data item being defined. The precision specifies the number of decimal digits and is constrained based on the data type and the length selected.


Precision (Edit Data Item Pattern)

When the Precision check box is selected, a text box is enabled that allows you to specify the number of digits in a numeric data item pattern.


Precision (Item Patterns Form)

The Precision attribute specifies the number of digits in a numeric data item. A value of N/A implies that the Precision attribute is not used when qualifying data items for this user data type.


Preferred Tabs

In the Preferred Tabs box, type numbers indicating tab positions within the range of 12 through 72 to be used when exporting an FD.


Previewing Table Data See Also

Creating and Editing Table Definitions

Defining Record Types

Table Form


Preview (Select Report)

In the right half of the dialog box, the Preview area displays a thumbnail version and the name of the of the selected report definition file as you move from file to file in the List area.


Previous (Add Condition Item)

The Previous button enables you to define the previous value for multiple values within the VALUE clause associated with the condition-name being defined.


Previous (Bind Subscripts)

The Previous button moves back to the previous subscript when two or more subscripts are associated with the data item.


Previous Item

The Previous Item area displays the name of the same item in the existing data file.


Previous Version - All Items

The Previous Version - All Items list contains a list of all data items from the previous version of the COBOL file definition being replaced by the merging process. The Previous Version - All Items list is used to interactively resolve entries in the Merged Version - Changed Items list.


Print Button (SQL Window)

Use the Print button to print the results of the executed query displayed in the SQL window.


Print Command Button (Reports Tab)

The Print button displays the Print Options dialog box for the printing of the report selected from the list of reports displayed in the Reports tab.

Notes

· If a report category is selected instead of a specific report description, a Select Report dialog box is displayed first to allow selection of the specific report definition file to be printed.

· The Print command on the Reports menu provides the same functionality as the Print button.


Printer Page Dependent

The Printer Page-Dependent option in the Printer Choice area relates to the printing of the first and following pages of a report on different printers. Selecting this option enables two Select buttons.


Printer Page Independent

The Printer Page-Independent option in the Printer Choice area relates to the printing of all pages of a report. Selecting this option enables a Select button.


Print Options Dialog Box See Also

Exporting Data to a Comma-Separated File

Print a report

Reporting


Print Preview Button (SQL Window)

Use the Print Preview button to open a Print Preview window where you can see how the results of the executed query will look when printed. To disable the preview capability, click Exit from the File menu in the window or click the Close button on the title bar.

When the Print Preview window is active, a menu bar and toolbar display commands and buttons you can use to print all or part of the results, and change the display of the window.


Print Preview (Show Table Contents)

Use the Print Preview button to open a Print Preview window where you can see how the results of the executed query will look when printed. To disable the preview capability, click Exit from the File menu in the window or click the Close button on the title bar.

When the Print Preview window is active, a menu bar and toolbar display commands and buttons you can use to print all or part of the results, and change the display of the window.

Alternatively, you can open a pop-up context menu of the commands available for the Show Table Contents form by right-clicking in the form. From the context menu, choose the command you need. Note that the Print Preview button provides the same functionality as the Print Preview command on the context menu.


Print (Show Table Contents)

Use the Print button to print the results of the executed query displayed on Show Table Contents form.

Alternatively, you can open a pop-up context menu of the commands available for the Show Table Contents form by right-clicking in the form. From the context menu, choose the command you need. Note that the Print button provides the same functionality as the Print command on the context menu.


Privilege List (Edit Privileges Form)

The Privilege list on the Edit Privileges form contains the privileges that can either be granted or not granted to a database group associated with the catalog. There are five types of privileges for a Relativity database:

1. Administrator privileges

2. Create Users privilege

3. Create Tables privilege

4. Table privileges

5. Column privileges

Note When a Column privilege is selected, a Table list is displayed to the right of the Privilege list in the Edit Privileges form. This list contains the names of all tables within the database. Upon selection of a table, the Not Granted column contains the names of all columns within the specified table.

The privilege you select in the Privilege list determines what appears in the Not Granted, Granted, and With Grant columns, as described in the following table:

When you select the following privilege | These items appear in the Not Granted, Granted, and With Grant columns
Administrator | Privileges: Create Groups, Date Constants, Reports, Use Administrator
Create Users | Group names
Create Tables | Table definition names
Table | Table names
Column | Column names (from the table definition associated with the table connection selected in the Table list that is displayed when a Column privilege is selected)


Privileges Command Button (Users Tab)

The Privileges button displays the Edit Privileges form for the selected group. If a group is not selected, the Privileges button is disabled.

Note The Privileges command on the Security menu and on the User menu provides the same functionality as the Privileges button.


Privileges Options See Also

Defining Group Privileges

Setting Options

Tools Menu Commands


Privileges Report Features See Also

Defining Group Privileges

Privileges by Grantee Report

Reporting


Process

The Process button causes Relativity to reprocess the merged (new) COBOL file definitions using the constraints imposed by the Type Changes, Position Changes, and Length Changes options.


Process COBOL.DIR (Import Wizard MF COBOL)

The Process COBOL.DIR option causes the source file import procedure to process the cobol.dir file, which specifies Micro Focus COBOL compiler directives. If a directive is not specified in a cobol.dir file, then the directive has the same default setting as the Micro Focus COBOL compiler for Windows. (Refer to your Micro Focus COBOL documentation for details on the meanings of each directive.)

Note The Process COBOL.DIR option is disabled unless Import COBOL Source is selected.


Process COBOL.DIR (Merge Wizard MF COBOL)

The Process COBOL.DIR option causes the source file merge procedure to process the cobol.dir file, which specifies Micro Focus COBOL compiler directives. If a directive is not specified in a cobol.dir file, then the directive has the same default setting as the Micro Focus COBOL compiler for Windows. Refer to your Micro Focus COBOL documentation for details on the meanings of each directive.

Note The Process COBOL.DIR option is disabled unless Merge COBOL Source is selected.


Process XML (Import Wizard MF COBOL)

The Process XML option enables the Source Code Import wizard to import not only the COBOL FD information, but also the relational information related to that FD in an accompanying XML (Extensible Markup Language) file. Any tables defined in the XML file are also created as part of the import process. The XML file must reside in the same directory as the COBOL source file, and it must have the same name as the source but with the file extension, .xml.

This ability to permit relational definitions to be imported at the same time as the COBOL FD is imported makes possible the faster development and deployment of Relativity catalogs. Furthermore, this capability optionally provides a mechanism that would allow for the synchronized maintenance of the COBOL and non-COBOL information required to create a catalog.

To obtain further information from technical support services, contact Liant Software Corporation.

Note Currently, this feature provides only a subset of Relativity's functionality necessary to import relational information from other products.


Process XML (Import Wizard RM COBOL)

The Process XML option enables the Source Code Import wizard to import not only the COBOL FD information, but also the relational information related to that FD in an accompanying XML (Extensible Markup Language) file. Any tables defined in the XML file are also created as part of the import process. The XML file must reside in the same directory as the COBOL source file, and it must have the same name as the source but with the file extension, .xml.

This ability to permit relational definitions to be imported at the same time as the COBOL FD is imported makes possible the faster development and deployment of Relativity catalogs. Furthermore, this capability optionally provides a mechanism that would allow for the synchronized maintenance of the COBOL and non-COBOL information required to create a catalog.

Contact Liant Software Corporation to obtain further information from technical support services.

Note Currently, this feature provides only a subset of Relativity's functionality necessary to import relational information from other products.


Process XML (Merge Wizard MF COBOL)

The Process XML option enables the Source Code Import wizard to import not only the COBOL FD information, but also the relational information related to that FD in an accompanying XML (Extensible Markup Language) file. Any tables defined in the XML file are also created as part of the import process. The XML file must reside in the same directory as the COBOL source file, and it must have the same name as the source but with the file extension, .xml.

This ability to permit relational definitions to be imported at the same time as the COBOL FD is imported makes possible the faster development and deployment of Relativity catalogs. Furthermore, this capability optionally provides a mechanism that would allow for the synchronized maintenance of the COBOL and non-COBOL information required to create a catalog.

To obtain further information from technical support services, contact Liant Software Corporation.

Note Currently, this feature provides only a subset of Relativity's functionality necessary to import relational information from other products.


Process XML (Merge Wizard RM COBOL)

The Process XML option enables the Source Code Import wizard to import not only the COBOL FD information, but also the relational information related to that FD in an accompanying XML (Extensible Markup Language) file. Any tables defined in the XML file are also created as part of the import process. The XML file must reside in the same directory as the COBOL source file, and it must have the same name as the source but with the file extension, .xml.

This ability to permit relational definitions to be imported at the same time as the COBOL FD is imported makes possible the faster development and deployment of Relativity catalogs. Furthermore, this capability optionally provides a mechanism that would allow for the synchronized maintenance of the COBOL and non-COBOL information required to create a catalog.

To obtain further information from technical support services, contact Liant Software Corporation.

Note Currently, this feature provides only a subset of Relativity's functionality necessary to import relational information from other products.


Properties (Edit Record Type Form)

The Record Type Filter Properties button displays the Record Type Properties form, where you can define a record type filter to specify the conditions that control the records that participate in providing data to a table based on the record type.


Query Builder Form See Also

Relational Definition Forms


Query Button (Show Table Contents)

Clicking the Query Builder button opens the Query Builder form, where you can design a new query, or, if you have been working with a query, you can make changes to modify it. Then, you can retrieve the query results for a selected table in the catalog. The results of the query will appear automatically in the Show Table Contents form when you execute the query in the Query Builder form.

Alternatively, you open a pop-up context menu of the commands available for the Show Table Contents form by right-clicking in the form. From the context menu, choose the command you need. Note that the Query Builder button provides the same functionality as the Design Query command on the context menu.


QUOTE

The QUOTE directive specifies that the figurative constants QUOTE and QUOTES will have the value ALL """"; that is, one or more double quote characters. The opposite directive to QUOTE is APOST, which specifies single quote characters (apostrophes) for figurative constants. The default is QUOTE.


Recent (Welcome to Relativity Window)

Select the Recent option to open the data source that you have most recently used in the Relativity Designer. When you select this option, a numbered list--in the order of the most recently opened data sources--is displayed in the List area and the data source most recently used is highlighted.

To quickly reopen one of these data sources, click it. If one of these data sources is selected from this list, any open, existing data source is closed, and the selected data source is opened.

Note This option corresponds to the Most Recently Used Data Source command on the File menu.


Record Length (FD Properties)

In the Properties area of the FD Properties form, the Record Length box displays the length of the record. If the record is a variable length record, this area displays the minimum and maximum length (that is, a To box also is displayed).


Record Size

The Record Size column displays the size of the record associated with the data-name on the same line.


Record Type List (Edit Record Type Form)

Click the down arrow on the Record Type: list to display the possible choices:

· The < no record type > option. Use the < no record type > option to reset or indicate that no record type is selected. Note that all COBOL names in the FD form are displayed in “normal” type style when the < no record type > option is selected.

· The < new record type > option. Select the < new record type > option to display the Add Record Type dialog box, where you define the record-name of the selected data items in the FD form that will make up a new record type. See Identify the data items within each record type structure.

Note This option provides the same functionality as the Record Types | Create New Record Type command on the FD menu when an FD form is open.

· The available record-name option. Select an available record-name for the record type associated with the file displayed in the FD form to display the Record Type Properties form for the selected record type. The definition of a record type can be changed or deleted by the appropriate actions in this form.

Note When a record-name is selected from the Record Type: list, the type style of the data items listed in the COBOL names column in the FD form has special meaning. For more information, click here.


Record Type Name

In the Record Type Name box, type the record-name to be assigned to the record defined by the selected data items in the FD form. This record-name must conform to the rules for a COBOL data-name.


Record Type Properties Form See Also

Defining Record Type Filters

Defining Record Types

Describe Filter Subexpression Dialog Box

Handling Multiple Record Types


Record Type Rule See Also

Building Writable Tables

Defining Record Types

Rules for Insertable Tables


Record Types Properties See Also

FD Properties Form


Record Types Used

The Record Types Used list contains all of the record types that are already in use for this table. This list is updated by specifying actions with the Add, Remove, Add All, and Remove All buttons.


Record Type (Table Wizard)

The Record Type list displays the following choice:

· Any currently defined record types for the selected data items.

· The <no record type option>, which allows you to reset or indicate that no record type is selected.


Record Type Toolbar See Also

Defining Record Type Filters

Defining Record Types

FD Form

FD Form Toolbar


Redefined By (FD Form Attributes)

In the expanded FD form, the Redefined By attribute is the COBOL data-name of any data item having a data description with the REDEFINES clause that specifies this data item. See Redefining Data Items and Defining Record Types.

The Redefined By attribute column is displayed in the FD form only if the Show Redefined By check box is selected on the File page in the Options dialog box.


Redefines (FD Form Attributes)

In the expanded FD form, the Redefines attribute is the COBOL data-name that appears in the REDEFINES clause of the data description for a data item that contains the REDEFINES clause. See Redefining Data Items and Defining Record Types.

The Redefines attribute column is displayed in the FD form only if the Show REDEFINES check box is selected on the File page in the Options dialog box.


Redefining Data Items See Also

Add COBOL Data Item Redefinition Dialog Box

COBOL Types Options


Redundant Data Items (FD Form Toolbar)

The Redundant Data Items button displays the Edit Item Sets form for the definition of an item set containing the selected redundant data items that are to be reduced to one data item. See Defining Item Sets.


Regular Expression Syntax Used in Pattern Matching See Also

Pattern Matching Examples


Re-Importing Btrieve Keys Dialog Box (Micro Focus COBOL Only) See Also

Importing Btrieve Keys (Micro Focus COBOL Only)

Re-Importing Btrieve Keys (Micro Focus COBOL Only)

Resolving Merge Differences


Re-import Keys

The Re-import Keys button directs Relativity to invoke the Import Btrieve Keys command on the Tools menu, which will allow you to choose from which Btrieve data files to import the keys.


Relational Definition Forms See Also

Administration Forms

Catalog Window

COBOL Definition Forms

Options Dialog Box

Tables Catalog Object


Relational Schema Maintenance See Also

File Schema Maintenance

Maintaining the Relativity Database


Relativity Catalogs See Also

Working with the Catalog Window


Relativity Designer Window See Also

Starting the Relativity Designer

Undocumented Features


Remove All (Assign or Remove Record Types)

The Remove All button moves all COBOL object programs in the Record Types Used list to the Available Record Types list.


Remove All (Import File Selection Page COB RST)

The Remove All button moves all COBOL data file definitions between the Available Files list and the Selected Files list, as necessary.


Remove All (Import File Selection Page COB)

The Remove All button moves all COBOL data file definitions between the Available Files list and the Selected Files list, as necessary.


Remove All (Merge File Selection Page CBL RST)

The Remove All button moves all COBOL data file definitions between the Available Files list and the Selected Files list, as necessary.


Remove All (Merge File Selection Page COB)

Use the Remove All button to move all COBOL data file definitions between the Available Files list and the Selected Files list, as necessary.


Remove All (Tables to Keep)

The Remove All button moves all table definitions in the Tables to Keep list to the Tables to Discard list.


Remove All (Table Wizard)

The Remove All button moves all data items in the Selected Items list to the Available Items list.


Remove (Assign or Remove Record Types)

The Remove button moves the selected COBOL object program in the Record Types Used list to the Available Record Types list.


Remove (Import File Selection Page COB RST)

The Remove button moves the selected COBOL data file definitions between the Available Files list and the Selected Files list, as necessary.


Remove (Import File Selection Page COB)

The Remove button moves the selected COBOL data file definitions between the Available Files list and the Selected Files list, as necessary.


Remove (Merge File Selection Page CBL RST)

The Remove button moves the selected COBOL data file definitions between the Available Files list and the Selected Files list, as necessary.


Remove (Merge File Selection Page COB)

Use the Remove button to move the selected COBOL data file definitions between the Available Files list and the Selected Files list, as necessary.


Remove (Tables to Keep)

The Remove button moves the selected table definition in the Tables to Keep list to the Tables to Discard list.


Remove (Table Wizard)

The Remove button moves the selected data items in the Selected Items list to the Available Items list.


Rename Table Dialog Box See Also

Establishing Table Connections


Rename Table Enter New Name

In the Enter New Name box, type the new name for the table being renamed. A table definition name must begin with an alphabetic character. The remaining characters can be any combination of alphabetic, numeric, or underscore characters.

Note A table name must not be an SQL reserved word.


Repeating Item Rule See Also

Building Writable Tables

Rules for Insertable Tables


Replace

The Replace box contains the characters to be matched within the column names in the FD form for replacement to take place. To specify the position of the characters to be replaced within the default column name, type the appropriate structure to determine the pattern matching process.


Replace All (Find Table)

If you want to automatically replace all occurrences of the search criteria, click the Replace All button. To search and replace the selected instance of the search criteria, find the next occurrence, and then stop, click the Replace button.


Replace (Find and Replace)

In the Find and Replace dialog box, the Replace button replaces the selected instance of the search criteria, finds the next occurrence, and then stops. If you want to replace all occurrences of the search criteria automatically, click Replace All.


Replace (Find Table)

In the Find dialog box, the Replace button opens the Find and Replace dialog box, where you replace the selected instance of the search criteria, find the next occurrence, and then stop. If you want to replace all occurrences of the search criteria automatically, click Replace All.


Replace With (Find Table)

In the Find and Replace dialog box, type the text that you want to use as replacement text in the Replace With box. You can type or paste text into this box. To delete from your table the text in the Find What box, leave the Replace With box empty.


Replace - With (Table Wizard Edit)

The Replace - With boxes allow global search and replace on the column names.


Report Definition Files See Also

Configuring Reports for Relativity DBA

Reporting

Select Report Dialog Box


Reporting See Also

Exporting Data to a Comma-Separated File

Report Definition Files

Relational Schema Maintenance


Report Name (Print Options)

The Report Name area indicates the name of the report that was selected for printing or exporting to another type of media in the Select Report dialog box.


Reports Catalog Object See Also

Tabbed Layout View

Working with the Catalog Window


Reports List (Reports Tab)

The Reports area displays a list of the report categories and the descriptions of the currently defined reports for each category. A report category or a report description may be selected by clicking once on the desired item in the list.

Note A specific report description may be deleted by selecting the report description and pressing the Del (Delete) key. A message box will be displayed requesting confirmation of the delete report request. If the user confirms the deletion, the report definition files for that report is deleted. The Del key has no effect if a report category is selected.


Reset Group Password (Edit Users Form)

The Reset Group Password button removes the current password for the selected group in the Edit Users form.

Shortcut: Alt+X

Note The Reset Group Password button provides the same functionality as the Reset Password command on the User menu.


Reset Names (Table Wizard Edit)

The Reset Names button restores all of the column names to their unedited state.


Reset User Password (Edit Users Form)

The Reset User Password button removes the current password for one or more selected users within a selected group in the Edit Users form.

Shortcut: Alt+Y

Note The Reset User Password button provides the same functionality as the Reset Password command on the User menu.


Resolve

The Resolve button displays the Merge Details dialog box for the selected data item from the Merged Version - Changed Items list and its selected data item from the Previous Version - All Items list. If a transform was associated with the previous (original) FD, it will be displayed and you can apply it to the new FD or select a different transform to apply.


Resolve Merge Differences Dialog Box See Also

FD Form - Attributes Summary

Merging COBOL File Definitions

Resolving Merge Differences


Resolving Merge Differences See Also

Merging COBOL File Definitions

Re-Importing Btrieve Keys (Micro Focus COBOL Only)


RM/COBOL (74) Types

When the RM/COBOL (74) Types check box is selected, the catalog includes the COMP-3 and COMP data types with a special positive sign convention.


RM/COBOL Types

Select the RM/COBOL Types check box to include RM/COBOL data types in the list of data types displayed in the Item Type list in the Add COBOL Data Item Redefinition dialog box. If the data files to be accessed through this catalog do not include any RM/COBOL data types, do not select this check box.


RM/COS Types

When the RM/COS Types check box is selected, the catalog includes the special COMP-3 and COMP data types with regard to minus and positive sign conventions in the RM/COS operating system.


Rules for Insertable Tables See Also

Write Support Wizard


Same Item Rule See Also

Building Writable Tables

Rules for Insertable Tables


Save (Assign or Remove Record Types)

The Save button completes the Assign or Remove Record Types dialog box by accepting all the selections made within the dialog box.


Save as Type (Save Export File As)

In the Save as type list, select the filename extension from the list or type an extension. The extension for a comma-separated file is .csv.


Save Changes (Data Types Form)

The Save Changes button writes into the catalog all additions, changes, and deletions made to the data types displayed in the Data Types form. If the Data Types form is closed with unsaved changes, there will be a prompt asking if any pending changes should be saved or not. This behavior can be controlled by the Save Data Type Changes check box on the User Types page in the Options dialog box.


Save Changes (Edit Connections Form)

The Save Changes button saves any changes you may have made to the Edit Connections form without closing the form.

Shortcut: Alt+S


Save Changes (Edit Privileges Form)

The Save Changes toolbar button accepts all privileges defined in the Edit Privileges form for the groups of a database.

Shortcut: Alt+S


Save Changes (FD Form Toolbar)

The Save Changes button writes into the Relativity catalog all additions, changes, and deletions made to the record description displayed in the FD form for a COBOL file. If the FD form is closed with uncommitted changes, there will be a prompt asking if any pending changes should be saved or not. This behavior can be controlled by the Save FD Changes check box on the File page in the Options dialog box.

Note This option provides the same functionality as the Save FD Changes command on the FD menu.


Save Changes (Item Patterns Form)

The Save Changes button writes into the catalog all additions, changes, and deletions made to the item patterns displayed in the Item Patterns form. If the Item Patterns form is closed with unsaved changes, there will be a prompt asking if any pending changes should be saved or not. This behavior can be controlled by the Save Patterns Changes check box on the Item Patterns page in the Options dialog box.


Save Changes (Resolve Merge Differences)

The Save Changes button displays the Tables to Keep dialog box. Clicking the Save Changes toolbar button is identical to clicking the Done command button.


Save Changes (Table Form Toolbar)

The Save Changes button behaves differently depending on whether the table definition is new or already exists.

· If the table definition is new, the Save Changes button displays the Create New Table dialog box, which allows a name to be assigned to the table.

· If the table definition already exists, the Save Changes button writes into the Relativity catalog all additions, changes, and deletions made to the table description displayed in the Table form. If the Table form is closed with unsaved (or uncommitted) changes, there will be a prompt asking if any pending changes should be saved or not. This behavior can be controlled by the Save Table Changes check box on the Table page in the Options dialog box.

Note This option provides the same functionality as the Save Table Changes command on the Table menu.


Save Data Type Changes

When the Save Data Type Changes check box is selected, changes to the Data Types form are accepted into the catalog without the message requesting configuration.


Save Export File As Dialog Box See Also

Exporting Data to a Comma-Separated File

Reporting


Save FD Changes

When the Save FD Changes check box is selected, the changes to data definitions in the FD form are accepted into the catalog without a message requesting confirmation.


Save in (Save Export File As)

In the Save in list, select the drive and folder in which you want to save the file.

The Save in list box lists the available folders and files. To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

The box below lists the folders and files in the selected location. To open any folder or file, click its name in the list. To open the folder one level higher, click the Up One Level toolbar button.


Save Options Permanently (Print Options)

The Save options permanently check box allows you to save the settings you have selected for the printer or other export media. Note that this check box is unavailable unless the printer (and any printer settings) or export module options have been changed in the Printer Choice dialog box.


Save Pattern Changes

When the Save Pattern Changes check box is selected, changes to the Item Patterns form are accepted into the catalog without the message requesting confirmation.


Save Results Button (SQL Window)

Use the Save Results button to save the results of the executed query to a comma separated file (*.csv). When you click this button, a Windows Save As dialog box is displayed.


Save Results (Show Table Contents)

Use the Save Results button to save the results of the executed query to a comma separated file (*.csv). When you click this button, a standard Windows Save As dialog box is displayed.

Alternatively, you can open a pop-up context menu of the commands available for the Show Table Contents form by right-clicking in the form. From the context menu, choose the command you need. Note that the Save Results button provides the same functionality as the Export Results command on the context menu.


Save (Save Export File As)

The Save button completes the Save Export File As dialog box by accepting all selections made within the dialog box and displays the Print Options dialog box.


Save Table Changes

When the Save Table Changes check box is selected, changes to data definitions in the Table form are accepted into the catalog without the message requesting confirmation.


Scale

When the Scale check box is selected in the Item Pattern area, a text box is enabled that allows you to specify the number of digits to the right of the decimal point in a numeric data item pattern.


Scale (Add COBOL Data Item Redefinition)

If a numeric item type was selected the Scale box is displayed, enabling you to enter a value for the scale of the data item being defined. The scale factor specifies the position of the decimal point from the right end of the new data item in terms of decimal digits. The absolute value of a negative scale factor specifies the number of digits to the right of the decimal point.


Scale (Edit Data Item Pattern)

When the Scale check box is selected, a text box is enabled that allows you to specify the number of digits to the right of the decimal point in a numeric data item pattern.


Scale (Item Patterns Form)

The Scale attribute specifies the number of digits to the right of the decimal point in a numeric data item. A value of N/A implies that the Scale attribute is not used when qualifying data items for this user data type.


Select 01's Dialog Box See Also

Importing COBOL File Definitions

Merging COBOL File Definitions


Select 01's (Import File Selection COB RST)

The Select 01's button displays the Select 01's dialog box allowing the association of other level 01 record descriptions not subordinate to the selected COBOL file-name with the selected COBOL file-name. Note that a file definition must be selected in the Available Files list before this button is enabled.


Select 01's (Merge File Selection Page CBL RST)

The Select 01's button displays the Select 01's dialog box allowing the association of other level 01 record descriptions not subordinate to the selected COBOL file-name with the selected COBOL file-name. Note that a file definition must be selected in the Available Files list before this button is enabled.


Select All (Choose Subscript Values)

Click the Select All button to select all of the occurrences in a repeating data item to add to a table.


Select ALL Columns (Table Form Toolbar)

The Select All Columns button is a toggle button that either selects all columns or removes the selection of all columns in the table.


Select Btrieve Data File for filename Dialog Box See Also

Importing Btrieve Keys (Micro Focus COBOL Only)


Select Character Set Dialog Box See Also

Defining Nonstandard Character Sets

LogicalOrder Column Transform

Maintaining Character Sets


Select COBOL Source Dialog Box See Also

Importing COBOL File Definitions

Merging COBOL File Definitions


Select Combination

The options under Select Combination represent the two possible function argument combinations with the functions that are selected. The functions are listed in the same order as they appear in the FD form. This allows you to distinguish between two combinations if the functions selected are the same.


Select Data Type Dialog Box See Also

Defining Item Patterns

Transforms


Select Default Value Dialog Box See Also

Building Writable Tables


Selected Files (Import File Selection Page COB RST)

The Selected Files list contains a list of COBOL data file definitions to be imported into the Relativity catalog.

Note By default, the Relativity Designer assumes that you want to import all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.


Selected Files (Import File Selection Page COB)

The Selected Files list contains a list of COBOL data file definitions to be imported into the Relativity catalog.

Note By default, the Relativity Designer assumes that you want to import all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.


Selected Files (Merge File Selection Page CBL RST)

The Selected Files list contains a list of COBOL data file definitions to be imported into the Relativity catalog for the merge procedure.

Note By default, the Relativity Designer assumes that you want to import (and merge) all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.


Selected Files (Merge File Selection Page COB)

The Selected Files list contains a list of COBOL data file definitions to be imported into the Relativity catalog for the merge procedure.

Note By default, the Relativity Designer assumes that you want to import (and merge) all of the FDs from the COBOL source file. Therefore, all of the file definitions are placed initially in the Selected Files list. You can change this default behavior by choosing the During Import, Initially Place Files in Available Column check box on the System page.


Selected Items (Table Wizard)

The Selected Items list contains a list of all of the data items that are to be included in the new table. This list defaults to all of the elementary items from the FD form.


Selected Select Privilege

Privilege | Action
Table: ALL Column: ALL | Adds or removes all related privileges.
Table: select Column: select | Adds or removes only 'SELECT' privileges.
Table/Column: insert, update, references, delete | Adds or removes only named privilege.


Select Function Dialog Box See Also

Internal Functions

Synthesize a data item using an internal function

Using Functions and Transforms


Selecting COBOL data files from COBOL programs for import

To select:

· all files, click Remove All to move the file definitions from all COBOL programs to the Available Files list and exclude them from the importing and merging procedures.

· one or more files, click the first COBOL data file in the Selected Files list. Then hold down the Ctrl key and click any other COBOL data files you want to select. Next, click Remove to move the file definitions from the selected COBOL programs to the Available Files list and exclude them from the importing and merging procedures.


Selecting COBOL data files from COBOL programs for merge

To select:

· all files, click Remove All to move the file definitions from all COBOL programs to the Available Files list and exclude them from the importing and merging procedures.

· one or more files, click the first COBOL data file in the Selected Files list. Then hold down the Ctrl key and click any other COBOL data files you want to select. Next, click Remove to move the file definitions from the selected COBOL programs to the Available Files list and exclude them from the importing and merging procedures.


Select ( Printer Choice)

The Select button displays a standard Windows dialog box that allows you to specify a printer and define its properties and paper settings (paper size, paper source, and paper orientation).


Select Report Dialog Box See Also

Create a new report

Edit an existing report

Print a report

Report Definition Files


Select RM/COBOL Program Dialog Box See Also

Importing COBOL File Definitions

Merging COBOL File Definitions


Select (Select Data Type)

The Select button completes the Select Data Type dialog box by accepting the selection made within the dialog box.


Select (Select Function)

The Select button completes the Select Function dialog box by accepting the selection made within the dialog box. (In the FD form, the function is displayed in the COBOL Name attribute column preceded by "f:".)


Select (Select Table Connection to Show)

After selecting the correct table connection, click Select to close this dialog and then open either the Show Table Contents form or the Show Indexes for Tablename form, depending on the operation you have selected from the Table menu.


Select Server Dialog Box See Also

Configuring a Relativity Data Source


Select Symbol Table Dialog Box See Also

Importing COBOL File Definitions

Merging COBOL File Definitions


Select Table Connection to Show Dialog Box See Also

Edit Connections Form


Series

Selecting the Series check box causes the generation of a condition item series; that is, multiple condition-names associated with the selected subscript item. These condition-names may be used to bind the subscript of the repeating data items accessed by the selected subscript item.

Each condition item in the generated series of condition items is assigned a condition-name consisting of the name provided in the New 88 Name box appended with a hyphen and a number. The number ranges from 1 to the maximum value of the subscript. The number appended to each condition-name in the series is also set as the single true value for the corresponding condition-item in the series.

For example, assume SubscriptItem is selected in the FD form, the Add Condition Item button is clicked, the characters CNAME are entered in the New 88 Name box, the Series check box is selected, and Add button is clicked. Then the following condition items will be associated with SubscriptItem:

03 repeating-data-item PIC X OCCURS 5 TIMES.
si SubscriptItem [subscript of repeating-data-item].
88 CNAME-1 value 1.
88 CNAME-2 value 2.
88 CNAME-3 value 3.
88 CNAME-4 value 4.
88 CNAME-5 value 5.

Note The Series check box is not available when the item selected in the FD form is not a subscript item.


Set Euro Character for Selected Character Set

Use the Set Euro Character for Selected Character Set area to change the location of the Euro character in a character set. Some COBOL applications supported the Euro character before the International Standards Organization decided its value in standard character sets. In such cases, Relativity must modify its understanding of the value of the Euro character within the standard character set.

To do this, select the character set whose definition for the Euro character will change from the Character Set column. Check the Enable Euro check box. In the edit box, enter the value that is used to represent the Euro character in the COBOL data file. The value must be a number between decimal 0 and 255 (hexadecimal 0x00 and 0xff). Click the Update button to change the value. The new value will appear in the Euro list to the right of the character set name in the Character Set column.


Setting Up a New Data Source See Also

Configuring a Relativity Data Source


Set To False

Selecting the Set to False check box allows you to define a condition-name associated with the entry of a value in the False Value list box.

Note Because the false value is always a single value, this check box is not available on subsequent Add Condition Item dialog boxes that are displayed when the Next button is clicked. If you want to set the false value after having clicked the Next button, use the Previous button to return to the first value of the condition item being added.


Show 88 Items (Table Wizard)

Under List Options, the Show 88 Items check box controls whether the 88-level condition-name is displayed in the Available Items list.


Show Comments

If the Show Comments check box is selected, the Comment column is displayed in the FD form. Comments may be entered to provide additional documentation of the database. If this option is not selected, the Comment column is not displayed in the FD form.


Show Comments

When the Show Comments check box is selected, the Comment column is displayed in the Table form. If the Show Comments check box is not selected, the Comment column is not displayed in the Table form.


Show Default Values

If the Show Default Values check box is selected, the Default Value column is displayed in the FD form. Default values are used when tables, which allow updates and inserts, are defined. If this option is not selected, the Default Value column is not displayed in the FD form.


Show Default Values

When the Show Default Values check box is selected, the Default Value column is displayed in the Table form if the Allow Inserts check box in the Table form toolbar has been selected for the table. If the Show Default Values check box is not selected, the Default Value column is not displayed in the Table form.


Show (Edit Connections Form)

The Show button displays the Show Table Contents form containing data from underlying COBOL file(s) for the selected table connection.


Show FD Details

When the Show FD Details check box is selected, the FD form opens in the expanded (Show Details) mode with additional attributes of the data item. If this option is not selected, the FD form opens with only the level indicator/level number and COBOL Name attribute visible.


Show Filter (Record Type Toolbar)

The Show Filter button displays an algebraic representation of the filter expression specified in the Record Type Properties form.


Show Filter (Table Filter Properties)

The Show Filter button displays an algebraic representation of the filter expression specified in the Table Filter Properties form.


Show Indexes for Tablename Form See Also

Relational Definition Forms


Show Indexes (Table Form Toolbar)

The Show Indexes button displays the Show Indexes for Tablename form, which allows you to specify the columns in a table definition that participate in one or more indices.


Show LogicalOrder Transform

When the Show LogicalOrder Transform check box is selected, the LogicalOrder column transform will be enabled in the data source. When this transform is enabled, Relativity will convert text from visual order (the order in which characters are presented for reading) into logical order (the order in which characters are typed on a keyboard) before returning the text to the application. Likewise, logical order text that is written into a column by the ODBC application will be converted back to visual order before storage into the COBOL data file, so that the COBOL application can use it. The LogicalOrder column transform can be placed either on an individual column or every column of a data source.


Show Null Information

If the Show Null Information check box is selected, the Null Value and Not Null columns are displayed in the FD form. These columns allow the specification of conditions that provide null SQL column values. If this option is not selected, the Null Value and Not Null columns are not displayed in the FD form.


Show Redefined By

If the Show Redefined By check box is selected, the Redefined By column is displayed in the FD form. If this option is not selected, the Redefined By column is not displayed in the FD form.


Show REDEFINES

If the Show REDEFINES check box is selected, the Redefines column is displayed in the FD form. This column shows the item that is redefined by the item in a particular row. If this option is not selected, the Redefines column is not displayed in the FD form.


Show Row (Query)

In the query design grid, the Show row displays or hides a column in the results of the query. If you hide a column, you can still use it to specify criteria. By default, the condition is set to True (show) when a column name is added to the Column row in the query design grid. To change the condition to False (hide), double-click in the cell to toggle the value.


Show Table Contents Form See Also

Establishing Table Connections

Relational Definition Forms


Show (Table Form Toolbar)

The Show button displays the Show Table Contents form containing data from the underlying COBOL file for selected columns in the Table form. See Previewing Table Data.

If no columns are selected in the Table form, all columns will be displayed in the Show Table Contents form. The Show button is enabled only if there is exactly one table connection for the table definition displayed in the Table form. If there is no table connection or more than one table connection, see the Edit Connections form, which is displayed by clicking the Edit Connections toolbar button.

Note This option provides the same functionality as the Show Table Contents command on the Table menu (or the Show Table Contents shortcut on the Table Common Tasks area of the Tables catalog object).


Show VALUE Column

If the Show VALUE Column check box is selected, the Value column is displayed in the FD form. This column allows you to view the condition. If this option is not selected, the Value column is not displayed in the FD form.


Show Welcome at Startup (Welcome to Relativity Window)

By default, this option is selected when you first install and start the Relativity Designer. If this option remains enabled, the Welcome to Relativity window displays each time you start the Relativity Designer. If you disable this option, you can choose Welcome from the Tools menu to enable it again.


SIGN"string"

The SIGN"string" directive specifies the sign convention for combined sign numeric DISPLAY data items as being ASCII, the default, or EBCDIC, based on the value of string, which must be one of these two words.


Single Table, All Tables, Selected Tables (Export DDL)

In this area, select the table definitions you want to export to a .ddl file:

· Selecting the Single Table option exports only the table definition selected on the Tables catalog object or opened in the Table form. (The name of the table definition name appears to the right of this option.) This option is selected by default when the dialog box is first opened.

· Selecting the All Tables option exports all the table definitions in the catalog.

· If you check the Selected Table(s) option, you can click the name of the table definition that you want to export in the Table Definition Names list box. To select multiple table definition names, press the Ctrl key as you select with the mouse.


Single Value Value Range Option Buttons

The Single Value and Value Range option buttons provide you with a choice of defining a condition-name associated with either a single value or a range of values.


Sort row (Query)

In the query design grid, the Sort row specifies whether a particular column will be used for sorting, and if so, whether the sort is in Ascending (0 to 9, A to Z) or Descending (9 to 0, Z to A) order. If you specify a sort order in multiple columns, Relativity sorts by each column, going in order from left to right. Sorting is optional; the default is a blank cell; that is, not sorted.

To specify a sort order on a column name, double-click in the cell to toggle between Ascending and Descending, or leave the cell blank to specify no sorting.


Source

The Source column displays the COBOL file-name or section-name in which the data item is located.

· The characters, FD, indicate that the data-name is subordinate to the COBOL file shown in the COBOL File box. FD:filename indicates that the record is found in the File Section and is subordinate to the COBOL file named filename.

· The characters, WSS, indicate that the data item is found in the Working-Storage Section.

· The characters, LS, indicate that the data item is found in the Linkage Section.


Source Charset (FD Properties)

In the Properties area of the FD Properties form, the Source Charset box indicates the character set of the source code. This box is informational only.


Source Code Import Wizard See Also

Creating a COBOL Schema File

Importing COBOL File Definitions


Source Code Import Wizard (with Micro Focus COBOL as the Dialect) See Also

Creating a COBOL Schema File

Importing COBOL File Definitions

Micro Focus COBOL Schema Extraction Restrictions


Source Code Merge Wizard File Selection Page (for .CBL and .RST Files) See Also

Resolve Merge Differences Dialog Box

Resolving Merge Differences


Source Code Merge Wizard File Selection Page (for .COB Files) See Also

Resolve Merge Differences Dialog Box

Resolving Merge Differences


Source Code Merge Wizard See Also

Merging COBOL File Definitions


Source (Copy File Label)

The Source list box contains all the FDs in the catalog on which a file label item has been defined. Choose a single FD from this list box.


Source (Copy File Label Column)

The Source Table list box contains all the tables on which a file label column has already been defined. Choose a single table from this list.


Source (Delete File Label)

The Source area contains all the FDs in a catalog on which a file label item has been defined. Choose one or more FDs from this list.


Source (Delete File Label Column)

The Source list box contains all the tables on which a file label column has already been defined. Choose one or more tables from this list.


SOURCEFORMAT"string"

The SOURCEFORMAT"string" directive specifies whether the source format is FIXED or FREE, based on the value of string, which must be one of these two words.


Specifying Comments See Also

Reporting


Specifying Treatment of the OCCURS Clause See Also

Building Tables, An Overview

Defining Columns on Repeating Data Items

Defining Insertable Tables

Determining Occurrence Count

FD Form

OCCURS Rule


Split (FD Form Toolbar)

The Split button causes the Relativity Designer window to split so that two different areas of a document can be seen in the same window.


SQL Reserved Words See Also

Create a table definition

Creating and Editing Table Definitions

Defining Default Column Names

FD Form – Attributes Summary

Tables Catalog Object

Table Form – Attributes Summary

Table Menu


SQL Window See Also

Relational Definition Forms


Start (FD Form Attributes)

In the expanded FD form, the Start attribute is the first character position for the data item within the record. For the filename, the Start attribute is the minimum record size.


Starting the Relativity Designer See Also

Configuring a Relativity Data Source

Customizing the Initialization File (RELDBDSN.INI)

Relativity Designer Window

Welcome to Relativity Window


Start (Print Options)

The Start button sends the print job to the selected printer or export module.


Status Report Dialog Box See Also

Rules for Insertable Tables


Subscripted Data Item Dialog Box See Also

Bind all occurrences at design time

Defining Columns on Repeating Data Items


Subscript Rule See Also

Building Writable Tables

Rules for Insertable Tables


Subscripts (FD Form Attributes)

In the expanded FD form, the Subscripts attribute is the number of subscripts that are necessary to reference the data item.


Supported standard character sets (Select Character Set)

Standard character sets:

Windows Latin 1 | MS-DOS Cyrillic CIS-1 | MS-DOS Hebrew
Windows Latin 2 | MS-DOS Turkish | EBCDIC US Canada
Windows Latin 5 | MS-DOS Portuguese | EBCDIC International
Windows Cyrillic | MS-DOS Icelandic | EBCDIC Greek
Windows Greek | MS-DOS French Canada | EBCDIC Latin 5 Turkish
Windows Baltic Rim | MS-DOS Greek | ISO 8859-1
Windows Hebrew | MS-DOS Greek 1 | ISO 8859-2
Windows Arabic | MS-DOS Greek 2 | ISO 8859-5
MS-DOS Latin US | MS-DOS Baltic Rim | ISO 8859-6
MS-DOS Latin 1 | MS-DOS Russian | ISO 8859-7
MS-DOS Latin 2 | MS-DOS Arabic | ISO 8859-8
MS-DOS Cyrillic | MS-DOS Arabic ASMO |


Supporting Multi-File Tables See Also

Establishing Table Connections


SYMBSTART"integer"

The SYMBSTART"integer" directive specifies the starting value for integers used in the SYMBOLIC CHARACTERS clause of the SPECIAL-NAMES paragraph. The default value of integer is 1 to match Standard COBOL. A value of 0 may be specified to match early Micro Focus COBOL implementations of the SYMBOLIC CHARACTERS clause.


System Options See Also

Setting Options

Starting the Relativity Designer

Tools Menu Commands


Table All

The Table ALL privilege is a shortcut method of assigning all the individual Table privileges (SELECT, INSERT, UPDATE, REFERENCES and DELETE) at one time. When the Table:ALL privilege is selected, the table names are displayed in the leftmost applicable column; that is, if any Table privilege is not granted, the table names are displayed in the Not Granted column. If any Table privilege is not granted with grant, then table names are displayed in the Granted column. Finally, if all Table privileges are granted with grant, table names are displayed in the With Grant column.

When Table ALL is selected, a table name can be moved from the Not Granted column to the Granted column in order to grant all the individual Table privileges for that table to the selected group. Then the user may select an individual Table privilege, for example, Table:select, and move the same table name from the Granted column to the With Grant column. If the user then selects the Table:ALL privilege again, that table name will still be displayed in the Granted column (not the With Grant column), even though the group has with grant privilege for the Table:select privilege.

Then, the user may select an individual Table privilege, for example, Table:delete, and move the same table name from the Granted column to the Not Granted column. In this case, if the user then selects the Table:ALL privilege again, that table name will be displayed in the Not Granted column, even though the group still has the privileges other than Table:delete for that table. This is because the group no longer has all Table privileges for that table.

Moving a table name from the Granted column to the Not Granted column when Table:ALL is selected resets all the Table privileges to Not Granted (including any individual Table privileges that were assigned With Grant).


Table Area (Edit Connections Form)

The Table area on the Edit Connections form contains the name(s) of the Relativity table definition(s) associated with one or more table connections.

· When the Edit Connections form is opened from the Security menu in the Designer window, this area displays a list of all the currently existing table definitions. A plus sign [+] precedes each table definition in the list. To expand an item and display the table connection for a specific table definition, click the plus sign. (Conversely, click the minus sign [-] to collapse an item in the expanded list.) The table connection, which is displayed in a hierarchical view, is composed of the following attributes:

-  a table name (the name of an SQL table),

-  a path name (the physical filename of the data file), and

-  a file label (if file labels are in effect). See Supporting Multi-File Tables.

· When the Edit Connections form is opened from the Tables catalog object in the Catalog window or on the Table form, this area displays only the associated table connection (table name, path name, and file label) for the selected Relativity table definition. Click the plus sign [+] to expand the list; click the minus sign [-] to collapse the list. To view an example, click here.

Note In either situation, if you right-click any of the items in the list or expanded list, a pop-up context-sensitive menu is displayed for that item.


Table Definition Names List (Export DDL)

The Table Definition Names list box displays all the table definitions in the catalog that are available for exporting to a .ddl text file. From this list, you can select specific table definition names you want to export if you have checked the Selected Tables option.


Table Edit Connection (Table Form Toolbar)

The Edit Connections button displays the Edit Connections form to define the connections between the table and its underlying files.

Note This option provides the same functionality as the Edit Connections command on the Table menu (or the Connections shortcut on the Table Common Tasks area of the Tables catalog object).


Table Filter Properties Form See Also

Defining Table Filters

Relational Definition Forms


Table Form Attributes Summary See Also

Table Form

Table Form Toolbar

Table Form - Column Property Summary

Table Form - File Indicator Bar


Table Form Column Property Summary See Also

Table Form

Table Form Toolbar

Table Form - Attributes Summary

Table Form - File Indicator Bar


Table Form File Indicator Bar See Also

Table Form

Table Form Toolbar

Table Form - Attributes Summary

Table Form - Column Property Summary


Table Form See Also

Bind Subscripts Form

Defining Relational Tables in the Table Form

Edit Connections Form

Query Builder Form

Show Indexes for Tablename Form

Show Table Contents Form

Table Filter Properties Form

Table Options


Table Form Toolbar See Also

Table Form

Table Form - Attributes Summary

Table Form - Column Property Summary

Table Form - File Indicator Bar


Table List (Edit Privileges Form)

The Table list on the Edit Privileges form contains the names of all tables within the database. When a table is selected, the Not Granted column contains the names of all columns within the specified table. The Table list is displayed only when a Column privilege is selected.


Table Name

The Table Name attribute on the Edit Connections form is the name of an SQL table.


Table Name (Add Table Connection Regular)

In the Table Name box, type the table name of the SQL table to be associated with the table connection being added to the selected table definition in the Edit Connections form.


Table Name Replace With (Add Connections Matching)

· The Table Name Replace box contains the pattern to be matched within the table name for replacement in the generation of a table name for the new table connection.

· The Table Name with box contains the pattern that is to replace the matching characters specified in the Table Name Replace box. The resulting table name becomes the table name for the new table connection.


Table Name With

The Table Name with box contains the pattern that is to replace the matching characters specified in the Table Name Replace box. The resulting table name becomes the table name for the new table connection.


Table Options See Also

Defining Relational Tables in the Table Form

Setting Options

Tools Menu Commands

Transforms


Tables Catalog Object See Also

Creating and Editing Table Definitions

Tabbed Layout View

Working with the Catalog Window


Tables List (Tables Tab)

The Tables area displays a list of tables currently defined in the catalog. A table may be selected by clicking once on the table name. Double-clicking a table name in the list is equivalent to selecting it and then clicking the Open button.

Note A table definition may be deleted from the catalog by selecting the table name and pressing the Del (Delete) key. A message box will be displayed requesting confirmation of the delete table request. If the user confirms the deletion, the table is deleted from the catalog.


Tables to Discard (Tables to Keep)

The Tables to Discard list contains a list of table definitions associated with the previous file definition that will not be replicated during the last phase of the merging process.


Tables to Keep Dialog Box See Also

Merging COBOL File Definitions

Resolving Merge Differences


Tables to Keep (Tables To Keep)

The Tables to Keep list contains a list of table definitions associated with the previous file definition that will be replicated during the last phase of the merging process.


Table Wizard Button (Files Tab)

The Table Wizard button displays the Table wizard, which simplifies the creation of a table by automating the selection of elementary items from the FD form, the addition or removal of items to or from the table, and the editing of column names.

Note The Table Wizard command on the FD menu provides the same functionality as the Table Wizard button.


Table Wizard Edit Page See Also

Building Writable Tables


Table Wizard See Also

Creating and Editing Table Definitions

Table Form

Using the Table Wizard


Tab Stops

In the Tab Stops box, type a comma-separated list of numbers indicating the columns in which to align the various elements and clauses of the exported COBOL data item definitions. The first number in the list must be the number 8.


To drag and drop from FD to Table form

Place the mouse pointer to the left of a data item in the FD form and click the mouse button to select that data item.

With the mouse pointer on the selected data item, hold down the left mouse button and move (or drag) the data item from the FD form to the Table form. During the drag operation, the mouse pointer changes shape three times.


Toolbar Area (Save Export As)

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.


Toolbar Area (Select a Report)

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.


Toolbar Area (Select COBOL Source)

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.


Toolbar (Select Report)

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.


Toolbar (Select RM/COBOL Program)

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.


Toolbar (Select Symbol Table)

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.


Tools Menu Commands See Also

Configuring a Relativity Data Source


To select items in the Choose Subscript Values dialog box

To select:

· two or more occurrences that are not consecutive, select the first occurrence. Then hold down the Ctrl key as you select each additional occurrence.

· a range of consecutive occurrences, select the first occurrence in the range and then hold down the Shift key while selecting the last occurrence in the range. The Ctrl and Shift keys must be used together if occurrences outside the consecutive range have already been selected.

· all the occurrences, click the Select All button.


To select one or more column definitions in a Table form

To select:

· a single column definition in the Table form, move the mouse pointer toward the left margin area and click the mouse button to select that column definition. When a single column definition cell or row is selected, a selector symbol appears in the gray area to the left of the grid.

· two or more column definitions in the Table form, select the first column definition. Then hold down the Ctrl key as you select each additional column definition.

· a range of consecutive column definitions in the Table form, select the first column definition in the range and then hold down the Shift key while selecting the last column definition in the range. The Ctrl and Shift keys must be used together if column definitions outside the range of consecutive column definitions have already been selected.


To select one or more data items in an FD form

To select:

· a single data item in the FD form, move the mouse pointer to the left of the COBOL name and click the mouse button to select that data item.

· two or more data items in the FD form, select the first COBOL data item. Then hold down the Ctrl key as you select each additional data item.

· a range of consecutive data items in the FD form, select the first data item in the range and then hold down the Shift key while selecting the last data item in the range. The Ctrl and Shift keys must be used together if data items outside the range of consecutive data items have already been selected.

· and extend a selection to all elementary data items subordinate to a group data item, press and hold the Alt key while clicking on the group data item.


To select one or more table connections

To select:

· a single table connection, click the mouse button on the desired table connection row.

· two or more table connections, select the first table connection. Then hold down the Ctrl key as you select each additional table connection.

· a range of table connections, select the first table connection in the range and then hold down the Shift key while selecting the last table connection in the range. The Ctrl and Shift keys must be used together if table connections outside the range of consecutive table connections have already been selected.


To select one, two or more, or a range of data items in an FD form

To select:

· a single data item in the FD form, move the mouse pointer to the left of the COBOL name and click the mouse button to select that data item.

· two or more data items in the FD form, select the first COBOL data item. Then hold down the Ctrl key as you select each additional data item.

· a range of consecutive data items in the FD form, select the first data item in the range and then hold down the Shift key while selecting the last data item in the range. The Ctrl and Shift keys must be used together if data items outside the range of consecutive data items have already been selected.

· and extend a selection to all elementary data items subordinate to a group data item, press and hold the Alt key while clicking on the group data item.


Transform (Add Data Type)

A transform converts a COBOL data item value to or from a relational database column value. The transform to be used is selected from the Transform list under Column Properties. Note that this transform property is usually left blank if the transform is already assigned to the COBOL data item.


Transform (FD Form Attributes)

In the expanded FD form, the Transform attribute specifies a data transformation for a COBOL data item value to and/or from a relational database column value. Change the transform in the Transform attribute by clicking in the grid cell and then selecting a transform from the list. A transform may also be assigned during the definition of an item pattern. See Defining Transforms on Data Items, Transforms, and Defining Item Patterns.

The choices available in the Transform attribute column are determined by the settings selected on the Date Formats page in the Options dialog box.


Transforms See Also

Date Constants Dialog Box

Defining Date Constants

Defining Item Patterns

Defining User Data Types

Using Functions and Transforms


Transform (Table Form Column Property)

The Transform property specifies a data transformation for a COBOL data item value to and/or from a relational database column value. The transform is selected from the list. This transform property is in addition to any transform assigned to the COBOL data-item in the FD form.

The options selected on the Date Formats and/or Table pages in the Options dialog box determine the choices available in the Transform property.


Type (Add Data Type)

Under Column Properties, the Type list selects the ODBC data type (char, date, integer, and so forth) associated with this user data type. The following lists the data type names pre-assigned to ODBC data types in Relativity:

· Exact numeric data types are bit, smallint, integer, and decimal.

· Approximate numeric data types are single and double.

· Character (or text) data types are char, varchar, and longvarchar.

· Unstructured binary data type is longvarbinary.

· Date/time data types are date, time, and timestamp.


Type Changes

Under Resolve, selecting the Type Changes check box instructs Relativity automatically to resolve changes in the COBOL data type of COBOL data items during the merging process.


Type (Data Types Form)

In the Data Types form, the Type attribute is the ODBC data type (char, date, integer, and so forth) associated with this user data type. To choose a different type, press the down arrow for a list of types. The following lists the data type names pre-assigned to ODBC data types in Relativity.

· Exact numeric data types are bit, smallint, integer, and decimal.

· Approximate numeric data types are single and double.

· Character (or text) data types are char, varchar, and longvarchar.

· Unstructured binary data type is longvarbinary.

· Date/time data types are date, time, and timestamp.


Type (Show Indexes)

The Type column contains the type of the index. The following values are valid:

· Clustered. Indicates a sorted index. Relativity supports only Clustered indexes.

· Hashed. Indicates an index that can be used to directly index to a row in the table, but is not otherwise sorted.


Type style indicates table

When a record-name is selected from the Record Type list, the type style of the data items listed in the COBOL names column in the FD form has special meaning.

All data items selected for the record type appear in bold font in the FD form. Subordinate data items appear in normal font if selected for inclusion with the record type. Data items not included in the record type appear in italic font. This information is summarized below:

This type style | Indicates that
Normal (or Regular) | The COBOL name is included in the record type implicitly by the parent group.
Italic | The COBOL name is excluded from the record type.
Bold | The COBOL name is included in the record type explicitly.


Unbind (Bind Subscripts)

The Unbind button removes a previously established binding for a subscripted data item, regardless of whether the binding was to a data item or literal. If the subscript is unbound, then multiple rows will be generated for a column based on the subscripted data item.


Unique (Show Indexes)

The Unique column contains True if the index uniquely identifies a row in the table and False otherwise. The False value may indicate that the underlying key allows duplicates, or that there are insufficient columns in the table definition to cover the entire file key.


Unpacked BCD (RM COMP)

When the Unpacked BCD (RM COMP) check box is selected, the catalog includes the signed decimal COBOL data type described by the USAGE IS COMPUTATIONAL clause.


Unsigned (Table Form Column Property)

The Unsigned property indicates that only nonnegative numeric values will appear in the column.

Many numeric data items do not order the data correctly. An index can include a column defined on a numeric data item under the following circumstances:

· Whatever data item values, if any, that correspond to a null in the column must precede all other values.

· The key order must be the same as numeric order. For example, negative numbers must precede positive numbers; for many signed data types, negative numbers follow positive numbers.

Note If the data item is signed but the column is marked unsigned, the Relativity DBMS will disallow negative values; the column can then be included in an index.

· There must be only one way to represent a given value in the numeric data item. For example, if the data item allows two or more representations of the sign, no index is possible. In some cases, the Relativity DBMS may limit the allowed representations of data items that are partially or totally within a file key so that an index can be built.


Updatable (Table Form Column Property)

The Updatable property is visible only if the table is already marked as updatable. It can be used to prevent an individual column from being updated. This value is automatically set on or off when the Allow Updates check box is selected or cleared on the Table form toolbar.


Update Comment button (FD Properties)

In the Properties area of the FD Properties form, the Update Comment button allows you to add additional comments associated with the selected FD.


Update Rules See Also

Table Wizard Edit Page


Use Expiration Area (Add Database Group Dialog)

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the group name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.


Use Expiration Area (Add Database User)

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the user name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.


Use Expiration Area (Change Password Dialog)

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the selected user name or group name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.


Use Expiration Area (Edit Group Dialog)

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the selected group name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.


Use Expiration Area (Edit User Dialog)

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the selected user name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.


User Data Name (Item Patterns Form)

The User Data (Name) attribute is the name assigned to the user data type. This data type name will appear in the Data Type list on the Table form and in the User Data Type list on the FD form. This data type name must be unique.


User Data Type

The User Data Type list specifies the name of the user data type having the data item pattern defined in the Add Data Item Pattern dialog box. The data type name is chosen from the list of data types in the associated list. If the < New > item is selected from the list of data types, then a new data type name is defined by entries in the Add Data Type dialog box.


User Data Type (Edit Data Item Pattern)

The User Data Type attribute specifies the name of the data type having the data item pattern defined in the Add Data Item Pattern dialog box. The data type name is chosen from the list of data types in the associated User Data Type list in that dialog. If the < New > item is selected from the list of data types, then a new data type name is defined by entries in the Add Data Type dialog box.


User Data Type (FD Form Attributes)

In the expanded FD form, the User Data Type attribute is the user data type that will be assigned by the Relativity Designer when the data item is used as a column in a table. Assign default data types to data items in the FD form by clicking Assign Default Data Types on the FD form toolbar. Change the default data type in the User Data Type attribute column by clicking in the grid cell and then selecting a user data type from the list. After a column is created, the default data type can be changed by selecting a type from the Data Type attribute in the Table form, which causes the display of a list containing types appropriate for the data item. See Defining User Data Types and Defining Item Patterns.


User Data Type (Select Data Type)

The User Data Type column lists the user data type associated with the item pattern.


User Name

The User Name option displays the name of the group or user logged on to use the data source.


User Name (Change Password)

The User Name box displays the name of the group or user whose password is to be changed.


User Name (Edit Users Form)

The User Name attribute on the Edit Users form is the name of a user associated with the selected user group. Each user name and group name within a catalog must be unique.


Users & Groups Catalog Object See Also

Defining Group Privileges

Defining Groups and Users

Tabbed Layout View

Working with the Catalog Window


Users List (Users Tab)

The Users area displays a list of the groups and users currently defined in the catalog for the Relativity database. A group or user may be selected by clicking once on the group or user name. Double-clicking a group name is equivalent to selecting it and clicking the Privileges button. Double-clicking a user name simply selects the user name.

Note A group or user may be deleted from the catalog by selecting the group or user name and pressing the Del (Delete) key. If a user name has been selected, the user name is immediately deleted. A message box, however, will be displayed requesting confirmation of a delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.


Users Report Features See Also

All Users by User Name Report

Defining Groups and Users

Reporting


User Types Options See Also

Configuring a Relativity Data Source

Defining User Data Types

Setting Options

Tools Menu Commands


USE"string"

The USE"string" directive is a synonym for the DIRECTIVES directive, q.v.


Use White Background on Grids

When the Use White Background on Grids check box is selected, Relativity overrides the color choice (set on the Appearance tab of the Display Properties dialog box) with white on many of the grid areas (such as in the FD form, the Table form, the Edit Connections form, and the Show Table Contents form). If this option is not selected, the background will be the same color as the top portion in the form.


Using Functions and Transforms See Also

Add Data Item Pattern Dialog Box

Add Data Type Dialog Box

Data Types Form

Date Formats Options

Edit Data Item Pattern Dialog Box

FD Form

Files/Tables Report Features

Function of Function Dialog Box

Item Patterns Form

Previewing Table Data

Table Form


Using Microsoft Query with Relativity Data Sources See Also

Configuring a Relativity Data Source


Using Relativity Help See Also

Help Button Bar


Using the Nullable Column Utility See Also

Defining Null Information

Determining Record Type

Handling Multiple Record Types

Nullable Column Utility

Nullable Columns Rule


Using the Table Wizard See Also

Augmenting the COBOL File Definition in the FD Form

Defining Default Column Names

FD Form

Table Form

Table Wizard

Table Wizard Edit Page


Value (Add Function Constant)

The Value list box displays the following items for the selection of a value or a type of value:

· Entered. Specifies that a value is to be entered in the text box to the right. Note that Entered is the only selection allowed when the conditional variable is numeric.

· SPACES. Specifies the figurative constant SPACES as the value for the condition-name.

· ZEROS. Specifies the figurative constant ZEROS as the value for the condition-name.

· LOW-VALUES. Specifies the figurative constant LOW-VALUES as the value for the condition-name.

· HIGH-VALUES. Specifies the figurative constant HIGH-VALUES as the value for the condition-name.

· Hexadecimal. Specifies that a hexadecimal value is to be entered in the text box to the right.


Value Attribute (FD Form Attributes)

In the expanded FD form, the Value attribute displays the value in the VALUE clause of a condition-name or the argument list of a function item. Double-click on the grid cell to display a message dialog box showing the complete VALUE entry or argument list. See Adding Condition Items and Internal Functions.

The Value attribute column is displayed in the FD form only if the Show VALUE Column check box is selected on the File page in the Options dialog box.


Value (Choose Subscript Values)

The Value column, which is labeled with the name of the repeating data item, contains the value of the 88-level condition-name. If a nested repeating data item occurs, then a column for each level of nesting is displayed, with each column labeled with the name of the repeating data item.


Value Drop-Down List (Set Default Value)

In the Value list box, select from one of the following values or types of values:

· Entered. Specifies that a value is to be entered in the box to the right.

· SPACES. Specifies the figurative constant SPACES as the value for the condition-name.

· ZEROS. Specifies the figurative constant ZEROS as the value for the condition-name.

· LOW-VALUES. Specifies the figurative constant LOW-VALUES as the value for the condition-name.

· HIGH-VALUES. Specifies the figurative constant HIGH-VALUES as the value for the condition-name.

· Hexadecimal. Specifies that a hexadecimal value is to be entered in the box to the right.


Value Text Box (Add Function Constant)

The Value text box allows you to type in a value when the value type selected in the Value drop-down list is Entered or Hexadecimal.


Value Text box (Set Default Value)

In the Value text box, type the value.


Value To Value Drop-Down Lists

The Value and To Value list boxes display the following items for the selection of a value or a type of value:

· Entered. Specifies that a value is to be entered in the text box to the right. Note that Entered is the only selection allowed when the conditional variable is numeric.

· SPACES. Specifies the figurative constant SPACES as the value for the condition-name.

· ZEROS. Specifies the figurative constant ZEROS as the value for the condition-name.

· LOW-VALUES. Specifies the figurative constant LOW-VALUES as the value for the condition-name.

· HIGH-VALUES. Specifies the figurative constant HIGH-VALUES as the value for the condition-name.

· Hexadecimal. Specifies that a hexadecimal value is to be entered in the text box to the right.

If the Single Value option button is selected, then the Value list box applies to the single value.

If the Value Range option button is selected, then the Value list box applies to the lowest value in the range of values. The To Value list box applies to the highest value in the range of values.


Value To Value Text Boxes

The Value and To Value text boxes allow you to type in a value when the value type selected in the Value or To Value drop-down list is Entered or Hexadecimal.

· If the Single Value option button is selected, then a single value is typed in the Value text box.

· If the Value Range option button is selected, then the lowest value in the range is typed in the Value text box. The highest value in the range is typed in the To Value text box.


Verify Password (Add Database Group)

In the Verify Password box, type the password a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Add Database Group dialog box must contain the same characters before the password is accepted for the group.


Verify Password (Add Database User)

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Add Database User dialog box must contain the same characters before the password is accepted for the user.


Verify Password (Change Password)

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Change Password dialog box must contain the same characters before the password is accepted for the group or user.


Verify Password (Edit Group Dialog)

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Edit Group dialog box must contain the same characters before the password is accepted for the group.


Verify Password (Edit User Dialog)

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Edit User dialog box must contain the same characters before the password is accepted for the user.


Visual Order Definition Popup

Visual order is the order in which characters are presented for reading.


Welcome to Relativity Window See Also

Opening a Data Source

Setting Up a New Data Source

Starting the Relativity Designer


With (Add Connections Matching Pattern)

The With box contains the pattern that is to replace the matching characters specified in the Replace box. The resulting column names are moved to the Table form during the creation of a table from the data items in the FD form. If the With box is blank, then the characters in the Replace box are deleted from the column names.


With Grant (Edit Privileges Form)

The With Grant column on the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group has access rights. The group also has the ability to grant those access rights to another group.


With (Import Detected Errors Page)

The With text box allows for the entry of a text editor.


With (Merge Detected Errors Page)

The With text box allows for the entry of a text editor.


Word Storage Mode

Word storage mode is a memory assignment mode in which binary numeric data items are assigned sizes for alignment with natural boundaries in the computer memory. In this mode, the SYNCHRONIZED clause causes implicit FILLER bytes to be generated such that data items begin on natural boundaries. The number of bytes assigned in word storage mode can be determined from the following chart:

Number of Digits (9s) in PICTURE character-string |  | Bytes of storage assigned
Signed | Unsigned | Word Storage Mode
1-4 | 1-4 | 2
5-9 | 5-9 | 4
10-18 | 10-18 | 8


Working-Storage Section

Selecting the Working-Storage check box causes the display of data items from the Working-Storage Section of the COBOL program.


Working with the Catalog Window See Also

Catalog Window

Relativity Catalogs


Write Support Wizard See Also

Building Writable Tables


Write Support Wizard (Table Form Toolbar)

The Write Support Wizard button launches the Write Support wizard, which will examine your table for issues that may occur if you attempt a write operation.


'YY' Base Year

The 'YY' Base Year box is displayed on the second line of the Date Constants dialog box when the 'YY' Base Year option button is selected. The 'YY' Base Year is changed either by typing a two-digit year or clicking on the arrows to indicate the two-digit year. This date constant specifies the base year used to interpret date values containing a two-digit year. The default base year is 1900. The base year is added to a two-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a two-digit year.


'YY' Base Year Option Button

The selection of the 'YY' Base Year option button displays the 'YY' Base Year box on the second line of the Date Constants dialog box.


'YY' Century Cutoff

When the 'YY' Century Cutoff option button is selected, the 'YY' Century Cutoff box is displayed on the second line of the Date Constants dialog box in place of the 'YY' Base Year box. The 'YY' Century Cutoff is changed either by typing a two-digit value or clicking on the arrows to indicate the two-digit century cutoff. This date constant specifies the century cutoff year used to interpret date values containing a two-digit year that are considered to be in the next century if lower than the specified cutoff. The default value is 1900. Using the default, all two-digit years are considered to be in the twentieth century (nineteen hundreds). If this date constant is changed to 1930, then all COBOL two-digit year dates less than 1930, after adding the two-digit base year, will be incremented by 100; that is, the two-digit years 00 through 29 would be interpreted as the four-digit years 2000 through 2029. If the value of 'YY' Century Cutoff is greater than 1900, then the value of 'YY' Base Year must be equal to 1900. The value of 'YY' Century Cutoff is only used when it is greater than 1900.


'YY' Century Cutoff Option Button

The selection of the 'YY' Century Cutoff option button displays the 'YY' Century Cutoff box on the second line in the Date Constants dialog box in place of the 'YY' Base Year box.

The 'YY' Century Cutoff is changed either by typing a two-digit value or clicking on the arrows to indicate the two-digit century cutoff. This date constant specifies the century cutoff year used to interpret date values containing a two-digit year that are considered to be in the next century if lower than the specified cutoff. The default value is 1900. Using the default, all two-digit years are considered to be in the twentieth century (nineteen hundreds). If this date constant is changed to 1930, then all COBOL two-digit year dates less than 1930, after adding the two-digit base year, will be incremented by 100; that is, the two-digit years 00 through 29 would be interpreted as the four-digit years 2000 through 2029. If the value of 'YY' Century Cutoff is greater than 1900, then the value of 'YY' Base Year must be equal to 1900. The value of 'YY' Century Cutoff is only used when it is greater than 1900.


'YY' Dates

The structure of 'YY' Dates is selected from the 'YY' Dates list. This date constant specifies the structure to be used for COBOL data items that were associated with a six-digit date transform when the catalog was designed. The six-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with two-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in its files. The default structure is YYMMDD (a two-digit year, followed by a two-digit month of the year, followed by a two-digit-day of the month).


'YYYY' Base Year

The 'YYYY' Base Year box is changed either by typing or clicking on the arrows to indicate the four-digit base year. This date constant specifies the base year used to interpret date values containing a four-digit year. The default base year is 0. The base year is added to a four-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a four-digit year.


'YYYY' Dates

The structure of 'YYYY' Dates is selected from the 'YYYY' Dates list. This date constant specifies the structure to be used for COBOL data items that were associated with an eight-digit date transform when the catalog was designed. The eight-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with four-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in its files. The default structure is YYYYMMDD (a four-digit year, followed by a two-digit month of the year, followed by a two-digit day of the month).


new_test